﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
//////////////////////////////////////
// COCOONJS.JS                      //
//////////////////////////////////////

(function()
{
	// There should not be a CocoonJS object when this code is executed.
	// if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
    * The basic object for all the CocoonJS related specific APIs === extensions.
    * @namespace
    */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

	CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

	/**
	* This type represents a 2D size structure with horizontal and vertical values.
	* @namespace
	*/
	CocoonJS.Size = {
		/**
		* The horizontal size value.
		*/
		width : 0,

		/**
		* The vertical size value.
		*/
		height : 0
	};

	/**
	* This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
	* This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
	* @param {function} subc The subclass function.
	* @param {function} superc The superclass function.
	*/
	CocoonJS.extend = function(subc, superc) {
	    var subcp = subc.prototype;

	    // Class pattern.
	    var CocoonJSExtendHierarchyChainClass = function() {};
	    CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

	    subc.prototype = new CocoonJSExtendHierarchyChainClass();       // chain prototypes.
	    subc.superclass = superc.prototype;
	    subc.prototype.constructor = subc;

	    // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
	    if (superc.prototype.constructor === Object.prototype.constructor) {
	        superc.prototype.constructor = superc;
	    }

	    // Check all the elements in the subclass prototype and add them to the chain object's prototype.
	    for (var method in subcp) {
	        if (subcp.hasOwnProperty(method)) {
	            subc.prototype[method] = subcp[method];

	            // // tenemos en super un metodo con igual nombre.
	            // if ( superc.prototype[method]) 
	            // {
	            //     subc.prototype[method]= (function(fn, fnsuper) 
	            //     {
	            //         return function() 
	            //         {
	            //             var prevMethod= this.__super;

	            //             this.__super= fnsuper;

	            //             var retValue= fn.apply(
	            //                     this,
	            //                     Array.prototype.slice.call(arguments) );

	            //             this.__super= prevMethod;

	            //             return retValue;
	            //         };
	            //     })(subc.prototype[method], superc.prototype[method]);
	            // }
	        }
	    }
	}

	/**
	* IMPORTANT: This function should only be used by Ludei.
	* This function allows a call to the native extension object function reusing the same arguments object.
	* Why is interesting to use this function instead of calling the native object's function directly?
	* As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
	* undefined arguments are passed to the native side. Some native functions do not check the parameters validation
	* correctly (just check the number of parameters passed).
	* Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
	* call, but it takes more work than using this approach.
	* @static
	* @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
	* @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
	* @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
	* @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
	* @returns Whatever the native function call returns.
	*/
	CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
		if (CocoonJS.nativeExtensionObjectAvailable) {
			var argumentsArray = Array.prototype.slice.call(args);
			argumentsArray.unshift(nativeFunctionName);
			var nativeExtensionObject = ext[nativeExtensionObjectName];
			var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
			var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
			var finalRet = ret;
			if (typeof ret === "string") {
				try	{
					finalRet = JSON.parse(ret);
				}
				catch(error) {
				}
			}
			return finalRet;
		}
	};

	/**
	* Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
	* It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
	* path could be "CocoonJS.App" or "document.body".
	* @param {Object} baseObject The object to start from to find the object using the given text path.
	* @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
	* For example:
	* var body = getObjectFromPath(window, "document.body");
	*/
	CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
    	var parts = objectPath.split('.');
    	var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) 
        {
            obj[parts[i]] = obj[parts[i]] || undefined;
    		obj = obj[parts[i]];
    	}
    	return obj;
 	};

 	/**
 	* Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
 	* @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
 	* @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
 	* @return The key that corresponds to the given value it is has been found or null.
 	*/
 	CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value)            {
                finalKey = key;
                break;
            }
        }
        return finalKey;
 	}

 	/**
 	* Finds a string inside a given array of strings by looking for a given substring. It can also
 	* specify if the search must be performed taking care or not of the case sensitivity.
 	* @param {Array} stringArray The array of strings in which to to look for the string.
 	* @param {string} subString The substring to look for inside all the strings of the array.
 	* @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the 
 	* case sensitiveness (true) or not (false).
 	* @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
 	*/
 	CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
 		var foundString = null;
 		subString = caseSensitive ? subString : subString.toUpperCase();
 		for (var i = 0; foundString == null && i < stringArray.length; i++)	{
 			foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
 			foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null; 
 		}
 		return foundString;
 	};

	/**
	* A class that represents objects to handle events. Event handlers have always the same structure:
	* Mainly they provide the addEventListener and removeEventListener functions.
	* Both functions receive a callback function that will be added or removed. All the added callback
	* functions will be called when the event takes place.
	* Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
	* @constructor
	* @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
	* @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
	* @param {string} nativeEventName The name of the native event inside the ext object.
	* @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
	* will be called before any of the other listeners.
	*/
	CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
		this.listeners = [];
		this.listenersOnce = [];
		this.chainFunction = chainFunction;

		/**
		* Adds a callback function so it can be called when the event takes place.
		* @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
		*/
		this.addEventListener = function(listener) {
			if (chainFunction) {
				var f = function() {
					chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments)); 
				};
				listener.CocoonJSEventHandlerChainFunction = f;
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                	this.listeners.push(listener);
                }
            }
		};

        this.addEventListenerOnce = function(listener)
		{
			if (chainFunction) {
				var f = function() { chainFunction(arguments.callee.sourceListener,Array.prototype.slice.call(arguments)); };
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            }
            else
            {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0)
                {
                	this.listenersOnce.push(listener);
                }
            }
		};

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function (listener) {

        	if (chainFunction) {
        		listener = listener.CocoonJSEventHandlerChainFunction;
        		delete listener.CocoonJSEventHandlerChainFunction;
        	}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

		this.notifyEventListeners = function() {
			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName);
            } else {

                var argumentsArray= Array.prototype.slice.call(arguments);
                var listeners =     Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce= [];
            }
		};
		return this;
	};

	/**
	* A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
	*/
	CocoonJS.Timer = function() {
		this.reset();
		return this;
	};

	CocoonJS.Timer.prototype = {
		currentTimeInMillis : 0,
		lastTimeInMillis : 0,
		elapsedTimeInMillis : 0,
		elapsedTimeInSeconds : 0,
		accumTimeInMillis : 0,

		/**
		Resets the timer to 0.
		*/
		reset : function() {
			this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
			this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
		},

		/**
		Updates the timer calculating the elapsed time between update calls.
		*/
		update : function() {
			this.currentTimeInMillis = new Date().getTime();
			this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
			this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
			this.lastTimeInMillis = this.currentTimeInMillis;
			this.accumTimeInMillis += this.elapsedTimeInMillis;
		}
	};

	// CocoonJS.FindAllNativeBindingsInCocoonJSExtensionObject = function(cocoonJSExtensionObject, nativeFunctionBindingCallback, nativeEventBindingCallback)
	// {
	// 	for (var cocoonJSExtensionObjectAttributeName in cocoonJSExtensionObject)
	// 	{
	// 		var cocoonJSExtensionObjectAttribute = cocoonJSExtensionObject[cocoonJSExtensionObjectAttributeName];

	// 		// Function
	// 		if (typeof cocoonJSExtensionObjectAttribute === 'function' && typeof cocoonJSExtensionObjectAttribute.nativeFunctionName !== 'undefined')
	// 		{
	// 			var nativeFunctionName = cocoonJSExtensionObjectAttribute.nativeFunctionName;
	// 			nativeFunctionBindingCallback(cocoonJSExtensionObjectAttributeName, nativeFunctionName);
	// 		}
	// 		// Event object
	// 		else if (typeof cocoonJSExtensionObjectAttribute === 'object' && cocoonJSExtensionObjectAttribute !== null && typeof cocoonJSExtensionObjectAttribute.nativeEventName !== 'undefined')
	// 		{
	// 			var nativeEventName = cocoonJSExtensionObjectAttribute.nativeEventName;
	// 			nativeEventBindingCallback(cocoonJSExtensionObjectAttributeName, nativeEventName);
	// 		}
	// 	}
	// }

	/**
	This function looks for a CocoonJS extension object that is bound to the given native ext object name.
	@returns The CocoonJS extension object that corresponds to the give native extension object name or null if it cannot be found.
	*/
	// CocoonJS.GetCocoonJSExtensionObjectForNativeExtensionObjectName = function(nativeExtensionObjectName)
	// {
	// 	var cocoonJSExtensionObject = null;
	// 	// Look in the CocoonJS object and for every object that is a CocoonJS.Extension check if it's nativeExtensionObjectName matches to the one passed as argument. If so, create an object that will represent it's documentation for the native ext object.
	// 	for (var cocoonJSAttributeName in CocoonJS)
	// 	{
	// 		var cocoonJSAttribute = CocoonJS[cocoonJSAttributeName];
	// 		if (typeof cocoonJSAttribute === 'object' && cocoonJSAttribute instanceof CocoonJS.Extension && cocoonJSAttribute.nativeExtensionObjectName === nativeExtensionObjectName)
	// 		{
	// 			// We have found the CocoonJS object that represents the native ext extension object name. 
	// 			cocoonJSExtensionObject = cocoonJSAttribute;
	// 			break;
	// 		}
	// 	}
	// 	return cocoonJSExtensionObject;
	// };

	/**
	This function adds functions to a CocoonJS extension object in order to bind them to the native makeCall function calls of the ext object.

	@param extensionObject The reference to the CocoonJS extension object where to add the new functions bound to the ext object makeCall functions calls.

	@param nativeFunctionsConfiguration An array of objects with the following structure:

		{ nativeFunctionName : "" [, functionName : "", isAsync : true/false] }

		- nativeFunctionName: Specifies the name of the function inside the ext object makeCall function call that will be bound.
		- functionName: An optional attribute that allows to specify the name of the function to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeFunctionName.
		- isAsync: An optional attribute that allows to specify if the call should be performed using makeCall (false or missing) or makeCallAsync (true).
		- alternativeFunction: An optional attribute that allows to specify an alternative function that will be called internally when this function is called. This attribute
		allows for adding new functionalities like for example adding methods 

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeFunctionBindingsToExtensionObject = function(extensionObject, nativeFunctionsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeFunctionsConfiguration === 'undefined' || nativeFunctionsConfiguration === null) throw("The passed native functions configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeFunctionsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeFunctionsConfiguration[i].nativeFunctionName === 'undefined') throw("The 'nativeFunctionName' attribute in the native function configuration object at index '" + i + "' in the native function configuration array cannot be undefined.");
	// 		var nativeFunctionName = nativeFunctionsConfiguration[i].nativeFunctionName;
	// 		var functionName = typeof nativeFunctionsConfiguration[i].functionName !== 'undefined' ? nativeFunctionsConfiguration[i].functionName : nativeFunctionName;
	// 		var makeCallFunction = null;
	// 		makeCallFunction = typeof nativeFunctionsConfiguration[i].isAsync !== 'undefined' && nativeFunctionsConfiguration[i].isAsync ? extensionObject.nativeExtensionObject.makeCallAsync : extensionObject.nativeExtensionObject.makeCall;
	// 		// Add the new function to the CocoonJS extension object
	// 		extensionObject[functionName] = function()
	// 		{
	// 			// Convert the arguments object to an array
	// 			var arguments = Array.prototype.slice.call(arguments);
	// 			// Add the native function name as the first parameter
	// 			arguments.unshift(nativeFunctionName);
	// 			// Make the native ext object call
	// 			var result = makeCallFunction.apply(extensionObject.nativeExtensionObject, arguments);
	// 			return result;
	// 		}
	// 		// Add a property to the newly added function to store the name of the original function.
	// 		extensionObject[functionName].nativeFunctionName = nativeFunctionName;
	// 	}
	// 	return extensionObject;
	// };

	/**
	This function adds objects to a CocoonJS extension object to allow event listener handling (add and remove) bound to the native ext object event listener handling.

	@param extensionObject The reference to the CocoonJS extension object where to add the new objects bound to the ext object event listener handling.

	@param nativeEventsConfiguration An array of objects with the following structure:

		{ nativeEventName : "" [, eventObjectName : ""] }

		- nativeEventName: Specifies the event in the native ext object to be bound.
		- eventObjectName: An optional attribute that allows to specify the name of the object to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeEventName.
		- alternativeAddEventListenerFunction:
		- alternativeRemoveEventListenerFunction:

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeEventBindingsToExtensionObject = function(extensionObject, nativeEventsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeEventsConfiguration === 'undefined' || nativeEventsConfiguration === null) throw("The passed native events configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeEventsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeEventsConfiguration[i].nativeEventName === 'undefined') throw("The 'nativeEventName' attribute in the native event configuration object at index '" + i + "' in the native event configuration array cannot be undefined.");
	// 		var nativeEventName = nativeEventsConfiguration[i].nativeEventName;
	// 		var eventObjectName = typeof nativeEventsConfiguration[i].eventObjectName !== 'undefined' ? nativeEventsConfiguration[i].eventObjectName : nativeEventName;
	// 		// Anonymous function call so each variable in the loop is used in the event listener handling function bindings.
	// 		(function(nativeEventName, eventObjectName)
	// 		{
	//     		extensionObject[eventObjectName] =
	//     		{
	//     			// Store the native event name
	//     			nativeEventName : nativeEventName,
	//     			// Create the event listener management functions bound to the native counterparts
	//     			addEventListener : function(callback)
	// 	    		{
	// 	    			extensionObject.nativeExtensionObject.addEventListener(nativeEventName, callback);
	//     			},
	//     			removeEventListener : function(callback)
	//     			{
	// 	    			extensionObject.nativeExtensionObject.removeEventListener(nativeEventName, callback);
	//     			}
	//     			// ,
	//     			// removeAllEventListeners : function()
	//     			// {

	//     			// }
	//     		};
	// 		})(nativeEventName, eventObjectName);
	// 	}
	// 	return extensionObject;
	// };

	/**
	The function object constructor function all the CocoonJS extensions can use to instantiate the CocoonJS extension object and add all the functionality needed bound to the native ext object.

	@param nativeExtensionObject The reference to the ext object extension object.

	@param nativeFunctionsConfiguration See CocoonJS.AddNativeFunctionBindingsToExtensionObject function's documentation for more details.

	@param nativeEventsConfiguration See CocoonJS.AddNativeEventBindingsToExtensionObject function's documentation for more details.

	@returns The new CocoonJS extension object.
	*/
	// CocoonJS.Extension = function(nativeExtensionObjectName, nativeFunctionsConfiguration, nativeEventsConfiguration)
	// {
	// 	if (typeof nativeExtensionObjectName === 'undefined' || nativeExtensionObjectName === null) throw("The native extension object name cannot be null");

	// 	if (window.ext[nativeExtensionObjectName] === 'undefined') throw("The given native extension object name '" + nativeExtensionObjectName + "' is incorrect or the native extension object is undefined.");

	// 	var nativeExtensionObject = window.ext[nativeExtensionObjectName];

	// 	// Store a reference to the native extension object and to it's name
	// 	this.nativeExtensionObject = nativeExtensionObject;
	// 	this.nativeExtensionObjectName = nativeExtensionObjectName;

	// 	// If native function configuration is passed, use it to add some functions to the new extension object.
	// 	if (typeof nativeFunctionsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeFunctionBindingsToExtensionObject(this, nativeFunctionsConfiguration);
	// 	}

	// 	// If native event configuration is passed, use it to add some event objects to the new extension object.
	// 	if (typeof nativeEventsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeEventBindingsToExtensionObject(this, nativeEventsConfiguration);
	// 	}

	// 	return this;
	// };   

})();

//////////////////////////////////////
// COCOONJS_APP.JS                  //
//////////////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                //return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                return window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                // window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            var result = prompt(message, text);
            var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
            eventObject.notifyEventListeners(result);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            var result = confirm(message);
            var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
            eventObject.notifyEventListeners();
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleepâ€ state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            // Control the parameters.
            if (!typeName) throw "The given typeName must be valid.";
            if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
            attributeNames = attributeNames ? attributeNames : [];
            functionNames = functionNames ? functionNames : [];
            eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

            // The parent object will be the window. It could be another object but careful, the destination side should know about this.
            // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
            var parentObject = window;

            // Setup the destination side too.
            var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
            CocoonJS.App.forward(jsCode);

            var originalType = parentObject[typeName];

            // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
            // internally calling to their counterparts in the destination environment.
            parentObject[typeName] = function () {
                var _this = this;

                // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
                this._cocoonjs_proxy_object_data = {};
                // The id is obtained calling to the destination side to create an instance of the type.
                var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
                this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
                // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
                // webview makes the corresponding calls.
                this._cocoonjs_proxy_object_data.eventHandlers = {};
                // Also store the typename inside each instance.
                this._cocoonjs_proxy_object_data.typeName = typeName;
                // A dictionary to store the event handlers
                this._cocoonjs_proxy_object_data.eventListeners = {};

                // TODO: eventHandlers and eventListeners should be in the same list ;)

                // Store all the proxy instances in a list that belongs to the type itself.
                parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

                // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
                for (var i = 0; i < attributeNames.length; i++) {
                    (function (attributeName) {
                        _this.__defineSetter__(attributeName, function (value) {
                            var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                        _this.__defineGetter__(attributeName, function () {
                            var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                    })(attributeNames[i]);
                }

                // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
                for (var i = 0; i < functionNames.length; i++) {
                    (function (functionName) {
                        _this[functionName] = function () {
                            // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                            var argumentsArray = Array.prototype.slice.call(arguments);
                            argumentsArray.unshift(functionName);
                            argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                            argumentsArray.unshift(typeName);
                            // Use the array to create the correct function call.
                            var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                            for (var i = 0; i < argumentsArray.length; i++) {
                                // The second argument (the id) should not be stringified
                                jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                            }
                            jsCode += ");";
                            // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                            // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                            var ret = CocoonJS.App.forwardAsync(jsCode);
                            return ret;
                        };
                    })(functionNames[i]);
                }

                // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
                // array so they can be called when the destination environment makes the corresponding callback call.
                for (var i = 0; i < eventHandlerNames.length; i++) {
                    (function (eventHandlerName) {
                        _this.__defineSetter__(eventHandlerName, function (value) {
                            _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                        });
                        _this.__defineGetter__(eventHandlerName, function () {
                            return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                        });
                    })(eventHandlerNames[i]);
                }

                // Setup the add and remove event listeners in the proxy object
                _this.addEventListener = function (eventTypeName, eventCallback) {
                    var addEventCallback = true;
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        // As the eventListeners were already added, check that the same callback has not been added.
                        addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                    }
                    else {
                        // There are no event listeners, so add the one and add the listeners array for the specific event type name
                        eventListeners = [];
                        _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                        // Forward the call so the other end registers a event listener (only one is needed).
                        var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                    // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                    if (addEventCallback) {
                        eventListeners.push(eventCallback);
                    }
                };

                _this.removeEventListener = function (eventTypeName, eventCallback) {
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                        if (eventCallbackIndex >= 0) {
                            eventListeners.splice(eventCallbackIndex, 1);
                        }
                    }
                };

                // Return the proxy instance.
                return this;
            };

            // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                originalType:originalType,
                proxyObjects:[]
            };

            /**
             * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
             * This function should be manually called whenever a proxy instance won't be accessed anymore.
             * @param {object} object The proxy object to be deleted.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
                var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
                if (proxyObjectKey) {
                    var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                    object._cocoonjs_proxy_object_data = null;
                    delete this.proxyObjects[proxyObjectKey];
                }
            };

            /**
             * Calls a event handler for the given proxy object id and eventHandlerName.
             * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
             * @param {string} eventHandlerName The name of the handler to be called.
             * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
             * structure to the event passing the target (the proxy object).
             * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
             * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
                var object = this.proxyObjects[id];
                var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                if (eventHandler) {
                    eventHandler({ target:object });
                }
            };

            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
                var object = this.proxyObjects[id];
                var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
                for (var i = 0; i < eventListeners.length; i++) {
                    eventListeners[i]({ target:object });
                }
            };
        }
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
            }
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (object && object._cocoonjs_proxy_object_data) {
                parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
            // and the names of all the event handlers and some utility functions.
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                nextId:0,
                proxyObjects:{},
                eventHandlerNames:eventHandlerNames
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                delete parentObject[typeName]._cocoonjs_proxy_type_data;
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            var proxyObject = new parentObject[typeName]();
            // Also store some additional information in the proxy object
            proxyObject._cocoonjs_proxy_object_data = {};
            // Like the type name, that could be useful late ;)
            proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
            // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
            var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
            // Store the created object in the structure defined in the setup of proxification with an id associated to it
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
            // Also store the id inside the proxy object itself
            proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
            // Calculate a new id for the next object.
            parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

            // Setup all the event handlers.
            for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    proxyObject[eventHandlerName] = function (event) {
                        var proxyObject = this; // event.target;
                        // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                        var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    };
                })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
            }

            // Add the dictionary where the event listeners (callbacks) will be added.
            proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

            return proxyObjectId;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var argumentsArray = Array.prototype.slice.call(arguments);
            argumentsArray.splice(0, 3);
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
            return result;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            proxyObject[attributeName] = attributeValue;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            return proxyObject[attributeName];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            // Look for the proxy object
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

            var callback = function (event) {
                var proxyObject = this; // event.target;
                // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
                // TODO: Is there a way to retrieve the callbackId without a closure?
                var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                CocoonJS.App.forwardAsync(jsCode);
            };

            proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

            // Finally add the event listener callback to the proxy object
            proxyObject.addEventListener(eventTypeName, callback);
        }
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };    

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onTextDialogFinished} event calls.
     * @name OnTextDialogFinishedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} text The text that was introduced in the text dialog when it was finished.
     */
    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();

//////////////////////////////////////
// COCOONJS_APP_FORCOCOONJS.JS		//
//////////////////////////////////////

(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    if (!CocoonJS.App.nativeExtensionObjectAvailable)
    {
        (function createWebView() { 
            CocoonJS.App.EmulatedWebView = document.createElement('div'); 
            CocoonJS.App.EmulatedWebView.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
            CocoonJS.App.EmulatedWebView.style.width = 0; 
            CocoonJS.App.EmulatedWebView.style.height = 0; 
            CocoonJS.App.EmulatedWebView.style.position = "absolute"; 
            CocoonJS.App.EmulatedWebView.style.left = 0; 
            CocoonJS.App.EmulatedWebView.style.top = 0;
            CocoonJS.App.EmulatedWebView.style.backgroundColor = 'transparent';
            CocoonJS.App.EmulatedWebView.style.border = "0px solid #000"; 
            CocoonJS.App.EmulatedWebViewIFrame = document.createElement("IFRAME"); 
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.style.width = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.style.height = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.frameBorder = 0;
            CocoonJS.App.EmulatedWebViewIFrame.allowtransparency = true;
            CocoonJS.App.EmulatedWebView.appendChild(CocoonJS.App.EmulatedWebViewIFrame);
            if(!document.body)
            document.body = document.createElement("body");
            document.body.appendChild(CocoonJS.App.EmulatedWebView);
        })(); 
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            // TODO: All this code should be changed to a simple call makeNativeExtensionObjectFunctionCall when the native argument control is improved.
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if (xhr.status === 200)
                    {
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else if (xhr.status === 404)
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('show'";
            if (typeof x !== 'undefined' && typeof y !== 'undefined' && typeof width !== 'undefined' && typeof height !== 'undefined')
            {
                javaScriptCodeToForward += ", " + x + ", " + y + ", " + width + ", " + height;
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");
    
})();

//////////////////////////////////////
// COCOONJS_AD.JS                   //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();

//////////////////////////////////////
// COCOONJS_STORE.JS                //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();

//////////////////////////////////////
// COCOONJS_SOCIAL.JS               //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Social = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + extensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationSucceed} event calls.
	     * @name OnRequestInitializationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when requestInitialization was called.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationFailed} event calls.
	     * @name OnRequestInitializationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when the requestInitialization function was called.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginSucceed} event calls.
	     * @name OnRequestLoginSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the user that logged in.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginFailed} event calls.
	     * @name OnRequestLoginFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user logs out.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onLogout = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLogout");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoSucceed} event calls.
	     * @name OnRequestUserInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the request user id.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoFailed} event calls.
	     * @name OnRequestUserInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLSucceed} event calls.
	     * @name OnRequestUserImageURLSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} imageURL The URL of the image of the requested user. 
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLFailed} event calls.
	     * @name OnRequestUserImageURLFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user the request was placed for.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosSucceed} event calls.
	     * @name OnRequestUserFriendsUserInfosSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user for whom the friend user infos where requested.
	     * @param {array} friendsInfo An array of {@link CocoonJS.Social.UserInfo} objects representing the information of the friends of the user.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info is successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosFailed} event calls.
	     * @name OnRequestUserFriendsUserInfosFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param 
	     * @param {string} userID The id of the user fro whom the friends infos were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationSucceed} event calls.
	     * @name OnRequestMessagePublicationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
 	     * @param {CocoonJS.Social.Message} message The message that has been published.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    * @param {CocoonJS.Social.Message} message The message that has been published.
	    */
		this.onRequestMessagePublicationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationFailed} event calls.
	     * @name OnRequestMessagePublicationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.Message} message The message that was supposed to be published.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestMessagePublicationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationFailed");

		/**
        * @ignore
        */
        this.on= function(event, callback) {
            event= "on"+event[0].toUpperCase()+event.substr(1);
            var signal= this[event];
            if (signal) {
                signal.addEventListener(callback);
            } else {
                console.error("SocialGaming service: '"+this.extensionName+"' does not understand '"+event+' signal.');
            }

            return this;
        };

	    return this;
	};

	CocoonJS.Social.prototype = {
        userInfo : null,
        userInfoCocoonJS : null,

        /**
        * @ignore
        */
        getUserInfo : function() {
            return this.userInfo;
        },

        /**
        * Returns the information of the currently logged in user.
        * @return {@link CocoonJS.Social.UserInfo}
        */
        getLoggedInUserInfo : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLoggedInUserInfo", arguments);
            }
            else {
                return this.userInfoCocoonJS;
            }
        },

        /**
        * @ignore
        */
        setUserInfo : function( userInfo) {
            this.userInfo= userInfo;
        },

        /**
        * @ignore
        */
        setUserInfoCocoonJS : function( userInfoCocoonJS ) {
            this.userInfoCocoonJS = userInfoCocoonJS;
        },

		/**
        * Request initialization of the underlying social service.
        * @param {object} paramsObject A data structure to initialize the service. It will be dependable of the underlying service.
        * @see CocoonJS.Social.onRequestInitializationSucceed
        * @see CocoonJS.Social.onRequestInitializationFailed
        */
		requestInitialization : function(paramsObject) 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestInitialization", arguments, true);
			}
		},

		/**
        * Returns a flag to indicate if the underlying service has been initialized or not.
        * @return {boolean} If the underlying service had been initialized using the requestInitialization function call.
        */
		isInitialized : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isInitialized", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to log in the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Socual.onRequestLoginFailed
		*/
		requestLogin : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogin", arguments, true);
			}
		},

		/**
		* Request to log out of the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Social.onRequestLoginFailed
		* @see CocoonJS.Social.onLogout
		*/
		requestLogout : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogout", arguments, true);
			}
		},

		/**
		* Check if the user is logged in.
		* @return {boolean} true if the user is still logged in, false otherwise.
		*/
		isLoggedIn : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isLoggedIn", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Returns all the granted permissions for the current session.
		* @return {Array} An array containin the user granted permissions.
		*/
		getPermissions : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPermissions", arguments);
			}
			else
			{
				return new Array();
			}
		},

		/**
		* Check if the user has granted the publish permission for the current session.
		* @return {boolean} true if the user has granted the publish permission for the current session, false otherwise.
		*/
		hasPublishPermission : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "hasPublishPermission", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to retrieve the current or a specific user's id. The request can be monitored using the {@link CocoonJS.Social.onUserInfoRequestSucceed} and {@link CocoonJS.Social.onUserInfoRequestFailed} event handlers.
		* @param {string} [userId] The id of the user to retireve the information from. If no userID is specified, the currently logged in user is assumed.
		* @see CocoonJS.Social.onRequestUserInfoSucceed
		* @see CocoonJS.Social.onRequestUserInfoFailed
		*/
		requestUserInfo : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserInfo", arguments, true);
			}
		},

		/**
		* Request to retrieve the Image of a user
		* @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}. If no value is specified, SMALL is used.
		* @see CocoonJS.Social.onRequestUserImageURLSucceed;
		* @see CocoonJS.Social.onRequestUserImageURLFailed;
		*/
		requestUserImageURL : function( imageSizeType, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserImageURL", arguments, true);
			}
		},

		/**
		* Request for the information of all the friends of the currently logged user.
		* @param {string} [userID] The id of the user to get the friends infos for. If no userID is specified, the currently logged user is used.
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosSucceed;
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosFailed;
		*/
		requestUserFriendsUserInfos : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserFriendsUserInfos", arguments, true);
			}
		},

		/**
		* Request the publication of a message using a dialog.
		* @param {CocoonJS.Social.Message} message A object representing the information to be published.
		* @see CocoonJS.Social.onRequestMessagePublicationSucceed
		* @see CocoonJS.Social.onRequestMessagePublicationFailed
		*/
		requestMessagePublicationWithDialog : function(message)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestMessagePublicationWithDialog", arguments, true);
			}
		}
	};

	/**
	* This structure represents the possible images to be obtained for a user in the social gaming extension.
	* @namespace
	*/
	CocoonJS.Social.ImageSizeType = 
	{
		/**
		* Represent a thumbnail like image size.
		*/
	    THUMB : "thumb",

		/**
		* Represents the small image size.
		*/
	    SMALL : "small",

		/**
		* Represents the medium image size.
		*/
	    MEDIUM : "medium",

		/**
		* Represents the large image size.
		*/
	    LARGE : "large"
	};

	/**
	* The data structure that represents the information of a user inside the social gaming extension.
	* @namespace
	* @constructor
	* @param {string} userID The id of the user.
	* @param {string} userName The user name of the user.
	*/
	CocoonJS.Social.UserInfo = function(userID, userName)
	{
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The user name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This type represents a message to be published.
	* @namespace
	* @constructor
	* @param {string} message The message to be published.
	* @param {string} mediaURL An URL to a media (image, video, ...)
	* @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
	* @param {string} linkText The text that will appear in the message link.
	* @param {string} linkCaption The text caption that will appear in the message link.
	*/
	CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
	{
		/**
		* The message to be published.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* An URL to a media (image, video, ...)
		* @field
		* @type string
		*/
		this.mediaURL = mediaURL;

		/**
		* An URL to add to the message so the user can click on that link to get more information.
		* @field
		* @type string
		*/
		this.linkURL = linkURL;

		/**
		* The text that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkText = linkText;

		/**
		* The text caption that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkCaption = linkCaption;

		return this;
	};

})();

//////////////////////////////////////
// COCOONJS_SOCIALGAMING.JS         //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    if (!CocoonJS.Social)
		throw("The CocoonJS.Social object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social Gamming extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.SocialGaming = function(nativeExtensionName, extensionName)
	{
		CocoonJS.SocialGaming.superclass.constructor.call(this, nativeExtensionName, extensionName);

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed} event calls.
	     * @name OnRequestUserAndFriendsScoresSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} userAndFriendsScoreInfos An array of {@link CocoonJS.SocialGaming.UserScoreInfo} objects representing the information of the user's and friends' scores.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and friends scores request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed} event calls.
	     * @name OnRequestUserAndFriendsScoresFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score and friends scores were requested.
	     * @param {string} leadeboardID The id of the leaderboard for whom the score and friends scores were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and his/her friends scores request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreSucceed} event calls.
	     * @name OnRequestUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.UserScoreInfo} userScoreInfo The info of the user's score.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreFailed} event calls.
	     * @name OnRequestUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score was requested.
	     * @param {string} leaderboardID The id of the leaderboard for whom the score was requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreSucceed} event calls.
	     * @name OnSubmitUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score has been submitted.
	     * @param {string} leaderboardID The id of the leaderboard for which the score has been submitted.
	     * @param {number} score The score that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreFailed} event calls.
	     * @name OnSubmitUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score submition was requested.
	     * @param {string} leaderboadID The id of the leaderboard for which the score submition was requested.
	     * @param {number} score The score that was submitted and failed.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} event calls.
	     * @name OnRequestUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where requested.
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of the user's achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsFailed} event calls.
	     * @name OnRequestUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were requested.
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} event calls.
	     * @name OnRequestAllAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of all the achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsFailed} event calls.
	     * @name OnRequestAllAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoSucceed} event calls.
	     * @name OnRequestAchievementInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.AchievementInfo} achievementInfo A {@link CocoonJS.SocialGaming.AchievementInfo} object representing the information of the achievement.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoFailed} event calls.
	     * @name OnRequestAchievementInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} achievementID The id of the achievement for which the information retrieval was requested.
	     * @param {string} errorMessage The error message.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementSucceed} event calls.
	     * @name OnSubmitUserAchievementSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievement has been submitted.
	     * @param {string} achievementID The id of the achievement that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementFailed} event calls.
	     * @name OnSubmitUserAchievementFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievment was submitted.
	     * @param {string} achievementID The id of the achievement that was submitted.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsSucceed} event calls.
	     * @name OnResetUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were reset.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsFailed} event calls.
	     * @name OnResetUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where tried to be reset.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the users closes the achievements view.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onAchievementsViewFailed} event calls.
	     * @name OnAchievementsViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} errorMessage The message that describes why the call failed.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the achievements view failed to show.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnAchievementsViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewFailed");

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when achievements view shows successfully.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewClosed} event calls.
	     * @name OnLeaderboardViewClosedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewClosedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewFailed} event calls.
	     * @name OnLeaderboardViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewSucceed} event calls.
	     * @name OnLeaderboardViewSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewSucceed");

		return this;
	};

	CocoonJS.SocialGaming.prototype = 
	{
        abstractToSocialGamingAchievementMap : null,
        abstractToSocialGamingAchievementMapInverse : null,

        /**
        * @ignore
        */
        setAbstractToSocialGamingAchievementMap : function( map ) {
            this.abstractToSocialGamingAchievementMap= map;

            // build a reciprocal map.
            this.abstractToSocialGamingAchievementMapInverse= {};
            for( var id in map ) {
                if ( map.hasOwnProperty(id) ) {
                    this.abstractToSocialGamingAchievementMapInverse[ map[id] ]= id;
                }
            }
            return this;
        },

        /**
        * @ignore
        */
        getAbstractToSocialGamingAchievementTranslation : function( achievementID ) {
            /**
             * If a translation map for abstract in-game achievements has been set, translate achievementID from
             * abstract to SocialGamingService.
             */
            if (this.abstractToSocialGamingAchievementMap) {
                var socialGamingAchievementID = this.abstractToSocialGamingAchievementMap[achievementID];
                if (socialGamingAchievementID) {
                    console.log("Abstract achieventID='" + achievementID + "' turned to '" + socialGamingAchievementID + "'");
                    achievementID = socialGamingAchievementID;
                } else {
                    console.log("Something may be wrong: abstract achievementID: '" + achievementID + "' w/o translation.")
                }
            }

            return achievementID;
        },

		/**
		* Request to retrieve the scores of all friends of a given user.
		* @param {string} [leaderboardID] The id of the leaderboard to request the scores for.
		* @param {string} [userID] The id of the user. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed
		*/
		requestUserAndFriendsScores : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAndFriendsScores", arguments, true);
			}
		},

		/**
		* Request to retrieve the score of a user.
		* @param {string} [leaderboardID] The id of the scores leaderboard to retireve the score from. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to retireve the score from. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserScoreSucceed
		* @see CocoonJS.SocualGaming.onRequestUserScoreFailed
		*/
		requestUserScore : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserScore", arguments, true);
			}
		},

		/**
		* Request to the server the score of a user.
		* @param {number} [score] the score to submit
		* @param {string} [leaderboardID] The id of the scores leaderboard to submit the score to. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to submit the score for. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onSubmitUserScoreSucceed
		* @see CocoonJS.SocualGaming.onSubmitUserScoreFailed
		*/
		submitUserScore : function(score, leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserScore", arguments, true);
			}
		},
		/**
		* Shows the leaderboard using a platform dependant view.
		* @param {string} [leaderboardID] The id of the scores leaderboard to show the view for. If null or underfined is passed, the "leadeboard" id will be used.
		* @see CocoonJS.SocialGaming.onLeaderboardViewClosed
		*/
		showLeaderboardView : function(leaderboardID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboardView", arguments, true);
			}
		},

		/**
		* Request to retrieve the user achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} and {@link CocoonJS.Social.onRequestUserAchievementsFailed} event handlers.
		* @param {string} [userID] The id of the user to retireve the achievements from. if null/undefined/"" is specified, the currently logged in user is assumed.
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsFailed
		*/
		requestUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve all the achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} and {@link CocoonJS.Social.onRequestAllAchievementsFailed} event handlers.
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsFailed
		*/
		requestAllAchievements : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAllAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve the information about an achievement. 
		* @param {string} achievementID The id of the achievement to get the information for.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}
		*/
		requestAchievementInfo : function(achievementID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAchievementInfo", arguments, true);
			}
		},

		/**
		* Submits an achievement to the server. If the process fails, the achievement is stored to submit it later.
		* @param {string} [achievementID] the achievement identifier
		* @param {number} [percentComplete] an optional number between 0 and 100 that indicates a completion percentage.
		* @see CocoonJS.SocialGaming.onSubmitAchievementSucceed
		* @see CocoonJS.SocualGaming.onSubmitAchievementFailed
		*/
        submitUserAchievement:function (achievementID, userID) {
            achievementID = this.getAbstractToSocialGamingAchievementTranslation(achievementID);

            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserAchievement", arguments, true);
            }
        },

		/**
		* Shows the achievements using a platform dependant view.
		* @see CocoonJS.SocialGaming.onAchievementsViewClosed
		*/
		showUserAchievementsView : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showUserAchievementsView", arguments, true);
			}
		},

		/**
		* Resets all the achievements of the current user
		* @param {string} [userID] The id of the user to reset the achievements for. If null/undefined/"", the logged in user is assumed.
		* @see CocoonJS.SocialGaming.onResetAchievementsSucceed
		* @see CocoonJS.SocualGaming.onResetAchievementsFailed
		*/
		resetUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetUserAchievements", arguments, true);
			}
		}
	};

	/**
    * @ignore
    */
	CocoonJS.extend(CocoonJS.SocialGaming, CocoonJS.Social);

	/**
	* The data structure that represents the information of the user score in the application.
	* @namespace
	* @constructor
	* @param {string} userID The user id.
	* @param {number} score The score of the user.
	* @param {string} userName The name of the user.
	* @param {string} imageURL The url of the user image.
	* @param {number} leaderboardID The id of the leaderboard the score belongs to.
	*/
	CocoonJS.SocialGaming.UserScoreInfo = function(userID, score, userName, imageURL, leaderboardID)
	{
		/**
		* The user id. 
		* @type string
		*/
		this.userID = userID;

		/**
		* The score of the user.
		* @type number
		*/
		this.score = score ? score : 0;

		/**
		* The name of the user.
		* @type string
		*/
        this.userName = userName;

		/**
		* The url of the user image.
		* @type string
		*/
        this.imageURL = imageURL;

        /**
		* The id of the leaderboard the score belongs to.
		* @type number
		*/
        this.leaderboardID = leaderboardID;
	};

	/**
	* The data structure that represents the information of an achievement in the application.
	* @namespace
	* @constructor
	* @param {string} achievementID The id of the achievement info.
	* @param {string} title The title of the achievement.
	* @param {string} description The description of the achievement.
	* @param {string} imageURL The url to the image representing the achievement.
	* @param {number} points The points value of the achievement
	*/
	CocoonJS.SocialGaming.AchievementInfo = function(achievementID, title, description, imageURL, points)
	{
		/**
		* The id of the achievement info.
		* @type string
		*/
		this.achievementID = achievementID;

		/**
		* The title of the achievement.
		* @type string
		*/
		this.title = title;

		/**
		* The description of the achievement.
		* @type string
		*/
		this.description = description;

		/**
		* The url to the image representing the achievement.
		* @type string
		*/
		this.imageURL = imageURL;

		/**
		* The points value of the achievement
		* @type number
		*/
		this.points = points ? points : 0;
	};

})();

/////////////////////////////////////////
// COCOONJS_SOCIALGAMING_GAMECENTER.JS //
/////////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.SocialGaming === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.SocialGaming object must exist and be valid before creating a Game Center extension object.");

	/**
	* This instance represents the extension object to access GameCenter related native functionalities.
	* The data structure for initialization: None.
	* @see CocoonJS.Social
	*/
	CocoonJS.SocialGaming.GameCenter = new CocoonJS.SocialGaming("IDTK_SRV_SOCIAL_GAMECENTER", "SocialGaming.GameCenter");
})();

//////////////////////////////
// COCOONJS_GAMEPAD.JS 		//
//////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    CocoonJS.Gamepad.Indices = {
        BUTTON_0                : 0, 
        BUTTON_1                : 1,
        BUTTON_2                : 2,
        BUTTON_3                : 3,
        BUTTON_LEFT_BUMPER      : 4,
        BUTTON_RIGHT_BUMPER     : 5,
        
        BUTTON_LEFT_TRIGGER     : 6,
        BUTTON_RIGHT_TRIGGER    : 7,
        
        BUTTON_LEFT_JOYSTICK    : 10,
        BUTTON_RIGHT_JOYSTICK   : 11,
        BUTTON_DPAD_UP          : 12,
        BUTTON_DPAD_DOWN        : 13,
        BUTTON_DPAD_LEFT        : 14,
        BUTTON_DPAD_RIGHT       : 15,
        BUTTON_MENU             : 16,
        
        AXE_LEFT_JOYSTICK_X     : 0,
        AXE_LEFT_JOYSTICK_Y     : 1,
        AXE_RIGHT_JOYSTICK_X    : 2,
        AXE_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (CocoonJS.Gamepad.nativeExtensionObjectAvailable && !systemSupportsGamepads)
    {
        navigator.getGamepads = function()
        {
            return window.ext.Gamepad.makeCall("getGamepads");
        };

        CocoonJS.Gamepad.originalWindowAddEventListener = window.addEventListener;
        CocoonJS.Gamepad.originalWindowRemoveEventListener = window.removeEventListener;

        window.addEventListener = function(eventName, callback)
        {
            console.log("The new window.addEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.addEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowAddEventListener.apply(window, argumentsArray);
            }
        };
        window.removeEventListener = function(eventName, callback)
        {
            console.log("The new window.removeEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.removeEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowRemoveEventListener.apply(window, argumentsArray);
            }
        };
    } 
    else if (systemSupportsGamepads) 
    {
        if (!navigator.getGamepads)
        {
            console.log("navigator.getGamepads does not exist.");
            if (navigator.webkitGetGamepads)
            {
                console.log("navigator.webkitGamepads exists, adding navigator.getGamepads to point to it.");
                navigator.getGamepads = navigator.webkitGetGamepads;
            }
            else
            {
                console.log("navigator.webkitGetGamepads does not exist either.");
            }
        }
    }
})();

//////////////////////////////
// COCOONJS_NOTIFICATION.JS //
//////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Notification extension.
    * @namespace
    */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

	/**
	* The data structure that represents the information of a local notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {string} contentBody The body content to be showed in the expanded notification information.
	* @param {string} contentTitle The title to be showed in the expanded notification information.
	* @param {number} date Time in millisecs from 1970 when the notification will be fired.
	*/
	CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* (iOS only) The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData;

		/**
		* (Android only) The body content to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentBody !== undefined)
			this.contentBody = contentBody;
		else
			this.contentBody = "";

		/**
		* (Android only) The title to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentTitle !== undefined)
			this.contentTitle = contentTitle;
		else
			this.contentTitle = "";

		/**
		* Time in millisecs from 1970 when the local notification will be fired
		* @field
		* @type number
		*/
		var currentTime = new Date().getTime();
		if (scheduleTime !== undefined){
			this.scheduleTime = scheduleTime;
		}else{
			this.scheduleTime = currentTime;
		}
	};

	/**
	* The data structure that represents the information of a push notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {array} channels An array containing the channels names this notification will be delivered to.
	* @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	* @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	*/
	CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData

		/**
		* An array containing the channels names this notification will be delivered to.
		* @field
		* @type array
		*/
		this.channels = channels;

		/**
		* A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTime !== undefined)
			this.expirationTime = expirationTime;
		else
			this.expirationTime = 0;

		/**
		* An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTimeInterval !== undefined)
			this.expirationTimeInterval = expirationTimeInterval;
		else
			this.expirationTimeInterval = 0;
	};

	/**
	* Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
	*/
	CocoonJS.Notification.start = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments, true);
		}
	};


	/**
	* Register to be able to receive push notifications.
	* The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
	* @function
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
	*/
	CocoonJS.Notification.registerForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
		}
	};

	/**
	* Unregister from receiving push notifications.
	* The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
	* @function
	* @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
	*/
	CocoonJS.Notification.unregisterForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
		}
	};

	/**
	* Cancel the last sent local notification.
	* The last sent local notification will be remove from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelLastSentLocalNotificiation = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
		}
	};

	/**
	* Cancel all sent local notifications.
	* All the notifications will ve removed from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelAllLocalNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments, true);
		}
	};

	/**
	* Send a local notification.
	* @function
	* @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
	*/
	CocoonJS.Notification.sendLocalNotification = function(localNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
		}
	};

	/**
	* Subscribe to a channel in order to receive notifications targeted to that channel.
	* @function
	* @param {string} channel The channel id to subscribe to.
	*/
	CocoonJS.Notification.subscribeToChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
		}
	};

	/**
	* Unsubscribe from a channel in order to stop receiving notifications targeted to it.
	* @function
	* @param {string} channel The channel id to unsubscribe from.
	*/
	CocoonJS.Notification.unsubscribeFromChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
		}
	};

	/**
	* Send a push notification.
	* @function
	* @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
	* @see CocoonJS.Notification.onPushNotificationDeliverySucceed
	* @see CocoonJS.Notification.onPushNotificationDeliveryFailed
	*/
	CocoonJS.Notification.sendPushNotification = function(pushNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
		}
	};

	/**
	* (iOS only) Set the badge number for this application.
	* This is useful if you want to modify the badge number set by a notification.
	* @function
	* @param {number} badgeNumber The number of the badge.
	*/
	CocoonJS.Notification.setBadgeNumber = function(badgeNumber)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
		}
	};

	/**
	* (iOS only) Returns the current badge number.
	* @function
	* @returns {number} The badge number.
	*/
	CocoonJS.Notification.getBadgeNumber = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
		}
	};

	/**
	* Returns the last received user data from a Local notification.
	* @function
	* @returns {object} The last received user data from a Local notification.
	*/
	CocoonJS.Notification.getLastReceivedLocalNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
		}
	};

	/**
	* Returns the last received user data from a Push notification.
	* @function
	* @returns {object} The last received user data from a Push notification.
	*/
	CocoonJS.Notification.getLastReceivedPushNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @param {string} token The token (apid or device token) received at registration time.
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
    * The callback function receives a parameter with the notificationId of the delivered notification.
    * @static
    * @event
    * @param {string} userData A string with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();

/////////////////
// PATHFIND.JS //
/////////////////

// Pathfind.js
// Written by Ashley Gullen
// Copyright (c) 2013 Scirra Ltd.

// A* pathfinding javascript implementation

(function() {
	
	var PF_CLEAR = 0;
	var PF_OBSTACLE = 32767;
	
	function node()
	{
		this.parent = null;
		
		this.x = 0;
		this.y = 0;

		this.f = 0;
		this.g = 0;
		this.h = 0;
	};
	
	var nodeCache = [];			// for recycling nodes
	
	function allocNode()
	{
		var ret;
		
		if (nodeCache.length)
			ret = nodeCache.pop();
		else
			ret = new node();
			
		ret.parent = null;
		ret.x = 0;
		ret.y = 0;
		ret.f = 0;
		ret.g = 0;
		ret.h = 0;
		return ret;
	};
	
	function freeNode(n)
	{
		if (nodeCache.length < 64000)
			nodeCache.push(n);
	};
	
	function resultNode(x_, y_)
	{
		this.x = x_ || 0;
		this.y = y_ || 0;
	};
	
	var resultNodeCache = [];			// for recycling resultNodes
	
	function allocResultNode()
	{
		if (resultNodeCache.length)
			return resultNodeCache.pop();
		else
			return new resultNode(0, 0);
	};
	
	function freeResultNode(n)
	{
		if (resultNodeCache.length < 10000)
			resultNodeCache.push(n);
	};
	
	var workersSupported = (typeof Worker !== "undefined");
	var isInWebWorker = (typeof document === "undefined");		// no DOM in a worker
	var myInstance = null;										// single pathfinder instance for worker
	
	if (isInWebWorker)
	{
		self.addEventListener("message", function (e)
		{
			var d = e.data;
			
			if (!d)
				return;		// could be empty postMessage() to start worker
			
			if (d.cmd === "init")
			{
				if (!myInstance)
					myInstance = new pathfinder();
					
				myInstance.init(d.hcells, d.vcells, d.data, d.diagonals);
			}
			else if (d.cmd === "find")
			{
				// receive a pathfind job, process it them dispatch result
				myInstance.pathEnd.parent = null;
				myInstance.targetX = d.endX;
				myInstance.targetY = d.endY;
				
				if (myInstance.doLongFindPath(d.startX, d.startY))
				{
					self.postMessage({ cmd: "result", pathList: myInstance.pathList });
				}
				else
				{
					self.postMessage({ cmd: "result", pathList: null });
				}
			}
			else if (d.cmd === "setdiag")
			{
				// update diagonalsEnabled flag
				myInstance.diagonalsEnabled = d.diagonals;
			}
			
		}, false);
	}
	
	function pathfinder()
	{
		this.hcells = 0;
		this.vcells = 0;
		
		this.pathEnd = allocNode();
		
		this.cells = null;
		this.openList = [];
		this.closedList = [];
		this.closedCache = {};
		this.pathList = [];
		
		this.currentNode = null;
		this.targetX = 0;
		this.targetY = 0;
		this.diagonalsEnabled = true;
		
		this.worker = null;
		this.workerQueue = [];		// jobs awaiting completion from worker in order of requests made
		this.workerRecycle = [];
		
		var self = this;
		var i, len;
		
		if (workersSupported && !isInWebWorker)
		{
			// Create worker and receive results of pathfind jobs from it
			this.worker = new Worker("pathfind.js");
			
			this.worker.addEventListener("message", function (e) {
			
				if (!e || !e.data)
					return;
				
				if (e.data.cmd === "result")
				{
					if (e.data.pathList)
					{
						for (i = 0, len = self.pathList.length; i < len; i++)
							freeResultNode(self.pathList[i]);
						
						self.pathList = e.data.pathList;
						self.workerQueue[0].success();
					}
					else
						self.workerQueue[0].fail();
						
					self.workerRecycle.push(self.workerQueue.shift());
				}
			}, false);
			
			this.worker.addEventListener("error", function (e) {
				console.error(e);
			}, false);
			
			this.worker.postMessage(null);
		}
	};
	
	pathfinder.prototype.init = function (hcells_, vcells_, data_, diagonals_)
	{
		this.hcells = hcells_;
		this.vcells = vcells_;
		this.cells = data_;
		this.diagonalsEnabled = diagonals_;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "init",
				hcells: hcells_,
				vcells: vcells_,
				diagonals: diagonals_,
				data: data_
			});
		}
	};
	
	pathfinder.prototype.isReady = function ()
	{
		return !!this.cells;
	};
	
	pathfinder.prototype.setDiagonals = function (d)
	{
		if (this.diagonalsEnabled === d)
			return;
		
		this.diagonalsEnabled = d;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "setdiag",
				diagonals: d,
			});
		}
	};
	
	pathfinder.prototype.at = function (x_, y_)
	{
		if (x_ < 0 || y_ < 0 || x_ >= this.hcells || y_ >= this.vcells)
			return PF_OBSTACLE;
			
		return this.cells[x_][y_];
	};
	
	pathfinder.prototype.findPath = function (startX, startY, endX, endY, successCallback, failCallback)
	{
		if (!this.cells)
		{
			// not yet initialised
			failCallback();
			return;
		}
		
		startX = Math.floor(startX);
		startY = Math.floor(startY);
		endX = Math.floor(endX);
		endY = Math.floor(endY);
		
		this.targetX = endX;
		this.targetY = endY;
		this.pathEnd.parent = null;
		
		// Check the box made by the start and dest cells.
		// If the complete box is empty, allow a direct move to target.
		var minX = Math.min(startX, endX);
		var maxX = Math.max(startX, endX);
		var minY = Math.min(startY, endY);
		var maxY = Math.max(startY, endY);
		
		// Path goes out of bounds: no calculable path
		if (minX < 0 || minY < 0 || maxX >= this.hcells || maxY >= this.vcells)
		{
			failCallback();
			return;
		}
		
		var x, y, i, len, c, h, n;

		if (this.diagonalsEnabled)
		{
			var canMoveDirect = true;
			
			for (x = minX; x <= maxX; x++)
			{
				for (y = minY; y <= maxY; y++)
				{
					if (this.cells[x][y] !== 0)
					{
						canMoveDirect = false;
						
						// Break both loops
						x = maxX + 1;
						break;
					}
				}
			}

			// A "direct" path is available (box is empty)
			if (canMoveDirect)
			{
				for (i = 0, len = this.pathList.length; i < len; i++)
					freeResultNode(this.pathList[i]);
				this.pathList.length = 0;
			
				this.pathEnd.x = endX;
				this.pathEnd.y = endY;
				this.pathEnd.parent = null;
				n = allocResultNode();
				n.x = endX;
				n.y = endY;
				this.pathList.push(n);
				successCallback();
				return;
			}
		}
		
		if (workersSupported)
		{
			// recycle objects in the worker queue
			if (this.workerRecycle.length)
				h = this.workerRecycle.pop();
			else
				h = {};
			
			h.success = successCallback;
			h.fail = failCallback;
			
			// dispatch the heavy lifting to the worker thread
			this.workerQueue.push(h);

			this.worker.postMessage({
				cmd: "find",
				startX: startX,
				startY: startY,
				endX: endX,
				endY: endY
			});
		}
		else
		{
			// no web worker support, just run on main thread
			if (this.doLongFindPath(startX, startY))
				successCallback();
			else
				failCallback();
		}
	};
		
	pathfinder.prototype.doLongFindPath = function (startX, startY)
	{
		var i, len, c, n, p, lastDir = 8, curDir = -1, addNode;
		for (i = 0, len = this.openList.length; i < len; i++)
			freeNode(this.openList[i]);
		for (i = 0, len = this.closedList.length; i < len; i++)
			freeNode(this.closedList[i]);
		for (i = 0, len = this.pathList.length; i < len; i++)
			freeResultNode(this.pathList[i]);
		this.openList.length = 0;
		this.closedList.length = 0;
		this.closedCache = {};
		this.pathList.length = 0;

		// Add the start node to the open list
		var startNode = allocNode();
		startNode.x = startX;
		startNode.y = startY;

		this.openList.push(startNode);
		var obsLeft = false, obsTop = false, obsRight = false, obsBottom = false;
		var diagonals = this.diagonalsEnabled;
		
		// While there are nodes on the open list
		while (this.openList.length)
		{
			// Move the best F value to closed list
			c = this.openList.shift();
			this.closedList.unshift(c);
			this.closedCache[((c.x << 16) + c.y).toString()] = true;

			// Are we there yet?
			if (c.x === this.targetX && c.y === this.targetY)
			{
				this.pathEnd.parent = c.parent;
				this.pathEnd.x = c.x;
				this.pathEnd.y = c.y;
				
				// Link up the whole path to an indexable array
				p = this.pathEnd;
				
				while (p)
				{
					// filter redundant nodes in straight lines
					if (this.pathList.length === 0)
					{
						addNode = true;
						
						if (p.parent)
						{
							lastDir = this.nodeDirection(p, p.parent);
							curDir = lastDir;
						}
					}
					else if (!p.parent)
						addNode = false;
					else 
					{
						curDir = this.nodeDirection(p, p.parent);
						addNode = (curDir !== lastDir);
					}
					
					if (addNode)
					{
						n = allocResultNode();
						n.x = p.x;
						n.y = p.y;
						this.pathList.unshift(n);
						lastDir = curDir;
					}
					
					p = p.parent;
				}
				
				return true;
			}

			// Get current node
			this.currentNode = c;
			var x = c.x;
			var y = c.y;
			
			var obsLeft = (this.at(x - 1, y) === PF_OBSTACLE);
			var obsTop = (this.at(x, y - 1) === PF_OBSTACLE);
			var obsRight = (this.at(x + 1, y) === PF_OBSTACLE);
			var obsBottom = (this.at(x, y + 1) === PF_OBSTACLE);

			// Check adjacent 8 nodes.  No diagonals allowed if either cell being crossed is obstacle.
			if (!obsLeft)
				this.addCellToOpenList(x - 1, y, 10);

			if (diagonals && !obsLeft && !obsTop)
				this.addCellToOpenList(x - 1, y - 1, 14);

			if (!obsTop)
				this.addCellToOpenList(x, y - 1, 10);

			if (diagonals && !obsTop && !obsRight)
				this.addCellToOpenList(x + 1, y - 1, 14);

			if (!obsRight)
				this.addCellToOpenList(x + 1, y, 10);

			if (diagonals && !obsRight && !obsBottom)
				this.addCellToOpenList(x + 1, y + 1, 14);

			if (!obsBottom)
				this.addCellToOpenList(x, y + 1, 10);

			if (diagonals && !obsBottom && !obsLeft)
				this.addCellToOpenList(x - 1, y + 1, 14);
		}
		
		return false;
	};
	
	pathfinder.prototype.insertToOpenList = function (c)
	{
		var i, len;
		
		// Needs to go at end
		if (c.f >= this.openList[this.openList.length - 1].f)
		{
			this.openList.push(c);
		}
		else
		{
			for (i = 0, len = this.openList.length; i < len; i++)
			{
				if (c.f < this.openList[i].f)
				{
					this.openList.splice(i, 0, c);
					break;
				}
			}
		}
	};
	
	pathfinder.prototype.addCellToOpenList = function (x_, y_, g_)
	{
		// Ignore if cell on closed list
		if (this.closedCache.hasOwnProperty(((x_ << 16) + y_).toString()))
			return;
		
		var i, len, c;
		
		// Cell costs can be increased by changing the number in the map
		var curCellCost = this.at(x_, y_);

		// Is this cell already on the open list?
		for (i = 0, len = this.openList.length; i < len; i++)
		{
			c = this.openList[i];
			
			if (x_ === c.x && y_ === c.y)
			{
				// Is this a better path?
				if (this.currentNode.g + g_ + curCellCost < c.g)
				{
					// Update F, G and H and update parent
					c.parent = this.currentNode;
					c.g = this.currentNode.g + g_ + curCellCost;
					c.h = this.estimateH(c.x, c.y);
					c.f = c.g + c.h;

					// This node's F has changed:  Delete it then re-insert it in the right place

					if (this.openList.length === 1)
					{
						// no need to remove then re-insert same node, just leave it there
						return;
					}
					
					this.openList.splice(i, 1);
					this.insertToOpenList(c);
				}

				return;
			}
		}

		// Not on the open list; add it in the right place
		c = allocNode();
		c.x = x_;
		c.y = y_;
		c.h = this.estimateH(x_, y_);
		c.g = this.currentNode.g + g_ + curCellCost;
		c.f = c.h + c.g;
		c.parent = this.currentNode;

		// Insert this node sorted in the open list
		// The loop below won't add new largest F values
		if (!this.openList.length)
		{
			this.openList.push(c);
			return;
		}
		
		this.insertToOpenList(c);
	};
	
	function quickAbs(x)
	{
		return x < 0 ? -x : x;
	};
	
	pathfinder.prototype.estimateH = function (x_, y_)
	{
		var dx = quickAbs(x_ - this.targetX);
		var dy = quickAbs(y_ - this.targetY);

		return dx * 10 + dy * 10;
	};
	
	pathfinder.prototype.nodeDirection = function (a, b)
	{
		var ax = a.x;
		var ay = a.y;
		var bx = b.x;
		var by = b.y;

		if (ax === bx)
		{
			if (by > ay) return 6;
			if (by < ay) return 2;
			if (ay == by) return 8;
		}
		else if (ay === by)
		{
			if (bx > ax) return 4;
			if (by < ax) return 0;
		}
		else
		{
			if (bx < ax && by < ay) return 1;
			if (bx > ax && by < ay) return 3;
			if (bx < ax && by > ay) return 7;
			if (bx > ax && by > ay) return 5;
		}
		return 8;
	};
	
	if (!isInWebWorker)
	{
		window.PF_CLEAR = PF_CLEAR;
		window.PF_OBSTACLE = PF_OBSTACLE;
		window.Pathfinder = pathfinder;
		
		window.ResultNode = resultNode;
		window.allocResultNode = allocResultNode;
		window.freeResultNode = freeResultNode;
	}

})();
(function() {
var cr = {};
cr.plugins_ = {};
cr.behaviors = {};
if (typeof Object.getPrototypeOf !== "function")
{
	if (typeof "test".__proto__ === "object")
	{
		Object.getPrototypeOf = function(object) {
			return object.__proto__;
		};
	}
	else
	{
		Object.getPrototypeOf = function(object) {
			return object.constructor.prototype;
		};
	}
}
(function(){
	cr.logexport = function (msg)
	{
		if (window.console && window.console.log)
			window.console.log(msg);
	};
	cr.seal = function(x)
	{
		return x;
	};
	cr.freeze = function(x)
	{
		return x;
	};
	cr.is_undefined = function (x)
	{
		return typeof x === "undefined";
	};
	cr.is_number = function (x)
	{
		return typeof x === "number";
	};
	cr.is_string = function (x)
	{
		return typeof x === "string";
	};
	cr.isPOT = function (x)
	{
		return x > 0 && ((x - 1) & x) === 0;
	};
	cr.nextHighestPowerOfTwo = function(x) {
		--x;
		for (var i = 1; i < 32; i <<= 1) {
			x = x | x >> i;
		}
		return x + 1;
	}
	cr.abs = function (x)
	{
		return (x < 0 ? -x : x);
	};
	cr.max = function (a, b)
	{
		return (a > b ? a : b);
	};
	cr.min = function (a, b)
	{
		return (a < b ? a : b);
	};
	cr.PI = Math.PI;
	cr.round = function (x)
	{
		return (x + 0.5) | 0;
	};
	cr.floor = function (x)
	{
		if (x >= 0)
			return x | 0;
		else
			return (x | 0) - 1;		// correctly round down when negative
	};
	cr.ceil = function (x)
	{
		var f = x | 0;
		return (f === x ? f : f + 1);
	};
	function Vector2(x, y)
	{
		this.x = x;
		this.y = y;
		cr.seal(this);
	};
	Vector2.prototype.offset = function (px, py)
	{
		this.x += px;
		this.y += py;
		return this;
	};
	Vector2.prototype.mul = function (px, py)
	{
		this.x *= px;
		this.y *= py;
		return this;
	};
	cr.vector2 = Vector2;
	cr.segments_intersect = function(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y)
	{
		var max_ax, min_ax, max_ay, min_ay, max_bx, min_bx, max_by, min_by;
		if (a1x < a2x)
		{
			min_ax = a1x;
			max_ax = a2x;
		}
		else
		{
			min_ax = a2x;
			max_ax = a1x;
		}
		if (b1x < b2x)
		{
			min_bx = b1x;
			max_bx = b2x;
		}
		else
		{
			min_bx = b2x;
			max_bx = b1x;
		}
		if (max_ax < min_bx || min_ax > max_bx)
			return false;
		if (a1y < a2y)
		{
			min_ay = a1y;
			max_ay = a2y;
		}
		else
		{
			min_ay = a2y;
			max_ay = a1y;
		}
		if (b1y < b2y)
		{
			min_by = b1y;
			max_by = b2y;
		}
		else
		{
			min_by = b2y;
			max_by = b1y;
		}
		if (max_ay < min_by || min_ay > max_by)
			return false;
		var dpx = b1x - a1x + b2x - a2x;
		var dpy = b1y - a1y + b2y - a2y;
		var qax = a2x - a1x;
		var qay = a2y - a1y;
		var qbx = b2x - b1x;
		var qby = b2y - b1y;
		var d = cr.abs(qay * qbx - qby * qax);
		var la = qbx * dpy - qby * dpx;
		if (cr.abs(la) > d)
			return false;
		var lb = qax * dpy - qay * dpx;
		return cr.abs(lb) <= d;
	};
	function Rect(left, top, right, bottom)
	{
		this.set(left, top, right, bottom);
		cr.seal(this);
	};
	Rect.prototype.set = function (left, top, right, bottom)
	{
		this.left = left;
		this.top = top;
		this.right = right;
		this.bottom = bottom;
	};
	Rect.prototype.copy = function (r)
	{
		this.left = r.left;
		this.top = r.top;
		this.right = r.right;
		this.bottom = r.bottom;
	};
	Rect.prototype.width = function ()
	{
		return this.right - this.left;
	};
	Rect.prototype.height = function ()
	{
		return this.bottom - this.top;
	};
	Rect.prototype.offset = function (px, py)
	{
		this.left += px;
		this.top += py;
		this.right += px;
		this.bottom += py;
		return this;
	};
	Rect.prototype.normalize = function ()
	{
		var temp = 0;
		if (this.left > this.right)
		{
			temp = this.left;
			this.left = this.right;
			this.right = temp;
		}
		if (this.top > this.bottom)
		{
			temp = this.top;
			this.top = this.bottom;
			this.bottom = temp;
		}
	};
	Rect.prototype.intersects_rect = function (rc)
	{
		return !(rc.right < this.left || rc.bottom < this.top || rc.left > this.right || rc.top > this.bottom);
	};
	Rect.prototype.intersects_rect_off = function (rc, ox, oy)
	{
		return !(rc.right + ox < this.left || rc.bottom + oy < this.top || rc.left + ox > this.right || rc.top + oy > this.bottom);
	};
	Rect.prototype.contains_pt = function (x, y)
	{
		return (x >= this.left && x <= this.right) && (y >= this.top && y <= this.bottom);
	};
	Rect.prototype.equals = function (r)
	{
		return this.left === r.left && this.top === r.top && this.right === r.right && this.bottom === r.bottom;
	};
	cr.rect = Rect;
	function Quad()
	{
		this.tlx = 0;
		this.tly = 0;
		this.trx = 0;
		this.try_ = 0;	// is a keyword otherwise!
		this.brx = 0;
		this.bry = 0;
		this.blx = 0;
		this.bly = 0;
		cr.seal(this);
	};
	Quad.prototype.set_from_rect = function (rc)
	{
		this.tlx = rc.left;
		this.tly = rc.top;
		this.trx = rc.right;
		this.try_ = rc.top;
		this.brx = rc.right;
		this.bry = rc.bottom;
		this.blx = rc.left;
		this.bly = rc.bottom;
	};
	Quad.prototype.set_from_rotated_rect = function (rc, a)
	{
		if (a === 0)
		{
			this.set_from_rect(rc);
		}
		else
		{
			var sin_a = Math.sin(a);
			var cos_a = Math.cos(a);
			var left_sin_a = rc.left * sin_a;
			var top_sin_a = rc.top * sin_a;
			var right_sin_a = rc.right * sin_a;
			var bottom_sin_a = rc.bottom * sin_a;
			var left_cos_a = rc.left * cos_a;
			var top_cos_a = rc.top * cos_a;
			var right_cos_a = rc.right * cos_a;
			var bottom_cos_a = rc.bottom * cos_a;
			this.tlx = left_cos_a - top_sin_a;
			this.tly = top_cos_a + left_sin_a;
			this.trx = right_cos_a - top_sin_a;
			this.try_ = top_cos_a + right_sin_a;
			this.brx = right_cos_a - bottom_sin_a;
			this.bry = bottom_cos_a + right_sin_a;
			this.blx = left_cos_a - bottom_sin_a;
			this.bly = bottom_cos_a + left_sin_a;
		}
	};
	Quad.prototype.offset = function (px, py)
	{
		this.tlx += px;
		this.tly += py;
		this.trx += px;
		this.try_ += py;
		this.brx += px;
		this.bry += py;
		this.blx += px;
		this.bly += py;
		return this;
	};
	var minresult = 0;
	var maxresult = 0;
	function minmax4(a, b, c, d)
	{
		if (a < b)
		{
			if (c < d)
			{
				if (a < c)
					minresult = a;
				else
					minresult = c;
				if (b > d)
					maxresult = b;
				else
					maxresult = d;
			}
			else
			{
				if (a < d)
					minresult = a;
				else
					minresult = d;
				if (b > c)
					maxresult = b;
				else
					maxresult = c;
			}
		}
		else
		{
			if (c < d)
			{
				if (b < c)
					minresult = b;
				else
					minresult = c;
				if (a > d)
					maxresult = a;
				else
					maxresult = d;
			}
			else
			{
				if (b < d)
					minresult = b;
				else
					minresult = d;
				if (a > c)
					maxresult = a;
				else
					maxresult = c;
			}
		}
	};
	Quad.prototype.bounding_box = function (rc)
	{
		minmax4(this.tlx, this.trx, this.brx, this.blx);
		rc.left = minresult;
		rc.right = maxresult;
		minmax4(this.tly, this.try_, this.bry, this.bly);
		rc.top = minresult;
		rc.bottom = maxresult;
	};
	Quad.prototype.contains_pt = function (x, y)
	{
		var v0x = this.trx - this.tlx;
		var v0y = this.try_ - this.tly;
		var v1x = this.brx - this.tlx;
		var v1y = this.bry - this.tly;
		var v2x = x - this.tlx;
		var v2y = y - this.tly;
		var dot00 = v0x * v0x + v0y * v0y
		var dot01 = v0x * v1x + v0y * v1y
		var dot02 = v0x * v2x + v0y * v2y
		var dot11 = v1x * v1x + v1y * v1y
		var dot12 = v1x * v2x + v1y * v2y
		var invDenom = 1.0 / (dot00 * dot11 - dot01 * dot01);
		var u = (dot11 * dot02 - dot01 * dot12) * invDenom;
		var v = (dot00 * dot12 - dot01 * dot02) * invDenom;
		if ((u >= 0.0) && (v > 0.0) && (u + v < 1))
			return true;
		v0x = this.blx - this.tlx;
		v0y = this.bly - this.tly;
		var dot00 = v0x * v0x + v0y * v0y
		var dot01 = v0x * v1x + v0y * v1y
		var dot02 = v0x * v2x + v0y * v2y
		invDenom = 1.0 / (dot00 * dot11 - dot01 * dot01);
		u = (dot11 * dot02 - dot01 * dot12) * invDenom;
		v = (dot00 * dot12 - dot01 * dot02) * invDenom;
		return (u >= 0.0) && (v > 0.0) && (u + v < 1);
	};
	Quad.prototype.at = function (i, xory)
	{
		if (xory)
		{
			switch (i)
			{
				case 0: return this.tlx;
				case 1: return this.trx;
				case 2: return this.brx;
				case 3: return this.blx;
				case 4: return this.tlx;
				default: return this.tlx;
			}
		}
		else
		{
			switch (i)
			{
				case 0: return this.tly;
				case 1: return this.try_;
				case 2: return this.bry;
				case 3: return this.bly;
				case 4: return this.tly;
				default: return this.tly;
			}
		}
	};
	Quad.prototype.midX = function ()
	{
		return (this.tlx + this.trx  + this.brx + this.blx) / 4;
	};
	Quad.prototype.midY = function ()
	{
		return (this.tly + this.try_ + this.bry + this.bly) / 4;
	};
	Quad.prototype.intersects_segment = function (x1, y1, x2, y2)
	{
		if (this.contains_pt(x1, y1) || this.contains_pt(x2, y2))
			return true;
		var a1x, a1y, a2x, a2y;
		var i;
		for (i = 0; i < 4; i++)
		{
			a1x = this.at(i, true);
			a1y = this.at(i, false);
			a2x = this.at(i + 1, true);
			a2y = this.at(i + 1, false);
			if (cr.segments_intersect(x1, y1, x2, y2, a1x, a1y, a2x, a2y))
				return true;
		}
		return false;
	};
	Quad.prototype.intersects_quad = function (rhs)
	{
		var midx = rhs.midX();
		var midy = rhs.midY();
		if (this.contains_pt(midx, midy))
			return true;
		midx = this.midX();
		midy = this.midY();
		if (rhs.contains_pt(midx, midy))
			return true;
		var a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
		var i, j;
		for (i = 0; i < 4; i++)
		{
			for (j = 0; j < 4; j++)
			{
				a1x = this.at(i, true);
				a1y = this.at(i, false);
				a2x = this.at(i + 1, true);
				a2y = this.at(i + 1, false);
				b1x = rhs.at(j, true);
				b1y = rhs.at(j, false);
				b2x = rhs.at(j + 1, true);
				b2y = rhs.at(j + 1, false);
				if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
					return true;
			}
		}
		return false;
	};
	cr.quad = Quad;
	cr.RGB = function (red, green, blue)
	{
		return Math.max(Math.min(red, 255), 0)
			 | (Math.max(Math.min(green, 255), 0) << 8)
			 | (Math.max(Math.min(blue, 255), 0) << 16);
	};
	cr.GetRValue = function (rgb)
	{
		return rgb & 0xFF;
	};
	cr.GetGValue = function (rgb)
	{
		return (rgb & 0xFF00) >> 8;
	};
	cr.GetBValue = function (rgb)
	{
		return (rgb & 0xFF0000) >> 16;
	};
	cr.shallowCopy = function (a, b, allowOverwrite)
	{
		var attr;
		for (attr in b)
		{
			if (b.hasOwnProperty(attr))
			{
;
				a[attr] = b[attr];
			}
		}
		return a;
	};
	cr.arrayRemove = function (arr, index)
	{
		var i, len;
		index = cr.floor(index);
		if (index < 0 || index >= arr.length)
			return;							// index out of bounds
		if (index === 0)					// removing first item
			arr.shift();
		else if (index === arr.length - 1)	// removing last item
			arr.pop();
		else
		{
			for (i = index, len = arr.length - 1; i < len; i++)
				arr[i] = arr[i + 1];
			arr.length = len;
		}
	};
	cr.shallowAssignArray = function (dest, src)
	{
		dest.length = src.length;
		var i, len;
		for (i = 0, len = src.length; i < len; i++)
			dest[i] = src[i];
	};
	cr.appendArray = function (a, b)
	{
		a.push.apply(a, b);
	};
	cr.arrayFindRemove = function (arr, item)
	{
		var index = arr.indexOf(item);
		if (index !== -1)
			cr.arrayRemove(arr, index);
	};
	cr.clamp = function(x, a, b)
	{
		if (x < a)
			return a;
		else if (x > b)
			return b;
		else
			return x;
	};
	cr.to_radians = function(x)
	{
		return x / (180.0 / cr.PI);
	};
	cr.to_degrees = function(x)
	{
		return x * (180.0 / cr.PI);
	};
	cr.clamp_angle_degrees = function (a)
	{
		a %= 360;       // now in (-360, 360) range
		if (a < 0)
			a += 360;   // now in [0, 360) range
		return a;
	};
	cr.clamp_angle = function (a)
	{
		a %= 2 * cr.PI;       // now in (-2pi, 2pi) range
		if (a < 0)
			a += 2 * cr.PI;   // now in [0, 2pi) range
		return a;
	};
	cr.to_clamped_degrees = function (x)
	{
		return cr.clamp_angle_degrees(cr.to_degrees(x));
	};
	cr.to_clamped_radians = function (x)
	{
		return cr.clamp_angle(cr.to_radians(x));
	};
	cr.angleTo = function(x1, y1, x2, y2)
	{
		var dx = x2 - x1;
        var dy = y2 - y1;
		return Math.atan2(dy, dx);
	};
	cr.angleDiff = function (a1, a2)
	{
		if (a1 === a2)
			return 0;
		var s1 = Math.sin(a1);
		var c1 = Math.cos(a1);
		var s2 = Math.sin(a2);
		var c2 = Math.cos(a2);
		var n = s1 * s2 + c1 * c2;
		if (n >= 1)
			return 0;
		if (n <= -1)
			return cr.PI;
		return Math.acos(n);
	};
	cr.angleRotate = function (start, end, step)
	{
		var ss = Math.sin(start);
		var cs = Math.cos(start);
		var se = Math.sin(end);
		var ce = Math.cos(end);
		if (Math.acos(ss * se + cs * ce) > step)
		{
			if (cs * se - ss * ce > 0)
				return cr.clamp_angle(start + step);
			else
				return cr.clamp_angle(start - step);
		}
		else
			return cr.clamp_angle(end);
	};
	cr.angleClockwise = function (a1, a2)
	{
		var s1 = Math.sin(a1);
		var c1 = Math.cos(a1);
		var s2 = Math.sin(a2);
		var c2 = Math.cos(a2);
		return c1 * s2 - s1 * c2 <= 0;
	};
	cr.rotatePtAround = function (px, py, a, ox, oy, getx)
	{
		if (a === 0)
			return getx ? px : py;
		var sin_a = Math.sin(a);
		var cos_a = Math.cos(a);
		px -= ox;
		py -= oy;
		var left_sin_a = px * sin_a;
		var top_sin_a = py * sin_a;
		var left_cos_a = px * cos_a;
		var top_cos_a = py * cos_a;
		px = left_cos_a - top_sin_a;
		py = top_cos_a + left_sin_a;
		px += ox;
		py += oy;
		return getx ? px : py;
	}
	cr.distanceTo = function(x1, y1, x2, y2)
	{
		var dx = x2 - x1;
        var dy = y2 - y1;
		return Math.sqrt(dx*dx + dy*dy);
	};
	cr.xor = function (x, y)
	{
		return !x !== !y;
	};
	cr.lerp = function (a, b, x)
	{
		return a + (b - a) * x;
	};
	cr.unlerp = function (a, b, c)
	{
		if (a === b)
			return 0;		// avoid divide by 0
		return (c - a) / (b - a);
	};
	cr.anglelerp = function (a, b, x)
	{
		var diff = cr.angleDiff(a, b);
		if (cr.angleClockwise(b, a))
		{
			return a + diff * x;
		}
		else
		{
			return a - diff * x;
		}
	};
	cr.hasAnyOwnProperty = function (o)
	{
		var p;
		for (p in o)
		{
			if (o.hasOwnProperty(p))
				return true;
		}
		return false;
	};
	cr.wipe = function (obj)
	{
		var p;
		for (p in obj)
		{
			if (obj.hasOwnProperty(p))
				delete obj[p];
		}
	};
	var startup_time = +(new Date());
	cr.performance_now = function()
	{
		if (typeof window["performance"] !== "undefined")
		{
			var winperf = window["performance"];
			if (typeof winperf.now !== "undefined")
				return winperf.now();
			else if (typeof winperf["webkitNow"] !== "undefined")
				return winperf["webkitNow"]();
			else if (typeof winperf["mozNow"] !== "undefined")
				return winperf["mozNow"]();
			else if (typeof winperf["msNow"] !== "undefined")
				return winperf["msNow"]();
		}
		return Date.now() - startup_time;
	};
	var supports_set = ((typeof window === "undefined" || !window["c2ejecta"]) && (typeof Set !== "undefined" && typeof Set.prototype["forEach"] !== "undefined"));
	function ObjectSet_()
	{
		this.s = null;
		this.items = null;			// lazy allocated (hopefully results in better GC performance)
		this.item_count = 0;
		if (supports_set)
		{
			this.s = new Set();
		}
		this.values_cache = [];
		this.cache_valid = true;
		cr.seal(this);
	};
	ObjectSet_.prototype.contains = function (x)
	{
		if (this.isEmpty())
			return false;
		if (supports_set)
			return this.s["has"](x);
		else
			return (this.items && this.items.hasOwnProperty(x));
	};
	ObjectSet_.prototype.add = function (x)
	{
		if (supports_set)
		{
			if (!this.s["has"](x))
			{
				this.s["add"](x);
				this.cache_valid = false;
			}
		}
		else
		{
			var str = x.toString();
			var items = this.items;
			if (!items)
			{
				this.items = {};
				this.items[str] = x;
				this.item_count = 1;
				this.cache_valid = false;
			}
			else if (!items.hasOwnProperty(str))
			{
				items[str] = x;
				this.item_count++;
				this.cache_valid = false;
			}
		}
	};
	ObjectSet_.prototype.remove = function (x)
	{
		if (this.isEmpty())
			return;
		if (supports_set)
		{
			if (this.s["has"](x))
			{
				this.s["delete"](x);
				this.cache_valid = false;
			}
		}
		else if (this.items)
		{
			var str = x.toString();
			var items = this.items;
			if (items.hasOwnProperty(str))
			{
				delete items[str];
				this.item_count--;
				this.cache_valid = false;
			}
		}
	};
	ObjectSet_.prototype.clear = function (/*wipe_*/)
	{
		if (this.isEmpty())
			return;
		if (supports_set)
		{
			this.s["clear"]();			// best!
		}
		else
		{
				this.items = null;		// creates garbage; will lazy allocate on next add()
			this.item_count = 0;
		}
		this.values_cache.length = 0;
		this.cache_valid = true;
	};
	ObjectSet_.prototype.isEmpty = function ()
	{
		return this.count() === 0;
	};
	ObjectSet_.prototype.count = function ()
	{
		if (supports_set)
			return this.s["size"];
		else
			return this.item_count;
	};
	var current_arr = null;
	var current_index = 0;
	function set_append_to_arr(x)
	{
		current_arr[current_index++] = x;
	};
	ObjectSet_.prototype.update_cache = function ()
	{
		if (this.cache_valid)
			return;
		if (supports_set)
		{
			this.values_cache.length = this.s["size"];
			current_arr = this.values_cache;
			current_index = 0;
			this.s["forEach"](set_append_to_arr);
;
			current_arr = null;
			current_index = 0;
		}
		else
		{
			var values_cache = this.values_cache;
			values_cache.length = this.item_count;
			var p, n = 0, items = this.items;
			if (items)
			{
				for (p in items)
				{
					if (items.hasOwnProperty(p))
						values_cache[n++] = items[p];
				}
			}
;
		}
		this.cache_valid = true;
	};
	ObjectSet_.prototype.valuesRef = function ()
	{
		this.update_cache();
		return this.values_cache;
	};
	cr.ObjectSet = ObjectSet_;
	function KahanAdder_()
	{
		this.c = 0;
        this.y = 0;
        this.t = 0;
        this.sum = 0;
		cr.seal(this);
	};
	KahanAdder_.prototype.add = function (v)
	{
		this.y = v - this.c;
	    this.t = this.sum + this.y;
	    this.c = (this.t - this.sum) - this.y;
	    this.sum = this.t;
	};
    KahanAdder_.prototype.reset = function ()
    {
        this.c = 0;
        this.y = 0;
        this.t = 0;
        this.sum = 0;
    };
	cr.KahanAdder = KahanAdder_;
	cr.regexp_escape = function(text)
	{
		return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
	};
	function CollisionPoly_(pts_array_)
	{
		this.pts_cache = [];
		this.bboxLeft = 0;
		this.bboxTop = 0;
		this.bboxRight = 0;
		this.bboxBottom = 0;
		this.convexpolys = null;		// for physics behavior to cache separated polys
		this.set_pts(pts_array_);
		cr.seal(this);
	};
	CollisionPoly_.prototype.set_pts = function(pts_array_)
	{
		this.pts_array = pts_array_;
		this.pts_count = pts_array_.length / 2;			// x, y, x, y... in array
		this.pts_cache.length = pts_array_.length;
		this.cache_width = -1;
		this.cache_height = -1;
		this.cache_angle = 0;
	};
	CollisionPoly_.prototype.is_empty = function()
	{
		return !this.pts_array.length;
	};
	CollisionPoly_.prototype.update_bbox = function ()
	{
		var myptscache = this.pts_cache;
		var bboxLeft_ = myptscache[0];
		var bboxRight_ = bboxLeft_;
		var bboxTop_ = myptscache[1];
		var bboxBottom_ = bboxTop_;
		var x, y, i = 1, i2, len = this.pts_count;
		for ( ; i < len; ++i)
		{
			i2 = i*2;
			x = myptscache[i2];
			y = myptscache[i2+1];
			if (x < bboxLeft_)
				bboxLeft_ = x;
			if (x > bboxRight_)
				bboxRight_ = x;
			if (y < bboxTop_)
				bboxTop_ = y;
			if (y > bboxBottom_)
				bboxBottom_ = y;
		}
		this.bboxLeft = bboxLeft_;
		this.bboxRight = bboxRight_;
		this.bboxTop = bboxTop_;
		this.bboxBottom = bboxBottom_;
	};
	CollisionPoly_.prototype.set_from_rect = function(rc, offx, offy)
	{
		this.pts_cache.length = 8;
		this.pts_count = 4;
		var myptscache = this.pts_cache;
		myptscache[0] = rc.left - offx;
		myptscache[1] = rc.top - offy;
		myptscache[2] = rc.right - offx;
		myptscache[3] = rc.top - offy;
		myptscache[4] = rc.right - offx;
		myptscache[5] = rc.bottom - offy;
		myptscache[6] = rc.left - offx;
		myptscache[7] = rc.bottom - offy;
		this.cache_width = rc.right - rc.left;
		this.cache_height = rc.bottom - rc.top;
		this.update_bbox();
	};
	CollisionPoly_.prototype.set_from_quad = function(q, offx, offy, w, h)
	{
		this.pts_cache.length = 8;
		this.pts_count = 4;
		var myptscache = this.pts_cache;
		myptscache[0] = q.tlx - offx;
		myptscache[1] = q.tly - offy;
		myptscache[2] = q.trx - offx;
		myptscache[3] = q.try_ - offy;
		myptscache[4] = q.brx - offx;
		myptscache[5] = q.bry - offy;
		myptscache[6] = q.blx - offx;
		myptscache[7] = q.bly - offy;
		this.cache_width = w;
		this.cache_height = h;
		this.update_bbox();
	};
	CollisionPoly_.prototype.set_from_poly = function (r)
	{
		this.pts_count = r.pts_count;
		cr.shallowAssignArray(this.pts_cache, r.pts_cache);
		this.bboxLeft = r.bboxLeft;
		this.bboxTop - r.bboxTop;
		this.bboxRight = r.bboxRight;
		this.bboxBottom = r.bboxBottom;
	};
	CollisionPoly_.prototype.cache_poly = function(w, h, a)
	{
		if (this.cache_width === w && this.cache_height === h && this.cache_angle === a)
			return;		// cache up-to-date
		this.cache_width = w;
		this.cache_height = h;
		this.cache_angle = a;
		var i, i2, i21, len, x, y;
		var sina = 0;
		var cosa = 1;
		var myptsarray = this.pts_array;
		var myptscache = this.pts_cache;
		if (a !== 0)
		{
			sina = Math.sin(a);
			cosa = Math.cos(a);
		}
		for (i = 0, len = this.pts_count; i < len; i++)
		{
			i2 = i*2;
			i21 = i2+1;
			x = myptsarray[i2] * w;
			y = myptsarray[i21] * h;
			myptscache[i2] = (x * cosa) - (y * sina);
			myptscache[i21] = (y * cosa) + (x * sina);
		}
		this.update_bbox();
	};
	CollisionPoly_.prototype.contains_pt = function (a2x, a2y)
	{
		var myptscache = this.pts_cache;
		if (a2x === myptscache[0] && a2y === myptscache[1])
			return true;
		var i, i2, imod, len = this.pts_count;
		var a1x = this.bboxLeft - 110;
		var a1y = this.bboxTop - 101;
		var a3x = this.bboxRight + 131
		var a3y = this.bboxBottom + 120;
		var b1x, b1y, b2x, b2y;
		var count1 = 0, count2 = 0;
		for (i = 0; i < len; i++)
		{
			i2 = i*2;
			imod = ((i+1)%len)*2;
			b1x = myptscache[i2];
			b1y = myptscache[i2+1];
			b2x = myptscache[imod];
			b2y = myptscache[imod+1];
			if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
				count1++;
			if (cr.segments_intersect(a3x, a3y, a2x, a2y, b1x, b1y, b2x, b2y))
				count2++;
		}
		return (count1 % 2 === 1) || (count2 % 2 === 1);
	};
	CollisionPoly_.prototype.intersects_poly = function (rhs, offx, offy)
	{
		var rhspts = rhs.pts_cache;
		var mypts = this.pts_cache;
		if (this.contains_pt(rhspts[0] + offx, rhspts[1] + offy))
			return true;
		if (rhs.contains_pt(mypts[0] - offx, mypts[1] - offy))
			return true;
		var i, i2, imod, leni, j, j2, jmod, lenj;
		var a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
		for (i = 0, leni = this.pts_count; i < leni; i++)
		{
			i2 = i*2;
			imod = ((i+1)%leni)*2;
			a1x = mypts[i2];
			a1y = mypts[i2+1];
			a2x = mypts[imod];
			a2y = mypts[imod+1];
			for (j = 0, lenj = rhs.pts_count; j < lenj; j++)
			{
				j2 = j*2;
				jmod = ((j+1)%lenj)*2;
				b1x = rhspts[j2] + offx;
				b1y = rhspts[j2+1] + offy;
				b2x = rhspts[jmod] + offx;
				b2y = rhspts[jmod+1] + offy;
				if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
					return true;
			}
		}
		return false;
	};
	CollisionPoly_.prototype.intersects_segment = function (offx, offy, x1, y1, x2, y2)
	{
		var mypts = this.pts_cache;
		if (this.contains_pt(x1 - offx, y1 - offy))
			return true;
		var i, leni, i2, imod;
		var a1x, a1y, a2x, a2y;
		for (i = 0, leni = this.pts_count; i < leni; i++)
		{
			i2 = i*2;
			imod = ((i+1)%leni)*2;
			a1x = mypts[i2] + offx;
			a1y = mypts[i2+1] + offy;
			a2x = mypts[imod] + offx;
			a2y = mypts[imod+1] + offy;
			if (cr.segments_intersect(x1, y1, x2, y2, a1x, a1y, a2x, a2y))
				return true;
		}
		return false;
	};
	CollisionPoly_.prototype.mirror = function (px)
	{
		var i, leni, i2;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i2 = i*2;
			this.pts_cache[i2] = px * 2 - this.pts_cache[i2];
		}
	};
	CollisionPoly_.prototype.flip = function (py)
	{
		var i, leni, i21;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i21 = i*2+1;
			this.pts_cache[i21] = py * 2 - this.pts_cache[i21];
		}
	};
	CollisionPoly_.prototype.diag = function ()
	{
		var i, leni, i2, i21, temp;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i2 = i*2;
			i21 = i2+1;
			temp = this.pts_cache[i2];
			this.pts_cache[i2] = this.pts_cache[i21];
			this.pts_cache[i21] = temp;
		}
	};
	cr.CollisionPoly = CollisionPoly_;
	function SparseGrid_(cellwidth_, cellheight_)
	{
		this.cellwidth = cellwidth_;
		this.cellheight = cellheight_;
		this.cells = {};
	};
	SparseGrid_.prototype.totalCellCount = 0;
	SparseGrid_.prototype.getCell = function (x_, y_, create_if_missing)
	{
		var ret;
		var col = this.cells[x_];
		if (!col)
		{
			if (create_if_missing)
			{
				ret = allocGridCell(this, x_, y_);
				this.cells[x_] = {};
				this.cells[x_][y_] = ret;
				return ret;
			}
			else
				return null;
		}
		ret = col[y_];
		if (ret)
			return ret;
		else if (create_if_missing)
		{
			ret = allocGridCell(this, x_, y_);
			this.cells[x_][y_] = ret;
			return ret;
		}
		else
			return null;
	};
	SparseGrid_.prototype.XToCell = function (x_)
	{
		return cr.floor(x_ / this.cellwidth);
	};
	SparseGrid_.prototype.YToCell = function (y_)
	{
		return cr.floor(y_ / this.cellheight);
	};
	SparseGrid_.prototype.update = function (inst, oldrange, newrange)
	{
		var x, lenx, y, leny, cell;
		if (oldrange)
		{
			for (x = oldrange.left, lenx = oldrange.right; x <= lenx; ++x)
			{
				for (y = oldrange.top, leny = oldrange.bottom; y <= leny; ++y)
				{
					if (newrange && newrange.contains_pt(x, y))
						continue;	// is still in this cell
					cell = this.getCell(x, y, false);	// don't create if missing
					if (!cell)
						continue;	// cell does not exist yet
					cell.remove(inst);
					if (cell.isEmpty())
					{
						freeGridCell(cell);
						this.cells[x][y] = null;
					}
				}
			}
		}
		if (newrange)
		{
			for (x = newrange.left, lenx = newrange.right; x <= lenx; ++x)
			{
				for (y = newrange.top, leny = newrange.bottom; y <= leny; ++y)
				{
					if (oldrange && oldrange.contains_pt(x, y))
						continue;	// is still in this cell
					this.getCell(x, y, true).insert(inst);
				}
			}
		}
	};
	SparseGrid_.prototype.queryRange = function (rc, result)
	{
		var x, lenx, ystart, y, leny, cell;
		x = this.XToCell(rc.left);
		ystart = this.YToCell(rc.top);
		lenx = this.XToCell(rc.right);
		leny = this.YToCell(rc.bottom);
		for ( ; x <= lenx; ++x)
		{
			for (y = ystart; y <= leny; ++y)
			{
				cell = this.getCell(x, y, false);
				if (!cell)
					continue;
				cell.dump(result);
			}
		}
	};
	cr.SparseGrid = SparseGrid_;
	var gridcellcache = [];
	function allocGridCell(grid_, x_, y_)
	{
		var ret;
		SparseGrid_.prototype.totalCellCount++;
		if (gridcellcache.length)
		{
			ret = gridcellcache.pop();
			ret.grid = grid_;
			ret.x = x_;
			ret.y = y_;
			return ret;
		}
		else
			return new cr.GridCell(grid_, x_, y_);
	};
	function freeGridCell(c)
	{
		SparseGrid_.prototype.totalCellCount--;
		c.objects.clear();
		if (gridcellcache.length < 1000)
			gridcellcache.push(c);
	};
	function GridCell_(grid_, x_, y_)
	{
		this.grid = grid_;
		this.x = x_;
		this.y = y_;
		this.objects = new cr.ObjectSet();
	};
	GridCell_.prototype.isEmpty = function ()
	{
		return this.objects.isEmpty();
	};
	GridCell_.prototype.insert = function (inst)
	{
		this.objects.add(inst);
	};
	GridCell_.prototype.remove = function (inst)
	{
		this.objects.remove(inst);
	};
	GridCell_.prototype.dump = function (result)
	{
		cr.appendArray(result, this.objects.valuesRef());
	};
	cr.GridCell = GridCell_;
	var fxNames = [ "lighter",
					"xor",
					"copy",
					"destination-over",
					"source-in",
					"destination-in",
					"source-out",
					"destination-out",
					"source-atop",
					"destination-atop"];
	cr.effectToCompositeOp = function(effect)
	{
		if (effect <= 0 || effect >= 11)
			return "source-over";
		return fxNames[effect - 1];	// not including "none" so offset by 1
	};
	cr.setGLBlend = function(this_, effect, gl)
	{
		if (!gl)
			return;
		this_.srcBlend = gl.ONE;
		this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
		switch (effect) {
		case 1:		// lighter (additive)
			this_.srcBlend = gl.ONE;
			this_.destBlend = gl.ONE;
			break;
		case 2:		// xor
			break;	// todo
		case 3:		// copy
			this_.srcBlend = gl.ONE;
			this_.destBlend = gl.ZERO;
			break;
		case 4:		// destination-over
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.ONE;
			break;
		case 5:		// source-in
			this_.srcBlend = gl.DST_ALPHA;
			this_.destBlend = gl.ZERO;
			break;
		case 6:		// destination-in
			this_.srcBlend = gl.ZERO;
			this_.destBlend = gl.SRC_ALPHA;
			break;
		case 7:		// source-out
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.ZERO;
			break;
		case 8:		// destination-out
			this_.srcBlend = gl.ZERO;
			this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 9:		// source-atop
			this_.srcBlend = gl.DST_ALPHA;
			this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 10:	// destination-atop
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.SRC_ALPHA;
			break;
		}
	};
	cr.round6dp = function (x)
	{
		return cr.round(x * 1000000) / 1000000;
	};
	/*
	var localeCompare_options = {
		"usage": "search",
		"sensitivity": "accent"
	};
	var has_localeCompare = !!"a".localeCompare;
	var localeCompare_works1 = (has_localeCompare && "a".localeCompare("A", undefined, localeCompare_options) === 0);
	var localeCompare_works2 = (has_localeCompare && "a".localeCompare("á", undefined, localeCompare_options) !== 0);
	var supports_localeCompare = (has_localeCompare && localeCompare_works1 && localeCompare_works2);
	*/
	cr.equals_nocase = function (a, b)
	{
		if (typeof a !== "string" || typeof b !== "string")
			return false;
		if (a.length !== b.length)
			return false;
		if (a === b)
			return true;
		/*
		if (supports_localeCompare)
		{
			return (a.localeCompare(b, undefined, localeCompare_options) === 0);
		}
		else
		{
		*/
			return a.toLowerCase() === b.toLowerCase();
	};
}());
;
(function()
{
	function Runtime(canvas)
	{
		if (!canvas || (!canvas.getContext && !canvas["dc"]))
			return;
		if (canvas["c2runtime"])
			return;
		else
			canvas["c2runtime"] = this;
		var self = this;
		this.isCrosswalk = /crosswalk/i.test(navigator.userAgent) || /xwalk/i.test(navigator.userAgent) || !!(typeof window["c2isCrosswalk"] !== "undefined" && window["c2isCrosswalk"]);
		this.isPhoneGap = (!this.isCrosswalk && (typeof window["device"] !== "undefined" && (typeof window["device"]["cordova"] !== "undefined" || typeof window["device"]["phonegap"] !== "undefined")));
		this.isDirectCanvas = !!canvas["dc"];
		this.isAppMobi = (typeof window["AppMobi"] !== "undefined" || this.isDirectCanvas);
		this.isCocoonJs = !!window["c2cocoonjs"];
		this.isEjecta = !!window["c2ejecta"];
		if (this.isCocoonJs)
		{
			CocoonJS["App"]["onSuspended"].addEventListener(function() {
				self["setSuspended"](true);
			});
			CocoonJS["App"]["onActivated"].addEventListener(function () {
				self["setSuspended"](false);
			});
		}
		if (this.isEjecta)
		{
			document.addEventListener("pagehide", function() {
				self["setSuspended"](true);
			});
			document.addEventListener("pageshow", function() {
				self["setSuspended"](false);
			});
			document.addEventListener("resize", function () {
				self["setSize"](window.innerWidth, window.innerHeight);
			});
		}
		this.isDomFree = (this.isDirectCanvas || this.isCocoonJs || this.isEjecta);
		this.isTizen = /tizen/i.test(navigator.userAgent);
		this.isAndroid = /android/i.test(navigator.userAgent) && !this.isTizen;		// tizen says "like Android"
		this.isIE = /msie/i.test(navigator.userAgent) || /trident/i.test(navigator.userAgent);
		this.isiPhone = /iphone/i.test(navigator.userAgent) || /ipod/i.test(navigator.userAgent);	// treat ipod as an iphone
		this.isiPad = /ipad/i.test(navigator.userAgent);
		this.isiOS = this.isiPhone || this.isiPad || this.isEjecta;
		this.isiPhoneiOS6 = (this.isiPhone && /os\s6/i.test(navigator.userAgent));
		this.isChrome = /chrome/i.test(navigator.userAgent) || /chromium/i.test(navigator.userAgent);
		this.isAmazonWebApp = /amazonwebappplatform/i.test(navigator.userAgent);
		this.isFirefox = /firefox/i.test(navigator.userAgent);
		this.isSafari = !this.isChrome && /safari/i.test(navigator.userAgent);		// Chrome includes Safari in UA
		this.isWindows = /windows/i.test(navigator.userAgent);
		this.isNodeWebkit = (typeof window["c2nodewebkit"] !== "undefined" || /nodewebkit/i.test(navigator.userAgent));
		this.isArcade = (typeof window["is_scirra_arcade"] !== "undefined");
		this.isWindows8App = !!(typeof window["c2isWindows8"] !== "undefined" && window["c2isWindows8"]);
		this.isWindows8Capable = !!(typeof window["c2isWindows8Capable"] !== "undefined" && window["c2isWindows8Capable"]);
		this.isWindowsPhone8 = !!(typeof window["c2isWindowsPhone8"] !== "undefined" && window["c2isWindowsPhone8"]);
		this.isWindowsPhone81 = !!(typeof window["c2isWindowsPhone81"] !== "undefined" && window["c2isWindowsPhone81"]);
		this.isWinJS = (this.isWindows8App || this.isWindows8Capable || this.isWindowsPhone81);	// note not WP8.0
		this.isBlackberry10 = !!(typeof window["c2isBlackberry10"] !== "undefined" && window["c2isBlackberry10"]);
		this.isAndroidStockBrowser = (this.isAndroid && !this.isChrome && !this.isFirefox && !this.isAmazonWebApp && !this.isDomFree);
		this.devicePixelRatio = 1;
		this.isMobile = (this.isPhoneGap || this.isCrosswalk || this.isAppMobi || this.isCocoonJs || this.isAndroid || this.isiOS || this.isWindowsPhone8 || this.isWindowsPhone81 || this.isBlackberry10 || this.isTizen || this.isEjecta);
		if (!this.isMobile)
		{
			this.isMobile = /(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet|kindle|silk)/i.test(navigator.userAgent);
		}
		if (typeof cr_is_preview !== "undefined" && !this.isNodeWebkit && (window.location.search === "?nw" || /nodewebkit/i.test(navigator.userAgent)))
		{
			this.isNodeWebkit = true;
		}
		this.isDebug = (typeof cr_is_preview !== "undefined" && window.location.search.indexOf("debug") > -1)
		this.canvas = canvas;
		this.canvasdiv = document.getElementById("c2canvasdiv");
		this.gl = null;
		this.glwrap = null;
		this.ctx = null;
		this.fullscreenOldMarginCss = "";
		this.firstInFullscreen = false;
		this.oldWidth = 0;		// for restoring non-fullscreen canvas after fullscreen
		this.oldHeight = 0;
		this.canvas.oncontextmenu = function (e) { if (e.preventDefault) e.preventDefault(); return false; };
		this.canvas.onselectstart = function (e) { if (e.preventDefault) e.preventDefault(); return false; };
		if (this.isDirectCanvas)
			window["c2runtime"] = this;
		if (this.isNodeWebkit)
		{
			window.ondragover = function(e) { e.preventDefault(); return false; };
			window.ondrop = function(e) { e.preventDefault(); return false; };
			require("nw.gui")["App"]["clearCache"]();
		}
		this.width = canvas.width;
		this.height = canvas.height;
		this.draw_width = this.width;
		this.draw_height = this.height;
		this.cssWidth = this.width;
		this.cssHeight = this.height;
		this.lastWindowWidth = window.innerWidth;
		this.lastWindowHeight = window.innerHeight;
		this.redraw = true;
		this.isSuspended = false;
		if (!Date.now) {
		  Date.now = function now() {
			return +new Date();
		  };
		}
		this.plugins = [];
		this.types = {};
		this.types_by_index = [];
		this.behaviors = [];
		this.layouts = {};
		this.layouts_by_index = [];
		this.eventsheets = {};
		this.eventsheets_by_index = [];
		this.wait_for_textures = [];        // for blocking until textures loaded
		this.triggers_to_postinit = [];
		this.all_global_vars = [];
		this.all_local_vars = [];
		this.solidBehavior = null;
		this.jumpthruBehavior = null;
		this.deathRow = new cr.ObjectSet();
		this.isInClearDeathRow = false;
		this.isInOnDestroy = 0;					// needs to support recursion so increments and decrements and is true if > 0
		this.isRunningEvents = false;
		this.createRow = [];
		this.isLoadingState = false;
		this.saveToSlot = "";
		this.loadFromSlot = "";
		this.loadFromJson = "";
		this.lastSaveJson = "";
		this.signalledContinuousPreview = false;
		this.suspendDrawing = false;		// for hiding display until continuous preview loads
		this.dt = 0;
        this.dt1 = 0;
		this.logictime = 0;			// used to calculate CPUUtilisation
		this.cpuutilisation = 0;
		this.zeroDtCount = 0;
        this.timescale = 1.0;
        this.kahanTime = new cr.KahanAdder();
		this.last_tick_time = 0;
		this.measuring_dt = true;
		this.fps = 0;
		this.last_fps_time = 0;
		this.tickcount = 0;
		this.execcount = 0;
		this.framecount = 0;        // for fps
		this.objectcount = 0;
		this.changelayout = null;
		this.destroycallbacks = [];
		this.event_stack = [];
		this.event_stack_index = -1;
		this.localvar_stack = [[]];
		this.localvar_stack_index = 0;
		this.trigger_depth = 0;		// recursion depth for triggers
		this.pushEventStack(null);
		this.loop_stack = [];
		this.loop_stack_index = -1;
		this.next_uid = 0;
		this.next_puid = 0;		// permanent unique ids
		this.layout_first_tick = true;
		this.family_count = 0;
		this.suspend_events = [];
		this.raf_id = -1;
		this.timeout_id = -1;
		this.isloading = true;
		this.loadingprogress = 0;
		this.isNodeFullscreen = false;
		this.stackLocalCount = 0;	// number of stack-based local vars for recursion
		this.halfFramerateMode = false;
		this.lastRafTime = 0;		// time of last requestAnimationFrame call
		this.ranLastRaf = false;	// false if last requestAnimationFrame was skipped for half framerate mode
		this.had_a_click = false;
		this.isInUserInputEvent = false;
        this.objects_to_tick = new cr.ObjectSet();
		this.objects_to_tick2 = new cr.ObjectSet();
		this.registered_collisions = [];
		this.temp_poly = new cr.CollisionPoly([]);
		this.temp_poly2 = new cr.CollisionPoly([]);
		this.allGroups = [];				// array of all event groups
        this.groups_by_name = {};
		this.cndsBySid = {};
		this.actsBySid = {};
		this.varsBySid = {};
		this.blocksBySid = {};
		this.running_layout = null;			// currently running layout
		this.layer_canvas = null;			// for layers "render-to-texture"
		this.layer_ctx = null;
		this.layer_tex = null;
		this.layout_tex = null;
		this.layout_canvas = null;
		this.layout_ctx = null;
		this.is_WebGL_context_lost = false;
		this.uses_background_blending = false;	// if any shader uses background blending, so entire layout renders to texture
		this.fx_tex = [null, null];
		this.fullscreen_scaling = 0;
		this.files_subfolder = "";			// path with project files
		this.objectsByUid = {};				// maps every in-use UID (as a string) to its instance
		this.loaderlogo = null;
		this.snapshotCanvas = null;
		this.snapshotData = "";
		this.load();
		this.isRetina = ((!this.isDomFree || this.isEjecta) && this.useHighDpi && !this.isAndroidStockBrowser);
		this.devicePixelRatio = (this.isRetina ? (window["devicePixelRatio"] || window["webkitDevicePixelRatio"] || window["mozDevicePixelRatio"] || window["msDevicePixelRatio"] || 1) : 1);
		this.ClearDeathRow();
		var attribs;
		var alpha_canvas = this.alphaBackground && !(this.isNodeWebkit || this.isWinJS || this.isWindowsPhone8 || this.isCrosswalk);
		if (this.fullscreen_mode > 0)
			this["setSize"](window.innerWidth, window.innerHeight, true);
		try {
			if (this.enableWebGL && (this.isCocoonJs || this.isEjecta || !this.isDomFree))
			{
				attribs = {
					"alpha": alpha_canvas,
					"depth": false,
					"antialias": false,
					"failIfMajorPerformanceCaveat": true
				};
				this.gl = (canvas.getContext("webgl", attribs) || canvas.getContext("experimental-webgl", attribs));
			}
		}
		catch (e) {
		}
		if (this.gl)
		{
;
			if (!this.isDomFree)
			{
				this.overlay_canvas = document.createElement("canvas");
				jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode);
				this.overlay_canvas.oncontextmenu = function (e) { return false; };
				this.overlay_canvas.onselectstart = function (e) { return false; };
				this.overlay_canvas.width = this.cssWidth;
				this.overlay_canvas.height = this.cssHeight;
				jQuery(this.overlay_canvas).css({"width": this.cssWidth + "px",
												"height": this.cssHeight + "px"});
				this.positionOverlayCanvas();
				this.overlay_ctx = this.overlay_canvas.getContext("2d");
			}
			this.glwrap = new cr.GLWrap(this.gl, this.isMobile);
			this.glwrap.setSize(canvas.width, canvas.height);
			this.glwrap.enable_mipmaps = (this.downscalingQuality !== 0);
			this.ctx = null;
			this.canvas.addEventListener("webglcontextlost", function (ev) {
				ev.preventDefault();
				self.onContextLost();
				console.log("[Construct 2] WebGL context lost");
				window["cr_setSuspended"](true);		// stop rendering
			}, false);
			this.canvas.addEventListener("webglcontextrestored", function (ev) {
				self.glwrap.initState();
				self.glwrap.setSize(self.glwrap.width, self.glwrap.height, true);
				self.layer_tex = null;
				self.layout_tex = null;
				self.fx_tex[0] = null;
				self.fx_tex[1] = null;
				self.onContextRestored();
				self.redraw = true;
				console.log("[Construct 2] WebGL context restored");
				window["cr_setSuspended"](false);		// resume rendering
			}, false);
			var i, len, j, lenj, k, lenk, t, s, l, y;
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				for (j = 0, lenj = t.effect_types.length; j < lenj; j++)
				{
					s = t.effect_types[j];
					s.shaderindex = this.glwrap.getShaderIndex(s.id);
					this.uses_background_blending = this.uses_background_blending || this.glwrap.programUsesDest(s.shaderindex);
				}
			}
			for (i = 0, len = this.layouts_by_index.length; i < len; i++)
			{
				l = this.layouts_by_index[i];
				for (j = 0, lenj = l.effect_types.length; j < lenj; j++)
				{
					s = l.effect_types[j];
					s.shaderindex = this.glwrap.getShaderIndex(s.id);
				}
				for (j = 0, lenj = l.layers.length; j < lenj; j++)
				{
					y = l.layers[j];
					for (k = 0, lenk = y.effect_types.length; k < lenk; k++)
					{
						s = y.effect_types[k];
						s.shaderindex = this.glwrap.getShaderIndex(s.id);
						this.uses_background_blending = this.uses_background_blending || this.glwrap.programUsesDest(s.shaderindex);
					}
				}
			}
		}
		else
		{
			if (this.fullscreen_mode > 0 && this.isDirectCanvas)
			{
;
				this.canvas = null;
				document.oncontextmenu = function (e) { return false; };
				document.onselectstart = function (e) { return false; };
				this.ctx = AppMobi["canvas"]["getContext"]("2d");
				try {
					this.ctx["samplingMode"] = this.linearSampling ? "smooth" : "sharp";
					this.ctx["globalScale"] = 1;
					this.ctx["HTML5CompatibilityMode"] = true;
					this.ctx["imageSmoothingEnabled"] = this.linearSampling;
				} catch(e){}
				if (this.width !== 0 && this.height !== 0)
				{
					this.ctx.width = this.width;
					this.ctx.height = this.height;
				}
			}
			if (!this.ctx)
			{
;
				if (this.isCocoonJs)
				{
					attribs = {
						"antialias": !!this.linearSampling,
						"alpha": alpha_canvas
					};
					this.ctx = canvas.getContext("2d", attribs);
				}
				else
				{
					attribs = {
						"alpha": alpha_canvas
					};
					this.ctx = canvas.getContext("2d", attribs);
				}
				this.ctx["webkitImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["mozImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["msImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["imageSmoothingEnabled"] = this.linearSampling;
			}
			this.overlay_canvas = null;
			this.overlay_ctx = null;
		}
		this.tickFunc = function () { self.tick(false); };
		if (window != window.top && !this.isDomFree && !this.isWinJS && !this.isWindowsPhone8)
		{
			document.addEventListener("mousedown", function () {
				window.focus();
			}, true);
			document.addEventListener("touchstart", function () {
				window.focus();
			}, true);
		}
		if (typeof cr_is_preview !== "undefined")
		{
			if (this.isCocoonJs)
				console.log("[Construct 2] In preview-over-wifi via CocoonJS mode");
			if (window.location.search.indexOf("continuous") > -1)
			{
				cr.logexport("Reloading for continuous preview");
				this.loadFromSlot = "__c2_continuouspreview";
				this.suspendDrawing = true;
			}
			if (this.pauseOnBlur && !this.isMobile)
			{
				jQuery(window).focus(function ()
				{
					self["setSuspended"](false);
				});
				jQuery(window).blur(function ()
				{
					self["setSuspended"](true);
				});
			}
		}
		if (this.fullscreen_mode === 0 && this.isRetina && this.devicePixelRatio > 1)
		{
			this["setSize"](this.original_width, this.original_height, true);
		}
		this.tryLockOrientation();
		this.go();			// run loading screen
		this.extra = {};
		cr.seal(this);
	};
	var webkitRepaintFlag = false;
	Runtime.prototype["setSize"] = function (w, h, force)
	{
		var offx = 0, offy = 0;
		var neww = 0, newh = 0, intscale = 0;
		var tryHideAddressBar = (this.isiPhoneiOS6 && this.isSafari && !navigator["standalone"] && !this.isDomFree && !this.isPhoneGap);
		if (tryHideAddressBar)
			h += 60;		// height of Safari iPhone iOS 6 address bar
		if (this.lastWindowWidth === w && this.lastWindowHeight === h && !force)
			return;
		this.lastWindowWidth = w;
		this.lastWindowHeight = h;
		var mode = this.fullscreen_mode;
		var orig_aspect, cur_aspect;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.isNodeFullscreen);
		if (!isfullscreen && this.fullscreen_mode === 0 && !force)
			return;			// ignore size events when not fullscreen and not using a fullscreen-in-browser mode
		if (isfullscreen && this.fullscreen_scaling > 0)
			mode = this.fullscreen_scaling;
		if (mode >= 4)
		{
			orig_aspect = this.original_width / this.original_height;
			cur_aspect = w / h;
			if (cur_aspect > orig_aspect)
			{
				neww = h * orig_aspect;
				if (mode === 5)	// integer scaling
				{
					intscale = neww / this.original_width;
					if (intscale > 1)
						intscale = Math.floor(intscale);
					else if (intscale < 1)
						intscale = 1 / Math.ceil(1 / intscale);
					neww = this.original_width * intscale;
					newh = this.original_height * intscale;
					offx = (w - neww) / 2;
					offy = (h - newh) / 2;
					w = neww;
					h = newh;
				}
				else
				{
					offx = (w - neww) / 2;
					w = neww;
				}
			}
			else
			{
				newh = w / orig_aspect;
				if (mode === 5)	// integer scaling
				{
					intscale = newh / this.original_height;
					if (intscale > 1)
						intscale = Math.floor(intscale);
					else if (intscale < 1)
						intscale = 1 / Math.ceil(1 / intscale);
					neww = this.original_width * intscale;
					newh = this.original_height * intscale;
					offx = (w - neww) / 2;
					offy = (h - newh) / 2;
					w = neww;
					h = newh;
				}
				else
				{
					offy = (h - newh) / 2;
					h = newh;
				}
			}
			if (isfullscreen && !this.isNodeWebkit)
			{
				offx = 0;
				offy = 0;
			}
			offx = Math.floor(offx);
			offy = Math.floor(offy);
			w = Math.floor(w);
			h = Math.floor(h);
		}
		else if (this.isNodeWebkit && this.isNodeFullscreen && this.fullscreen_mode_set === 0)
		{
			offx = Math.floor((w - this.original_width) / 2);
			offy = Math.floor((h - this.original_height) / 2);
			w = this.original_width;
			h = this.original_height;
		}
		if (mode < 2)
			this.aspect_scale = this.devicePixelRatio;
		if (this.isRetina && this.isiPad && this.devicePixelRatio > 1)	// don't apply to iPad 1-2
		{
			if (w >= 1024)
				w = 1023;		// 2046 retina pixels
			if (h >= 1024)
				h = 1023;
		}
		var multiplier = this.devicePixelRatio;
		this.cssWidth = w;
		this.cssHeight = h;
		this.width = Math.round(w * multiplier);
		this.height = Math.round(h * multiplier);
		this.redraw = true;
		if (this.wantFullscreenScalingQuality)
		{
			this.draw_width = this.width;
			this.draw_height = this.height;
			this.fullscreenScalingQuality = true;
		}
		else
		{
			if ((this.width < this.original_width && this.height < this.original_height) || mode === 1)
			{
				this.draw_width = this.width;
				this.draw_height = this.height;
				this.fullscreenScalingQuality = true;
			}
			else
			{
				this.draw_width = this.original_width;
				this.draw_height = this.original_height;
				this.fullscreenScalingQuality = false;
				/*var orig_aspect = this.original_width / this.original_height;
				var cur_aspect = this.width / this.height;
				if ((this.fullscreen_mode !== 2 && cur_aspect > orig_aspect) || (this.fullscreen_mode === 2 && cur_aspect < orig_aspect))
					this.aspect_scale = this.height / this.original_height;
				else
					this.aspect_scale = this.width / this.original_width;*/
				if (mode === 2)		// scale inner
				{
					orig_aspect = this.original_width / this.original_height;
					cur_aspect = this.lastWindowWidth / this.lastWindowHeight;
					if (cur_aspect < orig_aspect)
						this.draw_width = this.draw_height * cur_aspect;
					else if (cur_aspect > orig_aspect)
						this.draw_height = this.draw_width / cur_aspect;
				}
				else if (mode === 3)
				{
					orig_aspect = this.original_width / this.original_height;
					cur_aspect = this.lastWindowWidth / this.lastWindowHeight;
					if (cur_aspect > orig_aspect)
						this.draw_width = this.draw_height * cur_aspect;
					else if (cur_aspect < orig_aspect)
						this.draw_height = this.draw_width / cur_aspect;
				}
			}
		}
		if (this.canvasdiv && !this.isDomFree)
		{
			jQuery(this.canvasdiv).css({"width": w + "px",
										"height": h + "px",
										"margin-left": offx,
										"margin-top": offy});
			if (typeof cr_is_preview !== "undefined")
			{
				jQuery("#borderwrap").css({"width": w + "px",
											"height": h + "px"});
			}
		}
		if (this.canvas)
		{
			this.canvas.width = Math.round(w * multiplier);
			this.canvas.height = Math.round(h * multiplier);
			if (this.isEjecta)
			{
				this.canvas.style.left = offx + "px";
				this.canvas.style.top = offy + "px";
				this.canvas.style.width = w + "px";
				this.canvas.style.height = h + "px";
			}
			else if (this.isRetina && !this.isDomFree)
			{
				jQuery(this.canvas).css({"width": w + "px",
										"height": h + "px"});
			}
		}
		if (this.overlay_canvas)
		{
			this.overlay_canvas.width = w;
			this.overlay_canvas.height = h;
			jQuery(this.overlay_canvas).css({"width": w + "px",
											"height": h + "px"});
		}
		if (this.glwrap)
		{
			this.glwrap.setSize(Math.round(w * multiplier), Math.round(h * multiplier));
		}
		if (this.isDirectCanvas && this.ctx)
		{
			this.ctx.width = w;
			this.ctx.height = h;
		}
		if (this.ctx)
		{
			this.ctx["webkitImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["mozImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["msImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["imageSmoothingEnabled"] = this.linearSampling;
		}
		this.tryLockOrientation();
		if (!this.isDomFree && (tryHideAddressBar || this.isiPhone))
		{
			window.setTimeout(function () {
				window.scrollTo(0, 1);
			}, 100);
		}
	};
	Runtime.prototype.tryLockOrientation = function ()
	{
		if (!this.autoLockOrientation || this.orientations === 0)
			return;
		var orientation = "portrait";
		if (this.orientations === 2)
			orientation = "landscape";
		if (screen["lockOrientation"])
			screen["lockOrientation"](orientation);
		else if (screen["webkitLockOrientation"])
			screen["webkitLockOrientation"](orientation);
		else if (screen["mozLockOrientation"])
			screen["mozLockOrientation"](orientation);
		else if (screen["msLockOrientation"])
			screen["msLockOrientation"](orientation);
	};
	Runtime.prototype.onContextLost = function ()
	{
		this.is_WebGL_context_lost = true;
		var i, len, t;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onLostWebGLContext)
				t.onLostWebGLContext();
		}
	};
	Runtime.prototype.onContextRestored = function ()
	{
		this.is_WebGL_context_lost = false;
		var i, len, t;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onRestoreWebGLContext)
				t.onRestoreWebGLContext();
		}
	};
	Runtime.prototype.positionOverlayCanvas = function()
	{
		if (this.isDomFree)
			return;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"] || this.isNodeFullscreen);
		var overlay_position = isfullscreen ? jQuery(this.canvas).offset() : jQuery(this.canvas).position();
		overlay_position.position = "absolute";
		jQuery(this.overlay_canvas).css(overlay_position);
	};
	var caf = window["cancelAnimationFrame"] ||
	  window["mozCancelAnimationFrame"]    ||
	  window["webkitCancelAnimationFrame"] ||
	  window["msCancelAnimationFrame"]     ||
	  window["oCancelAnimationFrame"];
	Runtime.prototype["setSuspended"] = function (s)
	{
		var i, len;
		if (s && !this.isSuspended)
		{
			cr.logexport("[Construct 2] Suspending");
			this.isSuspended = true;			// next tick will be last
			if (this.raf_id !== -1 && caf)		// note: CocoonJS does not implement cancelAnimationFrame
				caf(this.raf_id);
			if (this.timeout_id !== -1)
				clearTimeout(this.timeout_id);
			for (i = 0, len = this.suspend_events.length; i < len; i++)
				this.suspend_events[i](true);
		}
		else if (!s && this.isSuspended)
		{
			cr.logexport("[Construct 2] Resuming");
			this.isSuspended = false;
			this.last_tick_time = cr.performance_now();	// ensure first tick is a zero-dt one
			this.last_fps_time = cr.performance_now();	// reset FPS counter
			this.framecount = 0;
			this.logictime = 0;
			for (i = 0, len = this.suspend_events.length; i < len; i++)
				this.suspend_events[i](false);
			this.tick(false);						// kick off runtime again
		}
	};
	Runtime.prototype.addSuspendCallback = function (f)
	{
		this.suspend_events.push(f);
	};
	Runtime.prototype.load = function ()
	{
;
		var pm = cr.getProjectModel();
		this.name = pm[0];
		this.first_layout = pm[1];
		this.fullscreen_mode = pm[11];	// 0 = off, 1 = crop, 2 = scale inner, 3 = scale outer, 4 = letterbox scale, 5 = integer letterbox scale
		this.fullscreen_mode_set = pm[11];
		this.original_width = pm[9];
		this.original_height = pm[10];
		this.parallax_x_origin = this.original_width / 2;
		this.parallax_y_origin = this.original_height / 2;
		if (this.isDomFree && !this.isEjecta && (pm[11] >= 4 || pm[11] === 0))
		{
			cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'");
			this.fullscreen_mode = 3;
			this.fullscreen_mode_set = 3;
		}
		this.uses_loader_layout = pm[17];
		this.loaderstyle = pm[18];
		if (this.loaderstyle === 0)
		{
			this.loaderlogo = new Image();
			this.loaderlogo.src = "loading-logo.png";
		}
		this.next_uid = pm[20];
		this.system = new cr.system_object(this);
		var i, len, j, lenj, k, lenk, idstr, m, b, t, f;
		var plugin, plugin_ctor;
		for (i = 0, len = pm[2].length; i < len; i++)
		{
			m = pm[2][i];
;
			cr.add_common_aces(m);
			plugin = new m[0](this);
			plugin.singleglobal = m[1];
			plugin.is_world = m[2];
			plugin.must_predraw = m[9];
			if (plugin.onCreate)
				plugin.onCreate();  // opportunity to override default ACEs
			cr.seal(plugin);
			this.plugins.push(plugin);
		}
		pm = cr.getProjectModel();
		for (i = 0, len = pm[3].length; i < len; i++)
		{
			m = pm[3][i];
			plugin_ctor = m[1];
;
			plugin = null;
			for (j = 0, lenj = this.plugins.length; j < lenj; j++)
			{
				if (this.plugins[j] instanceof plugin_ctor)
				{
					plugin = this.plugins[j];
					break;
				}
			}
;
;
			var type_inst = new plugin.Type(plugin);
;
			type_inst.name = m[0];
			type_inst.is_family = m[2];
			type_inst.instvar_sids = m[3].slice(0);
			type_inst.vars_count = m[3].length;
			type_inst.behs_count = m[4];
			type_inst.fx_count = m[5];
			type_inst.sid = m[11];
			if (type_inst.is_family)
			{
				type_inst.members = [];				// types in this family
				type_inst.family_index = this.family_count++;
				type_inst.families = null;
			}
			else
			{
				type_inst.members = null;
				type_inst.family_index = -1;
				type_inst.families = [];			// families this type belongs to
			}
			type_inst.family_var_map = null;
			type_inst.family_beh_map = null;
			type_inst.family_fx_map = null;
			type_inst.is_contained = false;
			type_inst.container = null;
			if (m[6])
			{
				type_inst.texture_file = m[6][0];
				type_inst.texture_filesize = m[6][1];
				type_inst.texture_pixelformat = m[6][2];
			}
			else
			{
				type_inst.texture_file = null;
				type_inst.texture_filesize = 0;
				type_inst.texture_pixelformat = 0;		// rgba8
			}
			if (m[7])
			{
				type_inst.animations = m[7];
			}
			else
			{
				type_inst.animations = null;
			}
			type_inst.index = i;                                // save index in to types array in type
			type_inst.instances = [];                           // all instances of this type
			type_inst.deadCache = [];							// destroyed instances to recycle next create
			type_inst.solstack = [new cr.selection(type_inst)]; // initialise SOL stack with one empty SOL
			type_inst.cur_sol = 0;
			type_inst.default_instance = null;
			type_inst.default_layerindex = 0;
			type_inst.stale_iids = true;
			type_inst.updateIIDs = cr.type_updateIIDs;
			type_inst.getFirstPicked = cr.type_getFirstPicked;
			type_inst.getPairedInstance = cr.type_getPairedInstance;
			type_inst.getCurrentSol = cr.type_getCurrentSol;
			type_inst.pushCleanSol = cr.type_pushCleanSol;
			type_inst.pushCopySol = cr.type_pushCopySol;
			type_inst.popSol = cr.type_popSol;
			type_inst.getBehaviorByName = cr.type_getBehaviorByName;
			type_inst.getBehaviorIndexByName = cr.type_getBehaviorIndexByName;
			type_inst.getEffectIndexByName = cr.type_getEffectIndexByName;
			type_inst.applySolToContainer = cr.type_applySolToContainer;
			type_inst.getInstanceByIID = cr.type_getInstanceByIID;
			type_inst.collision_grid = new cr.SparseGrid(this.original_width, this.original_height);
			type_inst.any_cell_changed = true;
			type_inst.any_instance_parallaxed = false;
			type_inst.extra = {};
			type_inst.toString = cr.type_toString;
			type_inst.behaviors = [];
			for (j = 0, lenj = m[8].length; j < lenj; j++)
			{
				b = m[8][j];
				var behavior_ctor = b[1];
				var behavior_plugin = null;
				for (k = 0, lenk = this.behaviors.length; k < lenk; k++)
				{
					if (this.behaviors[k] instanceof behavior_ctor)
					{
						behavior_plugin = this.behaviors[k];
						break;
					}
				}
				if (!behavior_plugin)
				{
					behavior_plugin = new behavior_ctor(this);
					behavior_plugin.my_types = [];						// types using this behavior
					behavior_plugin.my_instances = new cr.ObjectSet(); 	// instances of this behavior
					if (behavior_plugin.onCreate)
						behavior_plugin.onCreate();
					cr.seal(behavior_plugin);
					this.behaviors.push(behavior_plugin);
					if (cr.behaviors.solid && behavior_plugin instanceof cr.behaviors.solid)
						this.solidBehavior = behavior_plugin;
					if (cr.behaviors.jumpthru && behavior_plugin instanceof cr.behaviors.jumpthru)
						this.jumpthruBehavior = behavior_plugin;
				}
				if (behavior_plugin.my_types.indexOf(type_inst) === -1)
					behavior_plugin.my_types.push(type_inst);
				var behavior_type = new behavior_plugin.Type(behavior_plugin, type_inst);
				behavior_type.name = b[0];
				behavior_type.sid = b[2];
				behavior_type.onCreate();
				cr.seal(behavior_type);
				type_inst.behaviors.push(behavior_type);
			}
			type_inst.global = m[9];
			type_inst.isOnLoaderLayout = m[10];
			type_inst.effect_types = [];
			for (j = 0, lenj = m[12].length; j < lenj; j++)
			{
				type_inst.effect_types.push({
					id: m[12][j][0],
					name: m[12][j][1],
					shaderindex: -1,
					active: true,
					index: j
				});
			}
			type_inst.tile_poly_data = m[13];
			if (!this.uses_loader_layout || type_inst.is_family || type_inst.isOnLoaderLayout || !plugin.is_world)
			{
				type_inst.onCreate();
				cr.seal(type_inst);
			}
			if (type_inst.name)
				this.types[type_inst.name] = type_inst;
			this.types_by_index.push(type_inst);
			if (plugin.singleglobal)
			{
				var instance = new plugin.Instance(type_inst);
				instance.uid = this.next_uid++;
				instance.puid = this.next_puid++;
				instance.iid = 0;
				instance.get_iid = cr.inst_get_iid;
				instance.toString = cr.inst_toString;
				instance.properties = m[14];
				instance.onCreate();
				cr.seal(instance);
				type_inst.instances.push(instance);
				this.objectsByUid[instance.uid.toString()] = instance;
			}
		}
		for (i = 0, len = pm[4].length; i < len; i++)
		{
			var familydata = pm[4][i];
			var familytype = this.types_by_index[familydata[0]];
			var familymember;
			for (j = 1, lenj = familydata.length; j < lenj; j++)
			{
				familymember = this.types_by_index[familydata[j]];
				familymember.families.push(familytype);
				familytype.members.push(familymember);
			}
		}
		for (i = 0, len = pm[24].length; i < len; i++)
		{
			var containerdata = pm[24][i];
			var containertypes = [];
			for (j = 0, lenj = containerdata.length; j < lenj; j++)
				containertypes.push(this.types_by_index[containerdata[j]]);
			for (j = 0, lenj = containertypes.length; j < lenj; j++)
			{
				containertypes[j].is_contained = true;
				containertypes[j].container = containertypes;
			}
		}
		if (this.family_count > 0)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				if (t.is_family || !t.families.length)
					continue;
				t.family_var_map = new Array(this.family_count);
				t.family_beh_map = new Array(this.family_count);
				t.family_fx_map = new Array(this.family_count);
				var all_fx = [];
				var varsum = 0;
				var behsum = 0;
				var fxsum = 0;
				for (j = 0, lenj = t.families.length; j < lenj; j++)
				{
					f = t.families[j];
					t.family_var_map[f.family_index] = varsum;
					varsum += f.vars_count;
					t.family_beh_map[f.family_index] = behsum;
					behsum += f.behs_count;
					t.family_fx_map[f.family_index] = fxsum;
					fxsum += f.fx_count;
					for (k = 0, lenk = f.effect_types.length; k < lenk; k++)
						all_fx.push(cr.shallowCopy({}, f.effect_types[k]));
				}
				t.effect_types = all_fx.concat(t.effect_types);
				for (j = 0, lenj = t.effect_types.length; j < lenj; j++)
					t.effect_types[j].index = j;
			}
		}
		for (i = 0, len = pm[5].length; i < len; i++)
		{
			m = pm[5][i];
			var layout = new cr.layout(this, m);
			cr.seal(layout);
			this.layouts[layout.name] = layout;
			this.layouts_by_index.push(layout);
		}
		for (i = 0, len = pm[6].length; i < len; i++)
		{
			m = pm[6][i];
			var sheet = new cr.eventsheet(this, m);
			cr.seal(sheet);
			this.eventsheets[sheet.name] = sheet;
			this.eventsheets_by_index.push(sheet);
		}
		for (i = 0, len = this.eventsheets_by_index.length; i < len; i++)
			this.eventsheets_by_index[i].postInit();
		for (i = 0, len = this.eventsheets_by_index.length; i < len; i++)
			this.eventsheets_by_index[i].updateDeepIncludes();
		for (i = 0, len = this.triggers_to_postinit.length; i < len; i++)
			this.triggers_to_postinit[i].postInit();
		this.triggers_to_postinit.length = 0;
		this.files_subfolder = pm[7];
		this.pixel_rounding = pm[8];
		this.aspect_scale = 1.0;
		this.enableWebGL = pm[12];
		this.linearSampling = pm[13];
		this.alphaBackground = pm[14];
		this.versionstr = pm[15];
		this.useHighDpi = pm[16];
		this.orientations = pm[19];		// 0 = any, 1 = portrait, 2 = landscape
		this.autoLockOrientation = (this.orientations > 0);
		this.pauseOnBlur = pm[21];
		this.wantFullscreenScalingQuality = pm[22];		// false = low quality, true = high quality
		this.fullscreenScalingQuality = this.wantFullscreenScalingQuality;
		this.downscalingQuality = pm[23];	// 0 = low (mips off), 1 = medium (mips on, dense spritesheet), 2 = high (mips on, sparse spritesheet)
		this.start_time = Date.now();
	};
	var anyImageHadError = false;
	Runtime.prototype.waitForImageLoad = function (img_)
	{
		img_.onerror = function (e)
		{
			img_.c2error = true;
			anyImageHadError = true;
			if (console && console.error)
				console.error("Error loading image '" + img_.src + "': ", e);
		};
		this.wait_for_textures.push(img_);
	};
	Runtime.prototype.findWaitingTexture = function (src_)
	{
		var i, len;
		for (i = 0, len = this.wait_for_textures.length; i < len; i++)
		{
			if (this.wait_for_textures[i].cr_src === src_)
				return this.wait_for_textures[i];
		}
		return null;
	};
	Runtime.prototype.areAllTexturesLoaded = function ()
	{
		var totalsize = 0;
		var completedsize = 0;
		var ret = true;
		var i, len, img;
		for (i = 0, len = this.wait_for_textures.length; i < len; i++)
		{
			img = this.wait_for_textures[i];
			var filesize = img.cr_filesize;
			if (!filesize || filesize <= 0)
				filesize = 50000;
			totalsize += filesize;
			if ((img.complete || img["loaded"]) && !img.c2error)
				completedsize += filesize;
			else
				ret = false;    // not all textures loaded
		}
		if (totalsize == 0)
			this.progress = 0;
		else
			this.progress = (completedsize / totalsize);
		return ret;
	};
	Runtime.prototype.go = function ()
	{
		if (!this.ctx && !this.glwrap)
			return;
		var ctx = this.ctx || this.overlay_ctx;
		if (this.overlay_canvas)
			this.positionOverlayCanvas();
		this.progress = 0;
		this.last_progress = -1;
		if (this.areAllTexturesLoaded())
			this.go_textures_done();
		else
		{
			var ms_elapsed = Date.now() - this.start_time;
			if (ctx)
			{
				var overlay_width = this.width;
				var overlay_height = this.height;
				var multiplier = this.devicePixelRatio;
				if (this.overlay_canvas)
				{
					overlay_width = this.cssWidth;
					overlay_height = this.cssHeight;
					multiplier = 1;
				}
				if (this.loaderstyle !== 3 && (this.isCocoonJs || (ms_elapsed >= 500 && this.last_progress != this.progress)))
				{
					ctx.clearRect(0, 0, overlay_width, overlay_height);
					var mx = overlay_width / 2;
					var my = overlay_height / 2;
					var haslogo = (this.loaderstyle === 0 && this.loaderlogo.complete);
					var hlw = 40 * multiplier;
					var hlh = 0;
					var logowidth = 80 * multiplier;
					var logoheight;
					if (haslogo)
					{
						logowidth = this.loaderlogo.width * multiplier;
						logoheight = this.loaderlogo.height * multiplier;
						hlw = logowidth / 2;
						hlh = logoheight / 2;
						ctx.drawImage(this.loaderlogo, cr.floor(mx - hlw), cr.floor(my - hlh), logowidth, logoheight);
					}
					if (this.loaderstyle <= 1)
					{
						my += hlh + (haslogo ? 12 * multiplier : 0);
						mx -= hlw;
						mx = cr.floor(mx) + 0.5;
						my = cr.floor(my) + 0.5;
						ctx.fillStyle = anyImageHadError ? "red" : "DodgerBlue";
						ctx.fillRect(mx, my, Math.floor(logowidth * this.progress), 6 * multiplier);
						ctx.strokeStyle = "black";
						ctx.strokeRect(mx, my, logowidth, 6 * multiplier);
						ctx.strokeStyle = "white";
						ctx.strokeRect(mx - 1 * multiplier, my - 1 * multiplier, logowidth + 2 * multiplier, 8 * multiplier);
					}
					else if (this.loaderstyle === 2)
					{
						ctx.font = (this.isEjecta ? "12pt ArialMT" : "12pt Arial");
						ctx.fillStyle = anyImageHadError ? "#f00" : "#999";
						ctx.textBaseLine = "middle";
						var percent_text = Math.round(this.progress * 100) + "%";
						var text_dim = ctx.measureText ? ctx.measureText(percent_text) : null;
						var text_width = text_dim ? text_dim.width : 0;
						ctx.fillText(percent_text, mx - (text_width / 2), my);
					}
				}
				this.last_progress = this.progress;
			}
			setTimeout((function (self) { return function () { self.go(); }; })(this), (this.isCocoonJs ? 10 : 100));
		}
	};
	Runtime.prototype.go_textures_done = function ()
	{
		if (this.overlay_canvas)
		{
			this.canvas.parentNode.removeChild(this.overlay_canvas);
			this.overlay_ctx = null;
			this.overlay_canvas = null;
		}
		this.start_time = Date.now();
		this.last_fps_time = cr.performance_now();       // for counting framerate
		var i, len, t;
		if (this.uses_loader_layout)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				if (!t.is_family && !t.isOnLoaderLayout && t.plugin.is_world)
				{
					t.onCreate();
					cr.seal(t);
				}
			}
		}
		else
			this.isloading = false;
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			this.layouts_by_index[i].createGlobalNonWorlds();
		}
		if (this.fullscreen_mode >= 2)
		{
			var orig_aspect = this.original_width / this.original_height;
			var cur_aspect = this.width / this.height;
			if ((this.fullscreen_mode !== 2 && cur_aspect > orig_aspect) || (this.fullscreen_mode === 2 && cur_aspect < orig_aspect))
				this.aspect_scale = this.height / this.original_height;
			else
				this.aspect_scale = this.width / this.original_width;
		}
		if (this.first_layout)
			this.layouts[this.first_layout].startRunning();
		else
			this.layouts_by_index[0].startRunning();
;
		if (!this.uses_loader_layout)
		{
			this.loadingprogress = 1;
			this.trigger(cr.system_object.prototype.cnds.OnLoadFinished, null);
		}
		if (navigator["splashscreen"] && navigator["splashscreen"]["hide"])
			navigator["splashscreen"]["hide"]();
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onAppBegin)
				t.onAppBegin();
		}
		this.tick(false);
		if (this.isDirectCanvas)
			AppMobi["webview"]["execute"]("onGameReady();");
	};
	var raf = window["requestAnimationFrame"] ||
	  window["mozRequestAnimationFrame"]    ||
	  window["webkitRequestAnimationFrame"] ||
	  window["msRequestAnimationFrame"]     ||
	  window["oRequestAnimationFrame"];
	Runtime.prototype.tick = function (background_wake)
	{
		if (!this.running_layout)
			return;
		var logic_start = cr.performance_now();
		if (this.halfFramerateMode && this.ranLastRaf)
		{
			if (logic_start - this.lastRafTime < 29)
			{
				this.ranLastRaf = false;
				this.lastRafTime = logic_start;
				if (raf)
					this.raf_id = raf(this.tickFunc, this.canvas);
				else	// no idea if this works without raf/hi res timers but let's hope for the best
					this.timeout_id = setTimeout(this.tickFunc, this.isMobile ? 1 : 16);
				return;		// skipped this frame
			}
		}
		this.ranLastRaf = true;
		this.lastRafTime = logic_start;
		var fsmode = this.fullscreen_mode;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"]);
		if ((isfullscreen || this.isNodeFullscreen) && this.fullscreen_scaling > 0)
			fsmode = this.fullscreen_scaling;
		if (fsmode > 0 && (!this.isiOS || window.self !== window.top))
		{
			var curwidth = window.innerWidth;
			var curheight = window.innerHeight;
			if (this.lastWindowWidth !== curwidth || this.lastWindowHeight !== curheight)
			{
					this["setSize"](curwidth, curheight);
			}
		}
		if (!this.isDomFree)
		{
			if (isfullscreen)
			{
				if (!this.firstInFullscreen)
				{
					this.fullscreenOldMarginCss = jQuery(this.canvas).css("margin") || "0";
					this.firstInFullscreen = true;
				}
				if (!this.isChrome && !this.isNodeWebkit)
				{
					jQuery(this.canvas).css({
						"margin-left": "" + Math.floor((screen.width - (this.width / this.devicePixelRatio)) / 2) + "px",
						"margin-top": "" + Math.floor((screen.height - (this.height / this.devicePixelRatio)) / 2) + "px"
					});
				}
			}
			else
			{
				if (this.firstInFullscreen)
				{
					if (!this.isChrome && !this.isNodeWebkit)
					{
						jQuery(this.canvas).css("margin", this.fullscreenOldMarginCss);
					}
					this.fullscreenOldMarginCss = "";
					this.firstInFullscreen = false;
					if (this.fullscreen_mode === 0)
					{
						this["setSize"](Math.round(this.oldWidth / this.devicePixelRatio), Math.round(this.oldHeight / this.devicePixelRatio), true);
					}
				}
				else
				{
					this.oldWidth = this.width;
					this.oldHeight = this.height;
				}
			}
		}
		if (this.isloading)
		{
			var done = this.areAllTexturesLoaded();		// updates this.progress
			this.loadingprogress = this.progress;
			if (done)
			{
				this.isloading = false;
				this.progress = 1;
				this.trigger(cr.system_object.prototype.cnds.OnLoadFinished, null);
			}
		}
		this.logic();
		if ((this.redraw || this.isCocoonJs) && !this.is_WebGL_context_lost && !this.suspendDrawing && !background_wake)
		{
			this.redraw = false;
			if (this.glwrap)
				this.drawGL();
			else
				this.draw();
			if (this.snapshotCanvas)
			{
				if (this.canvas && this.canvas.toDataURL)
				{
					this.snapshotData = this.canvas.toDataURL(this.snapshotCanvas[0], this.snapshotCanvas[1]);
					this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot, null);
				}
				this.snapshotCanvas = null;
			}
		}
		if (!this.hit_breakpoint)
		{
			this.tickcount++;
			this.execcount++;
			this.framecount++;
		}
		this.logictime += cr.performance_now() - logic_start;
		if (this.isSuspended || background_wake)
			return;
		if (raf)
			this.raf_id = raf(this.tickFunc, this.canvas);
		else
		{
			this.timeout_id = setTimeout(this.tickFunc, this.isMobile ? 1 : 16);
		}
	};
	Runtime.prototype.logic = function ()
	{
		var i, leni, j, lenj, k, lenk, type, inst, binst;
		var cur_time = cr.performance_now();
		if (cur_time - this.last_fps_time >= 1000)  // every 1 second
		{
			this.last_fps_time += 1000;
			this.fps = this.framecount;
			this.framecount = 0;
			this.cpuutilisation = this.logictime;
			this.logictime = 0;
		}
		if (this.measuring_dt)
		{
			if (this.last_tick_time !== 0)
			{
				var ms_diff = cur_time - this.last_tick_time;
				if (ms_diff === 0 && !this.isDebug)
				{
					this.zeroDtCount++;
					if (this.zeroDtCout >= 10)
						this.measuring_dt = false;
					this.dt1 = 1.0 / 60.0;            // 60fps assumed (0.01666...)
				}
				else
				{
					this.dt1 = ms_diff / 1000.0; // dt measured in seconds
					if (this.dt1 > 0.5)
						this.dt1 = 0;
					else if (this.dt1 > 0.1)
						this.dt1 = 0.1;
				}
			}
			this.last_tick_time = cur_time;
		}
        this.dt = this.dt1 * this.timescale;
        this.kahanTime.add(this.dt);
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"] || this.isNodeFullscreen);
		if (this.fullscreen_mode >= 2 /* scale */ || (isfullscreen && this.fullscreen_scaling > 0))
		{
			var orig_aspect = this.original_width / this.original_height;
			var cur_aspect = this.width / this.height;
			var mode = this.fullscreen_mode;
			if (isfullscreen && this.fullscreen_scaling > 0)
				mode = this.fullscreen_scaling;
			if ((mode !== 2 && cur_aspect > orig_aspect) || (mode === 2 && cur_aspect < orig_aspect))
			{
				this.aspect_scale = this.height / this.original_height;
			}
			else
			{
				this.aspect_scale = this.width / this.original_width;
			}
			if (this.running_layout)
			{
				this.running_layout.scrollToX(this.running_layout.scrollX);
				this.running_layout.scrollToY(this.running_layout.scrollY);
			}
		}
		else
			this.aspect_scale = (this.isRetina ? this.devicePixelRatio : 1);
		this.ClearDeathRow();
		this.isInOnDestroy++;
		this.system.runWaits();		// prevent instance list changing
		this.isInOnDestroy--;
		this.ClearDeathRow();		// allow instance list changing
		this.isInOnDestroy++;
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					inst.behavior_insts[k].tick();
				}
			}
		}
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;	// type doesn't have any behaviors
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					binst = inst.behavior_insts[k];
					if (binst.posttick)
						binst.posttick();
				}
			}
		}
        var tickarr = this.objects_to_tick.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].tick();
		this.isInOnDestroy--;		// end preventing instance lists from being changed
		this.handleSaveLoad();		// save/load now if queued
		i = 0;
		while (this.changelayout && i++ < 10)
		{
			this.doChangeLayout(this.changelayout);
		}
        for (i = 0, leni = this.eventsheets_by_index.length; i < leni; i++)
            this.eventsheets_by_index[i].hasRun = false;
		if (this.running_layout.event_sheet)
			this.running_layout.event_sheet.run();
		this.registered_collisions.length = 0;
		this.layout_first_tick = false;
		this.isInOnDestroy++;		// prevent instance lists from being changed
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;	// type doesn't have any behaviors
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				var inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					binst = inst.behavior_insts[k];
					if (binst.tick2)
						binst.tick2();
				}
			}
		}
        tickarr = this.objects_to_tick2.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].tick2();
		this.isInOnDestroy--;		// end preventing instance lists from being changed
	};
	Runtime.prototype.doChangeLayout = function (changeToLayout)
	{
;
		var prev_layout = this.running_layout;
		this.running_layout.stopRunning();
		var i, len, j, lenj, k, lenk, type, inst, binst;
		if (this.glwrap)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				type = this.types_by_index[i];
				if (type.is_family)
					continue;
				if (type.unloadTextures && (!type.global || type.instances.length === 0) && changeToLayout.initial_types.indexOf(type) === -1)
				{
					type.unloadTextures();
				}
			}
		}
		if (prev_layout == changeToLayout)
			this.system.waits.length = 0;
		changeToLayout.startRunning();
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (!type.global && !type.plugin.singleglobal)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				if (inst.onLayoutChange)
					inst.onLayoutChange();
				if (inst.behavior_insts)
				{
					for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
					{
						binst = inst.behavior_insts[k];
						if (binst.onLayoutChange)
							binst.onLayoutChange();
					}
				}
			}
		}
		this.redraw = true;
		this.layout_first_tick = true;
		this.ClearDeathRow();
	};
    Runtime.prototype.tickMe = function (inst)
    {
        this.objects_to_tick.add(inst);
    };
	Runtime.prototype.untickMe = function (inst)
	{
		this.objects_to_tick.remove(inst);
	};
	Runtime.prototype.tick2Me = function (inst)
    {
        this.objects_to_tick2.add(inst);
    };
	Runtime.prototype.untick2Me = function (inst)
	{
		this.objects_to_tick2.remove(inst);
	};
    Runtime.prototype.getDt = function (inst)
    {
        if (!inst || inst.my_timescale === -1.0)
            return this.dt;
        return this.dt1 * inst.my_timescale;
    };
	Runtime.prototype.draw = function ()
	{
		this.running_layout.draw(this.ctx);
		if (this.isDirectCanvas)
			this.ctx["present"]();
	};
	Runtime.prototype.drawGL = function ()
	{
		this.running_layout.drawGL(this.glwrap);
		this.glwrap.present();
	};
	Runtime.prototype.addDestroyCallback = function (f)
	{
		if (f)
			this.destroycallbacks.push(f);
	};
	Runtime.prototype.removeDestroyCallback = function (f)
	{
		cr.arrayFindRemove(this.destroycallbacks, f);
	};
	Runtime.prototype.getObjectByUID = function (uid_)
	{
;
		var uidstr = uid_.toString();
		if (this.objectsByUid.hasOwnProperty(uidstr))
			return this.objectsByUid[uidstr];
		else
			return null;
	};
	Runtime.prototype.DestroyInstance = function (inst)
	{
		var i, len;
		if (!this.deathRow.contains(inst))
		{
			this.deathRow.add(inst);
			if (inst.is_contained)
			{
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					this.DestroyInstance(inst.siblings[i]);
				}
			}
			if (this.isInClearDeathRow)
				this.deathRow.values_cache.push(inst);
			this.isInOnDestroy++;		// support recursion
			this.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnDestroyed, inst);
			this.isInOnDestroy--;
		}
	};
	Runtime.prototype.ClearDeathRow = function ()
	{
		var inst, index, type, instances, binst;
		var i, j, k, leni, lenj, lenk;
		var w, f;
		this.isInClearDeathRow = true;
		for (i = 0, leni = this.createRow.length; i < leni; i++)
		{
			inst = this.createRow[i];
			type = inst.type;
			type.instances.push(inst);
			for (j = 0, lenj = type.families.length; j < lenj; j++)
			{
				type.families[j].instances.push(inst);
				type.families[j].stale_iids = true;
			}
		}
		this.createRow.length = 0;
		var arr = this.deathRow.valuesRef();	// get array of items from set
		for (i = 0; i < arr.length; i++)		// check array length every time in case it changes
		{
			inst = arr[i];
			type = inst.type;
			instances = type.instances;
			for (j = 0, lenj = this.destroycallbacks.length; j < lenj; j++)
				this.destroycallbacks[j](inst);
			cr.arrayFindRemove(instances, inst);
			if (instances.length === 0)
				type.any_instance_parallaxed = false;
			if (inst.collcells)
			{
				type.collision_grid.update(inst, inst.collcells, null);
			}
			if (inst.layer)
			{
				cr.arrayRemove(inst.layer.instances, inst.get_zindex());
				inst.layer.zindices_stale = true;
			}
			for (j = 0, lenj = type.families.length; j < lenj; j++)
			{
				cr.arrayFindRemove(type.families[j].instances, inst);
				type.families[j].stale_iids = true;
			}
			if (inst.behavior_insts)
			{
				for (j = 0, lenj = inst.behavior_insts.length; j < lenj; j++)
				{
					binst = inst.behavior_insts[j];
					if (binst.onDestroy)
						binst.onDestroy();
					binst.behavior.my_instances.remove(inst);
				}
			}
            this.objects_to_tick.remove(inst);
			this.objects_to_tick2.remove(inst);
			for (j = 0, lenj = this.system.waits.length; j < lenj; j++)
			{
				w = this.system.waits[j];
				if (w.sols.hasOwnProperty(type.index))
					cr.arrayFindRemove(w.sols[type.index].insts, inst);
				if (!type.is_family)
				{
					for (k = 0, lenk = type.families.length; k < lenk; k++)
					{
						f = type.families[k];
						if (w.sols.hasOwnProperty(f.index))
							cr.arrayFindRemove(w.sols[f.index].insts, inst);
					}
				}
			}
			if (inst.onDestroy)
				inst.onDestroy();
			if (this.objectsByUid.hasOwnProperty(inst.uid.toString()))
				delete this.objectsByUid[inst.uid.toString()];
			this.objectcount--;
			if (type.deadCache.length < 64)
				type.deadCache.push(inst);
			type.stale_iids = true;
		}
		if (!this.deathRow.isEmpty())
			this.redraw = true;
		this.deathRow.clear();
		this.isInClearDeathRow = false;
	};
	Runtime.prototype.createInstance = function (type, layer, sx, sy)
	{
		if (type.is_family)
		{
			var i = cr.floor(Math.random() * type.members.length);
			return this.createInstance(type.members[i], layer, sx, sy);
		}
		if (!type.default_instance)
		{
			return null;
		}
		return this.createInstanceFromInit(type.default_instance, layer, false, sx, sy, false);
	};
	var all_behaviors = [];
	Runtime.prototype.createInstanceFromInit = function (initial_inst, layer, is_startup_instance, sx, sy, skip_siblings)
	{
		var i, len, j, lenj, p, effect_fallback, x, y;
		if (!initial_inst)
			return null;
		var type = this.types_by_index[initial_inst[1]];
;
;
		var is_world = type.plugin.is_world;
;
		if (this.isloading && is_world && !type.isOnLoaderLayout)
			return null;
		if (is_world && !this.glwrap && initial_inst[0][11] === 11)
			return null;
		var original_layer = layer;
		if (!is_world)
			layer = null;
		var inst;
		if (type.deadCache.length)
		{
			inst = type.deadCache.pop();
			inst.recycled = true;
			type.plugin.Instance.call(inst, type);
		}
		else
		{
			inst = new type.plugin.Instance(type);
			inst.recycled = false;
		}
		if (is_startup_instance && !skip_siblings)
			inst.uid = initial_inst[2];
		else
			inst.uid = this.next_uid++;
		this.objectsByUid[inst.uid.toString()] = inst;
		inst.puid = this.next_puid++;
		inst.iid = type.instances.length;
		for (i = 0, len = this.createRow.length; i < len; ++i)
		{
			if (this.createRow[i].type === type)
				inst.iid++;
		}
		inst.get_iid = cr.inst_get_iid;
		var initial_vars = initial_inst[3];
		if (inst.recycled)
		{
			cr.wipe(inst.extra);
		}
		else
		{
			inst.extra = {};
			if (typeof cr_is_preview !== "undefined")
			{
				inst.instance_var_names = [];
				inst.instance_var_names.length = initial_vars.length;
				for (i = 0, len = initial_vars.length; i < len; i++)
					inst.instance_var_names[i] = initial_vars[i][1];
			}
			inst.instance_vars = [];
			inst.instance_vars.length = initial_vars.length;
		}
		for (i = 0, len = initial_vars.length; i < len; i++)
			inst.instance_vars[i] = initial_vars[i][0];
		if (is_world)
		{
			var wm = initial_inst[0];
;
			inst.x = cr.is_undefined(sx) ? wm[0] : sx;
			inst.y = cr.is_undefined(sy) ? wm[1] : sy;
			inst.z = wm[2];
			inst.width = wm[3];
			inst.height = wm[4];
			inst.depth = wm[5];
			inst.angle = wm[6];
			inst.opacity = wm[7];
			inst.hotspotX = wm[8];
			inst.hotspotY = wm[9];
			inst.blend_mode = wm[10];
			effect_fallback = wm[11];
			if (!this.glwrap && type.effect_types.length)	// no WebGL renderer and shaders used
				inst.blend_mode = effect_fallback;			// use fallback blend mode - destroy mode was handled above
			inst.compositeOp = cr.effectToCompositeOp(inst.blend_mode);
			if (this.gl)
				cr.setGLBlend(inst, inst.blend_mode, this.gl);
			if (inst.recycled)
			{
				for (i = 0, len = wm[12].length; i < len; i++)
				{
					for (j = 0, lenj = wm[12][i].length; j < lenj; j++)
						inst.effect_params[i][j] = wm[12][i][j];
				}
				inst.bbox.set(0, 0, 0, 0);
				inst.collcells.set(0, 0, -1, -1);
				inst.bquad.set_from_rect(inst.bbox);
				inst.bbox_changed_callbacks.length = 0;
			}
			else
			{
				inst.effect_params = wm[12].slice(0);
				for (i = 0, len = inst.effect_params.length; i < len; i++)
					inst.effect_params[i] = wm[12][i].slice(0);
				inst.active_effect_types = [];
				inst.active_effect_flags = [];
				inst.active_effect_flags.length = type.effect_types.length;
				inst.bbox = new cr.rect(0, 0, 0, 0);
				inst.collcells = new cr.rect(0, 0, -1, -1);
				inst.bquad = new cr.quad();
				inst.bbox_changed_callbacks = [];
				inst.set_bbox_changed = cr.set_bbox_changed;
				inst.add_bbox_changed_callback = cr.add_bbox_changed_callback;
				inst.contains_pt = cr.inst_contains_pt;
				inst.update_bbox = cr.update_bbox;
				inst.update_collision_cell = cr.update_collision_cell;
				inst.get_zindex = cr.inst_get_zindex;
			}
			inst.tilemap_exists = false;
			inst.tilemap_width = 0;
			inst.tilemap_height = 0;
			inst.tilemap_data = null;
			if (wm.length === 14)
			{
				inst.tilemap_exists = true;
				inst.tilemap_width = wm[13][0];
				inst.tilemap_height = wm[13][1];
				inst.tilemap_data = wm[13][2];
			}
			for (i = 0, len = type.effect_types.length; i < len; i++)
				inst.active_effect_flags[i] = true;
			inst.updateActiveEffects = cr.inst_updateActiveEffects;
			inst.updateActiveEffects();
			inst.uses_shaders = !!inst.active_effect_types.length;
			inst.bbox_changed = true;
			inst.cell_changed = true;
			type.any_cell_changed = true;
			inst.visible = true;
            inst.my_timescale = -1.0;
			inst.layer = layer;
			inst.zindex = layer.instances.length;	// will be placed at top of current layer
			if (typeof inst.collision_poly === "undefined")
				inst.collision_poly = null;
			inst.collisionsEnabled = true;
			this.redraw = true;
		}
		inst.toString = cr.inst_toString;
		var initial_props, binst;
		all_behaviors.length = 0;
		for (i = 0, len = type.families.length; i < len; i++)
		{
			all_behaviors.push.apply(all_behaviors, type.families[i].behaviors);
		}
		all_behaviors.push.apply(all_behaviors, type.behaviors);
		if (inst.recycled)
		{
			for (i = 0, len = all_behaviors.length; i < len; i++)
			{
				var btype = all_behaviors[i];
				binst = inst.behavior_insts[i];
				binst.recycled = true;
				btype.behavior.Instance.call(binst, btype, inst);
				initial_props = initial_inst[4][i];
				for (j = 0, lenj = initial_props.length; j < lenj; j++)
					binst.properties[j] = initial_props[j];
				binst.onCreate();
				btype.behavior.my_instances.add(inst);
			}
		}
		else
		{
			inst.behavior_insts = [];
			for (i = 0, len = all_behaviors.length; i < len; i++)
			{
				var btype = all_behaviors[i];
				var binst = new btype.behavior.Instance(btype, inst);
				binst.recycled = false;
				binst.properties = initial_inst[4][i].slice(0);
				binst.onCreate();
				cr.seal(binst);
				inst.behavior_insts.push(binst);
				btype.behavior.my_instances.add(inst);
			}
		}
		initial_props = initial_inst[5];
		if (inst.recycled)
		{
			for (i = 0, len = initial_props.length; i < len; i++)
				inst.properties[i] = initial_props[i];
		}
		else
			inst.properties = initial_props.slice(0);
		this.createRow.push(inst);
		if (layer)
		{
;
			layer.instances.push(inst);
			if (layer.parallaxX !== 1 || layer.parallaxY !== 1)
				type.any_instance_parallaxed = true;
		}
		this.objectcount++;
		if (type.is_contained)
		{
			inst.is_contained = true;
			if (inst.recycled)
				inst.siblings.length = 0;
			else
				inst.siblings = [];			// note: should not include self in siblings
			if (!is_startup_instance && !skip_siblings)	// layout links initial instances
			{
				for (i = 0, len = type.container.length; i < len; i++)
				{
					if (type.container[i] === type)
						continue;
					if (!type.container[i].default_instance)
					{
						return null;
					}
					inst.siblings.push(this.createInstanceFromInit(type.container[i].default_instance, original_layer, false, is_world ? inst.x : sx, is_world ? inst.y : sy, true));
				}
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					inst.siblings[i].siblings.push(inst);
					for (j = 0; j < len; j++)
					{
						if (i !== j)
							inst.siblings[i].siblings.push(inst.siblings[j]);
					}
				}
			}
		}
		else
		{
			inst.is_contained = false;
			inst.siblings = null;
		}
		inst.onCreate();
		if (!inst.recycled)
			cr.seal(inst);
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i].postCreate)
				inst.behavior_insts[i].postCreate();
		}
		return inst;
	};
	Runtime.prototype.getLayerByName = function (layer_name)
	{
		var i, len;
		for (i = 0, len = this.running_layout.layers.length; i < len; i++)
		{
			var layer = this.running_layout.layers[i];
			if (cr.equals_nocase(layer.name, layer_name))
				return layer;
		}
		return null;
	};
	Runtime.prototype.getLayerByNumber = function (index)
	{
		index = cr.floor(index);
		if (index < 0)
			index = 0;
		if (index >= this.running_layout.layers.length)
			index = this.running_layout.layers.length - 1;
		return this.running_layout.layers[index];
	};
	Runtime.prototype.getLayer = function (l)
	{
		if (cr.is_number(l))
			return this.getLayerByNumber(l);
		else
			return this.getLayerByName(l.toString());
	};
	Runtime.prototype.clearSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].getCurrentSol().select_all = true;
		}
	};
	Runtime.prototype.pushCleanSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].pushCleanSol();
		}
	};
	Runtime.prototype.pushCopySol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].pushCopySol();
		}
	};
	Runtime.prototype.popSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].popSol();
		}
	};
	Runtime.prototype.updateAllCells = function (type)
	{
		if (!type.any_cell_changed)
			return;		// all instances must already be up-to-date
		var i, len, instances = type.instances;
		for (i = 0, len = instances.length; i < len; ++i)
		{
			instances[i].update_collision_cell();
		}
		var createRow = this.createRow;
		for (i = 0, len = createRow.length; i < len; ++i)
		{
			if (createRow[i].type === type)
				createRow[i].update_collision_cell();
		}
		type.any_cell_changed = false;
	};
	Runtime.prototype.getCollisionCandidates = function (layer, rtype, bbox, candidates)
	{
		var i, len, t;
		var is_parallaxed = (layer ? (layer.parallaxX !== 1 || layer.parallaxY !== 1) : false);
		if (rtype.is_family)
		{
			for (i = 0, len = rtype.members.length; i < len; ++i)
			{
				t = rtype.members[i];
				if (is_parallaxed || t.any_instance_parallaxed)
				{
					cr.appendArray(candidates, t.instances);
				}
				else
				{
					this.updateAllCells(t);
					t.collision_grid.queryRange(bbox, candidates);
				}
			}
		}
		else
		{
			if (is_parallaxed || rtype.any_instance_parallaxed)
			{
				cr.appendArray(candidates, rtype.instances);
			}
			else
			{
				this.updateAllCells(rtype);
				rtype.collision_grid.queryRange(bbox, candidates);
			}
		}
	};
	Runtime.prototype.getTypesCollisionCandidates = function (layer, types, bbox, candidates)
	{
		var i, len;
		for (i = 0, len = types.length; i < len; ++i)
		{
			this.getCollisionCandidates(layer, types[i], bbox, candidates);
		}
	};
	Runtime.prototype.getSolidCollisionCandidates = function (layer, bbox, candidates)
	{
		var solid = this.getSolidBehavior();
		if (!solid)
			return null;
		this.getTypesCollisionCandidates(layer, solid.my_types, bbox, candidates);
	};
	Runtime.prototype.getJumpthruCollisionCandidates = function (layer, bbox, candidates)
	{
		var jumpthru = this.getJumpthruBehavior();
		if (!jumpthru)
			return null;
		this.getTypesCollisionCandidates(layer, jumpthru.my_types, bbox, candidates);
	};
	Runtime.prototype.testAndSelectCanvasPointOverlap = function (type, ptx, pty, inverted)
	{
		var sol = type.getCurrentSol();
		var i, j, inst, len;
		var lx, ly;
		if (sol.select_all)
		{
			if (!inverted)
			{
				sol.select_all = false;
				sol.instances.length = 0;   // clear contents
			}
			for (i = 0, len = type.instances.length; i < len; i++)
			{
				inst = type.instances[i];
				inst.update_bbox();
				lx = inst.layer.canvasToLayer(ptx, pty, true);
				ly = inst.layer.canvasToLayer(ptx, pty, false);
				if (inst.contains_pt(lx, ly))
				{
					if (inverted)
						return false;
					else
						sol.instances.push(inst);
				}
			}
		}
		else
		{
			j = 0;
			for (i = 0, len = sol.instances.length; i < len; i++)
			{
				inst = sol.instances[i];
				inst.update_bbox();
				lx = inst.layer.canvasToLayer(ptx, pty, true);
				ly = inst.layer.canvasToLayer(ptx, pty, false);
				if (inst.contains_pt(lx, ly))
				{
					if (inverted)
						return false;
					else
					{
						sol.instances[j] = sol.instances[i];
						j++;
					}
				}
			}
			if (!inverted)
				sol.instances.length = j;
		}
		type.applySolToContainer();
		if (inverted)
			return true;		// did not find anything overlapping
		else
			return sol.hasObjects();
	};
	Runtime.prototype.testOverlap = function (a, b)
	{
		if (!a || !b || a === b || !a.collisionsEnabled || !b.collisionsEnabled)
			return false;
		a.update_bbox();
		b.update_bbox();
		var layera = a.layer;
		var layerb = b.layer;
		var different_layers = (layera !== layerb && (layera.parallaxX !== layerb.parallaxX || layerb.parallaxY !== layerb.parallaxY || layera.scale !== layerb.scale || layera.angle !== layerb.angle || layera.zoomRate !== layerb.zoomRate));
		var i, len, i2, i21, x, y, haspolya, haspolyb, polya, polyb;
		if (!different_layers)	// same layers: easy check
		{
			if (!a.bbox.intersects_rect(b.bbox))
				return false;
			if (!a.bquad.intersects_quad(b.bquad))
				return false;
			if (a.tilemap_exists && b.tilemap_exists)
				return false;
			if (a.tilemap_exists)
				return this.testTilemapOverlap(a, b);
			if (b.tilemap_exists)
				return this.testTilemapOverlap(b, a);
			haspolya = (a.collision_poly && !a.collision_poly.is_empty());
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolya && !haspolyb)
				return true;
			if (haspolya)
			{
				a.collision_poly.cache_poly(a.width, a.height, a.angle);
				polya = a.collision_poly;
			}
			else
			{
				this.temp_poly.set_from_quad(a.bquad, a.x, a.y, a.width, a.height);
				polya = this.temp_poly;
			}
			if (haspolyb)
			{
				b.collision_poly.cache_poly(b.width, b.height, b.angle);
				polyb = b.collision_poly;
			}
			else
			{
				this.temp_poly.set_from_quad(b.bquad, b.x, b.y, b.width, b.height);
				polyb = this.temp_poly;
			}
			return polya.intersects_poly(polyb, b.x - a.x, b.y - a.y);
		}
		else	// different layers: need to do full translated check
		{
			haspolya = (a.collision_poly && !a.collision_poly.is_empty());
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (haspolya)
			{
				a.collision_poly.cache_poly(a.width, a.height, a.angle);
				this.temp_poly.set_from_poly(a.collision_poly);
			}
			else
			{
				this.temp_poly.set_from_quad(a.bquad, a.x, a.y, a.width, a.height);
			}
			polya = this.temp_poly;
			if (haspolyb)
			{
				b.collision_poly.cache_poly(b.width, b.height, b.angle);
				this.temp_poly2.set_from_poly(b.collision_poly);
			}
			else
			{
				this.temp_poly2.set_from_quad(b.bquad, b.x, b.y, b.width, b.height);
			}
			polyb = this.temp_poly2;
			for (i = 0, len = polya.pts_count; i < len; i++)
			{
				i2 = i * 2;
				i21 = i2 + 1;
				x = polya.pts_cache[i2];
				y = polya.pts_cache[i21];
				polya.pts_cache[i2] = layera.layerToCanvas(x + a.x, y + a.y, true);
				polya.pts_cache[i21] = layera.layerToCanvas(x + a.x, y + a.y, false);
			}
			polya.update_bbox();
			for (i = 0, len = polyb.pts_count; i < len; i++)
			{
				i2 = i * 2;
				i21 = i2 + 1;
				x = polyb.pts_cache[i2];
				y = polyb.pts_cache[i21];
				polyb.pts_cache[i2] = layerb.layerToCanvas(x + b.x, y + b.y, true);
				polyb.pts_cache[i21] = layerb.layerToCanvas(x + b.x, y + b.y, false);
			}
			polyb.update_bbox();
			return polya.intersects_poly(polyb, 0, 0);
		}
	};
	var tmpQuad = new cr.quad();
	var tmpRect = new cr.rect(0, 0, 0, 0);
	var collrect_candidates = [];
	Runtime.prototype.testTilemapOverlap = function (tm, a)
	{
		var i, len, c, rc;
		var bbox = a.bbox;
		var tmx = tm.x;
		var tmy = tm.y;
		tm.getCollisionRectCandidates(bbox, collrect_candidates);
		var collrects = collrect_candidates;
		var haspolya = (a.collision_poly && !a.collision_poly.is_empty());
		for (i = 0, len = collrects.length; i < len; ++i)
		{
			c = collrects[i];
			rc = c.rc;
			if (bbox.intersects_rect_off(rc, tmx, tmy))
			{
				tmpQuad.set_from_rect(rc);
				tmpQuad.offset(tmx, tmy);
				if (tmpQuad.intersects_quad(a.bquad))
				{
					if (haspolya)
					{
						a.collision_poly.cache_poly(a.width, a.height, a.angle);
						if (c.poly)
						{
							if (c.poly.intersects_poly(a.collision_poly, a.x - (tmx + rc.left), a.y - (tmy + rc.top)))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							this.temp_poly.set_from_quad(tmpQuad, 0, 0, rc.right - rc.left, rc.bottom - rc.top);
							if (this.temp_poly.intersects_poly(a.collision_poly, a.x, a.y))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
					}
					else
					{
						if (c.poly)
						{
							this.temp_poly.set_from_quad(a.bquad, 0, 0, a.width, a.height);
							if (c.poly.intersects_poly(this.temp_poly, -(tmx + rc.left), -(tmy + rc.top)))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
				}
			}
		}
		collrect_candidates.length = 0;
		return false;
	};
	Runtime.prototype.testRectOverlap = function (r, b)
	{
		if (!b || !b.collisionsEnabled)
			return false;
		b.update_bbox();
		var layerb = b.layer;
		var haspolyb, polyb;
		if (!b.bbox.intersects_rect(r))
			return false;
		if (b.tilemap_exists)
		{
			b.getCollisionRectCandidates(r, collrect_candidates);
			var collrects = collrect_candidates;
			var i, len, c, tilerc;
			var tmx = b.x;
			var tmy = b.y;
			for (i = 0, len = collrects.length; i < len; ++i)
			{
				c = collrects[i];
				tilerc = c.rc;
				if (r.intersects_rect_off(tilerc, tmx, tmy))
				{
					if (c.poly)
					{
						this.temp_poly.set_from_rect(r, 0, 0);
						if (c.poly.intersects_poly(this.temp_poly, -(tmx + tilerc.left), -(tmy + tilerc.top)))
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
					else
					{
						collrect_candidates.length = 0;
						return true;
					}
				}
			}
			collrect_candidates.length = 0;
			return false;
		}
		else
		{
			tmpQuad.set_from_rect(r);
			if (!b.bquad.intersects_quad(tmpQuad))
				return false;
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolyb)
				return true;
			b.collision_poly.cache_poly(b.width, b.height, b.angle);
			tmpQuad.offset(-r.left, -r.top);
			this.temp_poly.set_from_quad(tmpQuad, 0, 0, 1, 1);
			return b.collision_poly.intersects_poly(this.temp_poly, r.left - b.x, r.top - b.y);
		}
	};
	Runtime.prototype.testSegmentOverlap = function (x1, y1, x2, y2, b)
	{
		if (!b || !b.collisionsEnabled)
			return false;
		b.update_bbox();
		var layerb = b.layer;
		var haspolyb, polyb;
		tmpRect.set(cr.min(x1, x2), cr.min(y1, y2), cr.max(x1, x2), cr.max(y1, y2));
		if (!b.bbox.intersects_rect(tmpRect))
			return false;
		if (b.tilemap_exists)
		{
			b.getCollisionRectCandidates(tmpRect, collrect_candidates);
			var collrects = collrect_candidates;
			var i, len, c, tilerc;
			var tmx = b.x;
			var tmy = b.y;
			for (i = 0, len = collrects.length; i < len; ++i)
			{
				c = collrects[i];
				tilerc = c.rc;
				if (tmpRect.intersects_rect_off(tilerc, tmx, tmy))
				{
					tmpQuad.set_from_rect(tilerc);
					tmpQuad.offset(tmx, tmy);
					if (tmpQuad.intersects_segment(x1, y1, x2, y2))
					{
						if (c.poly)
						{
							if (c.poly.intersects_segment(tmx + tilerc.left, tmy + tilerc.top, x1, y1, x2, y2))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
				}
			}
			collrect_candidates.length = 0;
			return false;
		}
		else
		{
			if (!b.bquad.intersects_segment(x1, y1, x2, y2))
				return false;
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolyb)
				return true;
			b.collision_poly.cache_poly(b.width, b.height, b.angle);
			return b.collision_poly.intersects_segment(b.x, b.y, x1, y1, x2, y2);
		}
	};
	Runtime.prototype.typeHasBehavior = function (t, b)
	{
		if (!b)
			return false;
		var i, len, j, lenj, f;
		for (i = 0, len = t.behaviors.length; i < len; i++)
		{
			if (t.behaviors[i].behavior instanceof b)
				return true;
		}
		if (!t.is_family)
		{
			for (i = 0, len = t.families.length; i < len; i++)
			{
				f = t.families[i];
				for (j = 0, lenj = f.behaviors.length; j < lenj; j++)
				{
					if (f.behaviors[j].behavior instanceof b)
						return true;
				}
			}
		}
		return false;
	};
	Runtime.prototype.typeHasNoSaveBehavior = function (t)
	{
		return this.typeHasBehavior(t, cr.behaviors.NoSave);
	};
	Runtime.prototype.typeHasPersistBehavior = function (t)
	{
		return this.typeHasBehavior(t, cr.behaviors.Persist);
	};
	Runtime.prototype.getSolidBehavior = function ()
	{
		return this.solidBehavior;
	};
	Runtime.prototype.getJumpthruBehavior = function ()
	{
		return this.jumpthruBehavior;
	};
	var candidates = [];
	Runtime.prototype.testOverlapSolid = function (inst)
	{
		var i, len, s;
		inst.update_bbox();
		this.getSolidCollisionCandidates(inst.layer, inst.bbox, candidates);
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			s = candidates[i];
			if (!s.extra.solidEnabled)
				continue;
			if (this.testOverlap(inst, s))
			{
				candidates.length = 0;
				return s;
			}
		}
		candidates.length = 0;
		return null;
	};
	Runtime.prototype.testRectOverlapSolid = function (r)
	{
		var i, len, s;
		this.getSolidCollisionCandidates(null, r, candidates);
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			s = candidates[i];
			if (!s.extra.solidEnabled)
				continue;
			if (this.testRectOverlap(r, s))
			{
				candidates.length = 0;
				return s;
			}
		}
		candidates.length = 0;
		return null;
	};
	var jumpthru_array_ret = [];
	Runtime.prototype.testOverlapJumpThru = function (inst, all)
	{
		var ret = null;
		if (all)
		{
			ret = jumpthru_array_ret;
			ret.length = 0;
		}
		inst.update_bbox();
		this.getJumpthruCollisionCandidates(inst.layer, inst.bbox, candidates);
		var i, len, j;
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			j = candidates[i];
			if (!j.extra.jumpthruEnabled)
				continue;
			if (this.testOverlap(inst, j))
			{
				if (all)
					ret.push(j);
				else
				{
					candidates.length = 0;
					return j;
				}
			}
		}
		candidates.length = 0;
		return ret;
	};
	Runtime.prototype.pushOutSolid = function (inst, xdir, ydir, dist, include_jumpthrus, specific_jumpthru)
	{
		var push_dist = dist || 50;
		var oldx = inst.x
		var oldy = inst.y;
		var i;
		var last_overlapped = null, secondlast_overlapped = null;
		for (i = 0; i < push_dist; i++)
		{
			inst.x = (oldx + (xdir * i));
			inst.y = (oldy + (ydir * i));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, last_overlapped))
			{
				last_overlapped = this.testOverlapSolid(inst);
				if (last_overlapped)
					secondlast_overlapped = last_overlapped;
				if (!last_overlapped)
				{
					if (include_jumpthrus)
					{
						if (specific_jumpthru)
							last_overlapped = (this.testOverlap(inst, specific_jumpthru) ? specific_jumpthru : null);
						else
							last_overlapped = this.testOverlapJumpThru(inst);
						if (last_overlapped)
							secondlast_overlapped = last_overlapped;
					}
					if (!last_overlapped)
					{
						if (secondlast_overlapped)
							this.pushInFractional(inst, xdir, ydir, secondlast_overlapped, 16);
						return true;
					}
				}
			}
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.pushOut = function (inst, xdir, ydir, dist, otherinst)
	{
		var push_dist = dist || 50;
		var oldx = inst.x
		var oldy = inst.y;
		var i;
		for (i = 0; i < push_dist; i++)
		{
			inst.x = (oldx + (xdir * i));
			inst.y = (oldy + (ydir * i));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, otherinst))
				return true;
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.pushInFractional = function (inst, xdir, ydir, obj, limit)
	{
		var divisor = 2;
		var frac;
		var forward = false;
		var overlapping = false;
		var bestx = inst.x;
		var besty = inst.y;
		while (divisor <= limit)
		{
			frac = 1 / divisor;
			divisor *= 2;
			inst.x += xdir * frac * (forward ? 1 : -1);
			inst.y += ydir * frac * (forward ? 1 : -1);
			inst.set_bbox_changed();
			if (this.testOverlap(inst, obj))
			{
				forward = true;
				overlapping = true;
			}
			else
			{
				forward = false;
				overlapping = false;
				bestx = inst.x;
				besty = inst.y;
			}
		}
		if (overlapping)
		{
			inst.x = bestx;
			inst.y = besty;
			inst.set_bbox_changed();
		}
	};
	Runtime.prototype.pushOutSolidNearest = function (inst, max_dist_)
	{
		var max_dist = (cr.is_undefined(max_dist_) ? 100 : max_dist_);
		var dist = 0;
		var oldx = inst.x
		var oldy = inst.y;
		var dir = 0;
		var dx = 0, dy = 0;
		var last_overlapped = this.testOverlapSolid(inst);
		if (!last_overlapped)
			return true;		// already clear of solids
		while (dist <= max_dist)
		{
			switch (dir) {
			case 0:		dx = 0; dy = -1; dist++; break;
			case 1:		dx = 1; dy = -1; break;
			case 2:		dx = 1; dy = 0; break;
			case 3:		dx = 1; dy = 1; break;
			case 4:		dx = 0; dy = 1; break;
			case 5:		dx = -1; dy = 1; break;
			case 6:		dx = -1; dy = 0; break;
			case 7:		dx = -1; dy = -1; break;
			}
			dir = (dir + 1) % 8;
			inst.x = cr.floor(oldx + (dx * dist));
			inst.y = cr.floor(oldy + (dy * dist));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, last_overlapped))
			{
				last_overlapped = this.testOverlapSolid(inst);
				if (!last_overlapped)
					return true;
			}
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.registerCollision = function (a, b)
	{
		if (!a.collisionsEnabled || !b.collisionsEnabled)
			return;
		this.registered_collisions.push([a, b]);
	};
	Runtime.prototype.checkRegisteredCollision = function (a, b)
	{
		var i, len, x;
		for (i = 0, len = this.registered_collisions.length; i < len; i++)
		{
			x = this.registered_collisions[i];
			if ((x[0] == a && x[1] == b) || (x[0] == b && x[1] == a))
				return true;
		}
		return false;
	};
	Runtime.prototype.calculateSolidBounceAngle = function(inst, startx, starty, obj)
	{
		var objx = inst.x;
		var objy = inst.y;
		var radius = cr.max(10, cr.distanceTo(startx, starty, objx, objy));
		var startangle = cr.angleTo(startx, starty, objx, objy);
		var firstsolid = obj || this.testOverlapSolid(inst);
		if (!firstsolid)
			return cr.clamp_angle(startangle + cr.PI);
		var cursolid = firstsolid;
		var i, curangle, anticlockwise_free_angle, clockwise_free_angle;
		var increment = cr.to_radians(5);	// 5 degree increments
		for (i = 1; i < 36; i++)
		{
			curangle = startangle - i * increment;
			inst.x = startx + Math.cos(curangle) * radius;
			inst.y = starty + Math.sin(curangle) * radius;
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, cursolid))
			{
				cursolid = obj ? null : this.testOverlapSolid(inst);
				if (!cursolid)
				{
					anticlockwise_free_angle = curangle;
					break;
				}
			}
		}
		if (i === 36)
			anticlockwise_free_angle = cr.clamp_angle(startangle + cr.PI);
		var cursolid = firstsolid;
		for (i = 1; i < 36; i++)
		{
			curangle = startangle + i * increment;
			inst.x = startx + Math.cos(curangle) * radius;
			inst.y = starty + Math.sin(curangle) * radius;
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, cursolid))
			{
				cursolid = obj ? null : this.testOverlapSolid(inst);
				if (!cursolid)
				{
					clockwise_free_angle = curangle;
					break;
				}
			}
		}
		if (i === 36)
			clockwise_free_angle = cr.clamp_angle(startangle + cr.PI);
		inst.x = objx;
		inst.y = objy;
		inst.set_bbox_changed();
		if (clockwise_free_angle === anticlockwise_free_angle)
			return clockwise_free_angle;
		var half_diff = cr.angleDiff(clockwise_free_angle, anticlockwise_free_angle) / 2;
		var normal;
		if (cr.angleClockwise(clockwise_free_angle, anticlockwise_free_angle))
		{
			normal = cr.clamp_angle(anticlockwise_free_angle + half_diff + cr.PI);
		}
		else
		{
			normal = cr.clamp_angle(clockwise_free_angle + half_diff);
		}
;
		var vx = Math.cos(startangle);
		var vy = Math.sin(startangle);
		var nx = Math.cos(normal);
		var ny = Math.sin(normal);
		var v_dot_n = vx * nx + vy * ny;
		var rx = vx - 2 * v_dot_n * nx;
		var ry = vy - 2 * v_dot_n * ny;
		return cr.angleTo(0, 0, rx, ry);
	};
	var triggerSheetIndex = -1;
	Runtime.prototype.trigger = function (method, inst, value /* for fast triggers */)
	{
;
		if (!this.running_layout)
			return false;
		var sheet = this.running_layout.event_sheet;
		if (!sheet)
			return false;     // no event sheet active; nothing to trigger
		var ret = false;
		var r, i, len;
		triggerSheetIndex++;
		var deep_includes = sheet.deep_includes;
		for (i = 0, len = deep_includes.length; i < len; ++i)
		{
			r = this.triggerOnSheet(method, inst, deep_includes[i], value);
			ret = ret || r;
		}
		r = this.triggerOnSheet(method, inst, sheet, value);
		ret = ret || r;
		triggerSheetIndex--;
		return ret;
    };
    Runtime.prototype.triggerOnSheet = function (method, inst, sheet, value)
    {
        var ret = false;
		var i, leni, r, families;
		if (!inst)
		{
			r = this.triggerOnSheetForTypeName(method, inst, "system", sheet, value);
			ret = ret || r;
		}
		else
		{
			r = this.triggerOnSheetForTypeName(method, inst, inst.type.name, sheet, value);
			ret = ret || r;
			families = inst.type.families;
			for (i = 0, leni = families.length; i < leni; ++i)
			{
				r = this.triggerOnSheetForTypeName(method, inst, families[i].name, sheet, value);
				ret = ret || r;
			}
		}
		return ret;             // true if anything got triggered
	};
	Runtime.prototype.triggerOnSheetForTypeName = function (method, inst, type_name, sheet, value)
	{
		var i, leni;
		var ret = false, ret2 = false;
		var trig, index;
		var fasttrigger = (typeof value !== "undefined");
		var triggers = (fasttrigger ? sheet.fasttriggers : sheet.triggers);
		var obj_entry = triggers[type_name];
		if (!obj_entry)
			return ret;
		var triggers_list = null;
		for (i = 0, leni = obj_entry.length; i < leni; ++i)
		{
			if (obj_entry[i].method == method)
			{
				triggers_list = obj_entry[i].evs;
				break;
			}
		}
		if (!triggers_list)
			return ret;
		var triggers_to_fire;
		if (fasttrigger)
		{
			triggers_to_fire = triggers_list[value];
		}
		else
		{
			triggers_to_fire = triggers_list;
		}
		if (!triggers_to_fire)
			return null;
		for (i = 0, leni = triggers_to_fire.length; i < leni; i++)
		{
			trig = triggers_to_fire[i][0];
			index = triggers_to_fire[i][1];
			ret2 = this.executeSingleTrigger(inst, type_name, trig, index);
			ret = ret || ret2;
		}
		return ret;
	};
	Runtime.prototype.executeSingleTrigger = function (inst, type_name, trig, index)
	{
		var i, leni;
		var ret = false;
		this.trigger_depth++;
		var current_event = this.getCurrentEventStack().current_event;
		if (current_event)
			this.pushCleanSol(current_event.solModifiersIncludingParents);
		var isrecursive = (this.trigger_depth > 1);		// calling trigger from inside another trigger
		this.pushCleanSol(trig.solModifiersIncludingParents);
		if (isrecursive)
			this.pushLocalVarStack();
		var event_stack = this.pushEventStack(trig);
		event_stack.current_event = trig;
		if (inst)
		{
			var sol = this.types[type_name].getCurrentSol();
			sol.select_all = false;
			sol.instances.length = 1;
			sol.instances[0] = inst;
			this.types[type_name].applySolToContainer();
		}
		var ok_to_run = true;
		if (trig.parent)
		{
			var temp_parents_arr = event_stack.temp_parents_arr;
			var cur_parent = trig.parent;
			while (cur_parent)
			{
				temp_parents_arr.push(cur_parent);
				cur_parent = cur_parent.parent;
			}
			temp_parents_arr.reverse();
			for (i = 0, leni = temp_parents_arr.length; i < leni; i++)
			{
				if (!temp_parents_arr[i].run_pretrigger())   // parent event failed
				{
					ok_to_run = false;
					break;
				}
			}
		}
		if (ok_to_run)
		{
			this.execcount++;
			if (trig.orblock)
				trig.run_orblocktrigger(index);
			else
				trig.run();
			ret = ret || event_stack.last_event_true;
		}
		this.popEventStack();
		if (isrecursive)
			this.popLocalVarStack();
		this.popSol(trig.solModifiersIncludingParents);
		if (current_event)
			this.popSol(current_event.solModifiersIncludingParents);
		if (this.isInOnDestroy === 0 && triggerSheetIndex === 0 && !this.isRunningEvents && (!this.deathRow.isEmpty() || this.createRow.length))
		{
			this.ClearDeathRow();
		}
		this.trigger_depth--;
		return ret;
	};
	Runtime.prototype.getCurrentCondition = function ()
	{
		var evinfo = this.getCurrentEventStack();
		return evinfo.current_event.conditions[evinfo.cndindex];
	};
	Runtime.prototype.getCurrentAction = function ()
	{
		var evinfo = this.getCurrentEventStack();
		return evinfo.current_event.actions[evinfo.actindex];
	};
	Runtime.prototype.pushLocalVarStack = function ()
	{
		this.localvar_stack_index++;
		if (this.localvar_stack_index >= this.localvar_stack.length)
			this.localvar_stack.push([]);
	};
	Runtime.prototype.popLocalVarStack = function ()
	{
;
		this.localvar_stack_index--;
	};
	Runtime.prototype.getCurrentLocalVarStack = function ()
	{
		return this.localvar_stack[this.localvar_stack_index];
	};
	Runtime.prototype.pushEventStack = function (cur_event)
	{
		this.event_stack_index++;
		if (this.event_stack_index >= this.event_stack.length)
			this.event_stack.push(new cr.eventStackFrame());
		var ret = this.getCurrentEventStack();
		ret.reset(cur_event);
		return ret;
	};
	Runtime.prototype.popEventStack = function ()
	{
;
		this.event_stack_index--;
	};
	Runtime.prototype.getCurrentEventStack = function ()
	{
		return this.event_stack[this.event_stack_index];
	};
	Runtime.prototype.pushLoopStack = function (name_)
	{
		this.loop_stack_index++;
		if (this.loop_stack_index >= this.loop_stack.length)
		{
			this.loop_stack.push(cr.seal({ name: name_, index: 0, stopped: false }));
		}
		var ret = this.getCurrentLoop();
		ret.name = name_;
		ret.index = 0;
		ret.stopped = false;
		return ret;
	};
	Runtime.prototype.popLoopStack = function ()
	{
;
		this.loop_stack_index--;
	};
	Runtime.prototype.getCurrentLoop = function ()
	{
		return this.loop_stack[this.loop_stack_index];
	};
	Runtime.prototype.getEventVariableByName = function (name, scope)
	{
		var i, leni, j, lenj, sheet, e;
		while (scope)
		{
			for (i = 0, leni = scope.subevents.length; i < leni; i++)
			{
				e = scope.subevents[i];
				if (e instanceof cr.eventvariable && cr.equals_nocase(name, e.name))
					return e;
			}
			scope = scope.parent;
		}
		for (i = 0, leni = this.eventsheets_by_index.length; i < leni; i++)
		{
			sheet = this.eventsheets_by_index[i];
			for (j = 0, lenj = sheet.events.length; j < lenj; j++)
			{
				e = sheet.events[j];
				if (e instanceof cr.eventvariable && cr.equals_nocase(name, e.name))
					return e;
			}
		}
		return null;
	};
	Runtime.prototype.getLayoutBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			if (this.layouts_by_index[i].sid === sid_)
				return this.layouts_by_index[i];
		}
		return null;
	};
	Runtime.prototype.getObjectTypeBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			if (this.types_by_index[i].sid === sid_)
				return this.types_by_index[i];
		}
		return null;
	};
	Runtime.prototype.getGroupBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.allGroups.length; i < len; i++)
		{
			if (this.allGroups[i].sid === sid_)
				return this.allGroups[i];
		}
		return null;
	};
	function makeSaveDb(e)
	{
		var db = e.target.result;
		db.createObjectStore("saves", { keyPath: "slot" });
	};
	function IndexedDB_WriteSlot(slot_, data_, oncomplete_, onerror_)
	{
		var request = indexedDB.open("_C2SaveStates");
		request.onupgradeneeded = makeSaveDb;
		request.onerror = onerror_;
		request.onsuccess = function (e)
		{
			var db = e.target.result;
			db.onerror = onerror_;
			var transaction = db.transaction(["saves"], "readwrite");
			var objectStore = transaction.objectStore("saves");
			var putReq = objectStore.put({"slot": slot_, "data": data_ });
			putReq.onsuccess = oncomplete_;
		};
	};
	function IndexedDB_ReadSlot(slot_, oncomplete_, onerror_)
	{
		var request = indexedDB.open("_C2SaveStates");
		request.onupgradeneeded = makeSaveDb;
		request.onerror = onerror_;
		request.onsuccess = function (e)
		{
			var db = e.target.result;
			db.onerror = onerror_;
			var transaction = db.transaction(["saves"]);
			var objectStore = transaction.objectStore("saves");
			var readReq = objectStore.get(slot_);
			readReq.onsuccess = function (e)
			{
				if (readReq.result)
					oncomplete_(readReq.result["data"]);
				else
					oncomplete_(null);
			};
		};
	};
	Runtime.prototype.signalContinuousPreview = function ()
	{
		this.signalledContinuousPreview = true;
	};
	function doContinuousPreviewReload()
	{
		cr.logexport("Reloading for continuous preview");
		if (!!window["c2cocoonjs"])
		{
			CocoonJS["App"]["reload"]();
		}
		else
		{
			if (window.location.search.indexOf("continuous") > -1)
				window.location.reload(true);
			else
				window.location = window.location + "?continuous";
		}
	};
	Runtime.prototype.handleSaveLoad = function ()
	{
		var self = this;
		var savingToSlot = this.saveToSlot;
		var savingJson = this.lastSaveJson;
		var loadingFromSlot = this.loadFromSlot;
		var continuous = false;
		if (this.signalledContinuousPreview)
		{
			continuous = true;
			savingToSlot = "__c2_continuouspreview";
			this.signalledContinuousPreview = false;
		}
		if (savingToSlot.length)
		{
			this.ClearDeathRow();
			savingJson = this.saveToJSONString();
			if (window.indexedDB && !this.isCocoonJs)
			{
				IndexedDB_WriteSlot(savingToSlot, savingJson, function ()
				{
					cr.logexport("Saved state to IndexedDB storage (" + savingJson.length + " bytes)");
					self.lastSaveJson = savingJson;
					self.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
					self.lastSaveJson = "";
					if (continuous)
						doContinuousPreviewReload();
				}, function (e)
				{
					try {
						localStorage.setItem("__c2save_" + savingToSlot, savingJson);
						cr.logexport("Saved state to WebStorage (" + savingJson.length + " bytes)");
						self.lastSaveJson = savingJson;
						self.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
						self.lastSaveJson = "";
						if (continuous)
							doContinuousPreviewReload();
					}
					catch (f)
					{
						cr.logexport("Failed to save game state: " + e + "; " + f);
					}
				});
			}
			else
			{
				try {
					localStorage.setItem("__c2save_" + savingToSlot, savingJson);
					cr.logexport("Saved state to WebStorage (" + savingJson.length + " bytes)");
					self.lastSaveJson = savingJson;
					this.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
					self.lastSaveJson = "";
					if (continuous)
						doContinuousPreviewReload();
				}
				catch (e)
				{
					cr.logexport("Error saving to WebStorage: " + e);
				}
			}
			this.saveToSlot = "";
			this.loadFromSlot = "";
			this.loadFromJson = "";
		}
		if (loadingFromSlot.length)
		{
			if (window.indexedDB && !this.isCocoonJs)
			{
				IndexedDB_ReadSlot(loadingFromSlot, function (result_)
				{
					if (result_)
					{
						self.loadFromJson = result_;
						cr.logexport("Loaded state from IndexedDB storage (" + self.loadFromJson.length + " bytes)");
					}
					else
					{
						self.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
						cr.logexport("Loaded state from WebStorage (" + self.loadFromJson.length + " bytes)");
					}
					self.suspendDrawing = false;
					if (!self.loadFromJson.length)
						self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
				}, function (e)
				{
					self.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
					cr.logexport("Loaded state from WebStorage (" + self.loadFromJson.length + " bytes)");
					self.suspendDrawing = false;
					if (!self.loadFromJson.length)
						self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
				});
			}
			else
			{
				this.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
				cr.logexport("Loaded state from WebStorage (" + this.loadFromJson.length + " bytes)");
				this.suspendDrawing = false;
				if (!self.loadFromJson.length)
					self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
			}
			this.loadFromSlot = "";
			this.saveToSlot = "";
		}
		if (this.loadFromJson.length)
		{
			this.ClearDeathRow();
			this.loadFromJSONString(this.loadFromJson);
			this.lastSaveJson = this.loadFromJson;
			this.trigger(cr.system_object.prototype.cnds.OnLoadComplete, null);
			this.lastSaveJson = "";
			this.loadFromJson = "";
		}
	};
	function CopyExtraObject(extra)
	{
		var p, ret = {};
		for (p in extra)
		{
			if (extra.hasOwnProperty(p))
			{
				if (extra[p] instanceof cr.ObjectSet)
					continue;
				if (extra[p] && typeof extra[p].c2userdata !== "undefined")
					continue;
				ret[p] = extra[p];
			}
		}
		return ret;
	};
	Runtime.prototype.saveToJSONString = function()
	{
		var i, len, j, lenj, type, layout, typeobj, g, c, a, v, p;
		var o = {
			"c2save":				true,
			"version":				1,
			"rt": {
				"time":				this.kahanTime.sum,
				"timescale":		this.timescale,
				"tickcount":		this.tickcount,
				"execcount":		this.execcount,
				"next_uid":			this.next_uid,
				"running_layout":	this.running_layout.sid,
				"start_time_offset": (Date.now() - this.start_time)
			},
			"types": {},
			"layouts": {},
			"events": {
				"groups": {},
				"cnds": {},
				"acts": {},
				"vars": {}
			}
		};
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || this.typeHasNoSaveBehavior(type))
				continue;
			typeobj = {
				"instances": []
			};
			if (cr.hasAnyOwnProperty(type.extra))
				typeobj["ex"] = CopyExtraObject(type.extra);
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				typeobj["instances"].push(this.saveInstanceToJSON(type.instances[j]));
			}
			o["types"][type.sid.toString()] = typeobj;
		}
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			layout = this.layouts_by_index[i];
			o["layouts"][layout.sid.toString()] = layout.saveToJSON();
		}
		var ogroups = o["events"]["groups"];
		for (i = 0, len = this.allGroups.length; i < len; i++)
		{
			g = this.allGroups[i];
			ogroups[g.sid.toString()] = this.groups_by_name[g.group_name].group_active;
		}
		var ocnds = o["events"]["cnds"];
		for (p in this.cndsBySid)
		{
			if (this.cndsBySid.hasOwnProperty(p))
			{
				c = this.cndsBySid[p];
				if (cr.hasAnyOwnProperty(c.extra))
					ocnds[p] = { "ex": CopyExtraObject(c.extra) };
			}
		}
		var oacts = o["events"]["acts"];
		for (p in this.actsBySid)
		{
			if (this.actsBySid.hasOwnProperty(p))
			{
				a = this.actsBySid[p];
				if (cr.hasAnyOwnProperty(a.extra))
					oacts[p] = { "ex": a.extra };
			}
		}
		var ovars = o["events"]["vars"];
		for (p in this.varsBySid)
		{
			if (this.varsBySid.hasOwnProperty(p))
			{
				v = this.varsBySid[p];
				if (!v.is_constant && (!v.parent || v.is_static))
					ovars[p] = v.data;
			}
		}
		o["system"] = this.system.saveToJSON();
		return JSON.stringify(o);
	};
	Runtime.prototype.refreshUidMap = function ()
	{
		var i, len, type, j, lenj, inst;
		this.objectsByUid = {};
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				this.objectsByUid[inst.uid.toString()] = inst;
			}
		}
	};
	Runtime.prototype.loadFromJSONString = function (str)
	{
		var o = JSON.parse(str);
		if (!o["c2save"])
			return;		// probably not a c2 save state
		if (o["version"] > 1)
			return;		// from future version of c2; assume not compatible
		var rt = o["rt"];
		this.kahanTime.reset();
		this.kahanTime.sum = rt["time"];
		this.timescale = rt["timescale"];
		this.tickcount = rt["tickcount"];
		this.start_time = Date.now() - rt["start_time_offset"];
		var layout_sid = rt["running_layout"];
		if (layout_sid !== this.running_layout.sid)
		{
			var changeToLayout = this.getLayoutBySid(layout_sid);
			if (changeToLayout)
				this.doChangeLayout(changeToLayout);
			else
				return;		// layout that was saved on has gone missing (deleted?)
		}
		this.isLoadingState = true;
		var i, len, j, lenj, k, lenk, p, type, existing_insts, load_insts, inst, binst, layout, layer, g, iid, t;
		var otypes = o["types"];
		for (p in otypes)
		{
			if (otypes.hasOwnProperty(p))
			{
				type = this.getObjectTypeBySid(parseInt(p, 10));
				if (!type || type.is_family || this.typeHasNoSaveBehavior(type))
					continue;
				if (otypes[p]["ex"])
					type.extra = otypes[p]["ex"];
				else
					cr.wipe(type.extra);
				existing_insts = type.instances;
				load_insts = otypes[p]["instances"];
				for (i = 0, len = cr.min(existing_insts.length, load_insts.length); i < len; i++)
				{
					this.loadInstanceFromJSON(existing_insts[i], load_insts[i]);
				}
				for (i = load_insts.length, len = existing_insts.length; i < len; i++)
					this.DestroyInstance(existing_insts[i]);
				for (i = existing_insts.length, len = load_insts.length; i < len; i++)
				{
					layer = null;
					if (type.plugin.is_world)
					{
						layer = this.running_layout.getLayerBySid(load_insts[i]["w"]["l"]);
						if (!layer)
							continue;
					}
					inst = this.createInstanceFromInit(type.default_instance, layer, false, 0, 0, true);
					this.loadInstanceFromJSON(inst, load_insts[i]);
				}
				type.stale_iids = true;
			}
		}
		this.ClearDeathRow();
		this.refreshUidMap();
		var olayouts = o["layouts"];
		for (p in olayouts)
		{
			if (olayouts.hasOwnProperty(p))
			{
				layout = this.getLayoutBySid(parseInt(p, 10));
				if (!layout)
					continue;		// must've gone missing
				layout.loadFromJSON(olayouts[p]);
			}
		}
		var ogroups = o["events"]["groups"];
		for (p in ogroups)
		{
			if (ogroups.hasOwnProperty(p))
			{
				g = this.getGroupBySid(parseInt(p, 10));
				if (g && this.groups_by_name[g.group_name])
					this.groups_by_name[g.group_name].group_active = ogroups[p];
			}
		}
		var ocnds = o["events"]["cnds"];
		for (p in ocnds)
		{
			if (ocnds.hasOwnProperty(p) && this.cndsBySid.hasOwnProperty(p))
			{
				this.cndsBySid[p].extra = ocnds[p]["ex"];
			}
		}
		var oacts = o["events"]["acts"];
		for (p in oacts)
		{
			if (oacts.hasOwnProperty(p) && this.actsBySid.hasOwnProperty(p))
			{
				this.actsBySid[p].extra = oacts[p]["ex"];
			}
		}
		var ovars = o["events"]["vars"];
		for (p in ovars)
		{
			if (ovars.hasOwnProperty(p) && this.varsBySid.hasOwnProperty(p))
			{
				this.varsBySid[p].data = ovars[p];
			}
		}
		this.next_uid = rt["next_uid"];
		this.isLoadingState = false;
		this.system.loadFromJSON(o["system"]);
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				if (type.is_contained)
				{
					iid = inst.get_iid();
					inst.siblings.length = 0;
					for (k = 0, lenk = type.container.length; k < lenk; k++)
					{
						t = type.container[k];
						if (type === t)
							continue;
;
						inst.siblings.push(t.instances[iid]);
					}
				}
				if (inst.afterLoad)
					inst.afterLoad();
				if (inst.behavior_insts)
				{
					for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
					{
						binst = inst.behavior_insts[k];
						if (binst.afterLoad)
							binst.afterLoad();
					}
				}
			}
		}
		this.redraw = true;
	};
	Runtime.prototype.saveInstanceToJSON = function(inst, state_only)
	{
		var i, len, world, behinst, et;
		var type = inst.type;
		var plugin = type.plugin;
		var o = {};
		if (state_only)
			o["c2"] = true;		// mark as known json data from Construct 2
		else
			o["uid"] = inst.uid;
		if (cr.hasAnyOwnProperty(inst.extra))
			o["ex"] = CopyExtraObject(inst.extra);
		if (inst.instance_vars && inst.instance_vars.length)
		{
			o["ivs"] = {};
			for (i = 0, len = inst.instance_vars.length; i < len; i++)
			{
				o["ivs"][inst.type.instvar_sids[i].toString()] = inst.instance_vars[i];
			}
		}
		if (plugin.is_world)
		{
			world = {
				"x": inst.x,
				"y": inst.y,
				"w": inst.width,
				"h": inst.height,
				"l": inst.layer.sid,
				"zi": inst.get_zindex()
			};
			if (inst.angle !== 0)
				world["a"] = inst.angle;
			if (inst.opacity !== 1)
				world["o"] = inst.opacity;
			if (inst.hotspotX !== 0.5)
				world["hX"] = inst.hotspotX;
			if (inst.hotspotY !== 0.5)
				world["hY"] = inst.hotspotY;
			if (inst.blend_mode !== 0)
				world["bm"] = inst.blend_mode;
			if (!inst.visible)
				world["v"] = inst.visible;
			if (!inst.collisionsEnabled)
				world["ce"] = inst.collisionsEnabled;
			if (inst.my_timescale !== -1)
				world["mts"] = inst.my_timescale;
			if (type.effect_types.length)
			{
				world["fx"] = [];
				for (i = 0, len = type.effect_types.length; i < len; i++)
				{
					et = type.effect_types[i];
					world["fx"].push({"name": et.name,
									  "active": inst.active_effect_flags[et.index],
									  "params": inst.effect_params[et.index] });
				}
			}
			o["w"] = world;
		}
		if (inst.behavior_insts && inst.behavior_insts.length)
		{
			o["behs"] = {};
			for (i = 0, len = inst.behavior_insts.length; i < len; i++)
			{
				behinst = inst.behavior_insts[i];
				if (behinst.saveToJSON)
					o["behs"][behinst.type.sid.toString()] = behinst.saveToJSON();
			}
		}
		if (inst.saveToJSON)
			o["data"] = inst.saveToJSON();
		return o;
	};
	Runtime.prototype.getInstanceVarIndexBySid = function (type, sid_)
	{
		var i, len;
		for (i = 0, len = type.instvar_sids.length; i < len; i++)
		{
			if (type.instvar_sids[i] === sid_)
				return i;
		}
		return -1;
	};
	Runtime.prototype.getBehaviorIndexBySid = function (inst, sid_)
	{
		var i, len;
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i].type.sid === sid_)
				return i;
		}
		return -1;
	};
	Runtime.prototype.loadInstanceFromJSON = function(inst, o, state_only)
	{
		var p, i, len, iv, oivs, world, fxindex, obehs, behindex;
		var oldlayer;
		var type = inst.type;
		var plugin = type.plugin;
		if (state_only)
		{
			if (!o["c2"])
				return;
		}
		else
			inst.uid = o["uid"];
		if (o["ex"])
			inst.extra = o["ex"];
		else
			cr.wipe(inst.extra);
		oivs = o["ivs"];
		if (oivs)
		{
			for (p in oivs)
			{
				if (oivs.hasOwnProperty(p))
				{
					iv = this.getInstanceVarIndexBySid(type, parseInt(p, 10));
					if (iv < 0 || iv >= inst.instance_vars.length)
						continue;		// must've gone missing
					inst.instance_vars[iv] = oivs[p];
				}
			}
		}
		if (plugin.is_world)
		{
			world = o["w"];
			if (inst.layer.sid !== world["l"])
			{
				oldlayer = inst.layer;
				inst.layer = this.running_layout.getLayerBySid(world["l"]);
				if (inst.layer)
				{
					inst.layer.instances.push(inst);
					inst.layer.zindices_stale = true;
					cr.arrayFindRemove(oldlayer.instances, inst);
					oldlayer.zindices_stale = true;
				}
				else
				{
					inst.layer = oldlayer;
					this.DestroyInstance(inst);
				}
			}
			inst.x = world["x"];
			inst.y = world["y"];
			inst.width = world["w"];
			inst.height = world["h"];
			inst.zindex = world["zi"];
			inst.angle = world.hasOwnProperty("a") ? world["a"] : 0;
			inst.opacity = world.hasOwnProperty("o") ? world["o"] : 1;
			inst.hotspotX = world.hasOwnProperty("hX") ? world["hX"] : 0.5;
			inst.hotspotY = world.hasOwnProperty("hY") ? world["hY"] : 0.5;
			inst.visible = world.hasOwnProperty("v") ? world["v"] : true;
			inst.collisionsEnabled = world.hasOwnProperty("ce") ? world["ce"] : true;
			inst.my_timescale = world.hasOwnProperty("mts") ? world["mts"] : -1;
			inst.blend_mode = world.hasOwnProperty("bm") ? world["bm"] : 0;;
			inst.compositeOp = cr.effectToCompositeOp(inst.blend_mode);
			if (this.gl)
				cr.setGLBlend(inst, inst.blend_mode, this.gl);
			inst.set_bbox_changed();
			if (world.hasOwnProperty("fx"))
			{
				for (i = 0, len = world["fx"].length; i < len; i++)
				{
					fxindex = type.getEffectIndexByName(world["fx"][i]["name"]);
					if (fxindex < 0)
						continue;		// must've gone missing
					inst.active_effect_flags[fxindex] = world["fx"][i]["active"];
					inst.effect_params[fxindex] = world["fx"][i]["params"];
				}
			}
			inst.updateActiveEffects();
		}
		obehs = o["behs"];
		if (obehs)
		{
			for (p in obehs)
			{
				if (obehs.hasOwnProperty(p))
				{
					behindex = this.getBehaviorIndexBySid(inst, parseInt(p, 10));
					if (behindex < 0)
						continue;		// must've gone missing
					inst.behavior_insts[behindex].loadFromJSON(obehs[p]);
				}
			}
		}
		if (o["data"])
			inst.loadFromJSON(o["data"]);
	};
	cr.runtime = Runtime;
	cr.createRuntime = function (canvasid)
	{
		return new Runtime(document.getElementById(canvasid));
	};
	cr.createDCRuntime = function (w, h)
	{
		return new Runtime({ "dc": true, "width": w, "height": h });
	};
	window["cr_createRuntime"] = cr.createRuntime;
	window["cr_createDCRuntime"] = cr.createDCRuntime;
	window["createCocoonJSRuntime"] = function ()
	{
		window["c2cocoonjs"] = true;
		var canvas = document.createElement("screencanvas") || document.createElement("canvas");
		canvas.screencanvas = true;
		document.body.appendChild(canvas);
		var rt = new Runtime(canvas);
		window["c2runtime"] = rt;
		window.addEventListener("orientationchange", function () {
			window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		});
		window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		return rt;
	};
	window["createEjectaRuntime"] = function ()
	{
		var canvas = document.getElementById("canvas");
		var rt = new Runtime(canvas);
		window["c2runtime"] = rt;
		window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		return rt;
	};
}());
window["cr_getC2Runtime"] = function()
{
	var canvas = document.getElementById("c2canvas");
	if (canvas)
		return canvas["c2runtime"];
	else if (window["c2runtime"])
		return window["c2runtime"];
	else
		return null;
}
window["cr_sizeCanvas"] = function(w, h)
{
	if (w === 0 || h === 0)
		return;
	var runtime = window["cr_getC2Runtime"]();
	if (runtime)
		runtime["setSize"](w, h);
}
window["cr_setSuspended"] = function(s)
{
	var runtime = window["cr_getC2Runtime"]();
	if (runtime)
		runtime["setSuspended"](s);
}
;
(function()
{
	function Layout(runtime, m)
	{
		this.runtime = runtime;
		this.event_sheet = null;
		this.scrollX = (this.runtime.original_width / 2);
		this.scrollY = (this.runtime.original_height / 2);
		this.scale = 1.0;
		this.angle = 0;
		this.first_visit = true;
		this.name = m[0];
		this.width = m[1];
		this.height = m[2];
		this.unbounded_scrolling = m[3];
		this.sheetname = m[4];
		this.sid = m[5];
		var lm = m[6];
		var i, len;
		this.layers = [];
		this.initial_types = [];
		for (i = 0, len = lm.length; i < len; i++)
		{
			var layer = new cr.layer(this, lm[i]);
			layer.number = i;
			cr.seal(layer);
			this.layers.push(layer);
		}
		var im = m[7];
		this.initial_nonworld = [];
		for (i = 0, len = im.length; i < len; i++)
		{
			var inst = im[i];
			var type = this.runtime.types_by_index[inst[1]];
;
			if (!type.default_instance)
				type.default_instance = inst;
			this.initial_nonworld.push(inst);
			if (this.initial_types.indexOf(type) === -1)
				this.initial_types.push(type);
		}
		this.effect_types = [];
		this.active_effect_types = [];
		this.effect_params = [];
		for (i = 0, len = m[8].length; i < len; i++)
		{
			this.effect_types.push({
				id: m[8][i][0],
				name: m[8][i][1],
				shaderindex: -1,
				active: true,
				index: i
			});
			this.effect_params.push(m[8][i][2].slice(0));
		}
		this.updateActiveEffects();
		this.rcTex = new cr.rect(0, 0, 1, 1);
		this.rcTex2 = new cr.rect(0, 0, 1, 1);
		this.persist_data = {};
	};
	Layout.prototype.saveObjectToPersist = function (inst)
	{
		var sidStr = inst.type.sid.toString();
		if (!this.persist_data.hasOwnProperty(sidStr))
			this.persist_data[sidStr] = [];
		var type_persist = this.persist_data[sidStr];
		type_persist.push(this.runtime.saveInstanceToJSON(inst));
	};
	Layout.prototype.hasOpaqueBottomLayer = function ()
	{
		var layer = this.layers[0];
		return !layer.transparent && layer.opacity === 1.0 && !layer.forceOwnTexture && layer.visible;
	};
	Layout.prototype.updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.active)
				this.active_effect_types.push(et);
		}
	};
	Layout.prototype.getEffectByName = function (name_)
	{
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.name === name_)
				return et;
		}
		return null;
	};
	var created_instances = [];
	Layout.prototype.startRunning = function ()
	{
		if (this.sheetname)
		{
			this.event_sheet = this.runtime.eventsheets[this.sheetname];
;
			this.event_sheet.updateDeepIncludes();
		}
		this.runtime.running_layout = this;
		this.scrollX = (this.runtime.original_width / 2);
		this.scrollY = (this.runtime.original_height / 2);
		var i, k, len, lenk, type, type_instances, inst, iid, t, s, p, q, type_data, layer;
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			type = this.runtime.types_by_index[i];
			if (type.is_family)
				continue;		// instances are only transferred for their real type
			type_instances = type.instances;
			for (k = 0, lenk = type_instances.length; k < lenk; k++)
			{
				inst = type_instances[k];
				if (inst.layer)
				{
					var num = inst.layer.number;
					if (num >= this.layers.length)
						num = this.layers.length - 1;
					inst.layer = this.layers[num];
					inst.layer.instances.push(inst);
					inst.layer.zindices_stale = true;
				}
			}
		}
		var layer;
		created_instances.length = 0;
		this.boundScrolling();
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			layer = this.layers[i];
			layer.createInitialInstances();		// fills created_instances
			layer.disableAngle = true;
			var px = layer.canvasToLayer(0, 0, true, true);
			var py = layer.canvasToLayer(0, 0, false, true);
			layer.disableAngle = false;
			if (this.runtime.pixel_rounding)
			{
				px = (px + 0.5) | 0;
				py = (py + 0.5) | 0;
			}
			layer.rotateViewport(px, py, null);
		}
		var uids_changed = false;
		if (!this.first_visit)
		{
			for (p in this.persist_data)
			{
				if (this.persist_data.hasOwnProperty(p))
				{
					type = this.runtime.getObjectTypeBySid(parseInt(p, 10));
					if (!type || type.is_family || !this.runtime.typeHasPersistBehavior(type))
						continue;
					type_data = this.persist_data[p];
					for (i = 0, len = type_data.length; i < len; i++)
					{
						layer = null;
						if (type.plugin.is_world)
						{
							layer = this.getLayerBySid(type_data[i]["w"]["l"]);
							if (!layer)
								continue;
						}
						inst = this.runtime.createInstanceFromInit(type.default_instance, layer, false, 0, 0, true);
						this.runtime.loadInstanceFromJSON(inst, type_data[i]);
						uids_changed = true;
						created_instances.push(inst);
					}
					type_data.length = 0;
				}
			}
			for (i = 0, len = this.layers.length; i < len; i++)
			{
				this.layers[i].instances.sort(sortInstanceByZIndex);
				this.layers[i].zindices_stale = true;		// in case of duplicates/holes
			}
		}
		if (uids_changed)
		{
			this.runtime.ClearDeathRow();
			this.runtime.refreshUidMap();
		}
		for (i = 0; i < created_instances.length; i++)
		{
			inst = created_instances[i];
			if (!inst.type.is_contained)
				continue;
			iid = inst.get_iid();
			for (k = 0, lenk = inst.type.container.length; k < lenk; k++)
			{
				t = inst.type.container[k];
				if (inst.type === t)
					continue;
				if (t.instances.length > iid)
					inst.siblings.push(t.instances[iid]);
				else
				{
					if (!t.default_instance)
					{
					}
					else
					{
						s = this.runtime.createInstanceFromInit(t.default_instance, inst.layer, true, inst.x, inst.y, true);
						this.runtime.ClearDeathRow();
						t.updateIIDs();
						inst.siblings.push(s);
						created_instances.push(s);		// come back around and link up its own instances too
					}
				}
			}
		}
		for (i = 0, len = this.initial_nonworld.length; i < len; i++)
		{
			inst = this.runtime.createInstanceFromInit(this.initial_nonworld[i], null, true);
;
		}
		this.runtime.changelayout = null;
		this.runtime.ClearDeathRow();
		if (this.runtime.ctx && !this.runtime.isDomFree)
		{
			for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
			{
				t = this.runtime.types_by_index[i];
				if (t.is_family || !t.instances.length || !t.preloadCanvas2D)
					continue;
				t.preloadCanvas2D(this.runtime.ctx);
			}
		}
		/*
		if (this.runtime.glwrap)
		{
			console.log("Estimated VRAM at layout start: " + this.runtime.glwrap.textureCount() + " textures, approx. " + Math.round(this.runtime.glwrap.estimateVRAM() / 1024) + " kb");
		}
		*/
		for (i = 0, len = created_instances.length; i < len; i++)
		{
			inst = created_instances[i];
			this.runtime.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnCreated, inst);
		}
		created_instances.length = 0;
		this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart, null);
		this.first_visit = false;
	};
	Layout.prototype.createGlobalNonWorlds = function ()
	{
		var i, k, len, initial_inst, inst, type;
		for (i = 0, k = 0, len = this.initial_nonworld.length; i < len; i++)
		{
			initial_inst = this.initial_nonworld[i];
			type = this.runtime.types_by_index[initial_inst[1]];
			if (type.global)
				inst = this.runtime.createInstanceFromInit(initial_inst, null, true);
			else
			{
				this.initial_nonworld[k] = initial_inst;
				k++;
			}
		}
		this.initial_nonworld.length = k;
	};
	Layout.prototype.stopRunning = function ()
	{
;
		/*
		if (this.runtime.glwrap)
		{
			console.log("Estimated VRAM at layout end: " + this.runtime.glwrap.textureCount() + " textures, approx. " + Math.round(this.runtime.glwrap.estimateVRAM() / 1024) + " kb");
		}
		*/
		this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd, null);
		this.runtime.system.waits.length = 0;
		var i, leni, j, lenj;
		var layer_instances, inst, type;
		for (i = 0, leni = this.layers.length; i < leni; i++)
		{
			layer_instances = this.layers[i].instances;
			for (j = 0, lenj = layer_instances.length; j < lenj; j++)
			{
				inst = layer_instances[j];
				if (!inst.type.global)
				{
					if (this.runtime.typeHasPersistBehavior(inst.type))
						this.saveObjectToPersist(inst);
					this.runtime.DestroyInstance(inst);
				}
			}
			this.runtime.ClearDeathRow();
			layer_instances.length = 0;
			this.layers[i].zindices_stale = true;
		}
		for (i = 0, leni = this.runtime.types_by_index.length; i < leni; i++)
		{
			type = this.runtime.types_by_index[i];
			if (type.global || type.plugin.is_world || type.plugin.singleglobal || type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
				this.runtime.DestroyInstance(type.instances[j]);
			this.runtime.ClearDeathRow();
		}
	};
	Layout.prototype.draw = function (ctx)
	{
		var layout_canvas;
		var layout_ctx = ctx;
		var ctx_changed = false;
		var render_offscreen = !this.runtime.fullscreenScalingQuality;
		if (render_offscreen)
		{
			if (!this.runtime.layout_canvas)
			{
				this.runtime.layout_canvas = document.createElement("canvas");
				layout_canvas = this.runtime.layout_canvas;
				layout_canvas.width = this.runtime.draw_width;
				layout_canvas.height = this.runtime.draw_height;
				this.runtime.layout_ctx = layout_canvas.getContext("2d");
				ctx_changed = true;
			}
			layout_canvas = this.runtime.layout_canvas;
			layout_ctx = this.runtime.layout_ctx;
			if (layout_canvas.width !== this.runtime.draw_width)
			{
				layout_canvas.width = this.runtime.draw_width;
				ctx_changed = true;
			}
			if (layout_canvas.height !== this.runtime.draw_height)
			{
				layout_canvas.height = this.runtime.draw_height;
				ctx_changed = true;
			}
			if (ctx_changed)
			{
				layout_ctx["webkitImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["mozImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["msImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["imageSmoothingEnabled"] = this.runtime.linearSampling;
			}
		}
		layout_ctx.globalAlpha = 1;
		layout_ctx.globalCompositeOperation = "source-over";
		if (this.runtime.alphaBackground && !this.hasOpaqueBottomLayer())
			layout_ctx.clearRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		var i, len, l;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			l = this.layers[i];
			if (l.visible && l.opacity > 0 && l.blend_mode !== 11)
				l.draw(layout_ctx);
		}
		if (render_offscreen)
		{
			ctx.drawImage(layout_canvas, 0, 0, this.runtime.width, this.runtime.height);
		}
	};
	Layout.prototype.drawGL = function (glw)
	{
		var render_to_texture = (this.active_effect_types.length > 0 ||
								 this.runtime.uses_background_blending ||
								 !this.runtime.fullscreenScalingQuality);
		if (render_to_texture)
		{
			if (!this.runtime.layout_tex)
			{
				this.runtime.layout_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			if (this.runtime.layout_tex.c2width !== this.runtime.draw_width || this.runtime.layout_tex.c2height !== this.runtime.draw_height)
			{
				glw.deleteTexture(this.runtime.layout_tex);
				this.runtime.layout_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			glw.setRenderingToTexture(this.runtime.layout_tex);
			if (!this.runtime.fullscreenScalingQuality)
			{
				glw.setSize(this.runtime.draw_width, this.runtime.draw_height);
			}
		}
		else
		{
			if (this.runtime.layout_tex)
			{
				glw.setRenderingToTexture(null);
				glw.deleteTexture(this.runtime.layout_tex);
				this.runtime.layout_tex = null;
			}
		}
		if (this.runtime.alphaBackground && !this.hasOpaqueBottomLayer())
			glw.clear(0, 0, 0, 0);
		var i, len;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			if (this.layers[i].visible && this.layers[i].opacity > 0)
				this.layers[i].drawGL(glw);
		}
		if (render_to_texture)
		{
			if (this.active_effect_types.length === 0 ||
				(this.active_effect_types.length === 1 && this.runtime.fullscreenScalingQuality))
			{
				if (this.active_effect_types.length === 1)
				{
					var etindex = this.active_effect_types[0].index;
					glw.switchProgram(this.active_effect_types[0].shaderindex);
					glw.setProgramParameters(null,								// backTex
											 1.0 / this.runtime.draw_width,		// pixelWidth
											 1.0 / this.runtime.draw_height,	// pixelHeight
											 0.0, 0.0,							// destStart
											 1.0, 1.0,							// destEnd
											 this.scale,						// layerScale
											 this.angle,						// layerAngle
											 0.0, 0.0,							// viewOrigin
											 this.effect_params[etindex]);		// fx parameters
					if (glw.programIsAnimated(this.active_effect_types[0].shaderindex))
						this.runtime.redraw = true;
				}
				else
					glw.switchProgram(0);
				if (!this.runtime.fullscreenScalingQuality)
				{
					glw.setSize(this.runtime.width, this.runtime.height);
				}
				glw.setRenderingToTexture(null);				// to backbuffer
				glw.setOpacity(1);
				glw.setTexture(this.runtime.layout_tex);
				glw.setAlphaBlend();
				glw.resetModelView();
				glw.updateModelView();
				var halfw = this.runtime.width / 2;
				var halfh = this.runtime.height / 2;
				glw.quad(-halfw, halfh, halfw, halfh, halfw, -halfh, -halfw, -halfh);
				glw.setTexture(null);
			}
			else
			{
				this.renderEffectChain(glw, null, null, null);
			}
		}
	};
	Layout.prototype.getRenderTarget = function()
	{
		return (this.active_effect_types.length > 0 ||
				this.runtime.uses_background_blending ||
				!this.runtime.fullscreenScalingQuality) ? this.runtime.layout_tex : null;
	};
	Layout.prototype.getMinLayerScale = function ()
	{
		var m = this.layers[0].getScale();
		var i, len, l;
		for (i = 1, len = this.layers.length; i < len; i++)
		{
			l = this.layers[i];
			if (l.parallaxX === 0 && l.parallaxY === 0)
				continue;
			if (l.getScale() < m)
				m = l.getScale();
		}
		return m;
	};
	Layout.prototype.scrollToX = function (x)
	{
		if (!this.unbounded_scrolling)
		{
			var widthBoundary = (this.runtime.draw_width * (1 / this.getMinLayerScale()) / 2);
			if (x > this.width - widthBoundary)
				x = this.width - widthBoundary;
			if (x < widthBoundary)
				x = widthBoundary;
		}
		if (this.scrollX !== x)
		{
			this.scrollX = x;
			this.runtime.redraw = true;
		}
	};
	Layout.prototype.scrollToY = function (y)
	{
		if (!this.unbounded_scrolling)
		{
			var heightBoundary = (this.runtime.draw_height * (1 / this.getMinLayerScale()) / 2);
			if (y > this.height - heightBoundary)
				y = this.height - heightBoundary;
			if (y < heightBoundary)
				y = heightBoundary;
		}
		if (this.scrollY !== y)
		{
			this.scrollY = y;
			this.runtime.redraw = true;
		}
	};
	Layout.prototype.boundScrolling = function ()
	{
		this.scrollToX(this.scrollX);
		this.scrollToY(this.scrollY);
	};
	Layout.prototype.renderEffectChain = function (glw, layer, inst, rendertarget)
	{
		var active_effect_types = inst ?
							inst.active_effect_types :
							layer ?
								layer.active_effect_types :
								this.active_effect_types;
		var layerScale = 1, layerAngle = 0, viewOriginLeft = 0, viewOriginTop = 0;
		if (inst)
		{
			layerScale = inst.layer.getScale();
			layerAngle = inst.layer.getAngle();
			viewOriginLeft = inst.layer.viewLeft;
			viewOriginTop = inst.layer.viewTop;
		}
		else if (layer)
		{
			layerScale = layer.getScale();
			layerAngle = layer.getAngle();
			viewOriginLeft = layer.viewLeft;
			viewOriginTop = layer.viewTop;
		}
		var fx_tex = this.runtime.fx_tex;
		var i, len, last, temp, fx_index = 0, other_fx_index = 1;
		var y, h;
		var windowWidth = this.runtime.draw_width;
		var windowHeight = this.runtime.draw_height;
		var halfw = windowWidth / 2;
		var halfh = windowHeight / 2;
		var rcTex = layer ? layer.rcTex : this.rcTex;
		var rcTex2 = layer ? layer.rcTex2 : this.rcTex2;
		var screenleft = 0, clearleft = 0;
		var screentop = 0, cleartop = 0;
		var screenright = windowWidth, clearright = windowWidth;
		var screenbottom = windowHeight, clearbottom = windowHeight;
		var boxExtendHorizontal = 0;
		var boxExtendVertical = 0;
		var inst_layer_angle = inst ? inst.layer.getAngle() : 0;
		if (inst)
		{
			for (i = 0, len = active_effect_types.length; i < len; i++)
			{
				boxExtendHorizontal += glw.getProgramBoxExtendHorizontal(active_effect_types[i].shaderindex);
				boxExtendVertical += glw.getProgramBoxExtendVertical(active_effect_types[i].shaderindex);
			}
			var bbox = inst.bbox;
			screenleft = layer.layerToCanvas(bbox.left, bbox.top, true, true);
			screentop = layer.layerToCanvas(bbox.left, bbox.top, false, true);
			screenright = layer.layerToCanvas(bbox.right, bbox.bottom, true, true);
			screenbottom = layer.layerToCanvas(bbox.right, bbox.bottom, false, true);
			if (inst_layer_angle !== 0)
			{
				var screentrx = layer.layerToCanvas(bbox.right, bbox.top, true, true);
				var screentry = layer.layerToCanvas(bbox.right, bbox.top, false, true);
				var screenblx = layer.layerToCanvas(bbox.left, bbox.bottom, true, true);
				var screenbly = layer.layerToCanvas(bbox.left, bbox.bottom, false, true);
				temp = Math.min(screenleft, screenright, screentrx, screenblx);
				screenright = Math.max(screenleft, screenright, screentrx, screenblx);
				screenleft = temp;
				temp = Math.min(screentop, screenbottom, screentry, screenbly);
				screenbottom = Math.max(screentop, screenbottom, screentry, screenbly);
				screentop = temp;
			}
			screenleft -= boxExtendHorizontal;
			screentop -= boxExtendVertical;
			screenright += boxExtendHorizontal;
			screenbottom += boxExtendVertical;
			rcTex2.left = screenleft / windowWidth;
			rcTex2.top = 1 - screentop / windowHeight;
			rcTex2.right = screenright / windowWidth;
			rcTex2.bottom = 1 - screenbottom / windowHeight;
			clearleft = screenleft = cr.floor(screenleft);
			cleartop = screentop = cr.floor(screentop);
			clearright = screenright = cr.ceil(screenright);
			clearbottom = screenbottom = cr.ceil(screenbottom);
			clearleft -= boxExtendHorizontal;
			cleartop -= boxExtendVertical;
			clearright += boxExtendHorizontal;
			clearbottom += boxExtendVertical;
			if (screenleft < 0)					screenleft = 0;
			if (screentop < 0)					screentop = 0;
			if (screenright > windowWidth)		screenright = windowWidth;
			if (screenbottom > windowHeight)	screenbottom = windowHeight;
			if (clearleft < 0)					clearleft = 0;
			if (cleartop < 0)					cleartop = 0;
			if (clearright > windowWidth)		clearright = windowWidth;
			if (clearbottom > windowHeight)		clearbottom = windowHeight;
			rcTex.left = screenleft / windowWidth;
			rcTex.top = 1 - screentop / windowHeight;
			rcTex.right = screenright / windowWidth;
			rcTex.bottom = 1 - screenbottom / windowHeight;
		}
		else
		{
			rcTex.left = rcTex2.left = 0;
			rcTex.top = rcTex2.top = 0;
			rcTex.right = rcTex2.right = 1;
			rcTex.bottom = rcTex2.bottom = 1;
		}
		var pre_draw = (inst && (((inst.angle || inst_layer_angle) && glw.programUsesDest(active_effect_types[0].shaderindex)) || boxExtendHorizontal !== 0 || boxExtendVertical !== 0 || inst.opacity !== 1 || inst.type.plugin.must_predraw)) || (layer && !inst && layer.opacity !== 1);
		glw.setAlphaBlend();
		if (pre_draw)
		{
			if (!fx_tex[fx_index])
			{
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			if (fx_tex[fx_index].c2width !== windowWidth || fx_tex[fx_index].c2height !== windowHeight)
			{
				glw.deleteTexture(fx_tex[fx_index]);
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			glw.switchProgram(0);
			glw.setRenderingToTexture(fx_tex[fx_index]);
			h = clearbottom - cleartop;
			y = (windowHeight - cleartop) - h;
			glw.clearRect(clearleft, y, clearright - clearleft, h);
			if (inst)
			{
				inst.drawGL(glw);
			}
			else
			{
				glw.setTexture(this.runtime.layer_tex);
				glw.setOpacity(layer.opacity);
				glw.resetModelView();
				glw.translate(-halfw, -halfh);
				glw.updateModelView();
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
			}
			rcTex2.left = rcTex2.top = 0;
			rcTex2.right = rcTex2.bottom = 1;
			if (inst)
			{
				temp = rcTex.top;
				rcTex.top = rcTex.bottom;
				rcTex.bottom = temp;
			}
			fx_index = 1;
			other_fx_index = 0;
		}
		glw.setOpacity(1);
		var last = active_effect_types.length - 1;
		var post_draw = glw.programUsesCrossSampling(active_effect_types[last].shaderindex) ||
						(!layer && !inst && !this.runtime.fullscreenScalingQuality);
		var etindex = 0;
		for (i = 0, len = active_effect_types.length; i < len; i++)
		{
			if (!fx_tex[fx_index])
			{
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			if (fx_tex[fx_index].c2width !== windowWidth || fx_tex[fx_index].c2height !== windowHeight)
			{
				glw.deleteTexture(fx_tex[fx_index]);
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			glw.switchProgram(active_effect_types[i].shaderindex);
			etindex = active_effect_types[i].index;
			if (glw.programIsAnimated(active_effect_types[i].shaderindex))
				this.runtime.redraw = true;
			if (i == 0 && !pre_draw)
			{
				glw.setRenderingToTexture(fx_tex[fx_index]);
				h = clearbottom - cleartop;
				y = (windowHeight - cleartop) - h;
				glw.clearRect(clearleft, y, clearright - clearleft, h);
				if (inst)
				{
					glw.setProgramParameters(rendertarget,					// backTex
											 1.0 / inst.width,				// pixelWidth
											 1.0 / inst.height,				// pixelHeight
											 rcTex2.left, rcTex2.top,		// destStart
											 rcTex2.right, rcTex2.bottom,	// destEnd
											 layerScale,
											 layerAngle,
											 viewOriginLeft, viewOriginTop,
											 inst.effect_params[etindex]);	// fx params
					inst.drawGL(glw);
				}
				else
				{
					glw.setProgramParameters(rendertarget,					// backTex
											 1.0 / windowWidth,				// pixelWidth
											 1.0 / windowHeight,			// pixelHeight
											 0.0, 0.0,						// destStart
											 1.0, 1.0,						// destEnd
											 layerScale,
											 layerAngle,
											 viewOriginLeft, viewOriginTop,
											 layer ?						// fx params
												layer.effect_params[etindex] :
												this.effect_params[etindex]);
					glw.setTexture(layer ? this.runtime.layer_tex : this.runtime.layout_tex);
					glw.resetModelView();
					glw.translate(-halfw, -halfh);
					glw.updateModelView();
					glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
				}
				rcTex2.left = rcTex2.top = 0;
				rcTex2.right = rcTex2.bottom = 1;
				if (inst && !post_draw)
				{
					temp = screenbottom;
					screenbottom = screentop;
					screentop = temp;
				}
			}
			else
			{
				glw.setProgramParameters(rendertarget,						// backTex
										 1.0 / windowWidth,					// pixelWidth
										 1.0 / windowHeight,				// pixelHeight
										 rcTex2.left, rcTex2.top,			// destStart
										 rcTex2.right, rcTex2.bottom,		// destEnd
										 layerScale,
										 layerAngle,
										 viewOriginLeft, viewOriginTop,
										 inst ?								// fx params
											inst.effect_params[etindex] :
											layer ?
												layer.effect_params[etindex] :
												this.effect_params[etindex]);
				glw.setTexture(null);
				if (i === last && !post_draw)
				{
					if (inst)
						glw.setBlend(inst.srcBlend, inst.destBlend);
					else if (layer)
						glw.setBlend(layer.srcBlend, layer.destBlend);
					glw.setRenderingToTexture(rendertarget);
				}
				else
				{
					glw.setRenderingToTexture(fx_tex[fx_index]);
					h = clearbottom - cleartop;
					y = (windowHeight - cleartop) - h;
					glw.clearRect(clearleft, y, clearright - clearleft, h);
				}
				glw.setTexture(fx_tex[other_fx_index]);
				glw.resetModelView();
				glw.translate(-halfw, -halfh);
				glw.updateModelView();
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
				if (i === last && !post_draw)
					glw.setTexture(null);
			}
			fx_index = (fx_index === 0 ? 1 : 0);
			other_fx_index = (fx_index === 0 ? 1 : 0);		// will be opposite to fx_index since it was just assigned
		}
		if (post_draw)
		{
			glw.switchProgram(0);
			if (inst)
				glw.setBlend(inst.srcBlend, inst.destBlend);
			else if (layer)
				glw.setBlend(layer.srcBlend, layer.destBlend);
			else
			{
				if (!this.runtime.fullscreenScalingQuality)
				{
					glw.setSize(this.runtime.width, this.runtime.height);
					halfw = this.runtime.width / 2;
					halfh = this.runtime.height / 2;
					screenleft = 0;
					screentop = 0;
					screenright = this.runtime.width;
					screenbottom = this.runtime.height;
				}
			}
			glw.setRenderingToTexture(rendertarget);
			glw.setTexture(fx_tex[other_fx_index]);
			glw.resetModelView();
			glw.translate(-halfw, -halfh);
			glw.updateModelView();
			if (inst && active_effect_types.length === 1 && !pre_draw)
				glw.quadTex(screenleft, screentop, screenright, screentop, screenright, screenbottom, screenleft, screenbottom, rcTex);
			else
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
			glw.setTexture(null);
		}
	};
	Layout.prototype.getLayerBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			if (this.layers[i].sid === sid_)
				return this.layers[i];
		}
		return null;
	};
	Layout.prototype.saveToJSON = function ()
	{
		var i, len, layer, et;
		var o = {
			"sx": this.scrollX,
			"sy": this.scrollY,
			"s": this.scale,
			"a": this.angle,
			"w": this.width,
			"h": this.height,
			"fv": this.first_visit,			// added r127
			"persist": this.persist_data,
			"fx": [],
			"layers": {}
		};
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			o["fx"].push({"name": et.name, "active": et.active, "params": this.effect_params[et.index] });
		}
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			layer = this.layers[i];
			o["layers"][layer.sid.toString()] = layer.saveToJSON();
		}
		return o;
	};
	Layout.prototype.loadFromJSON = function (o)
	{
		var i, len, fx, p, layer;
		this.scrollX = o["sx"];
		this.scrollY = o["sy"];
		this.scale = o["s"];
		this.angle = o["a"];
		this.width = o["w"];
		this.height = o["h"];
		this.persist_data = o["persist"];
		if (typeof o["fv"] !== "undefined")
			this.first_visit = o["fv"];
		var ofx = o["fx"];
		for (i = 0, len = ofx.length; i < len; i++)
		{
			fx = this.getEffectByName(ofx[i]["name"]);
			if (!fx)
				continue;		// must've gone missing
			fx.active = ofx[i]["active"];
			this.effect_params[fx.index] = ofx[i]["params"];
		}
		this.updateActiveEffects();
		var olayers = o["layers"];
		for (p in olayers)
		{
			if (olayers.hasOwnProperty(p))
			{
				layer = this.getLayerBySid(parseInt(p, 10));
				if (!layer)
					continue;		// must've gone missing
				layer.loadFromJSON(olayers[p]);
			}
		}
	};
	cr.layout = Layout;
	function Layer(layout, m)
	{
		this.layout = layout;
		this.runtime = layout.runtime;
		this.instances = [];        // running instances
		this.scale = 1.0;
		this.angle = 0;
		this.disableAngle = false;
		this.tmprect = new cr.rect(0, 0, 0, 0);
		this.tmpquad = new cr.quad();
		this.viewLeft = 0;
		this.viewRight = 0;
		this.viewTop = 0;
		this.viewBottom = 0;
		this.zindices_stale = false;
		this.name = m[0];
		this.index = m[1];
		this.sid = m[2];
		this.visible = m[3];		// initially visible
		this.background_color = m[4];
		this.transparent = m[5];
		this.parallaxX = m[6];
		this.parallaxY = m[7];
		this.opacity = m[8];
		this.forceOwnTexture = m[9];
		this.zoomRate = m[10];
		this.blend_mode = m[11];
		this.effect_fallback = m[12];
		this.compositeOp = "source-over";
		this.srcBlend = 0;
		this.destBlend = 0;
		this.render_offscreen = false;
		var im = m[13];
		var i, len;
		this.initial_instances = [];
		for (i = 0, len = im.length; i < len; i++)
		{
			var inst = im[i];
			var type = this.runtime.types_by_index[inst[1]];
;
			if (!type.default_instance)
			{
				type.default_instance = inst;
				type.default_layerindex = this.index;
			}
			this.initial_instances.push(inst);
			if (this.layout.initial_types.indexOf(type) === -1)
				this.layout.initial_types.push(type);
		}
		this.effect_types = [];
		this.active_effect_types = [];
		this.effect_params = [];
		for (i = 0, len = m[14].length; i < len; i++)
		{
			this.effect_types.push({
				id: m[14][i][0],
				name: m[14][i][1],
				shaderindex: -1,
				active: true,
				index: i
			});
			this.effect_params.push(m[14][i][2].slice(0));
		}
		this.updateActiveEffects();
		this.rcTex = new cr.rect(0, 0, 1, 1);
		this.rcTex2 = new cr.rect(0, 0, 1, 1);
	};
	Layer.prototype.updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.active)
				this.active_effect_types.push(et);
		}
	};
	Layer.prototype.getEffectByName = function (name_)
	{
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.name === name_)
				return et;
		}
		return null;
	};
	Layer.prototype.createInitialInstances = function ()
	{
		var i, k, len, inst, initial_inst, type, keep, hasPersistBehavior;
		for (i = 0, k = 0, len = this.initial_instances.length; i < len; i++)
		{
			initial_inst = this.initial_instances[i];
			type = this.runtime.types_by_index[initial_inst[1]];
;
			hasPersistBehavior = this.runtime.typeHasPersistBehavior(type);
			keep = true;
			if (!hasPersistBehavior || this.layout.first_visit)
			{
				inst = this.runtime.createInstanceFromInit(initial_inst, this, true);
;
				created_instances.push(inst);
				if (inst.type.global)
					keep = false;
			}
			if (keep)
			{
				this.initial_instances[k] = this.initial_instances[i];
				k++;
			}
		}
		this.initial_instances.length = k;
		this.runtime.ClearDeathRow();		// flushes creation row so IIDs will be correct
		if (!this.runtime.glwrap && this.effect_types.length)	// no WebGL renderer and shaders used
			this.blend_mode = this.effect_fallback;				// use fallback blend mode
		this.compositeOp = cr.effectToCompositeOp(this.blend_mode);
		if (this.runtime.gl)
			cr.setGLBlend(this, this.blend_mode, this.runtime.gl);
	};
	Layer.prototype.updateZIndices = function ()
	{
		if (!this.zindices_stale)
			return;
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
;
;
			this.instances[i].zindex = i;
		}
		this.zindices_stale = false;
	};
	Layer.prototype.getScale = function (include_aspect)
	{
		return this.getNormalScale() * (this.runtime.fullscreenScalingQuality || include_aspect ? this.runtime.aspect_scale : 1);
	};
	Layer.prototype.getNormalScale = function ()
	{
		return ((this.scale * this.layout.scale) - 1) * this.zoomRate + 1;
	};
	Layer.prototype.getAngle = function ()
	{
		if (this.disableAngle)
			return 0;
		return cr.clamp_angle(this.layout.angle + this.angle);
	};
	Layer.prototype.draw = function (ctx)
	{
		this.render_offscreen = (this.forceOwnTexture || this.opacity !== 1.0 || this.blend_mode !== 0);
		var layer_canvas = this.runtime.canvas;
		var layer_ctx = ctx;
		var ctx_changed = false;
		if (this.render_offscreen)
		{
			if (!this.runtime.layer_canvas)
			{
				this.runtime.layer_canvas = document.createElement("canvas");
;
				layer_canvas = this.runtime.layer_canvas;
				layer_canvas.width = this.runtime.draw_width;
				layer_canvas.height = this.runtime.draw_height;
				this.runtime.layer_ctx = layer_canvas.getContext("2d");
;
				ctx_changed = true;
			}
			layer_canvas = this.runtime.layer_canvas;
			layer_ctx = this.runtime.layer_ctx;
			if (layer_canvas.width !== this.runtime.draw_width)
			{
				layer_canvas.width = this.runtime.draw_width;
				ctx_changed = true;
			}
			if (layer_canvas.height !== this.runtime.draw_height)
			{
				layer_canvas.height = this.runtime.draw_height;
				ctx_changed = true;
			}
			if (ctx_changed)
			{
				layer_ctx["webkitImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["mozImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["msImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["imageSmoothingEnabled"] = this.runtime.linearSampling;
			}
			if (this.transparent)
				layer_ctx.clearRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		}
		layer_ctx.globalAlpha = 1;
		layer_ctx.globalCompositeOperation = "source-over";
		if (!this.transparent)
		{
			layer_ctx.fillStyle = "rgb(" + this.background_color[0] + "," + this.background_color[1] + "," + this.background_color[2] + ")";
			layer_ctx.fillRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		}
		layer_ctx.save();
		this.disableAngle = true;
		var px = this.canvasToLayer(0, 0, true, true);
		var py = this.canvasToLayer(0, 0, false, true);
		this.disableAngle = false;
		if (this.runtime.pixel_rounding)
		{
			px = (px + 0.5) | 0;
			py = (py + 0.5) | 0;
		}
		this.rotateViewport(px, py, layer_ctx);
		var myscale = this.getScale();
		layer_ctx.scale(myscale, myscale);
		layer_ctx.translate(-px, -py);
		var i, len, inst, bbox;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			if (!inst.visible || inst.width === 0 || inst.height === 0)
				continue;
			inst.update_bbox();
			bbox = inst.bbox;
			if (bbox.right < this.viewLeft || bbox.bottom < this.viewTop || bbox.left > this.viewRight || bbox.top > this.viewBottom)
				continue;
			layer_ctx.globalCompositeOperation = inst.compositeOp;
			inst.draw(layer_ctx);
		}
		layer_ctx.restore();
		if (this.render_offscreen)
		{
			ctx.globalCompositeOperation = this.compositeOp;
			ctx.globalAlpha = this.opacity;
			ctx.drawImage(layer_canvas, 0, 0);
		}
	};
	Layer.prototype.rotateViewport = function (px, py, ctx)
	{
		var myscale = this.getScale();
		this.viewLeft = px;
		this.viewTop = py;
		this.viewRight = px + (this.runtime.draw_width * (1 / myscale));
		this.viewBottom = py + (this.runtime.draw_height * (1 / myscale));
		var myAngle = this.getAngle();
		if (myAngle !== 0)
		{
			if (ctx)
			{
				ctx.translate(this.runtime.draw_width / 2, this.runtime.draw_height / 2);
				ctx.rotate(-myAngle);
				ctx.translate(this.runtime.draw_width / -2, this.runtime.draw_height / -2);
			}
			this.tmprect.set(this.viewLeft, this.viewTop, this.viewRight, this.viewBottom);
			this.tmprect.offset((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
			this.tmpquad.set_from_rotated_rect(this.tmprect, myAngle);
			this.tmpquad.bounding_box(this.tmprect);
			this.tmprect.offset((this.viewLeft + this.viewRight) / 2, (this.viewTop + this.viewBottom) / 2);
			this.viewLeft = this.tmprect.left;
			this.viewTop = this.tmprect.top;
			this.viewRight = this.tmprect.right;
			this.viewBottom = this.tmprect.bottom;
		}
	}
	Layer.prototype.drawGL = function (glw)
	{
		var windowWidth = this.runtime.draw_width;
		var windowHeight = this.runtime.draw_height;
		var shaderindex = 0;
		var etindex = 0;
		this.render_offscreen = (this.forceOwnTexture || this.opacity !== 1.0 || this.active_effect_types.length > 0 || this.blend_mode !== 0);
		if (this.render_offscreen)
		{
			if (!this.runtime.layer_tex)
			{
				this.runtime.layer_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			if (this.runtime.layer_tex.c2width !== this.runtime.draw_width || this.runtime.layer_tex.c2height !== this.runtime.draw_height)
			{
				glw.deleteTexture(this.runtime.layer_tex);
				this.runtime.layer_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			glw.setRenderingToTexture(this.runtime.layer_tex);
			if (this.transparent)
				glw.clear(0, 0, 0, 0);
		}
		if (!this.transparent)
		{
			glw.clear(this.background_color[0] / 255, this.background_color[1] / 255, this.background_color[2] / 255, 1);
		}
		this.disableAngle = true;
		var px = this.canvasToLayer(0, 0, true, true);
		var py = this.canvasToLayer(0, 0, false, true);
		this.disableAngle = false;
		if (this.runtime.pixel_rounding)
		{
			px = (px + 0.5) | 0;
			py = (py + 0.5) | 0;
		}
		this.rotateViewport(px, py, null);
		var myscale = this.getScale();
		glw.resetModelView();
		glw.scale(myscale, myscale);
		glw.rotateZ(-this.getAngle());
		glw.translate((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
		glw.updateModelView();
		var i, len, inst, bbox;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			if (!inst.visible || inst.width === 0 || inst.height === 0)
				continue;
			inst.update_bbox();
			bbox = inst.bbox;
			if (bbox.right < this.viewLeft || bbox.bottom < this.viewTop || bbox.left > this.viewRight || bbox.top > this.viewBottom)
				continue;
			if (inst.uses_shaders)
			{
				shaderindex = inst.active_effect_types[0].shaderindex;
				etindex = inst.active_effect_types[0].index;
				if (inst.active_effect_types.length === 1 && !glw.programUsesCrossSampling(shaderindex) &&
					!glw.programExtendsBox(shaderindex) && ((!inst.angle && !inst.layer.getAngle()) || !glw.programUsesDest(shaderindex)) &&
					inst.opacity === 1 && !inst.type.plugin.must_predraw)
				{
					glw.switchProgram(shaderindex);
					glw.setBlend(inst.srcBlend, inst.destBlend);
					if (glw.programIsAnimated(shaderindex))
						this.runtime.redraw = true;
					var destStartX = 0, destStartY = 0, destEndX = 0, destEndY = 0;
					if (glw.programUsesDest(shaderindex))
					{
						var bbox = inst.bbox;
						var screenleft = this.layerToCanvas(bbox.left, bbox.top, true, true);
						var screentop = this.layerToCanvas(bbox.left, bbox.top, false, true);
						var screenright = this.layerToCanvas(bbox.right, bbox.bottom, true, true);
						var screenbottom = this.layerToCanvas(bbox.right, bbox.bottom, false, true);
						destStartX = screenleft / windowWidth;
						destStartY = 1 - screentop / windowHeight;
						destEndX = screenright / windowWidth;
						destEndY = 1 - screenbottom / windowHeight;
					}
					glw.setProgramParameters(this.render_offscreen ? this.runtime.layer_tex : this.layout.getRenderTarget(), // backTex
											 1.0 / inst.width,			// pixelWidth
											 1.0 / inst.height,			// pixelHeight
											 destStartX, destStartY,
											 destEndX, destEndY,
											 this.getScale(),
											 this.getAngle(),
											 this.viewLeft, this.viewTop,
											 inst.effect_params[etindex]);
					inst.drawGL(glw);
				}
				else
				{
					this.layout.renderEffectChain(glw, this, inst, this.render_offscreen ? this.runtime.layer_tex : this.layout.getRenderTarget());
					glw.resetModelView();
					glw.scale(myscale, myscale);
					glw.rotateZ(-this.getAngle());
					glw.translate((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
					glw.updateModelView();
				}
			}
			else
			{
				glw.switchProgram(0);		// un-set any previously set shader
				glw.setBlend(inst.srcBlend, inst.destBlend);
				inst.drawGL(glw);
			}
		}
		if (this.render_offscreen)
		{
			shaderindex = this.active_effect_types.length ? this.active_effect_types[0].shaderindex : 0;
			etindex = this.active_effect_types.length ? this.active_effect_types[0].index : 0;
			if (this.active_effect_types.length === 0 || (this.active_effect_types.length === 1 &&
				!glw.programUsesCrossSampling(shaderindex) && this.opacity === 1))
			{
				if (this.active_effect_types.length === 1)
				{
					glw.switchProgram(shaderindex);
					glw.setProgramParameters(this.layout.getRenderTarget(),		// backTex
											 1.0 / this.runtime.draw_width,		// pixelWidth
											 1.0 / this.runtime.draw_height,	// pixelHeight
											 0.0, 0.0,							// destStart
											 1.0, 1.0,							// destEnd
											 this.getScale(),					// layerScale
											 this.getAngle(),
											 this.viewLeft, this.viewTop,
											 this.effect_params[etindex]);		// fx parameters
					if (glw.programIsAnimated(shaderindex))
						this.runtime.redraw = true;
				}
				else
					glw.switchProgram(0);
				glw.setRenderingToTexture(this.layout.getRenderTarget());
				glw.setOpacity(this.opacity);
				glw.setTexture(this.runtime.layer_tex);
				glw.setBlend(this.srcBlend, this.destBlend);
				glw.resetModelView();
				glw.updateModelView();
				var halfw = this.runtime.draw_width / 2;
				var halfh = this.runtime.draw_height / 2;
				glw.quad(-halfw, halfh, halfw, halfh, halfw, -halfh, -halfw, -halfh);
				glw.setTexture(null);
			}
			else
			{
				this.layout.renderEffectChain(glw, this, null, this.layout.getRenderTarget());
			}
		}
	};
	Layer.prototype.canvasToLayer = function (ptx, pty, getx, using_draw_area)
	{
		var multiplier = this.runtime.devicePixelRatio;
		if (this.runtime.isRetina)
		{
			ptx *= multiplier;
			pty *= multiplier;
		}
		var ox = this.runtime.parallax_x_origin;
		var oy = this.runtime.parallax_y_origin;
		var x = ((this.layout.scrollX - ox) * this.parallaxX) + ox;
		var y = ((this.layout.scrollY - oy) * this.parallaxY) + oy;
		var invScale = 1 / this.getScale(!using_draw_area);
		if (using_draw_area)
		{
			x -= (this.runtime.draw_width * invScale) / 2;
			y -= (this.runtime.draw_height * invScale) / 2;
		}
		else
		{
			x -= (this.runtime.width * invScale) / 2;
			y -= (this.runtime.height * invScale) / 2;
		}
		x += ptx * invScale;
		y += pty * invScale;
		var a = this.getAngle();
		if (a !== 0)
		{
			x -= this.layout.scrollX;
			y -= this.layout.scrollY;
			var cosa = Math.cos(a);
			var sina = Math.sin(a);
			var x_temp = (x * cosa) - (y * sina);
			y = (y * cosa) + (x * sina);
			x = x_temp;
			x += this.layout.scrollX;
			y += this.layout.scrollY;
		}
		return getx ? x : y;
	};
	Layer.prototype.layerToCanvas = function (ptx, pty, getx, using_draw_area)
	{
		var a = this.getAngle();
		if (a !== 0)
		{
			ptx -= this.layout.scrollX;
			pty -= this.layout.scrollY;
			var cosa = Math.cos(-a);
			var sina = Math.sin(-a);
			var x_temp = (ptx * cosa) - (pty * sina);
			pty = (pty * cosa) + (ptx * sina);
			ptx = x_temp;
			ptx += this.layout.scrollX;
			pty += this.layout.scrollY;
		}
		var ox = this.runtime.parallax_x_origin;
		var oy = this.runtime.parallax_y_origin;
		var x = ((this.layout.scrollX - ox) * this.parallaxX) + ox;
		var y = ((this.layout.scrollY - oy) * this.parallaxY) + oy;
		var invScale = 1 / this.getScale(!using_draw_area);
		if (using_draw_area)
		{
			x -= (this.runtime.draw_width * invScale) / 2;
			y -= (this.runtime.draw_height * invScale) / 2;
		}
		else
		{
			x -= (this.runtime.width * invScale) / 2;
			y -= (this.runtime.height * invScale) / 2;
		}
		x = (ptx - x) / invScale;
		y = (pty - y) / invScale;
		var multiplier = this.runtime.devicePixelRatio;
		if (this.runtime.isRetina)
		{
			x /= multiplier;
			y /= multiplier;
		}
		return getx ? x : y;
	};
	Layer.prototype.rotatePt = function (x_, y_, getx)
	{
		if (this.getAngle() === 0)
			return getx ? x_ : y_;
		var nx = this.layerToCanvas(x_, y_, true);
		var ny = this.layerToCanvas(x_, y_, false);
		this.disableAngle = true;
		var px = this.canvasToLayer(nx, ny, true);
		var py = this.canvasToLayer(nx, ny, true);
		this.disableAngle = false;
		return getx ? px : py;
	};
	Layer.prototype.saveToJSON = function ()
	{
		var i, len, et;
		var o = {
			"s": this.scale,
			"a": this.angle,
			"vl": this.viewLeft,
			"vt": this.viewTop,
			"vr": this.viewRight,
			"vb": this.viewBottom,
			"v": this.visible,
			"bc": this.background_color,
			"t": this.transparent,
			"px": this.parallaxX,
			"py": this.parallaxY,
			"o": this.opacity,
			"zr": this.zoomRate,
			"fx": [],
			"instances": []
		};
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			o["fx"].push({"name": et.name, "active": et.active, "params": this.effect_params[et.index] });
		}
		return o;
	};
	function sortInstanceByZIndex(a, b)
	{
		return a.zindex - b.zindex;
	};
	Layer.prototype.loadFromJSON = function (o)
	{
		var i, len, p, inst, fx;
		this.scale = o["s"];
		this.angle = o["a"];
		this.viewLeft = o["vl"];
		this.viewTop = o["vt"];
		this.viewRight = o["vr"];
		this.viewBottom = o["vb"];
		this.visible = o["v"];
		this.background_color = o["bc"];
		this.transparent = o["t"];
		this.parallaxX = o["px"];
		this.parallaxY = o["py"];
		this.opacity = o["o"];
		this.zoomRate = o["zr"];
		var ofx = o["fx"];
		for (i = 0, len = ofx.length; i < len; i++)
		{
			fx = this.getEffectByName(ofx[i]["name"]);
			if (!fx)
				continue;		// must've gone missing
			fx.active = ofx[i]["active"];
			this.effect_params[fx.index] = ofx[i]["params"];
		}
		this.updateActiveEffects();
		this.instances.sort(sortInstanceByZIndex);
		this.zindices_stale = true;
	};
	cr.layer = Layer;
}());
;
(function()
{
	var allUniqueSolModifiers = [];
	function testSolsMatch(arr1, arr2)
	{
		var i, len = arr1.length;
		switch (len) {
		case 0:
			return true;
		case 1:
			return arr1[0] === arr2[0];
		case 2:
			return arr1[0] === arr2[0] && arr1[1] === arr2[1];
		default:
			for (i = 0; i < len; i++)
			{
				if (arr1[i] !== arr2[i])
					return false;
			}
			return true;
		}
	};
	function solArraySorter(t1, t2)
	{
		return t1.index - t2.index;
	};
	function findMatchingSolModifier(arr)
	{
		var i, len, u, temp, subarr;
		if (arr.length === 2)
		{
			if (arr[0].index > arr[1].index)
			{
				temp = arr[0];
				arr[0] = arr[1];
				arr[1] = temp;
			}
		}
		else if (arr.length > 2)
			arr.sort(solArraySorter);		// so testSolsMatch compares in same order
		if (arr.length >= allUniqueSolModifiers.length)
			allUniqueSolModifiers.length = arr.length + 1;
		if (!allUniqueSolModifiers[arr.length])
			allUniqueSolModifiers[arr.length] = [];
		subarr = allUniqueSolModifiers[arr.length];
		for (i = 0, len = subarr.length; i < len; i++)
		{
			u = subarr[i];
			if (testSolsMatch(arr, u))
				return u;
		}
		subarr.push(arr);
		return arr;
	};
	function EventSheet(runtime, m)
	{
		this.runtime = runtime;
		this.triggers = {};
		this.fasttriggers = {};
        this.hasRun = false;
        this.includes = new cr.ObjectSet(); 	// all event sheets included by this sheet, at first-level indirection only
		this.deep_includes = [];				// all includes from this sheet recursively, in trigger order
		this.already_included_sheets = [];		// used while building deep_includes
		this.name = m[0];
		var em = m[1];		// events model
		this.events = [];       // triggers won't make it to this array
		var i, len;
		for (i = 0, len = em.length; i < len; i++)
			this.init_event(em[i], null, this.events);
	};
    EventSheet.prototype.toString = function ()
    {
        return this.name;
    };
	EventSheet.prototype.init_event = function (m, parent, nontriggers)
	{
		switch (m[0]) {
		case 0:	// event block
		{
			var block = new cr.eventblock(this, parent, m);
			cr.seal(block);
			if (block.orblock)
			{
				nontriggers.push(block);
				var i, len;
				for (i = 0, len = block.conditions.length; i < len; i++)
				{
					if (block.conditions[i].trigger)
						this.init_trigger(block, i);
				}
			}
			else
			{
				if (block.is_trigger())
					this.init_trigger(block, 0);
				else
					nontriggers.push(block);
			}
			break;
		}
		case 1: // variable
		{
			var v = new cr.eventvariable(this, parent, m);
			cr.seal(v);
			nontriggers.push(v);
			break;
		}
        case 2:	// include
        {
            var inc = new cr.eventinclude(this, parent, m);
			cr.seal(inc);
            nontriggers.push(inc);
			break;
        }
		default:
;
		}
	};
	EventSheet.prototype.postInit = function ()
	{
		var i, len;
		for (i = 0, len = this.events.length; i < len; i++)
		{
			this.events[i].postInit(i < len - 1 && this.events[i + 1].is_else_block);
		}
	};
	EventSheet.prototype.updateDeepIncludes = function ()
	{
		this.deep_includes.length = 0;
		this.already_included_sheets.length = 0;
		this.addDeepIncludes(this);
		this.already_included_sheets.length = 0;
	};
	EventSheet.prototype.addDeepIncludes = function (root_sheet)
	{
		var i, len, inc, sheet;
		var deep_includes = root_sheet.deep_includes;
		var already_included_sheets = root_sheet.already_included_sheets;
		var arr = this.includes.valuesRef();
		for (i = 0, len = arr.length; i < len; ++i)
		{
			inc = arr[i];
			sheet = inc.include_sheet;
			if (!inc.isActive() || root_sheet === sheet || already_included_sheets.indexOf(sheet) > -1)
				continue;
			already_included_sheets.push(sheet);
			sheet.addDeepIncludes(root_sheet);
			deep_includes.push(sheet);
		}
	};
	EventSheet.prototype.run = function (from_include)
	{
		if (!this.runtime.resuming_breakpoint)
		{
			this.hasRun = true;
			if (!from_include)
				this.runtime.isRunningEvents = true;
		}
		var i, len;
		for (i = 0, len = this.events.length; i < len; i++)
		{
			var ev = this.events[i];
			ev.run();
				this.runtime.clearSol(ev.solModifiers);
				if (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length)
					this.runtime.ClearDeathRow();
		}
			if (!from_include)
				this.runtime.isRunningEvents = false;
	};
	function isPerformanceSensitiveTrigger(method)
	{
		if (cr.plugins_.Sprite && method === cr.plugins_.Sprite.prototype.cnds.OnFrameChanged)
		{
			return true;
		}
		return false;
	};
	EventSheet.prototype.init_trigger = function (trig, index)
	{
		if (!trig.orblock)
			this.runtime.triggers_to_postinit.push(trig);	// needs to be postInit'd later
		var i, len;
		var cnd = trig.conditions[index];
		var type_name;
		if (cnd.type)
			type_name = cnd.type.name;
		else
			type_name = "system";
		var fasttrigger = cnd.fasttrigger;
		var triggers = (fasttrigger ? this.fasttriggers : this.triggers);
		if (!triggers[type_name])
			triggers[type_name] = [];
		var obj_entry = triggers[type_name];
		var method = cnd.func;
		if (fasttrigger)
		{
			if (!cnd.parameters.length)				// no parameters
				return;
			var firstparam = cnd.parameters[0];
			if (firstparam.type !== 1 ||			// not a string param
				firstparam.expression.type !== 2)	// not a string literal node
			{
				return;
			}
			var fastevs;
			var firstvalue = firstparam.expression.value.toLowerCase();
			var i, len;
			for (i = 0, len = obj_entry.length; i < len; i++)
			{
				if (obj_entry[i].method == method)
				{
					fastevs = obj_entry[i].evs;
					if (!fastevs[firstvalue])
						fastevs[firstvalue] = [[trig, index]];
					else
						fastevs[firstvalue].push([trig, index]);
					return;
				}
			}
			fastevs = {};
			fastevs[firstvalue] = [[trig, index]];
			obj_entry.push({ method: method, evs: fastevs });
		}
		else
		{
			for (i = 0, len = obj_entry.length; i < len; i++)
			{
				if (obj_entry[i].method == method)
				{
					obj_entry[i].evs.push([trig, index]);
					return;
				}
			}
			if (isPerformanceSensitiveTrigger(method))
				obj_entry.unshift({ method: method, evs: [[trig, index]]});
			else
				obj_entry.push({ method: method, evs: [[trig, index]]});
		}
	};
	cr.eventsheet = EventSheet;
	function Selection(type)
	{
		this.type = type;
		this.instances = [];        // subset of picked instances
		this.else_instances = [];	// subset of unpicked instances
		this.select_all = true;
	};
	Selection.prototype.hasObjects = function ()
	{
		if (this.select_all)
			return this.type.instances.length;
		else
			return this.instances.length;
	};
	Selection.prototype.getObjects = function ()
	{
		if (this.select_all)
			return this.type.instances;
		else
			return this.instances;
	};
	/*
	Selection.prototype.ensure_picked = function (inst, skip_siblings)
	{
		var i, len;
		var orblock = inst.runtime.getCurrentEventStack().current_event.orblock;
		if (this.select_all)
		{
			this.select_all = false;
			if (orblock)
			{
				cr.shallowAssignArray(this.else_instances, inst.type.instances);
				cr.arrayFindRemove(this.else_instances, inst);
			}
			this.instances.length = 1;
			this.instances[0] = inst;
		}
		else
		{
			if (orblock)
			{
				i = this.else_instances.indexOf(inst);
				if (i !== -1)
				{
					this.instances.push(this.else_instances[i]);
					this.else_instances.splice(i, 1);
				}
			}
			else
			{
				if (this.instances.indexOf(inst) === -1)
					this.instances.push(inst);
			}
		}
		if (!skip_siblings)
		{
		}
	};
	*/
	Selection.prototype.pick_one = function (inst)
	{
		if (!inst)
			return;
		if (inst.runtime.getCurrentEventStack().current_event.orblock)
		{
			if (this.select_all)
			{
				this.instances.length = 0;
				cr.shallowAssignArray(this.else_instances, inst.type.instances);
				this.select_all = false;
			}
			var i = this.else_instances.indexOf(inst);
			if (i !== -1)
			{
				this.instances.push(this.else_instances[i]);
				this.else_instances.splice(i, 1);
			}
		}
		else
		{
			this.select_all = false;
			this.instances.length = 1;
			this.instances[0] = inst;
		}
	};
	cr.selection = Selection;
	function EventBlock(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.solModifiersIncludingParents = [];
		this.solWriterAfterCnds = false;	// block does not change SOL after running its conditions
		this.group = false;					// is group of events
		this.initially_activated = false;	// if a group, is active on startup
		this.toplevelevent = false;			// is an event block parented only by a top-level group
		this.toplevelgroup = false;			// is parented only by other groups or is top-level (i.e. not in a subevent)
		this.has_else_block = false;		// is followed by else
;
		this.conditions = [];
		this.actions = [];
		this.subevents = [];
		this.group_name = "";
		this.group = false;
		this.initially_activated = false;
		this.group_active = false;
		this.contained_includes = null;
        if (m[1])
        {
			this.group_name = m[1][1].toLowerCase();
			this.group = true;
			this.initially_activated = !!m[1][0];
			this.contained_includes = [];
			this.group_active = this.initially_activated;
			this.runtime.allGroups.push(this);
            this.runtime.groups_by_name[this.group_name] = this;
        }
		this.orblock = m[2];
		this.sid = m[4];
		if (!this.group)
			this.runtime.blocksBySid[this.sid.toString()] = this;
		var i, len;
		var cm = m[5];
		for (i = 0, len = cm.length; i < len; i++)
		{
			var cnd = new cr.condition(this, cm[i]);
			cnd.index = i;
			cr.seal(cnd);
			this.conditions.push(cnd);
			/*
			if (cnd.is_logical())
				this.is_logical = true;
			if (cnd.type && !cnd.type.plugin.singleglobal && this.cndReferences.indexOf(cnd.type) === -1)
				this.cndReferences.push(cnd.type);
			*/
			this.addSolModifier(cnd.type);
		}
		var am = m[6];
		for (i = 0, len = am.length; i < len; i++)
		{
			var act = new cr.action(this, am[i]);
			act.index = i;
			cr.seal(act);
			this.actions.push(act);
		}
		if (m.length === 8)
		{
			var em = m[7];
			for (i = 0, len = em.length; i < len; i++)
				this.sheet.init_event(em[i], this, this.subevents);
		}
		this.is_else_block = false;
		if (this.conditions.length)
		{
			this.is_else_block = (this.conditions[0].type == null && this.conditions[0].func == cr.system_object.prototype.cnds.Else);
		}
	};
	window["_c2hh_"] = "621F98E00EE075630910153A15712D7CDE157DB1";
	EventBlock.prototype.postInit = function (hasElse/*, prevBlock_*/)
	{
		var i, len;
		var p = this.parent;
		if (this.group)
		{
			this.toplevelgroup = true;
			while (p)
			{
				if (!p.group)
				{
					this.toplevelgroup = false;
					break;
				}
				p = p.parent;
			}
		}
		this.toplevelevent = !this.is_trigger() && (!this.parent || (this.parent.group && this.parent.toplevelgroup));
		this.has_else_block = !!hasElse;
		this.solModifiersIncludingParents = this.solModifiers.slice(0);
		p = this.parent;
		while (p)
		{
			for (i = 0, len = p.solModifiers.length; i < len; i++)
				this.addParentSolModifier(p.solModifiers[i]);
			p = p.parent;
		}
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
		this.solModifiersIncludingParents = findMatchingSolModifier(this.solModifiersIncludingParents);
		var i, len/*, s*/;
		for (i = 0, len = this.conditions.length; i < len; i++)
			this.conditions[i].postInit();
		for (i = 0, len = this.actions.length; i < len; i++)
			this.actions[i].postInit();
		for (i = 0, len = this.subevents.length; i < len; i++)
		{
			this.subevents[i].postInit(i < len - 1 && this.subevents[i + 1].is_else_block);
		}
		/*
		if (this.is_else_block && this.prev_block)
		{
			for (i = 0, len = this.prev_block.solModifiers.length; i < len; i++)
			{
				s = this.prev_block.solModifiers[i];
				if (this.solModifiers.indexOf(s) === -1)
					this.solModifiers.push(s);
			}
		}
		*/
	};
	EventBlock.prototype.setGroupActive = function (a)
	{
		if (this.group_active === !!a)
			return;		// same state
		this.group_active = !!a;
		var i, len;
		for (i = 0, len = this.contained_includes.length; i < len; ++i)
		{
			this.contained_includes[i].updateActive();
		}
		if (len > 0 && this.runtime.running_layout.event_sheet)
			this.runtime.running_layout.event_sheet.updateDeepIncludes();
	};
	function addSolModifierToList(type, arr)
	{
		var i, len, t;
		if (!type)
			return;
		if (arr.indexOf(type) === -1)
			arr.push(type);
		if (type.is_contained)
		{
			for (i = 0, len = type.container.length; i < len; i++)
			{
				t = type.container[i];
				if (type === t)
					continue;		// already handled
				if (arr.indexOf(t) === -1)
					arr.push(t);
			}
		}
	};
	EventBlock.prototype.addSolModifier = function (type)
	{
		addSolModifierToList(type, this.solModifiers);
	};
	EventBlock.prototype.addParentSolModifier = function (type)
	{
		addSolModifierToList(type, this.solModifiersIncludingParents);
	};
	EventBlock.prototype.setSolWriterAfterCnds = function ()
	{
		this.solWriterAfterCnds = true;
		if (this.parent)
			this.parent.setSolWriterAfterCnds();
	};
	EventBlock.prototype.is_trigger = function ()
	{
		if (!this.conditions.length)    // no conditions
			return false;
		else
			return this.conditions[0].trigger;
	};
	EventBlock.prototype.run = function ()
	{
		var i, len, any_true = false, cnd_result;
		var runtime = this.runtime;
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		var conditions = this.conditions;
			if (!this.is_else_block)
				evinfo.else_branch_ran = false;
		if (this.orblock)
		{
			if (conditions.length === 0)
				any_true = true;		// be sure to run if empty block
				evinfo.cndindex = 0
			for (len = conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				if (conditions[evinfo.cndindex].trigger)		// skip triggers when running OR block
					continue;
				cnd_result = conditions[evinfo.cndindex].run();
				if (cnd_result)			// make sure all conditions run and run if any were true
					any_true = true;
			}
			evinfo.last_event_true = any_true;
			if (any_true)
				this.run_actions_and_subevents();
		}
		else
		{
				evinfo.cndindex = 0
			for (len = conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				cnd_result = conditions[evinfo.cndindex].run();
				if (!cnd_result)    // condition failed
				{
					evinfo.last_event_true = false;
					if (this.toplevelevent && (!runtime.deathRow.isEmpty() || runtime.createRow.length))
						runtime.ClearDeathRow();
					return;		// bail out now
				}
			}
			evinfo.last_event_true = true;
			this.run_actions_and_subevents();
		}
		this.end_run(evinfo);
	};
	EventBlock.prototype.end_run = function (evinfo)
	{
		if (evinfo.last_event_true && this.has_else_block)
			evinfo.else_branch_ran = true;
		if (this.toplevelevent && (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length))
			this.runtime.ClearDeathRow();
	};
	EventBlock.prototype.run_orblocktrigger = function (index)
	{
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		if (this.conditions[index].run())
		{
			this.run_actions_and_subevents();
			this.runtime.getCurrentEventStack().last_event_true = true;
		}
	};
	EventBlock.prototype.run_actions_and_subevents = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		var len;
		for (evinfo.actindex = 0, len = this.actions.length; evinfo.actindex < len; evinfo.actindex++)
		{
			if (this.actions[evinfo.actindex].run())
				return;
		}
		this.run_subevents();
	};
	EventBlock.prototype.resume_actions_and_subevents = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		var len;
		for (len = this.actions.length; evinfo.actindex < len; evinfo.actindex++)
		{
			if (this.actions[evinfo.actindex].run())
				return;
		}
		this.run_subevents();
	};
	EventBlock.prototype.run_subevents = function ()
	{
		if (!this.subevents.length)
			return;
		var i, len, subev, pushpop/*, skipped_pop = false, pop_modifiers = null*/;
		var last = this.subevents.length - 1;
			this.runtime.pushEventStack(this);
		if (this.solWriterAfterCnds)
		{
			for (i = 0, len = this.subevents.length; i < len; i++)
			{
				subev = this.subevents[i];
					pushpop = (!this.toplevelgroup || (!this.group && i < last));
					if (pushpop)
						this.runtime.pushCopySol(subev.solModifiers);
				subev.run();
					if (pushpop)
						this.runtime.popSol(subev.solModifiers);
					else
						this.runtime.clearSol(subev.solModifiers);
			}
		}
		else
		{
			for (i = 0, len = this.subevents.length; i < len; i++)
			{
				this.subevents[i].run();
			}
		}
			this.runtime.popEventStack();
	};
	EventBlock.prototype.run_pretrigger = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		var any_true = false;
		var i, len;
		for (evinfo.cndindex = 0, len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
		{
;
			if (this.conditions[evinfo.cndindex].run())
				any_true = true;
			else if (!this.orblock)			// condition failed (let OR blocks run all conditions anyway)
				return false;               // bail out
		}
		return this.orblock ? any_true : true;
	};
	EventBlock.prototype.retrigger = function ()
	{
		this.runtime.execcount++;
		var prevcndindex = this.runtime.getCurrentEventStack().cndindex;
		var len;
		var evinfo = this.runtime.pushEventStack(this);
		if (!this.orblock)
		{
			for (evinfo.cndindex = prevcndindex + 1, len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				if (!this.conditions[evinfo.cndindex].run())    // condition failed
				{
					this.runtime.popEventStack();               // moving up level of recursion
					return false;                               // bail out
				}
			}
		}
		this.run_actions_and_subevents();
		this.runtime.popEventStack();
		return true;		// ran an iteration
	};
	EventBlock.prototype.isFirstConditionOfType = function (cnd)
	{
		var cndindex = cnd.index;
		if (cndindex === 0)
			return true;
		--cndindex;
		for ( ; cndindex >= 0; --cndindex)
		{
			if (this.conditions[cndindex].type === cnd.type)
				return false;
		}
		return true;
	};
	cr.eventblock = EventBlock;
	function Condition(block, m)
	{
		this.block = block;
		this.sheet = block.sheet;
		this.runtime = block.runtime;
		this.parameters = [];
		this.results = [];
		this.extra = {};		// for plugins to stow away some custom info
		this.index = -1;
		this.anyParamVariesPerInstance = false;
		this.func = m[1];
;
		this.trigger = (m[3] > 0);
		this.fasttrigger = (m[3] === 2);
		this.looping = m[4];
		this.inverted = m[5];
		this.isstatic = m[6];
		this.sid = m[7];
		this.runtime.cndsBySid[this.sid.toString()] = this;
		if (m[0] === -1)		// system object
		{
			this.type = null;
			this.run = this.run_system;
			this.behaviortype = null;
			this.beh_index = -1;
		}
		else
		{
			this.type = this.runtime.types_by_index[m[0]];
;
			if (this.isstatic)
				this.run = this.run_static;
			else
				this.run = this.run_object;
			if (m[2])
			{
				this.behaviortype = this.type.getBehaviorByName(m[2]);
;
				this.beh_index = this.type.getBehaviorIndexByName(m[2]);
;
			}
			else
			{
				this.behaviortype = null;
				this.beh_index = -1;
			}
			if (this.block.parent)
				this.block.parent.setSolWriterAfterCnds();
		}
		if (this.fasttrigger)
			this.run = this.run_true;
		if (m.length === 10)
		{
			var i, len;
			var em = m[9];
			for (i = 0, len = em.length; i < len; i++)
			{
				var param = new cr.parameter(this, em[i]);
				cr.seal(param);
				this.parameters.push(param);
			}
			this.results.length = em.length;
		}
	};
	Condition.prototype.postInit = function ()
	{
		var i, len, p;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			p = this.parameters[i];
			p.postInit();
			if (p.variesPerInstance)
				this.anyParamVariesPerInstance = true;
		}
	};
	/*
	Condition.prototype.is_logical = function ()
	{
		return !this.type || this.type.plugin.singleglobal;
	};
	*/
	Condition.prototype.run_true = function ()
	{
		return true;
	};
	Condition.prototype.run_system = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		return cr.xor(this.func.apply(this.runtime.system, this.results), this.inverted);
	};
	Condition.prototype.run_static = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		var ret = this.func.apply(this.behaviortype ? this.behaviortype : this.type, this.results);
		this.type.applySolToContainer();
		return ret;
	};
	Condition.prototype.run_object = function ()
	{
		var i, j, k, leni, lenj, p, ret, met, inst, s, sol2;
		var type = this.type;
		var sol = type.getCurrentSol();
		var is_orblock = this.block.orblock && !this.trigger;		// triggers in OR blocks need to work normally
		var offset = 0;
		var is_contained = type.is_contained;
		var is_family = type.is_family;
		var family_index = type.family_index;
		var beh_index = this.beh_index;
		var is_beh = (beh_index > -1);
		var params_vary = this.anyParamVariesPerInstance;
		var parameters = this.parameters;
		var results = this.results;
		var inverted = this.inverted;
		var func = this.func;
		var arr, container;
		if (params_vary)
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
			{
				p = parameters[j];
				if (!p.variesPerInstance)
					results[j] = p.get(0);
			}
		}
		else
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
				results[j] = parameters[j].get(0);
		}
		if (sol.select_all) {
			sol.instances.length = 0;       // clear contents
			sol.else_instances.length = 0;
			arr = type.instances;
			for (i = 0, leni = arr.length; i < leni; ++i)
			{
				inst = arr[i];
;
				if (params_vary)
				{
					for (j = 0, lenj = parameters.length; j < lenj; ++j)
					{
						p = parameters[j];
						if (p.variesPerInstance)
							results[j] = p.get(i);        // default SOL index is current object
					}
				}
				if (is_beh)
				{
					offset = 0;
					if (is_family)
					{
						offset = inst.type.family_beh_map[family_index];
					}
					ret = func.apply(inst.behavior_insts[beh_index + offset], results);
				}
				else
					ret = func.apply(inst, results);
				met = cr.xor(ret, inverted);
				if (met)
					sol.instances.push(inst);
				else if (is_orblock)					// in OR blocks, keep the instances not meeting the condition for subsequent testing
					sol.else_instances.push(inst);
			}
			if (type.finish)
				type.finish(true);
			sol.select_all = false;
			type.applySolToContainer();
			return sol.hasObjects();
		}
		else {
			k = 0;
			var using_else_instances = (is_orblock && !this.block.isFirstConditionOfType(this));
			arr = (using_else_instances ? sol.else_instances : sol.instances);
			var any_true = false;
			for (i = 0, leni = arr.length; i < leni; ++i)
			{
				inst = arr[i];
;
				if (params_vary)
				{
					for (j = 0, lenj = parameters.length; j < lenj; ++j)
					{
						p = parameters[j];
						if (p.variesPerInstance)
							results[j] = p.get(i);        // default SOL index is current object
					}
				}
				if (is_beh)
				{
					offset = 0;
					if (is_family)
					{
						offset = inst.type.family_beh_map[family_index];
					}
					ret = func.apply(inst.behavior_insts[beh_index + offset], results);
				}
				else
					ret = func.apply(inst, results);
				if (cr.xor(ret, inverted))
				{
					any_true = true;
					if (using_else_instances)
					{
						sol.instances.push(inst);
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().instances.push(s);
							}
						}
					}
					else
					{
						arr[k] = inst;
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().instances[k] = s;
							}
						}
						k++;
					}
				}
				else
				{
					if (using_else_instances)
					{
						arr[k] = inst;
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().else_instances[k] = s;
							}
						}
						k++;
					}
					else if (is_orblock)
					{
						sol.else_instances.push(inst);
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().else_instances.push(s);
							}
						}
					}
				}
			}
			arr.length = k;
			if (is_contained)
			{
				container = type.container;
				for (i = 0, leni = container.length; i < leni; i++)
				{
					sol2 = container[i].getCurrentSol();
					if (using_else_instances)
						sol2.else_instances.length = k;
					else
						sol2.instances.length = k;
				}
			}
			var pick_in_finish = any_true;		// don't pick in finish() if we're only doing the logic test below
			if (using_else_instances && !any_true)
			{
				for (i = 0, leni = sol.instances.length; i < leni; i++)
				{
					inst = sol.instances[i];
					if (params_vary)
					{
						for (j = 0, lenj = parameters.length; j < lenj; j++)
						{
							p = parameters[j];
							if (p.variesPerInstance)
								results[j] = p.get(i);
						}
					}
					if (is_beh)
						ret = func.apply(inst.behavior_insts[beh_index], results);
					else
						ret = func.apply(inst, results);
					if (cr.xor(ret, inverted))
					{
						any_true = true;
						break;		// got our flag, don't need to test any more
					}
				}
			}
			if (type.finish)
				type.finish(pick_in_finish || is_orblock);
			return is_orblock ? any_true : sol.hasObjects();
		}
	};
	cr.condition = Condition;
	function Action(block, m)
	{
		this.block = block;
		this.sheet = block.sheet;
		this.runtime = block.runtime;
		this.parameters = [];
		this.results = [];
		this.extra = {};		// for plugins to stow away some custom info
		this.index = -1;
		this.anyParamVariesPerInstance = false;
		this.func = m[1];
;
		if (m[0] === -1)	// system
		{
			this.type = null;
			this.run = this.run_system;
			this.behaviortype = null;
			this.beh_index = -1;
		}
		else
		{
			this.type = this.runtime.types_by_index[m[0]];
;
			this.run = this.run_object;
			if (m[2])
			{
				this.behaviortype = this.type.getBehaviorByName(m[2]);
;
				this.beh_index = this.type.getBehaviorIndexByName(m[2]);
;
			}
			else
			{
				this.behaviortype = null;
				this.beh_index = -1;
			}
		}
		this.sid = m[3];
		this.runtime.actsBySid[this.sid.toString()] = this;
		if (m.length === 6)
		{
			var i, len;
			var em = m[5];
			for (i = 0, len = em.length; i < len; i++)
			{
				var param = new cr.parameter(this, em[i]);
				cr.seal(param);
				this.parameters.push(param);
			}
			this.results.length = em.length;
		}
	};
	Action.prototype.postInit = function ()
	{
		var i, len, p;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			p = this.parameters[i];
			p.postInit();
			if (p.variesPerInstance)
				this.anyParamVariesPerInstance = true;
		}
	};
	Action.prototype.run_system = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		return this.func.apply(this.runtime.system, this.results);
	};
	Action.prototype.run_object = function ()
	{
		var instances = this.type.getCurrentSol().getObjects();
		var is_family = this.type.is_family;
		var family_index = this.type.family_index;
		var beh_index = this.beh_index;
		var is_beh = (beh_index > -1);
		var params_vary = this.anyParamVariesPerInstance;
		var parameters = this.parameters;
		var results = this.results;
		var func = this.func;
		var i, j, leni, lenj, p, inst, offset;
		if (params_vary)
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
			{
				p = parameters[j];
				if (!p.variesPerInstance)
					results[j] = p.get(0);
			}
		}
		else
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
				results[j] = parameters[j].get(0);
		}
		for (i = 0, leni = instances.length; i < leni; ++i)
		{
			inst = instances[i];
			if (params_vary)
			{
				for (j = 0, lenj = parameters.length; j < lenj; ++j)
				{
					p = parameters[j];
					if (p.variesPerInstance)
						results[j] = p.get(i);    // pass i to use as default SOL index
				}
			}
			if (is_beh)
			{
				offset = 0;
				if (is_family)
				{
					offset = inst.type.family_beh_map[family_index];
				}
				func.apply(inst.behavior_insts[beh_index + offset], results);
			}
			else
				func.apply(inst, results);
		}
		return false;
	};
	cr.action = Action;
	var tempValues = [];
	var tempValuesPtr = -1;
	function Parameter(owner, m)
	{
		this.owner = owner;
		this.block = owner.block;
		this.sheet = owner.sheet;
		this.runtime = owner.runtime;
		this.type = m[0];
		this.expression = null;
		this.solindex = 0;
		this.get = null;
		this.combosel = 0;
		this.layout = null;
		this.key = 0;
		this.object = null;
		this.index = 0;
		this.varname = null;
		this.eventvar = null;
		this.fileinfo = null;
		this.subparams = null;
		this.variadicret = null;
		this.subparams = null;
		this.variadicret = null;
		this.variesPerInstance = false;
		var i, len, param;
		switch (m[0])
		{
			case 0:		// number
			case 7:		// any
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_exp;
				break;
			case 1:		// string
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_exp_str;
				break;
			case 5:		// layer
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_layer;
				break;
			case 3:		// combo
			case 8:		// cmp
				this.combosel = m[1];
				this.get = this.get_combosel;
				break;
			case 6:		// layout
				this.layout = this.runtime.layouts[m[1]];
;
				this.get = this.get_layout;
				break;
			case 9:		// keyb
				this.key = m[1];
				this.get = this.get_key;
				break;
			case 4:		// object
				this.object = this.runtime.types_by_index[m[1]];
;
				this.get = this.get_object;
				this.block.addSolModifier(this.object);
				if (this.owner instanceof cr.action)
					this.block.setSolWriterAfterCnds();
				else if (this.block.parent)
					this.block.parent.setSolWriterAfterCnds();
				break;
			case 10:	// instvar
				this.index = m[1];
				if (owner.type.is_family)
				{
					this.get = this.get_familyvar;
					this.variesPerInstance = true;
				}
				else
					this.get = this.get_instvar;
				break;
			case 11:	// eventvar
				this.varname = m[1];
				this.eventvar = null;
				this.get = this.get_eventvar;
				break;
			case 2:		// audiofile	["name", ismusic]
			case 12:	// fileinfo		"name"
				this.fileinfo = m[1];
				this.get = this.get_audiofile;
				break;
			case 13:	// variadic
				this.get = this.get_variadic;
				this.subparams = [];
				this.variadicret = [];
				for (i = 1, len = m.length; i < len; i++)
				{
					param = new cr.parameter(this.owner, m[i]);
					cr.seal(param);
					this.subparams.push(param);
					this.variadicret.push(0);
				}
				break;
			default:
;
		}
	};
	Parameter.prototype.postInit = function ()
	{
		var i, len;
		if (this.type === 11)		// eventvar
		{
			this.eventvar = this.runtime.getEventVariableByName(this.varname, this.block.parent);
;
		}
		else if (this.type === 13)	// variadic, postInit all sub-params
		{
			for (i = 0, len = this.subparams.length; i < len; i++)
				this.subparams[i].postInit();
		}
		if (this.expression)
			this.expression.postInit();
	};
	Parameter.prototype.maybeVaryForType = function (t)
	{
		if (this.variesPerInstance)
			return;				// already varies per instance, no need to check again
		if (!t)
			return;				// never vary for system type
		if (!t.plugin.singleglobal)
		{
			this.variesPerInstance = true;
			return;
		}
	};
	Parameter.prototype.setVaries = function ()
	{
		this.variesPerInstance = true;
	};
	Parameter.prototype.pushTempValue = function ()
	{
		tempValuesPtr++;
		if (tempValues.length === tempValuesPtr)
			tempValues.push(new cr.expvalue());
		return tempValues[tempValuesPtr];
	};
	Parameter.prototype.popTempValue = function ()
	{
		tempValuesPtr--;
	};
	Parameter.prototype.get_exp = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		return temp.data;      			// return actual JS value, not expvalue
	};
	Parameter.prototype.get_exp_str = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		if (cr.is_string(temp.data))
			return temp.data;
		else
			return "";
	};
	Parameter.prototype.get_object = function ()
	{
		return this.object;
	};
	Parameter.prototype.get_combosel = function ()
	{
		return this.combosel;
	};
	Parameter.prototype.get_layer = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		if (temp.is_number())
			return this.runtime.getLayerByNumber(temp.data);
		else
			return this.runtime.getLayerByName(temp.data);
	}
	Parameter.prototype.get_layout = function ()
	{
		return this.layout;
	};
	Parameter.prototype.get_key = function ()
	{
		return this.key;
	};
	Parameter.prototype.get_instvar = function ()
	{
		return this.index;
	};
	Parameter.prototype.get_familyvar = function (solindex_)
	{
		var solindex = solindex_ || 0;
		var familytype = this.owner.type;
		var realtype = null;
		var sol = familytype.getCurrentSol();
		var objs = sol.getObjects();
		if (objs.length)
			realtype = objs[solindex % objs.length].type;
		else if (sol.else_instances.length)
			realtype = sol.else_instances[solindex % sol.else_instances.length].type;
		else if (familytype.instances.length)
			realtype = familytype.instances[solindex % familytype.instances.length].type;
		else
			return 0;
		return this.index + realtype.family_var_map[familytype.family_index];
	};
	Parameter.prototype.get_eventvar = function ()
	{
		return this.eventvar;
	};
	Parameter.prototype.get_audiofile = function ()
	{
		return this.fileinfo;
	};
	Parameter.prototype.get_variadic = function ()
	{
		var i, len;
		for (i = 0, len = this.subparams.length; i < len; i++)
		{
			this.variadicret[i] = this.subparams[i].get();
		}
		return this.variadicret;
	};
	cr.parameter = Parameter;
	function EventVariable(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.name = m[1];
		this.vartype = m[2];
		this.initial = m[3];
		this.is_static = !!m[4];
		this.is_constant = !!m[5];
		this.sid = m[6];
		this.runtime.varsBySid[this.sid.toString()] = this;
		this.data = this.initial;	// note: also stored in event stack frame for local nonstatic nonconst vars
		if (this.parent)			// local var
		{
			if (this.is_static || this.is_constant)
				this.localIndex = -1;
			else
				this.localIndex = this.runtime.stackLocalCount++;
			this.runtime.all_local_vars.push(this);
		}
		else						// global var
		{
			this.localIndex = -1;
			this.runtime.all_global_vars.push(this);
		}
	};
	EventVariable.prototype.postInit = function ()
	{
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
	};
	EventVariable.prototype.setValue = function (x)
	{
;
		var lvs = this.runtime.getCurrentLocalVarStack();
		if (!this.parent || this.is_static || !lvs)
			this.data = x;
		else	// local nonstatic variable: use event stack to keep value at this level of recursion
		{
			if (this.localIndex >= lvs.length)
				lvs.length = this.localIndex + 1;
			lvs[this.localIndex] = x;
		}
	};
	EventVariable.prototype.getValue = function ()
	{
		var lvs = this.runtime.getCurrentLocalVarStack();
		if (!this.parent || this.is_static || !lvs || this.is_constant)
			return this.data;
		else	// local nonstatic variable
		{
			if (this.localIndex >= lvs.length)
			{
;
				return this.initial;
			}
			if (typeof lvs[this.localIndex] === "undefined")
			{
;
				return this.initial;
			}
			return lvs[this.localIndex];
		}
	};
	EventVariable.prototype.run = function ()
	{
			if (this.parent && !this.is_static && !this.is_constant)
				this.setValue(this.initial);
	};
	cr.eventvariable = EventVariable;
	function EventInclude(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.include_sheet = null;		// determined in postInit
		this.include_sheet_name = m[1];
		this.active = true;
	};
	EventInclude.prototype.toString = function ()
	{
		return "include:" + this.include_sheet.toString();
	};
	EventInclude.prototype.postInit = function ()
	{
        this.include_sheet = this.runtime.eventsheets[this.include_sheet_name];
;
;
        this.sheet.includes.add(this);
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
		var p = this.parent;
		while (p)
		{
			if (p.group)
				p.contained_includes.push(this);
			p = p.parent;
		}
		this.updateActive();
	};
	EventInclude.prototype.run = function ()
	{
			if (this.parent)
				this.runtime.pushCleanSol(this.runtime.types_by_index);
        if (!this.include_sheet.hasRun)
            this.include_sheet.run(true);			// from include
			if (this.parent)
				this.runtime.popSol(this.runtime.types_by_index);
	};
	EventInclude.prototype.updateActive = function ()
	{
		var p = this.parent;
		while (p)
		{
			if (p.group && !p.group_active)
			{
				this.active = false;
				return;
			}
			p = p.parent;
		}
		this.active = true;
	};
	EventInclude.prototype.isActive = function ()
	{
		return this.active;
	};
	cr.eventinclude = EventInclude;
	function EventStackFrame()
	{
		this.temp_parents_arr = [];
		this.reset(null);
		cr.seal(this);
	};
	EventStackFrame.prototype.reset = function (cur_event)
	{
		this.current_event = cur_event;
		this.cndindex = 0;
		this.actindex = 0;
		this.temp_parents_arr.length = 0;
		this.last_event_true = false;
		this.else_branch_ran = false;
		this.any_true_state = false;
	};
	EventStackFrame.prototype.isModifierAfterCnds = function ()
	{
		if (this.current_event.solWriterAfterCnds)
			return true;
		if (this.cndindex < this.current_event.conditions.length - 1)
			return !!this.current_event.solModifiers.length;
		return false;
	};
	cr.eventStackFrame = EventStackFrame;
}());
(function()
{
	function ExpNode(owner_, m)
	{
		this.owner = owner_;
		this.runtime = owner_.runtime;
		this.type = m[0];
;
		this.get = [this.eval_int,
					this.eval_float,
					this.eval_string,
					this.eval_unaryminus,
					this.eval_add,
					this.eval_subtract,
					this.eval_multiply,
					this.eval_divide,
					this.eval_mod,
					this.eval_power,
					this.eval_and,
					this.eval_or,
					this.eval_equal,
					this.eval_notequal,
					this.eval_less,
					this.eval_lessequal,
					this.eval_greater,
					this.eval_greaterequal,
					this.eval_conditional,
					this.eval_system_exp,
					this.eval_object_behavior_exp,
					this.eval_instvar_exp,
					this.eval_object_behavior_exp,
					this.eval_eventvar_exp][this.type];
		var paramsModel = null;
		this.value = null;
		this.first = null;
		this.second = null;
		this.third = null;
		this.func = null;
		this.results = null;
		this.parameters = null;
		this.object_type = null;
		this.beh_index = -1;
		this.instance_expr = null;
		this.varindex = -1;
		this.behavior_type = null;
		this.varname = null;
		this.eventvar = null;
		this.return_string = false;
		switch (this.type) {
		case 0:		// int
		case 1:		// float
		case 2:		// string
			this.value = m[1];
			break;
		case 3:		// unaryminus
			this.first = new cr.expNode(owner_, m[1]);
			break;
		case 18:	// conditional
			this.first = new cr.expNode(owner_, m[1]);
			this.second = new cr.expNode(owner_, m[2]);
			this.third = new cr.expNode(owner_, m[3]);
			break;
		case 19:	// system_exp
			this.func = m[1];
;
			if (this.func === cr.system_object.prototype.exps.random
			 || this.func === cr.system_object.prototype.exps.choose)
			{
				this.owner.setVaries();
			}
			this.results = [];
			this.parameters = [];
			if (m.length === 3)
			{
				paramsModel = m[2];
				this.results.length = paramsModel.length + 1;	// must also fit 'ret'
			}
			else
				this.results.length = 1;      // to fit 'ret'
			break;
		case 20:	// object_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.beh_index = -1;
			this.func = m[2];
			this.return_string = m[3];
			if (cr.plugins_.Function && this.func === cr.plugins_.Function.prototype.exps.Call)
			{
				this.owner.setVaries();
			}
			if (m[4])
				this.instance_expr = new cr.expNode(owner_, m[4]);
			else
				this.instance_expr = null;
			this.results = [];
			this.parameters = [];
			if (m.length === 6)
			{
				paramsModel = m[5];
				this.results.length = paramsModel.length + 1;
			}
			else
				this.results.length = 1;	// to fit 'ret'
			break;
		case 21:		// instvar_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.return_string = m[2];
			if (m[3])
				this.instance_expr = new cr.expNode(owner_, m[3]);
			else
				this.instance_expr = null;
			this.varindex = m[4];
			break;
		case 22:		// behavior_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.behavior_type = this.object_type.getBehaviorByName(m[2]);
;
			this.beh_index = this.object_type.getBehaviorIndexByName(m[2]);
			this.func = m[3];
			this.return_string = m[4];
			if (m[5])
				this.instance_expr = new cr.expNode(owner_, m[5]);
			else
				this.instance_expr = null;
			this.results = [];
			this.parameters = [];
			if (m.length === 7)
			{
				paramsModel = m[6];
				this.results.length = paramsModel.length + 1;
			}
			else
				this.results.length = 1;	// to fit 'ret'
			break;
		case 23:		// eventvar_exp
			this.varname = m[1];
			this.eventvar = null;	// assigned in postInit
			break;
		}
		this.owner.maybeVaryForType(this.object_type);
		if (this.type >= 4 && this.type <= 17)
		{
			this.first = new cr.expNode(owner_, m[1]);
			this.second = new cr.expNode(owner_, m[2]);
		}
		if (paramsModel)
		{
			var i, len;
			for (i = 0, len = paramsModel.length; i < len; i++)
				this.parameters.push(new cr.expNode(owner_, paramsModel[i]));
		}
		cr.seal(this);
	};
	ExpNode.prototype.postInit = function ()
	{
		if (this.type === 23)	// eventvar_exp
		{
			this.eventvar = this.owner.runtime.getEventVariableByName(this.varname, this.owner.block.parent);
;
		}
		if (this.first)
			this.first.postInit();
		if (this.second)
			this.second.postInit();
		if (this.third)
			this.third.postInit();
		if (this.instance_expr)
			this.instance_expr.postInit();
		if (this.parameters)
		{
			var i, len;
			for (i = 0, len = this.parameters.length; i < len; i++)
				this.parameters[i].postInit();
		}
	};
	ExpNode.prototype.eval_system_exp = function (ret)
	{
		this.results[0] = ret;
		var temp = this.owner.pushTempValue();
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			this.parameters[i].get(temp);
			this.results[i + 1] = temp.data;   // passing actual javascript value as argument instead of expvalue
		}
		this.owner.popTempValue();
		this.func.apply(this.runtime.system, this.results);
	};
	ExpNode.prototype.eval_object_behavior_exp = function (ret)
	{
		var sol = this.object_type.getCurrentSol();
		var instances = sol.getObjects();
		if (!instances.length)
		{
			if (sol.else_instances.length)
				instances = sol.else_instances;
			else
			{
				if (this.return_string)
					ret.set_string("");
				else
					ret.set_int(0);
				return;
			}
		}
		this.results[0] = ret;
		ret.object_class = this.object_type;		// so expression can access family type if need be
		var temp = this.owner.pushTempValue();
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++) {
			this.parameters[i].get(temp);
			this.results[i + 1] = temp.data;   // passing actual javascript value as argument instead of expvalue
		}
		var index = this.owner.solindex;
		if (this.instance_expr) {
			this.instance_expr.get(temp);
			if (temp.is_number()) {
				index = temp.data;
				instances = this.object_type.instances;    // pick from all instances, not SOL
			}
		}
		this.owner.popTempValue();
		index %= instances.length;      // wraparound
		if (index < 0)
			index += instances.length;
		var returned_val;
		var inst = instances[index];
		if (this.beh_index > -1)
		{
			var offset = 0;
			if (this.object_type.is_family)
			{
				offset = inst.type.family_beh_map[this.object_type.family_index];
			}
			returned_val = this.func.apply(inst.behavior_insts[this.beh_index + offset], this.results);
		}
		else
			returned_val = this.func.apply(inst, this.results);
;
	};
	ExpNode.prototype.eval_instvar_exp = function (ret)
	{
		var sol = this.object_type.getCurrentSol();
		var instances = sol.getObjects();
		if (!instances.length)
		{
			if (sol.else_instances.length)
				instances = sol.else_instances;
			else
			{
				if (this.return_string)
					ret.set_string("");
				else
					ret.set_int(0);
				return;
			}
		}
		var index = this.owner.solindex;
		if (this.instance_expr)
		{
			var temp = this.owner.pushTempValue();
			this.instance_expr.get(temp);
			if (temp.is_number())
			{
				index = temp.data;
				var type_instances = this.object_type.instances;
				index %= type_instances.length;     // wraparound
				if (index < 0)                      // offset
					index += type_instances.length;
				var to_ret = type_instances[index].instance_vars[this.varindex];
				if (cr.is_string(to_ret))
					ret.set_string(to_ret);
				else
					ret.set_float(to_ret);
				this.owner.popTempValue();
				return;         // done
			}
			this.owner.popTempValue();
		}
		index %= instances.length;      // wraparound
		if (index < 0)
			index += instances.length;
		var inst = instances[index];
		var offset = 0;
		if (this.object_type.is_family)
		{
			offset = inst.type.family_var_map[this.object_type.family_index];
		}
		var to_ret = inst.instance_vars[this.varindex + offset];
		if (cr.is_string(to_ret))
			ret.set_string(to_ret);
		else
			ret.set_float(to_ret);
	};
	ExpNode.prototype.eval_int = function (ret)
	{
		ret.type = cr.exptype.Integer;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_float = function (ret)
	{
		ret.type = cr.exptype.Float;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_string = function (ret)
	{
		ret.type = cr.exptype.String;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_unaryminus = function (ret)
	{
		this.first.get(ret);                // retrieve operand
		if (ret.is_number())
			ret.data = -ret.data;
	};
	ExpNode.prototype.eval_add = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data += temp.data;          // both operands numbers: add
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_subtract = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data -= temp.data;          // both operands numbers: subtract
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_multiply = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data *= temp.data;          // both operands numbers: multiply
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_divide = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data /= temp.data;          // both operands numbers: divide
			ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_mod = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data %= temp.data;          // both operands numbers: modulo
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_power = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data = Math.pow(ret.data, temp.data);   // both operands numbers: raise to power
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_and = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number())
		{
			if (temp.is_string())
			{
				ret.set_string(ret.data.toString() + temp.data);
			}
			else
			{
				if (ret.data && temp.data)
					ret.set_int(1);
				else
					ret.set_int(0);
			}
		}
		else if (ret.is_string())
		{
			if (temp.is_string())
				ret.data += temp.data;
			else
			{
				ret.data += (Math.round(temp.data * 1e10) / 1e10).toString();
			}
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_or = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			if (ret.data || temp.data)
				ret.set_int(1);
			else
				ret.set_int(0);
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_conditional = function (ret)
	{
		this.first.get(ret);                // condition operand
		if (ret.data)                       // is true
			this.second.get(ret);           // evaluate second operand to ret
		else
			this.third.get(ret);            // evaluate third operand to ret
	};
	ExpNode.prototype.eval_equal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data === temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_notequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data !== temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_less = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data < temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_lessequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data <= temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_greater = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data > temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_greaterequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data >= temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_eventvar_exp = function (ret)
	{
		var val = this.eventvar.getValue();
		if (cr.is_number(val))
			ret.set_float(val);
		else
			ret.set_string(val);
	};
	cr.expNode = ExpNode;
	function ExpValue(type, data)
	{
		this.type = type || cr.exptype.Integer;
		this.data = data || 0;
		this.object_class = null;
;
;
;
		if (this.type == cr.exptype.Integer)
			this.data = Math.floor(this.data);
		cr.seal(this);
	};
	ExpValue.prototype.is_int = function ()
	{
		return this.type === cr.exptype.Integer;
	};
	ExpValue.prototype.is_float = function ()
	{
		return this.type === cr.exptype.Float;
	};
	ExpValue.prototype.is_number = function ()
	{
		return this.type === cr.exptype.Integer || this.type === cr.exptype.Float;
	};
	ExpValue.prototype.is_string = function ()
	{
		return this.type === cr.exptype.String;
	};
	ExpValue.prototype.make_int = function ()
	{
		if (!this.is_int())
		{
			if (this.is_float())
				this.data = Math.floor(this.data);      // truncate float
			else if (this.is_string())
				this.data = parseInt(this.data, 10);
			this.type = cr.exptype.Integer;
		}
	};
	ExpValue.prototype.make_float = function ()
	{
		if (!this.is_float())
		{
			if (this.is_string())
				this.data = parseFloat(this.data);
			this.type = cr.exptype.Float;
		}
	};
	ExpValue.prototype.make_string = function ()
	{
		if (!this.is_string())
		{
			this.data = this.data.toString();
			this.type = cr.exptype.String;
		}
	};
	ExpValue.prototype.set_int = function (val)
	{
;
		this.type = cr.exptype.Integer;
		this.data = Math.floor(val);
	};
	ExpValue.prototype.set_float = function (val)
	{
;
		this.type = cr.exptype.Float;
		this.data = val;
	};
	ExpValue.prototype.set_string = function (val)
	{
;
		this.type = cr.exptype.String;
		this.data = val;
	};
	ExpValue.prototype.set_any = function (val)
	{
		if (cr.is_number(val))
		{
			this.type = cr.exptype.Float;
			this.data = val;
		}
		else if (cr.is_string(val))
		{
			this.type = cr.exptype.String;
			this.data = val.toString();
		}
		else
		{
			this.type = cr.exptype.Integer;
			this.data = 0;
		}
	};
	cr.expvalue = ExpValue;
	cr.exptype = {
		Integer: 0,     // emulated; no native integer support in javascript
		Float: 1,
		String: 2
	};
}());
;
cr.system_object = function (runtime)
{
    this.runtime = runtime;
	this.waits = [];
};
cr.system_object.prototype.saveToJSON = function ()
{
	var o = {};
	var i, len, j, lenj, p, w, t, sobj;
	o["waits"] = [];
	var owaits = o["waits"];
	var waitobj;
	for (i = 0, len = this.waits.length; i < len; i++)
	{
		w = this.waits[i];
		waitobj = {
			"t": w.time,
			"ev": w.ev.sid,
			"sm": [],
			"sols": {}
		};
		if (w.ev.actions[w.actindex])
			waitobj["act"] = w.ev.actions[w.actindex].sid;
		for (j = 0, lenj = w.solModifiers.length; j < lenj; j++)
			waitobj["sm"].push(w.solModifiers[j].sid);
		for (p in w.sols)
		{
			if (w.sols.hasOwnProperty(p))
			{
				t = this.runtime.types_by_index[parseInt(p, 10)];
;
				sobj = {
					"sa": w.sols[p].sa,
					"insts": []
				};
				for (j = 0, lenj = w.sols[p].insts.length; j < lenj; j++)
					sobj["insts"].push(w.sols[p].insts[j].uid);
				waitobj["sols"][t.sid.toString()] = sobj;
			}
		}
		owaits.push(waitobj);
	}
	return o;
};
cr.system_object.prototype.loadFromJSON = function (o)
{
	var owaits = o["waits"];
	var i, len, j, lenj, p, w, addWait, e, aindex, t, savedsol, nusol, inst;
	this.waits.length = 0;
	for (i = 0, len = owaits.length; i < len; i++)
	{
		w = owaits[i];
		e = this.runtime.blocksBySid[w["ev"].toString()];
		if (!e)
			continue;	// event must've gone missing
		aindex = -1;
		for (j = 0, lenj = e.actions.length; j < lenj; j++)
		{
			if (e.actions[j].sid === w["act"])
			{
				aindex = j;
				break;
			}
		}
		if (aindex === -1)
			continue;	// action must've gone missing
		addWait = {};
		addWait.sols = {};
		addWait.solModifiers = [];
		addWait.deleteme = false;
		addWait.time = w["t"];
		addWait.ev = e;
		addWait.actindex = aindex;
		for (j = 0, lenj = w["sm"].length; j < lenj; j++)
		{
			t = this.runtime.getObjectTypeBySid(w["sm"][j]);
			if (t)
				addWait.solModifiers.push(t);
		}
		for (p in w["sols"])
		{
			if (w["sols"].hasOwnProperty(p))
			{
				t = this.runtime.getObjectTypeBySid(parseInt(p, 10));
				if (!t)
					continue;		// type must've been deleted
				savedsol = w["sols"][p];
				nusol = {
					sa: savedsol["sa"],
					insts: []
				};
				for (j = 0, lenj = savedsol["insts"].length; j < lenj; j++)
				{
					inst = this.runtime.getObjectByUID(savedsol["insts"][j]);
					if (inst)
						nusol.insts.push(inst);
				}
				addWait.sols[t.index.toString()] = nusol;
			}
		}
		this.waits.push(addWait);
	}
};
(function ()
{
	var sysProto = cr.system_object.prototype;
	function SysCnds() {};
    SysCnds.prototype.EveryTick = function()
    {
        return true;
    };
    SysCnds.prototype.OnLayoutStart = function()
    {
        return true;
    };
    SysCnds.prototype.OnLayoutEnd = function()
    {
        return true;
    };
    SysCnds.prototype.Compare = function(x, cmp, y)
    {
        return cr.do_cmp(x, cmp, y);
    };
    SysCnds.prototype.CompareTime = function (cmp, t)
    {
        var elapsed = this.runtime.kahanTime.sum;
        if (cmp === 0)
        {
            var cnd = this.runtime.getCurrentCondition();
            if (!cnd.extra.CompareTime_executed)
            {
                if (elapsed >= t)
                {
                    cnd.extra.CompareTime_executed = true;
                    return true;
                }
            }
            return false;
        }
        return cr.do_cmp(elapsed, cmp, t);
    };
    SysCnds.prototype.LayerVisible = function (layer)
    {
        if (!layer)
            return false;
        else
            return layer.visible;
    };
	SysCnds.prototype.LayerCmpOpacity = function (layer, cmp, opacity_)
	{
		if (!layer)
			return false;
		return cr.do_cmp(layer.opacity * 100, cmp, opacity_);
	};
    SysCnds.prototype.Repeat = function (count)
    {
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i;
		if (solModifierAfterCnds)
		{
			for (i = 0; i < count && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			for (i = 0; i < count && !current_loop.stopped; i++)
			{
				current_loop.index = i;
				current_event.retrigger();
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
	SysCnds.prototype.While = function (count)
    {
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i;
		if (solModifierAfterCnds)
		{
			for (i = 0; !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				current_loop.index = i;
				if (!current_event.retrigger())		// one of the other conditions returned false
					current_loop.stopped = true;	// break
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			for (i = 0; !current_loop.stopped; i++)
			{
				current_loop.index = i;
				if (!current_event.retrigger())
					current_loop.stopped = true;
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
    SysCnds.prototype.For = function (name, start, end)
    {
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack(name);
        var i;
		if (end < start)
		{
			if (solModifierAfterCnds)
			{
				for (i = start; i >= end && !current_loop.stopped; --i)  // inclusive to end
				{
					this.runtime.pushCopySol(current_event.solModifiers);
					current_loop.index = i;
					current_event.retrigger();
					this.runtime.popSol(current_event.solModifiers);
				}
			}
			else
			{
				for (i = start; i >= end && !current_loop.stopped; --i)  // inclusive to end
				{
					current_loop.index = i;
					current_event.retrigger();
				}
			}
		}
		else
		{
			if (solModifierAfterCnds)
			{
				for (i = start; i <= end && !current_loop.stopped; ++i)  // inclusive to end
				{
					this.runtime.pushCopySol(current_event.solModifiers);
					current_loop.index = i;
					current_event.retrigger();
					this.runtime.popSol(current_event.solModifiers);
				}
			}
			else
			{
				for (i = start; i <= end && !current_loop.stopped; ++i)  // inclusive to end
				{
					current_loop.index = i;
					current_event.retrigger();
				}
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
	var foreach_instancestack = [];
	var foreach_instanceptr = -1;
    SysCnds.prototype.ForEach = function (obj)
    {
        var sol = obj.getCurrentSol();
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var instances = foreach_instancestack[foreach_instanceptr];
		cr.shallowAssignArray(instances, sol.getObjects());
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i, len, j, lenj, inst, s, sol2;
		var is_contained = obj.is_contained;
		if (solModifierAfterCnds)
		{
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				inst = instances[i];
				sol = obj.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			sol.select_all = false;
			sol.instances.length = 1;
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				inst = instances[i];
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
			}
		}
		instances.length = 0;
        this.runtime.popLoopStack();
		foreach_instanceptr--;
		return false;
    };
	function foreach_sortinstances(a, b)
	{
		var va = a.extra.c2_foreachordered_val;
		var vb = b.extra.c2_foreachordered_val;
		if (cr.is_number(va) && cr.is_number(vb))
			return va - vb;
		else
		{
			va = "" + va;
			vb = "" + vb;
			if (va < vb)
				return -1;
			else if (va > vb)
				return 1;
			else
				return 0;
		}
	};
	SysCnds.prototype.ForEachOrdered = function (obj, exp, order)
    {
        var sol = obj.getCurrentSol();
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var instances = foreach_instancestack[foreach_instanceptr];
		cr.shallowAssignArray(instances, sol.getObjects());
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var current_condition = this.runtime.getCurrentCondition();
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
		var i, len, j, lenj, inst, s, sol2;
		for (i = 0, len = instances.length; i < len; i++)
		{
			instances[i].extra.c2_foreachordered_val = current_condition.parameters[1].get(i);
		}
		instances.sort(foreach_sortinstances);
		if (order === 1)
			instances.reverse();
		var is_contained = obj.is_contained;
		if (solModifierAfterCnds)
		{
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				inst = instances[i];
				sol = obj.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			sol.select_all = false;
			sol.instances.length = 1;
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				inst = instances[i];
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
			}
		}
		instances.length = 0;
        this.runtime.popLoopStack();
		foreach_instanceptr--;
		return false;
    };
	SysCnds.prototype.PickByComparison = function (obj_, exp_, cmp_, val_)
	{
		var i, len, k, inst;
		if (!obj_)
			return;
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var tmp_instances = foreach_instancestack[foreach_instanceptr];
		var sol = obj_.getCurrentSol();
		cr.shallowAssignArray(tmp_instances, sol.getObjects());
		if (sol.select_all)
			sol.else_instances.length = 0;
		var current_condition = this.runtime.getCurrentCondition();
		for (i = 0, k = 0, len = tmp_instances.length; i < len; i++)
		{
			inst = tmp_instances[i];
			tmp_instances[k] = inst;
			exp_ = current_condition.parameters[1].get(i);
			val_ = current_condition.parameters[3].get(i);
			if (cr.do_cmp(exp_, cmp_, val_))
			{
				k++;
			}
			else
			{
				sol.else_instances.push(inst);
			}
		}
		tmp_instances.length = k;
		sol.select_all = false;
		cr.shallowAssignArray(sol.instances, tmp_instances);
		tmp_instances.length = 0;
		foreach_instanceptr--;
		obj_.applySolToContainer();
		return !!sol.instances.length;
	};
	SysCnds.prototype.PickByEvaluate = function (obj_, exp_)
	{
		var i, len, k, inst;
		if (!obj_)
			return;
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var tmp_instances = foreach_instancestack[foreach_instanceptr];
		var sol = obj_.getCurrentSol();
		cr.shallowAssignArray(tmp_instances, sol.getObjects());
		if (sol.select_all)
			sol.else_instances.length = 0;
		var current_condition = this.runtime.getCurrentCondition();
		for (i = 0, k = 0, len = tmp_instances.length; i < len; i++)
		{
			inst = tmp_instances[i];
			tmp_instances[k] = inst;
			exp_ = current_condition.parameters[1].get(i);
			if (exp_)
			{
				k++;
			}
			else
			{
				sol.else_instances.push(inst);
			}
		}
		tmp_instances.length = k;
		sol.select_all = false;
		cr.shallowAssignArray(sol.instances, tmp_instances);
		tmp_instances.length = 0;
		foreach_instanceptr--;
		obj_.applySolToContainer();
		return !!sol.instances.length;
	};
    SysCnds.prototype.TriggerOnce = function ()
    {
        var cndextra = this.runtime.getCurrentCondition().extra;
		if (typeof cndextra.TriggerOnce_lastTick === "undefined")
			cndextra.TriggerOnce_lastTick = -1;
        var last_tick = cndextra.TriggerOnce_lastTick;
        var cur_tick = this.runtime.tickcount;
        cndextra.TriggerOnce_lastTick = cur_tick;
        return this.runtime.layout_first_tick || last_tick !== cur_tick - 1;
    };
    SysCnds.prototype.Every = function (seconds)
    {
        var cnd = this.runtime.getCurrentCondition();
        var last_time = cnd.extra.Every_lastTime || 0;
        var cur_time = this.runtime.kahanTime.sum;
		if (typeof cnd.extra.Every_seconds === "undefined")
			cnd.extra.Every_seconds = seconds;
		var this_seconds = cnd.extra.Every_seconds;
        if (cur_time >= last_time + this_seconds)
        {
            cnd.extra.Every_lastTime = last_time + this_seconds;
			if (cur_time >= cnd.extra.Every_lastTime + 0.04)
			{
				cnd.extra.Every_lastTime = cur_time;
			}
			cnd.extra.Every_seconds = seconds;
            return true;
        }
		else if (cur_time < last_time - 0.1)
		{
			cnd.extra.Every_lastTime = cur_time;
		}
		return false;
    };
    SysCnds.prototype.PickNth = function (obj, index)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
		index = cr.floor(index);
        if (index < 0 || index >= instances.length)
            return false;
		var inst = instances[index];
        sol.pick_one(inst);
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.PickRandom = function (obj)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
		var index = cr.floor(Math.random() * instances.length);
        if (index >= instances.length)
            return false;
		var inst = instances[index];
        sol.pick_one(inst);
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.CompareVar = function (v, cmp, val)
    {
        return cr.do_cmp(v.getValue(), cmp, val);
    };
    SysCnds.prototype.IsGroupActive = function (group)
    {
		var g = this.runtime.groups_by_name[group.toLowerCase()];
        return g && g.group_active;
    };
	SysCnds.prototype.IsPreview = function ()
	{
		return typeof cr_is_preview !== "undefined";
	};
	SysCnds.prototype.PickAll = function (obj)
    {
        if (!obj)
            return false;
		if (!obj.instances.length)
			return false;
        var sol = obj.getCurrentSol();
        sol.select_all = true;
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.IsMobile = function ()
	{
		return this.runtime.isMobile;
	};
	SysCnds.prototype.CompareBetween = function (x, a, b)
	{
		return x >= a && x <= b;
	};
	SysCnds.prototype.Else = function ()
	{
		var current_frame = this.runtime.getCurrentEventStack();
		if (current_frame.else_branch_ran)
			return false;		// another event in this else-if chain has run
		else
			return !current_frame.last_event_true;
		/*
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var prev_event = current_event.prev_block;
		if (!prev_event)
			return false;
		if (prev_event.is_logical)
			return !this.runtime.last_event_true;
		var i, len, j, lenj, s, sol, temp, inst, any_picked = false;
		for (i = 0, len = prev_event.cndReferences.length; i < len; i++)
		{
			s = prev_event.cndReferences[i];
			sol = s.getCurrentSol();
			if (sol.select_all || sol.instances.length === s.instances.length)
			{
				sol.select_all = false;
				sol.instances.length = 0;
			}
			else
			{
				if (sol.instances.length === 1 && sol.else_instances.length === 0 && s.instances.length >= 2)
				{
					inst = sol.instances[0];
					sol.instances.length = 0;
					for (j = 0, lenj = s.instances.length; j < lenj; j++)
					{
						if (s.instances[j] != inst)
							sol.instances.push(s.instances[j]);
					}
					any_picked = true;
				}
				else
				{
					temp = sol.instances;
					sol.instances = sol.else_instances;
					sol.else_instances = temp;
					any_picked = true;
				}
			}
		}
		return any_picked;
		*/
	};
	SysCnds.prototype.OnLoadFinished = function ()
	{
		return true;
	};
	SysCnds.prototype.OnCanvasSnapshot = function ()
	{
		return true;
	};
	SysCnds.prototype.EffectsSupported = function ()
	{
		return !!this.runtime.glwrap;
	};
	SysCnds.prototype.OnSaveComplete = function ()
	{
		return true;
	};
	SysCnds.prototype.OnLoadComplete = function ()
	{
		return true;
	};
	SysCnds.prototype.OnLoadFailed = function ()
	{
		return true;
	};
	SysCnds.prototype.ObjectUIDExists = function (u)
	{
		return !!this.runtime.getObjectByUID(u);
	};
	SysCnds.prototype.IsOnPlatform = function (p)
	{
		var rt = this.runtime;
		switch (p) {
		case 0:		// HTML5 website
			return !rt.isDomFree && !rt.isNodeWebkit && !rt.isPhoneGap && !rt.isCrosswalk && !rt.isWinJS && !rt.isWindowsPhone8 && !rt.isBlackberry10 && !rt.isAmazonWebApp;
		case 1:		// iOS
			return rt.isiOS;
		case 2:		// Android
			return rt.isAndroid;
		case 3:		// Windows 8
			return rt.isWindows8App;
		case 4:		// Windows Phone 8
			return rt.isWindowsPhone8;
		case 5:		// Blackberry 10
			return rt.isBlackberry10;
		case 6:		// Tizen
			return rt.isTizen;
		case 7:		// CocoonJS
			return rt.isCocoonJs;
		case 8:		// PhoneGap
			return rt.isPhoneGap;
		case 9:	// Scirra Arcade
			return rt.isArcade;
		case 10:	// node-webkit
			return rt.isNodeWebkit;
		case 11:	// crosswalk
			return rt.isCrosswalk;
		case 12:	// amazon webapp
			return rt.isAmazonWebApp;
		default:	// should not be possible
			return false;
		}
	};
	var cacheRegex = null;
	var lastRegex = "";
	var lastFlags = "";
	function getRegex(regex_, flags_)
	{
		if (!cacheRegex || regex_ !== lastRegex || flags_ !== lastFlags)
		{
			cacheRegex = new RegExp(regex_, flags_);
			lastRegex = regex_;
			lastFlags = flags_;
		}
		cacheRegex.lastIndex = 0;		// reset
		return cacheRegex;
	};
	SysCnds.prototype.RegexTest = function (str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		return regex.test(str_);
	};
	var tmp_arr = [];
	SysCnds.prototype.PickOverlappingPoint = function (obj_, x_, y_)
	{
		if (!obj_)
            return false;
        var sol = obj_.getCurrentSol();
        var instances = sol.getObjects();
		var current_event = this.runtime.getCurrentEventStack().current_event;
		var orblock = current_event.orblock;
		var cnd = this.runtime.getCurrentCondition();
		var i, len, inst, pick;
		if (sol.select_all)
		{
			cr.shallowAssignArray(tmp_arr, instances);
			sol.else_instances.length = 0;
			sol.select_all = false;
			sol.instances.length = 0;
		}
		else
		{
			if (orblock)
			{
				cr.shallowAssignArray(tmp_arr, sol.else_instances);
				sol.else_instances.length = 0;
			}
			else
			{
				cr.shallowAssignArray(tmp_arr, instances);
				sol.instances.length = 0;
			}
		}
		for (i = 0, len = tmp_arr.length; i < len; ++i)
		{
			inst = tmp_arr[i];
			inst.update_bbox();
			pick = cr.xor(inst.contains_pt(x_, y_), cnd.inverted);
			if (pick)
				sol.instances.push(inst);
			else
				sol.else_instances.push(inst);
		}
		obj_.applySolToContainer();
		return cr.xor(!!sol.instances.length, cnd.inverted);
	};
	sysProto.cnds = new SysCnds();
    function SysActs() {};
    SysActs.prototype.GoToLayout = function(to)
    {
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
;
        this.runtime.changelayout = to;
    };
    SysActs.prototype.CreateObject = function (obj, layer, x, y)
    {
        if (!layer || !obj)
            return;
        var inst = this.runtime.createInstance(obj, layer, x, y);
		if (!inst)
			return;
		this.runtime.isInOnDestroy++;
		var i, len, s;
		this.runtime.trigger(Object.getPrototypeOf(obj.plugin).cnds.OnCreated, inst);
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				this.runtime.trigger(Object.getPrototypeOf(s.type.plugin).cnds.OnCreated, s);
			}
		}
		this.runtime.isInOnDestroy--;
        var sol = obj.getCurrentSol();
        sol.select_all = false;
		sol.instances.length = 1;
		sol.instances[0] = inst;
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				sol = s.type.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = s;
			}
		}
    };
    SysActs.prototype.SetLayerVisible = function (layer, visible_)
    {
        if (!layer)
            return;
		if (layer.visible !== visible_)
		{
			layer.visible = visible_;
			this.runtime.redraw = true;
		}
    };
	SysActs.prototype.SetLayerOpacity = function (layer, opacity_)
	{
		if (!layer)
			return;
		opacity_ = cr.clamp(opacity_ / 100, 0, 1);
		if (layer.opacity !== opacity_)
		{
			layer.opacity = opacity_;
			this.runtime.redraw = true;
		}
	};
	SysActs.prototype.SetLayerScaleRate = function (layer, sr)
	{
		if (!layer)
			return;
		if (layer.zoomRate !== sr)
		{
			layer.zoomRate = sr;
			this.runtime.redraw = true;
		}
	};
	SysActs.prototype.SetLayoutScale = function (s)
	{
		if (!this.runtime.running_layout)
			return;
		if (this.runtime.running_layout.scale !== s)
		{
			this.runtime.running_layout.scale = s;
			this.runtime.running_layout.boundScrolling();
			this.runtime.redraw = true;
		}
	};
    SysActs.prototype.ScrollX = function(x)
    {
        this.runtime.running_layout.scrollToX(x);
    };
    SysActs.prototype.ScrollY = function(y)
    {
        this.runtime.running_layout.scrollToY(y);
    };
    SysActs.prototype.Scroll = function(x, y)
    {
        this.runtime.running_layout.scrollToX(x);
        this.runtime.running_layout.scrollToY(y);
    };
    SysActs.prototype.ScrollToObject = function(obj)
    {
        var inst = obj.getFirstPicked();
        if (inst)
        {
            this.runtime.running_layout.scrollToX(inst.x);
            this.runtime.running_layout.scrollToY(inst.y);
        }
    };
	SysActs.prototype.SetVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(x);
			else
				v.setValue(parseFloat(x));
		}
		else if (v.vartype === 1)
			v.setValue(x.toString());
	};
	SysActs.prototype.AddVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(v.getValue() + x);
			else
				v.setValue(v.getValue() + parseFloat(x));
		}
		else if (v.vartype === 1)
			v.setValue(v.getValue() + x.toString());
	};
	SysActs.prototype.SubVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(v.getValue() - x);
			else
				v.setValue(v.getValue() - parseFloat(x));
		}
	};
    SysActs.prototype.SetGroupActive = function (group, active)
    {
		var g = this.runtime.groups_by_name[group.toLowerCase()];
		if (!g)
			return;
		switch (active) {
		case 0:
			g.setGroupActive(false);
			break;
		case 1:
			g.setGroupActive(true);
			break;
		case 2:
			g.setGroupActive(!g.group_active);
			break;
		}
    };
    SysActs.prototype.SetTimescale = function (ts_)
    {
        var ts = ts_;
        if (ts < 0)
            ts = 0;
        this.runtime.timescale = ts;
    };
    SysActs.prototype.SetObjectTimescale = function (obj, ts_)
    {
        var ts = ts_;
        if (ts < 0)
            ts = 0;
        if (!obj)
            return;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
        var i, len;
        for (i = 0, len = instances.length; i < len; i++)
        {
            instances[i].my_timescale = ts;
        }
    };
    SysActs.prototype.RestoreObjectTimescale = function (obj)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
        var i, len;
        for (i = 0, len = instances.length; i < len; i++)
        {
            instances[i].my_timescale = -1.0;
        }
    };
	var waitobjrecycle = [];
	function allocWaitObject()
	{
		var w;
		if (waitobjrecycle.length)
			w = waitobjrecycle.pop();
		else
		{
			w = {};
			w.sols = {};
			w.solModifiers = [];
		}
		w.deleteme = false;
		return w;
	};
	function freeWaitObject(w)
	{
		cr.wipe(w.sols);
		w.solModifiers.length = 0;
		waitobjrecycle.push(w);
	};
	var solstateobjects = [];
	function allocSolStateObject()
	{
		var s;
		if (solstateobjects.length)
			s = solstateobjects.pop();
		else
		{
			s = {};
			s.insts = [];
		}
		s.sa = false;
		return s;
	};
	function freeSolStateObject(s)
	{
		s.insts.length = 0;
		solstateobjects.push(s);
	};
	SysActs.prototype.Wait = function (seconds)
	{
		if (seconds < 0)
			return;
		var i, len, s, t, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		var waitobj = allocWaitObject();
		waitobj.time = this.runtime.kahanTime.sum + seconds;
		waitobj.ev = evinfo.current_event;
		waitobj.actindex = evinfo.actindex + 1;	// pointing at next action
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			t = this.runtime.types_by_index[i];
			s = t.getCurrentSol();
			if (s.select_all && evinfo.current_event.solModifiers.indexOf(t) === -1)
				continue;
			waitobj.solModifiers.push(t);
			ss = allocSolStateObject();
			ss.sa = s.select_all;
			cr.shallowAssignArray(ss.insts, s.instances);
			waitobj.sols[i.toString()] = ss;
		}
		this.waits.push(waitobj);
		return true;
	};
	SysActs.prototype.SetLayerScale = function (layer, scale)
    {
        if (!layer)
            return;
		if (layer.scale === scale)
			return;
        layer.scale = scale;
        this.runtime.redraw = true;
    };
	SysActs.prototype.ResetGlobals = function ()
	{
		var i, len, g;
		for (i = 0, len = this.runtime.all_global_vars.length; i < len; i++)
		{
			g = this.runtime.all_global_vars[i];
			g.data = g.initial;
		}
	};
	SysActs.prototype.SetLayoutAngle = function (a)
	{
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (this.runtime.running_layout)
		{
			if (this.runtime.running_layout.angle !== a)
			{
				this.runtime.running_layout.angle = a;
				this.runtime.redraw = true;
			}
		}
	};
	SysActs.prototype.SetLayerAngle = function (layer, a)
    {
        if (!layer)
            return;
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (layer.angle === a)
			return;
        layer.angle = a;
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerParallax = function (layer, px, py)
    {
        if (!layer)
            return;
		if (layer.parallaxX === px / 100 && layer.parallaxY === py / 100)
			return;
        layer.parallaxX = px / 100;
		layer.parallaxY = py / 100;
		if (layer.parallaxX !== 1 || layer.parallaxY !== 1)
		{
			var i, len, instances = layer.instances;
			for (i = 0, len = instances.length; i < len; ++i)
			{
				instances[i].type.any_instance_parallaxed = true;
			}
		}
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerBackground = function (layer, c)
    {
        if (!layer)
            return;
		var r = cr.GetRValue(c);
		var g = cr.GetGValue(c);
		var b = cr.GetBValue(c);
		if (layer.background_color[0] === r && layer.background_color[1] === g && layer.background_color[2] === b)
			return;
        layer.background_color[0] = r;
		layer.background_color[1] = g;
		layer.background_color[2] = b;
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerTransparent = function (layer, t)
    {
        if (!layer)
            return;
		if (!!t === !!layer.transparent)
			return;
		layer.transparent = !!t;
        this.runtime.redraw = true;
    };
	SysActs.prototype.StopLoop = function ()
	{
		if (this.runtime.loop_stack_index < 0)
			return;		// no loop currently running
		this.runtime.getCurrentLoop().stopped = true;
	};
	SysActs.prototype.GoToLayoutByName = function (layoutname)
	{
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to different layout
;
		var l;
		for (l in this.runtime.layouts)
		{
			if (this.runtime.layouts.hasOwnProperty(l) && cr.equals_nocase(l, layoutname))
			{
				this.runtime.changelayout = this.runtime.layouts[l];
				return;
			}
		}
	};
	SysActs.prototype.RestartLayout = function (layoutname)
	{
		if (this.runtime.isloading)
			return;		// cannot restart loader layouts
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
;
		if (!this.runtime.running_layout)
			return;
		this.runtime.changelayout = this.runtime.running_layout;
		var i, len, g;
		for (i = 0, len = this.runtime.allGroups.length; i < len; i++)
		{
			g = this.runtime.allGroups[i];
			g.setGroupActive(g.initially_activated);
		}
	};
	SysActs.prototype.SnapshotCanvas = function (format_, quality_)
	{
		this.runtime.snapshotCanvas = [format_ === 0 ? "image/png" : "image/jpeg", quality_ / 100];
		this.runtime.redraw = true;		// force redraw so snapshot is always taken
	};
	SysActs.prototype.SetCanvasSize = function (w, h)
	{
		if (w <= 0 || h <= 0)
			return;
		var mode = this.runtime.fullscreen_mode;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.runtime.isNodeFullscreen);
		if (isfullscreen && this.runtime.fullscreen_scaling > 0)
			mode = this.runtime.fullscreen_scaling;
		if (mode === 0)
		{
			this.runtime["setSize"](w, h, true);
		}
		else
		{
			this.runtime.original_width = w;
			this.runtime.original_height = h;
			this.runtime["setSize"](this.runtime.lastWindowWidth, this.runtime.lastWindowHeight, true);
		}
	};
	SysActs.prototype.SetLayoutEffectEnabled = function (enable_, effectname_)
	{
		if (!this.runtime.running_layout || !this.runtime.glwrap)
			return;
		var et = this.runtime.running_layout.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var enable = (enable_ === 1);
		if (et.active == enable)
			return;		// no change
		et.active = enable;
		this.runtime.running_layout.updateActiveEffects();
		this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayerEffectEnabled = function (layer, enable_, effectname_)
	{
		if (!layer || !this.runtime.glwrap)
			return;
		var et = layer.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var enable = (enable_ === 1);
		if (et.active == enable)
			return;		// no change
		et.active = enable;
		layer.updateActiveEffects();
		this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayoutEffectParam = function (effectname_, index_, value_)
	{
		if (!this.runtime.running_layout || !this.runtime.glwrap)
			return;
		var et = this.runtime.running_layout.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var params = this.runtime.running_layout.effect_params[et.index];
		index_ = Math.floor(index_);
		if (index_ < 0 || index_ >= params.length)
			return;		// effect index out of bounds
		if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
			value_ /= 100.0;
		if (params[index_] === value_)
			return;		// no change
		params[index_] = value_;
		if (et.active)
			this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayerEffectParam = function (layer, effectname_, index_, value_)
	{
		if (!layer || !this.runtime.glwrap)
			return;
		var et = layer.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var params = layer.effect_params[et.index];
		index_ = Math.floor(index_);
		if (index_ < 0 || index_ >= params.length)
			return;		// effect index out of bounds
		if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
			value_ /= 100.0;
		if (params[index_] === value_)
			return;		// no change
		params[index_] = value_;
		if (et.active)
			this.runtime.redraw = true;
	};
	SysActs.prototype.SaveState = function (slot_)
	{
		this.runtime.saveToSlot = slot_;
	};
	SysActs.prototype.LoadState = function (slot_)
	{
		this.runtime.loadFromSlot = slot_;
	};
	SysActs.prototype.LoadStateJSON = function (jsonstr_)
	{
		this.runtime.loadFromJson = jsonstr_;
	};
	SysActs.prototype.SetHalfFramerateMode = function (set_)
	{
		this.runtime.halfFramerateMode = (set_ !== 0);
	};
	SysActs.prototype.SetFullscreenQuality = function (q)
	{
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.isNodeFullscreen);
		if (!isfullscreen && this.runtime.fullscreen_mode === 0)
			return;
		this.runtime.wantFullscreenScalingQuality = (q !== 0);
		this.runtime["setSize"](this.runtime.lastWindowWidth, this.runtime.lastWindowHeight, true);
	};
	sysProto.acts = new SysActs();
    function SysExps() {};
    SysExps.prototype["int"] = function(ret, x)
    {
        if (cr.is_string(x))
        {
            ret.set_int(parseInt(x, 10));
            if (isNaN(ret.data))
                ret.data = 0;
        }
        else
            ret.set_int(x);
    };
    SysExps.prototype["float"] = function(ret, x)
    {
        if (cr.is_string(x))
        {
            ret.set_float(parseFloat(x));
            if (isNaN(ret.data))
                ret.data = 0;
        }
        else
            ret.set_float(x);
    };
    SysExps.prototype.str = function(ret, x)
    {
        if (cr.is_string(x))
            ret.set_string(x);
        else
            ret.set_string(x.toString());
    };
    SysExps.prototype.len = function(ret, x)
    {
        ret.set_int(x.length || 0);
    };
    SysExps.prototype.random = function (ret, a, b)
    {
        if (b === undefined)
        {
            ret.set_float(Math.random() * a);
        }
        else
        {
            ret.set_float(Math.random() * (b - a) + a);
        }
    };
    SysExps.prototype.sqrt = function(ret, x)
    {
        ret.set_float(Math.sqrt(x));
    };
    SysExps.prototype.abs = function(ret, x)
    {
        ret.set_float(Math.abs(x));
    };
    SysExps.prototype.round = function(ret, x)
    {
        ret.set_int(Math.round(x));
    };
    SysExps.prototype.floor = function(ret, x)
    {
        ret.set_int(Math.floor(x));
    };
    SysExps.prototype.ceil = function(ret, x)
    {
        ret.set_int(Math.ceil(x));
    };
    SysExps.prototype.sin = function(ret, x)
    {
        ret.set_float(Math.sin(cr.to_radians(x)));
    };
    SysExps.prototype.cos = function(ret, x)
    {
        ret.set_float(Math.cos(cr.to_radians(x)));
    };
    SysExps.prototype.tan = function(ret, x)
    {
        ret.set_float(Math.tan(cr.to_radians(x)));
    };
    SysExps.prototype.asin = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.asin(x)));
    };
    SysExps.prototype.acos = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.acos(x)));
    };
    SysExps.prototype.atan = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.atan(x)));
    };
    SysExps.prototype.exp = function(ret, x)
    {
        ret.set_float(Math.exp(x));
    };
    SysExps.prototype.ln = function(ret, x)
    {
        ret.set_float(Math.log(x));
    };
    SysExps.prototype.log10 = function(ret, x)
    {
        ret.set_float(Math.log(x) / Math.LN10);
    };
    SysExps.prototype.max = function(ret)
    {
		var max_ = arguments[1];
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
		{
			if (max_ < arguments[i])
				max_ = arguments[i];
		}
		ret.set_float(max_);
    };
    SysExps.prototype.min = function(ret)
    {
        var min_ = arguments[1];
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
		{
			if (min_ > arguments[i])
				min_ = arguments[i];
		}
		ret.set_float(min_);
    };
    SysExps.prototype.dt = function(ret)
    {
        ret.set_float(this.runtime.dt);
    };
    SysExps.prototype.timescale = function(ret)
    {
        ret.set_float(this.runtime.timescale);
    };
    SysExps.prototype.wallclocktime = function(ret)
    {
        ret.set_float((Date.now() - this.runtime.start_time) / 1000.0);
    };
    SysExps.prototype.time = function(ret)
    {
        ret.set_float(this.runtime.kahanTime.sum);
    };
    SysExps.prototype.tickcount = function(ret)
    {
        ret.set_int(this.runtime.tickcount);
    };
    SysExps.prototype.objectcount = function(ret)
    {
        ret.set_int(this.runtime.objectcount);
    };
    SysExps.prototype.fps = function(ret)
    {
        ret.set_int(this.runtime.fps);
    };
    SysExps.prototype.loopindex = function(ret, name_)
    {
		var loop, i, len;
        if (!this.runtime.loop_stack.length)
        {
            ret.set_int(0);
            return;
        }
        if (name_)
        {
            for (i = 0, len = this.runtime.loop_stack.length; i < len; i++)
            {
                loop = this.runtime.loop_stack[i];
                if (loop.name === name_)
                {
                    ret.set_int(loop.index);
                    return;
                }
            }
            ret.set_int(0);
        }
        else
        {
			loop = this.runtime.getCurrentLoop();
			ret.set_int(loop ? loop.index : -1);
        }
    };
    SysExps.prototype.distance = function(ret, x1, y1, x2, y2)
    {
        ret.set_float(cr.distanceTo(x1, y1, x2, y2));
    };
    SysExps.prototype.angle = function(ret, x1, y1, x2, y2)
    {
        ret.set_float(cr.to_degrees(cr.angleTo(x1, y1, x2, y2)));
    };
    SysExps.prototype.scrollx = function(ret)
    {
        ret.set_float(this.runtime.running_layout.scrollX);
    };
    SysExps.prototype.scrolly = function(ret)
    {
        ret.set_float(this.runtime.running_layout.scrollY);
    };
    SysExps.prototype.newline = function(ret)
    {
        ret.set_string("\n");
    };
    SysExps.prototype.lerp = function(ret, a, b, x)
    {
        ret.set_float(cr.lerp(a, b, x));
    };
    SysExps.prototype.windowwidth = function(ret)
    {
        ret.set_int(this.runtime.width);
    };
    SysExps.prototype.windowheight = function(ret)
    {
        ret.set_int(this.runtime.height);
    };
	SysExps.prototype.uppercase = function(ret, str)
	{
		ret.set_string(cr.is_string(str) ? str.toUpperCase() : "");
	};
	SysExps.prototype.lowercase = function(ret, str)
	{
		ret.set_string(cr.is_string(str) ? str.toLowerCase() : "");
	};
	SysExps.prototype.clamp = function(ret, x, l, u)
	{
		if (x < l)
			ret.set_float(l);
		else if (x > u)
			ret.set_float(u);
		else
			ret.set_float(x);
	};
	SysExps.prototype.layerscale = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.scale);
	};
	SysExps.prototype.layeropacity = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.opacity * 100);
	};
	SysExps.prototype.layerscalerate = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.zoomRate);
	};
	SysExps.prototype.layerparallaxx = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.parallaxX * 100);
	};
	SysExps.prototype.layerparallaxy = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.parallaxY * 100);
	};
	SysExps.prototype.layoutscale = function (ret)
	{
		if (this.runtime.running_layout)
			ret.set_float(this.runtime.running_layout.scale);
		else
			ret.set_float(0);
	};
	SysExps.prototype.layoutangle = function (ret)
	{
		ret.set_float(cr.to_degrees(this.runtime.running_layout.angle));
	};
	SysExps.prototype.layerangle = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(cr.to_degrees(layer.angle));
	};
	SysExps.prototype.layoutwidth = function (ret)
	{
		ret.set_int(this.runtime.running_layout.width);
	};
	SysExps.prototype.layoutheight = function (ret)
	{
		ret.set_int(this.runtime.running_layout.height);
	};
	SysExps.prototype.find = function (ret, text, searchstr)
	{
		if (cr.is_string(text) && cr.is_string(searchstr))
			ret.set_int(text.search(new RegExp(cr.regexp_escape(searchstr), "i")));
		else
			ret.set_int(-1);
	};
	SysExps.prototype.left = function (ret, text, n)
	{
		ret.set_string(cr.is_string(text) ? text.substr(0, n) : "");
	};
	SysExps.prototype.right = function (ret, text, n)
	{
		ret.set_string(cr.is_string(text) ? text.substr(text.length - n) : "");
	};
	SysExps.prototype.mid = function (ret, text, index_, length_)
	{
		ret.set_string(cr.is_string(text) ? text.substr(index_, length_) : "");
	};
	SysExps.prototype.tokenat = function (ret, text, index_, sep)
	{
		if (cr.is_string(text) && cr.is_string(sep))
		{
			var arr = text.split(sep);
			var i = cr.floor(index_);
			if (i < 0 || i >= arr.length)
				ret.set_string("");
			else
				ret.set_string(arr[i]);
		}
		else
			ret.set_string("");
	};
	SysExps.prototype.tokencount = function (ret, text, sep)
	{
		if (cr.is_string(text) && text.length)
			ret.set_int(text.split(sep).length);
		else
			ret.set_int(0);
	};
	SysExps.prototype.replace = function (ret, text, find_, replace_)
	{
		if (cr.is_string(text) && cr.is_string(find_) && cr.is_string(replace_))
			ret.set_string(text.replace(new RegExp(cr.regexp_escape(find_), "gi"), replace_));
		else
			ret.set_string(cr.is_string(text) ? text : "");
	};
	SysExps.prototype.trim = function (ret, text)
	{
		ret.set_string(cr.is_string(text) ? text.trim() : "");
	};
	SysExps.prototype.pi = function (ret)
	{
		ret.set_float(cr.PI);
	};
	SysExps.prototype.layoutname = function (ret)
	{
		if (this.runtime.running_layout)
			ret.set_string(this.runtime.running_layout.name);
		else
			ret.set_string("");
	};
	SysExps.prototype.renderer = function (ret)
	{
		ret.set_string(this.runtime.gl ? "webgl" : "canvas2d");
	};
	SysExps.prototype.anglediff = function (ret, a, b)
	{
		ret.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(a), cr.to_radians(b))));
	};
	SysExps.prototype.choose = function (ret)
	{
		var index = cr.floor(Math.random() * (arguments.length - 1));
		ret.set_any(arguments[index + 1]);
	};
	SysExps.prototype.rgb = function (ret, r, g, b)
	{
		ret.set_int(cr.RGB(r, g, b));
	};
	SysExps.prototype.projectversion = function (ret)
	{
		ret.set_string(this.runtime.versionstr);
	};
	SysExps.prototype.anglelerp = function (ret, a, b, x)
	{
		a = cr.to_radians(a);
		b = cr.to_radians(b);
		var diff = cr.angleDiff(a, b);
		if (cr.angleClockwise(b, a))
		{
			ret.set_float(cr.to_clamped_degrees(a + diff * x));
		}
		else
		{
			ret.set_float(cr.to_clamped_degrees(a - diff * x));
		}
	};
	SysExps.prototype.anglerotate = function (ret, a, b, c)
	{
		a = cr.to_radians(a);
		b = cr.to_radians(b);
		c = cr.to_radians(c);
		ret.set_float(cr.to_clamped_degrees(cr.angleRotate(a, b, c)));
	};
	SysExps.prototype.zeropad = function (ret, n, d)
	{
		var s = (n < 0 ? "-" : "");
		if (n < 0) n = -n;
		var zeroes = d - n.toString().length;
		for (var i = 0; i < zeroes; i++)
			s += "0";
		ret.set_string(s + n.toString());
	};
	SysExps.prototype.cpuutilisation = function (ret)
	{
		ret.set_float(this.runtime.cpuutilisation / 1000);
	};
	SysExps.prototype.viewportleft = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewLeft : 0);
	};
	SysExps.prototype.viewporttop = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewTop : 0);
	};
	SysExps.prototype.viewportright = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewRight : 0);
	};
	SysExps.prototype.viewportbottom = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewBottom : 0);
	};
	SysExps.prototype.loadingprogress = function (ret)
	{
		ret.set_float(this.runtime.loadingprogress);
	};
	SysExps.prototype.unlerp = function(ret, a, b, y)
    {
        ret.set_float(cr.unlerp(a, b, y));
    };
	SysExps.prototype.canvassnapshot = function (ret)
	{
		ret.set_string(this.runtime.snapshotData);
	};
	SysExps.prototype.urlencode = function (ret, s)
	{
		ret.set_string(encodeURIComponent(s));
	};
	SysExps.prototype.urldecode = function (ret, s)
	{
		ret.set_string(decodeURIComponent(s));
	};
	SysExps.prototype.canvastolayerx = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.canvasToLayer(x, y, true) : 0);
	};
	SysExps.prototype.canvastolayery = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.canvasToLayer(x, y, false) : 0);
	};
	SysExps.prototype.layertocanvasx = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.layerToCanvas(x, y, true) : 0);
	};
	SysExps.prototype.layertocanvasy = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.layerToCanvas(x, y, false) : 0);
	};
	SysExps.prototype.savestatejson = function (ret)
	{
		ret.set_string(this.runtime.lastSaveJson);
	};
	SysExps.prototype.imagememoryusage = function (ret)
	{
		if (this.runtime.glwrap)
			ret.set_float(Math.round(100 * this.runtime.glwrap.estimateVRAM() / (1024 * 1024)) / 100);
		else
			ret.set_float(0);
	};
	SysExps.prototype.regexsearch = function (ret, str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		ret.set_int(str_ ? str_.search(regex) : -1);
	};
	SysExps.prototype.regexreplace = function (ret, str_, regex_, flags_, replace_)
	{
		var regex = getRegex(regex_, flags_);
		ret.set_string(str_ ? str_.replace(regex, replace_) : "");
	};
	var regexMatches = [];
	var lastMatchesStr = "";
	var lastMatchesRegex = "";
	var lastMatchesFlags = "";
	function updateRegexMatches(str_, regex_, flags_)
	{
		if (str_ === lastMatchesStr && regex_ === lastMatchesRegex && flags_ === lastMatchesFlags)
			return;
		var regex = getRegex(regex_, flags_);
		regexMatches = str_.match(regex);
		lastMatchesStr = str_;
		lastMatchesRegex = regex_;
		lastMatchesFlags = flags_;
	};
	SysExps.prototype.regexmatchcount = function (ret, str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		updateRegexMatches(str_, regex_, flags_);
		ret.set_int(regexMatches ? regexMatches.length : 0);
	};
	SysExps.prototype.regexmatchat = function (ret, str_, regex_, flags_, index_)
	{
		index_ = Math.floor(index_);
		var regex = getRegex(regex_, flags_);
		updateRegexMatches(str_, regex_, flags_);
		if (!regexMatches || index_ < 0 || index_ >= regexMatches.length)
			ret.set_string("");
		else
			ret.set_string(regexMatches[index_]);
	};
	SysExps.prototype.infinity = function (ret)
	{
		ret.set_float(Infinity);
	};
	SysExps.prototype.setbit = function (ret, n, b, v)
	{
		n = n | 0;
		b = b | 0;
		v = (v !== 0 ? 1 : 0);
		ret.set_int((n & ~(1 << b)) | (v << b));
	};
	SysExps.prototype.togglebit = function (ret, n, b)
	{
		n = n | 0;
		b = b | 0;
		ret.set_int(n ^ (1 << b));
	};
	SysExps.prototype.getbit = function (ret, n, b)
	{
		n = n | 0;
		b = b | 0;
		ret.set_int((n & (1 << b)) ? 1 : 0);
	};
	sysProto.exps = new SysExps();
	sysProto.runWaits = function ()
	{
		var i, j, len, w, k, s, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		for (i = 0, len = this.waits.length; i < len; i++)
		{
			w = this.waits[i];
			if (w.time > this.runtime.kahanTime.sum)
				continue;
			evinfo.current_event = w.ev;
			evinfo.actindex = w.actindex;
			evinfo.cndindex = 0;
			for (k in w.sols)
			{
				if (w.sols.hasOwnProperty(k))
				{
					s = this.runtime.types_by_index[parseInt(k, 10)].getCurrentSol();
					ss = w.sols[k];
					s.select_all = ss.sa;
					cr.shallowAssignArray(s.instances, ss.insts);
					freeSolStateObject(ss);
				}
			}
			w.ev.resume_actions_and_subevents();
			this.runtime.clearSol(w.solModifiers);
			w.deleteme = true;
		}
		for (i = 0, j = 0, len = this.waits.length; i < len; i++)
		{
			w = this.waits[i];
			this.waits[j] = w;
			if (w.deleteme)
				freeWaitObject(w);
			else
				j++;
		}
		this.waits.length = j;
	};
}());
;
(function () {
	cr.add_common_aces = function (m)
	{
		var pluginProto = m[0].prototype;
		var singleglobal_ = m[1];
		var position_aces = m[3];
		var size_aces = m[4];
		var angle_aces = m[5];
		var appearance_aces = m[6];
		var zorder_aces = m[7];
		var effects_aces = m[8];
		if (!pluginProto.cnds)
			pluginProto.cnds = {};
		if (!pluginProto.acts)
			pluginProto.acts = {};
		if (!pluginProto.exps)
			pluginProto.exps = {};
		var cnds = pluginProto.cnds;
		var acts = pluginProto.acts;
		var exps = pluginProto.exps;
		if (position_aces)
		{
			cnds.CompareX = function (cmp, x)
			{
				return cr.do_cmp(this.x, cmp, x);
			};
			cnds.CompareY = function (cmp, y)
			{
				return cr.do_cmp(this.y, cmp, y);
			};
			cnds.IsOnScreen = function ()
			{
				var layer = this.layer;
				this.update_bbox();
				var bbox = this.bbox;
				return !(bbox.right < layer.viewLeft || bbox.bottom < layer.viewTop || bbox.left > layer.viewRight || bbox.top > layer.viewBottom);
			};
			cnds.IsOutsideLayout = function ()
			{
				this.update_bbox();
				var bbox = this.bbox;
				var layout = this.runtime.running_layout;
				return (bbox.right < 0 || bbox.bottom < 0 || bbox.left > layout.width || bbox.top > layout.height);
			};
			cnds.PickDistance = function (which, x, y)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var dist = cr.distanceTo(inst.x, inst.y, x, y);
				var i, len, d;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					d = cr.distanceTo(inst.x, inst.y, x, y);
					if ((which === 0 && d < dist) || (which === 1 && d > dist))
					{
						dist = d;
						pickme = inst;
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			acts.SetX = function (x)
			{
				if (this.x !== x)
				{
					this.x = x;
					this.set_bbox_changed();
				}
			};
			acts.SetY = function (y)
			{
				if (this.y !== y)
				{
					this.y = y;
					this.set_bbox_changed();
				}
			};
			acts.SetPos = function (x, y)
			{
				if (this.x !== x || this.y !== y)
				{
					this.x = x;
					this.y = y;
					this.set_bbox_changed();
				}
			};
			acts.SetPosToObject = function (obj, imgpt)
			{
				var inst = obj.getPairedInstance(this);
				if (!inst)
					return;
				var newx, newy;
				if (inst.getImagePoint)
				{
					newx = inst.getImagePoint(imgpt, true);
					newy = inst.getImagePoint(imgpt, false);
				}
				else
				{
					newx = inst.x;
					newy = inst.y;
				}
				if (this.x !== newx || this.y !== newy)
				{
					this.x = newx;
					this.y = newy;
					this.set_bbox_changed();
				}
			};
			acts.MoveForward = function (dist)
			{
				if (dist !== 0)
				{
					this.x += Math.cos(this.angle) * dist;
					this.y += Math.sin(this.angle) * dist;
					this.set_bbox_changed();
				}
			};
			acts.MoveAtAngle = function (a, dist)
			{
				if (dist !== 0)
				{
					this.x += Math.cos(cr.to_radians(a)) * dist;
					this.y += Math.sin(cr.to_radians(a)) * dist;
					this.set_bbox_changed();
				}
			};
			exps.X = function (ret)
			{
				ret.set_float(this.x);
			};
			exps.Y = function (ret)
			{
				ret.set_float(this.y);
			};
			exps.dt = function (ret)
			{
				ret.set_float(this.runtime.getDt(this));
			};
		}
		if (size_aces)
		{
			cnds.CompareWidth = function (cmp, w)
			{
				return cr.do_cmp(this.width, cmp, w);
			};
			cnds.CompareHeight = function (cmp, h)
			{
				return cr.do_cmp(this.height, cmp, h);
			};
			acts.SetWidth = function (w)
			{
				if (this.width !== w)
				{
					this.width = w;
					this.set_bbox_changed();
				}
			};
			acts.SetHeight = function (h)
			{
				if (this.height !== h)
				{
					this.height = h;
					this.set_bbox_changed();
				}
			};
			acts.SetSize = function (w, h)
			{
				if (this.width !== w || this.height !== h)
				{
					this.width = w;
					this.height = h;
					this.set_bbox_changed();
				}
			};
			exps.Width = function (ret)
			{
				ret.set_float(this.width);
			};
			exps.Height = function (ret)
			{
				ret.set_float(this.height);
			};
			exps.BBoxLeft = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.left);
			};
			exps.BBoxTop = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.top);
			};
			exps.BBoxRight = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.right);
			};
			exps.BBoxBottom = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.bottom);
			};
		}
		if (angle_aces)
		{
			cnds.AngleWithin = function (within, a)
			{
				return cr.angleDiff(this.angle, cr.to_radians(a)) <= cr.to_radians(within);
			};
			cnds.IsClockwiseFrom = function (a)
			{
				return cr.angleClockwise(this.angle, cr.to_radians(a));
			};
			cnds.IsBetweenAngles = function (a, b)
			{
				var lower = cr.to_clamped_radians(a);
				var upper = cr.to_clamped_radians(b);
				var angle = cr.clamp_angle(this.angle);
				var obtuse = (!cr.angleClockwise(upper, lower));
				if (obtuse)
					return !(!cr.angleClockwise(angle, lower) && cr.angleClockwise(angle, upper));
				else
					return cr.angleClockwise(angle, lower) && !cr.angleClockwise(angle, upper);
			};
			acts.SetAngle = function (a)
			{
				var newangle = cr.to_radians(cr.clamp_angle_degrees(a));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.RotateClockwise = function (a)
			{
				if (a !== 0 && !isNaN(a))
				{
					this.angle += cr.to_radians(a);
					this.angle = cr.clamp_angle(this.angle);
					this.set_bbox_changed();
				}
			};
			acts.RotateCounterclockwise = function (a)
			{
				if (a !== 0 && !isNaN(a))
				{
					this.angle -= cr.to_radians(a);
					this.angle = cr.clamp_angle(this.angle);
					this.set_bbox_changed();
				}
			};
			acts.RotateTowardAngle = function (amt, target)
			{
				var newangle = cr.angleRotate(this.angle, cr.to_radians(target), cr.to_radians(amt));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.RotateTowardPosition = function (amt, x, y)
			{
				var dx = x - this.x;
				var dy = y - this.y;
				var target = Math.atan2(dy, dx);
				var newangle = cr.angleRotate(this.angle, target, cr.to_radians(amt));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.SetTowardPosition = function (x, y)
			{
				var dx = x - this.x;
				var dy = y - this.y;
				var newangle = Math.atan2(dy, dx);
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			exps.Angle = function (ret)
			{
				ret.set_float(cr.to_clamped_degrees(this.angle));
			};
		}
		if (!singleglobal_)
		{
			cnds.CompareInstanceVar = function (iv, cmp, val)
			{
				return cr.do_cmp(this.instance_vars[iv], cmp, val);
			};
			cnds.IsBoolInstanceVarSet = function (iv)
			{
				return this.instance_vars[iv];
			};
			cnds.PickInstVarHiLow = function (which, iv)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var val = inst.instance_vars[iv];
				var i, len, v;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					v = inst.instance_vars[iv];
					if ((which === 0 && v < val) || (which === 1 && v > val))
					{
						val = v;
						pickme = inst;
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			cnds.PickByUID = function (u)
			{
				var i, len, j, inst, families, instances, sol;
				var cnd = this.runtime.getCurrentCondition();
				if (cnd.inverted)
				{
					sol = this.getCurrentSol();
					if (sol.select_all)
					{
						sol.select_all = false;
						sol.instances.length = 0;
						sol.else_instances.length = 0;
						instances = this.instances;
						for (i = 0, len = instances.length; i < len; i++)
						{
							inst = instances[i];
							if (inst.uid === u)
								sol.else_instances.push(inst);
							else
								sol.instances.push(inst);
						}
						this.applySolToContainer();
						return !!sol.instances.length;
					}
					else
					{
						for (i = 0, j = 0, len = sol.instances.length; i < len; i++)
						{
							inst = sol.instances[i];
							sol.instances[j] = inst;
							if (inst.uid === u)
							{
								sol.else_instances.push(inst);
							}
							else
								j++;
						}
						sol.instances.length = j;
						this.applySolToContainer();
						return !!sol.instances.length;
					}
				}
				else
				{
					inst = this.runtime.getObjectByUID(u);
					if (!inst)
						return false;
					sol = this.getCurrentSol();
					if (!sol.select_all && sol.instances.indexOf(inst) === -1)
						return false;		// not picked
					if (this.is_family)
					{
						families = inst.type.families;
						for (i = 0, len = families.length; i < len; i++)
						{
							if (families[i] === this)
							{
								sol.pick_one(inst);
								this.applySolToContainer();
								return true;
							}
						}
					}
					else if (inst.type === this)
					{
						sol.pick_one(inst);
						this.applySolToContainer();
						return true;
					}
					return false;
				}
			};
			cnds.OnCreated = function ()
			{
				return true;
			};
			cnds.OnDestroyed = function ()
			{
				return true;
			};
			acts.SetInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] = val;
					else
						myinstvars[iv] = parseFloat(val);
				}
				else if (cr.is_string(myinstvars[iv]))
				{
					if (cr.is_string(val))
						myinstvars[iv] = val;
					else
						myinstvars[iv] = val.toString();
				}
				else
;
			};
			acts.AddInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] += val;
					else
						myinstvars[iv] += parseFloat(val);
				}
				else if (cr.is_string(myinstvars[iv]))
				{
					if (cr.is_string(val))
						myinstvars[iv] += val;
					else
						myinstvars[iv] += val.toString();
				}
				else
;
			};
			acts.SubInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] -= val;
					else
						myinstvars[iv] -= parseFloat(val);
				}
				else
;
			};
			acts.SetBoolInstanceVar = function (iv, val)
			{
				this.instance_vars[iv] = val ? 1 : 0;
			};
			acts.ToggleBoolInstanceVar = function (iv)
			{
				this.instance_vars[iv] = 1 - this.instance_vars[iv];
			};
			acts.Destroy = function ()
			{
				this.runtime.DestroyInstance(this);
			};
			if (!acts.LoadFromJsonString)
			{
				acts.LoadFromJsonString = function (str_)
				{
					var o, i, len, binst;
					try {
						o = JSON.parse(str_);
					}
					catch (e) {
						return;
					}
					this.runtime.loadInstanceFromJSON(this, o, true);
					if (this.afterLoad)
						this.afterLoad();
					if (this.behavior_insts)
					{
						for (i = 0, len = this.behavior_insts.length; i < len; ++i)
						{
							binst = this.behavior_insts[i];
							if (binst.afterLoad)
								binst.afterLoad();
						}
					}
				};
			}
			exps.Count = function (ret)
			{
				var count = ret.object_class.instances.length;
				var i, len, inst;
				for (i = 0, len = this.runtime.createRow.length; i < len; i++)
				{
					inst = this.runtime.createRow[i];
					if (ret.object_class.is_family)
					{
						if (inst.type.families.indexOf(ret.object_class) >= 0)
							count++;
					}
					else
					{
						if (inst.type === ret.object_class)
							count++;
					}
				}
				ret.set_int(count);
			};
			exps.PickedCount = function (ret)
			{
				ret.set_int(ret.object_class.getCurrentSol().getObjects().length);
			};
			exps.UID = function (ret)
			{
				ret.set_int(this.uid);
			};
			exps.IID = function (ret)
			{
				ret.set_int(this.get_iid());
			};
			if (!exps.AsJSON)
			{
				exps.AsJSON = function (ret)
				{
					ret.set_string(JSON.stringify(this.runtime.saveInstanceToJSON(this, true)));
				};
			}
		}
		if (appearance_aces)
		{
			cnds.IsVisible = function ()
			{
				return this.visible;
			};
			acts.SetVisible = function (v)
			{
				if (!v !== !this.visible)
				{
					this.visible = v;
					this.runtime.redraw = true;
				}
			};
			cnds.CompareOpacity = function (cmp, x)
			{
				return cr.do_cmp(cr.round6dp(this.opacity * 100), cmp, x);
			};
			acts.SetOpacity = function (x)
			{
				var new_opacity = x / 100.0;
				if (new_opacity < 0)
					new_opacity = 0;
				else if (new_opacity > 1)
					new_opacity = 1;
				if (new_opacity !== this.opacity)
				{
					this.opacity = new_opacity;
					this.runtime.redraw = true;
				}
			};
			exps.Opacity = function (ret)
			{
				ret.set_float(cr.round6dp(this.opacity * 100.0));
			};
		}
		if (zorder_aces)
		{
			cnds.IsOnLayer = function (layer_)
			{
				if (!layer_)
					return false;
				return this.layer === layer_;
			};
			cnds.PickTopBottom = function (which_)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var i, len;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					if (which_ === 0)
					{
						if (inst.layer.index > pickme.layer.index || (inst.layer.index === pickme.layer.index && inst.get_zindex() > pickme.get_zindex()))
						{
							pickme = inst;
						}
					}
					else
					{
						if (inst.layer.index < pickme.layer.index || (inst.layer.index === pickme.layer.index && inst.get_zindex() < pickme.get_zindex()))
						{
							pickme = inst;
						}
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			acts.MoveToTop = function ()
			{
				var zindex = this.get_zindex();
				if (zindex === this.layer.instances.length - 1)
					return;
				cr.arrayRemove(this.layer.instances, zindex);
				this.layer.instances.push(this);
				this.runtime.redraw = true;
				this.layer.zindices_stale = true;
			};
			acts.MoveToBottom = function ()
			{
				var zindex = this.get_zindex();
				if (zindex === 0)
					return;
				cr.arrayRemove(this.layer.instances, zindex);
				this.layer.instances.unshift(this);
				this.runtime.redraw = true;
				this.layer.zindices_stale = true;
			};
			acts.MoveToLayer = function (layerMove)
			{
				if (!layerMove || layerMove == this.layer)
					return;
				cr.arrayRemove(this.layer.instances, this.get_zindex());
				this.layer.zindices_stale = true;
				this.layer = layerMove;
				this.zindex = layerMove.instances.length;
				layerMove.instances.push(this);
				this.runtime.redraw = true;
			};
			acts.ZMoveToObject = function (where_, obj_)
			{
				var isafter = (where_ === 0);
				if (!obj_)
					return;
				var other = obj_.getFirstPicked(this);
				if (!other || other.uid === this.uid)
					return;
				if (this.layer.index !== other.layer.index)
				{
					cr.arrayRemove(this.layer.instances, this.get_zindex());
					this.layer.zindices_stale = true;
					this.layer = other.layer;
					this.zindex = other.layer.instances.length;
					other.layer.instances.push(this);
				}
				var myZ = this.get_zindex();
				var insertZ = other.get_zindex();
				cr.arrayRemove(this.layer.instances, myZ);
				if (myZ < insertZ)
					insertZ--;
				if (isafter)
					insertZ++;
				if (insertZ === this.layer.instances.length)
					this.layer.instances.push(this);
				else
					this.layer.instances.splice(insertZ, 0, this);
				this.layer.zindices_stale = true;
				this.runtime.redraw = true;
			};
			exps.LayerNumber = function (ret)
			{
				ret.set_int(this.layer.number);
			};
			exps.LayerName = function (ret)
			{
				ret.set_string(this.layer.name);
			};
			exps.ZIndex = function (ret)
			{
				ret.set_int(this.get_zindex());
			};
		}
		if (effects_aces)
		{
			acts.SetEffectEnabled = function (enable_, effectname_)
			{
				if (!this.runtime.glwrap)
					return;
				var i = this.type.getEffectIndexByName(effectname_);
				if (i < 0)
					return;		// effect name not found
				var enable = (enable_ === 1);
				if (this.active_effect_flags[i] === enable)
					return;		// no change
				this.active_effect_flags[i] = enable;
				this.updateActiveEffects();
				this.runtime.redraw = true;
			};
			acts.SetEffectParam = function (effectname_, index_, value_)
			{
				if (!this.runtime.glwrap)
					return;
				var i = this.type.getEffectIndexByName(effectname_);
				if (i < 0)
					return;		// effect name not found
				var et = this.type.effect_types[i];
				var params = this.effect_params[i];
				index_ = Math.floor(index_);
				if (index_ < 0 || index_ >= params.length)
					return;		// effect index out of bounds
				if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
					value_ /= 100.0;
				if (params[index_] === value_)
					return;		// no change
				params[index_] = value_;
				if (et.active)
					this.runtime.redraw = true;
			};
		}
	};
	cr.set_bbox_changed = function ()
	{
		this.bbox_changed = true;      		// will recreate next time box requested
		this.cell_changed = true;
		this.type.any_cell_changed = true;	// avoid unnecessary updateAllBBox() calls
		this.runtime.redraw = true;     	// assume runtime needs to redraw
		var i, len, callbacks = this.bbox_changed_callbacks;
		for (i = 0, len = callbacks.length; i < len; ++i)
		{
			callbacks[i](this);
		}
	};
	cr.add_bbox_changed_callback = function (f)
	{
		if (f)
		{
			this.bbox_changed_callbacks.push(f);
		}
	};
	cr.update_bbox = function ()
	{
		if (!this.bbox_changed)
			return;                 // bounding box not changed
		var bbox = this.bbox;
		var bquad = this.bquad;
		bbox.set(this.x, this.y, this.x + this.width, this.y + this.height);
		bbox.offset(-this.hotspotX * this.width, -this.hotspotY * this.height);
		if (!this.angle)
		{
			bquad.set_from_rect(bbox);    // make bounding quad from box
		}
		else
		{
			bbox.offset(-this.x, -this.y);       			// translate to origin
			bquad.set_from_rotated_rect(bbox, this.angle);	// rotate around origin
			bquad.offset(this.x, this.y);      				// translate back to original position
			bquad.bounding_box(bbox);
		}
		bbox.normalize();
		this.bbox_changed = false;  // bounding box up to date
	};
	var tmprc = new cr.rect(0, 0, 0, 0);
	cr.update_collision_cell = function ()
	{
		if (!this.cell_changed || !this.collisionsEnabled)
			return;
		this.update_bbox();
		var mygrid = this.type.collision_grid;
		var collcells = this.collcells;
		var bbox = this.bbox;
		tmprc.set(mygrid.XToCell(bbox.left), mygrid.YToCell(bbox.top), mygrid.XToCell(bbox.right), mygrid.YToCell(bbox.bottom));
		if (collcells.equals(tmprc))
			return;
		if (collcells.right < collcells.left)
			mygrid.update(this, null, tmprc);		// first insertion with invalid rect: don't provide old range
		else
			mygrid.update(this, collcells, tmprc);
		collcells.copy(tmprc);
		this.cell_changed = false;
	};
	cr.inst_contains_pt = function (x, y)
	{
		if (!this.bbox.contains_pt(x, y))
			return false;
		if (!this.bquad.contains_pt(x, y))
			return false;
		if (this.collision_poly && !this.collision_poly.is_empty())
		{
			this.collision_poly.cache_poly(this.width, this.height, this.angle);
			return this.collision_poly.contains_pt(x - this.x, y - this.y);
		}
		else
			return true;
	};
	cr.inst_get_iid = function ()
	{
		this.type.updateIIDs();
		return this.iid;
	};
	cr.inst_get_zindex = function ()
	{
		this.layer.updateZIndices();
		return this.zindex;
	};
	cr.inst_updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et, inst;
		for (i = 0, len = this.active_effect_flags.length; i < len; i++)
		{
			if (this.active_effect_flags[i])
				this.active_effect_types.push(this.type.effect_types[i]);
		}
		this.uses_shaders = !!this.active_effect_types.length;
	};
	cr.inst_toString = function ()
	{
		return "Inst" + this.puid;
	};
	cr.type_getFirstPicked = function (frominst)
	{
		if (frominst && frominst.is_contained && frominst.type != this)
		{
			var i, len, s;
			for (i = 0, len = frominst.siblings.length; i < len; i++)
			{
				s = frominst.siblings[i];
				if (s.type == this)
					return s;
			}
		}
		var instances = this.getCurrentSol().getObjects();
		if (instances.length)
			return instances[0];
		else
			return null;
	};
	cr.type_getPairedInstance = function (inst)
	{
		var instances = this.getCurrentSol().getObjects();
		if (instances.length)
			return instances[inst.get_iid() % instances.length];
		else
			return null;
	};
	cr.type_updateIIDs = function ()
	{
		if (!this.stale_iids || this.is_family)
			return;		// up to date or is family - don't want family to overwrite IIDs
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].iid = i;
		var next_iid = i;
		var createRow = this.runtime.createRow;
		for (i = 0, len = createRow.length; i < len; ++i)
		{
			if (createRow[i].type === this)
				createRow[i].iid = next_iid++;
		}
		this.stale_iids = false;
	};
	cr.type_getInstanceByIID = function (i)
	{
		if (i < this.instances.length)
			return this.instances[i];
		i -= this.instances.length;
		var createRow = this.runtime.createRow;
		var j, lenj;
		for (j = 0, lenj = createRow.length; j < lenj; ++j)
		{
			if (createRow[j].type === this)
			{
				if (i === 0)
					return createRow[j];
				--i;
			}
		}
;
		return null;
	};
	cr.type_getCurrentSol = function ()
	{
		return this.solstack[this.cur_sol];
	};
	cr.type_pushCleanSol = function ()
	{
		this.cur_sol++;
		if (this.cur_sol === this.solstack.length)
			this.solstack.push(new cr.selection(this));
		else
			this.solstack[this.cur_sol].select_all = true;  // else clear next SOL
	};
	cr.type_pushCopySol = function ()
	{
		this.cur_sol++;
		if (this.cur_sol === this.solstack.length)
			this.solstack.push(new cr.selection(this));
		var clonesol = this.solstack[this.cur_sol];
		var prevsol = this.solstack[this.cur_sol - 1];
		if (prevsol.select_all)
			clonesol.select_all = true;
		else
		{
			clonesol.select_all = false;
			cr.shallowAssignArray(clonesol.instances, prevsol.instances);
			cr.shallowAssignArray(clonesol.else_instances, prevsol.else_instances);
		}
	};
	cr.type_popSol = function ()
	{
;
		this.cur_sol--;
	};
	cr.type_getBehaviorByName = function (behname)
	{
		var i, len, j, lenj, f, index = 0;
		if (!this.is_family)
		{
			for (i = 0, len = this.families.length; i < len; i++)
			{
				f = this.families[i];
				for (j = 0, lenj = f.behaviors.length; j < lenj; j++)
				{
					if (behname === f.behaviors[j].name)
					{
						this.extra.lastBehIndex = index;
						return f.behaviors[j];
					}
					index++;
				}
			}
		}
		for (i = 0, len = this.behaviors.length; i < len; i++) {
			if (behname === this.behaviors[i].name)
			{
				this.extra.lastBehIndex = index;
				return this.behaviors[i];
			}
			index++;
		}
		return null;
	};
	cr.type_getBehaviorIndexByName = function (behname)
	{
		var b = this.getBehaviorByName(behname);
		if (b)
			return this.extra.lastBehIndex;
		else
			return -1;
	};
	cr.type_getEffectIndexByName = function (name_)
	{
		var i, len;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			if (this.effect_types[i].name === name_)
				return i;
		}
		return -1;
	};
	cr.type_applySolToContainer = function ()
	{
		if (!this.is_contained || this.is_family)
			return;
		var i, len, j, lenj, t, sol, sol2;
		this.updateIIDs();
		sol = this.getCurrentSol();
		var select_all = sol.select_all;
		var es = this.runtime.getCurrentEventStack();
		var orblock = es && es.current_event && es.current_event.orblock;
		for (i = 0, len = this.container.length; i < len; i++)
		{
			t = this.container[i];
			if (t === this)
				continue;
			t.updateIIDs();
			sol2 = t.getCurrentSol();
			sol2.select_all = select_all;
			if (!select_all)
			{
				sol2.instances.length = sol.instances.length;
				for (j = 0, lenj = sol.instances.length; j < lenj; j++)
					sol2.instances[j] = t.getInstanceByIID(sol.instances[j].iid);
				if (orblock)
				{
					sol2.else_instances.length = sol.else_instances.length;
					for (j = 0, lenj = sol.else_instances.length; j < lenj; j++)
						sol2.else_instances[j] = t.getInstanceByIID(sol.else_instances[j].iid);
				}
			}
		}
	};
	cr.type_toString = function ()
	{
		return "Type" + this.sid;
	};
	cr.do_cmp = function (x, cmp, y)
	{
		if (typeof x === "undefined" || typeof y === "undefined")
			return false;
		switch (cmp)
		{
			case 0:     // equal
				return x === y;
			case 1:     // not equal
				return x !== y;
			case 2:     // less
				return x < y;
			case 3:     // less/equal
				return x <= y;
			case 4:     // greater
				return x > y;
			case 5:     // greater/equal
				return x >= y;
			default:
;
				return false;
		}
	};
})();
cr.shaders = {};
;
;
cr.plugins_.Audio = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Audio.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	var audRuntime = null;
	var audInst = null;
	var audTag = "";
	var appPath = "";			// for PhoneGap only
	var API_HTML5 = 0;
	var API_WEBAUDIO = 1;
	var API_PHONEGAP = 2;
	var API_APPMOBI = 3;
	var api = API_HTML5;
	var context = null;
	var audioBuffers = [];		// cache of buffers
	var audioInstances = [];	// cache of instances
	var lastAudio = null;
	var useOgg = false;			// determined at create time
	var timescale_mode = 0;
	var silent = false;
	var masterVolume = 1;
	var listenerX = 0;
	var listenerY = 0;
	var panningModel = 1;		// HRTF
	var distanceModel = 1;		// Inverse
	var refDistance = 10;
	var maxDistance = 10000;
	var rolloffFactor = 1;
	var micSource = null;
	var micTag = "";
	var isMusicWorkaround = false;
	var musicPlayNextTouch = [];
	function dbToLinear(x)
	{
		var v = dbToLinear_nocap(x);
		if (v < 0)
			v = 0;
		if (v > 1)
			v = 1;
		return v;
	};
	function linearToDb(x)
	{
		if (x < 0)
			x = 0;
		if (x > 1)
			x = 1;
		return linearToDb_nocap(x);
	};
	function dbToLinear_nocap(x)
	{
		return Math.pow(10, x / 20);
	};
	function linearToDb_nocap(x)
	{
		return (Math.log(x) / Math.log(10)) * 20;
	};
	var effects = {};
	function getDestinationForTag(tag)
	{
		tag = tag.toLowerCase();
		if (effects.hasOwnProperty(tag))
		{
			if (effects[tag].length)
				return effects[tag][0].getInputNode();
		}
		return context["destination"];
	};
	function createGain()
	{
		if (context["createGain"])
			return context["createGain"]();
		else
			return context["createGainNode"]();
	};
	function createDelay(d)
	{
		if (context["createDelay"])
			return context["createDelay"](d);
		else
			return context["createDelayNode"](d);
	};
	function startSource(s)
	{
		if (s["start"])
			s["start"](0);
		else
			s["noteOn"](0);
	};
	function startSourceAt(s, x, d)
	{
		if (s["start"])
			s["start"](0, x);
		else
			s["noteGrainOn"](0, x, d - x);
	};
	function stopSource(s)
	{
		try {
			if (s["stop"])
				s["stop"](0);
			else
				s["noteOff"](0);
		}
		catch (e) {}
	};
	function setAudioParam(ap, value, ramp, time)
	{
		if (!ap)
			return;		// iOS is missing some parameters
		ap["cancelScheduledValues"](0);
		if (time === 0)
		{
			ap["value"] = value;
			return;
		}
		var curTime = context["currentTime"];
		time += curTime;
		switch (ramp) {
		case 0:		// step
			ap["setValueAtTime"](value, time);
			break;
		case 1:		// linear
			ap["setValueAtTime"](ap["value"], curTime);		// to set what to ramp from
			ap["linearRampToValueAtTime"](value, time);
			break;
		case 2:		// exponential
			ap["setValueAtTime"](ap["value"], curTime);		// to set what to ramp from
			ap["exponentialRampToValueAtTime"](value, time);
			break;
		}
	};
	var filterTypes = ["lowpass", "highpass", "bandpass", "lowshelf", "highshelf", "peaking", "notch", "allpass"];
	function FilterEffect(type, freq, detune, q, gain, mix)
	{
		this.type = "filter";
		this.params = [type, freq, detune, q, gain, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.filterNode = context["createBiquadFilter"]();
		if (typeof this.filterNode["type"] === "number")
			this.filterNode["type"] = type;
		else
			this.filterNode["type"] = filterTypes[type];
		this.filterNode["frequency"]["value"] = freq;
		if (this.filterNode["detune"])		// iOS 6 doesn't have detune yet
			this.filterNode["detune"]["value"] = detune;
		this.filterNode["Q"]["value"] = q;
		this.filterNode["gain"]["value"] = gain;
		this.inputNode["connect"](this.filterNode);
		this.inputNode["connect"](this.dryNode);
		this.filterNode["connect"](this.wetNode);
	};
	FilterEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	FilterEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.filterNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	FilterEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	FilterEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[5] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 1:		// filter frequency
			this.params[1] = value;
			setAudioParam(this.filterNode["frequency"], value, ramp, time);
			break;
		case 2:		// filter detune
			this.params[2] = value;
			setAudioParam(this.filterNode["detune"], value, ramp, time);
			break;
		case 3:		// filter Q
			this.params[3] = value;
			setAudioParam(this.filterNode["Q"], value, ramp, time);
			break;
		case 4:		// filter/delay gain (note value is in dB here)
			this.params[4] = value;
			setAudioParam(this.filterNode["gain"], value, ramp, time);
			break;
		}
	};
	function DelayEffect(delayTime, delayGain, mix)
	{
		this.type = "delay";
		this.params = [delayTime, delayGain, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.mainNode = createGain();
		this.delayNode = createDelay(delayTime);
		this.delayNode["delayTime"]["value"] = delayTime;
		this.delayGainNode = createGain();
		this.delayGainNode["gain"]["value"] = delayGain;
		this.inputNode["connect"](this.mainNode);
		this.inputNode["connect"](this.dryNode);
		this.mainNode["connect"](this.wetNode);
		this.mainNode["connect"](this.delayNode);
		this.delayNode["connect"](this.delayGainNode);
		this.delayGainNode["connect"](this.mainNode);
	};
	DelayEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	DelayEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.mainNode["disconnect"]();
		this.delayNode["disconnect"]();
		this.delayGainNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	DelayEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	DelayEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[2] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 4:		// filter/delay gain (note value is passed in dB but needs to be linear here)
			this.params[1] = dbToLinear(value);
			setAudioParam(this.delayGainNode["gain"], dbToLinear(value), ramp, time);
			break;
		case 5:		// delay time
			this.params[0] = value;
			setAudioParam(this.delayNode["delayTime"], value, ramp, time);
			break;
		}
	};
	function ConvolveEffect(buffer, normalize, mix, src)
	{
		this.type = "convolve";
		this.params = [normalize, mix, src];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.convolveNode = context["createConvolver"]();
		if (buffer)
		{
			this.convolveNode["normalize"] = normalize;
			this.convolveNode["buffer"] = buffer;
		}
		this.inputNode["connect"](this.convolveNode);
		this.inputNode["connect"](this.dryNode);
		this.convolveNode["connect"](this.wetNode);
	};
	ConvolveEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	ConvolveEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.convolveNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	ConvolveEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	ConvolveEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		}
	};
	function FlangerEffect(delay, modulation, freq, feedback, mix)
	{
		this.type = "flanger";
		this.params = [delay, modulation, freq, feedback, mix];
		this.inputNode = createGain();
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - (mix / 2);
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix / 2;
		this.feedbackNode = createGain();
		this.feedbackNode["gain"]["value"] = feedback;
		this.delayNode = createDelay(delay + modulation);
		this.delayNode["delayTime"]["value"] = delay;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = modulation;
		this.inputNode["connect"](this.delayNode);
		this.inputNode["connect"](this.dryNode);
		this.delayNode["connect"](this.wetNode);
		this.delayNode["connect"](this.feedbackNode);
		this.feedbackNode["connect"](this.delayNode);
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.delayNode["delayTime"]);
		startSource(this.oscNode);
	};
	FlangerEffect.prototype.connectTo = function (node)
	{
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
	};
	FlangerEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.delayNode["disconnect"]();
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.dryNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.feedbackNode["disconnect"]();
	};
	FlangerEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	FlangerEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[4] = value;
			setAudioParam(this.wetNode["gain"], value / 2, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - (value / 2), ramp, time);
			break;
		case 6:		// modulation
			this.params[1] = value / 1000;
			setAudioParam(this.oscGainNode["gain"], value / 1000, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[2] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		case 8:		// feedback
			this.params[3] = value / 100;
			setAudioParam(this.feedbackNode["gain"], value / 100, ramp, time);
			break;
		}
	};
	function PhaserEffect(freq, detune, q, modulation, modfreq, mix)
	{
		this.type = "phaser";
		this.params = [freq, detune, q, modulation, modfreq, mix];
		this.inputNode = createGain();
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - (mix / 2);
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix / 2;
		this.filterNode = context["createBiquadFilter"]();
		if (typeof this.filterNode["type"] === "number")
			this.filterNode["type"] = 7;	// all-pass
		else
			this.filterNode["type"] = "allpass";
		this.filterNode["frequency"]["value"] = freq;
		if (this.filterNode["detune"])		// iOS 6 doesn't have detune yet
			this.filterNode["detune"]["value"] = detune;
		this.filterNode["Q"]["value"] = q;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = modfreq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = modulation;
		this.inputNode["connect"](this.filterNode);
		this.inputNode["connect"](this.dryNode);
		this.filterNode["connect"](this.wetNode);
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.filterNode["frequency"]);
		startSource(this.oscNode);
	};
	PhaserEffect.prototype.connectTo = function (node)
	{
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
	};
	PhaserEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.filterNode["disconnect"]();
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.dryNode["disconnect"]();
		this.wetNode["disconnect"]();
	};
	PhaserEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	PhaserEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[5] = value;
			setAudioParam(this.wetNode["gain"], value / 2, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - (value / 2), ramp, time);
			break;
		case 1:		// filter frequency
			this.params[0] = value;
			setAudioParam(this.filterNode["frequency"], value, ramp, time);
			break;
		case 2:		// filter detune
			this.params[1] = value;
			setAudioParam(this.filterNode["detune"], value, ramp, time);
			break;
		case 3:		// filter Q
			this.params[2] = value;
			setAudioParam(this.filterNode["Q"], value, ramp, time);
			break;
		case 6:		// modulation
			this.params[3] = value;
			setAudioParam(this.oscGainNode["gain"], value, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[4] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function GainEffect(g)
	{
		this.type = "gain";
		this.params = [g];
		this.node = createGain();
		this.node["gain"]["value"] = g;
	};
	GainEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	GainEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	GainEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	GainEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 4:		// gain
			this.params[0] = dbToLinear(value);
			setAudioParam(this.node["gain"], dbToLinear(value), ramp, time);
			break;
		}
	};
	function TremoloEffect(freq, mix)
	{
		this.type = "tremolo";
		this.params = [freq, mix];
		this.node = createGain();
		this.node["gain"]["value"] = 1 - (mix / 2);
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = mix / 2;
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.node["gain"]);
		startSource(this.oscNode);
	};
	TremoloEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	TremoloEffect.prototype.remove = function ()
	{
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.node["disconnect"]();
	};
	TremoloEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	TremoloEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.node["gain"]["value"], 1 - (value / 2), ramp, time);
			setAudioParam(this.oscGainNode["gain"]["value"], value / 2, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[0] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function RingModulatorEffect(freq, mix)
	{
		this.type = "ringmod";
		this.params = [freq, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.ringNode = createGain();
		this.ringNode["gain"]["value"] = 0;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscNode["connect"](this.ringNode["gain"]);
		startSource(this.oscNode);
		this.inputNode["connect"](this.ringNode);
		this.inputNode["connect"](this.dryNode);
		this.ringNode["connect"](this.wetNode);
	};
	RingModulatorEffect.prototype.connectTo = function (node_)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node_);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node_);
	};
	RingModulatorEffect.prototype.remove = function ()
	{
		this.oscNode["disconnect"]();
		this.ringNode["disconnect"]();
		this.inputNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	RingModulatorEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	RingModulatorEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[0] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function DistortionEffect(threshold, headroom, drive, makeupgain, mix)
	{
		this.type = "distortion";
		this.params = [threshold, headroom, drive, makeupgain, mix];
		this.inputNode = createGain();
		this.preGain = createGain();
		this.postGain = createGain();
		this.setDrive(drive, dbToLinear_nocap(makeupgain));
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.waveShaper = context["createWaveShaper"]();
		this.curve = new Float32Array(65536);
		this.generateColortouchCurve(threshold, headroom);
		this.waveShaper.curve = this.curve;
		this.inputNode["connect"](this.preGain);
		this.inputNode["connect"](this.dryNode);
		this.preGain["connect"](this.waveShaper);
		this.waveShaper["connect"](this.postGain);
		this.postGain["connect"](this.wetNode);
	};
	DistortionEffect.prototype.setDrive = function (drive, makeupgain)
	{
		if (drive < 0.01)
			drive = 0.01;
		this.preGain["gain"]["value"] = drive;
		this.postGain["gain"]["value"] = Math.pow(1 / drive, 0.6) * makeupgain;
	};
	function e4(x, k)
	{
		return 1.0 - Math.exp(-k * x);
	}
	DistortionEffect.prototype.shape = function (x, linearThreshold, linearHeadroom)
	{
		var maximum = 1.05 * linearHeadroom * linearThreshold;
		var kk = (maximum - linearThreshold);
		var sign = x < 0 ? -1 : +1;
		var absx = x < 0 ? -x : x;
		var shapedInput = absx < linearThreshold ? absx : linearThreshold + kk * e4(absx - linearThreshold, 1.0 / kk);
		shapedInput *= sign;
		return shapedInput;
	};
	DistortionEffect.prototype.generateColortouchCurve = function (threshold, headroom)
	{
		var linearThreshold = dbToLinear_nocap(threshold);
		var linearHeadroom = dbToLinear_nocap(headroom);
		var n = 65536;
		var n2 = n / 2;
		var x = 0;
		for (var i = 0; i < n2; ++i) {
			x = i / n2;
			x = this.shape(x, linearThreshold, linearHeadroom);
			this.curve[n2 + i] = x;
			this.curve[n2 - i - 1] = -x;
		}
	};
	DistortionEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	DistortionEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.preGain["disconnect"]();
		this.waveShaper["disconnect"]();
		this.postGain["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	DistortionEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	DistortionEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[4] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		}
	};
	function CompressorEffect(threshold, knee, ratio, attack, release)
	{
		this.type = "compressor";
		this.params = [threshold, knee, ratio, attack, release];
		this.node = context["createDynamicsCompressor"]();
		try {
			this.node["threshold"]["value"] = threshold;
			this.node["knee"]["value"] = knee;
			this.node["ratio"]["value"] = ratio;
			this.node["attack"]["value"] = attack;
			this.node["release"]["value"] = release;
		}
		catch (e) {}
	};
	CompressorEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	CompressorEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	CompressorEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	CompressorEffect.prototype.setParam = function(param, value, ramp, time)
	{
	};
	function AnalyserEffect(fftSize, smoothing)
	{
		this.type = "analyser";
		this.params = [fftSize, smoothing];
		this.node = context["createAnalyser"]();
		this.node["fftSize"] = fftSize;
		this.node["smoothingTimeConstant"] = smoothing;
		this.freqBins = new Float32Array(this.node["frequencyBinCount"]);
		this.signal = new Uint8Array(fftSize);
		this.peak = 0;
		this.rms = 0;
	};
	AnalyserEffect.prototype.tick = function ()
	{
		this.node["getFloatFrequencyData"](this.freqBins);
		this.node["getByteTimeDomainData"](this.signal);
		var fftSize = this.node["fftSize"];
		var i = 0;
		this.peak = 0;
		var rmsSquaredSum = 0;
		var s = 0;
		for ( ; i < fftSize; i++)
		{
			s = (this.signal[i] - 128) / 128;
			if (s < 0)
				s = -s;
			if (this.peak < s)
				this.peak = s;
			rmsSquaredSum += s * s;
		}
		this.peak = linearToDb(this.peak);
		this.rms = linearToDb(Math.sqrt(rmsSquaredSum / fftSize));
	};
	AnalyserEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	AnalyserEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	AnalyserEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	AnalyserEffect.prototype.setParam = function(param, value, ramp, time)
	{
	};
	var OT_POS_SAMPLES = 4;
	function ObjectTracker()
	{
		this.obj = null;
		this.loadUid = 0;
		this.speeds = [];
		this.lastX = 0;
		this.lastY = 0;
		this.moveAngle = 0;
	};
	ObjectTracker.prototype.setObject = function (obj_)
	{
		this.obj = obj_;
		if (this.obj)
		{
			this.lastX = this.obj.x;
			this.lastY = this.obj.y;
		}
		this.speeds.length = 0;
	};
	ObjectTracker.prototype.hasObject = function ()
	{
		return !!this.obj;
	};
	ObjectTracker.prototype.tick = function (dt)
	{
		if (!this.obj || dt === 0)
			return;
		this.moveAngle = cr.angleTo(this.lastX, this.lastY, this.obj.x, this.obj.y);
		var s = cr.distanceTo(this.lastX, this.lastY, this.obj.x, this.obj.y) / dt;
		if (this.speeds.length < OT_POS_SAMPLES)
			this.speeds.push(s);
		else
		{
			this.speeds.shift();
			this.speeds.push(s);
		}
		this.lastX = this.obj.x;
		this.lastY = this.obj.y;
	};
	ObjectTracker.prototype.getSpeed = function ()
	{
		if (!this.speeds.length)
			return 0;
		var i, len, sum = 0;
		for (i = 0, len = this.speeds.length; i < len; i++)
		{
			sum += this.speeds[i];
		}
		return sum / this.speeds.length;
	};
	ObjectTracker.prototype.getVelocityX = function ()
	{
		return Math.cos(this.moveAngle) * this.getSpeed();
	};
	ObjectTracker.prototype.getVelocityY = function ()
	{
		return Math.sin(this.moveAngle) * this.getSpeed();
	};
	var iOShadtouch = false;	// has had touch input on iOS to work around web audio API muting
	function C2AudioBuffer(src_, is_music)
	{
		this.src = src_;
		this.myapi = api;
		this.is_music = is_music;
		this.added_end_listener = false;
		var self = this;
		this.outNode = null;
		this.mediaSourceNode = null;
		this.panWhenReady = [];		// for web audio API positioned sounds
		this.seekWhenReady = 0;
		this.pauseWhenReady = false;
		this.supportWebAudioAPI = false;
		if (api === API_WEBAUDIO && is_music)
		{
			this.myapi = API_HTML5;
			this.outNode = createGain();
		}
		this.bufferObject = null;			// actual audio object
		this.audioData = null;				// web audio api: ajax request result (compressed audio that needs decoding)
		var request;
		switch (this.myapi) {
		case API_HTML5:
			this.bufferObject = new Audio();
			if (api === API_WEBAUDIO && context["createMediaElementSource"] && !audRuntime.isFirefox && !/wiiu/i.test(navigator.userAgent))
			{
				this.supportWebAudioAPI = true;		// can be routed through web audio api
				this.bufferObject.addEventListener("canplay", function ()
				{
					if (!self.mediaSourceNode)		// protect against this event firing twice
					{
						self.mediaSourceNode = context["createMediaElementSource"](self.bufferObject);
						self.mediaSourceNode["connect"](self.outNode);
					}
				});
			}
			this.bufferObject.autoplay = false;	// this is only a source buffer, not an instance
			this.bufferObject.preload = "auto";
			this.bufferObject.src = src_;
			break;
		case API_WEBAUDIO:
			request = new XMLHttpRequest();
			request.open("GET", src_, true);
			request.responseType = "arraybuffer";
			request.onload = function () {
				self.audioData = request.response;
				self.decodeAudioBuffer();
			};
			request.send();
			break;
		case API_PHONEGAP:
			this.bufferObject = true;
			break;
		case API_APPMOBI:
			this.bufferObject = true;
			break;
		}
	};
	C2AudioBuffer.prototype.decodeAudioBuffer = function ()
	{
		if (this.bufferObject || !this.audioData)
			return;		// audio already decoded or AJAX request not yet complete
		var self = this;
		if (context["decodeAudioData"])
		{
			context["decodeAudioData"](this.audioData, function (buffer) {
					self.bufferObject = buffer;
					var p, i, len, a;
					if (!cr.is_undefined(self.playTagWhenReady) && !silent)
					{
						if (self.panWhenReady.length)
						{
							for (i = 0, len = self.panWhenReady.length; i < len; i++)
							{
								p = self.panWhenReady[i];
								a = new C2AudioInstance(self, p.thistag);
								a.setPannerEnabled(true);
								if (typeof p.objUid !== "undefined")
								{
									p.obj = audRuntime.getObjectByUID(p.objUid);
									if (!p.obj)
										continue;
								}
								if (p.obj)
								{
									var px = cr.rotatePtAround(p.obj.x, p.obj.y, -p.obj.layer.getAngle(), listenerX, listenerY, true);
									var py = cr.rotatePtAround(p.obj.x, p.obj.y, -p.obj.layer.getAngle(), listenerX, listenerY, false);
									a.setPan(px, py, cr.to_degrees(p.obj.angle - p.obj.layer.getAngle()), p.ia, p.oa, p.og);
									a.setObject(p.obj);
								}
								else
								{
									a.setPan(p.x, p.y, p.a, p.ia, p.oa, p.og);
								}
								a.play(self.loopWhenReady, self.volumeWhenReady, self.seekWhenReady);
								if (self.pauseWhenReady)
									a.pause();
								audioInstances.push(a);
							}
							self.panWhenReady.length = 0;
						}
						else
						{
							a = new C2AudioInstance(self, self.playTagWhenReady);
							a.play(self.loopWhenReady, self.volumeWhenReady, self.seekWhenReady);
							if (self.pauseWhenReady)
								a.pause();
							audioInstances.push(a);
						}
					}
					else if (!cr.is_undefined(self.convolveWhenReady))
					{
						var convolveNode = self.convolveWhenReady.convolveNode;
						convolveNode["normalize"] = self.normalizeWhenReady;
						convolveNode["buffer"] = buffer;
					}
			});
		}
		else
		{
			this.bufferObject = context["createBuffer"](this.audioData, false);
			if (!cr.is_undefined(this.playTagWhenReady) && !silent)
			{
				var a = new C2AudioInstance(this, this.playTagWhenReady);
				a.play(this.loopWhenReady, this.volumeWhenReady, this.seekWhenReady);
				if (this.pauseWhenReady)
					a.pause();
				audioInstances.push(a);
			}
			else if (!cr.is_undefined(this.convolveWhenReady))
			{
				var convolveNode = this.convolveWhenReady.convolveNode;
				convolveNode["normalize"] = this.normalizeWhenReady;
				convolveNode["buffer"] = this.bufferObject;
			}
		}
	};
	C2AudioBuffer.prototype.isLoaded = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			return this.bufferObject["readyState"] === 4;	// HAVE_ENOUGH_DATA
		case API_WEBAUDIO:
			return !!this.audioData;			// null until AJAX request completes
		case API_PHONEGAP:
			return true;
		case API_APPMOBI:
			return true;
		}
		return false;
	};
	function C2AudioInstance(buffer_, tag_)
	{
		var self = this;
		this.tag = tag_;
		this.fresh = true;
		this.stopped = true;
		this.src = buffer_.src;
		this.buffer = buffer_;
		this.myapi = api;
		this.is_music = buffer_.is_music;
		this.playbackRate = 1;
		this.pgended = true;			// for PhoneGap only: ended flag
		this.resume_me = false;			// make sure resumes when leaving suspend
		this.is_paused = false;
		this.resume_position = 0;		// for web audio api to resume from correct playback position
		this.looping = false;
		this.is_muted = false;
		this.is_silent = false;
		this.volume = 1;
		this.mutevol = 1;
		this.startTime = audRuntime.kahanTime.sum;
		this.gainNode = null;
		this.pannerNode = null;
		this.pannerEnabled = false;
		this.objectTracker = null;
		this.panX = 0;
		this.panY = 0;
		this.panAngle = 0;
		this.panConeInner = 0;
		this.panConeOuter = 0;
		this.panConeOuterGain = 0;
		this.instanceObject = null;
		var add_end_listener = false;
		if (this.myapi === API_WEBAUDIO && this.buffer.myapi === API_HTML5 && !this.buffer.supportWebAudioAPI)
			this.myapi = API_HTML5;
		switch (this.myapi) {
		case API_HTML5:
			if (this.is_music)
			{
				this.instanceObject = buffer_.bufferObject;
				add_end_listener = !buffer_.added_end_listener;
				buffer_.added_end_listener = true;
			}
			else
			{
				this.instanceObject = new Audio();
				this.instanceObject.autoplay = false;
				this.instanceObject.src = buffer_.bufferObject.src;
				add_end_listener = true;
			}
			if (add_end_listener)
			{
				this.instanceObject.addEventListener('ended', function () {
						audTag = self.tag;
						self.stopped = true;
						audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
				});
			}
			break;
		case API_WEBAUDIO:
			this.gainNode = createGain();
			this.gainNode["connect"](getDestinationForTag(tag_));
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (buffer_.bufferObject)
				{
					this.instanceObject = context["createBufferSource"]();
					this.instanceObject["buffer"] = buffer_.bufferObject;
					this.instanceObject["connect"](this.gainNode);
				}
			}
			else
			{
				this.instanceObject = this.buffer.bufferObject;		// reference the audio element
				this.buffer.outNode["connect"](this.gainNode);
			}
			break;
		case API_PHONEGAP:
			this.instanceObject = new window["Media"](appPath + this.src, null, null, function (status) {
					if (status === window["Media"]["MEDIA_STOPPED"])
					{
						self.pgended = true;
						self.stopped = true;
						audTag = self.tag;
						audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
					}
			});
			break;
		case API_APPMOBI:
			this.instanceObject = true;
			break;
		}
	};
	C2AudioInstance.prototype.hasEnded = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			return this.instanceObject.ended;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (!this.fresh && !this.stopped && this.instanceObject["loop"])
					return false;
				if (this.is_paused)
					return false;
				return (audRuntime.kahanTime.sum - this.startTime) > this.buffer.bufferObject["duration"];
			}
			else
				return this.instanceObject.ended;
		case API_PHONEGAP:
			return this.pgended;
		case API_APPMOBI:
			true;	// recycling an AppMobi sound does not matter because it will just do another throwaway playSound
		}
		return true;
	};
	C2AudioInstance.prototype.canBeRecycled = function ()
	{
		if (this.fresh || this.stopped)
			return true;		// not yet used or is not playing
		return this.hasEnded();
	};
	C2AudioInstance.prototype.setPannerEnabled = function (enable_)
	{
		if (api !== API_WEBAUDIO)
			return;
		if (!this.pannerEnabled && enable_)
		{
			if (!this.gainNode)
				return;
			if (!this.pannerNode)
			{
				this.pannerNode = context["createPanner"]();
				if (typeof this.pannerNode["panningModel"] === "number")
					this.pannerNode["panningModel"] = panningModel;
				else
					this.pannerNode["panningModel"] = ["equalpower", "HRTF", "soundfield"][panningModel];
				if (typeof this.pannerNode["distanceModel"] === "number")
					this.pannerNode["distanceModel"] = distanceModel;
				else
					this.pannerNode["distanceModel"] = ["linear", "inverse", "exponential"][distanceModel];
				this.pannerNode["refDistance"] = refDistance;
				this.pannerNode["maxDistance"] = maxDistance;
				this.pannerNode["rolloffFactor"] = rolloffFactor;
			}
			this.gainNode["disconnect"]();
			this.gainNode["connect"](this.pannerNode);
			this.pannerNode["connect"](getDestinationForTag(this.tag));
			this.pannerEnabled = true;
		}
		else if (this.pannerEnabled && !enable_)
		{
			if (!this.gainNode)
				return;
			this.pannerNode["disconnect"]();
			this.gainNode["disconnect"]();
			this.gainNode["connect"](getDestinationForTag(this.tag));
			this.pannerEnabled = false;
		}
	};
	C2AudioInstance.prototype.setPan = function (x, y, angle, innerangle, outerangle, outergain)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO)
			return;
		this.pannerNode["setPosition"](x, y, 0);
		this.pannerNode["setOrientation"](Math.cos(cr.to_radians(angle)), Math.sin(cr.to_radians(angle)), 0);
		this.pannerNode["coneInnerAngle"] = innerangle;
		this.pannerNode["coneOuterAngle"] = outerangle;
		this.pannerNode["coneOuterGain"] = outergain;
		this.panX = x;
		this.panY = y;
		this.panAngle = angle;
		this.panConeInner = innerangle;
		this.panConeOuter = outerangle;
		this.panConeOuterGain = outergain;
	};
	C2AudioInstance.prototype.setObject = function (o)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO)
			return;
		if (!this.objectTracker)
			this.objectTracker = new ObjectTracker();
		this.objectTracker.setObject(o);
	};
	C2AudioInstance.prototype.tick = function (dt)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO || !this.objectTracker || !this.objectTracker.hasObject() || !this.isPlaying())
		{
			return;
		}
		this.objectTracker.tick(dt);
		var inst = this.objectTracker.obj;
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		this.pannerNode["setPosition"](px, py, 0);
		var a = 0;
		if (typeof this.objectTracker.obj.angle !== "undefined")
		{
			a = inst.angle - inst.layer.getAngle();
			this.pannerNode["setOrientation"](Math.cos(a), Math.sin(a), 0);
		}
		px = cr.rotatePtAround(this.objectTracker.getVelocityX(), this.objectTracker.getVelocityY(), -inst.layer.getAngle(), 0, 0, true);
		py = cr.rotatePtAround(this.objectTracker.getVelocityX(), this.objectTracker.getVelocityY(), -inst.layer.getAngle(), 0, 0, false);
		this.pannerNode["setVelocity"](px, py, 0);
	};
	C2AudioInstance.prototype.play = function (looping, vol, fromPosition)
	{
		var instobj = this.instanceObject;
		this.looping = looping;
		this.volume = vol;
		var seekPos = fromPosition || 0;
		switch (this.myapi) {
		case API_HTML5:
			if (instobj.playbackRate !== 1.0)
				instobj.playbackRate = 1.0;
			if (instobj.volume !== vol * masterVolume)
				instobj.volume = vol * masterVolume;
			if (instobj.loop !== looping)
				instobj.loop = looping;
			if (instobj.muted)
				instobj.muted = false;
			if (instobj.currentTime !== seekPos)
			{
				try {
					instobj.currentTime = seekPos;
				}
				catch (err)
				{
;
				}
			}
			if (this.is_music && isMusicWorkaround && !audRuntime.isInUserInputEvent)
				musicPlayNextTouch.push(this);
			else
			{
				try {
					this.instanceObject.play();
				}
				catch (e) {}	// sometimes throws on WP8.1... try not to kill the app
			}
			break;
		case API_WEBAUDIO:
			this.muted = false;
			this.mutevol = 1;
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (!this.fresh)
				{
					this.instanceObject = context["createBufferSource"]();
					this.instanceObject["buffer"] = this.buffer.bufferObject;
					this.instanceObject["connect"](this.gainNode);
				}
				this.instanceObject.loop = looping;
				this.gainNode["gain"]["value"] = vol * masterVolume;
				if (seekPos === 0)
					startSource(this.instanceObject);
				else
					startSourceAt(this.instanceObject, seekPos, this.getDuration());
			}
			else
			{
				if (instobj.playbackRate !== 1.0)
					instobj.playbackRate = 1.0;
				if (instobj.loop !== looping)
					instobj.loop = looping;
				this.gainNode["gain"]["value"] = vol * masterVolume;
				if (instobj.currentTime !== seekPos)
				{
					try {
						instobj.currentTime = seekPos;
					}
					catch (err)
					{
;
					}
				}
				if (this.is_music && isMusicWorkaround && !audRuntime.isInUserInputEvent)
					musicPlayNextTouch.push(this);
				else
					instobj.play();
			}
			break;
		case API_PHONEGAP:
			if ((!this.fresh && this.stopped) || seekPos !== 0)
				instobj["seekTo"](seekPos);
			instobj["play"]();
			this.pgended = false;
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["playSound"](this.src, looping);
			else
				AppMobi["player"]["playSound"](this.src, looping);
			break;
		}
		this.playbackRate = 1;
		this.startTime = audRuntime.kahanTime.sum - seekPos;
		this.fresh = false;
		this.stopped = false;
		this.is_paused = false;
	};
	C2AudioInstance.prototype.stop = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			if (!this.instanceObject.paused)
				this.instanceObject.pause();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
				stopSource(this.instanceObject);
			else
			{
				if (!this.instanceObject.paused)
					this.instanceObject.pause();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["stop"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["stopSound"](this.src);
			break;
		}
		this.stopped = true;
		this.is_paused = false;
	};
	C2AudioInstance.prototype.pause = function ()
	{
		if (this.fresh || this.stopped || this.hasEnded() || this.is_paused)
			return;
		switch (this.myapi) {
		case API_HTML5:
			if (!this.instanceObject.paused)
				this.instanceObject.pause();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				this.resume_position = this.getPlaybackTime();
				if (this.looping)
					this.resume_position = this.resume_position % this.getDuration();
				stopSource(this.instanceObject);
			}
			else
			{
				if (!this.instanceObject.paused)
					this.instanceObject.pause();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["pause"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["stopSound"](this.src);
			break;
		}
		this.is_paused = true;
	};
	C2AudioInstance.prototype.resume = function ()
	{
		if (this.fresh || this.stopped || this.hasEnded() || !this.is_paused)
			return;
		switch (this.myapi) {
		case API_HTML5:
			this.instanceObject.play();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				this.instanceObject = context["createBufferSource"]();
				this.instanceObject["buffer"] = this.buffer.bufferObject;
				this.instanceObject["connect"](this.gainNode);
				this.instanceObject.loop = this.looping;
				this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
				this.startTime = audRuntime.kahanTime.sum - this.resume_position;
				startSourceAt(this.instanceObject, this.resume_position, this.getDuration());
			}
			else
			{
				this.instanceObject.play();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["play"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["resumeSound"](this.src);
			break;
		}
		this.is_paused = false;
	};
	C2AudioInstance.prototype.seek = function (pos)
	{
		if (this.fresh || this.stopped || this.hasEnded())
			return;
		switch (this.myapi) {
		case API_HTML5:
			try {
				this.instanceObject.currentTime = pos;
			}
			catch (e) {}
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.is_paused)
					this.resume_position = pos;
				else
				{
					this.pause();
					this.resume_position = pos;
					this.resume();
				}
			}
			else
			{
				try {
					this.instanceObject.currentTime = pos;
				}
				catch (e) {}
			}
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["seekSound"](this.src, pos);
			break;
		}
	};
	C2AudioInstance.prototype.reconnect = function (toNode)
	{
		if (this.myapi !== API_WEBAUDIO)
			return;
		if (this.pannerEnabled)
		{
			this.pannerNode["disconnect"]();
			this.pannerNode["connect"](toNode);
		}
		else
		{
			this.gainNode["disconnect"]();
			this.gainNode["connect"](toNode);
		}
	};
	C2AudioInstance.prototype.getDuration = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			if (typeof this.instanceObject.duration !== "undefined")
				return this.instanceObject.duration;
			else
				return 0;
		case API_WEBAUDIO:
			return this.buffer.bufferObject["duration"];
		case API_PHONEGAP:
			return this.instanceObject["getDuration"]();
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				return AppMobi["context"]["getDurationSound"](this.src);
			else
				return 0;
		}
		return 0;
	};
	C2AudioInstance.prototype.getPlaybackTime = function ()
	{
		var duration = this.getDuration();
		var ret = 0;
		switch (this.myapi) {
		case API_HTML5:
			if (typeof this.instanceObject.currentTime !== "undefined")
				ret = this.instanceObject.currentTime;
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.is_paused)
					return this.resume_position;
				else
					ret = audRuntime.kahanTime.sum - this.startTime;
			}
			else if (typeof this.instanceObject.currentTime !== "undefined")
				ret = this.instanceObject.currentTime;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				ret = AppMobi["context"]["getPlaybackTimeSound"](this.src);
			break;
		}
		if (!this.looping && ret > duration)
			ret = duration;
		return ret;
	};
	C2AudioInstance.prototype.isPlaying = function ()
	{
		return !this.is_paused && !this.fresh && !this.stopped && !this.hasEnded();
	};
	C2AudioInstance.prototype.setVolume = function (v)
	{
		this.volume = v;
		this.updateVolume();
	};
	C2AudioInstance.prototype.updateVolume = function ()
	{
		var volToSet = this.volume * masterVolume;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.volume && this.instanceObject.volume !== volToSet)
				this.instanceObject.volume = volToSet;
			break;
		case API_WEBAUDIO:
			this.gainNode["gain"]["value"] = volToSet * this.mutevol;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.getVolume = function ()
	{
		return this.volume;
	};
	C2AudioInstance.prototype.doSetMuted = function (m)
	{
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.muted !== !!m)
				this.instanceObject.muted = !!m;
			break;
		case API_WEBAUDIO:
			this.mutevol = (m ? 0 : 1);
			this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.setMuted = function (m)
	{
		this.is_muted = !!m;
		this.doSetMuted(this.is_muted || this.is_silent);
	};
	C2AudioInstance.prototype.setSilent = function (m)
	{
		this.is_silent = !!m;
		this.doSetMuted(this.is_muted || this.is_silent);
	};
	C2AudioInstance.prototype.setLooping = function (l)
	{
		this.looping = l;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.loop !== !!l)
				this.instanceObject.loop = !!l;
			break;
		case API_WEBAUDIO:
			if (this.instanceObject.loop !== !!l)
				this.instanceObject.loop = !!l;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["setLoopingSound"](this.src, l);
			break;
		}
	};
	C2AudioInstance.prototype.setPlaybackRate = function (r)
	{
		this.playbackRate = r;
		this.updatePlaybackRate();
	};
	C2AudioInstance.prototype.updatePlaybackRate = function ()
	{
		var r = this.playbackRate;
		if ((timescale_mode === 1 && !this.is_music) || timescale_mode === 2)
			r *= audRuntime.timescale;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.playbackRate !== r)
				this.instanceObject.playbackRate = r;
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.instanceObject["playbackRate"]["value"] !== r)
					this.instanceObject["playbackRate"]["value"] = r;
			}
			else
			{
				if (this.instanceObject.playbackRate !== r)
					this.instanceObject.playbackRate = r;
			}
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.setSuspended = function (s)
	{
		switch (this.myapi) {
		case API_HTML5:
			if (s)
			{
				if (this.isPlaying())
				{
					this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
					this.instanceObject["play"]();
			}
			break;
		case API_WEBAUDIO:
			if (s)
			{
				if (this.isPlaying())
				{
					if (this.buffer.myapi === API_WEBAUDIO)
					{
						this.resume_position = this.getPlaybackTime();
						if (this.looping)
							this.resume_position = this.resume_position % this.getDuration();
						stopSource(this.instanceObject);
					}
					else
						this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
				{
					if (this.buffer.myapi === API_WEBAUDIO)
					{
						this.instanceObject = context["createBufferSource"]();
						this.instanceObject["buffer"] = this.buffer.bufferObject;
						this.instanceObject["connect"](this.gainNode);
						this.instanceObject.loop = this.looping;
						this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
						this.startTime = audRuntime.kahanTime.sum - this.resume_position;
						startSourceAt(this.instanceObject, this.resume_position, this.getDuration());
					}
					else
					{
						this.instanceObject["play"]();
					}
				}
			}
			break;
		case API_PHONEGAP:
			if (s)
			{
				if (this.isPlaying())
				{
					this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
					this.instanceObject["play"]();
			}
			break;
		case API_APPMOBI:
			break;
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		audRuntime = this.runtime;
		audInst = this;
		this.listenerTracker = null;
		this.listenerZ = -600;
		if ((this.runtime.isiOS || (this.runtime.isAndroid && (this.runtime.isChrome || this.runtime.isAndroidStockBrowser))) && !this.runtime.isCrosswalk && !this.runtime.isDomFree)
		{
			isMusicWorkaround = true;
		}
		context = null;
		if (typeof AudioContext !== "undefined")
		{
			api = API_WEBAUDIO;
			context = new AudioContext();
		}
		else if (typeof webkitAudioContext !== "undefined")
		{
			api = API_WEBAUDIO;
			context = new webkitAudioContext();
		}
		if ((this.runtime.isiOS && api === API_WEBAUDIO) || isMusicWorkaround)
		{
			document.addEventListener("touchstart", function ()
			{
				var i, len, m;
				if (!iOShadtouch && context)
				{
					var buffer = context["createBuffer"](1, 1, 22050);
					var source = context["createBufferSource"]();
					source["buffer"] = buffer;
					source["connect"](context["destination"]);
					startSource(source);
					iOShadtouch = true;
				}
				if (isMusicWorkaround)
				{
					if (!silent)
					{
						for (i = 0, len = musicPlayNextTouch.length; i < len; ++i)
						{
							m = musicPlayNextTouch[i];
							if (!m.stopped && !m.is_paused)
								m.instanceObject.play();
						}
					}
					musicPlayNextTouch.length = 0;
				}
			}, true);
		}
		if (api !== API_WEBAUDIO)
		{
			if (this.runtime.isPhoneGap)
				api = API_PHONEGAP;
			else if (this.runtime.isAppMobi)
				api = API_APPMOBI;
		}
		if (api === API_PHONEGAP)
		{
			appPath = location.href;
			var i = appPath.lastIndexOf("/");
			if (i > -1)
				appPath = appPath.substr(0, i + 1);
			appPath = appPath.replace("file://", "");
		}
		if (this.runtime.isSafari && this.runtime.isWindows && typeof Audio === "undefined")
		{
			alert("It looks like you're using Safari for Windows without Quicktime.  Audio cannot be played until Quicktime is installed.");
			this.runtime.DestroyInstance(this);
		}
		else
		{
			if (this.runtime.isDirectCanvas)
				useOgg = this.runtime.isAndroid;		// AAC on iOS, OGG on Android
			else
			{
				try {
					useOgg = !!(new Audio().canPlayType('audio/ogg; codecs="vorbis"'));
				}
				catch (e)
				{
					useOgg = false;
				}
			}
			switch (api) {
			case API_HTML5:
;
				break;
			case API_WEBAUDIO:
;
				break;
			case API_PHONEGAP:
;
				break;
			case API_APPMOBI:
;
				break;
			default:
;
			}
			this.runtime.tickMe(this);
		}
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function ()
	{
		timescale_mode = this.properties[0];	// 0 = off, 1 = sounds only, 2 = all
		this.saveload = this.properties[1];		// 0 = all, 1 = sounds only, 2 = music only, 3 = none
		panningModel = this.properties[2];		// 0 = equalpower, 1 = hrtf, 3 = soundfield
		distanceModel = this.properties[3];		// 0 = linear, 1 = inverse, 2 = exponential
		this.listenerZ = -this.properties[4];
		refDistance = this.properties[5];
		maxDistance = this.properties[6];
		rolloffFactor = this.properties[7];
		this.listenerTracker = new ObjectTracker();
		if (api === API_WEBAUDIO)
		{
			context["listener"]["speedOfSound"] = this.properties[8];
			context["listener"]["dopplerFactor"] = this.properties[9];
			context["listener"]["setPosition"](this.runtime.draw_width / 2, this.runtime.draw_height / 2, this.listenerZ);
			context["listener"]["setOrientation"](0, 0, 1, 0, -1, 0);
			window["c2OnAudioMicStream"] = function (localMediaStream, tag)
			{
				if (micSource)
					micSource["disconnect"]();
				micTag = tag.toLowerCase();
				micSource = context["createMediaStreamSource"](localMediaStream);
				micSource["connect"](getDestinationForTag(micTag));
			};
		}
		this.runtime.addSuspendCallback(function(s)
		{
			audInst.onSuspend(s);
		});
		var self = this;
		this.runtime.addDestroyCallback(function (inst)
		{
			self.onInstanceDestroyed(inst);
		});
	};
	instanceProto.onInstanceDestroyed = function (inst)
	{
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (a.objectTracker)
			{
				if (a.objectTracker.obj === inst)
				{
					a.objectTracker.obj = null;
					if (a.pannerEnabled && a.isPlaying() && a.looping)
						a.stop();
				}
			}
		}
		if (this.listenerTracker.obj === inst)
			this.listenerTracker.obj = null;
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"silent": silent,
			"masterVolume": masterVolume,
			"listenerZ": this.listenerZ,
			"listenerUid": this.listenerTracker.hasObject() ? this.listenerTracker.obj.uid : -1,
			"playing": [],
			"effects": {}
		};
		var playingarr = o["playing"];
		var i, len, a, d, p, panobj, playbackTime;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (!a.isPlaying())
				continue;				// no need to save stopped sounds
			if (this.saveload === 3)	// not saving/loading any sounds/music
				continue;
			if (a.is_music && this.saveload === 1)	// not saving/loading music
				continue;
			if (!a.is_music && this.saveload === 2)	// not saving/loading sound
				continue;
			playbackTime = a.getPlaybackTime();
			if (a.looping)
				playbackTime = playbackTime % a.getDuration();
			d = {
				"tag": a.tag,
				"buffersrc": a.buffer.src,
				"is_music": a.is_music,
				"playbackTime": playbackTime,
				"volume": a.volume,
				"looping": a.looping,
				"muted": a.is_muted,
				"playbackRate": a.playbackRate,
				"paused": a.is_paused,
				"resume_position": a.resume_position
			};
			if (a.pannerEnabled)
			{
				d["pan"] = {};
				panobj = d["pan"];
				if (a.objectTracker && a.objectTracker.hasObject())
				{
					panobj["objUid"] = a.objectTracker.obj.uid;
				}
				else
				{
					panobj["x"] = a.panX;
					panobj["y"] = a.panY;
					panobj["a"] = a.panAngle;
				}
				panobj["ia"] = a.panConeInner;
				panobj["oa"] = a.panConeOuter;
				panobj["og"] = a.panConeOuterGain;
			}
			playingarr.push(d);
		}
		var fxobj = o["effects"];
		var fxarr;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				fxarr = [];
				for (i = 0, len = effects[p].length; i < len; i++)
				{
					fxarr.push({ "type": effects[p][i].type, "params": effects[p][i].params });
				}
				fxobj[p] = fxarr;
			}
		}
		return o;
	};
	var objectTrackerUidsToLoad = [];
	instanceProto.loadFromJSON = function (o)
	{
		var setSilent = o["silent"];
		masterVolume = o["masterVolume"];
		this.listenerZ = o["listenerZ"];
		this.listenerTracker.setObject(null);
		var listenerUid = o["listenerUid"];
		if (listenerUid !== -1)
		{
			this.listenerTracker.loadUid = listenerUid;
			objectTrackerUidsToLoad.push(this.listenerTracker);
		}
		var playingarr = o["playing"];
		var i, len, d, src, is_music, tag, playbackTime, looping, vol, b, a, p, pan, panObjUid;
		if (this.saveload !== 3)
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
			{
				a = audioInstances[i];
				if (a.is_music && this.saveload === 1)
					continue;		// only saving/loading sound: leave music playing
				if (!a.is_music && this.saveload === 2)
					continue;		// only saving/loading music: leave sound playing
				a.stop();
			}
		}
		var fxarr, fxtype, fxparams, fx;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				for (i = 0, len = effects[p].length; i < len; i++)
					effects[p][i].remove();
			}
		}
		cr.wipe(effects);
		for (p in o["effects"])
		{
			if (o["effects"].hasOwnProperty(p))
			{
				fxarr = o["effects"][p];
				for (i = 0, len = fxarr.length; i < len; i++)
				{
					fxtype = fxarr[i]["type"];
					fxparams = fxarr[i]["params"];
					switch (fxtype) {
					case "filter":
						addEffectForTag(p, new FilterEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4], fxparams[5]));
						break;
					case "delay":
						addEffectForTag(p, new DelayEffect(fxparams[0], fxparams[1], fxparams[2]));
						break;
					case "convolve":
						src = fxparams[2];
						b = this.getAudioBuffer(src, false);
						if (b.bufferObject)
						{
							fx = new ConvolveEffect(b.bufferObject, fxparams[0], fxparams[1], src);
						}
						else
						{
							fx = new ConvolveEffect(null, fxparams[0], fxparams[1], src);
							b.normalizeWhenReady = fxparams[0];
							b.convolveWhenReady = fx;
						}
						addEffectForTag(p, fx);
						break;
					case "flanger":
						addEffectForTag(p, new FlangerEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "phaser":
						addEffectForTag(p, new PhaserEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4], fxparams[5]));
						break;
					case "gain":
						addEffectForTag(p, new GainEffect(fxparams[0]));
						break;
					case "tremolo":
						addEffectForTag(p, new TremoloEffect(fxparams[0], fxparams[1]));
						break;
					case "ringmod":
						addEffectForTag(p, new RingModulatorEffect(fxparams[0], fxparams[1]));
						break;
					case "distortion":
						addEffectForTag(p, new DistortionEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "compressor":
						addEffectForTag(p, new CompressorEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "analyser":
						addEffectForTag(p, new AnalyserEffect(fxparams[0], fxparams[1]));
						break;
					}
				}
			}
		}
		for (i = 0, len = playingarr.length; i < len; i++)
		{
			if (this.saveload === 3)	// not saving/loading any sounds/music
				continue;
			d = playingarr[i];
			src = d["buffersrc"];
			is_music = d["is_music"];
			tag = d["tag"];
			playbackTime = d["playbackTime"];
			looping = d["looping"];
			vol = d["volume"];
			pan = d["pan"];
			panObjUid = (pan && pan.hasOwnProperty("objUid")) ? pan["objUid"] : -1;
			if (is_music && this.saveload === 1)	// not saving/loading music
				continue;
			if (!is_music && this.saveload === 2)	// not saving/loading sound
				continue;
			a = this.getAudioInstance(src, tag, is_music, looping, vol);
			if (!a)
			{
				b = this.getAudioBuffer(src, is_music);
				b.seekWhenReady = playbackTime;
				b.pauseWhenReady = d["paused"];
				if (pan)
				{
					if (panObjUid !== -1)
					{
						b.panWhenReady.push({ objUid: panObjUid, ia: pan["ia"], oa: pan["oa"], og: pan["og"], thistag: tag });
					}
					else
					{
						b.panWhenReady.push({ x: pan["x"], y: pan["y"], a: pan["a"], ia: pan["ia"], oa: pan["oa"], og: pan["og"], thistag: tag });
					}
				}
				continue;
			}
			a.resume_position = d["resume_position"];
			a.setPannerEnabled(!!pan);
			a.play(looping, vol, playbackTime);
			a.updatePlaybackRate();
			a.updateVolume();
			a.doSetMuted(a.is_muted || a.is_silent);
			if (d["paused"])
				a.pause();
			if (d["muted"])
				a.setMuted(true);
			a.doSetMuted(a.is_muted || a.is_silent);
			if (pan)
			{
				if (panObjUid !== -1)
				{
					a.objectTracker = a.objectTracker || new ObjectTracker();
					a.objectTracker.loadUid = panObjUid;
					objectTrackerUidsToLoad.push(a.objectTracker);
				}
				else
				{
					a.setPan(pan["x"], pan["y"], pan["a"], pan["ia"], pan["oa"], pan["og"]);
				}
			}
		}
		if (setSilent && !silent)			// setting silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(true);
			silent = true;
		}
		else if (!setSilent && silent)		// setting not silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(false);
			silent = false;
		}
	};
	instanceProto.afterLoad = function ()
	{
		var i, len, ot, inst;
		for (i = 0, len = objectTrackerUidsToLoad.length; i < len; i++)
		{
			ot = objectTrackerUidsToLoad[i];
			inst = this.runtime.getObjectByUID(ot.loadUid);
			ot.setObject(inst);
			ot.loadUid = -1;
			if (inst)
			{
				listenerX = inst.x;
				listenerY = inst.y;
			}
		}
		objectTrackerUidsToLoad.length = 0;
	};
	instanceProto.onSuspend = function (s)
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].setSuspended(s);
	};
	instanceProto.tick = function ()
	{
		var dt = this.runtime.dt;
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			a.tick(dt);
			if (a.myapi !== API_HTML5 && a.myapi !== API_APPMOBI)
			{
				if (!a.fresh && !a.stopped && a.hasEnded())
				{
					a.stopped = true;
					audTag = a.tag;
					audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
				}
			}
			if (timescale_mode !== 0)
				a.updatePlaybackRate();
		}
		var p, arr, f;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				arr = effects[p];
				for (i = 0, len = arr.length; i < len; i++)
				{
					f = arr[i];
					if (f.tick)
						f.tick();
				}
			}
		}
		if (api === API_WEBAUDIO && this.listenerTracker.hasObject())
		{
			this.listenerTracker.tick(dt);
			listenerX = this.listenerTracker.obj.x;
			listenerY = this.listenerTracker.obj.y;
			context["listener"]["setPosition"](this.listenerTracker.obj.x, this.listenerTracker.obj.y, this.listenerZ);
			context["listener"]["setVelocity"](this.listenerTracker.getVelocityX(), this.listenerTracker.getVelocityY(), 0);
		}
	};
	instanceProto.getAudioBuffer = function (src_, is_music)
	{
		var i, len, a, ret = null, j, k, lenj, ai;
		for (i = 0, len = audioBuffers.length; i < len; i++)
		{
			a = audioBuffers[i];
			if (a.src === src_)
			{
				ret = a;
				break;
			}
		}
		if (!ret)
		{
			ret = new C2AudioBuffer(src_, is_music);
			audioBuffers.push(ret);
		}
		return ret;
	};
	instanceProto.getAudioInstance = function (src_, tag, is_music, looping, vol)
	{
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (a.src === src_ && (a.canBeRecycled() || is_music))
			{
				a.tag = tag;
				return a;
			}
		}
		var b = this.getAudioBuffer(src_, is_music);
		if (!b.bufferObject)
		{
			if (tag !== "<preload>")
			{
				b.playTagWhenReady = tag;
				b.loopWhenReady = looping;
				b.volumeWhenReady = vol;
			}
			return null;
		}
		a = new C2AudioInstance(b, tag);
		audioInstances.push(a);
		return a;
	};
	var taggedAudio = [];
	function getAudioByTag(tag)
	{
		taggedAudio.length = 0;
		if (!tag.length)
		{
			if (!lastAudio || lastAudio.hasEnded())
				return;
			else
			{
				taggedAudio.length = 1;
				taggedAudio[0] = lastAudio;
				return;
			}
		}
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (cr.equals_nocase(tag, a.tag))
				taggedAudio.push(a);
		}
	};
	function reconnectEffects(tag)
	{
		var i, len, arr, n, toNode = context["destination"];
		if (effects.hasOwnProperty(tag))
		{
			arr = effects[tag];
			if (arr.length)
			{
				toNode = arr[0].getInputNode();
				for (i = 0, len = arr.length; i < len; i++)
				{
					n = arr[i];
					if (i + 1 === len)
						n.connectTo(context["destination"]);
					else
						n.connectTo(arr[i + 1].getInputNode());
				}
			}
		}
		getAudioByTag(tag);
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].reconnect(toNode);
		if (micSource && micTag === tag)
		{
			micSource["disconnect"]();
			micSource["connect"](toNode);
		}
	};
	function addEffectForTag(tag, fx)
	{
		if (!effects.hasOwnProperty(tag))
			effects[tag] = [fx];
		else
			effects[tag].push(fx);
		reconnectEffects(tag);
	};
	function Cnds() {};
	Cnds.prototype.OnEnded = function (t)
	{
		return cr.equals_nocase(audTag, t);
	};
	Cnds.prototype.PreloadsComplete = function ()
	{
		var i, len;
		for (i = 0, len = audioBuffers.length; i < len; i++)
		{
			if (!audioBuffers[i].isLoaded())
				return false;
		}
		return true;
	};
	Cnds.prototype.AdvancedAudioSupported = function ()
	{
		return api === API_WEBAUDIO;
	};
	Cnds.prototype.IsSilent = function ()
	{
		return silent;
	};
	Cnds.prototype.IsAnyPlaying = function ()
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			if (audioInstances[i].isPlaying())
				return true;
		}
		return false;
	};
	Cnds.prototype.IsTagPlaying = function (tag)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			if (taggedAudio[i].isPlaying())
				return true;
		}
		return false;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Play = function (file, looping, vol, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
			return;
		lastAudio.setPannerEnabled(false);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtPosition = function (file, looping, vol, x_, y_, angle_, innerangle_, outerangle_, outergain_, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ x: x_, y: y_, a: angle_, ia: innerangle_, oa: outerangle_, og: dbToLinear(outergain_), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		lastAudio.setPan(x_, y_, angle_, innerangle_, outerangle_, dbToLinear(outergain_));
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtObject = function (file, looping, vol, obj, innerangle, outerangle, outergain, tag)
	{
		if (silent || !obj)
			return;
		var inst = obj.getFirstPicked();
		if (!inst)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ obj: inst, ia: innerangle, oa: outerangle, og: dbToLinear(outergain), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		lastAudio.setPan(px, py, cr.to_degrees(inst.angle - inst.layer.getAngle()), innerangle, outerangle, dbToLinear(outergain));
		lastAudio.setObject(inst);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayByName = function (folder, filename, looping, vol, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
			return;
		lastAudio.setPannerEnabled(false);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtPositionByName = function (folder, filename, looping, vol, x_, y_, angle_, innerangle_, outerangle_, outergain_, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ x: x_, y: y_, a: angle_, ia: innerangle_, oa: outerangle_, og: dbToLinear(outergain_), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		lastAudio.setPan(x_, y_, angle_, innerangle_, outerangle_, dbToLinear(outergain_));
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtObjectByName = function (folder, filename, looping, vol, obj, innerangle, outerangle, outergain, tag)
	{
		if (silent || !obj)
			return;
		var inst = obj.getFirstPicked();
		if (!inst)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ obj: inst, ia: innerangle, oa: outerangle, og: dbToLinear(outergain), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		lastAudio.setPan(px, py, cr.to_degrees(inst.angle - inst.layer.getAngle()), innerangle, outerangle, dbToLinear(outergain));
		lastAudio.setObject(inst);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.SetLooping = function (tag, looping)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setLooping(looping === 0);
	};
	Acts.prototype.SetMuted = function (tag, muted)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setMuted(muted === 0);
	};
	Acts.prototype.SetVolume = function (tag, vol)
	{
		getAudioByTag(tag);
		var v = dbToLinear(vol);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setVolume(v);
	};
	Acts.prototype.Preload = function (file)
	{
		if (silent)
			return;
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		if (api === API_APPMOBI)
		{
			if (this.runtime.isDirectCanvas)
				AppMobi["context"]["loadSound"](src);
			else
				AppMobi["player"]["loadSound"](src);
			return;
		}
		else if (api === API_PHONEGAP)
		{
			return;
		}
		this.getAudioInstance(src, "<preload>", is_music, false);
	};
	Acts.prototype.PreloadByName = function (folder, filename)
	{
		if (silent)
			return;
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		if (api === API_APPMOBI)
		{
			if (this.runtime.isDirectCanvas)
				AppMobi["context"]["loadSound"](src);
			else
				AppMobi["player"]["loadSound"](src);
			return;
		}
		else if (api === API_PHONEGAP)
		{
			return;
		}
		this.getAudioInstance(src, "<preload>", is_music, false);
	};
	Acts.prototype.SetPlaybackRate = function (tag, rate)
	{
		getAudioByTag(tag);
		if (rate < 0.0)
			rate = 0;
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setPlaybackRate(rate);
	};
	Acts.prototype.Stop = function (tag)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].stop();
	};
	Acts.prototype.StopAll = function ()
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].stop();
	};
	Acts.prototype.SetPaused = function (tag, state)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			if (state === 0)
				taggedAudio[i].pause();
			else
				taggedAudio[i].resume();
		}
	};
	Acts.prototype.Seek = function (tag, pos)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			taggedAudio[i].seek(pos);
		}
	};
	Acts.prototype.SetSilent = function (s)
	{
		var i, len;
		if (s === 2)					// toggling
			s = (silent ? 1 : 0);		// choose opposite state
		if (s === 0 && !silent)			// setting silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(true);
			silent = true;
		}
		else if (s === 1 && silent)		// setting not silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(false);
			silent = false;
		}
	};
	Acts.prototype.SetMasterVolume = function (vol)
	{
		masterVolume = dbToLinear(vol);
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].updateVolume();
	};
	Acts.prototype.AddFilterEffect = function (tag, type, freq, detune, q, gain, mix)
	{
		if (api !== API_WEBAUDIO || type < 0 || type >= filterTypes.length || !context["createBiquadFilter"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new FilterEffect(type, freq, detune, q, gain, mix));
	};
	Acts.prototype.AddDelayEffect = function (tag, delay, gain, mix)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new DelayEffect(delay, dbToLinear(gain), mix));
	};
	Acts.prototype.AddFlangerEffect = function (tag, delay, modulation, freq, feedback, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new FlangerEffect(delay / 1000, modulation / 1000, freq, feedback / 100, mix));
	};
	Acts.prototype.AddPhaserEffect = function (tag, freq, detune, q, mod, modfreq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new PhaserEffect(freq, detune, q, mod, modfreq, mix));
	};
	Acts.prototype.AddConvolutionEffect = function (tag, file, norm, mix)
	{
		if (api !== API_WEBAUDIO || !context["createConvolver"])
			return;
		var doNormalize = (norm === 0);
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		var b = this.getAudioBuffer(src, false);
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		var fx;
		if (b.bufferObject)
		{
			fx = new ConvolveEffect(b.bufferObject, doNormalize, mix, src);
		}
		else
		{
			fx = new ConvolveEffect(null, doNormalize, mix, src);
			b.normalizeWhenReady = doNormalize;
			b.convolveWhenReady = fx;
		}
		addEffectForTag(tag, fx);
	};
	Acts.prototype.AddGainEffect = function (tag, g)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new GainEffect(dbToLinear(g)));
	};
	Acts.prototype.AddMuteEffect = function (tag)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new GainEffect(0));	// re-use gain effect with 0 gain
	};
	Acts.prototype.AddTremoloEffect = function (tag, freq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new TremoloEffect(freq, mix));
	};
	Acts.prototype.AddRingModEffect = function (tag, freq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new RingModulatorEffect(freq, mix));
	};
	Acts.prototype.AddDistortionEffect = function (tag, threshold, headroom, drive, makeupgain, mix)
	{
		if (api !== API_WEBAUDIO || !context["createWaveShaper"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new DistortionEffect(threshold, headroom, drive, makeupgain, mix));
	};
	Acts.prototype.AddCompressorEffect = function (tag, threshold, knee, ratio, attack, release)
	{
		if (api !== API_WEBAUDIO || !context["createDynamicsCompressor"])
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new CompressorEffect(threshold, knee, ratio, attack / 1000, release / 1000));
	};
	Acts.prototype.AddAnalyserEffect = function (tag, fftSize, smoothing)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new AnalyserEffect(fftSize, smoothing));
	};
	Acts.prototype.RemoveEffects = function (tag)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		var i, len, arr;
		if (effects.hasOwnProperty(tag))
		{
			arr = effects[tag];
			if (arr.length)
			{
				for (i = 0, len = arr.length; i < len; i++)
					arr[i].remove();
				arr.length = 0;
				reconnectEffects(tag);
			}
		}
	};
	Acts.prototype.SetEffectParameter = function (tag, index, param, value, ramp, time)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var arr;
		if (!effects.hasOwnProperty(tag))
			return;
		arr = effects[tag];
		if (index < 0 || index >= arr.length)
			return;
		arr[index].setParam(param, value, ramp, time);
	};
	Acts.prototype.SetListenerObject = function (obj_)
	{
		if (!obj_ || api !== API_WEBAUDIO)
			return;
		var inst = obj_.getFirstPicked();
		if (!inst)
			return;
		this.listenerTracker.setObject(inst);
		listenerX = inst.x;
		listenerY = inst.y;
	};
	Acts.prototype.SetListenerZ = function (z)
	{
		this.listenerZ = z;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Duration = function (ret, tag)
	{
		getAudioByTag(tag);
		if (taggedAudio.length)
			ret.set_float(taggedAudio[0].getDuration());
		else
			ret.set_float(0);
	};
	Exps.prototype.PlaybackTime = function (ret, tag)
	{
		getAudioByTag(tag);
		if (taggedAudio.length)
			ret.set_float(taggedAudio[0].getPlaybackTime());
		else
			ret.set_float(0);
	};
	Exps.prototype.Volume = function (ret, tag)
	{
		getAudioByTag(tag);
		if (taggedAudio.length)
		{
			var v = taggedAudio[0].getVolume();
			ret.set_float(linearToDb(v));
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.MasterVolume = function (ret)
	{
		ret.set_float(masterVolume);
	};
	Exps.prototype.EffectCount = function (ret, tag)
	{
		tag = tag.toLowerCase();
		var arr = null;
		if (effects.hasOwnProperty(tag))
			arr = effects[tag];
		ret.set_int(arr ? arr.length : 0);
	};
	function getAnalyser(tag, index)
	{
		var arr = null;
		if (effects.hasOwnProperty(tag))
			arr = effects[tag];
		if (arr && index >= 0 && index < arr.length && arr[index].freqBins)
			return arr[index];
		else
			return null;
	};
	Exps.prototype.AnalyserFreqBinCount = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		ret.set_int(analyser ? analyser.node["frequencyBinCount"] : 0);
	};
	Exps.prototype.AnalyserFreqBinAt = function (ret, tag, index, bin)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		bin = Math.floor(bin);
		var analyser = getAnalyser(tag, index);
		if (!analyser)
			ret.set_float(0);
		else if (bin < 0 || bin >= analyser.node["frequencyBinCount"])
			ret.set_float(0);
		else
			ret.set_float(analyser.freqBins[bin]);
	};
	Exps.prototype.AnalyserPeakLevel = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		if (analyser)
			ret.set_float(analyser.peak);
		else
			ret.set_float(0);
	};
	Exps.prototype.AnalyserRMSLevel = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		if (analyser)
			ret.set_float(analyser.rms);
		else
			ret.set_float(0);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Browser = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Browser.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		var self = this;
		window.addEventListener("resize", function () {
			self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize, self);
		});
		if (typeof navigator.onLine !== "undefined")
		{
			window.addEventListener("online", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline, self);
			});
			window.addEventListener("offline", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline, self);
			});
		}
		if (typeof window.applicationCache !== "undefined")
		{
			window.applicationCache.addEventListener('updateready', function() {
				self.runtime.loadingprogress = 1;
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady, self);
			});
			window.applicationCache.addEventListener('progress', function(e) {
				self.runtime.loadingprogress = e["loaded"] / e["total"];
			});
		}
		if (!this.runtime.isDirectCanvas)
		{
			document.addEventListener("appMobi.device.update.available", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady, self);
			});
			document.addEventListener("backbutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
			});
			document.addEventListener("menubutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton, self);
			});
			document.addEventListener("searchbutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton, self);
			});
			document.addEventListener("tizenhwkey", function (e) {
				var ret;
				switch (e["keyName"]) {
				case "back":
					ret = self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
					if (!ret)
					{
						if (window["tizen"])
							window["tizen"]["application"]["getCurrentApplication"]()["exit"]();
					}
					break;
				case "menu":
					ret = self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton, self);
					if (!ret)
						e.preventDefault();
					break;
				}
			});
		}
		if (this.runtime.isWindowsPhone81)
		{
			WinJS["Application"]["onbackclick"] = function (e)
			{
				return !!self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
			};
		}
		this.runtime.addSuspendCallback(function(s) {
			if (s)
			{
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden, self);
			}
			else
			{
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible, self);
			}
		});
		this.is_arcade = (typeof window["is_scirra_arcade"] !== "undefined");
	};
	function Cnds() {};
	Cnds.prototype.CookiesEnabled = function()
	{
		return navigator ? navigator.cookieEnabled : false;
	};
	Cnds.prototype.IsOnline = function()
	{
		return navigator ? navigator.onLine : false;
	};
	Cnds.prototype.HasJava = function()
	{
		return navigator ? navigator.javaEnabled() : false;
	};
	Cnds.prototype.OnOnline = function()
	{
		return true;
	};
	Cnds.prototype.OnOffline = function()
	{
		return true;
	};
	Cnds.prototype.IsDownloadingUpdate = function ()
	{
		if (typeof window["applicationCache"] === "undefined")
			return false;
		else
			return window["applicationCache"]["status"] === window["applicationCache"]["DOWNLOADING"];
	};
	Cnds.prototype.OnUpdateReady = function ()
	{
		return true;
	};
	Cnds.prototype.PageVisible = function ()
	{
		return !this.runtime.isSuspended;
	};
	Cnds.prototype.OnPageVisible = function ()
	{
		return true;
	};
	Cnds.prototype.OnPageHidden = function ()
	{
		return true;
	};
	Cnds.prototype.OnResize = function ()
	{
		return true;
	};
	Cnds.prototype.IsFullscreen = function ()
	{
		return !!(document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || this.runtime.isNodeFullscreen);
	};
	Cnds.prototype.OnBackButton = function ()
	{
		return true;
	};
	Cnds.prototype.OnMenuButton = function ()
	{
		return true;
	};
	Cnds.prototype.OnSearchButton = function ()
	{
		return true;
	};
	Cnds.prototype.IsMetered = function ()
	{
		var connection = navigator["connection"] || navigator["mozConnection"] || navigator["webkitConnection"];
		if (!connection)
			return false;
		return connection["metered"];
	};
	Cnds.prototype.IsCharging = function ()
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			return true;
		return battery["charging"];
	};
	Cnds.prototype.IsPortraitLandscape = function (p)
	{
		var current = (window.innerWidth <= window.innerHeight ? 0 : 1);
		return current === p;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Alert = function (msg)
	{
		if (!this.runtime.isDomFree)
			alert(msg.toString());
	};
	Acts.prototype.Close = function ()
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["forceToFinish"]();
		else if (window["tizen"])
			window["tizen"]["application"]["getCurrentApplication"]()["exit"]();
		else if (navigator["app"] && navigator["app"]["exitApp"])
			navigator["app"]["exitApp"]();
		else if (navigator["device"] && navigator["device"]["exitApp"])
			navigator["device"]["exitApp"]();
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.close();
	};
	Acts.prototype.Focus = function ()
	{
		if (this.runtime.isNodeWebkit)
		{
			var win = window["nwgui"]["Window"]["get"]();
			win["focus"]();
		}
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.focus();
	};
	Acts.prototype.Blur = function ()
	{
		if (this.runtime.isNodeWebkit)
		{
			var win = window["nwgui"]["Window"]["get"]();
			win["blur"]();
		}
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.blur();
	};
	Acts.prototype.GoBack = function ()
	{
		if (navigator["app"] && navigator["app"]["backHistory"])
			navigator["app"]["backHistory"]();
		else if (!this.is_arcade && !this.runtime.isDomFree && window.back)
			window.back();
	};
	Acts.prototype.GoForward = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree && window.forward)
			window.forward();
	};
	Acts.prototype.GoHome = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree && window.home)
			window.home();
	};
	Acts.prototype.GoToURL = function (url)
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["openURL"](url);
		else if (this.runtime.isEjecta)
			ejecta["openURL"](url);
		else if (this.runtime.isWinJS)
			Windows["System"]["Launcher"]["launchUriAsync"](new Windows["Foundation"]["Uri"](url));
		else if (navigator["app"] && navigator["app"]["loadUrl"])
			navigator["app"]["loadUrl"](url, { "openExternal": true });
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.location = url;
	};
	Acts.prototype.GoToURLWindow = function (url, tag)
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["openURL"](url);
		else if (this.runtime.isEjecta)
			ejecta["openURL"](url);
		else if (this.runtime.isWinJS)
			Windows["System"]["Launcher"]["launchUriAsync"](new Windows["Foundation"]["Uri"](url));
		else if (navigator["app"] && navigator["app"]["loadUrl"])
			navigator["app"]["loadUrl"](url, { "openExternal": true });
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.open(url, tag);
	};
	Acts.prototype.Reload = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree)
			window.location.reload();
	};
	var firstRequestFullscreen = true;
	var crruntime = null;
	function onFullscreenError()
	{
		if (typeof jQuery !== "undefined")
		{
			crruntime["setSize"](jQuery(window).width(), jQuery(window).height());
		}
	};
	Acts.prototype.RequestFullScreen = function (stretchmode)
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored");
			return;
		}
		if (stretchmode >= 2)
			stretchmode += 1;
		if (stretchmode === 6)
			stretchmode = 2;
		if (this.runtime.isNodeWebkit)
		{
			if (!this.runtime.isNodeFullscreen)
			{
				window["nwgui"]["Window"]["get"]()["enterFullscreen"]();
				this.runtime.isNodeFullscreen = true;
				this.runtime.fullscreen_scaling = (stretchmode >= 2 ? stretchmode : 0);
			}
		}
		else
		{
			if (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"])
			{
				return;
			}
			this.runtime.fullscreen_scaling = (stretchmode >= 2 ? stretchmode : 0);
			var elem = this.runtime.canvasdiv || this.runtime.canvas;
			if (firstRequestFullscreen)
			{
				firstRequestFullscreen = false;
				crruntime = this.runtime;
				elem.addEventListener("mozfullscreenerror", onFullscreenError);
				elem.addEventListener("webkitfullscreenerror", onFullscreenError);
				elem.addEventListener("msfullscreenerror", onFullscreenError);
				elem.addEventListener("fullscreenerror", onFullscreenError);
			}
			if (!cr.is_undefined(elem["requestFullscreen"]))
				elem["requestFullscreen"]();
			else if (!cr.is_undefined(elem["webkitRequestFullScreen"]))
			{
				if (typeof Element !== "undefined" && typeof Element["ALLOW_KEYBOARD_INPUT"] !== "undefined")
					elem["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"]);
				else
					elem["webkitRequestFullScreen"]();
			}
			else if (!cr.is_undefined(elem["mozRequestFullScreen"]))
				elem["mozRequestFullScreen"]();
			else if (!cr.is_undefined(elem["msRequestFullscreen"]))
				elem["msRequestFullscreen"]();
		}
	};
	Acts.prototype.CancelFullScreen = function ()
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored");
			return;
		}
		if (this.runtime.isNodeWebkit)
		{
			if (this.runtime.isNodeFullscreen)
			{
				window["nwgui"]["Window"]["get"]()["leaveFullscreen"]();
				this.runtime.isNodeFullscreen = false;
			}
		}
		else
		{
			if (!cr.is_undefined(document["exitFullscreen"]))
				document["exitFullscreen"]();
			else if (!cr.is_undefined(document["webkitCancelFullScreen"]))
				document["webkitCancelFullScreen"]();
			else if (!cr.is_undefined(document["mozCancelFullScreen"]))
				document["mozCancelFullScreen"]();
			else if (!cr.is_undefined(document["msExitFullscreen"]))
				document["msExitFullscreen"]();
		}
	};
	Acts.prototype.Vibrate = function (pattern_)
	{
		try {
			var arr = pattern_.split(",");
			var i, len;
			for (i = 0, len = arr.length; i < len; i++)
			{
				arr[i] = parseInt(arr[i], 10);
			}
			if (navigator["vibrate"])
				navigator["vibrate"](arr);
			else if (navigator["mozVibrate"])
				navigator["mozVibrate"](arr);
			else if (navigator["webkitVibrate"])
				navigator["webkitVibrate"](arr);
			else if (navigator["msVibrate"])
				navigator["msVibrate"](arr);
		}
		catch (e) {}
	};
	Acts.prototype.InvokeDownload = function (url_, filename_)
	{
		var a = document.createElement("a");
		if (typeof a["download"] === "undefined")
		{
			window.open(url_);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename_;
			a.href = url_;
			a["download"] = filename_;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	Acts.prototype.InvokeDownloadString = function (str_, mimetype_, filename_)
	{
		var datauri = "data:" + mimetype_ + "," + encodeURIComponent(str_);
		var a = document.createElement("a");
		if (typeof a["download"] === "undefined")
		{
			window.open(datauri);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename_;
			a.href = datauri;
			a["download"] = filename_;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	Acts.prototype.ConsoleLog = function (type_, msg_)
	{
		if (typeof console === "undefined")
			return;
		if (type_ === 0 && console.log)
			console.log(msg_.toString());
		if (type_ === 1 && console.warn)
			console.warn(msg_.toString());
		if (type_ === 2 && console.error)
			console.error(msg_.toString());
	};
	Acts.prototype.ConsoleGroup = function (name_)
	{
		if (console && console.group)
			console.group(name_);
	};
	Acts.prototype.ConsoleGroupEnd = function ()
	{
		if (console && console.groupEnd)
			console.groupEnd();
	};
	Acts.prototype.ExecJs = function (js_)
	{
		if (eval)
			eval(js_);
	};
	var orientations = [
		"portrait",
		"landscape",
		"portrait-primary",
		"portrait-secondary",
		"landscape-primary",
		"landscape-secondary"
	];
	Acts.prototype.LockOrientation = function (o)
	{
		o = Math.floor(o);
		if (o < 0 || o >= orientations.length)
			return;
		this.runtime.autoLockOrientation = false;
		var orientation = orientations[o];
		if (screen["lockOrientation"])
			screen["lockOrientation"](orientation);
		else if (screen["webkitLockOrientation"])
			screen["webkitLockOrientation"](orientation);
		else if (screen["mozLockOrientation"])
			screen["mozLockOrientation"](orientation);
		else if (screen["msLockOrientation"])
			screen["msLockOrientation"](orientation);
	};
	Acts.prototype.UnlockOrientation = function ()
	{
		this.runtime.autoLockOrientation = false;
		if (screen["unlockOrientation"])
			screen["unlockOrientation"]();
		else if (screen["webkitUnlockOrientation"])
			screen["webkitUnlockOrientation"]();
		else if (screen["mozUnlockOrientation"])
			screen["mozUnlockOrientation"]();
		else if (screen["msUnlockOrientation"])
			screen["msUnlockOrientation"]();
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.URL = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.toString());
	};
	Exps.prototype.Protocol = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.protocol);
	};
	Exps.prototype.Domain = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.hostname);
	};
	Exps.prototype.PathName = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.pathname);
	};
	Exps.prototype.Hash = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.hash);
	};
	Exps.prototype.Referrer = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : document.referrer);
	};
	Exps.prototype.Title = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : document.title);
	};
	Exps.prototype.Name = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.appName);
	};
	Exps.prototype.Version = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.appVersion);
	};
	Exps.prototype.Language = function (ret)
	{
		if (navigator && navigator.language)
			ret.set_string(navigator.language);
		else
			ret.set_string("");
	};
	Exps.prototype.Platform = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.platform);
	};
	Exps.prototype.Product = function (ret)
	{
		if (navigator && navigator.product)
			ret.set_string(navigator.product);
		else
			ret.set_string("");
	};
	Exps.prototype.Vendor = function (ret)
	{
		if (navigator && navigator.vendor)
			ret.set_string(navigator.vendor);
		else
			ret.set_string("");
	};
	Exps.prototype.UserAgent = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.userAgent);
	};
	Exps.prototype.QueryString = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.search);
	};
	Exps.prototype.QueryParam = function (ret, paramname)
	{
		if (this.runtime.isDomFree)
		{
			ret.set_string("");
			return;
		}
		var match = RegExp('[?&]' + paramname + '=([^&]*)').exec(window.location.search);
		if (match)
			ret.set_string(decodeURIComponent(match[1].replace(/\+/g, ' ')));
		else
			ret.set_string("");
	};
	Exps.prototype.Bandwidth = function (ret)
	{
		var connection = navigator["connection"] || navigator["mozConnection"] || navigator["webkitConnection"];
		if (!connection)
			ret.set_float(Number.POSITIVE_INFINITY);
		else
			ret.set_float(connection["bandwidth"]);
	};
	Exps.prototype.BatteryLevel = function (ret)
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			ret.set_float(1);
		else
			ret.set_float(battery["level"]);
	};
	Exps.prototype.BatteryTimeLeft = function (ret)
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			ret.set_float(Number.POSITIVE_INFINITY);
		else
			ret.set_float(battery["dischargingTime"]);
	};
	Exps.prototype.ExecJS = function (ret, js_)
	{
		if (!eval)
		{
			ret.set_any(0);
			return;
		}
		var result = eval(js_);
		if (typeof result === "number")
			ret.set_any(result);
		else if (typeof result === "string")
			ret.set_any(result);
		else if (typeof result === "boolean")
			ret.set_any(result ? 1 : 0);
		else
			ret.set_any(0);
	};
	Exps.prototype.ScreenWidth = function (ret)
	{
		ret.set_int(screen.width);
	};
	Exps.prototype.ScreenHeight = function (ret)
	{
		ret.set_int(screen.height);
	};
	Exps.prototype.DevicePixelRatio = function (ret)
	{
		ret.set_float(this.runtime.devicePixelRatio);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.CJSAds = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var input_text = "";
	var products_list = [];
	var requested_score = 0;
	var bannerPosition = 0;
	var preloadingBanner = false;
	var bannerReady = false;
	var preloadingFullscreen = false;
	var fullscreenReady = false;
	var pluginProto = cr.plugins_.CJSAds.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.isShowingBanner = false;
		this.isShowingFullscreen = false;
		this.triggerProduct = "";
		this.socialService = null;
		this.socialServiceAvailable = false;
		this.storeServiceAvailable = (this.runtime.isCocoonJs && typeof CocoonJS["Store"]["nativeExtensionObjectAvailable"] !== "undefined");
		this.storeManaged = (this.properties[0] !== 1);
		this.storeSandboxed = (this.properties[1] !== 0);
		this.onConsumePurchaseFailedTransactionId = "";
		this.onConsumePurchaseCompleted = "";
		var self = this;
		if (this.runtime.isCocoonJs)
		{
			CocoonJS["App"]["onTextDialogFinished"].addEventListener(function(text) {
				input_text = text;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK, self);
			});
			CocoonJS["App"]["onTextDialogCancelled"].addEventListener(function() {
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled, self);
			});
			CocoonJS["Ad"]["onBannerShown"].addEventListener(function ()
			{
				self.isShowingBanner = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown, self);
			});
			CocoonJS["Ad"]["onBannerReady"].addEventListener(function ()
			{
				bannerReady = true;
				if (!preloadingBanner)
				{
					CocoonJS["Ad"]["setBannerLayout"](bannerPosition);
					CocoonJS["Ad"]["showBanner"]();
				}
			});
			CocoonJS["Ad"]["onFullScreenShown"].addEventListener(function ()
			{
				self.isShowingFullscreen = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown, self);
			});
			CocoonJS["Ad"]["onFullScreenHidden"].addEventListener(function ()
			{
				self.isShowingFullscreen = false;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden, self);
			});
			CocoonJS["Ad"]["onFullScreenReady"].addEventListener(function ()
			{
				fullscreenReady = true;
				if (!preloadFullScreen)
					CocoonJS["Ad"]["showFullScreen"]();
			});
			if (this.storeServiceAvailable)
			{
				CocoonJS["Store"]["onProductPurchaseCompleted"].addEventListener(function (purchase)
				{
					self.triggerProduct = purchase["productId"];
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete, self);
					CocoonJS["Store"]["addPurchase"](purchase);
					CocoonJS["Store"]["consumePurchase"](purchase["transactionId"], purchase["productId"]);
					CocoonJS["Store"]["finishPurchase"](purchase["transactionId"]);
				});
				CocoonJS["Store"]["onConsumePurchaseFailed"].addEventListener(function(transactionId, errorMessage)
				{
					this.onConsumePurchaseFailedTransactionId = transactionId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed, self);
				});
				CocoonJS["Store"]["onConsumePurchaseCompleted"].addEventListener(function(transactionId)
				{
					this.onConsumePurchaseCompleted = transactionId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted, self);
				});
				CocoonJS["Store"]["onProductPurchaseFailed"].addEventListener(function (productId, errorMsg)
				{
					self.triggerProduct = productId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail, self);
				});
				CocoonJS["Store"]["onProductPurchaseStarted"].addEventListener(function (productinfo)
				{
					self.triggerProduct = productinfo["productId"];
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart, self);
				});
				CocoonJS["Store"]["onProductsFetchStarted"].addEventListener(function ()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted, self);
				});
				CocoonJS["Store"]["onProductsFetchFailed"].addEventListener(function ()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed, self);
				});
				CocoonJS["Store"]["onProductsFetchCompleted"].addEventListener(function (products)
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted, self);
				});
				CocoonJS["Store"]["requestInitialization"]({
					"managed": this.storeManaged,
					"sandbox": this.storeSandboxed
				});
				CocoonJS["Store"]["start"]();
			}
			this.socialService = CocoonJS["SocialGaming"]["GameCenter"];
			this.socialServiceAvailable = !!this.socialService["nativeExtensionObjectAvailable"];
			this.socialService["onRequestLoginSucceed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginSuccess, self);
			});
			this.socialService["onRequestLoginFailed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginFail, self);
			});
			this.socialService["onLogout"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLogout, self);
			});
			this.socialService["onRequestUserScoreSucceed"].addEventListener(function (userInfo) {
				requested_score = userInfo["score"] || 0;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreReceived, self);
			});
			this.socialService["onRequestUserScoreFailed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreUnavailable, self);
			});
			this.socialService["onSubmitUserScoreSucceed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitSuccess, self);
			});
			this.socialService["onSubmitUserScoreFailed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitFail, self);
			});
			this.socialService["onLeaderboardViewSucceed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardOpen, self);
			});
			this.socialService["onLeaderboardViewClosed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardClose, self);
			});
		}
	};
	function Cnds() {};
	Cnds.prototype.IsShowingBanner = function ()
	{
		return this.isShowingBanner;
	};
	Cnds.prototype.IsCocoonJS = function ()
	{
		return this.runtime.isCocoonJs;
	};
	Cnds.prototype.OnBannerShown = function ()
	{
		return true;
	};
	Cnds.prototype.OnFullscreenShown = function ()
	{
		return true;
	};
	Cnds.prototype.OnFullscreenHidden = function ()
	{
		return true;
	};
	Cnds.prototype.IsShowingFullscreen = function ()
	{
		return this.isShowingFullscreen;
	};
	Cnds.prototype.IsStoreAvailable = function ()
	{
		if (this.runtime.isCocoonJs)
			return this.storeServiceAvailable && CocoonJS["Store"]["canPurchase"]();
		else
			return false;
	};
	Cnds.prototype.OnPurchaseStart = function (productid)
	{
		return this.triggerProduct === productid;
	};
	Cnds.prototype.OnPurchaseComplete = function (productid)
	{
		return this.triggerProduct === productid;
	};
	Cnds.prototype.OnPurchaseFail = function (productid)
	{
		return this.triggerProduct === productid;
	};
	Cnds.prototype.onProductsFetchStarted = function(){
		return true;
	}
	Cnds.prototype.onConsumePurchaseFailed = function(){
		return true;
	}
	Cnds.prototype.onProductsFetchCompleted = function(){
		return true;
	}
	Cnds.prototype.onProductsFetchFailed = function(){
		return true;
	}
	Cnds.prototype.IsProductPurchased = function (productid)
	{
		if (this.runtime.isCocoonJs)
			return CocoonJS["Store"]["isProductPurchased"](productid);
		else
			return false;
	};
	Cnds.prototype.OnKeyboardCancelled = function ()
	{
		return true;
	};
	Cnds.prototype.OnKeyboardOK = function ()
	{
		return true;
	};
	Cnds.prototype.IsGCAvailable = function ()
	{
		return this.socialServiceAvailable;
	};
	Cnds.prototype.IsGCLoggedIn = function ()
	{
		if (!this.socialServiceAvailable)
			return false;
		return this.socialService["isLoggedIn"]();
	};
	Cnds.prototype.OnGCLoginSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLoginFail = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLogout = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreReceived = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreUnavailable = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreSubmitSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreSubmitFail = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLeaderboardOpen = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLeaderboardClose = function ()
	{
		return true;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.ShowBanner = function (layout_)
	{
		if (!this.runtime.isCocoonJs)
			return;
		bannerPosition = (layout_ === 0 ? CocoonJS["Ad"]["BannerLayout"]["TOP_CENTER"] : CocoonJS["Ad"]["BannerLayout"]["BOTTOM_CENTER"]);
		preloadingBanner = false;
		if (bannerReady)
		{
			CocoonJS["Ad"]["setBannerLayout"](bannerPosition);
			CocoonJS["Ad"]["showBanner"]();
		}
		else
		{
			CocoonJS["Ad"]["preloadBanner"]();
		}
	};
	Acts.prototype.ShowFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingFullscreen = false;
		if (fullscreenReady)
			CocoonJS["Ad"]["showFullScreen"]();
		else
			CocoonJS["Ad"]["preloadFullScreen"]();
	};
	Acts.prototype.HideBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["hideBanner"]();
		this.isShowingBanner = false;
	};
	Acts.prototype.PreloadBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingBanner = true;
		CocoonJS["Ad"]["preloadBanner"]();
	};
	Acts.prototype.PreloadFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingFullscreen = true;
		CocoonJS["Ad"]["preloadFullScreen"]();
	};
	Acts.prototype.RefreshBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["refreshBanner"]();
	};
	Acts.prototype.RefreshFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["refreshFullScreen"]();
	};
	Acts.prototype.Purchase = function (productid)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["purchaseProduct"](productid);
	};
	Acts.prototype.fetchProductsFromStore = function (products)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["fetchProductsFromStore"](products.split(","));
	};
	Acts.prototype.restorePurchases = function ()
	{
		if (this.runtime.isCocoonJs)
			return CocoonJS["Store"]["restorePurchases"]();
	};
	Acts.prototype.PurchasePreview = function (productid)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["purchaseProductModalWithPreview"](productid);
	};
	Acts.prototype.RestorePurchases = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["restorePurchases"]();
	};
	Acts.prototype.PromptKeyboard = function (title_, message_, initial_, type_, canceltext_, oktext_)
	{
		if (!this.runtime.isCocoonJs)
			return;
		var typestr = ["text", "num", "phone", "email", "url"][type_];
		CocoonJS["App"]["showTextDialog"](title_, message_, initial_, typestr, canceltext_, oktext_);
	};
	Acts.prototype.UpdateProductsList = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		if (!CocoonJS["Store"]["canPurchase"]())
			return;
		products_list = CocoonJS["Store"]["getProducts"]();
	};
	Acts.prototype.GCLogin = function ()
	{
		if (!this.socialServiceAvailable || this.socialService["isLoggedIn"]())
			return;
		this.socialService["requestLogin"]();
	};
	Acts.prototype.GCLogout = function ()
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["requestLogout"]();
	};
	Acts.prototype.GCSubmitScore = function (score_, leaderboard_)
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["submitUserScore"](score_, leaderboard_);
	};
	Acts.prototype.GCRequestScore = function (leaderboard_)
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["requestUserScore"](leaderboard_);
	};
	Acts.prototype.GCOpenLeaderboard = function (leaderboard_)
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["showLeaderboardView"](leaderboard_);
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.InputText = function (ret)
	{
		ret.set_string(input_text);
	};
	Exps.prototype.ProductCount = function (ret)
	{
		ret.set_int(products_list.length);
	};
	Exps.prototype.ProductDescription = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["description"]);
	};
	Exps.prototype.ProductLocalizedPrice = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["localizedPrice"]);
	};
	Exps.prototype.ProductPrice = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["price"]);
	};
	Exps.prototype.ProductAlias = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["productAlias"]);
	};
	Exps.prototype.ProductID = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["productId"]);
	};
	Exps.prototype.ProductTitle = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["title"]);
	};
	Exps.prototype.GameCenterScore = function (ret)
	{
		ret.set_float(requested_score);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.CJSBackButton = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.CJSBackButton.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		var self = this;
		if (this.runtime.isCocoonJs)
		{
			CocoonJS["App"]["setAppShouldFinishCallback"](function ()
				{
				self.runtime.trigger(cr.plugins_.CJSBackButton.prototype.cnds.OnBack, self);
					return false;
				});
		}
	};
	function Cnds() {};
	Cnds.prototype.OnBack = function ()
	{
		return true;
	};
	pluginProto.cnds = new Cnds();
}());
;
;
cr.plugins_.Function = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Function.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var funcStack = [];
	var funcStackPtr = -1;
	var isInPreview = false;	// set in onCreate
	function FuncStackEntry()
	{
		this.name = "";
		this.retVal = 0;
		this.params = [];
	};
	function pushFuncStack()
	{
		funcStackPtr++;
		if (funcStackPtr === funcStack.length)
			funcStack.push(new FuncStackEntry());
		return funcStack[funcStackPtr];
	};
	function getCurrentFuncStack()
	{
		if (funcStackPtr < 0)
			return null;
		return funcStack[funcStackPtr];
	};
	function getOneAboveFuncStack()
	{
		if (!funcStack.length)
			return null;
		var i = funcStackPtr + 1;
		if (i >= funcStack.length)
			i = funcStack.length - 1;
		return funcStack[i];
	};
	function popFuncStack()
	{
;
		funcStackPtr--;
	};
	instanceProto.onCreate = function()
	{
		isInPreview = (typeof cr_is_preview !== "undefined");
	};
	function Cnds() {};
	Cnds.prototype.OnFunction = function (name_)
	{
		var fs = getCurrentFuncStack();
		if (!fs)
			return false;
		return cr.equals_nocase(name_, fs.name);
	};
	Cnds.prototype.CompareParam = function (index_, cmp_, value_)
	{
		var fs = getCurrentFuncStack();
		if (!fs)
			return false;
		index_ = cr.floor(index_);
		if (index_ < 0 || index_ >= fs.params.length)
			return false;
		return cr.do_cmp(fs.params[index_], cmp_, value_);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.CallFunction = function (name_, params_)
	{
		var fs = pushFuncStack();
		fs.name = name_.toLowerCase();
		fs.retVal = 0;
		cr.shallowAssignArray(fs.params, params_);
		var ran = this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction, this, fs.name);
		if (isInPreview && !ran)
		{
;
		}
		popFuncStack();
	};
	Acts.prototype.SetReturnValue = function (value_)
	{
		var fs = getCurrentFuncStack();
		if (fs)
			fs.retVal = value_;
		else
;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.ReturnValue = function (ret)
	{
		var fs = getOneAboveFuncStack();
		if (fs)
			ret.set_any(fs.retVal);
		else
			ret.set_int(0);
	};
	Exps.prototype.ParamCount = function (ret)
	{
		var fs = getCurrentFuncStack();
		if (fs)
			ret.set_int(fs.params.length);
		else
		{
;
			ret.set_int(0);
		}
	};
	Exps.prototype.Param = function (ret, index_)
	{
		index_ = cr.floor(index_);
		var fs = getCurrentFuncStack();
		if (fs)
		{
			if (index_ >= 0 && index_ < fs.params.length)
			{
				ret.set_any(fs.params[index_]);
			}
			else
			{
;
				ret.set_int(0);
			}
		}
		else
		{
;
			ret.set_int(0);
		}
	};
	Exps.prototype.Call = function (ret, name_)
	{
		var fs = pushFuncStack();
		fs.name = name_.toLowerCase();
		fs.retVal = 0;
		fs.params.length = 0;
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
			fs.params.push(arguments[i]);
		var ran = this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction, this, fs.name);
		if (isInPreview && !ran)
		{
;
		}
		popFuncStack();
		ret.set_any(fs.retVal);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Particles = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Particles.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.texture_img.cr_filesize = this.texture_filesize;
		this.webGL_texture = null;
		this.runtime.waitForImageLoad(this.texture_img);
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
		}
	};
	typeProto.loadTextures = function ()
	{
		if (this.is_family || this.webGL_texture || !this.runtime.glwrap)
			return;
		this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.webGL_texture)
			return;
		this.runtime.glwrap.deleteTexture(this.webGL_texture);
		this.webGL_texture = null;
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
		ctx.drawImage(this.texture_img, 0, 0);
	};
	function Particle(owner)
	{
		this.owner = owner;
		this.active = false;
		this.x = 0;
		this.y = 0;
		this.speed = 0;
		this.angle = 0;
		this.opacity = 1;
		this.grow = 0;
		this.size = 0;
		this.gs = 0;			// gravity speed
		this.age = 0;
		cr.seal(this);
	};
	Particle.prototype.init = function ()
	{
		var owner = this.owner;
		this.x = owner.x - (owner.xrandom / 2) + (Math.random() * owner.xrandom);
		this.y = owner.y - (owner.yrandom / 2) + (Math.random() * owner.yrandom);
		this.speed = owner.initspeed - (owner.speedrandom / 2) + (Math.random() * owner.speedrandom);
		this.angle = owner.angle - (owner.spraycone / 2) + (Math.random() * owner.spraycone);
		this.opacity = owner.initopacity;
		this.size = owner.initsize - (owner.sizerandom / 2) + (Math.random() * owner.sizerandom);
		this.grow = owner.growrate - (owner.growrandom / 2) + (Math.random() * owner.growrandom);
		this.gs = 0;
		this.age = 0;
	};
	Particle.prototype.tick = function (dt)
	{
		var owner = this.owner;
		this.x += Math.cos(this.angle) * this.speed * dt;
		this.y += Math.sin(this.angle) * this.speed * dt;
		this.y += this.gs * dt;
		this.speed += owner.acc * dt;
		this.size += this.grow * dt;
		this.gs += owner.g * dt;
		this.age += dt;
		if (this.size < 1)
		{
			this.active = false;
			return;
		}
		if (owner.lifeanglerandom !== 0)
			this.angle += (Math.random() * owner.lifeanglerandom * dt) - (owner.lifeanglerandom * dt / 2);
		if (owner.lifespeedrandom !== 0)
			this.speed += (Math.random() * owner.lifespeedrandom * dt) - (owner.lifespeedrandom * dt / 2);
		if (owner.lifeopacityrandom !== 0)
		{
			this.opacity += (Math.random() * owner.lifeopacityrandom * dt) - (owner.lifeopacityrandom * dt / 2);
			if (this.opacity < 0)
				this.opacity = 0;
			else if (this.opacity > 1)
				this.opacity = 1;
		}
		if (owner.destroymode <= 1 && this.age >= owner.timeout)
		{
			this.active = false;
		}
		if (owner.destroymode === 2 && this.speed <= 0)
		{
			this.active = false;
		}
	};
	Particle.prototype.draw = function (ctx)
	{
		var curopacity = this.owner.opacity * this.opacity;
		if (curopacity === 0)
			return;
		if (this.owner.destroymode === 0)
			curopacity *= 1 - (this.age / this.owner.timeout);
		ctx.globalAlpha = curopacity;
		var drawx = this.x - this.size / 2;
		var drawy = this.y - this.size / 2;
		if (this.owner.runtime.pixel_rounding)
		{
			drawx = (drawx + 0.5) | 0;
			drawy = (drawy + 0.5) | 0;
		}
		ctx.drawImage(this.owner.type.texture_img, drawx, drawy, this.size, this.size);
	};
	Particle.prototype.drawGL = function (glw)
	{
		var curopacity = this.owner.opacity * this.opacity;
		if (this.owner.destroymode === 0)
			curopacity *= 1 - (this.age / this.owner.timeout);
		var drawsize = this.size;
		var scaleddrawsize = drawsize * this.owner.particlescale;
		var drawx = this.x - drawsize / 2;
		var drawy = this.y - drawsize / 2;
		if (this.owner.runtime.pixel_rounding)
		{
			drawx = (drawx + 0.5) | 0;
			drawy = (drawy + 0.5) | 0;
		}
		if (scaleddrawsize < 1 || curopacity === 0)
			return;
		if (scaleddrawsize < glw.minPointSize || scaleddrawsize > glw.maxPointSize)
		{
			glw.setOpacity(curopacity);
			glw.quad(drawx, drawy, drawx + drawsize, drawy, drawx + drawsize, drawy + drawsize, drawx, drawy + drawsize);
		}
		else
			glw.point(this.x, this.y, scaleddrawsize, curopacity);
	};
	Particle.prototype.left = function ()
	{
		return this.x - this.size / 2;
	};
	Particle.prototype.right = function ()
	{
		return this.x + this.size / 2;
	};
	Particle.prototype.top = function ()
	{
		return this.y - this.size / 2;
	};
	Particle.prototype.bottom = function ()
	{
		return this.y + this.size / 2;
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var deadparticles = [];
	instanceProto.onCreate = function()
	{
		var props = this.properties;
		this.rate = props[0];
		this.spraycone = cr.to_radians(props[1]);
		this.spraytype = props[2];			// 0 = continuous, 1 = one-shot
		this.spraying = true;				// for continuous mode only
		this.initspeed = props[3];
		this.initsize = props[4];
		this.initopacity = props[5] / 100.0;
		this.growrate = props[6];
		this.xrandom = props[7];
		this.yrandom = props[8];
		this.speedrandom = props[9];
		this.sizerandom = props[10];
		this.growrandom = props[11];
		this.acc = props[12];
		this.g = props[13];
		this.lifeanglerandom = props[14];
		this.lifespeedrandom = props[15];
		this.lifeopacityrandom = props[16];
		this.destroymode = props[17];		// 0 = fade, 1 = timeout, 2 = stopped
		this.timeout = props[18];
		this.particleCreateCounter = 0;
		this.particlescale = 1;
		this.particleBoxLeft = this.x;
		this.particleBoxTop = this.y;
		this.particleBoxRight = this.x;
		this.particleBoxBottom = this.y;
		this.add_bbox_changed_callback(function (self) {
			self.bbox.set(self.particleBoxLeft, self.particleBoxTop, self.particleBoxRight, self.particleBoxBottom);
			self.bquad.set_from_rect(self.bbox);
			self.bbox_changed = false;
			self.update_collision_cell();
		});
		if (!this.recycled)
			this.particles = [];
		this.runtime.tickMe(this);
		this.type.loadTextures();
		if (this.spraytype === 1)
		{
			for (var i = 0; i < this.rate; i++)
				this.allocateParticle().opacity = 0;
		}
		this.first_tick = true;		// for re-init'ing one-shot particles on first tick so they assume any new angle/position
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"r": this.rate,
			"sc": this.spraycone,
			"st": this.spraytype,
			"s": this.spraying,
			"isp": this.initspeed,
			"isz": this.initsize,
			"io": this.initopacity,
			"gr": this.growrate,
			"xr": this.xrandom,
			"yr": this.yrandom,
			"spr": this.speedrandom,
			"szr": this.sizerandom,
			"grnd": this.growrandom,
			"acc": this.acc,
			"g": this.g,
			"lar": this.lifeanglerandom,
			"lsr": this.lifespeedrandom,
			"lor": this.lifeopacityrandom,
			"dm": this.destroymode,
			"to": this.timeout,
			"pcc": this.particleCreateCounter,
			"ft": this.first_tick,
			"p": []
		};
		var i, len, p;
		var arr = o["p"];
		for (i = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			arr.push([p.x, p.y, p.speed, p.angle, p.opacity, p.grow, p.size, p.gs, p.age]);
		}
		return o;
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.rate = o["r"];
		this.spraycone = o["sc"];
		this.spraytype = o["st"];
		this.spraying = o["s"];
		this.initspeed = o["isp"];
		this.initsize = o["isz"];
		this.initopacity = o["io"];
		this.growrate = o["gr"];
		this.xrandom = o["xr"];
		this.yrandom = o["yr"];
		this.speedrandom = o["spr"];
		this.sizerandom = o["szr"];
		this.growrandom = o["grnd"];
		this.acc = o["acc"];
		this.g = o["g"];
		this.lifeanglerandom = o["lar"];
		this.lifespeedrandom = o["lsr"];
		this.lifeopacityrandom = o["lor"];
		this.destroymode = o["dm"];
		this.timeout = o["to"];
		this.particleCreateCounter = o["pcc"];
		this.first_tick = o["ft"];
		deadparticles.push.apply(deadparticles, this.particles);
		this.particles.length = 0;
		var i, len, p, d;
		var arr = o["p"];
		for (i = 0, len = arr.length; i < len; i++)
		{
			p = this.allocateParticle();
			d = arr[i];
			p.x = d[0];
			p.y = d[1];
			p.speed = d[2];
			p.angle = d[3];
			p.opacity = d[4];
			p.grow = d[5];
			p.size = d[6];
			p.gs = d[7];
			p.age = d[8];
		}
	};
	instanceProto.onDestroy = function ()
	{
		deadparticles.push.apply(deadparticles, this.particles);
		this.particles.length = 0;
	};
	instanceProto.allocateParticle = function ()
	{
		var p;
		if (deadparticles.length)
		{
			p = deadparticles.pop();
			p.owner = this;
		}
		else
			p = new Particle(this);
		this.particles.push(p);
		p.active = true;
		return p;
	};
	instanceProto.tick = function()
	{
		var dt = this.runtime.getDt(this);
		var i, len, p, n, j;
		if (this.spraytype === 0 && this.spraying)
		{
			this.particleCreateCounter += dt * this.rate;
			n = cr.floor(this.particleCreateCounter);
			this.particleCreateCounter -= n;
			for (i = 0; i < n; i++)
			{
				p = this.allocateParticle();
				p.init();
			}
		}
		this.particleBoxLeft = this.x;
		this.particleBoxTop = this.y;
		this.particleBoxRight = this.x;
		this.particleBoxBottom = this.y;
		for (i = 0, j = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			this.particles[j] = p;
			this.runtime.redraw = true;
			if (this.spraytype === 1 && this.first_tick)
				p.init();
			p.tick(dt);
			if (!p.active)
			{
				deadparticles.push(p);
				continue;
			}
			if (p.left() < this.particleBoxLeft)
				this.particleBoxLeft = p.left();
			if (p.right() > this.particleBoxRight)
				this.particleBoxRight = p.right();
			if (p.top() < this.particleBoxTop)
				this.particleBoxTop = p.top();
			if (p.bottom() > this.particleBoxBottom)
				this.particleBoxBottom = p.bottom();
			j++;
		}
		this.particles.length = j;
		this.set_bbox_changed();
		this.first_tick = false;
		if (this.spraytype === 1 && this.particles.length === 0)
			this.runtime.DestroyInstance(this);
	};
	instanceProto.draw = function (ctx)
	{
		var i, len, p, layer = this.layer;
		for (i = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			if (p.right() >= layer.viewLeft && p.bottom() >= layer.viewTop && p.left() <= layer.viewRight && p.top() <= layer.viewBottom)
			{
				p.draw(ctx);
			}
		}
	};
	instanceProto.drawGL = function (glw)
	{
		this.particlescale = this.layer.getScale();
		glw.setTexture(this.type.webGL_texture);
		var i, len, p, layer = this.layer;
		for (i = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			if (p.right() >= layer.viewLeft && p.bottom() >= layer.viewTop && p.left() <= layer.viewRight && p.top() <= layer.viewBottom)
			{
				p.drawGL(glw);
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.IsSpraying = function ()
	{
		return this.spraying;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetSpraying = function (set_)
	{
		this.spraying = (set_ !== 0);
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.SetRate = function (x)
	{
		this.rate = x;
		var diff, i;
		if (this.spraytype === 1 && this.first_tick)
		{
			if (x < this.particles.length)
			{
				diff = this.particles.length - x;
				for (i = 0; i < diff; i++)
					deadparticles.push(this.particles.pop());
			}
			else if (x > this.particles.length)
			{
				diff = x - this.particles.length;
				for (i = 0; i < diff; i++)
					this.allocateParticle().opacity = 0;
			}
		}
	};
	Acts.prototype.SetSprayCone = function (x)
	{
		this.spraycone = cr.to_radians(x);
	};
	Acts.prototype.SetInitSpeed = function (x)
	{
		this.initspeed = x;
	};
	Acts.prototype.SetInitSize = function (x)
	{
		this.initsize = x;
	};
	Acts.prototype.SetInitOpacity = function (x)
	{
		this.initopacity = x / 100;
	};
	Acts.prototype.SetGrowRate = function (x)
	{
		this.growrate = x;
	};
	Acts.prototype.SetXRandomiser = function (x)
	{
		this.xrandom = x;
	};
	Acts.prototype.SetYRandomiser = function (x)
	{
		this.yrandom = x;
	};
	Acts.prototype.SetSpeedRandomiser = function (x)
	{
		this.speedrandom = x;
	};
	Acts.prototype.SetSizeRandomiser = function (x)
	{
		this.sizerandom = x;
	};
	Acts.prototype.SetGrowRateRandomiser = function (x)
	{
		this.growrandom = x;
	};
	Acts.prototype.SetParticleAcc = function (x)
	{
		this.acc = x;
	};
	Acts.prototype.SetGravity = function (x)
	{
		this.g = x;
	};
	Acts.prototype.SetAngleRandomiser = function (x)
	{
		this.lifeanglerandom = x;
	};
	Acts.prototype.SetSpeedRandomiser = function (x)
	{
		this.lifespeedrandom = x;
	};
	Acts.prototype.SetOpacityRandomiser = function (x)
	{
		this.lifeopacityrandom = x;
	};
	Acts.prototype.SetTimeout = function (x)
	{
		this.timeout = x;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.ParticleCount = function (ret)
	{
		ret.set_int(this.particles.length);
	};
	Exps.prototype.Rate = function (ret)
	{
		ret.set_float(this.rate);
	};
	Exps.prototype.SprayCone = function (ret)
	{
		ret.set_float(cr.to_degrees(this.spraycone));
	};
	Exps.prototype.InitSpeed = function (ret)
	{
		ret.set_float(this.initspeed);
	};
	Exps.prototype.InitSize = function (ret)
	{
		ret.set_float(this.initsize);
	};
	Exps.prototype.InitOpacity = function (ret)
	{
		ret.set_float(this.initopacity * 100);
	};
	Exps.prototype.InitGrowRate = function (ret)
	{
		ret.set_float(this.growrate);
	};
	Exps.prototype.XRandom = function (ret)
	{
		ret.set_float(this.xrandom);
	};
	Exps.prototype.YRandom = function (ret)
	{
		ret.set_float(this.yrandom);
	};
	Exps.prototype.InitSpeedRandom = function (ret)
	{
		ret.set_float(this.speedrandom);
	};
	Exps.prototype.InitSizeRandom = function (ret)
	{
		ret.set_float(this.sizerandom);
	};
	Exps.prototype.InitGrowRandom = function (ret)
	{
		ret.set_float(this.growrandom);
	};
	Exps.prototype.ParticleAcceleration = function (ret)
	{
		ret.set_float(this.acc);
	};
	Exps.prototype.Gravity = function (ret)
	{
		ret.set_float(this.g);
	};
	Exps.prototype.ParticleAngleRandom = function (ret)
	{
		ret.set_float(this.lifeanglerandom);
	};
	Exps.prototype.ParticleSpeedRandom = function (ret)
	{
		ret.set_float(this.lifespeedrandom);
	};
	Exps.prototype.ParticleOpacityRandom = function (ret)
	{
		ret.set_float(this.lifeopacityrandom);
	};
	Exps.prototype.Timeout = function (ret)
	{
		ret.set_float(this.timeout);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Sprite = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Sprite.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	function frame_getDataUri()
	{
		if (this.datauri.length === 0)
		{
			var tmpcanvas = document.createElement("canvas");
			tmpcanvas.width = this.width;
			tmpcanvas.height = this.height;
			var tmpctx = tmpcanvas.getContext("2d");
			if (this.spritesheeted)
			{
				tmpctx.drawImage(this.texture_img, this.offx, this.offy, this.width, this.height,
										 0, 0, this.width, this.height);
			}
			else
			{
				tmpctx.drawImage(this.texture_img, 0, 0, this.width, this.height);
			}
			this.datauri = tmpcanvas.toDataURL("image/png");
		}
		return this.datauri;
	};
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		var i, leni, j, lenj;
		var anim, frame, animobj, frameobj, wt, uv;
		this.all_frames = [];
		this.has_loaded_textures = false;
		for (i = 0, leni = this.animations.length; i < leni; i++)
		{
			anim = this.animations[i];
			animobj = {};
			animobj.name = anim[0];
			animobj.speed = anim[1];
			animobj.loop = anim[2];
			animobj.repeatcount = anim[3];
			animobj.repeatto = anim[4];
			animobj.pingpong = anim[5];
			animobj.sid = anim[6];
			animobj.frames = [];
			for (j = 0, lenj = anim[7].length; j < lenj; j++)
			{
				frame = anim[7][j];
				frameobj = {};
				frameobj.texture_file = frame[0];
				frameobj.texture_filesize = frame[1];
				frameobj.offx = frame[2];
				frameobj.offy = frame[3];
				frameobj.width = frame[4];
				frameobj.height = frame[5];
				frameobj.duration = frame[6];
				frameobj.hotspotX = frame[7];
				frameobj.hotspotY = frame[8];
				frameobj.image_points = frame[9];
				frameobj.poly_pts = frame[10];
				frameobj.pixelformat = frame[11];
				frameobj.spritesheeted = (frameobj.width !== 0);
				frameobj.datauri = "";		// generated on demand and cached
				frameobj.getDataUri = frame_getDataUri;
				uv = {};
				uv.left = 0;
				uv.top = 0;
				uv.right = 1;
				uv.bottom = 1;
				frameobj.sheetTex = uv;
				frameobj.webGL_texture = null;
				wt = this.runtime.findWaitingTexture(frame[0]);
				if (wt)
				{
					frameobj.texture_img = wt;
				}
				else
				{
					frameobj.texture_img = new Image();
					frameobj.texture_img["idtkLoadDisposed"] = true;
					frameobj.texture_img.src = frame[0];
					frameobj.texture_img.cr_src = frame[0];
					frameobj.texture_img.cr_filesize = frame[1];
					frameobj.texture_img.c2webGL_texture = null;
					this.runtime.waitForImageLoad(frameobj.texture_img);
				}
				cr.seal(frameobj);
				animobj.frames.push(frameobj);
				this.all_frames.push(frameobj);
			}
			cr.seal(animobj);
			this.animations[i] = animobj;		// swap array data for object
		}
	};
	typeProto.updateAllCurrentTexture = function ()
	{
		var i, len, inst;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			inst.curWebGLTexture = inst.curFrame.webGL_texture;
		}
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.texture_img.c2webGL_texture = null;
			frame.webGL_texture = null;
		}
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.webGL_texture = this.runtime.glwrap.loadTexture(frame.texture_img, false, this.runtime.linearSampling, frame.pixelformat);
		}
		this.updateAllCurrentTexture();
	};
	typeProto.loadTextures = function ()
	{
		if (this.is_family || this.has_loaded_textures || !this.runtime.glwrap)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.webGL_texture = this.runtime.glwrap.loadTexture(frame.texture_img, false, this.runtime.linearSampling, frame.pixelformat);
		}
		this.has_loaded_textures = true;
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.has_loaded_textures)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			this.runtime.glwrap.deleteTexture(frame.webGL_texture);
			frame.webGL_texture = null;
		}
		this.has_loaded_textures = false;
	};
	var already_drawn_images = [];
	typeProto.preloadCanvas2D = function (ctx)
	{
		var i, len, frameimg;
		already_drawn_images.length = 0;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frameimg = this.all_frames[i].texture_img;
			if (already_drawn_images.indexOf(frameimg) !== -1)
					continue;
			ctx.drawImage(frameimg, 0, 0);
			already_drawn_images.push(frameimg);
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		var poly_pts = this.type.animations[0].frames[0].poly_pts;
		if (this.recycled)
			this.collision_poly.set_pts(poly_pts);
		else
			this.collision_poly = new cr.CollisionPoly(poly_pts);
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.visible = (this.properties[0] === 0);	// 0=visible, 1=invisible
		this.isTicking = false;
		this.inAnimTrigger = false;
		this.collisionsEnabled = (this.properties[3] !== 0);
		if (!(this.type.animations.length === 1 && this.type.animations[0].frames.length === 1) && this.type.animations[0].speed !== 0)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		this.cur_animation = this.getAnimationByName(this.properties[1]) || this.type.animations[0];
		this.cur_frame = this.properties[2];
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		var curanimframe = this.cur_animation.frames[this.cur_frame];
		this.collision_poly.set_pts(curanimframe.poly_pts);
		this.hotspotX = curanimframe.hotspotX;
		this.hotspotY = curanimframe.hotspotY;
		this.cur_anim_speed = this.cur_animation.speed;
		if (this.recycled)
			this.animTimer.reset();
		else
			this.animTimer = new cr.KahanAdder();
		this.frameStart = this.getNowTime();
		this.animPlaying = true;
		this.animRepeats = 0;
		this.animForwards = true;
		this.animTriggerName = "";
		this.changeAnimName = "";
		this.changeAnimFrom = 0;
		this.changeAnimFrame = -1;
		this.type.loadTextures();
		var i, leni, j, lenj;
		var anim, frame, uv, maintex;
		for (i = 0, leni = this.type.animations.length; i < leni; i++)
		{
			anim = this.type.animations[i];
			for (j = 0, lenj = anim.frames.length; j < lenj; j++)
			{
				frame = anim.frames[j];
				if (frame.width === 0)
				{
					frame.width = frame.texture_img.width;
					frame.height = frame.texture_img.height;
				}
				if (frame.spritesheeted)
				{
					maintex = frame.texture_img;
					uv = frame.sheetTex;
					uv.left = frame.offx / maintex.width;
					uv.top = frame.offy / maintex.height;
					uv.right = (frame.offx + frame.width) / maintex.width;
					uv.bottom = (frame.offy + frame.height) / maintex.height;
					if (frame.offx === 0 && frame.offy === 0 && frame.width === maintex.width && frame.height === maintex.height)
					{
						frame.spritesheeted = false;
					}
				}
			}
		}
		this.curFrame = this.cur_animation.frames[this.cur_frame];
		this.curWebGLTexture = this.curFrame.webGL_texture;
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"a": this.cur_animation.sid,
			"f": this.cur_frame,
			"cas": this.cur_anim_speed,
			"fs": this.frameStart,
			"ar": this.animRepeats,
			"at": this.animTimer.sum
		};
		if (!this.animPlaying)
			o["ap"] = this.animPlaying;
		if (!this.animForwards)
			o["af"] = this.animForwards;
		return o;
	};
	instanceProto.loadFromJSON = function (o)
	{
		var anim = this.getAnimationBySid(o["a"]);
		if (anim)
			this.cur_animation = anim;
		this.cur_frame = o["f"];
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		this.cur_anim_speed = o["cas"];
		this.frameStart = o["fs"];
		this.animRepeats = o["ar"];
		this.animTimer.reset();
		this.animTimer.sum = o["at"];
		this.animPlaying = o.hasOwnProperty("ap") ? o["ap"] : true;
		this.animForwards = o.hasOwnProperty("af") ? o["af"] : true;
		this.curFrame = this.cur_animation.frames[this.cur_frame];
		this.curWebGLTexture = this.curFrame.webGL_texture;
		this.collision_poly.set_pts(this.curFrame.poly_pts);
		this.hotspotX = this.curFrame.hotspotX;
		this.hotspotY = this.curFrame.hotspotY;
	};
	instanceProto.animationFinish = function (reverse)
	{
		this.cur_frame = reverse ? 0 : this.cur_animation.frames.length - 1;
		this.animPlaying = false;
		this.animTriggerName = this.cur_animation.name;
		this.inAnimTrigger = true;
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished, this);
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished, this);
		this.inAnimTrigger = false;
		this.animRepeats = 0;
	};
	instanceProto.getNowTime = function()
	{
		return this.animTimer.sum;
	};
	instanceProto.tick = function()
	{
		this.animTimer.add(this.runtime.getDt(this));
		if (this.changeAnimName.length)
			this.doChangeAnim();
		if (this.changeAnimFrame >= 0)
			this.doChangeAnimFrame();
		var now = this.getNowTime();
		var cur_animation = this.cur_animation;
		var prev_frame = cur_animation.frames[this.cur_frame];
		var next_frame;
		var cur_frame_time = prev_frame.duration / this.cur_anim_speed;
		if (this.animPlaying && now >= this.frameStart + cur_frame_time)
		{
			if (this.animForwards)
			{
				this.cur_frame++;
			}
			else
			{
				this.cur_frame--;
			}
			this.frameStart += cur_frame_time;
			if (this.cur_frame >= cur_animation.frames.length)
			{
				if (cur_animation.pingpong)
				{
					this.animForwards = false;
					this.cur_frame = cur_animation.frames.length - 2;
				}
				else if (cur_animation.loop)
				{
					this.cur_frame = cur_animation.repeatto;
				}
				else
				{
					this.animRepeats++;
					if (this.animRepeats >= cur_animation.repeatcount)
					{
						this.animationFinish(false);
					}
					else
					{
						this.cur_frame = cur_animation.repeatto;
					}
				}
			}
			if (this.cur_frame < 0)
			{
				if (cur_animation.pingpong)
				{
					this.cur_frame = 1;
					this.animForwards = true;
					if (!cur_animation.loop)
					{
						this.animRepeats++;
						if (this.animRepeats >= cur_animation.repeatcount)
						{
							this.animationFinish(true);
						}
					}
				}
				else
				{
					if (cur_animation.loop)
					{
						this.cur_frame = cur_animation.repeatto;
					}
					else
					{
						this.animRepeats++;
						if (this.animRepeats >= cur_animation.repeatcount)
						{
							this.animationFinish(true);
						}
						else
						{
							this.cur_frame = cur_animation.repeatto;
						}
					}
				}
			}
			if (this.cur_frame < 0)
				this.cur_frame = 0;
			else if (this.cur_frame >= cur_animation.frames.length)
				this.cur_frame = cur_animation.frames.length - 1;
			if (now > this.frameStart + (cur_animation.frames[this.cur_frame].duration / this.cur_anim_speed))
			{
				this.frameStart = now;
			}
			next_frame = cur_animation.frames[this.cur_frame];
			this.OnFrameChanged(prev_frame, next_frame);
			this.runtime.redraw = true;
		}
	};
	instanceProto.getAnimationByName = function (name_)
	{
		var i, len, a;
		for (i = 0, len = this.type.animations.length; i < len; i++)
		{
			a = this.type.animations[i];
			if (cr.equals_nocase(a.name, name_))
				return a;
		}
		return null;
	};
	instanceProto.getAnimationBySid = function (sid_)
	{
		var i, len, a;
		for (i = 0, len = this.type.animations.length; i < len; i++)
		{
			a = this.type.animations[i];
			if (a.sid === sid_)
				return a;
		}
		return null;
	};
	instanceProto.doChangeAnim = function ()
	{
		var prev_frame = this.cur_animation.frames[this.cur_frame];
		var anim = this.getAnimationByName(this.changeAnimName);
		this.changeAnimName = "";
		if (!anim)
			return;
		if (cr.equals_nocase(anim.name, this.cur_animation.name) && this.animPlaying)
			return;
		this.cur_animation = anim;
		this.cur_anim_speed = anim.speed;
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		if (this.changeAnimFrom === 1)
			this.cur_frame = 0;
		this.animPlaying = true;
		this.frameStart = this.getNowTime();
		this.animForwards = true;
		this.OnFrameChanged(prev_frame, this.cur_animation.frames[this.cur_frame]);
		this.runtime.redraw = true;
	};
	instanceProto.doChangeAnimFrame = function ()
	{
		var prev_frame = this.cur_animation.frames[this.cur_frame];
		var prev_frame_number = this.cur_frame;
		this.cur_frame = cr.floor(this.changeAnimFrame);
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		if (prev_frame_number !== this.cur_frame)
		{
			this.OnFrameChanged(prev_frame, this.cur_animation.frames[this.cur_frame]);
			this.frameStart = this.getNowTime();
			this.runtime.redraw = true;
		}
		this.changeAnimFrame = -1;
	};
	instanceProto.OnFrameChanged = function (prev_frame, next_frame)
	{
		var oldw = prev_frame.width;
		var oldh = prev_frame.height;
		var neww = next_frame.width;
		var newh = next_frame.height;
		if (oldw != neww)
			this.width *= (neww / oldw);
		if (oldh != newh)
			this.height *= (newh / oldh);
		this.hotspotX = next_frame.hotspotX;
		this.hotspotY = next_frame.hotspotY;
		this.collision_poly.set_pts(next_frame.poly_pts);
		this.set_bbox_changed();
		this.curFrame = next_frame;
		this.curWebGLTexture = next_frame.webGL_texture;
		var i, len, b;
		for (i = 0, len = this.behavior_insts.length; i < len; i++)
		{
			b = this.behavior_insts[i];
			if (b.onSpriteFrameChanged)
				b.onSpriteFrameChanged(prev_frame, next_frame);
		}
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged, this);
	};
	instanceProto.draw = function(ctx)
	{
		ctx.globalAlpha = this.opacity;
		var cur_frame = this.curFrame;
		var spritesheeted = cur_frame.spritesheeted;
		var cur_image = cur_frame.texture_img;
		var myx = this.x;
		var myy = this.y;
		var w = this.width;
		var h = this.height;
		if (this.angle === 0 && w >= 0 && h >= 0)
		{
			myx -= this.hotspotX * w;
			myy -= this.hotspotY * h;
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			if (spritesheeted)
			{
				ctx.drawImage(cur_image, cur_frame.offx, cur_frame.offy, cur_frame.width, cur_frame.height,
										 myx, myy, w, h);
			}
			else
			{
				ctx.drawImage(cur_image, myx, myy, w, h);
			}
		}
		else
		{
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			ctx.save();
			var widthfactor = w > 0 ? 1 : -1;
			var heightfactor = h > 0 ? 1 : -1;
			ctx.translate(myx, myy);
			if (widthfactor !== 1 || heightfactor !== 1)
				ctx.scale(widthfactor, heightfactor);
			ctx.rotate(this.angle * widthfactor * heightfactor);
			var drawx = 0 - (this.hotspotX * cr.abs(w))
			var drawy = 0 - (this.hotspotY * cr.abs(h));
			if (spritesheeted)
			{
				ctx.drawImage(cur_image, cur_frame.offx, cur_frame.offy, cur_frame.width, cur_frame.height,
										 drawx, drawy, cr.abs(w), cr.abs(h));
			}
			else
			{
				ctx.drawImage(cur_image, drawx, drawy, cr.abs(w), cr.abs(h));
			}
			ctx.restore();
		}
		/*
		ctx.strokeStyle = "#f00";
		ctx.lineWidth = 3;
		ctx.beginPath();
		this.collision_poly.cache_poly(this.width, this.height, this.angle);
		var i, len, ax, ay, bx, by;
		for (i = 0, len = this.collision_poly.pts_count; i < len; i++)
		{
			ax = this.collision_poly.pts_cache[i*2] + this.x;
			ay = this.collision_poly.pts_cache[i*2+1] + this.y;
			bx = this.collision_poly.pts_cache[((i+1)%len)*2] + this.x;
			by = this.collision_poly.pts_cache[((i+1)%len)*2+1] + this.y;
			ctx.moveTo(ax, ay);
			ctx.lineTo(bx, by);
		}
		ctx.stroke();
		ctx.closePath();
		*/
		/*
		if (this.behavior_insts.length >= 1 && this.behavior_insts[0].draw)
		{
			this.behavior_insts[0].draw(ctx);
		}
		*/
	};
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.curWebGLTexture);
		glw.setOpacity(this.opacity);
		var cur_frame = this.curFrame;
		var q = this.bquad;
		if (this.runtime.pixel_rounding)
		{
			var ox = ((this.x + 0.5) | 0) - this.x;
			var oy = ((this.y + 0.5) | 0) - this.y;
			if (cur_frame.spritesheeted)
				glw.quadTex(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy, cur_frame.sheetTex);
			else
				glw.quad(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy);
		}
		else
		{
			if (cur_frame.spritesheeted)
				glw.quadTex(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly, cur_frame.sheetTex);
			else
				glw.quad(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly);
		}
	};
	instanceProto.getImagePointIndexByName = function(name_)
	{
		var cur_frame = this.curFrame;
		var i, len;
		for (i = 0, len = cur_frame.image_points.length; i < len; i++)
		{
			if (cr.equals_nocase(name_, cur_frame.image_points[i][0]))
				return i;
		}
		return -1;
	};
	instanceProto.getImagePoint = function(imgpt, getX)
	{
		var cur_frame = this.curFrame;
		var image_points = cur_frame.image_points;
		var index;
		if (cr.is_string(imgpt))
			index = this.getImagePointIndexByName(imgpt);
		else
			index = imgpt - 1;	// 0 is origin
		index = cr.floor(index);
		if (index < 0 || index >= image_points.length)
			return getX ? this.x : this.y;	// return origin
		var x = (image_points[index][1] - cur_frame.hotspotX) * this.width;
		var y = image_points[index][2];
		y = (y - cur_frame.hotspotY) * this.height;
		var cosa = Math.cos(this.angle);
		var sina = Math.sin(this.angle);
		var x_temp = (x * cosa) - (y * sina);
		y = (y * cosa) + (x * sina);
		x = x_temp;
		x += this.x;
		y += this.y;
		return getX ? x : y;
	};
	function Cnds() {};
	var arrCache = [];
	function allocArr()
	{
		if (arrCache.length)
			return arrCache.pop();
		else
			return [0, 0, 0];
	};
	function freeArr(a)
	{
		a[0] = 0;
		a[1] = 0;
		a[2] = 0;
		arrCache.push(a);
	};
	function makeCollKey(a, b)
	{
		if (a < b)
			return "" + a + "," + b;
		else
			return "" + b + "," + a;
	};
	function collmemory_add(collmemory, a, b, tickcount)
	{
		var a_uid = a.uid;
		var b_uid = b.uid;
		var key = makeCollKey(a_uid, b_uid);
		if (collmemory.hasOwnProperty(key))
		{
			collmemory[key][2] = tickcount;
			return;
		}
		var arr = allocArr();
		arr[0] = a_uid;
		arr[1] = b_uid;
		arr[2] = tickcount;
		collmemory[key] = arr;
	};
	function collmemory_remove(collmemory, a, b)
	{
		var key = makeCollKey(a.uid, b.uid);
		if (collmemory.hasOwnProperty(key))
		{
			freeArr(collmemory[key]);
			delete collmemory[key];
		}
	};
	function collmemory_removeInstance(collmemory, inst)
	{
		var uid = inst.uid;
		var p, entry;
		for (p in collmemory)
		{
			if (collmemory.hasOwnProperty(p))
			{
				entry = collmemory[p];
				if (entry[0] === uid || entry[1] === uid)
				{
					freeArr(collmemory[p]);
					delete collmemory[p];
				}
			}
		}
	};
	var last_coll_tickcount = -2;
	function collmemory_has(collmemory, a, b)
	{
		var key = makeCollKey(a.uid, b.uid);
		if (collmemory.hasOwnProperty(key))
		{
			last_coll_tickcount = collmemory[key][2];
			return true;
		}
		else
		{
			last_coll_tickcount = -2;
			return false;
		}
	};
	var candidates1 = [];
	Cnds.prototype.OnCollision = function (rtype)
	{
		if (!rtype)
			return false;
		var runtime = this.runtime;
		var cnd = runtime.getCurrentCondition();
		var ltype = cnd.type;
		if (!cnd.extra.collmemory)
		{
			cnd.extra.collmemory = {};
			runtime.addDestroyCallback((function (collmemory) {
				return function(inst) {
					collmemory_removeInstance(collmemory, inst);
				};
			})(cnd.extra.collmemory));
		}
		var collmemory = cnd.extra.collmemory;
		var lsol = ltype.getCurrentSol();
		var rsol = rtype.getCurrentSol();
		var linstances = lsol.getObjects();
		var rinstances;
		var l, linst, r, rinst;
		var curlsol, currsol;
		var tickcount = this.runtime.tickcount;
		var lasttickcount = tickcount - 1;
		var exists, run;
		var current_event = runtime.getCurrentEventStack().current_event;
		var orblock = current_event.orblock;
		for (l = 0; l < linstances.length; l++)
		{
			linst = linstances[l];
			if (rsol.select_all)
			{
				linst.update_bbox();
				this.runtime.getCollisionCandidates(linst.layer, rtype, linst.bbox, candidates1);
				rinstances = candidates1;
			}
			else
				rinstances = rsol.getObjects();
			for (r = 0; r < rinstances.length; r++)
			{
				rinst = rinstances[r];
				if (runtime.testOverlap(linst, rinst) || runtime.checkRegisteredCollision(linst, rinst))
				{
					exists = collmemory_has(collmemory, linst, rinst);
					run = (!exists || (last_coll_tickcount < lasttickcount));
					collmemory_add(collmemory, linst, rinst, tickcount);
					if (run)
					{
						runtime.pushCopySol(current_event.solModifiers);
						curlsol = ltype.getCurrentSol();
						currsol = rtype.getCurrentSol();
						curlsol.select_all = false;
						currsol.select_all = false;
						if (ltype === rtype)
						{
							curlsol.instances.length = 2;	// just use lsol, is same reference as rsol
							curlsol.instances[0] = linst;
							curlsol.instances[1] = rinst;
							ltype.applySolToContainer();
						}
						else
						{
							curlsol.instances.length = 1;
							currsol.instances.length = 1;
							curlsol.instances[0] = linst;
							currsol.instances[0] = rinst;
							ltype.applySolToContainer();
							rtype.applySolToContainer();
						}
						current_event.retrigger();
						runtime.popSol(current_event.solModifiers);
					}
				}
				else
				{
					collmemory_remove(collmemory, linst, rinst);
				}
			}
			candidates1.length = 0;
		}
		return false;
	};
	var rpicktype = null;
	var rtopick = new cr.ObjectSet();
	var needscollisionfinish = false;
	var candidates2 = [];
	function DoOverlapCondition(rtype, offx, offy)
	{
		if (!rtype)
			return false;
		var do_offset = (offx !== 0 || offy !== 0);
		var oldx, oldy, ret = false, r, lenr, rinst;
		var cnd = this.runtime.getCurrentCondition();
		var ltype = cnd.type;
		var inverted = cnd.inverted;
		var rsol = rtype.getCurrentSol();
		var orblock = this.runtime.getCurrentEventStack().current_event.orblock;
		var rinstances;
		if (rsol.select_all)
		{
			this.update_bbox();
			this.runtime.getCollisionCandidates(this.layer, rtype, this.bbox, candidates2);
			rinstances = candidates2;
		}
		else if (orblock)
			rinstances = rsol.else_instances;
		else
			rinstances = rsol.instances;
		rpicktype = rtype;
		needscollisionfinish = (ltype !== rtype && !inverted);
		if (do_offset)
		{
			oldx = this.x;
			oldy = this.y;
			this.x += offx;
			this.y += offy;
			this.set_bbox_changed();
		}
		for (r = 0, lenr = rinstances.length; r < lenr; r++)
		{
			rinst = rinstances[r];
			if (this.runtime.testOverlap(this, rinst))
			{
				ret = true;
				if (inverted)
					break;
				if (ltype !== rtype)
					rtopick.add(rinst);
			}
		}
		if (do_offset)
		{
			this.x = oldx;
			this.y = oldy;
			this.set_bbox_changed();
		}
		candidates2.length = 0;
		return ret;
	};
	typeProto.finish = function (do_pick)
	{
		if (!needscollisionfinish)
			return;
		if (do_pick)
		{
			var orblock = this.runtime.getCurrentEventStack().current_event.orblock;
			var sol = rpicktype.getCurrentSol();
			var topick = rtopick.valuesRef();
			var i, len, inst;
			if (sol.select_all)
			{
				sol.select_all = false;
				sol.instances.length = topick.length;
				for (i = 0, len = topick.length; i < len; i++)
				{
					sol.instances[i] = topick[i];
				}
				if (orblock)
				{
					sol.else_instances.length = 0;
					for (i = 0, len = rpicktype.instances.length; i < len; i++)
					{
						inst = rpicktype.instances[i];
						if (!rtopick.contains(inst))
							sol.else_instances.push(inst);
					}
				}
			}
			else
			{
				if (orblock)
				{
					var initsize = sol.instances.length;
					sol.instances.length = initsize + topick.length;
					for (i = 0, len = topick.length; i < len; i++)
					{
						sol.instances[initsize + i] = topick[i];
						cr.arrayFindRemove(sol.else_instances, topick[i]);
					}
				}
				else
				{
					cr.shallowAssignArray(sol.instances, topick);
				}
			}
			rpicktype.applySolToContainer();
		}
		rtopick.clear();
		needscollisionfinish = false;
	};
	Cnds.prototype.IsOverlapping = function (rtype)
	{
		return DoOverlapCondition.call(this, rtype, 0, 0);
	};
	Cnds.prototype.IsOverlappingOffset = function (rtype, offx, offy)
	{
		return DoOverlapCondition.call(this, rtype, offx, offy);
	};
	Cnds.prototype.IsAnimPlaying = function (animname)
	{
		if (this.changeAnimName.length)
			return cr.equals_nocase(this.changeAnimName, animname);
		else
			return cr.equals_nocase(this.cur_animation.name, animname);
	};
	Cnds.prototype.CompareFrame = function (cmp, framenum)
	{
		return cr.do_cmp(this.cur_frame, cmp, framenum);
	};
	Cnds.prototype.CompareAnimSpeed = function (cmp, x)
	{
		var s = (this.animForwards ? this.cur_anim_speed : -this.cur_anim_speed);
		return cr.do_cmp(s, cmp, x);
	};
	Cnds.prototype.OnAnimFinished = function (animname)
	{
		return cr.equals_nocase(this.animTriggerName, animname);
	};
	Cnds.prototype.OnAnyAnimFinished = function ()
	{
		return true;
	};
	Cnds.prototype.OnFrameChanged = function ()
	{
		return true;
	};
	Cnds.prototype.IsMirrored = function ()
	{
		return this.width < 0;
	};
	Cnds.prototype.IsFlipped = function ()
	{
		return this.height < 0;
	};
	Cnds.prototype.OnURLLoaded = function ()
	{
		return true;
	};
	Cnds.prototype.IsCollisionEnabled = function ()
	{
		return this.collisionsEnabled;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Spawn = function (obj, layer, imgpt)
	{
		if (!obj || !layer)
			return;
		var inst = this.runtime.createInstance(obj, layer, this.getImagePoint(imgpt, true), this.getImagePoint(imgpt, false));
		if (!inst)
			return;
		if (typeof inst.angle !== "undefined")
		{
			inst.angle = this.angle;
			inst.set_bbox_changed();
		}
		this.runtime.isInOnDestroy++;
		var i, len, s;
		this.runtime.trigger(Object.getPrototypeOf(obj.plugin).cnds.OnCreated, inst);
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				this.runtime.trigger(Object.getPrototypeOf(s.type.plugin).cnds.OnCreated, s);
			}
		}
		this.runtime.isInOnDestroy--;
		var cur_act = this.runtime.getCurrentAction();
		var reset_sol = false;
		if (cr.is_undefined(cur_act.extra.Spawn_LastExec) || cur_act.extra.Spawn_LastExec < this.runtime.execcount)
		{
			reset_sol = true;
			cur_act.extra.Spawn_LastExec = this.runtime.execcount;
		}
		var sol;
		if (obj != this.type)
		{
			sol = obj.getCurrentSol();
			sol.select_all = false;
			if (reset_sol)
			{
				sol.instances.length = 1;
				sol.instances[0] = inst;
			}
			else
				sol.instances.push(inst);
			if (inst.is_contained)
			{
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					s = inst.siblings[i];
					sol = s.type.getCurrentSol();
					sol.select_all = false;
					if (reset_sol)
					{
						sol.instances.length = 1;
						sol.instances[0] = s;
					}
					else
						sol.instances.push(s);
				}
			}
		}
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.StopAnim = function ()
	{
		this.animPlaying = false;
	};
	Acts.prototype.StartAnim = function (from)
	{
		this.animPlaying = true;
		this.frameStart = this.getNowTime();
		if (from === 1 && this.cur_frame !== 0)
		{
			this.changeAnimFrame = 0;
			if (!this.inAnimTrigger)
				this.doChangeAnimFrame();
		}
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
	};
	Acts.prototype.SetAnim = function (animname, from)
	{
		this.changeAnimName = animname;
		this.changeAnimFrom = from;
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		if (!this.inAnimTrigger)
			this.doChangeAnim();
	};
	Acts.prototype.SetAnimFrame = function (framenumber)
	{
		this.changeAnimFrame = framenumber;
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		if (!this.inAnimTrigger)
			this.doChangeAnimFrame();
	};
	Acts.prototype.SetAnimSpeed = function (s)
	{
		this.cur_anim_speed = cr.abs(s);
		this.animForwards = (s >= 0);
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
	};
	Acts.prototype.SetMirrored = function (m)
	{
		var neww = cr.abs(this.width) * (m === 0 ? -1 : 1);
		if (this.width === neww)
			return;
		this.width = neww;
		this.set_bbox_changed();
	};
	Acts.prototype.SetFlipped = function (f)
	{
		var newh = cr.abs(this.height) * (f === 0 ? -1 : 1);
		if (this.height === newh)
			return;
		this.height = newh;
		this.set_bbox_changed();
	};
	Acts.prototype.SetScale = function (s)
	{
		var cur_frame = this.curFrame;
		var mirror_factor = (this.width < 0 ? -1 : 1);
		var flip_factor = (this.height < 0 ? -1 : 1);
		var new_width = cur_frame.width * s * mirror_factor;
		var new_height = cur_frame.height * s * flip_factor;
		if (this.width !== new_width || this.height !== new_height)
		{
			this.width = new_width;
			this.height = new_height;
			this.set_bbox_changed();
		}
	};
	Acts.prototype.LoadURL = function (url_, resize_)
	{
		var img = new Image();
		var self = this;
		var curFrame_ = this.curFrame;
		img.onload = function ()
		{
			if (curFrame_.texture_img.src === img.src)
			{
				if (self.runtime.glwrap && self.curFrame === curFrame_)
					self.curWebGLTexture = curFrame_.webGL_texture;
				self.runtime.redraw = true;
				self.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded, self);
				return;
			}
			curFrame_.texture_img = img;
			curFrame_.offx = 0;
			curFrame_.offy = 0;
			curFrame_.width = img.width;
			curFrame_.height = img.height;
			curFrame_.spritesheeted = false;
			curFrame_.datauri = "";
			if (self.runtime.glwrap)
			{
				if (curFrame_.webGL_texture)
					self.runtime.glwrap.deleteTexture(curFrame_.webGL_texture);
				curFrame_.webGL_texture = self.runtime.glwrap.loadTexture(img, false, self.runtime.linearSampling);
				if (self.curFrame === curFrame_)
					self.curWebGLTexture = curFrame_.webGL_texture;
				self.type.updateAllCurrentTexture();
			}
			if (resize_ === 0)		// resize to image size
			{
				self.width = img.width;
				self.height = img.height;
				self.set_bbox_changed();
			}
			self.runtime.redraw = true;
			self.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded, self);
		};
		if (url_.substr(0, 5) !== "data:")
			img.crossOrigin = 'anonymous';
		img.src = url_;
	};
	Acts.prototype.SetCollisions = function (set_)
	{
		if (this.collisionsEnabled === (set_ !== 0))
			return;		// no change
		this.collisionsEnabled = (set_ !== 0);
		if (this.collisionsEnabled)
			this.set_bbox_changed();		// needs to be added back to cells
		else
		{
			if (this.collcells.right >= this.collcells.left)
				this.type.collision_grid.update(this, this.collcells, null);
			this.collcells.set(0, 0, -1, -1);
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.AnimationFrame = function (ret)
	{
		ret.set_int(this.cur_frame);
	};
	Exps.prototype.AnimationFrameCount = function (ret)
	{
		ret.set_int(this.cur_animation.frames.length);
	};
	Exps.prototype.AnimationName = function (ret)
	{
		ret.set_string(this.cur_animation.name);
	};
	Exps.prototype.AnimationSpeed = function (ret)
	{
		ret.set_float(this.animForwards ? this.cur_anim_speed : -this.cur_anim_speed);
	};
	Exps.prototype.ImagePointX = function (ret, imgpt)
	{
		ret.set_float(this.getImagePoint(imgpt, true));
	};
	Exps.prototype.ImagePointY = function (ret, imgpt)
	{
		ret.set_float(this.getImagePoint(imgpt, false));
	};
	Exps.prototype.ImagePointCount = function (ret)
	{
		ret.set_int(this.curFrame.image_points.length);
	};
	Exps.prototype.ImageWidth = function (ret)
	{
		ret.set_float(this.curFrame.width);
	};
	Exps.prototype.ImageHeight = function (ret)
	{
		ret.set_float(this.curFrame.height);
	};
	pluginProto.exps = new Exps();
}());
/* global cr,log,assert2 */
/* jshint globalstrict: true */
/* jshint strict: true */
;
;
cr.plugins_.Spritefont2 = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Spritefont2.prototype;
	pluginProto.onCreate = function ()
	{
	};
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.runtime.waitForImageLoad(this.texture_img);
		this.webGL_texture = null;
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, false, this.runtime.linearSampling, this.texture_pixelformat);
		}
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].webGL_texture = this.webGL_texture;
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.webGL_texture)
			return;
		this.runtime.glwrap.deleteTexture(this.webGL_texture);
		this.webGL_texture = null;
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
		ctx.drawImage(this.texture_img, 0, 0);
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onDestroy = function()
	{
		freeAllLines (this.lines);
		freeAllClip  (this.clipList);
		freeAllClipUV(this.clipUV);
		cr.wipe(this.characterWidthList);
	};
	instanceProto.onCreate = function()
	{
		this.texture_img      = this.type.texture_img;
		this.characterWidth   = this.properties[0];
		this.characterHeight  = this.properties[1];
		this.characterSet     = this.properties[2];
		this.text             = this.properties[3];
		this.characterScale   = this.properties[4];
		this.visible          = (this.properties[5] === 0);	// 0=visible, 1=invisible
		this.halign           = this.properties[6]/2.0;			// 0=left, 1=center, 2=right
		this.valign           = this.properties[7]/2.0;			// 0=top, 1=center, 2=bottom
		this.wrapbyword       = (this.properties[9] === 0);	// 0=word, 1=character
		this.characterSpacing = this.properties[10];
		this.lineHeight       = this.properties[11];
		this.textWidth  = 0;
		this.textHeight = 0;
		if (this.recycled)
		{
			this.lines.length = 0;
			cr.wipe(this.clipList);
			cr.wipe(this.clipUV);
			cr.wipe(this.characterWidthList);
		}
		else
		{
			this.lines = [];
			this.clipList = {};
			this.clipUV = {};
			this.characterWidthList = {};
		}
		this.text_changed = true;
		this.lastwrapwidth = this.width;
		if (this.runtime.glwrap)
		{
			if (!this.type.webGL_texture)
			{
				this.type.webGL_texture = this.runtime.glwrap.loadTexture(this.type.texture_img, false, this.runtime.linearSampling, this.type.texture_pixelformat);
			}
			this.webGL_texture = this.type.webGL_texture;
		}
		this.SplitSheet();
	};
	instanceProto.saveToJSON = function ()
	{
		var save = {
			"t": this.text,
			"csc": this.characterScale,
			"csp": this.characterSpacing,
			"lh": this.lineHeight,
			"tw": this.textWidth,
			"th": this.textHeight,
			"lrt": this.last_render_tick,
			"cw": {}
		};
		for (var ch in this.characterWidthList)
			save["cw"][ch] = this.characterWidthList[ch];
		return save;
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.text = o["t"];
		this.characterScale = o["csc"];
		this.characterSpacing = o["csp"];
		this.lineHeight = o["lh"];
		this.textWidth = o["tw"];
		this.textHeight = o["th"];
		this.last_render_tick = o["lrt"];
		for(var ch in o["cw"])
			this.characterWidthList[ch] = o["cw"][ch];
		this.text_changed = true;
		this.lastwrapwidth = this.width;
	};
	function trimRight(text)
	{
		return text.replace(/\s\s*$/, '');
	}
	var MAX_CACHE_SIZE = 1000;
	function alloc(cache,Constructor)
	{
		if (cache.length)
			return cache.pop();
		else
			return new Constructor();
	}
	function free(cache,data)
	{
		if (cache.length < MAX_CACHE_SIZE)
		{
			cache.push(data);
		}
	}
	function freeAll(cache,dataList,isArray)
	{
		if (isArray) {
			var i, len;
			for (i = 0, len = dataList.length; i < len; i++)
			{
				free(cache,dataList[i]);
			}
			dataList.length = 0;
		} else {
			var prop;
			for(prop in dataList) {
				if(Object.prototype.hasOwnProperty.call(dataList,prop)) {
					free(cache,dataList[prop]);
					delete dataList[prop];
				}
			}
		}
	}
	function addLine(inst,lineIndex,cur_line) {
		var lines = inst.lines;
		var line;
		cur_line = trimRight(cur_line);
		if (lineIndex >= lines.length)
			lines.push(allocLine());
		line = lines[lineIndex];
		line.text = cur_line;
		line.width = inst.measureWidth(cur_line);
		inst.textWidth = cr.max(inst.textWidth,line.width);
	}
	var linesCache = [];
	function allocLine()       { return alloc(linesCache,Object); }
	function freeLine(l)       { free(linesCache,l); }
	function freeAllLines(arr) { freeAll(linesCache,arr,true); }
	function addClip(obj,property,x,y,w,h) {
		if (obj[property] === undefined) {
			obj[property] = alloc(clipCache,Object);
		}
		obj[property].x = x;
		obj[property].y = y;
		obj[property].w = w;
		obj[property].h = h;
	}
	var clipCache = [];
	function allocClip()      { return alloc(clipCache,Object); }
	function freeAllClip(obj) { freeAll(clipCache,obj,false);}
	function addClipUV(obj,property,left,top,right,bottom) {
		if (obj[property] === undefined) {
			obj[property] = alloc(clipUVCache,cr.rect);
		}
		obj[property].left   = left;
		obj[property].top    = top;
		obj[property].right  = right;
		obj[property].bottom = bottom;
	}
	var clipUVCache = [];
	function allocClipUV()      { return alloc(clipUVCache,cr.rect);}
	function freeAllClipUV(obj) { freeAll(clipUVCache,obj,false);}
	instanceProto.SplitSheet = function() {
		var texture      = this.texture_img;
		var texWidth     = texture.width;
		var texHeight    = texture.height;
		var charWidth    = this.characterWidth;
		var charHeight   = this.characterHeight;
		var charU        = charWidth /texWidth;
		var charV        = charHeight/texHeight;
		var charSet      = this.characterSet ;
		var cols = Math.floor(texWidth/charWidth);
		var rows = Math.floor(texHeight/charHeight);
		for ( var c = 0; c < charSet.length; c++) {
			if  (c >= cols * rows) break;
			var x = c%cols;
			var y = Math.floor(c/cols);
			var letter = charSet.charAt(c);
			if (this.runtime.glwrap) {
				addClipUV(
					this.clipUV, letter,
					x * charU ,
					y * charV ,
					(x+1) * charU ,
					(y+1) * charV
				);
			} else {
				addClip(
					this.clipList, letter,
					x * charWidth,
					y * charHeight,
					charWidth,
					charHeight
				);
			}
		}
	};
	/*
     *	Word-Wrapping
     */
	var wordsCache = [];
	pluginProto.TokeniseWords = function (text)
	{
		wordsCache.length = 0;
		var cur_word = "";
		var ch;
		var i = 0;
		while (i < text.length)
		{
			ch = text.charAt(i);
			if (ch === "\n")
			{
				if (cur_word.length)
				{
					wordsCache.push(cur_word);
					cur_word = "";
				}
				wordsCache.push("\n");
				++i;
			}
			else if (ch === " " || ch === "\t" || ch === "-")
			{
				do {
					cur_word += text.charAt(i);
					i++;
				}
				while (i < text.length && (text.charAt(i) === " " || text.charAt(i) === "\t"));
				wordsCache.push(cur_word);
				cur_word = "";
			}
			else if (i < text.length)
			{
				cur_word += ch;
				i++;
			}
		}
		if (cur_word.length)
			wordsCache.push(cur_word);
	};
	pluginProto.WordWrap = function (inst)
	{
		var text = inst.text;
		var lines = inst.lines;
		if (!text || !text.length)
		{
			freeAllLines(lines);
			return;
		}
		var width = inst.width;
		if (width <= 2.0)
		{
			freeAllLines(lines);
			return;
		}
		var charWidth = inst.characterWidth;
		var charScale = inst.characterScale;
		var charSpacing = inst.characterSpacing;
		if ( (text.length * (charWidth * charScale + charSpacing) - charSpacing) <= width && text.indexOf("\n") === -1)
		{
			var all_width = inst.measureWidth(text);
			if (all_width <= width)
			{
				freeAllLines(lines);
				lines.push(allocLine());
				lines[0].text = text;
				lines[0].width = all_width;
				inst.textWidth  = all_width;
				inst.textHeight = inst.characterHeight * charScale + inst.lineHeight;
				return;
			}
		}
		var wrapbyword = inst.wrapbyword;
		this.WrapText(inst);
		inst.textHeight = lines.length * (inst.characterHeight * charScale + inst.lineHeight);
	};
	pluginProto.WrapText = function (inst)
	{
		var wrapbyword = inst.wrapbyword;
		var text       = inst.text;
		var lines      = inst.lines;
		var width      = inst.width;
		var wordArray;
		if (wrapbyword) {
			this.TokeniseWords(text);	// writes to wordsCache
			wordArray = wordsCache;
		} else {
			wordArray = text;
		}
		var cur_line = "";
		var prev_line;
		var line_width;
		var i;
		var lineIndex = 0;
		var line;
		var ignore_newline = false;
		for (i = 0; i < wordArray.length; i++)
		{
			if (wordArray[i] === "\n")
			{
				if (ignore_newline === true) {
					ignore_newline = false;
				} else {
					addLine(inst,lineIndex,cur_line);
					lineIndex++;
				}
				cur_line = "";
				continue;
			}
			ignore_newline = false;
			prev_line = cur_line;
			cur_line += wordArray[i];
			line_width = inst.measureWidth(trimRight(cur_line));
			if (line_width > width)
			{
				if (prev_line === "") {
					addLine(inst,lineIndex,cur_line);
					cur_line = "";
					ignore_newline = true;
				} else {
					addLine(inst,lineIndex,prev_line);
					cur_line = wordArray[i];
				}
				lineIndex++;
				if (!wrapbyword && cur_line === " ")
					cur_line = "";
			}
		}
		if (trimRight(cur_line).length)
		{
			addLine(inst,lineIndex,cur_line);
			lineIndex++;
		}
		for (i = lineIndex; i < lines.length; i++)
			freeLine(lines[i]);
		lines.length = lineIndex;
	};
	instanceProto.measureWidth = function(text) {
		var spacing = this.characterSpacing;
		var len     = text.length;
		var width   = 0;
		for (var i = 0; i < len; i++) {
			width += this.getCharacterWidth(text.charAt(i)) * this.characterScale + spacing;
		}
		width -= (width > 0) ? spacing : 0;
		return width;
	};
	/***/
	instanceProto.getCharacterWidth = function(character) {
		var widthList = this.characterWidthList;
		if (widthList[character] !== undefined) {
			return widthList[character];
		} else {
			return this.characterWidth;
		}
	};
	instanceProto.rebuildText = function() {
		if (this.text_changed || this.width !== this.lastwrapwidth) {
			this.textWidth = 0;
			this.textHeight = 0;
			this.type.plugin.WordWrap(this);
			this.text_changed = false;
			this.lastwrapwidth = this.width;
		}
	};
	var EPSILON = 0.00001;
	instanceProto.draw = function(ctx, glmode)
	{
		var texture = this.texture_img;
		if (this.text !== "" && texture != null) {
			this.rebuildText();
			if (this.height < this.characterHeight*this.characterScale + this.lineHeight) {
				return;
			}
			ctx.globalAlpha = this.opacity;
			var myx = this.x;
			var myy = this.y;
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			ctx.save();
			ctx.translate(myx, myy);
			ctx.rotate(this.angle);
			var ha         = this.halign;
			var va         = this.valign;
			var scale      = this.characterScale;
			var charHeight = this.characterHeight * scale;
			var lineHeight = this.lineHeight;
			var charSpace  = this.characterSpacing;
			var lines = this.lines;
			var textHeight = this.textHeight;
			var halign;
			var valign = va * cr.max(0,(this.height - textHeight));
			var offx = -(this.hotspotX * this.width);
			var offy = -(this.hotspotY * this.height);
			offy += valign;
			var drawX ;
			var drawY = offy;
			var roundX, roundY;
			for(var i = 0; i < lines.length; i++) {
				var line = lines[i].text;
				var len  = lines[i].width;
				halign = ha * cr.max(0,this.width - len);
				drawX = offx + halign;
				drawY += lineHeight;
				for(var j = 0; j < line.length; j++) {
					var letter = line.charAt(j);
					var clip = this.clipList[letter];
					if ( drawX + this.getCharacterWidth(letter) * scale > this.width + EPSILON ) {
						break;
					}
					if (clip !== undefined) {
						roundX = drawX;
						roundY = drawY;
						if (this.angle === 0)
						{
							roundX = Math.round(roundX);
							roundY = Math.round(roundY);
						}
						ctx.drawImage( this.texture_img,
									 clip.x, clip.y, clip.w, clip.h,
									 roundX,roundY,clip.w*scale,clip.h*scale);
					}
					drawX  += this.getCharacterWidth(letter) * scale + charSpace;
				}
				drawY += charHeight;
				if ( drawY + charHeight + lineHeight > this.height) {
					break;
				}
			}
			ctx.restore();
		}
	};
	var dQuad = new cr.quad();
	function rotateQuad(quad,cosa,sina) {
		var x_temp;
		x_temp   = (quad.tlx * cosa) - (quad.tly * sina);
		quad.tly = (quad.tly * cosa) + (quad.tlx * sina);
		quad.tlx = x_temp;
		x_temp    = (quad.trx * cosa) - (quad.try_ * sina);
		quad.try_ = (quad.try_ * cosa) + (quad.trx * sina);
		quad.trx  = x_temp;
		x_temp   = (quad.blx * cosa) - (quad.bly * sina);
		quad.bly = (quad.bly * cosa) + (quad.blx * sina);
		quad.blx = x_temp;
		x_temp    = (quad.brx * cosa) - (quad.bry * sina);
		quad.bry = (quad.bry * cosa) + (quad.brx * sina);
		quad.brx  = x_temp;
	}
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.webGL_texture);
		glw.setOpacity(this.opacity);
		if (this.text !== "") {
			this.rebuildText();
			if (this.height < this.characterHeight*this.characterScale + this.lineHeight) {
				return;
			}
			this.update_bbox();
			var q = this.bquad;
			var ox = 0;
			var oy = 0;
			if (this.runtime.pixel_rounding)
			{
				ox = ((this.x + 0.5) | 0) - this.x;
				oy = ((this.y + 0.5) | 0) - this.y;
			}
			var angle      = this.angle;
			var ha         = this.halign;
			var va         = this.valign;
			var scale      = this.characterScale;
			var charHeight = this.characterHeight * scale;   // to precalculate in onCreate or on change
			var lineHeight = this.lineHeight;
			var charSpace  = this.characterSpacing;
			var lines = this.lines;
			var textHeight = this.textHeight;
			var cosa,sina;
			if (angle !== 0)
			{
				cosa = Math.cos(angle);
				sina = Math.sin(angle);
			}
			var halign;
			var valign = va * cr.max(0,(this.height - textHeight));
			var offx = q.tlx + ox;
			var offy = q.tly + oy;
			var drawX ;
			var drawY = valign;
			var roundX, roundY;
			for(var i = 0; i < lines.length; i++) {
				var line       = lines[i].text;
				var lineWidth  = lines[i].width;
				halign = ha * cr.max(0,this.width - lineWidth);
				drawX = halign;
				drawY += lineHeight;
				for(var j = 0; j < line.length; j++) {
					var letter = line.charAt(j);
					var clipUV = this.clipUV[letter];
					if ( drawX + this.getCharacterWidth(letter) * scale  > this.width + EPSILON) {
						break;
					}
					if (clipUV !== undefined) {
						var clipWidth  = this.characterWidth*scale;
						var clipHeight = this.characterHeight*scale;
						roundX = drawX;
						roundY = drawY;
						if (angle === 0)
						{
							roundX = Math.round(roundX);
							roundY = Math.round(roundY);
						}
						dQuad.tlx  = roundX;
						dQuad.tly  = roundY;
						dQuad.trx  = roundX + clipWidth;
						dQuad.try_ = roundY ;
						dQuad.blx  = roundX;
						dQuad.bly  = roundY + clipHeight;
						dQuad.brx  = roundX + clipWidth;
						dQuad.bry  = roundY + clipHeight;
						if(angle !== 0)
						{
							rotateQuad(dQuad,cosa,sina);
						}
						dQuad.offset(offx,offy);
						glw.quadTex(
							dQuad.tlx, dQuad.tly,
							dQuad.trx, dQuad.try_,
							dQuad.brx, dQuad.bry,
							dQuad.blx, dQuad.bly,
							clipUV
						);
					}
					drawX  += this.getCharacterWidth(letter) * scale + charSpace;
				}
				drawY += charHeight;
				if ( drawY + charHeight + lineHeight > this.height) {
					break;
				}
			}
		}
	};
	function Cnds() {}
	Cnds.prototype.CompareText = function(text_to_compare, case_sensitive)
	{
		if (case_sensitive)
			return this.text == text_to_compare;
		else
			return cr.equals_nocase(this.text, text_to_compare);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {}
	Acts.prototype.SetText = function(param)
	{
		if (cr.is_number(param) && param < 1e9)
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_set = param.toString();
		if (this.text !== text_to_set)
		{
			this.text = text_to_set;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.AppendText = function(param)
	{
		if (cr.is_number(param))
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_append = param.toString();
		if (text_to_append)	// not empty
		{
			this.text += text_to_append;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetScale = function(param)
	{
		if (param !== this.characterScale) {
			this.characterScale = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetCharacterSpacing = function(param)
	{
		if (param !== this.CharacterSpacing) {
			this.characterSpacing = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetLineHeight = function(param)
	{
		if (param !== this.lineHeight) {
			this.lineHeight = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	instanceProto.SetCharWidth = function(character,width) {
		var w = parseInt(width,10);
		if (this.characterWidthList[character] !== w) {
			this.characterWidthList[character] = w;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetCharacterWidth = function(characterSet,width)
	{
		if (characterSet !== "") {
			for(var c = 0; c < characterSet.length; c++) {
				this.SetCharWidth(characterSet.charAt(c),width);
			}
		}
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.SetHAlign = function (a)
	{
		this.halign = a / 2.0;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	Acts.prototype.SetVAlign = function (a)
	{
		this.valign = a / 2.0;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	pluginProto.acts = new Acts();
	function Exps() {}
	Exps.prototype.CharacterWidth = function(ret,character)
	{
		ret.set_int(this.getCharacterWidth(character));
	};
	Exps.prototype.CharacterHeight = function(ret)
	{
		ret.set_int(this.characterHeight);
	};
	Exps.prototype.CharacterScale = function(ret)
	{
		ret.set_float(this.characterScale);
	};
	Exps.prototype.CharacterSpacing = function(ret)
	{
		ret.set_int(this.characterSpacing);
	};
	Exps.prototype.LineHeight = function(ret)
	{
		ret.set_int(this.lineHeight);
	};
	Exps.prototype.Text = function(ret)
	{
		ret.set_string(this.text);
	};
	Exps.prototype.TextWidth = function (ret)
	{
		this.rebuildText();
		ret.set_float(this.textWidth);
	};
	Exps.prototype.TextHeight = function (ret)
	{
		this.rebuildText();
		ret.set_float(this.textHeight);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.TiledBg = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.TiledBg.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.texture_img.cr_filesize = this.texture_filesize;
		this.runtime.waitForImageLoad(this.texture_img);
		this.pattern = null;
		this.webGL_texture = null;
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
		}
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].webGL_texture = this.webGL_texture;
	};
	typeProto.loadTextures = function ()
	{
		if (this.is_family || this.webGL_texture || !this.runtime.glwrap)
			return;
		this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.webGL_texture)
			return;
		this.runtime.glwrap.deleteTexture(this.webGL_texture);
		this.webGL_texture = null;
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
		ctx.drawImage(this.texture_img, 0, 0);
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.visible = (this.properties[0] === 0);							// 0=visible, 1=invisible
		this.rcTex = new cr.rect(0, 0, 0, 0);
		this.has_own_texture = false;										// true if a texture loaded in from URL
		this.texture_img = this.type.texture_img;
		if (this.runtime.glwrap)
		{
			this.type.loadTextures();
			this.webGL_texture = this.type.webGL_texture;
		}
		else
		{
			if (!this.type.pattern)
				this.type.pattern = this.runtime.ctx.createPattern(this.type.texture_img, "repeat");
			this.pattern = this.type.pattern;
		}
	};
	instanceProto.afterLoad = function ()
	{
		this.has_own_texture = false;
		this.texture_img = this.type.texture_img;
	};
	instanceProto.onDestroy = function ()
	{
		if (this.runtime.glwrap && this.has_own_texture && this.webGL_texture)
		{
			this.runtime.glwrap.deleteTexture(this.webGL_texture);
			this.webGL_texture = null;
		}
	};
	instanceProto.draw = function(ctx)
	{
		ctx.globalAlpha = this.opacity;
		ctx.save();
		ctx.fillStyle = this.pattern;
		var myx = this.x;
		var myy = this.y;
		if (this.runtime.pixel_rounding)
		{
			myx = (myx + 0.5) | 0;
			myy = (myy + 0.5) | 0;
		}
		var drawX = -(this.hotspotX * this.width);
		var drawY = -(this.hotspotY * this.height);
		var offX = drawX % this.texture_img.width;
		var offY = drawY % this.texture_img.height;
		if (offX < 0)
			offX += this.texture_img.width;
		if (offY < 0)
			offY += this.texture_img.height;
		ctx.translate(myx, myy);
		ctx.rotate(this.angle);
		ctx.translate(offX, offY);
		ctx.fillRect(drawX - offX,
					 drawY - offY,
					 this.width,
					 this.height);
		ctx.restore();
	};
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.webGL_texture);
		glw.setOpacity(this.opacity);
		var rcTex = this.rcTex;
		rcTex.right = this.width / this.texture_img.width;
		rcTex.bottom = this.height / this.texture_img.height;
		var q = this.bquad;
		if (this.runtime.pixel_rounding)
		{
			var ox = ((this.x + 0.5) | 0) - this.x;
			var oy = ((this.y + 0.5) | 0) - this.y;
			glw.quadTex(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy, rcTex);
		}
		else
			glw.quadTex(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly, rcTex);
	};
	function Cnds() {};
	Cnds.prototype.OnURLLoaded = function ()
	{
		return true;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.LoadURL = function (url_)
	{
		var img = new Image();
		var self = this;
		img.onload = function ()
		{
			self.texture_img = img;
			if (self.runtime.glwrap)
			{
				if (self.has_own_texture && self.webGL_texture)
					self.runtime.glwrap.deleteTexture(self.webGL_texture);
				self.webGL_texture = self.runtime.glwrap.loadTexture(img, true, self.runtime.linearSampling);
			}
			else
			{
				self.pattern = self.runtime.ctx.createPattern(img, "repeat");
			}
			self.has_own_texture = true;
			self.runtime.redraw = true;
			self.runtime.trigger(cr.plugins_.TiledBg.prototype.cnds.OnURLLoaded, self);
		};
		if (url_.substr(0, 5) !== "data:")
			img.crossOrigin = 'anonymous';
		img.src = url_;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.ImageWidth = function (ret)
	{
		ret.set_float(this.texture_img.width);
	};
	Exps.prototype.ImageHeight = function (ret)
	{
		ret.set_float(this.texture_img.height);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Touch = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Touch.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		this.touches = [];
		this.mouseDown = false;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var dummyoffset = {left: 0, top: 0};
	instanceProto.findTouch = function (id)
	{
		var i, len;
		for (i = 0, len = this.touches.length; i < len; i++)
		{
			if (this.touches[i]["id"] === id)
				return i;
		}
		return -1;
	};
	var appmobi_accx = 0;
	var appmobi_accy = 0;
	var appmobi_accz = 0;
	function AppMobiGetAcceleration(evt)
	{
		appmobi_accx = evt.x;
		appmobi_accy = evt.y;
		appmobi_accz = evt.z;
	};
	var pg_accx = 0;
	var pg_accy = 0;
	var pg_accz = 0;
	function PhoneGapGetAcceleration(evt)
	{
		pg_accx = evt.x;
		pg_accy = evt.y;
		pg_accz = evt.z;
	};
	var theInstance = null;
	instanceProto.onCreate = function()
	{
		theInstance = this;
		this.isWindows8 = !!(typeof window["c2isWindows8"] !== "undefined" && window["c2isWindows8"]);
		this.orient_alpha = 0;
		this.orient_beta = 0;
		this.orient_gamma = 0;
		this.acc_g_x = 0;
		this.acc_g_y = 0;
		this.acc_g_z = 0;
		this.acc_x = 0;
		this.acc_y = 0;
		this.acc_z = 0;
		this.curTouchX = 0;
		this.curTouchY = 0;
		this.trigger_index = 0;
		this.trigger_id = 0;
		this.useMouseInput = (this.properties[0] !== 0);
		var elem = (this.runtime.fullscreen_mode > 0) ? document : this.runtime.canvas;
		var elem2 = document;
		if (this.runtime.isDirectCanvas)
			elem2 = elem = window["Canvas"];
		else if (this.runtime.isCocoonJs)
			elem2 = elem = window;
		var self = this;
		if (window.navigator["pointerEnabled"])
		{
			elem.addEventListener("pointerdown",
				function(info) {
					self.onPointerStart(info);
				},
				false
			);
			elem.addEventListener("pointermove",
				function(info) {
					self.onPointerMove(info);
				},
				false
			);
			elem2.addEventListener("pointerup",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			elem2.addEventListener("pointercancel",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			if (this.runtime.canvas)
			{
				this.runtime.canvas.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				this.runtime.canvas.addEventListener("gesturehold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("gesturehold", function(e) {
					e.preventDefault();
				}, false);
			}
		}
		else if (window.navigator["msPointerEnabled"])
		{
			elem.addEventListener("MSPointerDown",
				function(info) {
					self.onPointerStart(info);
				},
				false
			);
			elem.addEventListener("MSPointerMove",
				function(info) {
					self.onPointerMove(info);
				},
				false
			);
			elem2.addEventListener("MSPointerUp",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			elem2.addEventListener("MSPointerCancel",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			if (this.runtime.canvas)
			{
				this.runtime.canvas.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
			}
		}
		else
		{
			elem.addEventListener("touchstart",
				function(info) {
					self.onTouchStart(info);
				},
				false
			);
			elem.addEventListener("touchmove",
				function(info) {
					self.onTouchMove(info);
				},
				false
			);
			elem2.addEventListener("touchend",
				function(info) {
					self.onTouchEnd(info);
				},
				false
			);
			elem2.addEventListener("touchcancel",
				function(info) {
					self.onTouchEnd(info);
				},
				false
			);
		}
		if (this.isWindows8)
		{
			var win8accelerometerFn = function(e) {
					var reading = e["reading"];
					self.acc_x = reading["accelerationX"];
					self.acc_y = reading["accelerationY"];
					self.acc_z = reading["accelerationZ"];
				};
			var win8inclinometerFn = function(e) {
					var reading = e["reading"];
					self.orient_alpha = reading["yawDegrees"];
					self.orient_beta = reading["pitchDegrees"];
					self.orient_gamma = reading["rollDegrees"];
				};
			var accelerometer = Windows["Devices"]["Sensors"]["Accelerometer"]["getDefault"]();
            if (accelerometer)
			{
                accelerometer["reportInterval"] = Math.max(accelerometer["minimumReportInterval"], 16);
				accelerometer.addEventListener("readingchanged", win8accelerometerFn);
            }
			var inclinometer = Windows["Devices"]["Sensors"]["Inclinometer"]["getDefault"]();
			if (inclinometer)
			{
				inclinometer["reportInterval"] = Math.max(inclinometer["minimumReportInterval"], 16);
				inclinometer.addEventListener("readingchanged", win8inclinometerFn);
			}
			document.addEventListener("visibilitychange", function(e) {
				if (document["hidden"] || document["msHidden"])
				{
					if (accelerometer)
						accelerometer.removeEventListener("readingchanged", win8accelerometerFn);
					if (inclinometer)
						inclinometer.removeEventListener("readingchanged", win8inclinometerFn);
				}
				else
				{
					if (accelerometer)
						accelerometer.addEventListener("readingchanged", win8accelerometerFn);
					if (inclinometer)
						inclinometer.addEventListener("readingchanged", win8inclinometerFn);
				}
			}, false);
		}
		else
		{
			window.addEventListener("deviceorientation", function (eventData) {
				self.orient_alpha = eventData["alpha"] || 0;
				self.orient_beta = eventData["beta"] || 0;
				self.orient_gamma = eventData["gamma"] || 0;
			}, false);
			window.addEventListener("devicemotion", function (eventData) {
				if (eventData["accelerationIncludingGravity"])
				{
					self.acc_g_x = eventData["accelerationIncludingGravity"]["x"] || 0;
					self.acc_g_y = eventData["accelerationIncludingGravity"]["y"] || 0;
					self.acc_g_z = eventData["accelerationIncludingGravity"]["z"] || 0;
				}
				if (eventData["acceleration"])
				{
					self.acc_x = eventData["acceleration"]["x"] || 0;
					self.acc_y = eventData["acceleration"]["y"] || 0;
					self.acc_z = eventData["acceleration"]["z"] || 0;
				}
			}, false);
		}
		if (this.useMouseInput && !this.runtime.isDomFree)
		{
			jQuery(document).mousemove(
				function(info) {
					self.onMouseMove(info);
				}
			);
			jQuery(document).mousedown(
				function(info) {
					self.onMouseDown(info);
				}
			);
			jQuery(document).mouseup(
				function(info) {
					self.onMouseUp(info);
				}
			);
		}
		if (this.runtime.isAppMobi && !this.runtime.isDirectCanvas)
		{
			AppMobi["accelerometer"]["watchAcceleration"](AppMobiGetAcceleration, { "frequency": 40, "adjustForRotation": true });
		}
		if (this.runtime.isPhoneGap && navigator["accelerometer"] && navigator["accelerometer"]["watchAcceleration"])
		{
			navigator["accelerometer"]["watchAcceleration"](PhoneGapGetAcceleration, null, { "frequency": 40 });
		}
		this.runtime.tick2Me(this);
	};
	instanceProto.onPointerMove = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var i = this.findTouch(info["pointerId"]);
		var nowtime = cr.performance_now();
		if (i >= 0)
		{
			var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
			var t = this.touches[i];
			if (nowtime - t.time < 2)
				return;
			t.lasttime = t.time;
			t.lastx = t.x;
			t.lasty = t.y;
			t.time = nowtime;
			t.x = info.pageX - offset.left;
			t.y = info.pageY - offset.top;
		}
	};
	instanceProto.onPointerStart = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var touchx = info.pageX - offset.left;
		var touchy = info.pageY - offset.top;
		var nowtime = cr.performance_now();
		this.trigger_index = this.touches.length;
		this.trigger_id = info["pointerId"];
		this.touches.push({ time: nowtime,
							x: touchx,
							y: touchy,
							lasttime: nowtime,
							lastx: touchx,
							lasty: touchy,
							"id": info["pointerId"],
							startindex: this.trigger_index
						});
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart, this);
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart, this);
		this.curTouchX = touchx;
		this.curTouchY = touchy;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onPointerEnd = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var i = this.findTouch(info["pointerId"]);
		this.trigger_index = (i >= 0 ? this.touches[i].startindex : -1);
		this.trigger_id = (i >= 0 ? this.touches[i]["id"] : -1);
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd, this);
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd, this);
		this.runtime.isInUserInputEvent = false;
		if (i >= 0)
		{
			this.touches.splice(i, 1);
		}
	};
	instanceProto.onTouchMove = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var nowtime = cr.performance_now();
		var i, len, t, u;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			var j = this.findTouch(t["identifier"]);
			if (j >= 0)
			{
				var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
				u = this.touches[j];
				if (nowtime - u.time < 2)
					continue;
				u.lasttime = u.time;
				u.lastx = u.x;
				u.lasty = u.y;
				u.time = nowtime;
				u.x = t.pageX - offset.left;
				u.y = t.pageY - offset.top;
			}
		}
	};
	instanceProto.onTouchStart = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var nowtime = cr.performance_now();
		this.runtime.isInUserInputEvent = true;
		var i, len, t, j;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			j = this.findTouch(t["identifier"]);
			if (j !== -1)
				continue;
			var touchx = t.pageX - offset.left;
			var touchy = t.pageY - offset.top;
			this.trigger_index = this.touches.length;
			this.trigger_id = t["identifier"];
			this.touches.push({ time: nowtime,
								x: touchx,
								y: touchy,
								lasttime: nowtime,
								lastx: touchx,
								lasty: touchy,
								"id": t["identifier"],
								startindex: this.trigger_index
							});
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart, this);
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart, this);
			this.curTouchX = touchx;
			this.curTouchY = touchy;
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject, this);
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onTouchEnd = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		this.runtime.isInUserInputEvent = true;
		var i, len, t, j;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			j = this.findTouch(t["identifier"]);
			if (j >= 0)
			{
				this.trigger_index = this.touches[j].startindex;
				this.trigger_id = this.touches[j]["id"];
				this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd, this);
				this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd, this);
				this.touches.splice(j, 1);
			}
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.getAlpha = function ()
	{
		if (this.runtime.isAppMobi && this.orient_alpha === 0 && appmobi_accz !== 0)
			return appmobi_accz * 90;
		else if (this.runtime.isPhoneGap  && this.orient_alpha === 0 && pg_accz !== 0)
			return pg_accz * 90;
		else
			return this.orient_alpha;
	};
	instanceProto.getBeta = function ()
	{
		if (this.runtime.isAppMobi && this.orient_beta === 0 && appmobi_accy !== 0)
			return appmobi_accy * -90;
		else if (this.runtime.isPhoneGap  && this.orient_beta === 0 && pg_accy !== 0)
			return pg_accy * -90;
		else
			return this.orient_beta;
	};
	instanceProto.getGamma = function ()
	{
		if (this.runtime.isAppMobi && this.orient_gamma === 0 && appmobi_accx !== 0)
			return appmobi_accx * 90;
		else if (this.runtime.isPhoneGap  && this.orient_gamma === 0 && pg_accx !== 0)
			return pg_accx * 90;
		else
			return this.orient_gamma;
	};
	var noop_func = function(){};
	instanceProto.onMouseDown = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchStart(fakeinfo);
		this.mouseDown = true;
	};
	instanceProto.onMouseMove = function(info)
	{
		if (!this.mouseDown)
			return;
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchMove(fakeinfo);
	};
	instanceProto.onMouseUp = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		this.runtime.had_a_click = true;
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchEnd(fakeinfo);
		this.mouseDown = false;
	};
	instanceProto.tick2 = function()
	{
		var i, len, t;
		var nowtime = cr.performance_now();
		for (i = 0, len = this.touches.length; i < len; i++)
		{
			t = this.touches[i];
			if (t.time <= nowtime - 50)
				t.lasttime = nowtime;
		}
	};
	function Cnds() {};
	Cnds.prototype.OnTouchStart = function ()
	{
		return true;
	};
	Cnds.prototype.OnTouchEnd = function ()
	{
		return true;
	};
	Cnds.prototype.IsInTouch = function ()
	{
		return this.touches.length;
	};
	Cnds.prototype.OnTouchObject = function (type)
	{
		if (!type)
			return false;
		return this.runtime.testAndSelectCanvasPointOverlap(type, this.curTouchX, this.curTouchY, false);
	};
	Cnds.prototype.IsTouchingObject = function (type)
	{
		if (!type)
			return false;
		var sol = type.getCurrentSol();
		var instances = sol.getObjects();
		var px, py;
		var touching = [];
		var i, leni, j, lenj;
		for (i = 0, leni = instances.length; i < leni; i++)
		{
			var inst = instances[i];
			inst.update_bbox();
			for (j = 0, lenj = this.touches.length; j < lenj; j++)
			{
				var touch = this.touches[j];
				px = inst.layer.canvasToLayer(touch.x, touch.y, true);
				py = inst.layer.canvasToLayer(touch.x, touch.y, false);
				if (inst.contains_pt(px, py))
				{
					touching.push(inst);
					break;
				}
			}
		}
		if (touching.length)
		{
			sol.select_all = false;
			sol.instances = touching;
			type.applySolToContainer();
			return true;
		}
		else
			return false;
	};
	Cnds.prototype.CompareTouchSpeed = function (index, cmp, s)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
			return false;
		var t = this.touches[index];
		var dist = cr.distanceTo(t.x, t.y, t.lastx, t.lasty);
		var timediff = (t.time - t.lasttime) / 1000;
		var speed = 0;
		if (timediff > 0)
			speed = dist / timediff;
		return cr.do_cmp(speed, cmp, s);
	};
	Cnds.prototype.OrientationSupported = function ()
	{
		return typeof window["DeviceOrientationEvent"] !== "undefined";
	};
	Cnds.prototype.MotionSupported = function ()
	{
		return typeof window["DeviceMotionEvent"] !== "undefined";
	};
	Cnds.prototype.CompareOrientation = function (orientation_, cmp_, angle_)
	{
		var v = 0;
		if (orientation_ === 0)
			v = this.getAlpha();
		else if (orientation_ === 1)
			v = this.getBeta();
		else
			v = this.getGamma();
		return cr.do_cmp(v, cmp_, angle_);
	};
	Cnds.prototype.CompareAcceleration = function (acceleration_, cmp_, angle_)
	{
		var v = 0;
		if (acceleration_ === 0)
			v = this.acc_g_x;
		else if (acceleration_ === 1)
			v = this.acc_g_y;
		else if (acceleration_ === 2)
			v = this.acc_g_z;
		else if (acceleration_ === 3)
			v = this.acc_x;
		else if (acceleration_ === 4)
			v = this.acc_y;
		else if (acceleration_ === 5)
			v = this.acc_z;
		return cr.do_cmp(v, cmp_, angle_);
	};
	Cnds.prototype.OnNthTouchStart = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return touch_ === this.trigger_index;
	};
	Cnds.prototype.OnNthTouchEnd = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return touch_ === this.trigger_index;
	};
	Cnds.prototype.HasNthTouch = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return this.touches.length >= touch_ + 1;
	};
	pluginProto.cnds = new Cnds();
	function Exps() {};
	Exps.prototype.TouchCount = function (ret)
	{
		ret.set_int(this.touches.length);
	};
	Exps.prototype.X = function (ret, layerparam)
	{
		if (this.touches.length)
		{
			var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
			if (cr.is_undefined(layerparam))
			{
				layer = this.runtime.getLayerByNumber(0);
				oldScale = layer.scale;
				oldZoomRate = layer.zoomRate;
				oldParallaxX = layer.parallaxX;
				oldAngle = layer.angle;
				layer.scale = this.runtime.running_layout.scale;
				layer.zoomRate = 1.0;
				layer.parallaxX = 1.0;
				layer.angle = this.runtime.running_layout.angle;
				ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, true));
				layer.scale = oldScale;
				layer.zoomRate = oldZoomRate;
				layer.parallaxX = oldParallaxX;
				layer.angle = oldAngle;
			}
			else
			{
				if (cr.is_number(layerparam))
					layer = this.runtime.getLayerByNumber(layerparam);
				else
					layer = this.runtime.getLayerByName(layerparam);
				if (layer)
					ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, true));
				else
					ret.set_float(0);
			}
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.XAt = function (ret, index, layerparam)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.XForID = function (ret, id, layerparam)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(touch.x, touch.y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(touch.x, touch.y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.Y = function (ret, layerparam)
	{
		if (this.touches.length)
		{
			var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
			if (cr.is_undefined(layerparam))
			{
				layer = this.runtime.getLayerByNumber(0);
				oldScale = layer.scale;
				oldZoomRate = layer.zoomRate;
				oldParallaxY = layer.parallaxY;
				oldAngle = layer.angle;
				layer.scale = this.runtime.running_layout.scale;
				layer.zoomRate = 1.0;
				layer.parallaxY = 1.0;
				layer.angle = this.runtime.running_layout.angle;
				ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, false));
				layer.scale = oldScale;
				layer.zoomRate = oldZoomRate;
				layer.parallaxY = oldParallaxY;
				layer.angle = oldAngle;
			}
			else
			{
				if (cr.is_number(layerparam))
					layer = this.runtime.getLayerByNumber(layerparam);
				else
					layer = this.runtime.getLayerByName(layerparam);
				if (layer)
					ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, false));
				else
					ret.set_float(0);
			}
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.YAt = function (ret, index, layerparam)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.YForID = function (ret, id, layerparam)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(touch.x, touch.y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(touch.x, touch.y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.AbsoluteX = function (ret)
	{
		if (this.touches.length)
			ret.set_float(this.touches[0].x);
		else
			ret.set_float(0);
	};
	Exps.prototype.AbsoluteXAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		ret.set_float(this.touches[index].x);
	};
	Exps.prototype.AbsoluteXForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(touch.x);
	};
	Exps.prototype.AbsoluteY = function (ret)
	{
		if (this.touches.length)
			ret.set_float(this.touches[0].y);
		else
			ret.set_float(0);
	};
	Exps.prototype.AbsoluteYAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		ret.set_float(this.touches[index].y);
	};
	Exps.prototype.AbsoluteYForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(touch.y);
	};
	Exps.prototype.SpeedAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var t = this.touches[index];
		var dist = cr.distanceTo(t.x, t.y, t.lastx, t.lasty);
		var timediff = (t.time - t.lasttime) / 1000;
		if (timediff === 0)
			ret.set_float(0);
		else
			ret.set_float(dist / timediff);
	};
	Exps.prototype.SpeedForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var dist = cr.distanceTo(touch.x, touch.y, touch.lastx, touch.lasty);
		var timediff = (touch.time - touch.lasttime) / 1000;
		if (timediff === 0)
			ret.set_float(0);
		else
			ret.set_float(dist / timediff);
	};
	Exps.prototype.AngleAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var t = this.touches[index];
		ret.set_float(cr.to_degrees(cr.angleTo(t.lastx, t.lasty, t.x, t.y)));
	};
	Exps.prototype.AngleForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(cr.to_degrees(cr.angleTo(touch.lastx, touch.lasty, touch.x, touch.y)));
	};
	Exps.prototype.Alpha = function (ret)
	{
		ret.set_float(this.getAlpha());
	};
	Exps.prototype.Beta = function (ret)
	{
		ret.set_float(this.getBeta());
	};
	Exps.prototype.Gamma = function (ret)
	{
		ret.set_float(this.getGamma());
	};
	Exps.prototype.AccelerationXWithG = function (ret)
	{
		ret.set_float(this.acc_g_x);
	};
	Exps.prototype.AccelerationYWithG = function (ret)
	{
		ret.set_float(this.acc_g_y);
	};
	Exps.prototype.AccelerationZWithG = function (ret)
	{
		ret.set_float(this.acc_g_z);
	};
	Exps.prototype.AccelerationX = function (ret)
	{
		ret.set_float(this.acc_x);
	};
	Exps.prototype.AccelerationY = function (ret)
	{
		ret.set_float(this.acc_y);
	};
	Exps.prototype.AccelerationZ = function (ret)
	{
		ret.set_float(this.acc_z);
	};
	Exps.prototype.TouchIndex = function (ret)
	{
		ret.set_int(this.trigger_index);
	};
	Exps.prototype.TouchID = function (ret)
	{
		ret.set_float(this.trigger_id);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.WebStorage = function(runtime)
{
	this.runtime = runtime;
};
(function()
{
	var pluginProto = cr.plugins_.WebStorage.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var prefix = "";
	var is_arcade = (typeof window["is_scirra_arcade"] !== "undefined");
	if (is_arcade)
		prefix = "arcade" + window["scirra_arcade_id"];
	var logged_sessionnotsupported = false;
	function LogSessionNotSupported()
	{
		if (logged_sessionnotsupported)
			return;
		cr.logexport("[Construct 2] Webstorage plugin: session storage is not supported on this platform. Try using local storage or global variables instead.");
		logged_sessionnotsupported = true;
	};
	instanceProto.onCreate = function()
	{
	};
	function Cnds() {};
	Cnds.prototype.LocalStorageEnabled = function()
	{
		return true;
	};
	Cnds.prototype.SessionStorageEnabled = function()
	{
		return true;
	};
	Cnds.prototype.LocalStorageExists = function(key)
	{
		return localStorage.getItem(prefix + key) != null;
	};
	Cnds.prototype.SessionStorageExists = function(key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return false;
		}
		return sessionStorage.getItem(prefix + key) != null;
	};
	Cnds.prototype.OnQuotaExceeded = function ()
	{
		return true;
	};
	Cnds.prototype.CompareKeyText = function (key, text_to_compare, case_sensitive)
	{
		var value = localStorage.getItem(prefix + key) || "";
		if (case_sensitive)
			return value == text_to_compare;
		else
			return cr.equals_nocase(value, text_to_compare);
	};
	Cnds.prototype.CompareKeyNumber = function (key, cmp, x)
	{
		var value = localStorage.getItem(prefix + key) || "";
		return cr.do_cmp(parseFloat(value), cmp, x);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.StoreLocal = function(key, data)
	{
		try {
			localStorage.setItem(prefix + key, data);
		}
		catch (e)
		{
			this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
		}
	};
	Acts.prototype.StoreSession = function(key,data)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		try {
			sessionStorage.setItem(prefix + key, data);
		}
		catch (e)
		{
			this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
		}
	};
	Acts.prototype.RemoveLocal = function(key)
	{
		localStorage.removeItem(prefix + key);
	};
	Acts.prototype.RemoveSession = function(key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		sessionStorage.removeItem(prefix + key);
	};
	Acts.prototype.ClearLocal = function()
	{
		if (!is_arcade)
			localStorage.clear();
	};
	Acts.prototype.ClearSession = function()
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		if (!is_arcade)
			sessionStorage.clear();
	};
	Acts.prototype.JSONLoad = function (json_, mode_)
	{
		var d;
		try {
			d = JSON.parse(json_);
		}
		catch(e) { return; }
		if (!d["c2dictionary"])			// presumably not a c2dictionary object
			return;
		var o = d["data"];
		if (mode_ === 0 && !is_arcade)	// 'set' mode: must clear webstorage first
			localStorage.clear();
		var p;
		for (p in o)
		{
			if (o.hasOwnProperty(p))
			{
				try {
					localStorage.setItem(prefix + p, o[p]);
				}
				catch (e)
				{
					this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
					return;
				}
			}
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.LocalValue = function(ret,key)
	{
		ret.set_string(localStorage.getItem(prefix + key) || "");
	};
	Exps.prototype.SessionValue = function(ret,key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		ret.set_string(sessionStorage.getItem(prefix + key) || "");
	};
	Exps.prototype.LocalCount = function(ret)
	{
		ret.set_int(is_arcade ? 0 : localStorage.length);
	};
	Exps.prototype.SessionCount = function(ret)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_int(0);
			return;
		}
		ret.set_int(is_arcade ? 0 : sessionStorage.length);
	};
	Exps.prototype.LocalAt = function(ret,n)
	{
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(localStorage.getItem(localStorage.key(n)) || "");
	};
	Exps.prototype.SessionAt = function(ret,n)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(sessionStorage.getItem(sessionStorage.key(n)) || "");
	};
	Exps.prototype.LocalKeyAt = function(ret,n)
	{
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(localStorage.key(n) || "");
	};
	Exps.prototype.SessionKeyAt = function(ret,n)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(sessionStorage.key(n) || "");
	};
	Exps.prototype.AsJSON = function (ret)
	{
		var o = {}, i, len, k;
		for (i = 0, len = localStorage.length; i < len; i++)
		{
			k = localStorage.key(i);
			if (is_arcade)
			{
				if (k.substr(0, prefix.length) === prefix)
				{
					o[k.substr(prefix.length)] = localStorage.getItem(k);
				}
			}
			else
				o[k] = localStorage.getItem(k);
		}
		ret.set_string(JSON.stringify({
			"c2dictionary": true,
			"data": o
		}));
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.behaviors.DragnDrop = function(runtime)
{
	this.runtime = runtime;
	var self = this;
	if (!this.runtime.isDomFree)
	{
		jQuery(document).mousemove(
			function(info) {
				self.onMouseMove(info);
			}
		);
		jQuery(document).mousedown(
			function(info) {
				self.onMouseDown(info);
			}
		);
		jQuery(document).mouseup(
			function(info) {
				self.onMouseUp(info);
			}
		);
	}
	var elem = (this.runtime.fullscreen_mode > 0) ? document : this.runtime.canvas;
	if (this.runtime.isDirectCanvas)
		elem = window["Canvas"];
	else if (this.runtime.isCocoonJs)
		elem = window;
	if (window.navigator["pointerEnabled"])
	{
		elem.addEventListener("pointerdown",
			function(info) {
				self.onPointerStart(info);
			},
			false
		);
		elem.addEventListener("pointermove",
			function(info) {
				self.onPointerMove(info);
			},
			false
		);
		elem.addEventListener("pointerup",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
		elem.addEventListener("pointercancel",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
	}
	else if (window.navigator["msPointerEnabled"])
	{
		elem.addEventListener("MSPointerDown",
			function(info) {
				self.onPointerStart(info);
			},
			false
		);
		elem.addEventListener("MSPointerMove",
			function(info) {
				self.onPointerMove(info);
			},
			false
		);
		elem.addEventListener("MSPointerUp",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
		elem.addEventListener("MSPointerCancel",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
	}
	else
	{
		elem.addEventListener("touchstart",
			function(info) {
				self.onTouchStart(info);
			},
			false
		);
		elem.addEventListener("touchmove",
			function(info) {
				self.onTouchMove(info);
			},
			false
		);
		elem.addEventListener("touchend",
			function(info) {
				self.onTouchEnd(info);
			},
			false
		);
		elem.addEventListener("touchcancel",
			function(info) {
				self.onTouchEnd(info);
			},
			false
		);
	}
};
(function ()
{
	var behaviorProto = cr.behaviors.DragnDrop.prototype;
	var dummyoffset = {left: 0, top: 0};
	function GetDragDropBehavior(inst)
	{
		var i, len;
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i] instanceof behaviorProto.Instance)
				return inst.behavior_insts[i];
		}
		return null;
	};
	behaviorProto.onMouseDown = function (info)
	{
		if (info.which !== 1)
			return;		// not left mouse button
		this.onInputDown("leftmouse", info.pageX, info.pageY);
	};
	behaviorProto.onMouseMove = function (info)
	{
		if (info.which !== 1)
			return;		// not left mouse button
		this.onInputMove("leftmouse", info.pageX, info.pageY);
	};
	behaviorProto.onMouseUp = function (info)
	{
		if (info.which !== 1)
			return;		// not left mouse button
		this.onInputUp("leftmouse");
	};
	behaviorProto.onTouchStart = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputDown(id ? id.toString() : "<none>", t.pageX, t.pageY);
		}
	};
	behaviorProto.onTouchMove = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputMove(id ? id.toString() : "<none>", t.pageX, t.pageY);
		}
	};
	behaviorProto.onTouchEnd = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputUp(id ? id.toString() : "<none>");
		}
	};
	behaviorProto.onPointerStart = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		this.onInputDown(info["pointerId"].toString(), info.pageX, info.pageY);
	};
	behaviorProto.onPointerMove = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		this.onInputMove(info["pointerId"].toString(), info.pageX, info.pageY);
	};
	behaviorProto.onPointerEnd = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		this.onInputUp(info["pointerId"].toString());
	};
	behaviorProto.onInputDown = function (src, pageX, pageY)
	{
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var x = pageX - offset.left;
		var y = pageY - offset.top;
		var lx, ly, topx, topy;
		var arr = this.my_instances.valuesRef();
		var i, len, b, inst, topmost = null;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			b = GetDragDropBehavior(inst);
			if (!b.enabled || b.dragging)
				continue;		// don't consider disabled or already-dragging instances
			lx = inst.layer.canvasToLayer(x, y, true);
			ly = inst.layer.canvasToLayer(x, y, false);
			inst.update_bbox();
			if (!inst.contains_pt(lx, ly))
				continue;		// don't consider instances not over this point
			if (!topmost)
			{
				topmost = inst;
				topx = lx;
				topy = ly;
				continue;
			}
			if (inst.layer.index > topmost.layer.index)
			{
				topmost = inst;
				topx = lx;
				topy = ly;
				continue;
			}
			if (inst.layer.index === topmost.layer.index && inst.get_zindex() > topmost.get_zindex())
			{
				topmost = inst;
				topx = lx;
				topy = ly;
				continue;
			}
		}
		if (topmost)
			GetDragDropBehavior(topmost).onDown(src, topx, topy);
	};
	behaviorProto.onInputMove = function (src, pageX, pageY)
	{
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var x = pageX - offset.left;
		var y = pageY - offset.top;
		var lx, ly;
		var arr = this.my_instances.valuesRef();
		var i, len, b, inst;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			b = GetDragDropBehavior(inst);
			if (!b.enabled || !b.dragging || (b.dragging && b.dragsource !== src))
				continue;		// don't consider disabled, not-dragging, or dragging by other sources
			lx = inst.layer.canvasToLayer(x, y, true);
			ly = inst.layer.canvasToLayer(x, y, false);
			b.onMove(lx, ly);
		}
	};
	behaviorProto.onInputUp = function (src)
	{
		var arr = this.my_instances.valuesRef();
		var i, len, b, inst;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			b = GetDragDropBehavior(inst);
			if (b.dragging && b.dragsource === src)
				b.onUp();
		}
	};
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.dragging = false;
		this.dx = 0;
		this.dy = 0;
		this.dragsource = "<none>";
		this.axes = this.properties[0];
		this.enabled = (this.properties[1] !== 0);
	};
	behinstProto.saveToJSON = function ()
	{
		return { "enabled": this.enabled };
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.enabled = o["enabled"];
		this.dragging = false;
	};
	behinstProto.onDown = function(src, x, y)
	{
		this.dx = x - this.inst.x;
		this.dy = y - this.inst.y;
		this.dragging = true;
		this.dragsource = src;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDragStart, this.inst);
		this.runtime.isInUserInputEvent = false;
	};
	behinstProto.onMove = function(x, y)
	{
		var newx = x - this.dx;
		var newy = y - this.dy;
		if (this.axes === 0)		// both
		{
			if (this.inst.x !== newx || this.inst.y !== newy)
			{
				this.inst.x = newx;
				this.inst.y = newy;
				this.inst.set_bbox_changed();
			}
		}
		else if (this.axes === 1)	// horizontal
		{
			if (this.inst.x !== newx)
			{
				this.inst.x = newx;
				this.inst.set_bbox_changed();
			}
		}
		else if (this.axes === 2)	// vertical
		{
			if (this.inst.y !== newy)
			{
				this.inst.y = newy;
				this.inst.set_bbox_changed();
			}
		}
	};
	behinstProto.onUp = function()
	{
		this.dragging = false;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDrop, this.inst);
		this.runtime.isInUserInputEvent = false;
	};
	behinstProto.tick = function ()
	{
	};
	function Cnds() {};
	Cnds.prototype.IsDragging = function ()
	{
		return this.dragging;
	};
	Cnds.prototype.OnDragStart = function ()
	{
		return true;
	};
	Cnds.prototype.OnDrop = function ()
	{
		return true;
	};
	Cnds.prototype.IsEnabled = function ()
	{
		return !!this.enabled;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetEnabled = function (s)
	{
		this.enabled = (s !== 0);
		if (!this.enabled)
			this.dragging = false;
	};
	Acts.prototype.Drop = function ()
	{
		if (this.dragging)
			this.onUp();
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Fade = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Fade.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		var active_at_start = this.properties[0] === 1;
		this.fadeInTime = this.properties[1];
		this.waitTime = this.properties[2];
		this.fadeOutTime = this.properties[3];
		this.destroy = this.properties[4];			// 0 = no, 1 = after fade out
		this.stage = active_at_start ? 0 : 3;		// 0 = fade in, 1 = wait, 2 = fade out, 3 = done
		if (this.recycled)
			this.stageTime.reset();
		else
			this.stageTime = new cr.KahanAdder();
		this.maxOpacity = (this.inst.opacity ? this.inst.opacity : 1.0);
		if (active_at_start)
		{
			if (this.fadeInTime === 0)
			{
				this.stage = 1;
				if (this.waitTime === 0)
					this.stage = 2;
			}
			else
			{
				this.inst.opacity = 0;
				this.runtime.redraw = true;
			}
		}
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"fit": this.fadeInTime,
			"wt": this.waitTime,
			"fot": this.fadeOutTime,
			"s": this.stage,
			"st": this.stageTime.sum,
			"mo": this.maxOpacity,
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.fadeInTime = o["fit"];
		this.waitTime = o["wt"];
		this.fadeOutTime = o["fot"];
		this.stage = o["s"];
		this.stageTime.reset();
		this.stageTime.sum = o["st"];
		this.maxOpacity = o["mo"];
	};
	behinstProto.tick = function ()
	{
		this.stageTime.add(this.runtime.getDt(this.inst));
		if (this.stage === 0)
		{
			this.inst.opacity = (this.stageTime.sum / this.fadeInTime) * this.maxOpacity;
			this.runtime.redraw = true;
			if (this.inst.opacity >= this.maxOpacity)
			{
				this.inst.opacity = this.maxOpacity;
				this.stage = 1;	// wait stage
				this.stageTime.reset();
			}
		}
		if (this.stage === 1)
		{
			if (this.stageTime.sum >= this.waitTime)
			{
				this.stage = 2;	// fade out stage
				this.stageTime.reset();
			}
		}
		if (this.stage === 2)
		{
			if (this.fadeOutTime !== 0)
			{
				this.inst.opacity = this.maxOpacity - ((this.stageTime.sum / this.fadeOutTime) * this.maxOpacity);
				this.runtime.redraw = true;
				if (this.inst.opacity < 0)
				{
					this.inst.opacity = 0;
					this.stage = 3;	// done
					this.stageTime.reset();
					this.runtime.trigger(cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd, this.inst);
					if (this.destroy === 1)
						this.runtime.DestroyInstance(this.inst);
				}
			}
		}
	};
	behinstProto.doStart = function ()
	{
		this.stage = 0;
		this.stageTime.reset();
		if (this.fadeInTime === 0)
		{
			this.stage = 1;
			if (this.waitTime === 0)
				this.stage = 2;
		}
		else
		{
			this.inst.opacity = 0;
			this.runtime.redraw = true;
		}
	};
	function Cnds() {};
	Cnds.prototype.OnFadeOutEnd = function ()
	{
		return true;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.StartFade = function ()
	{
		if (this.stage === 3)
			this.doStart();
	};
	Acts.prototype.RestartFade = function ()
	{
		this.doStart();
	};
	behaviorProto.acts = new Acts();
}());
;
;
cr.behaviors.Pin = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Pin.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.pinObject = null;
		this.pinObjectUid = -1;		// for loading
		this.pinAngle = 0;
		this.pinDist = 0;
		this.myStartAngle = 0;
		this.theirStartAngle = 0;
		this.lastKnownAngle = 0;
		this.mode = 0;				// 0 = position & angle; 1 = position; 2 = angle; 3 = rope; 4 = bar
		var self = this;
		if (!this.recycled)
		{
			this.myDestroyCallback = (function(inst) {
													self.onInstanceDestroyed(inst);
												});
		}
		this.runtime.addDestroyCallback(this.myDestroyCallback);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"uid": this.pinObject ? this.pinObject.uid : -1,
			"pa": this.pinAngle,
			"pd": this.pinDist,
			"msa": this.myStartAngle,
			"tsa": this.theirStartAngle,
			"lka": this.lastKnownAngle,
			"m": this.mode
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.pinObjectUid = o["uid"];		// wait until afterLoad to look up
		this.pinAngle = o["pa"];
		this.pinDist = o["pd"];
		this.myStartAngle = o["msa"];
		this.theirStartAngle = o["tsa"];
		this.lastKnownAngle = o["lka"];
		this.mode = o["m"];
	};
	behinstProto.afterLoad = function ()
	{
		if (this.pinObjectUid === -1)
			this.pinObject = null;
		else
		{
			this.pinObject = this.runtime.getObjectByUID(this.pinObjectUid);
;
		}
		this.pinObjectUid = -1;
	};
	behinstProto.onInstanceDestroyed = function (inst)
	{
		if (this.pinObject == inst)
			this.pinObject = null;
	};
	behinstProto.onDestroy = function()
	{
		this.pinObject = null;
		this.runtime.removeDestroyCallback(this.myDestroyCallback);
	};
	behinstProto.tick = function ()
	{
	};
	behinstProto.tick2 = function ()
	{
		if (!this.pinObject)
			return;
		if (this.lastKnownAngle !== this.inst.angle)
			this.myStartAngle = cr.clamp_angle(this.myStartAngle + (this.inst.angle - this.lastKnownAngle));
		var newx = this.inst.x;
		var newy = this.inst.y;
		if (this.mode === 3 || this.mode === 4)		// rope mode or bar mode
		{
			var dist = cr.distanceTo(this.inst.x, this.inst.y, this.pinObject.x, this.pinObject.y);
			if ((dist > this.pinDist) || (this.mode === 4 && dist < this.pinDist))
			{
				var a = cr.angleTo(this.pinObject.x, this.pinObject.y, this.inst.x, this.inst.y);
				newx = this.pinObject.x + Math.cos(a) * this.pinDist;
				newy = this.pinObject.y + Math.sin(a) * this.pinDist;
			}
		}
		else
		{
			newx = this.pinObject.x + Math.cos(this.pinObject.angle + this.pinAngle) * this.pinDist;
			newy = this.pinObject.y + Math.sin(this.pinObject.angle + this.pinAngle) * this.pinDist;
		}
		var newangle = cr.clamp_angle(this.myStartAngle + (this.pinObject.angle - this.theirStartAngle));
		this.lastKnownAngle = newangle;
		if ((this.mode === 0 || this.mode === 1 || this.mode === 3 || this.mode === 4)
			&& (this.inst.x !== newx || this.inst.y !== newy))
		{
			this.inst.x = newx;
			this.inst.y = newy;
			this.inst.set_bbox_changed();
		}
		if ((this.mode === 0 || this.mode === 2) && (this.inst.angle !== newangle))
		{
			this.inst.angle = newangle;
			this.inst.set_bbox_changed();
		}
	};
	function Cnds() {};
	Cnds.prototype.IsPinned = function ()
	{
		return !!this.pinObject;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Pin = function (obj, mode_)
	{
		if (!obj)
			return;
		var otherinst = obj.getFirstPicked(this.inst);
		if (!otherinst)
			return;
		this.pinObject = otherinst;
		this.pinAngle = cr.angleTo(otherinst.x, otherinst.y, this.inst.x, this.inst.y) - otherinst.angle;
		this.pinDist = cr.distanceTo(otherinst.x, otherinst.y, this.inst.x, this.inst.y);
		this.myStartAngle = this.inst.angle;
		this.lastKnownAngle = this.inst.angle;
		this.theirStartAngle = otherinst.angle;
		this.mode = mode_;
	};
	Acts.prototype.Unpin = function ()
	{
		this.pinObject = null;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.PinnedUID = function (ret)
	{
		ret.set_int(this.pinObject ? this.pinObject.uid : -1);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Platform = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Platform.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	var ANIMMODE_STOPPED = 0;
	var ANIMMODE_MOVING = 1;
	var ANIMMODE_JUMPING = 2;
	var ANIMMODE_FALLING = 3;
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
		this.leftkey = false;
		this.rightkey = false;
		this.jumpkey = false;
		this.jumped = false;			// prevent bunnyhopping
		this.ignoreInput = false;
		this.simleft = false;
		this.simright = false;
		this.simjump = false;
		this.lastFloorObject = null;
		this.loadFloorObject = -1;
		this.lastFloorX = 0;
		this.lastFloorY = 0;
		this.floorIsJumpthru = false;
		this.animMode = ANIMMODE_STOPPED;
		this.fallthrough = 0;			// fall through jump-thru.  >0 to disable, lasts a few ticks
		this.firstTick = true;
		this.dx = 0;
		this.dy = 0;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.updateGravity = function()
	{
		this.downx = Math.cos(this.ga);
		this.downy = Math.sin(this.ga);
		this.rightx = Math.cos(this.ga - Math.PI / 2);
		this.righty = Math.sin(this.ga - Math.PI / 2);
		this.downx = cr.round6dp(this.downx);
		this.downy = cr.round6dp(this.downy);
		this.rightx = cr.round6dp(this.rightx);
		this.righty = cr.round6dp(this.righty);
		this.g1 = this.g;
		if (this.g < 0)
		{
			this.downx *= -1;
			this.downy *= -1;
			this.g = Math.abs(this.g);
		}
	};
	behinstProto.onCreate = function()
	{
		this.maxspeed = this.properties[0];
		this.acc = this.properties[1];
		this.dec = this.properties[2];
		this.jumpStrength = this.properties[3];
		this.g = this.properties[4];
		this.g1 = this.g;
		this.maxFall = this.properties[5];
		this.defaultControls = (this.properties[6] === 1);	// 0=no, 1=yes
		this.enabled = (this.properties[7] !== 0);
		this.wasOnFloor = false;
		this.wasOverJumpthru = this.runtime.testOverlapJumpThru(this.inst);
		this.loadOverJumpthru = -1;
		this.ga = cr.to_radians(90);
		this.updateGravity();
		var self = this;
		if (this.defaultControls && !this.runtime.isDomFree)
		{
			jQuery(document).keydown(function(info) {
						self.onKeyDown(info);
					});
			jQuery(document).keyup(function(info) {
						self.onKeyUp(info);
					});
		}
		if (!this.recycled)
		{
			this.myDestroyCallback = function(inst) {
										self.onInstanceDestroyed(inst);
									};
		}
		this.runtime.addDestroyCallback(this.myDestroyCallback);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"ii": this.ignoreInput,
			"lfx": this.lastFloorX,
			"lfy": this.lastFloorY,
			"lfo": (this.lastFloorObject ? this.lastFloorObject.uid : -1),
			"am": this.animMode,
			"en": this.enabled,
			"fall": this.fallthrough,
			"ft": this.firstTick,
			"dx": this.dx,
			"dy": this.dy,
			"ms": this.maxspeed,
			"acc": this.acc,
			"dec": this.dec,
			"js": this.jumpStrength,
			"g": this.g,
			"g1": this.g1,
			"mf": this.maxFall,
			"wof": this.wasOnFloor,
			"woj": (this.wasOverJumpthru ? this.wasOverJumpthru.uid : -1),
			"ga": this.ga
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.ignoreInput = o["ii"];
		this.lastFloorX = o["lfx"];
		this.lastFloorY = o["lfy"];
		this.loadFloorObject = o["lfo"];
		this.animMode = o["am"];
		this.enabled = o["en"];
		this.fallthrough = o["fall"];
		this.firstTick = o["ft"];
		this.dx = o["dx"];
		this.dy = o["dy"];
		this.maxspeed = o["ms"];
		this.acc = o["acc"];
		this.dec = o["dec"];
		this.jumpStrength = o["js"];
		this.g = o["g"];
		this.g1 = o["g1"];
		this.maxFall = o["mf"];
		this.wasOnFloor = o["wof"];
		this.loadOverJumpthru = o["woj"];
		this.ga = o["ga"];
		this.leftkey = false;
		this.rightkey = false;
		this.jumpkey = false;
		this.jumped = false;
		this.simleft = false;
		this.simright = false;
		this.simjump = false;
		this.updateGravity();
	};
	behinstProto.afterLoad = function ()
	{
		if (this.loadFloorObject === -1)
			this.lastFloorObject = null;
		else
			this.lastFloorObject = this.runtime.getObjectByUID(this.loadFloorObject);
		if (this.loadOverJumpthru === -1)
			this.wasOverJumpthru = null;
		else
			this.wasOverJumpthru = this.runtime.getObjectByUID(this.loadOverJumpthru);
	};
	behinstProto.onInstanceDestroyed = function (inst)
	{
		if (this.lastFloorObject == inst)
			this.lastFloorObject = null;
	};
	behinstProto.onDestroy = function ()
	{
		this.lastFloorObject = null;
		this.runtime.removeDestroyCallback(this.myDestroyCallback);
	};
	behinstProto.onKeyDown = function (info)
	{
		switch (info.which) {
		case 38:	// up
			info.preventDefault();
			this.jumpkey = true;
			break;
		case 37:	// left
			info.preventDefault();
			this.leftkey = true;
			break;
		case 39:	// right
			info.preventDefault();
			this.rightkey = true;
			break;
		}
	};
	behinstProto.onKeyUp = function (info)
	{
		switch (info.which) {
		case 38:	// up
			info.preventDefault();
			this.jumpkey = false;
			this.jumped = false;
			break;
		case 37:	// left
			info.preventDefault();
			this.leftkey = false;
			break;
		case 39:	// right
			info.preventDefault();
			this.rightkey = false;
			break;
		}
	};
	behinstProto.getGDir = function ()
	{
		if (this.g < 0)
			return -1;
		else
			return 1;
	};
	behinstProto.isOnFloor = function ()
	{
		var ret = null;
		var ret2 = null;
		var i, len, j;
		var oldx = this.inst.x;
		var oldy = this.inst.y;
		this.inst.x += this.downx;
		this.inst.y += this.downy;
		this.inst.set_bbox_changed();
		if (this.lastFloorObject && this.runtime.testOverlap(this.inst, this.lastFloorObject))
		{
			this.inst.x = oldx;
			this.inst.y = oldy;
			this.inst.set_bbox_changed();
			return this.lastFloorObject;
		}
		else
		{
			ret = this.runtime.testOverlapSolid(this.inst);
			if (!ret && this.fallthrough === 0)
				ret2 = this.runtime.testOverlapJumpThru(this.inst, true);
			this.inst.x = oldx;
			this.inst.y = oldy;
			this.inst.set_bbox_changed();
			if (ret)		// was overlapping solid
			{
				if (this.runtime.testOverlap(this.inst, ret))
					return null;
				else
				{
					this.floorIsJumpthru = false;
					return ret;
				}
			}
			if (ret2 && ret2.length)
			{
				for (i = 0, j = 0, len = ret2.length; i < len; i++)
				{
					ret2[j] = ret2[i];
					if (!this.runtime.testOverlap(this.inst, ret2[i]))
						j++;
				}
				if (j >= 1)
				{
					this.floorIsJumpthru = true;
					return ret2[0];
				}
			}
			return null;
		}
	};
	behinstProto.tick = function ()
	{
	};
	behinstProto.posttick = function ()
	{
		var dt = this.runtime.getDt(this.inst);
		var mx, my, obstacle, mag, allover, i, len, j, oldx, oldy;
		if (!this.jumpkey && !this.simjump)
			this.jumped = false;
		var left = this.leftkey || this.simleft;
		var right = this.rightkey || this.simright;
		var jump = (this.jumpkey || this.simjump) && !this.jumped;
		this.simleft = false;
		this.simright = false;
		this.simjump = false;
		if (!this.enabled)
			return;
		if (this.ignoreInput)
		{
			left = false;
			right = false;
			jump = false;
		}
		var lastFloor = this.lastFloorObject;
		var floor_moved = false;
		if (this.firstTick)
		{
			if (this.runtime.testOverlapSolid(this.inst) || this.runtime.testOverlapJumpThru(this.inst))
			{
				this.runtime.pushOutSolid(this.inst, -this.downx, -this.downy, 4, true);
			}
			this.firstTick = false;
		}
		if (lastFloor && this.dy === 0 && (lastFloor.y !== this.lastFloorY || lastFloor.x !== this.lastFloorX))
		{
			mx = (lastFloor.x - this.lastFloorX);
			my = (lastFloor.y - this.lastFloorY);
			this.inst.x += mx;
			this.inst.y += my;
			this.inst.set_bbox_changed();
			this.lastFloorX = lastFloor.x;
			this.lastFloorY = lastFloor.y;
			floor_moved = true;
			if (this.runtime.testOverlapSolid(this.inst))
			{
				this.runtime.pushOutSolid(this.inst, -mx, -my, Math.sqrt(mx * mx + my * my) * 2.5);
			}
		}
		var floor_ = this.isOnFloor();
		var collobj = this.runtime.testOverlapSolid(this.inst);
		if (collobj)
		{
			if (this.runtime.pushOutSolidNearest(this.inst, Math.max(this.inst.width, this.inst.height) / 2))
				this.runtime.registerCollision(this.inst, collobj);
			else
				return;
		}
		if (floor_)
		{
			if (this.dy > 0)
			{
				if (!this.wasOnFloor)
				{
					this.runtime.pushInFractional(this.inst, -this.downx, -this.downy, floor_, 16);
					this.wasOnFloor = true;
				}
				this.dy = 0;
			}
			if (lastFloor != floor_)
			{
				this.lastFloorObject = floor_;
				this.lastFloorX = floor_.x;
				this.lastFloorY = floor_.y;
				this.runtime.registerCollision(this.inst, floor_);
			}
			else if (floor_moved)
			{
				collobj = this.runtime.testOverlapSolid(this.inst);
				if (collobj)
				{
					this.runtime.registerCollision(this.inst, collobj);
					if (mx !== 0)
					{
						if (mx > 0)
							this.runtime.pushOutSolid(this.inst, -this.rightx, -this.righty);
						else
							this.runtime.pushOutSolid(this.inst, this.rightx, this.righty);
					}
					this.runtime.pushOutSolid(this.inst, -this.downx, -this.downy);
				}
			}
			if (jump)
			{
				oldx = this.inst.x;
				oldy = this.inst.y;
				this.inst.x -= this.downx;
				this.inst.y -= this.downy;
				this.inst.set_bbox_changed();
				if (!this.runtime.testOverlapSolid(this.inst))
				{
					this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnJump, this.inst);
					this.animMode = ANIMMODE_JUMPING;
					this.dy = -this.jumpStrength;
					this.jumped = true;
				}
				else
					jump = false;
				this.inst.x = oldx;
				this.inst.y = oldy;
				this.inst.set_bbox_changed();
			}
		}
		else
		{
			this.lastFloorObject = null;
			this.dy += this.g * dt;
			if (this.dy > this.maxFall)
				this.dy = this.maxFall;
			if (jump)
				this.jumped = true;
		}
		this.wasOnFloor = !!floor_;
		if (left == right)	// both up or both down
		{
			if (this.dx < 0)
			{
				this.dx += this.dec * dt;
				if (this.dx > 0)
					this.dx = 0;
			}
			else if (this.dx > 0)
			{
				this.dx -= this.dec * dt;
				if (this.dx < 0)
					this.dx = 0;
			}
		}
		if (left && !right)
		{
			if (this.dx > 0)
				this.dx -= (this.acc + this.dec) * dt;
			else
				this.dx -= this.acc * dt;
		}
		if (right && !left)
		{
			if (this.dx < 0)
				this.dx += (this.acc + this.dec) * dt;
			else
				this.dx += this.acc * dt;
		}
		if (this.dx > this.maxspeed)
			this.dx = this.maxspeed;
		else if (this.dx < -this.maxspeed)
			this.dx = -this.maxspeed;
		var landed = false;
		if (this.dx !== 0)
		{
			oldx = this.inst.x;
			oldy = this.inst.y;
			mx = this.dx * dt * this.rightx;
			my = this.dx * dt * this.righty;
			this.inst.x += this.rightx * (this.dx > 1 ? 1 : -1) - this.downx;
			this.inst.y += this.righty * (this.dx > 1 ? 1 : -1) - this.downy;
			this.inst.set_bbox_changed();
			var is_jumpthru = false;
			var slope_too_steep = this.runtime.testOverlapSolid(this.inst);
			/*
			if (!slope_too_steep && floor_)
			{
				slope_too_steep = this.runtime.testOverlapJumpThru(this.inst);
				is_jumpthru = true;
				if (slope_too_steep)
				{
					this.inst.x = oldx;
					this.inst.y = oldy;
					this.inst.set_bbox_changed();
					if (this.runtime.testOverlap(this.inst, slope_too_steep))
					{
						slope_too_steep = null;
						is_jumpthru = false;
					}
				}
			}
			*/
			this.inst.x = oldx + mx;
			this.inst.y = oldy + my;
			this.inst.set_bbox_changed();
			obstacle = this.runtime.testOverlapSolid(this.inst);
			if (!obstacle && floor_)
			{
				obstacle = this.runtime.testOverlapJumpThru(this.inst);
				if (obstacle)
				{
					this.inst.x = oldx;
					this.inst.y = oldy;
					this.inst.set_bbox_changed();
					if (this.runtime.testOverlap(this.inst, obstacle))
					{
						obstacle = null;
						is_jumpthru = false;
					}
					else
						is_jumpthru = true;
					this.inst.x = oldx + mx;
					this.inst.y = oldy + my;
					this.inst.set_bbox_changed();
				}
			}
			if (obstacle)
			{
				var push_dist = Math.abs(this.dx * dt) + 2;
				if (slope_too_steep || !this.runtime.pushOutSolid(this.inst, -this.downx, -this.downy, push_dist, is_jumpthru, obstacle))
				{
					this.runtime.registerCollision(this.inst, obstacle);
					push_dist = Math.max(Math.abs(this.dx * dt * 2.5), 30);
					if (!this.runtime.pushOutSolid(this.inst, this.rightx * (this.dx < 0 ? 1 : -1), this.righty * (this.dx < 0 ? 1 : -1), push_dist, false))
					{
						this.inst.x = oldx;
						this.inst.y = oldy;
						this.inst.set_bbox_changed();
					}
					else if (floor_ && !is_jumpthru && !this.floorIsJumpthru)
					{
						oldx = this.inst.x;
						oldy = this.inst.y;
						this.inst.x += this.downx;
						this.inst.y += this.downy;
						if (this.runtime.testOverlapSolid(this.inst))
						{
							if (!this.runtime.pushOutSolid(this.inst, -this.downx, -this.downy, 3, false))
							{
								this.inst.x = oldx;
								this.inst.y = oldy;
								this.inst.set_bbox_changed();
							}
						}
						else
						{
							this.inst.x = oldx;
							this.inst.y = oldy;
							this.inst.set_bbox_changed();
						}
					}
					if (!is_jumpthru)
						this.dx = 0;	// stop
				}
				else if (!slope_too_steep && Math.abs(this.dy) < 15)
				{
					this.dy = 0;
					if (!floor_)
						landed = true;
				}
			}
			else
			{
				var newfloor = this.isOnFloor();
				if (floor_ && !newfloor)
				{
					mag = Math.ceil(Math.abs(this.dx * dt)) + 2;
					oldx = this.inst.x;
					oldy = this.inst.y;
					this.inst.x += this.downx * mag;
					this.inst.y += this.downy * mag;
					this.inst.set_bbox_changed();
					if (this.runtime.testOverlapSolid(this.inst) || this.runtime.testOverlapJumpThru(this.inst))
						this.runtime.pushOutSolid(this.inst, -this.downx, -this.downy, mag + 2, true);
					else
					{
						this.inst.x = oldx;
						this.inst.y = oldy;
						this.inst.set_bbox_changed();
					}
				}
				else if (newfloor && this.dy === 0)
				{
					this.runtime.pushInFractional(this.inst, -this.downx, -this.downy, newfloor, 16);
				}
			}
		}
		if (this.dy !== 0)
		{
			oldx = this.inst.x;
			oldy = this.inst.y;
			this.inst.x += this.dy * dt * this.downx;
			this.inst.y += this.dy * dt * this.downy;
			var newx = this.inst.x;
			var newy = this.inst.y;
			this.inst.set_bbox_changed();
			collobj = this.runtime.testOverlapSolid(this.inst);
			var fell_on_jumpthru = false;
			if (!collobj && (this.dy > 0) && !floor_)
			{
				allover = this.fallthrough > 0 ? null : this.runtime.testOverlapJumpThru(this.inst, true);
				if (allover && allover.length)
				{
					if (this.wasOverJumpthru)
					{
						this.inst.x = oldx;
						this.inst.y = oldy;
						this.inst.set_bbox_changed();
						for (i = 0, j = 0, len = allover.length; i < len; i++)
						{
							allover[j] = allover[i];
							if (!this.runtime.testOverlap(this.inst, allover[i]))
								j++;
						}
						allover.length = j;
						this.inst.x = newx;
						this.inst.y = newy;
						this.inst.set_bbox_changed();
					}
					if (allover.length >= 1)
						collobj = allover[0];
				}
				fell_on_jumpthru = !!collobj;
			}
			if (collobj)
			{
				this.runtime.registerCollision(this.inst, collobj);
				var push_dist = (fell_on_jumpthru ? Math.abs(this.dy * dt * 2.5 + 10) : Math.max(Math.abs(this.dy * dt * 2.5 + 10), 30));
				if (!this.runtime.pushOutSolid(this.inst, this.downx * (this.dy < 0 ? 1 : -1), this.downy * (this.dy < 0 ? 1 : -1), push_dist, fell_on_jumpthru, collobj))
				{
					this.inst.x = oldx;
					this.inst.y = oldy;
					this.inst.set_bbox_changed();
					this.wasOnFloor = true;		// prevent adjustment for unexpected floor landings
					if (!fell_on_jumpthru)
						this.dy = 0;	// stop
				}
				else
				{
					this.lastFloorObject = collobj;
					this.lastFloorX = collobj.x;
					this.lastFloorY = collobj.y;
					this.floorIsJumpthru = fell_on_jumpthru;
					if (fell_on_jumpthru)
						landed = true;
					this.dy = 0;	// stop
				}
			}
		}
		if (this.animMode !== ANIMMODE_FALLING && this.dy > 0 && !floor_)
		{
			this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnFall, this.inst);
			this.animMode = ANIMMODE_FALLING;
		}
		if (floor_ || landed)
		{
			if (this.animMode === ANIMMODE_FALLING || landed || (jump && this.dy === 0))
			{
				this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnLand, this.inst);
				if (this.dx === 0 && this.dy === 0)
					this.animMode = ANIMMODE_STOPPED;
				else
					this.animMode = ANIMMODE_MOVING;
			}
			else
			{
				if (this.animMode !== ANIMMODE_STOPPED && this.dx === 0 && this.dy === 0)
				{
					this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnStop, this.inst);
					this.animMode = ANIMMODE_STOPPED;
				}
				if (this.animMode !== ANIMMODE_MOVING && (this.dx !== 0 || this.dy !== 0) && !jump)
				{
					this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnMove, this.inst);
					this.animMode = ANIMMODE_MOVING;
				}
			}
		}
		if (this.fallthrough > 0)
			this.fallthrough--;
		this.wasOverJumpthru = this.runtime.testOverlapJumpThru(this.inst);
	};
	function Cnds() {};
	Cnds.prototype.IsMoving = function ()
	{
		return this.dx !== 0 || this.dy !== 0;
	};
	Cnds.prototype.CompareSpeed = function (cmp, s)
	{
		var speed = Math.sqrt(this.dx * this.dx + this.dy * this.dy);
		return cr.do_cmp(speed, cmp, s);
	};
	Cnds.prototype.IsOnFloor = function ()
	{
		if (this.dy !== 0)
			return false;
		var ret = null;
		var ret2 = null;
		var i, len, j;
		var oldx = this.inst.x;
		var oldy = this.inst.y;
		this.inst.x += this.downx;
		this.inst.y += this.downy;
		this.inst.set_bbox_changed();
		ret = this.runtime.testOverlapSolid(this.inst);
		if (!ret && this.fallthrough === 0)
			ret2 = this.runtime.testOverlapJumpThru(this.inst, true);
		this.inst.x = oldx;
		this.inst.y = oldy;
		this.inst.set_bbox_changed();
		if (ret)		// was overlapping solid
		{
			return !this.runtime.testOverlap(this.inst, ret);
		}
		if (ret2 && ret2.length)
		{
			for (i = 0, j = 0, len = ret2.length; i < len; i++)
			{
				ret2[j] = ret2[i];
				if (!this.runtime.testOverlap(this.inst, ret2[i]))
					j++;
			}
			if (j >= 1)
				return true;
		}
		return false;
	};
	Cnds.prototype.IsByWall = function (side)
	{
		var ret = false;
		var oldx = this.inst.x;
		var oldy = this.inst.y;
		this.inst.x -= this.downx * 3;
		this.inst.y -= this.downy * 3;
		this.inst.set_bbox_changed();
		if (this.runtime.testOverlapSolid(this.inst))
		{
			this.inst.x = oldx;
			this.inst.y = oldy;
			this.inst.set_bbox_changed();
			return false;
		}
		if (side === 0)		// left
		{
			this.inst.x -= this.rightx * 2;
			this.inst.y -= this.righty * 2;
		}
		else
		{
			this.inst.x += this.rightx * 2;
			this.inst.y += this.righty * 2;
		}
		this.inst.set_bbox_changed();
		ret = this.runtime.testOverlapSolid(this.inst);
		this.inst.x = oldx;
		this.inst.y = oldy;
		this.inst.set_bbox_changed();
		return ret;
	};
	Cnds.prototype.IsJumping = function ()
	{
		return this.dy < 0;
	};
	Cnds.prototype.IsFalling = function ()
	{
		return this.dy > 0;
	};
	Cnds.prototype.OnJump = function ()
	{
		return true;
	};
	Cnds.prototype.OnFall = function ()
	{
		return true;
	};
	Cnds.prototype.OnStop = function ()
	{
		return true;
	};
	Cnds.prototype.OnMove = function ()
	{
		return true;
	};
	Cnds.prototype.OnLand = function ()
	{
		return true;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetIgnoreInput = function (ignoring)
	{
		this.ignoreInput = ignoring;
	};
	Acts.prototype.SetMaxSpeed = function (maxspeed)
	{
		this.maxspeed = maxspeed;
		if (this.maxspeed < 0)
			this.maxspeed = 0;
	};
	Acts.prototype.SetAcceleration = function (acc)
	{
		this.acc = acc;
		if (this.acc < 0)
			this.acc = 0;
	};
	Acts.prototype.SetDeceleration = function (dec)
	{
		this.dec = dec;
		if (this.dec < 0)
			this.dec = 0;
	};
	Acts.prototype.SetJumpStrength = function (js)
	{
		this.jumpStrength = js;
		if (this.jumpStrength < 0)
			this.jumpStrength = 0;
	};
	Acts.prototype.SetGravity = function (grav)
	{
		if (this.g1 === grav)
			return;		// no change
		this.g = grav;
		this.updateGravity();
		if (this.runtime.testOverlapSolid(this.inst))
		{
			this.runtime.pushOutSolid(this.inst, this.downx, this.downy, 10);
			this.inst.x += this.downx * 2;
			this.inst.y += this.downy * 2;
			this.inst.set_bbox_changed();
		}
		this.lastFloorObject = null;
	};
	Acts.prototype.SetMaxFallSpeed = function (mfs)
	{
		this.maxFall = mfs;
		if (this.maxFall < 0)
			this.maxFall = 0;
	};
	Acts.prototype.SimulateControl = function (ctrl)
	{
		switch (ctrl) {
		case 0:		this.simleft = true;	break;
		case 1:		this.simright = true;	break;
		case 2:		this.simjump = true;	break;
		}
	};
	Acts.prototype.SetVectorX = function (vx)
	{
		this.dx = vx;
	};
	Acts.prototype.SetVectorY = function (vy)
	{
		this.dy = vy;
	};
	Acts.prototype.SetGravityAngle = function (a)
	{
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (this.ga === a)
			return;		// no change
		this.ga = a;
		this.updateGravity();
		this.lastFloorObject = null;
	};
	Acts.prototype.SetEnabled = function (en)
	{
		if (this.enabled !== (en === 1))
		{
			this.enabled = (en === 1);
			if (!this.enabled)
				this.lastFloorObject = null;
		}
	};
	Acts.prototype.FallThrough = function ()
	{
		var oldx = this.inst.x;
		var oldy = this.inst.y;
		this.inst.x += this.downx;
		this.inst.y += this.downy;
		this.inst.set_bbox_changed();
		var overlaps = this.runtime.testOverlapJumpThru(this.inst, false);
		this.inst.x = oldx;
		this.inst.y = oldy;
		this.inst.set_bbox_changed();
		if (!overlaps)
			return;
		this.fallthrough = 3;			// disable jumpthrus for 3 ticks (1 doesn't do it, 2 does, 3 to be on safe side)
		this.lastFloorObject = null;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Speed = function (ret)
	{
		ret.set_float(Math.sqrt(this.dx * this.dx + this.dy * this.dy));
	};
	Exps.prototype.MaxSpeed = function (ret)
	{
		ret.set_float(this.maxspeed);
	};
	Exps.prototype.Acceleration = function (ret)
	{
		ret.set_float(this.acc);
	};
	Exps.prototype.Deceleration = function (ret)
	{
		ret.set_float(this.dec);
	};
	Exps.prototype.JumpStrength = function (ret)
	{
		ret.set_float(this.jumpStrength);
	};
	Exps.prototype.Gravity = function (ret)
	{
		ret.set_float(this.g);
	};
	Exps.prototype.GravityAngle = function (ret)
	{
		ret.set_float(cr.to_degrees(this.ga));
	};
	Exps.prototype.MaxFallSpeed = function (ret)
	{
		ret.set_float(this.maxFall);
	};
	Exps.prototype.MovingAngle = function (ret)
	{
		ret.set_float(cr.to_degrees(Math.atan2(this.dy, this.dx)));
	};
	Exps.prototype.VectorX = function (ret)
	{
		ret.set_float(this.dx);
	};
	Exps.prototype.VectorY = function (ret)
	{
		ret.set_float(this.dy);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Rotate = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Rotate.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.speed = cr.to_radians(this.properties[0]);
		this.acc = cr.to_radians(this.properties[1]);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"speed": this.speed,
			"acc": this.acc
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.speed = o["speed"];
		this.acc = o["acc"];
	};
	behinstProto.tick = function ()
	{
		var dt = this.runtime.getDt(this.inst);
		if (dt === 0)
			return;
		if (this.acc !== 0)
			this.speed += this.acc * dt;
		if (this.speed !== 0)
		{
			this.inst.angle = cr.clamp_angle(this.inst.angle + this.speed * dt);
			this.inst.set_bbox_changed();
		}
	};
	function Cnds() {};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetSpeed = function (s)
	{
		this.speed = cr.to_radians(s);
	};
	Acts.prototype.SetAcceleration = function (a)
	{
		this.acc = cr.to_radians(a);
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Speed = function (ret)
	{
		ret.set_float(cr.to_degrees(this.speed));
	};
	Exps.prototype.Acceleration = function (ret)
	{
		ret.set_float(cr.to_degrees(this.acc));
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Sin = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Sin.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
		this.i = 0;		// period offset (radians)
	};
	var behinstProto = behaviorProto.Instance.prototype;
	var _2pi = 2 * Math.PI;
	var _pi_2 = Math.PI / 2;
	var _3pi_2 = (3 * Math.PI) / 2;
	behinstProto.onCreate = function()
	{
		this.active = (this.properties[0] === 1);
		this.movement = this.properties[1]; // 0=Horizontal|1=Vertical|2=Size|3=Width|4=Height|5=Angle|6=Opacity|7=Value only
		this.wave = this.properties[2];		// 0=Sine|1=Triangle|2=Sawtooth|3=Reverse sawtooth|4=Square
		this.period = this.properties[3];
		this.period += Math.random() * this.properties[4];								// period random
		if (this.period === 0)
			this.i = 0;
		else
		{
			this.i = (this.properties[5] / this.period) * _2pi;								// period offset
			this.i += ((Math.random() * this.properties[6]) / this.period) * _2pi;			// period offset random
		}
		this.mag = this.properties[7];													// magnitude
		this.mag += Math.random() * this.properties[8];									// magnitude random
		this.initialValue = 0;
		this.initialValue2 = 0;
		this.ratio = 0;
		this.init();
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"i": this.i,
			"a": this.active,
			"mv": this.movement,
			"w": this.wave,
			"p": this.period,
			"mag": this.mag,
			"iv": this.initialValue,
			"iv2": this.initialValue2,
			"r": this.ratio,
			"lkv": this.lastKnownValue,
			"lkv2": this.lastKnownValue2
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.i = o["i"];
		this.active = o["a"];
		this.movement = o["mv"];
		this.wave = o["w"];
		this.period = o["p"];
		this.mag = o["mag"];
		this.initialValue = o["iv"];
		this.initialValue2 = o["iv2"] || 0;
		this.ratio = o["r"];
		this.lastKnownValue = o["lkv"];
		this.lastKnownValue2 = o["lkv2"] || 0;
	};
	behinstProto.init = function ()
	{
		switch (this.movement) {
		case 0:		// horizontal
			this.initialValue = this.inst.x;
			break;
		case 1:		// vertical
			this.initialValue = this.inst.y;
			break;
		case 2:		// size
			this.initialValue = this.inst.width;
			this.ratio = this.inst.height / this.inst.width;
			break;
		case 3:		// width
			this.initialValue = this.inst.width;
			break;
		case 4:		// height
			this.initialValue = this.inst.height;
			break;
		case 5:		// angle
			this.initialValue = this.inst.angle;
			this.mag = cr.to_radians(this.mag);		// convert magnitude from degrees to radians
			break;
		case 6:		// opacity
			this.initialValue = this.inst.opacity;
			break;
		case 7:
			this.initialValue = 0;
			break;
		case 8:		// forwards/backwards
			this.initialValue = this.inst.x;
			this.initialValue2 = this.inst.y;
			break;
		default:
;
		}
		this.lastKnownValue = this.initialValue;
		this.lastKnownValue2 = this.initialValue2;
	};
	behinstProto.waveFunc = function (x)
	{
		x = x % _2pi;
		switch (this.wave) {
		case 0:		// sine
			return Math.sin(x);
		case 1:		// triangle
			if (x <= _pi_2)
				return x / _pi_2;
			else if (x <= _3pi_2)
				return 1 - (2 * (x - _pi_2) / Math.PI);
			else
				return (x - _3pi_2) / _pi_2 - 1;
		case 2:		// sawtooth
			return 2 * x / _2pi - 1;
		case 3:		// reverse sawtooth
			return -2 * x / _2pi + 1;
		case 4:		// square
			return x < Math.PI ? -1 : 1;
		};
		return 0;
	};
	behinstProto.tick = function ()
	{
		var dt = this.runtime.getDt(this.inst);
		if (!this.active || dt === 0)
			return;
		if (this.period === 0)
			this.i = 0;
		else
		{
			this.i += (dt / this.period) * _2pi;
			this.i = this.i % _2pi;
		}
		switch (this.movement) {
		case 0:		// horizontal
			if (this.inst.x !== this.lastKnownValue)
				this.initialValue += this.inst.x - this.lastKnownValue;
			this.inst.x = this.initialValue + this.waveFunc(this.i) * this.mag;
			this.lastKnownValue = this.inst.x;
			break;
		case 1:		// vertical
			if (this.inst.y !== this.lastKnownValue)
				this.initialValue += this.inst.y - this.lastKnownValue;
			this.inst.y = this.initialValue + this.waveFunc(this.i) * this.mag;
			this.lastKnownValue = this.inst.y;
			break;
		case 2:		// size
			this.inst.width = this.initialValue + this.waveFunc(this.i) * this.mag;
			this.inst.height = this.inst.width * this.ratio;
			break;
		case 3:		// width
			this.inst.width = this.initialValue + this.waveFunc(this.i) * this.mag;
			break;
		case 4:		// height
			this.inst.height = this.initialValue + this.waveFunc(this.i) * this.mag;
			break;
		case 5:		// angle
			if (this.inst.angle !== this.lastKnownValue)
				this.initialValue = cr.clamp_angle(this.initialValue + (this.inst.angle - this.lastKnownValue));
			this.inst.angle = cr.clamp_angle(this.initialValue + this.waveFunc(this.i) * this.mag);
			this.lastKnownValue = this.inst.angle;
			break;
		case 6:		// opacity
			this.inst.opacity = this.initialValue + (this.waveFunc(this.i) * this.mag) / 100;
			if (this.inst.opacity < 0)
				this.inst.opacity = 0;
			else if (this.inst.opacity > 1)
				this.inst.opacity = 1;
			break;
		case 8:		// forwards/backwards
			if (this.inst.x !== this.lastKnownValue)
				this.initialValue += this.inst.x - this.lastKnownValue;
			if (this.inst.y !== this.lastKnownValue2)
				this.initialValue2 += this.inst.y - this.lastKnownValue2;
			this.inst.x = this.initialValue + Math.cos(this.inst.angle) * this.waveFunc(this.i) * this.mag;
			this.inst.y = this.initialValue2 + Math.sin(this.inst.angle) * this.waveFunc(this.i) * this.mag;
			this.lastKnownValue = this.inst.x;
			this.lastKnownValue2 = this.inst.y;
			break;
		}
		this.inst.set_bbox_changed();
	};
	behinstProto.onSpriteFrameChanged = function (prev_frame, next_frame)
	{
		switch (this.movement) {
		case 2:	// size
			this.initialValue *= (next_frame.width / prev_frame.width);
			this.ratio = next_frame.height / next_frame.width;
			break;
		case 3:	// width
			this.initialValue *= (next_frame.width / prev_frame.width);
			break;
		case 4:	// height
			this.initialValue *= (next_frame.height / prev_frame.height);
			break;
		}
	};
	function Cnds() {};
	Cnds.prototype.IsActive = function ()
	{
		return this.active;
	};
	Cnds.prototype.CompareMovement = function (m)
	{
		return this.movement === m;
	};
	Cnds.prototype.ComparePeriod = function (cmp, v)
	{
		return cr.do_cmp(this.period, cmp, v);
	};
	Cnds.prototype.CompareMagnitude = function (cmp, v)
	{
		if (this.movement === 5)
			return cr.do_cmp(this.mag, cmp, cr.to_radians(v));
		else
			return cr.do_cmp(this.mag, cmp, v);
	};
	Cnds.prototype.CompareWave = function (w)
	{
		return this.wave === w;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetActive = function (a)
	{
		this.active = (a === 1);
	};
	Acts.prototype.SetPeriod = function (x)
	{
		this.period = x;
	};
	Acts.prototype.SetMagnitude = function (x)
	{
		this.mag = x;
		if (this.movement === 5)	// angle
			this.mag = cr.to_radians(this.mag);
	};
	Acts.prototype.SetMovement = function (m)
	{
		if (this.movement === 5)
			this.mag = cr.to_degrees(this.mag);
		this.movement = m;
		this.init();
	};
	Acts.prototype.SetWave = function (w)
	{
		this.wave = w;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.CyclePosition = function (ret)
	{
		ret.set_float(this.i / _2pi);
	};
	Exps.prototype.Period = function (ret)
	{
		ret.set_float(this.period);
	};
	Exps.prototype.Magnitude = function (ret)
	{
		if (this.movement === 5)	// angle
			ret.set_float(cr.to_degrees(this.mag));
		else
			ret.set_float(this.mag);
	};
	Exps.prototype.Value = function (ret)
	{
		ret.set_float(this.waveFunc(this.i) * this.mag);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.solid = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.solid.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.inst.extra.solidEnabled = (this.properties[0] !== 0);
	};
	behinstProto.tick = function ()
	{
	};
	function Cnds() {};
	Cnds.prototype.IsEnabled = function ()
	{
		return this.inst.extra.solidEnabled;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetEnabled = function (e)
	{
		this.inst.extra.solidEnabled = !!e;
	};
	behaviorProto.acts = new Acts();
}());
cr.getProjectModel = function() { return [
	null,
	"Loading",
	[
	[
		cr.plugins_.Audio,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.CJSAds,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Browser,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.CJSBackButton,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.TiledBg,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.WebStorage,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Touch,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Function,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Particles,
		false,
		true,
		true,
		false,
		true,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.Sprite,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		false
	]
,	[
		cr.plugins_.Spritefont2,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		true
	]
	],
	[
	[
		"t0",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			20,
			true,
			1,
			0,
			false,
			201986243071844,
			[
				["2x-sheet0.png", 1120, 0, 0, 32, 16, 1, 0.5333333611488342, 0.5714285969734192,[],[],0],
				["2x-sheet0.png", 1120, 0, 16, 32, 16, 1, 0.5, 0.5,[],[],0],
				["2x-sheet1.png", 1065, 0, 0, 30, 14, 1, 0.4666666686534882, 0.5714285969734192,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		5390316932519152,
		[],
		null
	]
,	[
		"t1",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			1484370846431713,
			[
				["best-sheet0.png", 7256, 0, 0, 103, 38, 1, 0.5048543810844421, 0.5263158082962036,[],[-0.4321270883083344,-0.3318718075752258,-0.006153374910354614,-0.1443718075752258,0.3886516094207764,-0.2415938079357147,0.4613796472549439,-0.02631580829620361,0.4639766216278076,0.3903511762619019,-0.006153374910354614,0.4181281924247742,-0.4814777672290802,0.4111841320991516,-0.5048543810844421,-0.02631580829620361],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			2029207805399205
		]
		],
		false,
		false,
		6182056198159878,
		[],
		null
	]
,	[
		"t2",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			1678195385321695,
			[
				["home_button-sheet0.png", 13609, 0, 0, 82, 74, 1, 0.5121951103210449, 0.5,[],[-0.4673675000667572,-0.4503816962242127,-0.01219511032104492,-0.4923664033412933,0.4395288825035095,-0.4465649127960205,0.4843568801879883,0,0.4395288825035095,0.4465649724006653,-0.01219511032104492,0.4885500073432922,-0.4639192223548889,0.4465649724006653,-0.5121951103210449,0],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			6131849254365432
		]
		],
		false,
		false,
		9642968418104188,
		[],
		null
	]
,	[
		"t3",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			7697609952664989,
			[
				["shop_button-sheet0.png", 29591, 0, 0, 131, 108, 1, 0.5038167834281921, 0.5,[],[-0.446596086025238,-0.4304636120796204,-0.005178779363632202,-0.5,0.4362372159957886,-0.4271523058414459,0.4798341989517212,0,0.4280632138252258,0.4172189831733704,-0.005178779363632202,0.4768210053443909,-0.4356968998908997,0.4172189831733704,-0.4929175972938538,0],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			680838777397814
		]
		],
		false,
		false,
		3873591260268581,
		[],
		null
	]
,	[
		"t4",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			8791901507777297,
			[
				["leaderboardbutton-sheet0.png", 50955, 0, 0, 215, 122, 1, 0.5023255944252014, 0.5,[],[-0.4726226031780243,-0.4470587968826294,-0.002325594425201416,-0.5,0.4679713845252991,-0.4470587968826294,0.4976744055747986,0,0.4300174117088318,0.3794119954109192,-0.002325594425201416,0.4823529720306397,-0.434668779373169,0.3794119954109192,-0.5023255944252014,0],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			9251034827738601
		]
		],
		false,
		false,
		3279843330409194,
		[],
		null
	]
,	[
		"t5",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			8718647109184771,
			[
				["retry_button-sheet0.png", 52955, 0, 0, 228, 110, 1, 0.5, 0.5090909004211426,[],[-0.4689655005931854,-0.445033997297287,0,-0.5055322051048279,0.468966007232666,-0.445033997297287,0.5,-0.01086989045143127,0.468966007232666,0.4268521070480347,0,0.4873501062393189,-0.4689655005931854,0.4268521070480347,-0.5,-0.01086989045143127],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			1589096172482287
		]
		],
		false,
		false,
		7809487601117954,
		[],
		null
	]
,	[
		"t6",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["cristal_display.png", 13556, 0],
		null,
		[
		],
		false,
		false,
		880804450642471,
		[],
		null
	]
,	[
		"t7",
		cr.plugins_.Spritefont2,
		false,
		[],
		1,
		0,
		["cristal_display.png", 13556, 0],
		null,
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4897643817431336
		]
		],
		false,
		false,
		4854960889729214,
		[],
		null
	]
,	[
		"t8",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["distance_display.png", 12786, 0],
		null,
		[
		],
		false,
		false,
		6147212796201066,
		[],
		null
	]
,	[
		"t9",
		cr.plugins_.Spritefont2,
		false,
		[],
		1,
		0,
		["distance_score.png", 14855, 0],
		null,
		[
		[
			"Pin",
			cr.behaviors.Pin,
			9012566723757207
		]
		],
		false,
		false,
		2327846679926497,
		[],
		null
	]
,	[
		"t10",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9024971690076487,
			[
				["sprite4-sheet0.png", 783, 0, 0, 20, 30, 1, 0.5, 0.5,[],[-0.1599999964237213,-0.2733330130577087,0,-0.4266667068004608,0.1600000262260437,-0.2733330130577087,0.4100000262260437,0,0.1600000262260437,0.2733330130577087,0,0.4200000166893005,-0.4000000059604645,0],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4754537049320798
		]
		],
		false,
		false,
		3558074220047105,
		[],
		null
	]
,	[
		"t11",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			8162148739809198,
			[
				["air_01_fase01-sheet0.png", 2259, 0, 0, 90, 72, 1, 0.5111111402511597, 0.5,[["Imagepoint 1", 0.5111111402511597, -0.0416666679084301]],[-0.4111111462116242,-0.1944440007209778,0.3555558323860169,-0.1944440007209778,-1.192092895507813e-007,-0.1111110150814056],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			3823120699068865
		]
		],
		false,
		false,
		8622679875217481,
		[],
		null
	]
,	[
		"t12",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			9424419820828613,
			[
				["air_02_fase01-sheet0.png", 2133, 0, 0, 90, 72, 1, 0.5111111402511597, 0.5833333134651184,[["Imagepoint 1", 1, 0.1944444477558136]],[0.4777778387069702,-0.05555528402328491,0.01111084222793579,0.02777767181396484,-0.4888889491558075,-0.05555528402328491],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			923867452457598
		]
		],
		false,
		false,
		7102628172796641,
		[],
		null
	]
,	[
		"t13",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			2341446591484197,
			[
				["air_03_fase01-sheet0.png", 1976, 0, 0, 90, 72, 1, 0.5111111402511597, 0.3888888955116272,[["Imagepoint 1", 0.6333333253860474, -0.1388888955116272]],[-0.4222222566604614,-0.1111108958721161,0.3999998569488525,-0.1527778953313828,0.01111084222793579,-0.05555590987205505],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			4395948478073783
		]
		],
		false,
		false,
		2643044750240702,
		[],
		null
	]
,	[
		"t14",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			1648061637113245,
			[
				["air_04_fase01-sheet0.png", 1169, 0, 0, 71, 32, 1, 0.5211267471313477, 0.46875,[["Imagepoint 1", 0.5352112650871277, -0.25]],[0.3943662643432617,-0.15625,-0.01408475637435913,0.09375,-0.4507041573524475,-0.09375],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			6667670198801562
		]
		],
		false,
		false,
		5356421359674671,
		[],
		null
	]
,	[
		"t15",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3162327132930229,
			[
				["transacao01-sheet0.png", 28820, 0, 0, 250, 160, 1, 0.5, 0,[],[-0.3019999861717224,0.309374988079071,0,0,0.2509999871253967,0.3890619874000549,0.2549999952316284,0.5,0.300000011920929,0.6874999403953552,0,1,-0.3400000035762787,0.75,-0.3009999990463257,0.5],0]
			]
			]
		],
		[
		],
		false,
		false,
		4081710183655344,
		[],
		null
	]
,	[
		"t16",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2577267236322911,
			[
				["chao01_fase01-sheet0.png", 67225, 0, 0, 550, 320, 1, 0, 0,[],[0,0.668749988079071,0.7981820106506348,0.668749988079071,0.8781819939613342,0.7906249761581421,0,1],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			7046997805535898
		]
		],
		false,
		false,
		3411820148721557,
		[],
		null
	]
,	[
		"t17",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			9909836784642048,
			[
				["chao02_fase01-sheet0.png", 23939, 0, 0, 589, 150, 1, 0, 0,[["air_01", 0.1426146030426025, -0.5933333039283752],["air_02", 0.392190158367157, -0.9200000166893005],["air_03", 0.7079796195030212, -0.8733333349227905],["air_04", 0.9643463492393494, -0.5533333420753479],["cristal_spawn01", 0.4312393963336945, 0.3333333432674408],["cristal_spawn02", 0.7368420958518982, 0.2133333384990692],["cristal_spawn03", 0.1782682538032532, 0.4866666793823242]],[0.07809849828481674,0.5400000214576721,0.1697790026664734,0.6866670250892639,0.2640070021152496,0.6533330082893372,0.3994059860706329,0.5133330225944519,0.5619699954986572,0.5133330225944519,0.6867570281028748,0.3533329963684082,0.8556879758834839,0.5133330225944519,0.4533109962940216,0.9800000190734863,0.1069609969854355,0.7200000286102295,0.01358230039477348,0.5933330059051514],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			6026047652182319
		]
		],
		false,
		false,
		7428076538396798,
		[],
		null
	]
,	[
		"t18",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			255851599196589,
			[
				["chao03_fase01-sheet0.png", 43496, 0, 0, 571, 102, 1, 0.001751313451677561, 0.009803921915590763,[["air_01", 0.07180385291576386, -0.8333333134651184],["air_02", 0.2521891295909882, -1.117647051811218],["air_03", 0.5481611490249634, -1.176470637321472],["air_04", 0.793345034122467, -1.078431367874146],["cristal_spawn01", 0.1173380017280579, 0.3039215803146362],["cristal_spawn02", 0.2714535892009735, 0.1862745136022568],["cristal_spawn03", 0.4921191036701202, 0.147058829665184],["cristal_spawn04", 0.7250437736511231, 0.1078431382775307]],[0.04203158617019653,0.3725490868091583,0.1199646890163422,0.5490200519561768,0.2504377067089081,0.3529410660266876,0.3239936828613281,0.3921570777893066,0.4185636937618256,0.22549007833004,0.5411556959152222,0.4411760866641998,0.7250437140464783,0.2352940738201141,0.8423817157745361,0.4313720762729645,0.9737306833267212,0.1568630784749985,0.6987736821174622,0.9803920388221741,0.228546679019928,0.9803920388221741,0.01050788722932339,0.411765068769455],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			9068789026483023
		]
		],
		false,
		false,
		1378912188723754,
		[],
		null
	]
,	[
		"t19",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			8284196356758604,
			[
				["chao04_fase01-sheet0.png", 97968, 0, 0, 821, 320, 1, 0, 0,[["air_01", 0.06090134009718895, 0.46875],["air_02", 0.2228989005088806, 0.315625011920929],["air_03", 0.4031668603420258, 0.21875],["air_04", 0.986601710319519, 0.356249988079071],["cristal_spawn01", 0.185140073299408, 0.621874988079071],["cristal_spawn02", 0.3556638360023499, 0.6812499761581421],["cristal_spawn03", 0.5261875987052918, 0.668749988079071],["cristal_spawn04", 0.6772229075431824, 0.668749988079071]],[0.09987819939851761,0.7906249761581421,0.1686969995498657,0.6796870231628418,0.2236600071191788,0.6824219822883606,0.2786239981651306,0.7976559996604919,0.3252129852771759,0.784375011920929,0.3526189923286438,0.731249988079071,0.5359320044517517,0.7593749761581421,0.785627007484436,0.753125011920929,0.8824599981307983,0.6109380125999451,0.9180870056152344,0.627344012260437,0.7904989719390869,1,0.02436050027608872,0.8031250238418579],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			9409993052514585
		]
		],
		false,
		false,
		3191081602490388,
		[],
		null
	]
,	[
		"t20",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			9589323521805843,
			[
				["chao04_galho_fase01-sheet0.png", 364, 0, 0, 821, 320, 1, 0, 0,[],[0.5434569716453552,0.2612499892711639,0.8793950080871582,0.2037499994039536,0.7250980138778687,0.2450000047683716],3]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			7424174942536436
		]
		],
		false,
		false,
		4069059063285268,
		[],
		null
	]
,	[
		"t21",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			5751054118735817,
			[
				["chao05_fase01-sheet0.png", 71700, 0, 0, 650, 214, 1, 0, 0,[["air_01", -0.007692307699471712, -0.02803738228976727],["air_02", 0.3123076856136322, -0.1308411210775375],["air_03", 0.7769230604171753, 0.05140186846256256],["air_04", 0.9953846335411072, 0.1214953288435936],["cristal_spawn01", 0.1169230788946152, 0.336448609828949],["cristal_spawn02", 0.3292307555675507, 0.336448609828949],["cristal_spawn03", 0.4676923155784607, 0.336448609828949],["cristal_spawn04", 0.8153846263885498, 0.514018714427948],["teto", 0, 0]],[0.4723080098628998,0.696262001991272,0.5753849744796753,0.6308410167694092,0.6630769968032837,0.4672900140285492,0.7553849816322327,0.4953269958496094,0.7984619736671448,0.5911219716072083,0.8869230151176453,0.6927570104598999,0.9692310094833374,0.7009350061416626,0.699999988079071,1,0.01076919957995415,0.6822429895401001],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			7990439900252128
		]
		],
		false,
		false,
		980386634205827,
		[],
		null
	]
,	[
		"t22",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			7223221176093066,
			[
				["chao05_teto_fase01-sheet0.png", 241, 0, 0, 650, 214, 1, 0, 0,[],[0.1181759983301163,0.4621930122375488,0.1634159982204437,0.4461719989776611,0.2087019979953766,0.4773249924182892,0.491553008556366,0.4453819990158081,0.5917230248451233,0.406702995300293,0.6331019997596741,0.3455640077590942,0.5912619829177856,0.3990040123462677,0.4916679859161377,0.4349550008773804,0.2097640037536621,0.4744940102100372,0.1632180064916611,0.4404290020465851,0.1181669980287552,0.4554339945316315,0.06614969670772553,0.4540829956531525],3]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			3778805248845297
		]
		],
		false,
		false,
		7662962321330484,
		[],
		null
	]
,	[
		"t23",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			7408305497233268,
			[
				["chao06_galho01_fase01-sheet0.png", 347, 0, 0, 884, 280, 1, 0, 0,[],[0.2941380143165588,0.4775710105895996,0.3284449875354767,0.3817859888076782,0.4338859915733337,0.3679290115833283,0.3305090069770813,0.3844999969005585,0.2948980033397675,0.4787859916687012,0.2724440097808838,0.4767139852046967],3]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			6732993569624899
		]
		],
		false,
		false,
		2612694981094663,
		[],
		null
	]
,	[
		"t24",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			5085691341262772,
			[
				["chao06_galho01_fase01-sheet0.png", 347, 0, 0, 884, 280, 1, 0, 0,[],[0.548583984375,0.3937140107154846,0.5288680195808411,0.3545889854431152,0.4918450117111206,0.3447499871253967,0.5291010141372681,0.3574639856815338,0.5488110184669495,0.3981960117816925,0.7637220025062561,0.4011070132255554,0.7370439767837524,0.3935360014438629,0.7168009877204895,0.3758569955825806],3]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			7990086420304804
		]
		],
		false,
		false,
		3614957816891348,
		[],
		null
	]
,	[
		"t25",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			2026836359310261,
			[
				["chao06_galho01_fase01-sheet0.png", 347, 0, 0, 884, 280, 1, 0, 0,[],[0.4634569883346558,0.1742140054702759,0.6267669796943665,0.2062859982252121,0.8428720235824585,0.1573030054569244,0.7010989785194397,0.1666869968175888,0.6587619781494141,0.1486299932003021,0.618848979473114,0.17535699903965,0.5846379995346069,0.1588570028543472],3]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			2022277590693705
		]
		],
		false,
		false,
		454719141920717,
		[],
		null
	]
,	[
		"t26",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			8347630493954901,
			[
				["chao06_fase01-sheet0.png", 30365, 0, 0, 884, 280, 1, 0, 0,[["Imagepoint 1", -0.009049774147570133, -0.5142857432365418],["Imagepoint 2", -0.009049774147570133, -0.5142857432365418],["air_01", 0.08484163135290146, 0.1928571462631226],["air_02", 0.3156108558177948, -0.03214285895228386],["cristal_spawn01", 0.5158371329307556, 0.08214285969734192],["cristal_spawn02", 0.3325791954994202, 0.3392857015132904],["cristal_spawn03", 0.7466063499450684, 0.125],["cristal_spawn04", 0.1289592832326889, 0.4714285731315613],["air_03", 0.5, -0.3535714149475098],["air_04", 0.9151583909988403, -0.1892857104539871]],[0.1527149975299835,0.5285710096359253,0.2002259939908981,0.5196430087089539,0.2539590001106262,0.6116070151329041,0.7907249927520752,0.6178569793701172,0.8710409998893738,0.4642859995365143,0.9106330275535584,0.4214290082454681,0.930994987487793,0.4946430027484894,0.5373299717903137,1,0.01470590010285378,0.682142972946167,0.07805430144071579,0.682142972946167],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			7870475845737105
		]
		],
		false,
		false,
		9575625808645152,
		[],
		null
	]
,	[
		"t27",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			2767857825489969,
			[
				["chao01_fase02-sheet0.png", 9819, 0, 0, 373, 175, 1, 0, 0,[["Imagepoint 1", 0.5013405084609985, 0.5028571486473084],["Imagepoint 2", 0.5013405084609985, 0.5028571486473084],["Imagepoint 3", 0.5013405084609985, 0.5028571486473084],["Imagepoint 4", 0.5013405084609985, 0.5028571486473084],["cristal_spawn01", 0.08310992270708084, 0.3085714280605316],["cristal_spawn01", 0.302949070930481, 0.3085714280605316],["cristal_spawn01", 0.8310992121696472, -0.2000000029802322]],[0.4343160092830658,0.4971430003643036,0.573727011680603,0.3600000143051148,0.766755998134613,0.01714280061423779,0.8525469899177551,0.01714299991726875,0.978551983833313,0.9542859792709351,0.4986599981784821,0.5314289927482605,0.2198390066623688,0.5314289927482605,0.008042899891734123,0.4971430003643036],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			9229482771657724
		]
		],
		false,
		false,
		1470250000859844,
		[],
		null
	]
,	[
		"t28",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			6171937613119266,
			[
				["chao02_fase02-sheet0.png", 18055, 0, 0, 418, 220, 1, 0, 0,[["Imagepoint 1", 0.5, 0.5],["Imagepoint 2", 0.5, 0.5],["Imagepoint 3", 0.5, 0.5],["Imagepoint 4", 0.5, 0.5],["cristal_spawn", 0.1052631586790085, 0.3136363625526428],["cristal_spawn", 0.2942583858966827, 0.3545454442501068],["cristal_spawn", 0.5574162602424622, 0.3545454442501068],["cristal_spawn", 0.760765552520752, 0.1272727251052856]],[0.3205739855766296,0.4227269887924194,0.6507179737091065,0.418181985616684,0.9377989768981934,0.3772729933261871,0.9521530270576477,0.5,0.9952149987220764,0.9909089803695679,0.5,0.4727270007133484,0.007177030202001333,0.9863640069961548,0.03827749937772751,0.4045459926128388],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			2364869556671873
		]
		],
		false,
		false,
		8052652792351409,
		[],
		null
	]
,	[
		"t29",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			4057303321819198,
			[
				["chao03_fase02-sheet0.png", 15000, 0, 0, 468, 225, 1, 0, 0,[["Imagepoint 1", 0.5, 0.5022222399711609],["Imagepoint 2", 0.5, 0.5022222399711609],["Imagepoint 3", 0.5, 0.5022222399711609],["Imagepoint 4", 0.5, 0.5022222399711609],["cristal_spawn", 0.1089743599295616, 0.4000000059604645],["cristal_spawn", 0.252136766910553, 0.2800000011920929],["cristal_spawn", 0.5299145579338074, 0.2711111009120941],["cristal_spawn", 1.042735099792481, 0.2800000011920929]],[0.1367519944906235,0.5422220230102539,0.2585470080375671,0.5955550074577332,0.4209389984607697,0.5400000214576721,0.4807679951190949,0.4944440126419067,0.5726490020751953,0.4850000143051148,0.6773499846458435,0.5377780199050903,0.9764959812164307,0.5111110210418701,0.9401710033416748,0.8755559921264648,0.5,0.5911110043525696,0.01282049994915724,0.6888890266418457,0.04914529994130135,0.5777779817581177],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			8905399305208965
		]
		],
		false,
		false,
		798114399171137,
		[],
		null
	]
,	[
		"t30",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			7648435607584689,
			[
				["chao04_fase02-sheet0.png", 20171, 0, 0, 430, 217, 1, 0, 0,[["Imagepoint 1", 0.5, 0.5023041367530823],["Imagepoint 2", 0.5, 0.5023041367530823],["Imagepoint 3", 0.5, 0.5023041367530823],["Imagepoint 4", 0.5, 0.5023041367530823],["cristal_spawn", 0.0651162788271904, 0.4377880096435547],["cristal_spawn", 0.6860465407371521, 0.4930875599384308],["cristal_spawn", 0.2116279006004334, -0.06912442296743393],["cristal_spawn", 0.6558139324188232, -0.05069124326109886]],[0.9860460162162781,0.5852530002593994,0.1279069930315018,0.6543779969215393,0.01627909950911999,0.5299540162086487,0.1209300011396408,0.5622119903564453],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			8861676169285577
		]
		],
		false,
		false,
		6378042360883863,
		[],
		null
	]
,	[
		"t31",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			1554156294234302,
			[
				["chao04e06_teto_fase02-sheet0.png", 201, 0, 0, 436, 220, 1, 0, 0,[],[0.1582569926977158,0.104544997215271,0.2866970002651215,0.04090910032391548,0.5642200112342835,0.02272729948163033,0.8738530278205872,0.05000000074505806,0.369266003370285,0.05000000074505806],3]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			328801416414608
		]
		],
		false,
		false,
		3019125885417672,
		[],
		null
	]
,	[
		"t32",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			9191787655921612,
			[
				["chao05_fase02-sheet0.png", 9767, 0, 0, 370, 152, 1, 0, 0,[["Imagepoint 1", 0.5, 0.5],["Imagepoint 2", 0.5, 0.5],["Imagepoint 3", 0.5, 0.5],["Imagepoint 4", 0.5, 0.5],["cristal_spawn", 0.1297297328710556, 0.3486842215061188],["cristal_spawn", 0.410810798406601, 0.3486842215061188],["cristal_spawn", 0.9108108282089233, -0.2171052694320679],["cristal_spawn", 1.062162160873413, 0.2960526347160339]],[0.9972969889640808,0.5,0.4594590067863464,0.7039480209350586,0.01081079989671707,0.4736840128898621],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			7835120864891607
		]
		],
		false,
		false,
		5982397099539093,
		[],
		null
	]
,	[
		"t33",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			6894433266375828,
			[
				["chao05_fase02_teto-sheet0.png", 162, 0, 0, 370, 152, 1, 0, 0,[],[0.9351350069046021,0.02631580084562302,0.7972970008850098,0.08552639931440353,0.6594589948654175,0.105263002216816],3]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			1522415148610407
		]
		],
		false,
		false,
		5401218778564237,
		[],
		null
	]
,	[
		"t34",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			7388661730628988,
			[
				["chao06_fase02-sheet0.png", 21945, 0, 0, 436, 220, 1, 0, 0,[["Imagepoint 1", 0.5, 0.5],["Imagepoint 2", 0.5, 0.5],["Imagepoint 3", 0.5, 0.5],["Imagepoint 4", 0.5, 0.5],["cristal_spawn", 0.0229357797652483, 0.4863636493682861],["cristal_spawn", 0.7293577790260315, 0.5181818008422852],["cristal_spawn", 0.2018348574638367, -0.06818182021379471],["cristal_spawn", 0.6788991093635559, -0.07727272808551788]],[0.9839450120925903,0.5909090042114258,0.5,0.9954550266265869,0.01146790012717247,0.5681819915771484],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			1811433561199389
		]
		],
		false,
		false,
		3807868265970916,
		[],
		null
	]
,	[
		"t35",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2430526367506547,
			[
				["chao02_teto_fase03-sheet0.png", 24413, 0, 0, 446, 199, 1, 0, 0,[],[0.6973090171813965,0.251255989074707,0.9843050241470337,0.251255989074707,0.8340809941291809,0.2864319980144501],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			6059834365498265
		]
		],
		false,
		false,
		2649776946356822,
		[],
		null
	]
,	[
		"t36",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5975462889148516,
			[
				["chao02_fase03-sheet0.png", 24395, 0, 0, 446, 199, 1, 0, 0,[],[0.632286012172699,0.793969988822937,0.4798209965229034,0.9949749708175659,0.006726460065692663,0.7989950180053711],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			2883611068009531
		]
		],
		false,
		false,
		7007096690177762,
		[],
		null
	]
,	[
		"t37",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8664829888510196,
			[
				["chao03_fase03-sheet0.png", 42798, 0, 0, 854, 216, 1, 0, 0,[],[0.2377050071954727,0.2222220003604889,0.1124119982123375,0.6157410144805908,0.8255270123481751,0.6111109852790833,0.00819671992212534,0.8611109852790833,0.007025760132819414,0.2268519997596741],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			5587550178601218
		]
		],
		false,
		false,
		1372882774950204,
		[],
		null
	]
,	[
		"t38",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1019517551293882,
			[
				["chao01_fase03-sheet0.png", 61861, 0, 0, 871, 253, 1, 0, 0,[],[0.009184850379824638,0.778656005859375,0.8943740129470825,0.7826089859008789,0.4374279975891113,0.9960470199584961],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			1715144234224309
		]
		],
		false,
		false,
		4493496399133771,
		[],
		null
	]
,	[
		"t39",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3911308002061007,
			[
				["chao04_fase03-sheet0.png", 22820, 0, 0, 704, 157, 1, 0, 0,[],[0.1576700061559677,0.866241991519928,0.2585229873657227,0.6496819853782654,0.05823859944939613,0.656050980091095],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			8623221480451746
		]
		],
		false,
		false,
		7772975718477661,
		[],
		null
	]
,	[
		"t40",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3275817281296583,
			[
				["chao04_fase03_plat01-sheet0.png", 22829, 0, 0, 704, 157, 1, 0, 0,[],[0.5291020274162293,0.3248009979724884,0.8743749856948853,0.3215560019016266,0.690500020980835,0.4415209889411926],0]
			]
			]
		],
		[
		[
			"Solid",
			cr.behaviors.solid,
			9663844373427155
		]
		],
		false,
		false,
		4027833655111614,
		[],
		null
	]
,	[
		"t41",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Item0",
			5,
			false,
			1,
			0,
			false,
			5768807986301616,
			[
				["item-sheet0.png", 8284, 0, 0, 32, 32, 1, 0.5, 0.5,[],[-0.3447940051555634,-0.3605580031871796,-0.0009819865226745606,-0.4980079531669617,0.3428289890289307,-0.3605580031871796,0.4980350136756897,-0.001991987228393555,0.344793975353241,0.3585659861564636,-0.0009819865226745606,0.4980080127716065,-0.3467580080032349,0.3585659861564636,-0.4980353713035584,-0.001991987228393555],0]
			]
			]
,			[
			"Item1",
			5,
			false,
			1,
			0,
			false,
			3916453032310921,
			[
				["item-sheet0.png", 8284, 32, 0, 32, 32, 1, 0.5, 0.5,[],[-0.3447940051555634,-0.3605580031871796,-0.0009819865226745606,-0.4980079531669617,0.3428289890289307,-0.3605580031871796,0.4980350136756897,-0.001991987228393555,0.344793975353241,0.3585659861564636,-0.0009819865226745606,0.4980080127716065,-0.3467580080032349,0.3585659861564636,-0.4980353713035584,-0.001991987228393555],0]
			]
			]
,			[
			"Item2",
			5,
			false,
			1,
			0,
			false,
			251021205079024,
			[
				["item-sheet0.png", 8284, 0, 32, 32, 32, 1, 0.5, 0.5,[],[-0.3447940051555634,-0.3605580031871796,-0.0009819865226745606,-0.4980079531669617,0.3428289890289307,-0.3605580031871796,0.4980350136756897,-0.001991987228393555,0.344793975353241,0.3585659861564636,-0.0009819865226745606,0.4980080127716065,-0.3467580080032349,0.3585659861564636,-0.4980353713035584,-0.001991987228393555],0]
			]
			]
,			[
			"Item3",
			5,
			false,
			1,
			0,
			false,
			6653980856760789,
			[
				["item-sheet0.png", 8284, 32, 32, 32, 32, 1, 0.5, 0.5,[],[-0.3447940051555634,-0.3605580031871796,-0.0009819865226745606,-0.4980079531669617,0.3428289890289307,-0.3605580031871796,0.4980350136756897,-0.001991987228393555,0.344793975353241,0.3585659861564636,-0.0009819865226745606,0.4980080127716065,-0.3467580080032349,0.3585659861564636,-0.4980353713035584,-0.001991987228393555],0]
			]
			]
,			[
			"Item4",
			5,
			false,
			1,
			0,
			false,
			9908389644916396,
			[
				["item-sheet1.png", 2332, 0, 0, 30, 30, 1, 0.5, 0.5,[],[-0.35521200299263,-0.350598007440567,0,-0.4980079829692841,0.3474900126457214,-0.3426290154457092,0.4806950092315674,0,0.3474900126457214,0.3426290154457092,0,0.4980080127716065,-0.35521200299263,0.3505979776382446,-0.4980694949626923,0],0]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			8690118500138303
		]
		],
		false,
		false,
		9634556742378936,
		[],
		null
	]
,	[
		"t42",
		cr.plugins_.Particles,
		false,
		[],
		0,
		0,
		["item_particles.png", 449, 0],
		null,
		[
		],
		false,
		false,
		9516751069952099,
		[],
		null
	]
,	[
		"t43",
		cr.plugins_.Particles,
		false,
		[],
		0,
		0,
		["item_particles.png", 449, 0],
		null,
		[
		],
		false,
		false,
		3919689858916372,
		[],
		null
	]
,	[
		"t44",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			6225462420188017,
			[
				["buyitem01-sheet0.png", 5566, 0, 0, 64, 29, 1, 0.5, 0.5185185074806213,[],[-0.4354839026927948,-0.3703705072402954,0,-0.5185185074806213,0.4516130089759827,-0.4074075222015381,0.4838709831237793,-0.03703752160072327,0.4193549752235413,0.2962964773178101,0,0.3703705072402954,-0.4193547964096069,0.2962964773178101,-0.4516128897666931,-0.03703752160072327],0],
				["buyitem01-sheet0.png", 5566, 0, 29, 64, 29, 1, 0.5, 0.5185185074806213,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			7653113348491622
		]
		],
		false,
		false,
		1094154842151447,
		[],
		null
	]
,	[
		"t45",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["cristaisshop.png", 11348, 0],
		null,
		[
		],
		false,
		false,
		772272283120768,
		[],
		null
	]
,	[
		"t46",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			1589990823868722,
			[
				["equipitem01-sheet0.png", 7254, 0, 0, 87, 30, 1, 0.5058823823928833, 0.5,[],[-0.4470588862895966,-0.3214290142059326,-0.01176437735557556,-0.5,0.4588236212730408,-0.3928570151329041,0.4941176176071167,0,0.4235296249389648,0.2857139706611633,-0.01176437735557556,0.3928570151329041,-0.4352941811084747,0.2857139706611633,-0.4705882668495178,0],0],
				["equipitem01-sheet0.png", 7254, 0, 30, 87, 30, 1, 0.5058823823928833, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			803990949726061
		]
		],
		false,
		false,
		4531046505139082,
		[],
		null
	]
,	[
		"t47",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7016819065411069,
			[
				["headshop-sheet0.png", 81918, 0, 0, 587, 110, 1, 0.5008518099784851, 0.5,[],[-0.483815997838974,-0.4090909063816071,-0.001703798770904541,-0.5,0.4855191707611084,-0.4272727072238922,0.4855191707611084,0,0.4616692066192627,0.300000011920929,-0.001703798770904541,0.3727269768714905,-0.4633731245994568,0.300000011920929,-0.483815997838974,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		8838009532418179,
		[],
		null
	]
,	[
		"t48",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Run",
			0,
			false,
			0,
			0,
			false,
			1948453770109689,
			[
				["player-sheet0.png", 94, 0, 0, 70, 45, 1, 0.5142857432365418, 0.5111111402511597,[],[-0.2949877381324768,-0.1686451435089111,0.161153256893158,-0.1686451435089111,0.161153256893158,0.2697108387947083,-0.2949877381324768,0.2697108387947083],1]
			]
			]
		],
		[
		[
			"Platform",
			cr.behaviors.Platform,
			5302933667310878
		]
		],
		false,
		false,
		5347855291220216,
		[],
		null
	]
,	[
		"t49",
		cr.plugins_.Touch,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		8668585515706748,
		[],
		null
		,[1]
	]
,	[
		"t50",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			15,
			true,
			0,
			0,
			false,
			5857019723344022,
			[
				["cristalpurple-sheet0.png", 5977, 0, 0, 38, 59, 1, 0.5, 0.5263158082962036,[],[0,-0.1685377955436707,0.136667013168335,-0.02631580829620361,0,0.1136841773986816,-0.1333329975605011,-0.02631580829620361],0]
			]
			]
,			[
			"explode",
			25,
			false,
			1,
			0,
			false,
			5057558037227545,
			[
				["cristalpurple-sheet0.png", 5977, 38, 0, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cristalpurple-sheet0.png", 5977, 76, 0, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cristalpurple-sheet0.png", 5977, 0, 59, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cristalpurple-sheet0.png", 5977, 38, 59, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cristalpurple-sheet0.png", 5977, 76, 59, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cristalpurple-sheet1.png", 1565, 0, 0, 36, 57, 1, 0.5, 0.5087719559669495,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			2922590009655243
		]
		],
		false,
		false,
		2051138380668713,
		[],
		null
	]
,	[
		"t51",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			4596090335634382,
			[
				["cristalblue-sheet0.png", 5882, 0, 0, 38, 59, 1, 0.5, 0.5263158082962036,[],[0,-0.1685377955436707,0.136667013168335,-0.02631580829620361,0,0.1136841773986816,-0.1333329975605011,-0.02631580829620361],0]
			]
			]
,			[
			"explode",
			25,
			false,
			1,
			0,
			false,
			424141580797329,
			[
				["cristalblue-sheet0.png", 5882, 38, 0, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cristalblue-sheet0.png", 5882, 76, 0, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cristalblue-sheet0.png", 5882, 0, 59, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cristalblue-sheet0.png", 5882, 38, 59, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cristalblue-sheet0.png", 5882, 76, 59, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cristalblue-sheet1.png", 1546, 0, 0, 36, 57, 1, 0.5, 0.5087719559669495,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			7199496925835027
		]
		],
		false,
		false,
		820908166850173,
		[],
		null
	]
,	[
		"t52",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			301970838409594,
			[
				["cistalgray-sheet0.png", 5144, 0, 0, 38, 59, 1, 0.5, 0.5263158082962036,[],[0,-0.1685377955436707,0.136667013168335,-0.02631580829620361,0,0.1136841773986816,-0.1333329975605011,-0.02631580829620361],0]
			]
			]
,			[
			"explode",
			25,
			false,
			1,
			0,
			false,
			5815960263305481,
			[
				["cistalgray-sheet0.png", 5144, 38, 0, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cistalgray-sheet0.png", 5144, 76, 0, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cistalgray-sheet0.png", 5144, 0, 59, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cistalgray-sheet0.png", 5144, 38, 59, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cistalgray-sheet0.png", 5144, 76, 59, 38, 59, 1, 0.5, 0.5087719559669495,[],[],0],
				["cistalgray-sheet1.png", 1418, 0, 0, 36, 57, 1, 0.5, 0.5087719559669495,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			7321637767620125
		]
		],
		false,
		false,
		1725411107628417,
		[],
		null
	]
,	[
		"t53",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5850510637357455,
			[
				["title-sheet0.png", 19195, 0, 0, 300, 82, 1, 0.5, 0,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		9218392478360064,
		[],
		null
	]
,	[
		"t54",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			10,
			true,
			1,
			0,
			false,
			5717406996017487,
			[
				["mago-sheet0.png", 6814, 0, 0, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet0.png", 6814, 34, 0, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet0.png", 6814, 68, 0, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet0.png", 6814, 0, 42, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet0.png", 6814, 34, 42, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet0.png", 6814, 68, 42, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet0.png", 6814, 0, 84, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet0.png", 6814, 34, 84, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet0.png", 6814, 68, 84, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet1.png", 2570, 0, 0, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet1.png", 2570, 34, 0, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0],
				["mago-sheet1.png", 2570, 68, 0, 34, 42, 1, 0.5, 0.5,[],[-0.2601920068264008,-0.2359220087528229,0.1834530234336853,-0.2359220087528229,0.1834530234336853,0.3834949731826782,-0.2601920068264008,0.3834949731826782],0]
			]
			]
		],
		[
		[
			"Platform",
			cr.behaviors.Platform,
			5518083115852806
		]
		],
		false,
		false,
		3780875832582449,
		[],
		null
	]
,	[
		"t55",
		cr.plugins_.Particles,
		false,
		[],
		0,
		0,
		["rabo_particles.png", 7252, 0],
		null,
		[
		],
		false,
		false,
		9930918216837622,
		[],
		null
	]
,	[
		"t56",
		cr.plugins_.Sprite,
		false,
		[],
		3,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8331873174923609,
			[
				["fada-sheet0.png", 344, 0, 0, 10, 10, 1, 0.5, 0.6000000238418579,[],[-0.3708969950675964,-0.4376470446586609,0.3315100073814392,-0.4023530185222626,0.2133479714393616,-0.04235303401947022,0.2593000531196594,0.2399999499320984,-0.289933979511261,0.2658819556236267,-0.2352299988269806,-0.04235303401947022],0]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			2678935313325147
		]
,		[
			"Sine2",
			cr.behaviors.Sin,
			2665649282720532
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			3330850614471045
		]
		],
		false,
		false,
		3750953602173935,
		[],
		null
	]
,	[
		"t57",
		cr.plugins_.Particles,
		false,
		[],
		1,
		0,
		["fada_particle.png", 120, 0],
		null,
		[
		[
			"Pin",
			cr.behaviors.Pin,
			8776509586920609
		]
		],
		false,
		false,
		8264604403958977,
		[],
		null
	]
,	[
		"t58",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Run",
			25,
			true,
			1,
			0,
			false,
			6521799106447206,
			[
				["player_sprite-sheet0.png", 65272, 360, 276, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.08571428805589676, 0.5777778029441834]],[],0],
				["player_sprite-sheet0.png", 65272, 432, 276, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.1142857149243355, 0.3555555641651154]],[],0],
				["player_sprite-sheet0.png", 65272, 360, 323, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.1714285761117935, 0.2444444447755814]],[],0],
				["player_sprite-sheet0.png", 65272, 432, 323, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.228571429848671, 0.2000000029802322]],[],0],
				["player_sprite-sheet0.png", 65272, 0, 345, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.342857152223587, 0.1111111119389534]],[],0],
				["player_sprite-sheet0.png", 65272, 72, 345, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.4000000059604645, 0.2000000029802322]],[],0],
				["player_sprite-sheet0.png", 65272, 144, 345, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.3571428656578064, 0.2666666805744171]],[],0],
				["player_sprite-sheet0.png", 65272, 216, 345, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.2857142984867096, 0.4000000059604645]],[],0],
				["player_sprite-sheet0.png", 65272, 288, 345, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.2142857164144516, 0.4666666686534882]],[],0],
				["player_sprite-sheet0.png", 65272, 360, 370, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.1428571492433548, 0.7333333492279053]],[],0]
			]
			]
,			[
			"Roll",
			55,
			false,
			1,
			0,
			false,
			9151121303843632,
			[
				["player_sprite-sheet0.png", 65272, 0, 0, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.4428571462631226, 0.8059701323509216]],[],0],
				["player_sprite-sheet0.png", 65272, 72, 0, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3142857253551483, 0.7761194109916687]],[],0],
				["player_sprite-sheet0.png", 65272, 144, 0, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.4142857193946838, 0.7313432693481445]],[],0],
				["player_sprite-sheet0.png", 65272, 216, 0, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3857142925262451, 0.6716417670249939]],[],0],
				["player_sprite-sheet0.png", 65272, 288, 0, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3857142925262451, 0.611940324306488]],[],0],
				["player_sprite-sheet0.png", 65272, 360, 0, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3857142925262451, 0.5522388219833374]],[],0],
				["player_sprite-sheet0.png", 65272, 432, 0, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3714285790920258, 0.5074626803398132]],[],0],
				["player_sprite-sheet0.png", 65272, 0, 69, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3857142925262451, 0.447761207818985]],[],0],
				["player_sprite-sheet0.png", 65272, 72, 69, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3714285790920258, 0.3731343150138855]],[],0],
				["player_sprite-sheet0.png", 65272, 144, 69, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3714285790920258, 0.3134328424930573]],[],0],
				["player_sprite-sheet0.png", 65272, 216, 69, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3714285790920258, 0.2686567306518555]],[],0],
				["player_sprite-sheet0.png", 65272, 288, 69, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3857142925262451, 0.2537313401699066]],[],0],
				["player_sprite-sheet0.png", 65272, 360, 69, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3714285790920258, 0.2238806039094925]],[],0],
				["player_sprite-sheet0.png", 65272, 432, 69, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3857142925262451, 0.2238806039094925]],[],0],
				["player_sprite-sheet0.png", 65272, 0, 138, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3857142925262451, 0.2238806039094925]],[],0],
				["player_sprite-sheet0.png", 65272, 72, 138, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.3857142925262451, 0.238805964589119]],[],0],
				["player_sprite-sheet0.png", 65272, 144, 138, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.4000000059604645, 0.2537313401699066]],[],0],
				["player_sprite-sheet0.png", 65272, 216, 138, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.4285714328289032, 0.2835820913314819]],[],0],
				["player_sprite-sheet0.png", 65272, 288, 138, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.4857142865657806, 0.3283582031726837]],[],0],
				["player_sprite-sheet0.png", 65272, 360, 138, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.4714285731315613, 0.3134328424930573]],[],0],
				["player_sprite-sheet0.png", 65272, 432, 138, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.4857142865657806, 0.2985074520111084]],[],0],
				["player_sprite-sheet0.png", 65272, 0, 207, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.4857142865657806, 0.2835820913314819]],[],0],
				["player_sprite-sheet0.png", 65272, 72, 207, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.5142857432365418, 0.2835820913314819]],[],0],
				["player_sprite-sheet0.png", 65272, 144, 207, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.699999988079071, 0.3731343150138855]],[],0],
				["player_sprite-sheet0.png", 65272, 216, 207, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.699999988079071, 0.641791045665741]],[],0],
				["player_sprite-sheet0.png", 65272, 288, 207, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.6000000238418579, 0.8059701323509216]],[],0],
				["player_sprite-sheet0.png", 65272, 360, 207, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.4428571462631226, 0.8208954930305481]],[],0],
				["player_sprite-sheet0.png", 65272, 432, 207, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.342857152223587, 0.7761194109916687]],[],0],
				["player_sprite-sheet0.png", 65272, 0, 276, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.2857142984867096, 0.746268630027771]],[],0],
				["player_sprite-sheet0.png", 65272, 72, 276, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.228571429848671, 0.7313432693481445]],[],0],
				["player_sprite-sheet0.png", 65272, 144, 276, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.1857142895460129, 0.6268656849861145]],[],0],
				["player_sprite-sheet0.png", 65272, 216, 276, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.1857142895460129, 0.5970149040222168]],[],0],
				["player_sprite-sheet0.png", 65272, 288, 276, 72, 69, 1, 0.5, 0.5074626803398132,[["rabo", 0.2000000029802322, 0.5522388219833374]],[],0]
			]
			]
,			[
			"Jump",
			15,
			false,
			1,
			0,
			false,
			6842619132448011,
			[
				["player_sprite-sheet0.png", 65272, 432, 370, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.300000011920929, 0.3777777850627899]],[-0.2400000095367432,-0.1080101430416107,0,-0.3870801329612732,0.1725000143051148,-0.00335913896560669,0.1725000143051148,-0.01111114025115967,0.175000011920929,-0.01498714089393616,0,0.1710598468780518,-0.2950000166893005,0.1710598468780518,-0.2750000059604645,-0.01111114025115967],0],
				["player_sprite-sheet0.png", 65272, 0, 392, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.228571429848671, 0.4666666686534882]],[-0.1049999892711639,0.101291835308075,0,-0.3444441556930542,0.1700000166893005,0.0005168318748474121,0.1725000143051148,-0.01111114025115967,0.175000011920929,-0.01498714089393616,0,0.2098188400268555,-0.3125,0.1981908679008484,-0.3224999904632568,-0.01111114025115967],0],
				["player_sprite-sheet0.png", 65272, 72, 392, 72, 47, 1, 0.5142857432365418, 0.5111111402511597,[["rabo", 0.1428571492433548, 0.7111111283302307]],[-0.2542857527732849,-0.1080101430416107,-0.01428574323654175,-0.4064601361751556,0.08821427822113037,0.1051678657531738,0.1532142162322998,-0.02661514282226563,-0.01428574323654175,0.1051678657531738,-0.2117857336997986,0.01989686489105225,-0.3517857491970062,-0.01111114025115967],0],
				["player_sprite-sheet0.png", 65272, 144, 392, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.0714285746216774, 0.5555555820465088]],[-0.2849999964237213,-0.1777781546115875,0,-0.3211891353130341,0.1449999809265137,-0.01111114025115967,0.1399999856948853,-0.06925114989280701,0,0.07028383016586304,-0.1674999892711639,-0.02661514282226563,-0.4225000143051148,-0.01111114025115967],0],
				["player_sprite-sheet0.png", 65272, 216, 392, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.1142857149243355, 0.3777777850627899]],[-0.3224999904632568,-0.2359171509742737,0,-0.3173131346702576,0.1499999761581421,0.03152483701705933,0.1600000262260437,-0.01111114025115967,0.1474999785423279,-0.05762314796447754,0,0.1439278721809387,-0.1475000083446503,-0.05762314796447754,-0.1475000083446503,-0.01111114025115967],0],
				["player_sprite-sheet0.png", 65272, 288, 392, 72, 47, 1, 0.5, 0.5111111402511597,[["rabo", 0.1571428626775742, 0.2666666805744171]],[-0.3474999964237213,-0.2746771574020386,0,-0.3793281316757202,0.1650000214576721,0.008268833160400391,0.1525000333786011,-0.01111114025115967,0.1525000333786011,-0.04987114667892456,0,0.1439278721809387,-0.137499988079071,-0.0731271505355835,-0.0949999988079071,-0.01111114025115967],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			8653893942356097
		]
		],
		false,
		false,
		2912254272602414,
		[],
		null
	]
,	[
		"t59",
		cr.plugins_.Function,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		5012025206362111,
		[],
		null
		,[]
	]
,	[
		"t60",
		cr.plugins_.Audio,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		5968855643775301,
		[],
		null
		,[0,3,1,1,600,600,10000,1,5000,1]
	]
,	[
		"t61",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			16635992139145,
			[
				["bg_gameover-sheet0.png", 4579, 0, 0, 250, 250, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		6633067454205801,
		[],
		null
	]
,	[
		"t62",
		cr.plugins_.WebStorage,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		1817413247610843,
		[],
		null
		,[]
	]
,	[
		"t63",
		cr.plugins_.Spritefont2,
		false,
		[],
		1,
		0,
		["distance_display.png", 12786, 0],
		null,
		[
		[
			"Pin",
			cr.behaviors.Pin,
			8685192501998123
		]
		],
		false,
		true,
		9904419947975348,
		[],
		null
	]
,	[
		"t64",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7620574214255128,
			[
				["shop_button_home-sheet0.png", 6164, 0, 0, 56, 45, 1, 0.5, 0.5111111402511597,[],[-0.4427793025970459,-0.44157475233078,-0.001361995935440064,-0.5111111402511597,0.4400539994239807,-0.4382634460926056,0.4836509823799133,-0.01111114025115967,0.431879997253418,0.4061078429222107,-0.001361995935440064,0.4657098650932312,-0.4318801164627075,0.4061078429222107,-0.4891008138656616,-0.01111114025115967],0]
			]
			]
		],
		[
		],
		false,
		false,
		6977982645989061,
		[],
		null
	]
,	[
		"t65",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2418178239547724,
			[
				["chaohome-sheet0.png", 124939, 0, 0, 532, 541, 1, 0.4849624037742615, 0.4768946468830109,[],[-0.3009244203567505,-0.2957486510276794,0.01456859707832336,-0.4232902526855469,0.3854606151580811,-0.3493526577949524,0.4662116169929504,0.02310535311698914,0.3197326064109802,0.3308683335781097,0.01456859707832336,0.4630313813686371,-0.3234604001045227,0.3641403615474701,-0.422990620136261,0.02310535311698914],0]
			]
			]
		],
		[
		[
			"Rotate",
			cr.behaviors.Rotate,
			3973280108350289
		]
		],
		false,
		false,
		1422191218501979,
		[],
		null
	]
,	[
		"t66",
		cr.plugins_.Particles,
		false,
		[],
		0,
		0,
		["particles2x.png", 338, 0],
		null,
		[
		],
		false,
		false,
		2770425729986377,
		[],
		null
	]
,	[
		"t67",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			1955791902408896,
			[
				["item01-sheet0.png", 47656, 0, 0, 577, 78, 1, 0.5008665323257446, 0.5128205418586731,[],[-0.4887348413467407,-0.4230769276618958,-0.001733541488647461,-0.5000000596046448,0.4870014786720276,-0.4230769276618958,0.4818024635314941,0.3589744567871094,-0.001733541488647461,0.4102564454078674,-0.4835355281829834,0.3589744567871094],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			1806432071565929
		]
		],
		false,
		false,
		5298729878439293,
		[],
		null
	]
,	[
		"t68",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			1745330239043581,
			[
				["item02-sheet0.png", 46975, 0, 0, 577, 78, 1, 0.5008665323257446, 0.5128205418586731,[],[-0.4887348413467407,-0.4230769276618958,-0.001733541488647461,-0.5000000596046448,0.4870014786720276,-0.4230769276618958,0.4818024635314941,0.3589744567871094,-0.001733541488647461,0.4102564454078674,-0.4835355281829834,0.3589744567871094],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			729897296299197
		]
		],
		false,
		false,
		5977459950940302,
		[],
		null
	]
,	[
		"t69",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			8508726073588601,
			[
				["item03-sheet0.png", 48230, 0, 0, 577, 78, 1, 0.5008665323257446, 0.5128205418586731,[],[-0.4887348413467407,-0.4230769276618958,-0.001733541488647461,-0.5000000596046448,0.4870014786720276,-0.4230769276618958,0.4818024635314941,0.3589744567871094,-0.001733541488647461,0.4102564454078674,-0.4835355281829834,0.3589744567871094],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			9760575623575873
		]
		],
		false,
		false,
		3101001963621363,
		[],
		null
	]
,	[
		"t70",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			8935259402590368,
			[
				["item04-sheet0.png", 47354, 0, 0, 577, 78, 1, 0.5008665323257446, 0.5128205418586731,[],[-0.4887348413467407,-0.4230769276618958,-0.001733541488647461,-0.5000000596046448,0.4870014786720276,-0.4230769276618958,0.4818024635314941,0.3589744567871094,-0.001733541488647461,0.4102564454078674,-0.4835355281829834,0.3589744567871094],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			1137732581681298
		]
		],
		false,
		false,
		2909222514546489,
		[],
		null
	]
,	[
		"t71",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			965976579431436,
			[
				["buyitem01-sheet0.png", 5566, 0, 0, 64, 29, 1, 0.5, 0.5185185074806213,[],[-0.4354839026927948,-0.3703705072402954,0,-0.5185185074806213,0.4516130089759827,-0.4074075222015381,0.4838709831237793,-0.03703752160072327,0.4193549752235413,0.2962964773178101,0,0.3703705072402954,-0.4193547964096069,0.2962964773178101,-0.4516128897666931,-0.03703752160072327],0],
				["buyitem02-sheet0.png", 1666, 0, 0, 62, 27, 1, 0.5, 0.5185185074806213,[],[-0.4354839026927948,-0.3703705072402954,0,-0.5185185074806213,0.4516130089759827,-0.4074075222015381,0.4838709831237793,-0.03703752160072327,0.4193549752235413,0.2962964773178101,0,0.3703705072402954,-0.4193547964096069,0.2962964773178101,-0.4516128897666931,-0.03703752160072327],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4818590414780658
		]
		],
		false,
		false,
		7327927186336,
		[],
		null
	]
,	[
		"t72",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			3406068622915502,
			[
				["equipitem01-sheet0.png", 7254, 0, 0, 87, 30, 1, 0.5058823823928833, 0.5,[],[-0.4470588862895966,-0.3214290142059326,-0.01176437735557556,-0.5,0.4588236212730408,-0.3928570151329041,0.4941176176071167,0,0.4235296249389648,0.2857139706611633,-0.01176437735557556,0.3928570151329041,-0.4352941811084747,0.2857139706611633,-0.4705882668495178,0],0],
				["equipitem01-sheet0.png", 7254, 0, 30, 87, 30, 1, 0.5058823823928833, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			9102357280354808
		]
		],
		false,
		false,
		2308932616967938,
		[],
		null
	]
,	[
		"t73",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			8017666510802102,
			[
				["buyitem01-sheet0.png", 5566, 0, 0, 64, 29, 1, 0.5, 0.5185185074806213,[],[-0.4354839026927948,-0.3703705072402954,0,-0.5185185074806213,0.4516130089759827,-0.4074075222015381,0.4838709831237793,-0.03703752160072327,0.4193549752235413,0.2962964773178101,0,0.3703705072402954,-0.4193547964096069,0.2962964773178101,-0.4516128897666931,-0.03703752160072327],0],
				["buyitem01-sheet0.png", 5566, 0, 29, 64, 29, 1, 0.5, 0.5185185074806213,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			1722616210148607
		]
		],
		false,
		false,
		1787567253741399,
		[],
		null
	]
,	[
		"t74",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			4579382014789177,
			[
				["equipitem01-sheet0.png", 7254, 0, 0, 87, 30, 1, 0.5058823823928833, 0.5,[],[-0.4470588862895966,-0.3214290142059326,-0.01176437735557556,-0.5,0.4588236212730408,-0.3928570151329041,0.4941176176071167,0,0.4235296249389648,0.2857139706611633,-0.01176437735557556,0.3928570151329041,-0.4352941811084747,0.2857139706611633,-0.4705882668495178,0],0],
				["equipitem01-sheet0.png", 7254, 0, 30, 87, 30, 1, 0.5058823823928833, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4244071843849274
		]
		],
		false,
		false,
		8968378904308976,
		[],
		null
	]
,	[
		"t75",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			1813580847944269,
			[
				["buyitem01-sheet0.png", 5566, 0, 0, 64, 29, 1, 0.5, 0.5185185074806213,[],[-0.4354839026927948,-0.3703705072402954,0,-0.5185185074806213,0.4516130089759827,-0.4074075222015381,0.4838709831237793,-0.03703752160072327,0.4193549752235413,0.2962964773178101,0,0.3703705072402954,-0.4193547964096069,0.2962964773178101,-0.4516128897666931,-0.03703752160072327],0],
				["buyitem01-sheet0.png", 5566, 0, 29, 64, 29, 1, 0.5, 0.5185185074806213,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			7612926449139156
		]
		],
		false,
		false,
		3233513253193026,
		[],
		null
	]
,	[
		"t76",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			473136717367123,
			[
				["equipitem01-sheet0.png", 7254, 0, 0, 87, 30, 1, 0.5058823823928833, 0.5,[],[-0.4470588862895966,-0.3214290142059326,-0.01176437735557556,-0.5,0.4588236212730408,-0.3928570151329041,0.4941176176071167,0,0.4235296249389648,0.2857139706611633,-0.01176437735557556,0.3928570151329041,-0.4352941811084747,0.2857139706611633,-0.4705882668495178,0],0],
				["equipitem01-sheet0.png", 7254, 0, 30, 87, 30, 1, 0.5058823823928833, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			3781391237393253
		]
		],
		false,
		false,
		6825530833465163,
		[],
		null
	]
,	[
		"t77",
		cr.plugins_.Spritefont2,
		false,
		[],
		1,
		0,
		["valoritemshop.png", 16258, 0],
		null,
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4326256638444258
		]
		],
		false,
		false,
		5121025958561579,
		[],
		null
	]
,	[
		"t78",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2556241720804402,
			[
				["touchloja-sheet0.png", 155, 0, 0, 250, 250, 1, 0.5, 0.5,[],[],1]
			]
			]
		],
		[
		[
			"DragDrop",
			cr.behaviors.DragnDrop,
			2117699433450242
		]
		],
		false,
		false,
		2616367728912405,
		[],
		null
	]
,	[
		"t79",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2179755137652824,
			[
				["item01slot-sheet0.png", 59332, 0, 0, 229, 189, 1, 0.5021833777427673, 0.5026454925537109,[],[-0.344978392124176,-0.3121694922447205,-0.004366368055343628,-0.4126983880996704,0.3406116366386414,-0.3121694922447205,0.4235806465148926,-0.005290478467941284,0.3406116366386414,0.3068785071372986,-0.004366368055343628,0.4074075222015381,-0.344978392124176,0.3068785071372986,-0.4279475808143616,-0.005290478467941284],0]
			]
			]
		],
		[
		],
		false,
		false,
		3397906559500676,
		[],
		null
	]
,	[
		"t80",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5735505733877056,
			[
				["item02slot-sheet0.png", 51480, 0, 0, 229, 189, 1, 0.5021833777427673, 0.5026454925537109,[],[-0.344978392124176,-0.3121694922447205,-0.004366368055343628,-0.4126983880996704,0.3406116366386414,-0.3121694922447205,0.4235806465148926,-0.005290478467941284,0.3406116366386414,0.3068785071372986,-0.004366368055343628,0.4074075222015381,-0.344978392124176,0.3068785071372986,-0.4279475808143616,-0.005290478467941284],0]
			]
			]
		],
		[
		],
		false,
		false,
		4775893832843069,
		[],
		null
	]
,	[
		"t81",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			567103433694408,
			[
				["item03slot-sheet0.png", 61954, 0, 0, 229, 189, 1, 0.5021833777427673, 0.5026454925537109,[],[-0.344978392124176,-0.3121694922447205,-0.004366368055343628,-0.4126983880996704,0.3406116366386414,-0.3121694922447205,0.4235806465148926,-0.005290478467941284,0.3406116366386414,0.3068785071372986,-0.004366368055343628,0.4074075222015381,-0.344978392124176,0.3068785071372986,-0.4279475808143616,-0.005290478467941284],0]
			]
			]
		],
		[
		],
		false,
		false,
		355040986543721,
		[],
		null
	]
,	[
		"t82",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3958000543989259,
			[
				["item04slot-sheet0.png", 57237, 0, 0, 229, 189, 1, 0.5021833777427673, 0.5026454925537109,[],[-0.344978392124176,-0.3121694922447205,-0.004366368055343628,-0.4126983880996704,0.3406116366386414,-0.3121694922447205,0.4235806465148926,-0.005290478467941284,0.3406116366386414,0.3068785071372986,-0.004366368055343628,0.4074075222015381,-0.344978392124176,0.3068785071372986,-0.4279475808143616,-0.005290478467941284],0]
			]
			]
		],
		[
		],
		false,
		false,
		9986218406906991,
		[],
		null
	]
,	[
		"t83",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5111371458667702,
			[
				["ima-sheet0.png", 4618, 0, 0, 74, 74, 1, 0.5135135054588318, 0.4864864945411682,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			4100622811010929
		]
		],
		false,
		false,
		4093818455428618,
		[],
		null
	]
,	[
		"t84",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7460993313259507,
			[
				["boiadumal-sheet0.png", 4241, 0, 0, 40, 40, 1, 0.5, 0.5,[],[-0.3525469899177551,-0.3541110157966614,-0.001340001821517944,-0.4973474740982056,0.3498659729957581,-0.3514589965343475,0.4946380257606506,-0.001325994729995728,0.3552280068397522,0.356764018535614,-0.001340001821517944,0.4946950078010559,-0.3552280068397522,0.356764018535614,-0.4973190426826477,-0.001325994729995728],0]
			]
			]
		],
		[
		[
			"Rotate",
			cr.behaviors.Rotate,
			2280140054859064
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			1254505950628589
		]
		],
		false,
		false,
		5893024136031272,
		[],
		null
	]
,	[
		"t85",
		cr.plugins_.Particles,
		false,
		[],
		0,
		0,
		["smoke.png", 3078, 0],
		null,
		[
		],
		false,
		false,
		3157145435230464,
		[],
		null
	]
,	[
		"t86",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5638021975681237,
			[
				["revive-sheet0.png", 366, 0, 0, 42, 42, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		7787585162695058,
		[],
		null
	]
,	[
		"t87",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4068405943728676,
			[
				["life-sheet0.png", 1257, 0, 0, 25, 23, 1, 0.5199999809265137, 0.52173912525177,[],[-0.3335199952125549,-0.3144851326942444,-0.02116596698760986,-0.2549001276493073,0.2865270376205444,-0.3067131042480469,0.3214920163154602,-0.02173912525177002,0.1956180334091187,0.1621989011764526,-0.02116596698760986,0.3331828713417053,-0.2262939810752869,0.1518358588218689,-0.3451749682426453,-0.02173912525177002],0]
			]
			]
		],
		[
		],
		false,
		false,
		1820593589468411,
		[],
		null
	]
,	[
		"t88",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1743535451000953,
			[
				["pausebutton-sheet0.png", 194843, 0, 0, 364, 347, 1, 0.5, 0.5014409422874451,[],[-0.357142984867096,-0.3515849411487579,0,-0.5014409422874451,0.357142984867096,-0.3515849411487579,0.5,-0.002881944179534912,0.357142984867096,0.3487030863761902,0,0.4985590577125549,-0.357142984867096,0.3487030863761902,-0.5,-0.002881944179534912],0]
			]
			]
		],
		[
		],
		false,
		false,
		1357765877873229,
		[],
		null
	]
,	[
		"t89",
		cr.plugins_.Particles,
		false,
		[],
		0,
		0,
		["boost.png", 10850, 0],
		null,
		[
		],
		false,
		false,
		3867781275010155,
		[],
		null
	]
,	[
		"t90",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			921985551000691,
			[
				["bgpause-sheet0.png", 168, 0, 0, 250, 250, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		9953640784113873,
		[],
		null
	]
,	[
		"t91",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			9630302464050843,
			[
				["resumebutton-sheet0.png", 16036, 0, 0, 122, 58, 1, 0.5, 0.5,[],[-0.4689655005931854,-0.4359430968761444,0,-0.4964412748813629,0.468966007232666,-0.4359430968761444,0.5,-0.001778990030288696,0.468966007232666,0.4359430074691773,0,0.4964410066604614,-0.4689655005931854,0.4359430074691773,-0.5,-0.001778990030288696],0]
			]
			]
		],
		[
		],
		false,
		false,
		2702794831149861,
		[],
		null
	]
,	[
		"t92",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			4342075837336533,
			[
				["retrybuttonpause-sheet0.png", 15914, 0, 0, 122, 58, 1, 0.5, 0.5,[],[-0.4689655005931854,-0.4359430968761444,0,-0.4964412748813629,0.468966007232666,-0.4359430968761444,0.5,-0.001778990030288696,0.468966007232666,0.4359430074691773,0,0.4964410066604614,-0.4689655005931854,0.4359430074691773,-0.5,-0.001778990030288696],0]
			]
			]
		],
		[
		],
		false,
		false,
		3842825390895344,
		[],
		null
	]
,	[
		"t93",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			2772594839262194,
			[
				["quitbutton-sheet0.png", 15648, 0, 0, 122, 58, 1, 0.5, 0.5,[],[-0.4689655005931854,-0.4359430968761444,0,-0.4964412748813629,0.468966007232666,-0.4359430968761444,0.5,-0.001778990030288696,0.468966007232666,0.4359430074691773,0,0.4964410066604614,-0.4689655005931854,0.4359430074691773,-0.5,-0.001778990030288696],0]
			]
			]
		],
		[
		],
		false,
		false,
		5107475073886195,
		[],
		null
	]
,	[
		"t94",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			7777917975093997,
			[
				["headpause-sheet0.png", 84637, 0, 0, 588, 110, 1, 0.5, 0.5,[],[-0.4829931855201721,-0.4090909063816071,0,-0.5,0.486395001411438,-0.4272727072238922,0.486395001411438,0,0.4625849723815918,0.300000011920929,0,0.3727269768714905,-0.4625850021839142,0.300000011920929,-0.4829931855201721,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		8329409848816753,
		[],
		null
	]
,	[
		"t95",
		cr.plugins_.CJSBackButton,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		2254327695434048,
		[],
		null
		,[0,1]
	]
,	[
		"t96",
		cr.plugins_.Browser,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		2459242851687011,
		[],
		null
		,[]
	]
,	[
		"t97",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9830403706103008,
			[
				["transicao02-sheet0.png", 28857, 0, 0, 250, 160, 1, 0.5, 0,[],[0.5,1,-0.5,1,-0.5,0,0.5,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		620261110758444,
		[],
		null
	]
,	[
		"t98",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6322206202797253,
			[
				["homeinstructions-sheet0.png", 4069, 0, 0, 244, 34, 1, 0.5, 0.5,[],[-0.3219780027866364,-0.484375,0.04065901041030884,-0.203125,0.3703299760818481,-0.234375,-0.2868130207061768,0.03125,0.04065901041030884,0.171875,0.3153849840164185,0.421875],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			3870901793960969
		]
		],
		false,
		false,
		9941391647914673,
		[],
		null
	]
,	[
		"t99",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3270017413251158,
			[
				["tapaerro-sheet0.png", 155, 0, 0, 250, 250, 1, 0.5, 0.5,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		8245921375840433,
		[],
		null
	]
,	[
		"t100",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4480623930975647,
			[
				["creditsbutton-sheet0.png", 5598, 0, 0, 89, 42, 1, 0.5056179761886597, 0.5,[],[-0.4722846746444702,-0.4298245906829834,-0.005617976188659668,-0.4824560880661011,0.3777150511741638,-0.2543860077857971,0.4027150273323059,-0.008771985769271851,0.3777150511741638,0.2543860077857971,-0.005617976188659668,0.307017982006073,-0.3889509737491608,0.2543860077857971,-0.5056179761886597,-0.008771985769271851],0]
			]
			]
		],
		[
		],
		false,
		false,
		7372000386578384,
		[],
		null
	]
,	[
		"t101",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1191850960136354,
			[
				["bgcredits-sheet0.png", 186670, 0, 0, 569, 320, 1, 0.5008787512779236, 0.5,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		7075171079625096,
		[],
		null
	]
,	[
		"t102",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9241430698094192,
			[
				["backbuttoncredits-sheet0.png", 6081, 0, 0, 94, 55, 1, 0.5, 0.5090909004211426,[],[-0.4680851101875305,-0.45454540848732,0,-0.5090909004211426,0.3723400235176086,-0.2909089028835297,0.3936169743537903,-0.01818189024925232,0.3723400235176086,0.2727270722389221,0,0.3090910911560059,-0.3723399937152863,0.2727270722389221,-0.5,-0.01818189024925232],0]
			]
			]
		],
		[
		],
		false,
		false,
		170214754313022,
		[],
		null
	]
,	[
		"t103",
		cr.plugins_.CJSAds,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		9711914489049318,
		[],
		null
		,[1,0]
	]
,	[
		"t104",
		cr.plugins_.TiledBg,
		false,
		[],
		0,
		0,
		["shopbg.png", 5887, 1],
		null,
		[
		],
		false,
		false,
		948640375055838,
		[],
		null
	]
,	[
		"t105",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6796419030964506,
			[
				["googleplay-sheet0.png", 8764, 0, 0, 212, 100, 1, 0.5, 0.5,[],[-0.1415089964866638,-0.300000011920929,0.1415089964866638,-0.300000011920929,0.4056599736213684,0,0.1415089964866638,0.300000011920929,-0.1415089964866638,0.300000011920929,-0.4056603908538818,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		4722578987891343,
		[],
		null
	]
,	[
		"t106",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6139149248518671,
			[
				["itembutton-sheet0.png", 23389, 0, 0, 127, 92, 1, 0.5039370059967041, 0.5,[],[-0.4542475938796997,-0.4304347932338715,-0.004972010850906372,-0.5,0.4256699681282044,-0.4014492928981781,0.4732890129089356,-0.001448988914489746,0.4235990047454834,0.3985509872436523,-0.004972010850906372,0.4681159853935242,-0.4314731955528259,0.3985509872436523,-0.5039370059967041,-0.001448988914489746],0]
			]
			]
		],
		[
		],
		false,
		false,
		7217512249165407,
		[],
		null
	]
,	[
		"t107",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2756317148445655,
			[
				["clothesbutton-sheet0.png", 23517, 0, 0, 127, 92, 1, 0.5039370059967041, 0.5,[],[-0.4279615879058838,-0.3921279907226563,-0.004963994026184082,-0.5,0.4467819929122925,-0.4300292134284973,0.4960629940032959,-0.00145798921585083,0.420087993144989,0.3921279907226563,-0.004963994026184082,0.467930018901825,-0.432068407535553,0.3979589939117432,-0.4813497066497803,-0.00145798921585083],0]
			]
			]
		],
		[
		],
		false,
		false,
		535649047540789,
		[],
		null
	]
,	[
		"t108",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9381088069486256,
			[
				["backshopitem-sheet0.png", 8610, 0, 0, 94, 55, 1, 0.5, 0.5090909004211426,[],[-0.4680851101875305,-0.45454540848732,0,-0.5090909004211426,0.3723400235176086,-0.2909089028835297,0.3936169743537903,-0.01818189024925232,0.3723400235176086,0.2727270722389221,0,0.3090910911560059,-0.3723399937152863,0.2727270722389221,-0.5,-0.01818189024925232],0]
			]
			]
		],
		[
		],
		false,
		false,
		851927042244525,
		[],
		null
	]
,	[
		"t109",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5798828371877776,
			[
				["comingclothes-sheet0.png", 42750, 0, 0, 415, 67, 1, 0.5012048482894898, 0.5074626803398132,[],[-0.4798308610916138,-0.3766216635704041,-0.001967847347259522,-0.2831636667251587,0.4667341709136963,-0.3112006783485413,0.4865811467170715,-0.01213568449020386,0.4529931545257568,0.2121633291244507,-0.001967847347259522,0.3430043458938599,-0.4584567546844482,0.2308553457260132,-0.4966247081756592,-0.01213568449020386],0]
			]
			]
		],
		[
		],
		false,
		false,
		6106314159213572,
		[],
		null
	]
,	[
		"t110",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6666917168425336,
			[
				["comingitems-sheet0.png", 79366, 0, 0, 577, 77, 1, 0.5008665323257446, 0.5064935088157654,[],[-0.4887348413467407,-0.4155844151973724,-0.001733541488647461,-0.5064935088157654,0.4870014786720276,-0.4155844151973724,0.4818024635314941,0.3636364936828613,-0.001733541488647461,0.4155845046043396,-0.4835355281829834,0.3636364936828613],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			6570715420580402
		]
		],
		false,
		false,
		9771723130750662,
		[],
		null
	]
,	[
		"t111",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4917643318629467,
			[
				["fadein-sheet0.png", 155, 0, 0, 250, 250, 1, 0.5, 0.5,[],[],4]
			]
			]
		],
		[
		],
		false,
		false,
		5014061676521337,
		[],
		null
	]
,	[
		"t112",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8267079806900343,
			[
				["fadein-sheet0.png", 155, 0, 0, 250, 250, 1, 0.5, 0.5,[],[],4]
			]
			]
		],
		[
		],
		false,
		false,
		7987343355210437,
		[],
		null
	]
,	[
		"t113",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			9751151942014845,
			[
				["bg01_01-sheet0.png", 212143, 0, 0, 455, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			8759980105698868
		]
		],
		false,
		false,
		6610751301266937,
		[],
		null
	]
,	[
		"t114",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			9258712104735166,
			[
				["bg01_02-sheet0.png", 215946, 0, 0, 455, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		3535513898176112,
		[],
		null
	]
,	[
		"t115",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			2087779869567752,
			[
				["bg01_03-sheet0.png", 174902, 0, 0, 455, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		2661974511164529,
		[],
		null
	]
,	[
		"t116",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			3657970504334519,
			[
				["bg01_04-sheet0.png", 215254, 0, 0, 455, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		5101363515072106,
		[],
		null
	]
,	[
		"t117",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			5178865942370711,
			[
				["bg01_05-sheet0.png", 212404, 0, 0, 455, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		9215581619682513,
		[],
		null
	]
,	[
		"t118",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			3438408223551212,
			[
				["bg01_06-sheet0.png", 212108, 0, 0, 455, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		3199037977229382,
		[],
		null
	]
,	[
		"t119",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			6397238044909747,
			[
				["bg01_07-sheet0.png", 215372, 0, 0, 455, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		8371014155774863,
		[],
		null
	]
,	[
		"t120",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			2479083379234581,
			[
				["bg01_08-sheet0.png", 174724, 0, 0, 455, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		9163796039536988,
		[],
		null
	]
,	[
		"t121",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			2797047492298147,
			[
				["bg01_09-sheet0.png", 215641, 0, 0, 455, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		5839481581907027,
		[],
		null
	]
,	[
		"t122",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			3904229624180192,
			[
				["bg01_10-sheet0.png", 212436, 0, 0, 455, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		3361197152434262,
		[],
		null
	]
,	[
		"t123",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9860493243719498,
			[
				["sprite-sheet0.png", 35977, 0, 0, 569, 320, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		],
		false,
		true,
		1700030227852381,
		[],
		null
	]
,	[
		"t124",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8019836055397592,
			[
				["sprite2-sheet0.png", 92, 0, 0, 10, 10, 1, 0.5, 0.5,[],[],1]
			]
			]
		],
		[
		],
		false,
		true,
		2245032117713357,
		[],
		null
	]
,	[
		"t125",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			3254656860114364,
			[
				["bg02_01-sheet0.png", 152566, 0, 0, 500, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		9468465609196495,
		[],
		null
	]
,	[
		"t126",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			4753348313069513,
			[
				["bg02_02-sheet0.png", 172767, 0, 0, 500, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		8261652242255536,
		[],
		null
	]
,	[
		"t127",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			1963115680840464,
			[
				["bg02_03-sheet0.png", 170498, 0, 0, 500, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		9293845412981809,
		[],
		null
	]
,	[
		"t128",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			9841318067562778,
			[
				["bg02_04-sheet0.png", 169681, 0, 0, 500, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		7157533038720809,
		[],
		null
	]
,	[
		"t129",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			4812018233030122,
			[
				["bg02_05-sheet0.png", 169199, 0, 0, 500, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		8585493639107853,
		[],
		null
	]
,	[
		"t130",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			1148080848091418,
			[
				["bg02_06-sheet0.png", 170787, 0, 0, 500, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		3910159477536884,
		[],
		null
	]
,	[
		"t131",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			7116072038970802,
			[
				["bg02_07-sheet0.png", 172192, 0, 0, 500, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		7951926901633487,
		[],
		null
	]
,	[
		"t132",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			8500729181933824,
			[
				["bg02_08-sheet0.png", 168590, 0, 0, 500, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		7277599842642874,
		[],
		null
	]
,	[
		"t133",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			2694214255672582,
			[
				["bg03_01-sheet0.png", 68381, 0, 0, 500, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		645442823435313,
		[],
		null
	]
,	[
		"t134",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			6551332234301185,
			[
				["bg03_02-sheet0.png", 71447, 0, 0, 500, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		3298798561712621,
		[],
		null
	]
,	[
		"t135",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			547082453910428,
			[
				["bg03_03-sheet0.png", 98292, 0, 0, 500, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		4369023757544682,
		[],
		null
	]
,	[
		"t136",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			7421123130019346,
			[
				["bg03_04-sheet0.png", 63561, 0, 0, 500, 320, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		8158550706359523,
		[],
		null
	]
,	[
		"t137",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			2031086028981145,
			[
				["bg03_05-sheet0.png", 63186, 0, 0, 500, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		1298625449810037,
		[],
		null
	]
,	[
		"t138",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			6373818675151595,
			[
				["bg03_06-sheet0.png", 96192, 0, 0, 500, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		658318940467814,
		[],
		null
	]
,	[
		"t139",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			5868000434708605,
			[
				["bg03_07-sheet0.png", 71411, 0, 0, 500, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		4243489950296648,
		[],
		null
	]
,	[
		"t140",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			0,
			0,
			false,
			4145693345991073,
			[
				["bg03_08-sheet0.png", 68894, 0, 0, 500, 320, 1, 0, 0,[],[1,1,0,1,0,0,1,0],1]
			]
			]
		],
		[
		],
		false,
		false,
		4785885676060827,
		[],
		null
	]
,	[
		"t141",
		cr.plugins_.TiledBg,
		false,
		[],
		0,
		0,
		["tiledbackground.png", 4287, 0],
		null,
		[
		],
		false,
		true,
		3376563897769195,
		[],
		null
	]
	],
	[
	],
	[
	[
		"Fase1",
		569,
		320,
		true,
		"Fase1",
		1467933635595578,
		[
		[
			"Background",
			0,
			2349238537963748,
			true,
			[0, 0, 0],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[346, -492, 0, 500, 320, 0, 0, 1, 0.5, 0, 0, 0, []],
				15,
				73,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[849, -498, 0, 500, 320, 0, 0, 1, 0.5, 0, 0, 0, []],
				97,
				119,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[0, 0, 0, 455, 320, 0, 0, 1, 0, 0, 0, 0, []],
				113,
				137,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[455, 0, 0, 455, 320, 0, 0, 1, 0, 0, 0, 0, []],
				114,
				138,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[910, 0, 0, 455, 320, 0, 0, 1, 0, 0, 0, 0, []],
				115,
				139,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[1365, 0, 0, 455, 320, 0, 0, 1, 0, 0, 0, 0, []],
				116,
				140,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[1820, 0, 0, 455, 320, 0, 0, 1, 0, 0, 0, 0, []],
				117,
				141,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[2275, 0, 0, 455, 320, 0, 0, 1, 0, 0, 0, 0, []],
				118,
				142,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[2730, 0, 0, 455, 320, 0, 0, 1, 0, 0, 0, 0, []],
				119,
				143,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[3185, 0, 0, 455, 320, 0, 0, 1, 0, 0, 0, 0, []],
				120,
				144,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[3640, 0, 0, 455, 320, 0, 0, 1, 0, 0, 0, 0, []],
				121,
				145,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[4095, 0, 0, 455, 320, 0, 0, 1, 0, 0, 0, 0, []],
				122,
				146,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[-135, 820, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				125,
				118,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[375, 830, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				126,
				147,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[905, 830, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				127,
				148,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[1405, 830, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				128,
				149,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[1915, 830, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				129,
				150,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[2425, 840, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				130,
				151,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[2905, 840, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				131,
				152,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[3405, 830, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				132,
				153,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[-195, 1330, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				133,
				154,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[345, 1350, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				134,
				155,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[865, 1360, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				135,
				156,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[1395, 1350, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				136,
				157,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[1915, 1340, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				137,
				158,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[2445, 1340, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				138,
				159,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[2995, 1340, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				139,
				160,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[3535, 1360, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				140,
				161,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
			],
			[			]
		]
,		[
			"Game",
			1,
			1469515691606569,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[-989, -955, 0, 821, 320, 0, 0, 1, 0, 0, 0, 0, []],
				19,
				9,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-895, -1119, 0, 548, 125, 0, 0, 1, 0, 0, 0, 0, []],
				17,
				7,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[439.8035583496094, 222, 0, 571, 102, 0, 0, 1, 0.001751313451677561, 0.009803921915590763, 0, 0, []],
				18,
				8,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-929, -585, 0, 650, 214, 0, 0, 1, 0, 0, 0, 0, []],
				21,
				10,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-1112, -300, 0, 884, 280, 0, 0, 1, 0, 0, 0, 0, []],
				26,
				12,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-2022, -286, 0, 884, 280, 0, 0, 1, 0, 0, 0, 0, []],
				23,
				13,
				[
				],
				[
				[
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-3205, -250, 0, 884, 280, 0, 0, 1, 0, 0, 0, 0, []],
				24,
				14,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-1763, -576, 0, 650, 214, 0, 0, 1, 0, 0, 0, 0, []],
				22,
				29,
				[
				],
				[
				[
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-130.8554992675781, 0.798248291015625, 0, 550, 320, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				2,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-2551, -210, 0, 884, 280, 0, 0, 1, 0, 0, 0, 0, []],
				25,
				21,
				[
				],
				[
				[
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-455, 259, 0, 90, 72, 0, 0, 1, 0.5111111402511597, 0.5, 0, 0, []],
				11,
				31,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-702, 279, 0, 90, 72, 0, 0, 1, 0.5111111402511597, 0.5833333134651184, 0, 0, []],
				12,
				53,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-258, 279, 0, 90, 72, 0, 0, 1, 0.5111111402511597, 0.3888888955116272, 0, 0, []],
				13,
				54,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-953, 316, 0, 71, 32, 0, 0, 1, 0.5211267471313477, 0.46875, 0, 0, []],
				14,
				55,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-1951, -940, 0, 821, 320, 0, 0, 1, 0, 0, 0, 0, []],
				20,
				56,
				[
				],
				[
				[
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-928, 546, 0, 64, 79, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				54,
				57,
				[
				],
				[
				[
					30,
					1500,
					1500,
					650,
					1500,
					1000,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-690, 949, 0, 373, 175, 0, 0, 1, 0, 0, 0, 0, []],
				27,
				46,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-1168, 932, 0, 418, 220, 0, 0, 1, 0, 0, 0, 0, []],
				28,
				3,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-1775, 921, 0, 468, 225, 0, 0, 1, 0, 0, 0, 0, []],
				29,
				48,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-2327, 929, 0, 430, 217, 0, 0, 1, 0, 0, 0, 0, []],
				30,
				44,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-2863, 942, 0, 370, 152, 0, 0, 1, 0, 0, 0, 0, []],
				32,
				50,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-2895, 619, 0, 436, 220, 0, 0, 1, 0, 0, 0, 0, []],
				34,
				51,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[220, -130, 0, 128, 128, 0, -0.02397803403437138, 1, 0, 0.5, 0, 0, []],
				85,
				103,
				[
				],
				[
				],
				[
					25,
					360,
					1,
					30,
					32,
					100,
					0,
					5,
					5,
					0,
					40,
					0,
					-50,
					0,
					0,
					800,
					0,
					0,
					1
				]
			]
,			[
				[150, 1930, 0, 704, 157, 0, 0, 1, 0, 0, 0, 0, []],
				39,
				116,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[210, 2257, 0, 704, 157, 0, 0, 1, 0, 0, 0, 0, []],
				40,
				117,
				[
				],
				[
				[
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-1114, 1871, 0, 871, 253, 0, 0, 1, 0, 0, 0, 0, []],
				38,
				60,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-1886, 1867, 0, 446, 199, 0, 0, 1, 0, 0, 0, 0, []],
				36,
				61,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-1880, 2240, 0, 446, 199, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				62,
				[
				],
				[
				[
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-3174, 1794, 0, 854, 216, 0, 0, 1, 0, 0, 0, 0, []],
				37,
				63,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-3481, 588, 0, 436, 220, 0, 0, 1, 0, 0, 0, 0, []],
				31,
				40,
				[
				],
				[
				[
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-3351, 956, 0, 370, 152, 0, 0, 1, 0, 0, 0, 0, []],
				33,
				34,
				[
				],
				[
				[
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Player",
			2,
			6152648285084086,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[-395, 827, 0, 36, 57, 0, 0, 1, 0.5, 0.5263158082962036, 0, 0, []],
				50,
				15,
				[
				],
				[
				[
					0,
					0,
					0,
					0.4,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-538, 826, 0, 36, 57, 0, 0, 1, 0.5, 0.5263158082962036, 0, 0, []],
				51,
				32,
				[
				],
				[
				[
					0,
					0,
					0,
					0.4,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-469, 821, 0, 36, 57, 0, 0, 1, 0.5, 0.5263158082962036, 0, 0, []],
				52,
				33,
				[
				],
				[
				[
					0,
					0,
					0,
					0.4,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-150, 350, 0, 128, 128, 0, 0, 1, 0, 0.5, 0, 0, []],
				55,
				11,
				[
				],
				[
				],
				[
					80,
					5,
					0,
					-50,
					3,
					100,
					0,
					0,
					0,
					0,
					7,
					0,
					-150,
					0,
					0,
					800,
					0,
					0,
					1
				]
			]
,			[
				[110, 195, 0, 10, 10, 0, 0, 1, 0.5, 0.6000000238418579, 0, 0, []],
				56,
				42,
				[
				],
				[
				[
					1,
					0,
					0,
					4,
					0,
					0,
					0,
					15,
					0
				],
				[
					1,
					1,
					0,
					1,
					0,
					0,
					0,
					10,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-150, 400, 0, 128, 128, 0, 2.055252075195313, 1, 0, 0.5, 0, 0, []],
				57,
				43,
				[
				],
				[
				[
				]
				],
				[
					50,
					60,
					0,
					50,
					2,
					100,
					0,
					0,
					0,
					0,
					5,
					0,
					-150,
					0,
					0,
					800,
					0,
					0,
					0.5
				]
			]
,			[
				[-114, 125, 0, 30, 30, 0, 0, 0.800000011920929, 0.5, 0.5, 0, 0, []],
				41,
				45,
				[
				],
				[
				[
					1,
					1,
					0,
					3,
					0,
					0,
					0,
					100,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-109, 185, 0, 70, 45, 0, 0, 1, 0.5142857432365418, 0.5111111402511597, 0, 0, []],
				48,
				1,
				[
				],
				[
				[
					250,
					200,
					0,
					700,
					1450,
					1000,
					0,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[772, -628, 0, 128, 128, 0, 0, 1, 0, 0.5, 0, 0, []],
				42,
				58,
				[
				],
				[
				],
				[
					30,
					60,
					0,
					50,
					5,
					100,
					0,
					10,
					30,
					0,
					15,
					0,
					-150,
					0,
					0,
					800,
					0,
					0,
					1
				]
			]
,			[
				[1896, -786, 0, 128, 128, 0, 5.375999990064884e-006, 1, 0, 0.5, 0, 0, []],
				43,
				59,
				[
				],
				[
				],
				[
					150,
					60,
					1,
					-100,
					5,
					100,
					0,
					50,
					50,
					0,
					12,
					0,
					-100,
					0,
					0,
					800,
					0,
					0,
					2
				]
			]
,			[
				[180, 150, 0, 128, 128, 0, -3.129915237426758, 1, 0, 0.5, 0, 0, []],
				89,
				107,
				[
				],
				[
				],
				[
					80,
					60,
					0,
					200,
					32,
					100,
					0,
					0,
					20,
					0,
					90,
					0,
					-150,
					0,
					0,
					800,
					0,
					0,
					1
				]
			]
,			[
				[-109, 185, 0, 70, 45, 0, 0, 1, 0.5, 0.5111111402511597, 0, 0, []],
				58,
				22,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[50, -110, 0, 80, 80, 0, 0, 0.699999988079071, 0.5, 0.5, 0, 0, []],
				84,
				102,
				[
				],
				[
				[
					-100,
					0
				],
				[
					0,
					0,
					0,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-71, -179, 0, 148, 148, 0, 0, 0.2000000029802322, 0.5135135054588318, 0.4864864945411682, 0, 0, []],
				83,
				101,
				[
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[130, 140, 0, 30, 30, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				86,
				104,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"UI",
			3,
			9171778070915424,
			true,
			[255, 255, 255],
			true,
			0,
			0,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[4, 35, 0, 138.5084381103516, 35.05384063720703, 0, 0, 1, 0, 0, 0, 0, []],
				6,
				47,
				[
				],
				[
				],
				[
					35,
					35,
					"0123456789",
					"0",
					0.5,
					0,
					0,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[2, 1.16100001335144, 0, 154.2698059082031, 35.09466552734375, 0, 0, 1, 0, 0, 0, 0, []],
				8,
				41,
				[
				],
				[
				],
				[
					35,
					35,
					"0123456789",
					"0",
					0.7,
					0,
					0,
					0,
					0,
					0,
					-10,
					0
				]
			]
,			[
				[76.7138671875, 45.78337860107422, 0, 128, 128, 0, -1.570834159851074, 1, 0, 0.5, 0, 0, []],
				66,
				76,
				[
				],
				[
				],
				[
					30,
					60,
					0,
					80,
					10,
					100,
					0,
					5,
					0,
					0,
					20,
					0,
					-150,
					0,
					0,
					800,
					0,
					0,
					1
				]
			]
,			[
				[77.32298278808594, 42.08082580566406, 0, 30, 14, 0, 0, 1, 0.5333333611488342, 0.5714285969734192, 0, 0, []],
				0,
				75,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[15.74171352386475, 66.17744445800781, 0, 25, 23, 0, 0, 1, 0.5199999809265137, 0.52173912525177, 0, 0, []],
				87,
				105,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[539, 28, 0, 30.72608184814453, 29.29107475280762, 0, 0, 1, 0.5, 0.5014409422874451, 0, 0, []],
				88,
				106,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[365, 420, 0, 762, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				99,
				121,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, -100, 0, 762, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				99,
				162,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"GameOver",
			4,
			6842909581184004,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[409.1080627441406, 490.1759948730469, 0, 818.2161254882813, 340.3527526855469, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				61,
				64,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[438, 586, 0, 228, 110, 0, 0, 1, 0.5, 0.5090909004211426, 0, 0, []],
				5,
				65,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[488.2945556640625, 476.1768188476563, 0, 131, 108, 0, 0, 1, 0.5038167834281921, 0.5, 0, 0, []],
				3,
				67,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[8, 470, 0, 227, 42, 0, -0.1745333671569824, 1, 0, 0, 0, 0, []],
				9,
				68,
				[
				],
				[
				[
				]
				],
				[
					35,
					35,
					"0123456789m",
					"0",
					1.2,
					0,
					0,
					0,
					0,
					0,
					-10,
					0
				]
			]
,			[
				[159, 490, 0, 140, 30, 0, 0, 1, 0, 0, 0, 0, []],
				7,
				69,
				[
				],
				[
				[
				]
				],
				[
					35,
					35,
					"0123456789",
					"19000",
					0.8,
					0,
					0,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[169.5857696533203, 582.2454833984375, 0, 206.376220703125, 117.1065139770508, 0, 3.141592741012573, 1, 0.5023255944252014, 0.5, 0, 0, []],
				4,
				70,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[137, 403, 0, 200, 38, 0, 0, 1, 0, 0, 0, 0, []],
				63,
				74,
				[
				],
				[
				[
				]
				],
				[
					35,
					35,
					"0123456789",
					"0",
					1,
					0,
					0,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[149, 501, 0, 20, 30, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				10,
				39,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[70, 416, 0, 103, 38, 0, 0, 1, 0.5048543810844421, 0.5263158082962036, 0, 0, []],
				1,
				72,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[367, 490, 0, 82, 74, 0, 0, 1, 0.5121951103210449, 0.5, 0, 0, []],
				2,
				66,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
			],
			[			]
		]
,		[
			"Pause",
			5,
			9099737605102134,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[369.06884765625, 160, 0, 738.1376953125, 320, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				90,
				108,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[355, 140, 0, 122, 58, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				91,
				109,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[225, 140, 0, 122, 58, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				92,
				110,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[285, 210, 0, 122, 58, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				93,
				111,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[284.5, 49, 0, 588, 110, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				94,
				112,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
			],
			[			]
		]
,		[
			"transition",
			6,
			7271865391100531,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[284.5, 160, 0, 600, 380, 0, 0, 0, 0.5, 0.5, 0, 0, []],
				111,
				135,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 160, 0, 600, 380, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				112,
				136,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"MainMenu",
		569,
		320,
		true,
		"MainMenu",
		1848252332209993,
		[
		[
			"Layer 0",
			0,
			2367717241824433,
			true,
			[0, 0, 0],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				133,
				163,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[500, 0, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				134,
				164,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1000, 0, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				135,
				165,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1500, 0, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				136,
				166,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[2000, 0, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				137,
				167,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[2500, 0, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				138,
				168,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[3000, 0, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				139,
				169,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[3500, 0, 0, 500, 320, 0, 0, 1, 0, 0, 0, 0, []],
				140,
				170,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 657, 0, 1065, 1082, 0, 0, 1, 0.4849624037742615, 0.4768946468830109, 0, 0, []],
				65,
				28,
				[
				],
				[
				[
					-30,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[55.33489990234375, 297.114990234375, 0, 89, 42, 0, 0, 1, 0.5056179761886597, 0.5, 0, 0, []],
				100,
				122,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 285.0849609375, 0, 244, 34, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				98,
				120,
				[
				],
				[
				[
					1,
					1,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[525, 286, 0, 56, 45, 0, 0, 1, 0.5, 0.5111111402511597, 0, 0, []],
				64,
				27,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 223.6677398681641, 0, 70, 45, 0, 0, 1, 0.5, 0.5111111402511597, 0, 0, []],
				58,
				30,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[284.5, 12.50556945800781, 0, 300, 82, 0, 0, 1, 0.5, 0, 0, 0, []],
				53,
				6,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, -100, 0, 762, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				99,
				177,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 420, 0, 762, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				99,
				178,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"transition",
			1,
			3487938157176547,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[284.5, 160, 0, 600, 380, 0, 0, 0, 0.5, 0.5, 0, 0, []],
				111,
				5,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 160, 0, 600, 380, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				112,
				18,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"shopItems",
		569,
		320,
		true,
		"shopItems",
		2609536695863558,
		[
		[
			"Layer 0",
			0,
			6306635122396602,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 569, 320, 0, 0, 1, 0, 0, 0, 0, []],
				104,
				17,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[284.5, 130, 0, 577, 78, 0, 0, 1, 0.5008665323257446, 0.5128205418586731, 0, 0, []],
				67,
				80,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 200, 0, 577, 78, 0, 0, 1, 0.5008665323257446, 0.5128205418586731, 0, 0, []],
				68,
				81,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 270, 0, 577, 78, 0, 0, 1, 0.5008665323257446, 0.5128205418586731, 0, 0, []],
				69,
				84,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 340, 0, 577, 78, 0, 0, 1, 0.5008665323257446, 0.5128205418586731, 0, 0, []],
				70,
				85,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[135, 135, 0, 62, 27, 0, 0, 1, 0.5, 0.5185185074806213, 0, 0, []],
				44,
				82,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[220, 135, 0, 85, 28, 0, 0, 1, 0.5058823823928833, 0.5, 0, 0, []],
				46,
				83,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[135, 205, 0, 62, 27, 0, 0, 1, 0.5, 0.5185185074806213, 0, 0, []],
				71,
				86,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[220, 205, 0, 85, 28, 0, 0, 1, 0.5058823823928833, 0.5, 0, 0, []],
				72,
				87,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[135, 275, 0, 62, 27, 0, 0, 1, 0.5, 0.5185185074806213, 0, 0, []],
				73,
				88,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[220, 275, 0, 85, 28, 0, 0, 1, 0.5058823823928833, 0.5, 0, 0, []],
				74,
				89,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[135, 345, 0, 62, 27, 0, 0, 1, 0.5, 0.5185185074806213, 0, 0, []],
				75,
				90,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[220, 345, 0, 85, 28, 0, 0, 1, 0.5058823823928833, 0.5, 0, 0, []],
				76,
				91,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[500, 135, 0, 115, 28, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				77,
				92,
				[
				],
				[
				[
				]
				],
				[
					35,
					35,
					"0123456789mx",
					"1000",
					0.7,
					0,
					1,
					1,
					1,
					0,
					0,
					0
				]
			]
,			[
				[501, 205, 0, 115, 28, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				77,
				93,
				[
				],
				[
				[
				]
				],
				[
					35,
					35,
					"0123456789mx",
					"1000",
					0.7,
					0,
					1,
					1,
					1,
					0,
					0,
					0
				]
			]
,			[
				[502, 275, 0, 115, 28, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				77,
				94,
				[
				],
				[
				[
				]
				],
				[
					35,
					35,
					"0123456789mx",
					"1000",
					0.7,
					0,
					1,
					1,
					1,
					0,
					0,
					0
				]
			]
,			[
				[500, 345, 0, 115, 28, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				77,
				95,
				[
				],
				[
				[
				]
				],
				[
					35,
					35,
					"0123456789mx",
					"1000",
					0.7,
					0,
					1,
					1,
					1,
					0,
					0,
					0
				]
			]
,			[
				[284.5, 410, 0, 577, 78, 0, 0, 1, 0.5008665323257446, 0.5064935088157654, 0, 0, []],
				110,
				127,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 281, 0, 569, 376, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				78,
				96,
				[
				],
				[
				[
					2,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 49, 0, 587, 110, 0, 0, 1, 0.5008518099784851, 0.5, 0, 0, []],
				47,
				78,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[74, 19, 0, 320, 68, 0, 0, 1, 0, 0, 0, 0, []],
				45,
				79,
				[
				],
				[
				],
				[
					35,
					35,
					"0123456789",
					"1721721",
					1.2,
					0,
					0,
					0,
					0,
					0,
					-10,
					0
				]
			]
,			[
				[437, 37, 0, 87, 71, 0, 0, 1, 0.5021833777427673, 0.5026454925537109, 0, 0, []],
				79,
				97,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-124, 144, 0, 87, 71, 0, 0, 1, 0.5021833777427673, 0.5026454925537109, 0, 0, []],
				80,
				98,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-121, 214, 0, 87, 71, 0, 0, 1, 0.5021833777427673, 0.5026454925537109, 0, 0, []],
				81,
				99,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-119, 289, 0, 87, 71, 0, 0, 1, 0.5021833777427673, 0.5026454925537109, 0, 0, []],
				82,
				100,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[44, 292, 0, 71.02983093261719, 41.56000518798828, 0, 0, 1, 0.5, 0.5090909004211426, 0, 0, []],
				108,
				36,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 420, 0, 762, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				99,
				171,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, -100, 0, 762, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				99,
				172,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"transition",
			1,
			2322130885027977,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[284.5, 160, 0, 600, 380, 0, 0, 0, 0.5, 0.5, 0, 0, []],
				111,
				131,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 160, 0, 600, 380, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				112,
				132,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"Credits",
		569,
		320,
		true,
		"Credits",
		6603154594116034,
		[
		[
			"Layer 0",
			0,
			8020798500959019,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[284.5, 160, 0, 569, 320, 0, 0, 1, 0.5008787512779236, 0.5, 0, 0, []],
				101,
				123,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[76, 56, 0, 94, 55, 0, 0, 1, 0.5, 0.5090909004211426, 0, 0, []],
				102,
				124,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"shopSection",
		569,
		320,
		true,
		"shopSection",
		4848490536802041,
		[
		[
			"Layer 0",
			0,
			8971844675782034,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 569, 320, 0, 0, 1, 0, 0, 0, 0, []],
				104,
				19,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[426.75, 183, 0, 127, 92, 0, 0, 1, 0.5039370059967041, 0.5, 0, 0, []],
				106,
				20,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[142.25, 183, 0, 127, 92, 0, 0, 1, 0.5039370059967041, 0.5, 0, 0, []],
				107,
				23,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 47, 0, 587, 110, 0, 0, 1, 0.5008518099784851, 0.5, 0, 0, []],
				47,
				37,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[31, 291, 0, 47.91659545898438, 43.24180603027344, 0, 0, 1, 0.5121951103210449, 0.5, 0, 0, []],
				2,
				38,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[74, 19, 0, 320, 68, 0, 0, 1, 0, 0, 0, 0, []],
				45,
				129,
				[
				],
				[
				],
				[
					35,
					35,
					"0123456789",
					"1721721",
					1.2,
					0,
					0,
					0,
					0,
					0,
					-10,
					0
				]
			]
,			[
				[284.5, 420, 0, 762, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				99,
				175,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, -100, 0, 762, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				99,
				176,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"transition",
			1,
			2148359131484925,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[284.5, 160, 0, 600, 380, 0, 0, 0, 0.5, 0.5, 0, 0, []],
				111,
				113,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 160, 0, 600, 380, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				112,
				130,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"shopClothes",
		569,
		320,
		true,
		"shopClothes",
		5667745912973101,
		[
		[
			"Layer 0",
			0,
			8485773176228684,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 569, 320, 0, 0, 1, 0, 0, 0, 0, []],
				104,
				52,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[284.5, 134, 0, 262.9389343261719, 41.95326995849609, 0, 0, 1, 0.5012048482894898, 0.5074626803398132, 0, 0, []],
				109,
				77,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 49, 0, 587, 110, 0, 0, 1, 0.5008518099784851, 0.5, 0, 0, []],
				47,
				125,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[44, 292, 0, 71.02983093261719, 41.56000518798828, 0, 0, 1, 0.5, 0.5090909004211426, 0, 0, []],
				108,
				126,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[74, 19, 0, 320, 68, 0, 0, 1, 0, 0, 0, 0, []],
				45,
				128,
				[
				],
				[
				],
				[
					35,
					35,
					"0123456789",
					"1721721",
					1.2,
					0,
					0,
					0,
					0,
					0,
					-10,
					0
				]
			]
,			[
				[284.5, 420, 0, 762, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				99,
				173,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, -100, 0, 762, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				99,
				174,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"transition",
			1,
			3060896702360103,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[284.5, 160, 0, 600, 380, 0, 0, 0, 0.5, 0.5, 0, 0, []],
				111,
				133,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 160, 0, 600, 380, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				112,
				134,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"Loading",
		569,
		320,
		true,
		"Loading",
		4808633466555496,
		[
		[
			"Layer 0",
			0,
			5063130933258462,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[284.98828125, 232.5, 0, 86, 137, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				124,
				35,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[0, 0, 0, 569, 320, 0, 0, 1, 0, 0, 0, 0, []],
				123,
				0,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284.5, 153, 0, 200, 38, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				63,
				49,
				[
				],
				[
				[
				]
				],
				[
					35,
					35,
					"0123456789",
					"0",
					0.5,
					0,
					1,
					1,
					1,
					0,
					0,
					0
				]
			]
,			[
				[285, 295.740966796875, 0, 84, -0.0006103515625, 0, 3.141592741012573, 1, 0.5, 0.5, 0, 0, []],
				141,
				26,
				[
				],
				[
				],
				[
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
	],
	[
	[
		"Fase1",
		[
		[
			2,
			"transitions",
			false
		]
,		[
			2,
			"fodage",
			false
		]
,		[
			2,
			"Cristais",
			false
		]
,		[
			2,
			"Player",
			false
		]
,		[
			1,
			"AirSpawn",
			0,
			0,
false,false,2026652369192975,false
		]
,		[
			1,
			"cristalType",
			0,
			0,
false,false,61542552861395,false
		]
,		[
			1,
			"spawnCristal",
			0,
			0,
false,false,9042859834335793,false
		]
,		[
			1,
			"spawn",
			0,
			1,
false,false,3783715314374354,false
		]
,		[
			1,
			"TotalDistance",
			0,
			0,
false,false,7887643382280267,false
		]
,		[
			1,
			"CurrentDistance",
			0,
			0,
false,false,4673367897468756,false
		]
,		[
			1,
			"NextBlock",
			0,
			600,
false,false,191991042476716,false
		]
,		[
			0,
			null,
			false,
			null,
			4455595324536928,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				1794005359380503,
				false
			]
			],
			[
			[
				58,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				1866694372106874,
				false
				,[
				[
					1,
					[
						2,
						"Run"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				41,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				4401087079772856,
				false
			]
,			[
				58,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				2790131358202876,
				false
				,[
				[
					4,
					48
				]
,				[
					3,
					0
				]
				]
			]
,			[
				5,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				4286426708603608,
				false
				,[
				[
					4,
					61
				]
,				[
					3,
					0
				]
				]
			]
,			[
				3,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				8747306406038154,
				false
				,[
				[
					4,
					61
				]
,				[
					3,
					0
				]
				]
			]
,			[
				2,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				8300330803101497,
				false
				,[
				[
					4,
					61
				]
,				[
					3,
					0
				]
				]
			]
,			[
				4,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				7243885428042444,
				false
				,[
				[
					4,
					61
				]
,				[
					3,
					0
				]
				]
			]
,			[
				7,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				9197243517447923,
				false
				,[
				[
					4,
					61
				]
,				[
					3,
					0
				]
				]
			]
,			[
				9,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				8482727442324385,
				false
				,[
				[
					4,
					61
				]
,				[
					3,
					0
				]
				]
			]
,			[
				63,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				105421644092946,
				false
				,[
				[
					4,
					61
				]
,				[
					3,
					0
				]
				]
			]
,			[
				10,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				4377607955723046,
				false
				,[
				[
					4,
					61
				]
,				[
					3,
					0
				]
				]
			]
,			[
				1,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				3134566556816672,
				false
				,[
				[
					4,
					61
				]
,				[
					3,
					0
				]
				]
			]
,			[
				15,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				3632571040349207,
				false
			]
,			[
				97,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				2973863074308102,
				false
			]
,			[
				66,
				cr.plugins_.Particles.prototype.acts.SetVisible,
				null,
				7409038372021242,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				89,
				cr.plugins_.Particles.prototype.acts.SetVisible,
				null,
				7832483623576417,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				103,
				cr.plugins_.CJSAds.prototype.acts.HideBanner,
				null,
				3633305348452301,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8964331387354898,
			[
			[
				60,
				cr.plugins_.Audio.prototype.cnds.IsTagPlaying,
				null,
				0,
				false,
				false,
				false,
				7062086391973141,
				false
				,[
				[
					1,
					[
						2,
						"shop"
					]
				]
				]
			]
			],
			[
			[
				60,
				cr.plugins_.Audio.prototype.acts.SetVolume,
				null,
				952104884221271,
				false
				,[
				[
					1,
					[
						2,
						"shop"
					]
				]
,				[
					0,
					[
						5,
						[
							20,
							60,
							cr.plugins_.Audio.prototype.exps.Volume,
							false,
							null
							,[
[
								2,
								"shop"
							]
							]
						]
						,[
							1,
							0.3
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				791264482374316,
				false
				,[
				[
					0,
					[
						1,
						0.8
					]
				]
				]
			]
,			[
				60,
				cr.plugins_.Audio.prototype.acts.Stop,
				null,
				5510835258283327,
				false
				,[
				[
					1,
					[
						2,
						"shop"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6344280318359791,
			[
			[
				60,
				cr.plugins_.Audio.prototype.cnds.IsTagPlaying,
				null,
				0,
				false,
				true,
				false,
				3701873022547684,
				false
				,[
				[
					1,
					[
						2,
						"01"
					]
				]
				]
			]
			],
			[
			[
				60,
				cr.plugins_.Audio.prototype.acts.PlayByName,
				null,
				3735031132014809,
				false
				,[
				[
					3,
					1
				]
,				[
					1,
					[
						2,
						"Hard Rain"
					]
				]
,				[
					3,
					1
				]
,				[
					0,
					[
						0,
						-20
					]
				]
,				[
					1,
					[
						2,
						"01"
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Backgrounds"],
			false,
			null,
			4922436447989024,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4922436447989024,
				false
				,[
				[
					1,
					[
						2,
						"Backgrounds"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Transações"],
				false,
				null,
				2986762396040206,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					2986762396040206,
					false
					,[
					[
						1,
						[
							2,
							"Transações"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					3161268460094718,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						8107066989214579,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								500
							]
						]
						]
					]
,					[
						113,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						2468628860972947,
						false
						,[
						[
							8,
							3
						]
,						[
							0,
							[
								5,
								[
									6,
									[
										20,
										113,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										10
									]
								]
								,[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						6921042402667121,
						false
						,[
						[
							7,
							[
								20,
								15,
								cr.plugins_.Sprite.prototype.exps.Count,
								false,
								null
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						5035419621156878,
						false
						,[
						[
							4,
							15
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									113,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									6,
									[
										20,
										113,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										10
									]
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4603815887221779,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						2968957484093455,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								3000
							]
						]
						]
					]
,					[
						125,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						6739594341048515,
						false
						,[
						[
							8,
							3
						]
,						[
							0,
							[
								5,
								[
									6,
									[
										20,
										125,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										8
									]
								]
								,[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						7371113008906637,
						false
						,[
						[
							7,
							[
								20,
								97,
								cr.plugins_.Sprite.prototype.exps.Count,
								false,
								null
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						945602845681952,
						false
						,[
						[
							4,
							97
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									125,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									6,
									[
										20,
										125,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										8
									]
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Fase01"],
				false,
				null,
				9524733764790065,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					9524733764790065,
					false
					,[
					[
						1,
						[
							2,
							"Fase01"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7430074102805055,
					[
					[
						113,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						8287822153998644,
						false
						,[
						[
							8,
							3
						]
,						[
							0,
							[
								6,
								[
									3,
									[
										20,
										113,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
								]
								,[
									1,
									5
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						4639808633464365,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								500
							]
						]
						]
					]
					],
					[
					[
						113,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						6604304162265757,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									113,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									6,
									[
										20,
										113,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										1,
										5
									]
								]
							]
						]
						]
					]
,					[
						114,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						6280488985568339,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									113,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									114,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						115,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						4841877910535875,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									114,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									115,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						116,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						2825036839030404,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									115,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									116,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						117,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						1496824044937243,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									116,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									117,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						118,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						1491105020721476,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									117,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									118,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						119,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						5012408623411952,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									118,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									119,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						120,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						9895998706935616,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									119,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									120,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						121,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						1952423577232077,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									120,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									121,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						122,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						1951513627342038,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									121,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									122,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8458915578984848,
					[
					[
						113,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						9407691586125971,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								6,
								[
									3,
									[
										20,
										113,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
								]
								,[
									0,
									10
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						8468825401054224,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								500
							]
						]
						]
					]
					],
					[
					[
						113,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						4721494451502477,
						false
					]
,					[
						114,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						8314874638062305,
						false
					]
,					[
						115,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5038009434806021,
						false
					]
,					[
						116,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						2437374371529851,
						false
					]
,					[
						117,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						9719808119077567,
						false
					]
,					[
						118,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6548542123037871,
						false
					]
,					[
						119,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6415960817624286,
						false
					]
,					[
						120,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						817963209658383,
						false
					]
,					[
						121,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6846096886716108,
						false
					]
,					[
						122,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						864957042852072,
						false
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Fase03"],
				false,
				null,
				1642962554205293,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					1642962554205293,
					false
					,[
					[
						1,
						[
							2,
							"Fase03"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8704210393393668,
					[
					[
						132,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						8073423427977469,
						false
						,[
						[
							8,
							3
						]
,						[
							0,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
								,[
									20,
									132,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						9622278526517135,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								3000
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						5180057106218107,
						false
						,[
						[
							7,
							[
								20,
								133,
								cr.plugins_.Sprite.prototype.exps.Count,
								false,
								null
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						6907433070165382,
						false
						,[
						[
							4,
							133
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									132,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									132,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8008650769975979,
						false
						,[
						[
							4,
							134
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									133,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									133,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						3372209677827852,
						false
						,[
						[
							4,
							135
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									134,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									134,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						9715360284141754,
						false
						,[
						[
							4,
							136
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									135,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									135,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						4501652822181338,
						false
						,[
						[
							4,
							137
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									136,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									136,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						3316651796127372,
						false
						,[
						[
							4,
							138
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									137,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									137,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8032353809507835,
						false
						,[
						[
							4,
							139
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									138,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									138,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7820818359681458,
						false
						,[
						[
							4,
							140
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									139,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									139,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						97,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						4005974388904871,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9503914556231929,
					[
					[
						133,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						6067184095082274,
						false
						,[
						[
							8,
							3
						]
,						[
							0,
							[
								6,
								[
									3,
									[
										20,
										133,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
								]
								,[
									1,
									4
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						8220907718952399,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								3000
							]
						]
						]
					]
					],
					[
					[
						133,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						743311456553497,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									133,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									6,
									[
										20,
										133,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										1,
										4
									]
								]
							]
						]
						]
					]
,					[
						134,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						2535185208613867,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									133,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									134,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						135,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						6701443471069374,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									134,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									135,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						136,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						8634523883156242,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									135,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									136,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						137,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						282922280986377,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									136,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									137,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						138,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						9219583463603637,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									137,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									138,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						139,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						3439146225899715,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									138,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									139,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						140,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						5648185510411548,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									139,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									140,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Fase02"],
				false,
				null,
				1144778432093556,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					1144778432093556,
					false
					,[
					[
						1,
						[
							2,
							"Fase02"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					1757772682389173,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						1785611309085169,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								500
							]
						]
						]
					]
,					[
						122,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						1818206258251941,
						false
						,[
						[
							8,
							3
						]
,						[
							0,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
								,[
									20,
									122,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						6963493109570266,
						false
						,[
						[
							7,
							[
								20,
								125,
								cr.plugins_.Sprite.prototype.exps.Count,
								false,
								null
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8520742911375747,
						false
						,[
						[
							4,
							125
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									122,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									122,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7688300407012571,
						false
						,[
						[
							4,
							126
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									125,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									125,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8637560355339311,
						false
						,[
						[
							4,
							127
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									126,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									126,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						895287999250672,
						false
						,[
						[
							4,
							128
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									127,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									127,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7377340346993514,
						false
						,[
						[
							4,
							129
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									128,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									128,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						2892779526195692,
						false
						,[
						[
							4,
							130
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									129,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									129,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1293231602851671,
						false
						,[
						[
							4,
							131
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									130,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									130,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7745331711407373,
						false
						,[
						[
							4,
							132
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									131,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									131,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						15,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						3412574069874702,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9829885745886371,
					[
					[
						125,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						2835896928605571,
						false
						,[
						[
							8,
							3
						]
,						[
							0,
							[
								6,
								[
									3,
									[
										20,
										125,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
								]
								,[
									1,
									4
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						9482338210823278,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								3000
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						9596630553803911,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								500
							]
						]
						]
					]
					],
					[
					[
						125,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						8640593283256088,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									125,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									6,
									[
										20,
										125,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										1,
										4
									]
								]
							]
						]
						]
					]
,					[
						126,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						7611846743523315,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									125,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									126,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						127,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						675354868638939,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									126,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									127,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						128,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						6826782395638294,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									127,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									128,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						129,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						3545040222683401,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									128,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									129,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						130,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						1675402549708541,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									129,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									130,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						131,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						8227786501792523,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									130,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									131,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
,					[
						132,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						8545278407291402,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									131,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									20,
									132,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6923901008796134,
			[
			[
				-1,
				cr.system_object.prototype.cnds.EveryTick,
				null,
				0,
				false,
				false,
				false,
				7886916692124447,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				9619844794227525,
				false
				,[
				[
					11,
					"isMove"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.AddVar,
				null,
				1986652228507297,
				false
				,[
				[
					11,
					"CurrentDistance"
				]
,				[
					7,
					[
						6,
						[
							23,
							"VelocidadeCenario"
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.AddVar,
				null,
				283264504172598,
				false
				,[
				[
					11,
					"TotalDistance"
				]
,				[
					7,
					[
						6,
						[
							23,
							"VelocidadeCenario"
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7899527245930916,
			[
			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				8084488805260535,
				false
				,[
				[
					0,
					[
						1,
						0.15
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.cnds.LayerVisible,
				null,
				0,
				false,
				true,
				false,
				6279489783746754,
				false
				,[
				[
					5,
					[
						2,
						"GameOver"
					]
				]
				]
			]
			],
			[
			[
				8,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				6030823611339889,
				false
				,[
				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							7,
							[
								23,
								"TotalDistance"
							]
							,[
								0,
								20
							]
						]
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Spawn Cenário"],
			false,
			null,
			866698488602196,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				866698488602196,
				false
				,[
				[
					1,
					[
						2,
						"Spawn Cenário"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Fase 01"],
				false,
				null,
				5283474477177905,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					5283474477177905,
					false
					,[
					[
						1,
						[
							2,
							"Fase 01"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					518108935277516,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4004971738315917,
						false
						,[
						[
							11,
							"CurrentDistance"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"NextBlock"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						6143477913048152,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								1300
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6008905405927281,
						false
						,[
						[
							11,
							"spawn"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										5
									]
									]
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4628555302659003,
						false
						,[
						[
							11,
							"spawnCristal"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										2
									]
									]
								]
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						1678340924423413,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							7167210745962583,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							8523563000952612,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3650991677616233,
							false
							,[
							[
								4,
								17
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							17,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							5003297638152006,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										17,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							1209284690786469,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									20,
									17,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							9229244484427412,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								2465023770962177,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								1781465669478929,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2898363769189544,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								5566327503828697,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										17,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3263389653319756,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										17,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								5716001942345279,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1568976348863294,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1643919658087769,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								1769288257683389,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									1587080048898397,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									9136320453129402,
									false
									,[
									[
										4,
										11
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_01"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_01"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1472120017886903,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								5838183166871773,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								890532544010431,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									1941572303212094,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									7562196572714066,
									false
									,[
									[
										4,
										12
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_02"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_02"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3283687789828264,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4064843513891139,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								5747349608864828,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									2893409236920251,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									7206031446673237,
									false
									,[
									[
										4,
										13
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_03"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_03"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3082840826247343,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								5950107876296635,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								9678509382988682,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									3457635740129928,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									9034054675358947,
									false
									,[
									[
										4,
										14
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_04"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_04"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8203870884063167,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							4336096683541364,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							4819472929120588,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6533010573737237,
							false
							,[
							[
								4,
								18
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							18,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							3548812532491177,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										18,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							9904554766360964,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										18,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										1,
										30
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							1023741039455967,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								4816818615218929,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								7486180786093964,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								7981671064280097,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								7496104123912099,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										18,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3039197239476996,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										18,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6741212782905298,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							635373068687282,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								383391622143506,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								6078556898331913,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									1615271838734785,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									3813979035924173,
									false
									,[
									[
										4,
										11
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											18,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_01"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											18,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_01"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7198728778442042,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4800270070096404,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								6618270226165438,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									8323604760866238,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									5476816963661963,
									false
									,[
									[
										4,
										12
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											18,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_02"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											18,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_02"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5002033311908891,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								7182686266457001,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								3764154996091043,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									5121584876010952,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									9983980171743773,
									false
									,[
									[
										4,
										13
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											18,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_03"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											18,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_03"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2066648877733969,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4225801745653159,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								5456263109430909,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									9976451965110055,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									3355124821009886,
									false
									,[
									[
										4,
										14
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											18,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_04"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											18,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_04"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4799592481597865,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5085060125050494,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							3082107464977159,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3313067471498069,
							false
							,[
							[
								4,
								19
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							19,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							2746044376490726,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7754640207857353,
							false
							,[
							[
								4,
								20
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										0
									]
									]
								]
							]
,							[
								0,
								[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										0
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8863125338537753,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							1552472598642876,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								1244196099130812,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								20082895416078,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8262345030963671,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								10438168899121,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								9076355001883389,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8769521655207318,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							394723652266313,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2287459834555757,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								432228449539693,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									2141781605357053,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									6458149541718373,
									false
									,[
									[
										4,
										11
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_01"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_01"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							6774321355588273,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4067072064849849,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								9915994868927204,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									6757347614907792,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									3670644226870552,
									false
									,[
									[
										4,
										12
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_02"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_02"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5197890701013837,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								5766737426136038,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								1141609996703033,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									8637503916882683,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									8147278955023853,
									false
									,[
									[
										4,
										13
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_03"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_03"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1541668106024853,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8986657827389735,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								6951338350414729,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									1416981400458631,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									4160405860011574,
									false
									,[
									[
										4,
										14
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_04"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_04"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9156481275497978,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3662338884278749,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							680410588085738,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9813096112593331,
							false
							,[
							[
								4,
								21
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							21,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							7555895329518297,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										21,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7356040016423757,
							false
							,[
							[
								4,
								22
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									21,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										11
									]
									]
								]
							]
,							[
								0,
								[
									20,
									21,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										11
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5336633966669337,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										21,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							7854325763863296,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								2610742118804574,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								1912351821040859,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6889142104057659,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6818432602153811,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										21,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6205041765535016,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										21,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7944657881956324,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3451581807449384,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6019750837888412,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								3897860240119822,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									4204568977308713,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									3826803879113201,
									false
									,[
									[
										4,
										11
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											21,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_01"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											21,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_01"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1398927625796014,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1115379226249956,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								8092018381008294,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									3738182490282138,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									4005912636073334,
									false
									,[
									[
										4,
										12
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											21,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_02"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											21,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_02"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7211848268800817,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								5532871455178046,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								6566445777753186,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									4011818394688518,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									1940400047516034,
									false
									,[
									[
										4,
										13
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											21,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_03"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											21,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_03"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4781350850628586,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3014308804591649,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								1507132186231828,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									3140876840613048,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									8017183726262584,
									false
									,[
									[
										4,
										14
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											21,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_04"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											21,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_04"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3061440550337208,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9493504110899789,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							1041773048204839,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1555881734011055,
							false
							,[
							[
								4,
								26
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							26,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							8030283290677808,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									4,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											20,
											26,
											cr.plugins_.Sprite.prototype.exps.Height,
											false,
											null
										]
									]
									,[
										0,
										50
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4007790284898857,
							false
							,[
							[
								4,
								23
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									26,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										0
									]
									]
								]
							]
,							[
								0,
								[
									20,
									26,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										0
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3500316705004911,
							false
							,[
							[
								4,
								24
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									26,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										0
									]
									]
								]
							]
,							[
								0,
								[
									20,
									26,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										0
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							928555992150457,
							false
							,[
							[
								4,
								25
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									26,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										0
									]
									]
								]
							]
,							[
								0,
								[
									20,
									26,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										0
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							2555036557803055,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										26,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							7739988338178071,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6446588110426303,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								4497931536430153,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4367906297091092,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2447382823986881,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										26,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								7819928783781708,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										26,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7747094689743831,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3611229532677091,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								105773911817836,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								200192065402505,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									9916783951973067,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									4129868171007497,
									false
									,[
									[
										4,
										11
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											26,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_01"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											26,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_01"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							6876336370128541,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6658565722260768,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								884595412698048,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									4476346415737045,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									7467434574003135,
									false
									,[
									[
										4,
										12
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											26,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_02"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											26,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_02"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1056953933122418,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2209363146849511,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								1783775535726138,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									2457049025670458,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									9623051976499818,
									false
									,[
									[
										4,
										13
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											26,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_03"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											26,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_03"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7387022738844519,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1483505075780652,
								false
								,[
								[
									11,
									"AirSpawn"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												2
											]
											]
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								3527471118244059,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									2965069431927453,
									false
									,[
									[
										11,
										"AirSpawn"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									411797289555531,
									false
									,[
									[
										4,
										14
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											26,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												2,
												"air_04"
											]
											]
										]
									]
,									[
										0,
										[
											20,
											26,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												2,
												"air_04"
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7766662021293047,
					[
					[
						11,
						cr.plugins_.Sprite.prototype.cnds.OnCreated,
						null,
						1,
						false,
						false,
						false,
						6424769464090879,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2152800143974777,
						false
						,[
						[
							11,
							"spawnCristal"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										10
									]
									]
								]
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						true,
						null,
						5404651497928022,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							1709369934599858,
							false
							,[
							[
								7,
								[
									23,
									"spawnCristal"
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							152690449049776,
							false
							,[
							[
								7,
								[
									23,
									"spawnCristal"
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3665815075839939,
							false
							,[
							[
								11,
								"x"
							]
,							[
								7,
								[
									20,
									11,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5981520007589874,
							false
							,[
							[
								11,
								"y"
							]
,							[
								7,
								[
									20,
									11,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							59,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							108256098496789,
							false
							,[
							[
								1,
								[
									19,
									cr.system_object.prototype.exps.str
									,[
[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												10
											]
,[
												0,
												12
											]
											]
										]
										]
									]
									]
								]
							]
,							[
								13,
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9751743932703998,
					[
					[
						12,
						cr.plugins_.Sprite.prototype.cnds.OnCreated,
						null,
						1,
						false,
						false,
						false,
						2119034286397091,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1154936696455545,
						false
						,[
						[
							11,
							"spawnCristal"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										10
									]
									]
								]
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						true,
						null,
						4805864708000379,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							4049831187731717,
							false
							,[
							[
								7,
								[
									23,
									"spawnCristal"
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							9540212088430736,
							false
							,[
							[
								7,
								[
									23,
									"spawnCristal"
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5160808938415854,
							false
							,[
							[
								11,
								"x"
							]
,							[
								7,
								[
									20,
									12,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3864478756292187,
							false
							,[
							[
								11,
								"y"
							]
,							[
								7,
								[
									20,
									12,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							59,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4074113862739138,
							false
							,[
							[
								1,
								[
									19,
									cr.system_object.prototype.exps.str
									,[
[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												10
											]
,[
												0,
												12
											]
											]
										]
										]
									]
									]
								]
							]
,							[
								13,
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5139531344545088,
					[
					[
						13,
						cr.plugins_.Sprite.prototype.cnds.OnCreated,
						null,
						1,
						false,
						false,
						false,
						457564565662735,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3381728246132508,
						false
						,[
						[
							11,
							"spawnCristal"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										10
									]
									]
								]
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						true,
						null,
						6487039883473561,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							6018117251440637,
							false
							,[
							[
								7,
								[
									23,
									"spawnCristal"
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							2134852061795404,
							false
							,[
							[
								7,
								[
									23,
									"spawnCristal"
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6456989395052552,
							false
							,[
							[
								11,
								"x"
							]
,							[
								7,
								[
									20,
									13,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4519198726494618,
							false
							,[
							[
								11,
								"y"
							]
,							[
								7,
								[
									20,
									13,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							59,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1697514371147196,
							false
							,[
							[
								1,
								[
									19,
									cr.system_object.prototype.exps.str
									,[
[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												10
											]
,[
												0,
												12
											]
											]
										]
										]
									]
									]
								]
							]
,							[
								13,
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5736289432408486,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCreated,
						null,
						1,
						false,
						false,
						false,
						8691798073203363,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2446254461414026,
						false
						,[
						[
							11,
							"spawnCristal"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										10
									]
									]
								]
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						true,
						null,
						7760390989310806,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							6191241766987899,
							false
							,[
							[
								7,
								[
									23,
									"spawnCristal"
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							5013636592611012,
							false
							,[
							[
								7,
								[
									23,
									"spawnCristal"
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8924153833095997,
							false
							,[
							[
								11,
								"x"
							]
,							[
								7,
								[
									20,
									14,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7214710468818236,
							false
							,[
							[
								11,
								"y"
							]
,							[
								7,
								[
									20,
									14,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							59,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3435751894528198,
							false
							,[
							[
								1,
								[
									19,
									cr.system_object.prototype.exps.str
									,[
[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												10
											]
,[
												0,
												12
											]
											]
										]
										]
									]
									]
								]
							]
,							[
								13,
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Fase 02"],
				false,
				null,
				1713842240011324,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					1713842240011324,
					false
					,[
					[
						1,
						[
							2,
							"Fase 02"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					46232769028207,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						605068114902847,
						false
						,[
						[
							11,
							"CurrentDistance"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"NextBlock"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						2258137456708682,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								3500
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						2902466799922104,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								1300
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3381229173187831,
						false
						,[
						[
							11,
							"spawn"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										6
									]
									]
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7879837017108785,
						false
						,[
						[
							11,
							"spawnCristal"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										2
									]
									]
								]
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						3795426383137921,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3711875098886272,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							2786052641717662,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4013710892490131,
							false
							,[
							[
								4,
								27
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							27,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							3540159873972575,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										27,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3685792709347452,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										27,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										150
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							9975824944624508,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								389410433113207,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								9493518545592578,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1116490024356156,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1939329253350194,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										27,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8447054063276435,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										27,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3958745325572205,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7803741293167425,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9117011657425211,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							7032049137511144,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3149502179253378,
							false
							,[
							[
								4,
								28
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							28,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							6678917214155182,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										28,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							1949779439793572,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										28,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										150
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							3585249529587006,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								3085421799744686,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								950807450256948,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								9660546186003483,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								5984893860459749,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										28,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6287207265821702,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										28,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								303430876823672,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4484075563783218,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1982268361352765,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							2007926543841524,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7408088075824422,
							false
							,[
							[
								4,
								29
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							29,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							6372097354277953,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										29,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							2347931522021871,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										29,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										150
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							3975100126011076,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								2315986816818497,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								1909106877286942,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2249174060888714,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								7961339836675417,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										29,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2594655146652324,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										29,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6057113107693784,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5695278316398032,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8007028024691772,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							9600680407556518,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1842581788174759,
							false
							,[
							[
								4,
								30
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							30,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							1753253520342664,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										30,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							2950999790112967,
							false
							,[
							[
								4,
								31
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									30,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									20,
									30,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6201217003884646,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										30,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										150
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							479551334316525,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								391916165621756,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								2668683195719082,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2111147471449174,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4147692790199068,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										30,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								5305211490278937,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										30,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								1708579504508812,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7463807562988871,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1316227724150558,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							3573062137651919,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1443529043141034,
							false
							,[
							[
								4,
								32
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							32,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							7041175305228745,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										32,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7458614128829625,
							false
							,[
							[
								4,
								33
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									32,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									20,
									32,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							967696481255464,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										32,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										150
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							3802999328233114,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								144785612849114,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								3455246604609986,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								5026701240494054,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2560997259905605,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										32,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								7502909943289544,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										32,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								806946904642627,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2167906635849731,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2960202284760256,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							4572103755548631,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8994046093460114,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							6450369017795345,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										34,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							361726412379637,
							false
							,[
							[
								4,
								31
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									34,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									20,
									34,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4929720343982917,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										34,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										150
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							8815156650528739,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								8121188757552844,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								658004072222623,
								false
								,[
								[
									11,
									"spawnCristal"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8900561181264096,
								false
								,[
								[
									11,
									"cristalType"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												8
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4653057035417366,
								false
								,[
								[
									11,
									"x"
								]
,								[
									7,
									[
										20,
										34,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4180123256070307,
								false
								,[
								[
									11,
									"y"
								]
,								[
									7,
									[
										20,
										34,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											23,
											"cristalType"
										]
										]
									]
								]
								]
							]
,							[
								59,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								4980484237505442,
								false
								,[
								[
									1,
									[
										19,
										cr.system_object.prototype.exps.str
										,[
[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													7
												]
												]
											]
											]
										]
										]
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Fase 03"],
				false,
				null,
				4143951842237008,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					4143951842237008,
					false
					,[
					[
						1,
						[
							2,
							"Fase 03"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					1644455823563516,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4613857050942984,
						false
						,[
						[
							11,
							"CurrentDistance"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"NextBlock"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						9312250013133558,
						false
						,[
						[
							7,
							[
								7,
								[
									23,
									"TotalDistance"
								]
								,[
									0,
									20
								]
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								3500
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2541514744926712,
						false
						,[
						[
							11,
							"spawn"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										4
									]
									]
								]
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						4800344390361396,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6254916081310028,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							6315249967778585,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4839739260256653,
							false
							,[
							[
								4,
								38
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							38,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							2269813962878106,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										38,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3231739179978469,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										38,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6139492431295294,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3690640387655489,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							4149702197475398,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							2026022811846827,
							false
							,[
							[
								4,
								36
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							36,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							9402401817277183,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										36,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9124823576369369,
							false
							,[
							[
								4,
								35
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									36,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									20,
									36,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							9853626008350153,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										36,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4655570928816223,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8282339111190046,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							5143159589440796,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3055013180830872,
							false
							,[
							[
								4,
								37
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							37,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							3333245988402519,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									4,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.Height,
											false,
											null
										]
									]
									,[
										0,
										20
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6999812127789493,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									20,
									37,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1596619416033912,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3219337564370141,
							false
							,[
							[
								11,
								"spawn"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							108152989056854,
							false
							,[
							[
								11,
								"CurrentDistance"
							]
,							[
								7,
								[
									23,
									"NextBlock"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1659221024472251,
							false
							,[
							[
								4,
								39
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							39,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							2996652910197632,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
							]
,							[
								0,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										20,
										39,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8157368504481772,
							false
							,[
							[
								4,
								40
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									39,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									20,
									39,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							1410053404460742,
							false
							,[
							[
								11,
								"NextBlock"
							]
,							[
								7,
								[
									4,
									[
										20,
										39,
										cr.plugins_.Sprite.prototype.exps.Width,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Mobs"],
			false,
			null,
			5800353377465242,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5800353377465242,
				false
				,[
				[
					1,
					[
						2,
						"Mobs"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3650353544094363,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					7576748530732304,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								0,
								3
							]
,[
								0,
								7
							]
							]
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					4699493467614687,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					4017095924151189,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6658193800144746,
					false
					,[
					[
						7,
						[
							19,
							cr.system_object.prototype.exps["int"]
							,[
[
								20,
								6,
								cr.plugins_.Spritefont2.prototype.exps.Text,
								true,
								null
							]
							]
						]
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							20
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					4116931406167317,
					false
					,[
					[
						4,
						54
					]
,					[
						5,
						[
							2,
							"Game"
						]
					]
,					[
						0,
						[
							4,
							[
								19,
								cr.system_object.prototype.exps.layoutwidth
							]
							,[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									100
								]
,[
									0,
									300
								]
								]
							]
						]
					]
,					[
						0,
						[
							0,
							30
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				418790158622707,
				[
				[
					54,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					7580183038988495,
					false
					,[
					[
						4,
						52
					]
					]
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					1947941730030004,
					false
					,[
					[
						1,
						[
							2,
							"explode"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					52,
					cr.behaviors.Fade.prototype.acts.StartFade,
					"Fade",
					3284913643195184,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9306325458027546,
				[
				[
					54,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					757208382565498,
					false
					,[
					[
						4,
						51
					]
					]
				]
				],
				[
				[
					51,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					5218911139969195,
					false
					,[
					[
						1,
						[
							2,
							"explode"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					51,
					cr.behaviors.Fade.prototype.acts.StartFade,
					"Fade",
					1702291318108156,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3877610802506081,
				[
				[
					54,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					3918720469700849,
					false
					,[
					[
						4,
						50
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					2027865308819271,
					false
					,[
					[
						1,
						[
							2,
							"explode"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					50,
					cr.behaviors.Fade.prototype.acts.StartFade,
					"Fade",
					4422627594142626,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7079839408453954,
				[
				[
					54,
					cr.behaviors.Platform.prototype.cnds.IsOnFloor,
					"Platform",
					0,
					false,
					false,
					false,
					2786118131267095,
					false
				]
				],
				[
				[
					54,
					cr.behaviors.Platform.prototype.acts.SimulateControl,
					"Platform",
					8285926303059074,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Erase objects"],
			false,
			null,
			9006918458959602,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9006918458959602,
				false
				,[
				[
					1,
					[
						2,
						"Erase objects"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3699721251238793,
				[
				[
					17,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					8020212015909508,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								17,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					17,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3954735716024342,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5680664908377188,
				[
				[
					18,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					6070408181900327,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								18,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					18,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1780041886454085,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9683595056298783,
				[
				[
					19,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					9193183858302071,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								19,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					19,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1612115560620855,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				531749227637664,
				[
				[
					21,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					278247225290829,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								21,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					21,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3510367084192301,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1969176294548874,
				[
				[
					26,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					8069798438361662,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								26,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					26,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5094138670017071,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3609847896336902,
				[
				[
					11,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					1340312848140097,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								11,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5306806608819664,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7397206798024314,
				[
				[
					12,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					5916531845444384,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								12,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					12,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4440370729841378,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9497687626930645,
				[
				[
					13,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					4072197664834517,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								13,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					13,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9357351491036298,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3546022837968227,
				[
				[
					14,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					2113142864707161,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								14,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					14,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6474779528214328,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7606050231517313,
				[
				[
					20,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					2283768854697695,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								20,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					20,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2986466328352558,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3705246820690942,
				[
				[
					22,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					3338591439641044,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								22,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					22,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5777171369798721,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5686283433055687,
				[
				[
					23,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					2831066823152015,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								23,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					23,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					67736378175285,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8192009945329019,
				[
				[
					24,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					4666597406588878,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								24,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					24,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4782366212197199,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2461189076642326,
				[
				[
					25,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					7562163526858429,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								25,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					25,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6724675707032483,
					false
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				3216225050803724,
				[
				[
					54,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					7105182400659108,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								54,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.cnds.CompareY,
					null,
					0,
					false,
					false,
					false,
					6392076028930538,
					false
					,[
					[
						8,
						4
					]
,					[
						0,
						[
							0,
							700
						]
					]
					]
				]
				],
				[
				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3872767236221872,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5668699838268093,
				[
				[
					42,
					cr.plugins_.Particles.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					522776988338655,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							0,
							-190
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Particles.prototype.acts.Destroy,
					null,
					3407975190681092,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8799095157099055,
				[
				[
					41,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					9071986874894169,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							0,
							-200
						]
					]
					]
				]
				],
				[
				[
					41,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1308307909128675,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5463208420573201,
				[
				[
					27,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					871070224899505,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								27,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					27,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9818594107870594,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4762442833354745,
				[
				[
					28,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					2018046790446412,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								28,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					28,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5204868416854592,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7230183156917306,
				[
				[
					29,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					1099982551494223,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								29,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					29,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3137620590012681,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9998611569392051,
				[
				[
					30,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					6715071338168203,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								30,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					30,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7276824974013669,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9696802032718102,
				[
				[
					32,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					8398233241688403,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								32,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					32,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					236966653894182,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6180254343131202,
				[
				[
					34,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					8555877887493835,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								34,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					34,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					889240845574187,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2131897122434787,
				[
				[
					31,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					9245096862916951,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								31,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					31,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1431605957941916,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				165258349416242,
				[
				[
					33,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					5517259687605291,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								33,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					33,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1634736047151284,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1145070570753883,
				[
				[
					38,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					4471608225506462,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								38,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					38,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6358282095506823,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2051629885454712,
				[
				[
					36,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					2101436332911747,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								36,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					36,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3004065814854835,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8451392791553863,
				[
				[
					35,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					1770007259524932,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								35,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					35,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7091065004688232,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1806701113373619,
				[
				[
					37,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					8941844599677413,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								37,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					37,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6325527221862732,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				740822469793153,
				[
				[
					39,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					5095421609705209,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								39,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					39,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9740115302132283,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5523841797020735,
				[
				[
					40,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					8244675577614624,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								40,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1095699783293814,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				762260849818025,
				[
				[
					51,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					5900491544022696,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								51,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8687368301327303,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7719402716408481,
				[
				[
					50,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					9624791875498432,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								50,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3541669188730532,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9073114925732541,
				[
				[
					52,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					8000241377409271,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								52,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2096822801527751,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9179932462222407,
				[
				[
					97,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					124587403849115,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								97,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					97,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7619683240178183,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4244330030190358,
				[
				[
					15,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					7412701466282037,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							5,
							[
								0,
								0
							]
							,[
								20,
								15,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					15,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3857452438543996,
					false
				]
				]
			]
			]
		]
,		[
			0,
			[true, "itens"],
			false,
			null,
			7502768967367117,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7502768967367117,
				false
				,[
				[
					1,
					[
						2,
						"itens"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9556290592001654,
				[
				[
					56,
					cr.behaviors.Pin.prototype.cnds.IsPinned,
					"Pin",
					0,
					false,
					true,
					false,
					5249923030644098,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6674986456994645,
					false
					,[
					[
						7,
						[
							20,
							56,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							20,
							48,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
					]
				]
				],
				[
				[
					56,
					cr.plugins_.Sprite.prototype.acts.SetY,
					null,
					8366158229602853,
					false
					,[
					[
						0,
						[
							5,
							[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								0,
								50
							]
						]
					]
					]
				]
,				[
					56,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					9720055823789178,
					false
					,[
					[
						4,
						48
					]
,					[
						3,
						3
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3546845668776562,
				[
				[
					41,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					9032907899342788,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1617925484061759,
					false
					,[
					[
						7,
						[
							20,
							41,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutwidth
						]
					]
					]
				]
				],
				[
				[
					56,
					cr.behaviors.Pin.prototype.acts.Unpin,
					"Pin",
					976251207015364,
					false
				]
,				[
					56,
					cr.plugins_.Sprite.prototype.acts.SetY,
					null,
					129153473599249,
					false
					,[
					[
						0,
						[
							20,
							41,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3727318030313256,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						7508745929511247,
						false
						,[
						[
							7,
							[
								20,
								56,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								460
							]
						]
						]
					]
					],
					[
					[
						56,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						5062337725349864,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									56,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									5
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1974222647873744,
				[
				[
					41,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					1054800855148903,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					8035444971158367,
					false
					,[
					[
						7,
						[
							20,
							41,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutwidth
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					4134326151439354,
					false
					,[
					[
						7,
						[
							20,
							56,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							20,
							48,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					5994560364579828,
					false
					,[
					[
						7,
						[
							20,
							41,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							20,
							48,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
					]
				]
				],
				[
				[
					56,
					cr.plugins_.Sprite.prototype.acts.SetY,
					null,
					1550900630868461,
					false
					,[
					[
						0,
						[
							5,
							[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								0,
								50
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					6548295982020222,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						8048459668301241,
						false
						,[
						[
							7,
							[
								20,
								56,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								105
							]
						]
						]
					]
					],
					[
					[
						56,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						5736227634644124,
						false
						,[
						[
							0,
							[
								5,
								[
									20,
									56,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									5
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2075754268332207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					1493348086137706,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								0,
								20
							]
,[
								0,
								30
							]
							]
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1364426613945621,
					false
					,[
					[
						4,
						41
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							4,
							[
								19,
								cr.system_object.prototype.exps.layoutwidth
							]
							,[
								0,
								1000
							]
						]
					]
,					[
						0,
						[
							0,
							125
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					9459327964385428,
					false
					,[
					[
						4,
						42
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							20,
							41,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							20,
							41,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
					]
					]
				]
,				[
					41,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					9861238793801298,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Item"
							]
							,[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											5
										]
										]
									]
									]
								]
								]
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3975681267191567,
				[
				[
					41,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					false,
					false,
					8681626812674417,
					false
					,[
					[
						1,
						[
							2,
							"Item0"
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					8699776548836693,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					41,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					5380720789418589,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Item"
							]
							,[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											5
										]
										]
									]
									]
								]
								]
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5770947362385303,
				[
				[
					41,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					false,
					false,
					4975074751938558,
					false
					,[
					[
						1,
						[
							2,
							"Item0"
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					8972728765863426,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					41,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					8804454140068846,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Item"
							]
							,[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											5
										]
										]
									]
									]
								]
								]
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1339216355491753,
				[
				[
					41,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					false,
					false,
					8311896401812457,
					false
					,[
					[
						1,
						[
							2,
							"Item3"
						]
					]
					]
				]
,				[
					87,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					1477789233402339,
					false
				]
				],
				[
				[
					41,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					3677498861810786,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Item"
							]
							,[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											5
										]
										]
									]
									]
								]
								]
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				149002982057017,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					8559330828329657,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					41,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					false,
					false,
					7569760513033251,
					false
					,[
					[
						1,
						[
							2,
							"Item1"
						]
					]
					]
				]
				],
				[
				[
					41,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					1090816317787537,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Item"
							]
							,[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											5
										]
										]
									]
									]
								]
								]
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1928385295324433,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					8221941946736805,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					41,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					false,
					false,
					6285260718482372,
					false
					,[
					[
						1,
						[
							2,
							"Item1"
						]
					]
					]
				]
				],
				[
				[
					41,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					8028672908599996,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Item"
							]
							,[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											5
										]
										]
									]
									]
								]
								]
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2590914985590821,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					5091308988781181,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					4432135952455269,
					false
					,[
					[
						7,
						[
							20,
							41,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Particles.prototype.acts.SetPos,
					null,
					5134496221810823,
					false
					,[
					[
						0,
						[
							20,
							41,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							20,
							41,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "webstorage"],
			false,
			null,
			206359033381571,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				206359033381571,
				false
				,[
				[
					1,
					[
						2,
						"webstorage"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2055216148788364,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					8687733827988582,
					false
					,[
					[
						1,
						[
							2,
							"highscore"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2367705644912321,
					false
					,[
					[
						1,
						[
							2,
							"highscore"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4834298832540181,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					2759250413351908,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7178139248696218,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Colisões c item"],
			false,
			null,
			8203445423319527,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8203445423319527,
				false
				,[
				[
					1,
					[
						2,
						"Colisões c item"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9132562668184425,
				[
				[
					48,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					5076162955755856,
					false
					,[
					[
						4,
						41
					]
					]
				]
				],
				[
				[
					41,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1755619253234403,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1760555108601738,
					false
					,[
					[
						4,
						43
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							20,
							48,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							20,
							48,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
					]
					]
				]
,				[
					60,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					9882516332210169,
					false
					,[
					[
						2,
						["item",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							30
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1030009322294125,
					[
					],
					[
					[
						42,
						cr.plugins_.Particles.prototype.acts.SetGrowRate,
						null,
						1347964396945023,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						42,
						cr.plugins_.Particles.prototype.acts.Destroy,
						null,
						8243626883190289,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8272472803903768,
					[
					[
						41,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						2039621281504421,
						false
						,[
						[
							1,
							[
								2,
								"Item0"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1832115744446116,
						false
						,[
						[
							11,
							"cristalValue"
						]
,						[
							7,
							[
								0,
								2
							]
						]
						]
					]
,					[
						66,
						cr.plugins_.Particles.prototype.acts.SetVisible,
						null,
						4245811018004954,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7123729774686599,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						7187619486039903,
						false
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6794022152299163,
						false
						,[
						[
							0,
							[
								0,
								15
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4719461367578926,
						false
						,[
						[
							11,
							"cristalValue"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6859662734071125,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						66,
						cr.plugins_.Particles.prototype.acts.SetVisible,
						null,
						84827270150166,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9305889180665871,
					[
					[
						41,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						4673850907277087,
						false
						,[
						[
							1,
							[
								2,
								"Item1"
							]
						]
						]
					]
					],
					[
					[
						60,
						cr.plugins_.Audio.prototype.acts.PlayAtObject,
						null,
						212744955755455,
						false
						,[
						[
							2,
							["ima",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								50
							]
						]
,						[
							4,
							48
						]
,						[
							0,
							[
								0,
								360
							]
						]
,						[
							0,
							[
								0,
								360
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								2,
								""
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						6115527374311685,
						false
						,[
						[
							4,
							83
						]
,						[
							5,
							[
								2,
								"Player"
							]
						]
,						[
							0,
							[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						9070934462247298,
						false
						,[
						[
							0,
							[
								0,
								15
							]
						]
						]
					]
,					[
						83,
						cr.behaviors.Fade.prototype.acts.StartFade,
						"Fade",
						8310140890543748,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5406061685057084,
					[
					[
						41,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						4608525250539995,
						false
						,[
						[
							1,
							[
								2,
								"Item2"
							]
						]
						]
					]
					],
					[
					[
						60,
						cr.plugins_.Audio.prototype.acts.PlayAtObject,
						null,
						753498283507026,
						false
						,[
						[
							2,
							["bolha do mal",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								-5
							]
						]
,						[
							4,
							48
						]
,						[
							0,
							[
								0,
								360
							]
						]
,						[
							0,
							[
								0,
								360
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								2,
								"ima"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						2414114578028681,
						false
						,[
						[
							4,
							84
						]
,						[
							5,
							[
								2,
								"Player"
							]
						]
,						[
							0,
							[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						8977740996195334,
						false
						,[
						[
							0,
							[
								0,
								15
							]
						]
						]
					]
,					[
						84,
						cr.behaviors.Fade.prototype.acts.StartFade,
						"Fade",
						8336734908976349,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8106482309552595,
					[
					[
						41,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						9293364787169954,
						false
						,[
						[
							1,
							[
								2,
								"Item3"
							]
						]
						]
					]
					],
					[
					[
						87,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7323206086766449,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7605991740862341,
						false
						,[
						[
							11,
							"vida"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4688117478674113,
					[
					[
						41,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						6181840107584005,
						false
						,[
						[
							1,
							[
								2,
								"Item4"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetTimescale,
						null,
						7283144374465525,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						9861068614995126,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetTimescale,
						null,
						210099456198647,
						false
						,[
						[
							0,
							[
								1,
								2.5
							]
						]
						]
					]
,					[
						60,
						cr.plugins_.Audio.prototype.acts.PlayAtObject,
						null,
						3471942082261309,
						false
						,[
						[
							2,
							["boost fire",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								-15
							]
						]
,						[
							4,
							48
						]
,						[
							0,
							[
								0,
								360
							]
						]
,						[
							0,
							[
								0,
								360
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								2,
								""
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						2460937781439977,
						false
						,[
						[
							4,
							89
						]
,						[
							5,
							[
								2,
								"Player"
							]
						]
,						[
							0,
							[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Particles.prototype.acts.SetVisible,
						null,
						5264864010482182,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetObjectTimescale,
						null,
						6970329134613957,
						false
						,[
						[
							4,
							89
						]
,						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						48,
						cr.behaviors.Platform.prototype.acts.SetEnabled,
						"Platform",
						5360696708443603,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						58,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						4693309583353059,
						false
						,[
						[
							1,
							[
								2,
								"Jump"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						967534357559808,
						false
						,[
						[
							0,
							[
								0,
								15
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Particles.prototype.acts.SetVisible,
						null,
						4235400749984045,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						48,
						cr.behaviors.Platform.prototype.acts.SetEnabled,
						"Platform",
						1929815057492864,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetTimescale,
						null,
						7705803900936635,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Colisão mob c boia"],
			false,
			null,
			7611089211152382,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7611089211152382,
				false
				,[
				[
					1,
					[
						2,
						"Colisão mob c boia"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				5748849884176994,
				[
				[
					84,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					3583354338782596,
					false
					,[
					[
						4,
						54
					]
					]
				]
,				[
					84,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					7245023735576103,
					false
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					6284203097290572,
					false
					,[
					[
						4,
						85
					]
,					[
						5,
						[
							2,
							"Game"
						]
					]
,					[
						0,
						[
							20,
							54,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							20,
							54,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1575133892486263,
					false
				]
,				[
					60,
					cr.plugins_.Audio.prototype.acts.PlayAtObject,
					null,
					2850580431290719,
					false
					,[
					[
						2,
						["mob morre",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							-10
						]
					]
,					[
						4,
						54
					]
,					[
						0,
						[
							0,
							360
						]
					]
,					[
						0,
						[
							0,
							360
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4282603230538073,
			[
			[
				84,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				2900126566309281,
				false
			]
			],
			[
			[
				84,
				cr.plugins_.Sprite.prototype.acts.SetPosToObject,
				null,
				5640808911420512,
				false
				,[
				[
					4,
					48
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3040587403630124,
			[
			[
				83,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				4340781039127561,
				false
			]
			],
			[
			[
				83,
				cr.plugins_.Sprite.prototype.acts.SetPosToObject,
				null,
				3348618915095678,
				false
				,[
				[
					4,
					48
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4917645487578771,
			[
			[
				87,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				641308440180414,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				4974219145313737,
				false
				,[
				[
					11,
					"vida"
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "itens da loja"],
			false,
			null,
			2379853745527507,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2379853745527507,
				false
				,[
				[
					1,
					[
						2,
						"itens da loja"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7263665555700692,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					9791590296360341,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					9539181255386078,
					false
					,[
					[
						5,
						[
							2,
							"GameOver"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8624564490431806,
					false
					,[
					[
						11,
						"cristalValue"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					66,
					cr.plugins_.Particles.prototype.acts.SetVisible,
					null,
					3405261692724899,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9445915477364951,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					8544843975094927,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9346085787593391,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					1068422255642432,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					4225316034893871,
					false
					,[
					[
						5,
						[
							2,
							"GameOver"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6908865438425689,
					false
					,[
					[
						11,
						"cristalValue"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					66,
					cr.plugins_.Particles.prototype.acts.SetVisible,
					null,
					1348198604650562,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1778074082703756,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					932765883435996,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				453063203174955,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					9020187252842018,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					3529106709658284,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					7713137006506695,
					false
					,[
					[
						4,
						83
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							20,
							48,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							20,
							48,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2749511531081068,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					5749036547044874,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6557701272853168,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					444613692567094,
					false
					,[
					[
						4,
						83
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							20,
							48,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							20,
							48,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Pause"],
			false,
			null,
			2221092147958395,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2221092147958395,
				false
				,[
				[
					1,
					[
						2,
						"Pause"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8276243071068028,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					4201403063370693,
					false
					,[
					[
						4,
						88
					]
					]
				]
,				[
					88,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					7150139326380051,
					false
				]
				],
				[
				[
					88,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2183683360912418,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					9404984393111644,
					false
					,[
					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					697174879110775,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6426626998443879,
				[
				[
					95,
					cr.plugins_.CJSBackButton.prototype.cnds.OnBack,
					null,
					1,
					false,
					false,
					false,
					8338337495114924,
					false
				]
,				[
					88,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					9469139860942168,
					false
				]
				],
				[
				[
					88,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4578194426769726,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					9901429706307659,
					false
					,[
					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					8697366406891645,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				619768194283319,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					1855466881195547,
					false
					,[
					[
						4,
						91
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					4716268520405993,
					false
					,[
					[
						5,
						[
							2,
							"Pause"
						]
					]
					]
				]
				],
				[
				[
					88,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6810813748265987,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					9366643186855333,
					false
					,[
					[
						0,
						[
							1,
							0.5
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					8844019030491446,
					false
					,[
					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6422058123302837,
					false
					,[
					[
						0,
						[
							1,
							0.25
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					2557268463358318,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5859734220145633,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					7746732585235998,
					false
					,[
					[
						4,
						92
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					2008333311162483,
					false
					,[
					[
						5,
						[
							2,
							"Pause"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3494917434126768,
					false
					,[
					[
						11,
						"goTo"
					]
,					[
						7,
						[
							2,
							"Fase1"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					720193364122932,
					false
					,[
					[
						11,
						"retry"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					311743683129809,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7236311857313342,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					7827520012870413,
					false
					,[
					[
						4,
						93
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					6747746543062828,
					false
					,[
					[
						5,
						[
							2,
							"Pause"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3718059275007514,
					false
					,[
					[
						11,
						"goTo"
					]
,					[
						7,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4966510531485223,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7830399599351441,
			[
			[
				-1,
				cr.system_object.prototype.cnds.LayerVisible,
				null,
				0,
				false,
				false,
				false,
				5927499281230139,
				false
				,[
				[
					5,
					[
						2,
						"Pause"
					]
				]
				]
			]
			],
			[
			[
				103,
				cr.plugins_.CJSAds.prototype.acts.ShowBanner,
				null,
				2130341220517848,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3982798714620127,
			[
			[
				-1,
				cr.system_object.prototype.cnds.LayerVisible,
				null,
				0,
				false,
				false,
				false,
				372658788177699,
				false
				,[
				[
					5,
					[
						2,
						"GameOver"
					]
				]
				]
			]
			],
			[
			[
				103,
				cr.plugins_.CJSAds.prototype.acts.ShowBanner,
				null,
				8969181750220684,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Set slot PAUSE"],
			false,
			null,
			101257764645208,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				101257764645208,
				false
				,[
				[
					1,
					[
						2,
						"Set slot PAUSE"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				155878573294782,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					7778355786126862,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					7057937696714468,
					false
					,[
					[
						7,
						[
							20,
							79,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					4226634692912763,
					false
					,[
					[
						4,
						79
					]
,					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						0,
						[
							0,
							438
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1893849685947297,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					7074947684695892,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6929936802960511,
					false
					,[
					[
						7,
						[
							20,
							80,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					746671372994502,
					false
					,[
					[
						4,
						80
					]
,					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						0,
						[
							0,
							438
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7182993217377928,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					904755835283639,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					3029476958955305,
					false
					,[
					[
						7,
						[
							20,
							81,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					390597958570165,
					false
					,[
					[
						4,
						81
					]
,					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						0,
						[
							0,
							438
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5187360657117961,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					3327603761129132,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6595580559192644,
					false
					,[
					[
						7,
						[
							20,
							82,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					8809692754005019,
					false
					,[
					[
						4,
						82
					]
,					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						0,
						[
							0,
							438
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3702620370805296,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6710696873763062,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					146155748934564,
					false
					,[
					[
						7,
						[
							20,
							79,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2262409219237843,
					false
					,[
					[
						4,
						79
					]
,					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						0,
						[
							0,
							521
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6902762080178184,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6296383327961176,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					2696458232221203,
					false
					,[
					[
						7,
						[
							20,
							80,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1013100263421114,
					false
					,[
					[
						4,
						80
					]
,					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						0,
						[
							0,
							521
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8890588128025935,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					4792165085458655,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1653930733884418,
					false
					,[
					[
						7,
						[
							20,
							81,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					662674902493558,
					false
					,[
					[
						4,
						81
					]
,					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						0,
						[
							0,
							521
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3886463655669667,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					1357235701116777,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1272601644068601,
					false
					,[
					[
						7,
						[
							20,
							82,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					9191310833915736,
					false
					,[
					[
						4,
						82
					]
,					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						0,
						[
							0,
							521
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Destroi all on start"],
			false,
			null,
			890717537324202,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				890717537324202,
				false
				,[
				[
					1,
					[
						2,
						"Destroi all on start"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				5932407055157647,
				[
				[
					-1,
					cr.system_object.prototype.cnds.OnLayoutStart,
					null,
					1,
					false,
					false,
					false,
					2726901898622317,
					false
				]
				],
				[
				[
					86,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2655780641712109,
					false
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2860208366914183,
					false
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9905119032040501,
					false
				]
,				[
					20,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8828167411906197,
					false
				]
,				[
					21,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4274520525053956,
					false
				]
,				[
					22,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1175944347298884,
					false
				]
,				[
					26,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5645511899271107,
					false
				]
,				[
					23,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6150289366759569,
					false
				]
,				[
					24,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3299575345477184,
					false
				]
,				[
					25,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1992869173739161,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8188801322175124,
				[
				[
					-1,
					cr.system_object.prototype.cnds.OnLayoutStart,
					null,
					1,
					false,
					false,
					false,
					2435143847988559,
					false
				]
				],
				[
				[
					27,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8063161415400771,
					false
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1927751612594239,
					false
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					38786190845475,
					false
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6868911077057167,
					false
				]
,				[
					31,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1470451689547685,
					false
				]
,				[
					32,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6824638889575105,
					false
				]
,				[
					33,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4164475527937774,
					false
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2243975222213487,
					false
				]
,				[
					125,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2779462663158224,
					false
				]
,				[
					126,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5912346374887215,
					false
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6879807437386,
					false
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8261192260190888,
					false
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1530562415116804,
					false
				]
,				[
					130,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2275898046993711,
					false
				]
,				[
					131,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1020106545487098,
					false
				]
,				[
					132,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2130233343222713,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				995836440207451,
				[
				[
					-1,
					cr.system_object.prototype.cnds.OnLayoutStart,
					null,
					1,
					false,
					false,
					false,
					5241563179164952,
					false
				]
				],
				[
				[
					38,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					100094541944767,
					false
				]
,				[
					36,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5285260579890824,
					false
				]
,				[
					35,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1481366980848339,
					false
				]
,				[
					37,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9243758208150561,
					false
				]
,				[
					39,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2284490059031464,
					false
				]
,				[
					40,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1592524418008138,
					false
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8847826092899023,
					false
				]
,				[
					134,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3573638948580414,
					false
				]
,				[
					135,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1203012061199065,
					false
				]
,				[
					136,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2452575321419731,
					false
				]
,				[
					137,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5707218600425638,
					false
				]
,				[
					138,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7030470701765159,
					false
				]
,				[
					139,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6606759784224428,
					false
				]
,				[
					140,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6339685246755138,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2720190319033496,
				[
				[
					-1,
					cr.system_object.prototype.cnds.OnLayoutStart,
					null,
					1,
					false,
					false,
					false,
					265276967148635,
					false
				]
				],
				[
				[
					15,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2231935541477977,
					false
				]
,				[
					97,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9960040397436813,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				821686478249643,
				[
				[
					-1,
					cr.system_object.prototype.cnds.OnLayoutStart,
					null,
					1,
					false,
					false,
					false,
					8757236873439265,
					false
				]
				],
				[
				[
					84,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6161675848893481,
					false
				]
,				[
					83,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					204574741449359,
					false
				]
				]
			]
			]
		]
,		[
			0,
			[true, "leaderboards"],
			false,
			null,
			7203628981314091,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7203628981314091,
				false
				,[
				[
					1,
					[
						2,
						"leaderboards"
					]
				]
				]
			]
			],
			[
			]
		]
		]
	]
,	[
		"MainMenu",
		[
		[
			2,
			"transitions",
			false
		]
,		[
			0,
			null,
			false,
			null,
			9022548731235078,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				8755709593675192,
				false
			]
			],
			[
			[
				103,
				cr.plugins_.CJSAds.prototype.acts.PreloadBanner,
				null,
				7230149979745265,
				false
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetTimescale,
				null,
				7014615533066921,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				8702070967076241,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					155879956141174,
					false
					,[
					[
						1,
						[
							2,
							"Item01Value"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					9307088744871195,
					false
					,[
					[
						1,
						[
							2,
							"Item01Value"
						]
					]
,					[
						7,
						[
							0,
							1500
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6190255299165662,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					3161981077485989,
					false
					,[
					[
						1,
						[
							2,
							"Item01"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2471299159970623,
					false
					,[
					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6753158681426162,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					9680822390086228,
					false
					,[
					[
						1,
						[
							2,
							"Item02Value"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7703919097290125,
					false
					,[
					[
						1,
						[
							2,
							"Item02Value"
						]
					]
,					[
						7,
						[
							0,
							3000
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3749120537221322,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					1640353079948018,
					false
					,[
					[
						1,
						[
							2,
							"Item02"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2184131804326919,
					false
					,[
					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				504894767793563,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					2071044735422017,
					false
					,[
					[
						1,
						[
							2,
							"Item03Value"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2845690018074302,
					false
					,[
					[
						1,
						[
							2,
							"Item03Value"
						]
					]
,					[
						7,
						[
							0,
							6500
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8845466715238688,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					4206935604670976,
					false
					,[
					[
						1,
						[
							2,
							"Item03"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6950173029220316,
					false
					,[
					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4362539451006989,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					832665916598466,
					false
					,[
					[
						1,
						[
							2,
							"Item04Value"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6028611264575084,
					false
					,[
					[
						1,
						[
							2,
							"Item04Value"
						]
					]
,					[
						7,
						[
							0,
							9000
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9433795150891769,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					7621750728320242,
					false
					,[
					[
						1,
						[
							2,
							"Item04"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					1535127814822506,
					false
					,[
					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9305956025207748,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					9586425817351608,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8893995942674636,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							""
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7027567658566009,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					4226021271861875,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					4208433629013115,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							2,
							""
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3787167885373332,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					3076682096886782,
					false
					,[
					[
						1,
						[
							2,
							"Level"
						]
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7522399012518186,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							2,
							""
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7321463705658552,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchStart,
				null,
				1,
				false,
				false,
				false,
				102899073747885,
				false
			]
,			[
				49,
				cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
				null,
				0,
				false,
				true,
				false,
				2710499313939781,
				false
				,[
				[
					4,
					64
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3156405070544144,
				false
				,[
				[
					11,
					"goTo"
				]
,				[
					7,
					[
						2,
						"Fase1"
					]
				]
				]
			]
,			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				697193358456832,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			968874307616952,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				2820049516907839,
				false
				,[
				[
					4,
					64
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				2669481754039871,
				false
				,[
				[
					11,
					"goTo"
				]
,				[
					7,
					[
						2,
						"shopSection"
					]
				]
				]
			]
,			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				4404029123463313,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1686647261405972,
			[
			[
				95,
				cr.plugins_.CJSBackButton.prototype.cnds.OnBack,
				null,
				1,
				false,
				false,
				false,
				3367746396772657,
				false
			]
			],
			[
			[
				96,
				cr.plugins_.Browser.prototype.acts.Close,
				null,
				2646299632441837,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7754538129206081,
			[
			[
				98,
				cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd,
				"Fade",
				1,
				false,
				false,
				false,
				1996932961627531,
				false
			]
			],
			[
			[
				98,
				cr.behaviors.Fade.prototype.acts.StartFade,
				"Fade",
				7728040013754239,
				false
			]
			]
		]
,		[
			0,
			[true, "Credits"],
			false,
			null,
			3769435177360143,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				3769435177360143,
				false
				,[
				[
					1,
					[
						2,
						"Credits"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8665666597203529,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					9718917786412666,
					false
					,[
					[
						4,
						100
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					3106181279339719,
					false
					,[
					[
						6,
						"Credits"
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9349076304312022,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				8457091487800623,
				false
				,[
				[
					4,
					105
				]
				]
			]
			],
			[
			[
				96,
				cr.plugins_.Browser.prototype.acts.GoToURLWindow,
				null,
				2517686920591716,
				false
				,[
				[
					1,
					[
						2,
						"https://play.google.com/store/apps/details?id=com.mkstudios.semblant"
					]
				]
,				[
					1,
					[
						2,
						"Semblant"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5365914958566555,
			[
			[
				133,
				cr.plugins_.Sprite.prototype.cnds.CompareX,
				null,
				0,
				false,
				false,
				false,
				5019223162046196,
				false
				,[
				[
					8,
					3
				]
,				[
					0,
					[
						6,
						[
							3,
							[
								20,
								133,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
						,[
							1,
							4
						]
					]
				]
				]
			]
			],
			[
			[
				133,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				2023760950142072,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							133,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							6,
							[
								20,
								133,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
							,[
								1,
								4
							]
						]
					]
				]
				]
			]
,			[
				134,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				1575856670311036,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							133,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							20,
							134,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
					]
				]
				]
			]
,			[
				135,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				1349586161129625,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							134,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							20,
							135,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
					]
				]
				]
			]
,			[
				136,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				9829101996881148,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							135,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							20,
							136,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
					]
				]
				]
			]
,			[
				137,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				7673284652768953,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							136,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							20,
							137,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
					]
				]
				]
			]
,			[
				138,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				2172777210834731,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							137,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							20,
							138,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
					]
				]
				]
			]
,			[
				139,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				2048426721116927,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							138,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							20,
							139,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
					]
				]
				]
			]
,			[
				140,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				3552593310905798,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							139,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							20,
							140,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			764142469339254,
			[
			[
				-1,
				cr.system_object.prototype.cnds.EveryTick,
				null,
				0,
				false,
				false,
				false,
				1115137400156921,
				false
			]
			],
			[
			[
				133,
				cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
				null,
				452861762104208,
				false
				,[
				[
					0,
					[
						0,
						180
					]
				]
,				[
					0,
					[
						6,
						[
							7,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								0,
								4
							]
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
,			[
				134,
				cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
				null,
				9150848226930085,
				false
				,[
				[
					0,
					[
						0,
						180
					]
				]
,				[
					0,
					[
						6,
						[
							7,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								0,
								4
							]
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
,			[
				135,
				cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
				null,
				1165858411284679,
				false
				,[
				[
					0,
					[
						0,
						180
					]
				]
,				[
					0,
					[
						6,
						[
							7,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								0,
								4
							]
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
,			[
				136,
				cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
				null,
				8219613937115781,
				false
				,[
				[
					0,
					[
						0,
						180
					]
				]
,				[
					0,
					[
						6,
						[
							7,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								0,
								4
							]
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
,			[
				137,
				cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
				null,
				9367471732592301,
				false
				,[
				[
					0,
					[
						0,
						180
					]
				]
,				[
					0,
					[
						6,
						[
							7,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								0,
								4
							]
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
,			[
				138,
				cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
				null,
				1648073314053192,
				false
				,[
				[
					0,
					[
						0,
						180
					]
				]
,				[
					0,
					[
						6,
						[
							7,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								0,
								4
							]
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
,			[
				139,
				cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
				null,
				1242540106825012,
				false
				,[
				[
					0,
					[
						0,
						180
					]
				]
,				[
					0,
					[
						6,
						[
							7,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								0,
								4
							]
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
,			[
				140,
				cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
				null,
				7730716896872018,
				false
				,[
				[
					0,
					[
						0,
						180
					]
				]
,				[
					0,
					[
						6,
						[
							7,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								0,
								4
							]
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Player",
		[
		[
			1,
			"vida",
			0,
			0,
false,false,390152057490949,false
		]
,		[
			1,
			"jump",
			0,
			0,
false,false,3949163238002749,false
		]
,		[
			1,
			"cristalValue",
			0,
			1,
false,false,7393576852477512,false
		]
,		[
			1,
			"Skin",
			1,
			"normal",
false,false,9614508059888499,false
		]
,		[
			0,
			null,
			false,
			null,
			3507116363497977,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				821398005282635,
				false
			]
			],
			[
			[
				57,
				cr.plugins_.Particles.prototype.acts.SetPos,
				null,
				5261187824598978,
				false
				,[
				[
					0,
					[
						20,
						56,
						cr.plugins_.Sprite.prototype.exps.X,
						false,
						null
					]
				]
,				[
					0,
					[
						20,
						56,
						cr.plugins_.Sprite.prototype.exps.Y,
						false,
						null
					]
				]
				]
			]
,			[
				57,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				1191281364952726,
				false
				,[
				[
					4,
					56
				]
,				[
					3,
					0
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetLayerVisible,
				null,
				8902756024827531,
				false
				,[
				[
					5,
					[
						2,
						"GameOver"
					]
				]
,				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7653757853568782,
			[
			[
				48,
				cr.plugins_.Sprite.prototype.cnds.CompareX,
				null,
				0,
				false,
				false,
				false,
				1052569962846006,
				false
				,[
				[
					8,
					4
				]
,				[
					0,
					[
						0,
						105
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6072549309164545,
				false
				,[
				[
					11,
					"isMove"
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
,			[
				48,
				cr.behaviors.Platform.prototype.acts.SetMaxSpeed,
				"Platform",
				5758502655925468,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				48,
				cr.behaviors.Platform.prototype.acts.SetAcceleration,
				"Platform",
				9368735652984499,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			true,
			null,
			4510792433397185,
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				false,
				false,
				3489565645851498,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					1,
					[
						2,
						"Item02"
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				false,
				false,
				3539900229452583,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					1,
					[
						2,
						"Item02"
					]
				]
,				[
					3,
					0
				]
				]
			]
			],
			[
			[
				48,
				cr.behaviors.Platform.prototype.acts.SetJumpStrength,
				"Platform",
				3026390555541494,
				false
				,[
				[
					0,
					[
						0,
						480
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Normal"],
			false,
			null,
			7894742260953346,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7894742260953346,
				false
				,[
				[
					1,
					[
						2,
						"Normal"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				5525370384953867,
				[
				[
					48,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					7519361745983412,
					false
					,[
					[
						8,
						1
					]
,					[
						0,
						[
							0,
							105
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1261749837767608,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					48,
					cr.plugins_.Sprite.prototype.acts.SetX,
					null,
					9336838257732738,
					false
					,[
					[
						0,
						[
							0,
							105
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8002623449504882,
				[
				[
					48,
					cr.behaviors.Platform.prototype.cnds.IsOnFloor,
					"Platform",
					0,
					false,
					false,
					false,
					4334731992191622,
					false
				]
				],
				[
				[
					48,
					cr.behaviors.Platform.prototype.acts.SimulateControl,
					"Platform",
					1736095736007959,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2794815410668899,
					false
					,[
					[
						11,
						"jump"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				709267163951977,
				[
				[
					48,
					cr.behaviors.Platform.prototype.cnds.OnJump,
					"Platform",
					1,
					false,
					false,
					false,
					5804501752422709,
					false
				]
				],
				[
				[
					58,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					6357608195457756,
					false
					,[
					[
						1,
						[
							2,
							"Jump"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8197844282800886,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6903017366998001,
					false
					,[
					[
						11,
						"jump"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9231981973914901,
				[
				[
					48,
					cr.behaviors.Platform.prototype.cnds.OnLand,
					"Platform",
					1,
					false,
					false,
					false,
					5769050740570292,
					false
				]
,				[
					58,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					true,
					false,
					9155419095864813,
					false
					,[
					[
						1,
						[
							2,
							"Roll"
						]
					]
					]
				]
				],
				[
				[
					58,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					7146597248457148,
					false
					,[
					[
						1,
						[
							2,
							"Run"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6913566663541846,
				[
				[
					58,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					true,
					false,
					485376606990427,
					false
					,[
					[
						1,
						[
							2,
							"Roll"
						]
					]
					]
				]
,				[
					48,
					cr.behaviors.Platform.prototype.cnds.IsOnFloor,
					"Platform",
					0,
					false,
					false,
					false,
					9000865671904294,
					false
				]
				],
				[
				[
					58,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					4266122507677165,
					false
					,[
					[
						1,
						[
							2,
							"Run"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6747172079849508,
				[
				[
					58,
					cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
					null,
					1,
					false,
					false,
					false,
					5696716753357055,
					false
					,[
					[
						1,
						[
							2,
							"Roll"
						]
					]
					]
				]
				],
				[
				[
					58,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					9170507157854267,
					false
					,[
					[
						1,
						[
							2,
							"Run"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				3051406598218318,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6423264755623766,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					362406535963362,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					4680344983365017,
					[
					[
						48,
						cr.behaviors.Platform.prototype.cnds.IsOnFloor,
						"Platform",
						0,
						false,
						true,
						false,
						9874068290024317,
						false
					]
,					[
						49,
						cr.plugins_.Touch.prototype.cnds.IsInTouch,
						null,
						0,
						false,
						false,
						false,
						2676566744381411,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3975244990188221,
						false
						,[
						[
							11,
							"jump"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						5486090120225636,
						false
						,[
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.timescale
							]
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						58,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						7555144269871089,
						false
						,[
						[
							1,
							[
								2,
								"Jump"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						48,
						cr.behaviors.Platform.prototype.acts.SetVectorY,
						"Platform",
						6673664791111803,
						false
						,[
						[
							0,
							[
								0,
								-600
							]
						]
						]
					]
,					[
						48,
						cr.behaviors.Platform.prototype.acts.SimulateControl,
						"Platform",
						2023577461512802,
						false
						,[
						[
							3,
							2
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						8413569879757326,
						false
						,[
						[
							11,
							"jump"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3172654140759577,
					[
					[
						49,
						cr.plugins_.Touch.prototype.cnds.IsInTouch,
						null,
						0,
						false,
						false,
						false,
						5761421322385792,
						false
					]
,					[
						48,
						cr.behaviors.Platform.prototype.cnds.IsJumping,
						"Platform",
						0,
						false,
						true,
						false,
						2584986057965638,
						false
					]
,					[
						58,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						7358691981442601,
						false
						,[
						[
							1,
							[
								2,
								"Run"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						8608058982098793,
						false
						,[
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.timescale
							]
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						58,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						2705474883039354,
						false
						,[
						[
							1,
							[
								2,
								"Jump"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						48,
						cr.behaviors.Platform.prototype.acts.SetVectorY,
						"Platform",
						3141800713256816,
						false
						,[
						[
							0,
							[
								0,
								-600
							]
						]
						]
					]
,					[
						48,
						cr.behaviors.Platform.prototype.acts.SimulateControl,
						"Platform",
						1860809335839489,
						false
						,[
						[
							3,
							2
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6556918131971121,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.IsInTouch,
					null,
					0,
					false,
					false,
					false,
					9640936436776687,
					false
				]
,				[
					48,
					cr.behaviors.Platform.prototype.cnds.IsJumping,
					"Platform",
					0,
					false,
					true,
					false,
					3130405391953339,
					false
				]
,				[
					58,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					false,
					false,
					4960982437680414,
					false
					,[
					[
						1,
						[
							2,
							"Run"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					4809900128964399,
					false
					,[
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.timescale
						]
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					58,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					3732689479298308,
					false
					,[
					[
						1,
						[
							2,
							"Jump"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					48,
					cr.behaviors.Platform.prototype.acts.SetVectorY,
					"Platform",
					3640190920328244,
					false
					,[
					[
						0,
						[
							0,
							-600
						]
					]
					]
				]
,				[
					48,
					cr.behaviors.Platform.prototype.acts.SimulateControl,
					"Platform",
					5113866892735498,
					false
					,[
					[
						3,
						2
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				877356723614249,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchEnd,
					null,
					1,
					false,
					false,
					false,
					85567133251177,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					7104626691119548,
					false
					,[
					[
						7,
						[
							22,
							48,
							"Platform",
							cr.behaviors.Platform.prototype.exps.VectorY,
							false,
							null
						]
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							0,
							-250
						]
					]
					]
				]
				],
				[
				[
					48,
					cr.behaviors.Platform.prototype.acts.SetVectorY,
					"Platform",
					1145647206011762,
					false
					,[
					[
						0,
						[
							0,
							-250
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5338725385842002,
				[
				[
					48,
					cr.behaviors.Platform.prototype.cnds.OnLand,
					"Platform",
					1,
					false,
					false,
					false,
					3845283270024253,
					false
				]
				],
				[
				[
					48,
					cr.plugins_.Sprite.prototype.acts.SetX,
					null,
					8045376944843398,
					false
					,[
					[
						0,
						[
							4,
							[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								0,
								1
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6766581275676376,
				[
				[
					48,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					2107319570123808,
					false
					,[
					[
						4,
						54
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1271539582190061,
					false
					,[
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.timescale
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					58,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					7742846459673337,
					false
					,[
					[
						1,
						[
							2,
							"Roll"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					60,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					9862254886341145,
					false
					,[
					[
						2,
						["miauzinho",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							-17
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					6,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					7242228877043127,
					false
					,[
					[
						7,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									6,
									cr.plugins_.Spritefont2.prototype.exps.Text,
									true,
									null
								]
								]
							]
							,[
								0,
								20
							]
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2755650397440925,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
,					[
						7,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									62,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"cristais"
									]
									]
								]
								]
							]
							,[
								0,
								20
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4296920680567389,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					2212355224588763,
					false
					,[
					[
						0,
						[
							1,
							0.05
						]
					]
					]
				]
				],
				[
				[
					55,
					cr.plugins_.Particles.prototype.acts.SetPos,
					null,
					5215979309183222,
					false
					,[
					[
						0,
						[
							20,
							58,
							cr.plugins_.Sprite.prototype.exps.ImagePointX,
							false,
							null
							,[
[
								2,
								"rabo"
							]
							]
						]
					]
,					[
						0,
						[
							20,
							58,
							cr.plugins_.Sprite.prototype.exps.ImagePointY,
							false,
							null
							,[
[
								2,
								"rabo"
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3208118505136666,
				[
				[
					-1,
					cr.system_object.prototype.cnds.OnLayoutStart,
					null,
					1,
					false,
					false,
					false,
					9648870064043293,
					false
				]
				],
				[
				[
					56,
					cr.plugins_.Sprite.prototype.acts.SetY,
					null,
					4547130370820152,
					false
					,[
					[
						0,
						[
							5,
							[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								0,
								50
							]
						]
					]
					]
				]
,				[
					56,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					4606603927340958,
					false
					,[
					[
						4,
						48
					]
,					[
						3,
						3
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9607627144598655,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.IsInTouch,
					null,
					0,
					false,
					false,
					false,
					1496877173566929,
					false
				]
,				[
					89,
					cr.plugins_.Particles.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					1606014544102932,
					false
				]
				],
				[
				[
					48,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					2995943629715361,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.angle
							,[
[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
,[
								20,
								48,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
,[
								20,
								49,
								cr.plugins_.Touch.prototype.exps.X,
								false,
								null
							]
,[
								20,
								49,
								cr.plugins_.Touch.prototype.exps.Y,
								false,
								null
							]
							]
						]
					]
,					[
						0,
						[
							6,
							[
								0,
								50
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4446737503556861,
				[
				[
					89,
					cr.plugins_.Particles.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6225564630555389,
					false
				]
				],
				[
				[
					89,
					cr.plugins_.Particles.prototype.acts.SetPosToObject,
					null,
					5795569695010995,
					false
					,[
					[
						4,
						48
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "colisões com skins"],
			false,
			null,
			9528998595052245,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9528998595052245,
				false
				,[
				[
					1,
					[
						2,
						"colisões com skins"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8598248276161994,
				[
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					3944717489942597,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3547157745407564,
						false
						,[
						[
							11,
							"Skin"
						]
,						[
							7,
							[
								2,
								"lava"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						2272028642692486,
						false
						,[
						[
							0,
							[
								0,
								15
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7904231148732976,
						false
						,[
						[
							11,
							"Skin"
						]
,						[
							7,
							[
								2,
								"normal"
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Morre"],
			false,
			null,
			9604393769945562,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9604393769945562,
				false
				,[
				[
					1,
					[
						2,
						"Morre"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8298763877238196,
				[
				[
					48,
					cr.plugins_.Sprite.prototype.cnds.CompareY,
					null,
					0,
					false,
					false,
					false,
					9474644731436621,
					false
					,[
					[
						8,
						4
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6740804567500242,
					false
					,[
					[
						11,
						"vida"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					3419396798241325,
					false
					,[
					[
						5,
						[
							2,
							"GameOver"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4626318111707069,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					1016001737923246,
					false
					,[
					[
						5,
						[
							2,
							"GameOver"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					88,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1373317013261644,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					359965477540701,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					66,
					cr.plugins_.Particles.prototype.acts.SetVisible,
					null,
					3058890850580463,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					9,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4772325901189535,
					false
					,[
					[
						7,
						[
							10,
							[
								20,
								8,
								cr.plugins_.Spritefont2.prototype.exps.Text,
								true,
								null
							]
							,[
								2,
								"m"
							]
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					1886266309191418,
					false
					,[
					[
						7,
						[
							20,
							6,
							cr.plugins_.Spritefont2.prototype.exps.Text,
							true,
							null
						]
					]
					]
				]
,				[
					63,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					8035854791962993,
					false
					,[
					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"highscore"
							]
							]
						]
					]
					]
				]
,				[
					6,
					cr.plugins_.Spritefont2.prototype.acts.SetVisible,
					null,
					3291925923947556,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					8,
					cr.plugins_.Spritefont2.prototype.acts.SetVisible,
					null,
					6278474027772983,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6218612027407106,
				[
				[
					48,
					cr.plugins_.Sprite.prototype.cnds.CompareY,
					null,
					0,
					false,
					false,
					false,
					1180134916879899,
					false
					,[
					[
						8,
						4
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
					]
					]
				]
,				[
					87,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6990858205868876,
					false
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					9330017934211582,
					false
					,[
					[
						4,
						86
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							4,
							[
								3,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										105
									]
								]
							]
							,[
								0,
								105
							]
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					86,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3919184824849584,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					4206598304435849,
					false
					,[
					[
						4,
						86
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.layoutwidth
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					86,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5738323645414192,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					3674527796871812,
					false
					,[
					[
						4,
						86
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							4,
							[
								3,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										105
									]
								]
							]
							,[
								0,
								105
							]
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
					]
					]
				]
,				[
					86,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4156188056675879,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					7332245662047332,
					false
					,[
					[
						4,
						86
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.layoutwidth
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
					]
					]
				]
,				[
					86,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					424913502204807,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					4181724300132998,
					false
					,[
					[
						0,
						[
							1,
							0.5
						]
					]
					]
				]
,				[
					87,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1634889968823408,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3190905261765415,
				[
				[
					86,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					5072614964383202,
					false
				]
				],
				[
				[
					86,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					3290383358370348,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.angle
							,[
[
								20,
								86,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
,[
								20,
								86,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
,[
								0,
								105
							]
,[
								7,
								[
									19,
									cr.system_object.prototype.exps.layoutheight
								]
								,[
									0,
									2
								]
							]
							]
						]
					]
,					[
						0,
						[
							6,
							[
								0,
								1100
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3995523746256374,
					[
					[
						60,
						cr.plugins_.Audio.prototype.cnds.IsTagPlaying,
						null,
						0,
						false,
						true,
						false,
						1705211193298421,
						false
						,[
						[
							1,
							[
								2,
								"revive"
							]
						]
						]
					]
					],
					[
					[
						60,
						cr.plugins_.Audio.prototype.acts.Play,
						null,
						7450245754306905,
						false
						,[
						[
							2,
							["revive sem vidro",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								-10
							]
						]
,						[
							1,
							[
								2,
								"revive"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7295511009284789,
				[
				[
					86,
					cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
					null,
					0,
					false,
					false,
					false,
					9884103072854989,
					false
					,[
					[
						4,
						86
					]
					]
				]
				],
				[
				[
					48,
					cr.plugins_.Sprite.prototype.acts.SetPosToObject,
					null,
					9553432454272675,
					false
					,[
					[
						4,
						86
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					86,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8415159902052553,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					8992592735849454,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					86,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5817439799591268,
					false
				]
,				[
					86,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8510677631043569,
					false
				]
,				[
					86,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6552148447018566,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4107865094443564,
					false
					,[
					[
						11,
						"vida"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			788643567739924,
			[
			[
				-1,
				cr.system_object.prototype.cnds.LayerVisible,
				null,
				0,
				false,
				false,
				false,
				6718476941159109,
				false
				,[
				[
					5,
					[
						2,
						"GameOver"
					]
				]
				]
			]
,			[
				61,
				cr.plugins_.Sprite.prototype.cnds.CompareY,
				null,
				0,
				false,
				false,
				false,
				9321969236612582,
				false
				,[
				[
					8,
					4
				]
,				[
					0,
					[
						0,
						160
					]
				]
				]
			]
			],
			[
			[
				61,
				cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
				null,
				1332855035223946,
				false
				,[
				[
					0,
					[
						0,
						90
					]
				]
,				[
					0,
					[
						6,
						[
							0,
							-800
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2656431990070816,
			[
			[
				61,
				cr.plugins_.Sprite.prototype.cnds.CompareY,
				null,
				0,
				false,
				false,
				false,
				6150587439606435,
				false
				,[
				[
					8,
					2
				]
,				[
					0,
					[
						0,
						160
					]
				]
				]
			]
			],
			[
			[
				61,
				cr.plugins_.Sprite.prototype.acts.SetY,
				null,
				1996988910370892,
				false
				,[
				[
					0,
					[
						0,
						160
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "acões dos botões"],
			false,
			null,
			3725214355634111,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				3725214355634111,
				false
				,[
				[
					1,
					[
						2,
						"acões dos botões"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7619297981956653,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5820117226937233,
					false
					,[
					[
						4,
						5
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7226638364293928,
					false
					,[
					[
						11,
						"goTo"
					]
,					[
						7,
						[
							2,
							"Fase1"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7566324346329039,
					false
					,[
					[
						11,
						"retry"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1601624289103201,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6694766423875828,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					8977839596843727,
					false
					,[
					[
						4,
						2
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8790146854669538,
					false
					,[
					[
						11,
						"goTo"
					]
,					[
						7,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					25772890375461,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3380837395535228,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5453142064865097,
					false
					,[
					[
						4,
						3
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4170075990294895,
					false
					,[
					[
						11,
						"goTo"
					]
,					[
						7,
						[
							2,
							"shopSection"
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6547897728797895,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			509141534804122,
			[
			[
				-1,
				cr.system_object.prototype.cnds.Compare,
				null,
				0,
				false,
				false,
				false,
				5530684958211128,
				false
				,[
				[
					7,
					[
						19,
						cr.system_object.prototype.exps["int"]
						,[
[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"highscore"
							]
							]
						]
						]
					]
				]
,				[
					8,
					2
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps["int"]
						,[
[
							20,
							8,
							cr.plugins_.Spritefont2.prototype.exps.Text,
							true,
							null
						]
						]
					]
				]
				]
			]
			],
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				9132986344782655,
				false
				,[
				[
					1,
					[
						2,
						"highscore"
					]
				]
,				[
					7,
					[
						20,
						8,
						cr.plugins_.Spritefont2.prototype.exps.Text,
						true,
						null
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Level"],
			false,
			null,
			4420272088579301,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4420272088579301,
				false
				,[
				[
					1,
					[
						2,
						"Level"
					]
				]
				]
			]
			],
			[
			]
		]
		]
	]
,	[
		"Cristais",
		[
		[
			1,
			"contactChar",
			0,
			0,
false,false,2686726459823946,false
		]
,		[
			1,
			"y",
			0,
			0,
false,false,3325588756915451,false
		]
,		[
			1,
			"x",
			0,
			0,
false,false,8823326501747963,false
		]
,		[
			0,
			null,
			false,
			null,
			5987289419793562,
			[
			[
				59,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				4814132375680597,
				false
				,[
				[
					1,
					[
						2,
						"0"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5288461358894994,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1084488422005864,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9956114078271449,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				364199023396174,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6807668779325329,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				801366016728932,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6931199031583079,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1332562717972641,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3924928322109273,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4905923504741234,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9270601047182199,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9225729671046127,
			[
			[
				59,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				135509030139775,
				false
				,[
				[
					1,
					[
						2,
						"1"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6925626288525485,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6646155128859614,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5425774521104772,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8645497273503827,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4581124287268248,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9091956826053674,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8640547604414545,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8987906222015285,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7835471121191321,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				2269873682335725,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9407534183632208,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3000010907334971,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				922990529466142,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							60
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9327029333720035,
			[
			[
				59,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				4545395921803631,
				false
				,[
				[
					1,
					[
						2,
						"2"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5059493406370701,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				186099891465403,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1058244585288399,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9102978434786207,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7133694808591425,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8670829077166761,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5982917157895447,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6796331940502938,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6666373270033068,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							60
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8352045416985842,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6902691289087784,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4662922442629984,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7904044886994983,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7193480193356964,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7302523445320204,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			79851627586912,
			[
			[
				59,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				9732532244057306,
				false
				,[
				[
					1,
					[
						2,
						"3"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9507734060294542,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4427478583423554,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				319372073731504,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4694227923816075,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8022083423115593,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7208023675989683,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5726213974813507,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9261461651300138,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4779772121076152,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8690080266345432,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				762636295850412,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				2246689623695248,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9686980312021245,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3711008774051225,
			[
			[
				59,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				3069363134673346,
				false
				,[
				[
					1,
					[
						2,
						"4"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6287800672662311,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3873723276047356,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9842742797924664,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8265490835384217,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9015909227743626,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4940229753214587,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3260811914299474,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1087579767787652,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5739373607457767,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5511952495178319,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8640082897451098,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6405094882687642,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				451001264388089,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9745269192085563,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6355540909447261,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8254372149652694,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5831978480929704,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9737876659633794,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				526667902971995,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3392917337737176,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				2127865438070092,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1918943026615019,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4916562993288139,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3945867677913737,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9260185790685997,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1383141785699342,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5171964944249824,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							75
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5753180736840321,
			[
			[
				59,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				8946714812523772,
				false
				,[
				[
					1,
					[
						2,
						"5"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8640333521600016,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4113314354406559,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1832036951986716,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8534457094783786,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				2698341221549113,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							60
						]
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5331060226684957,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							75
						]
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1088961153678517,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1483746950817436,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8652135760228807,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3105031031827685,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6826280407774976,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9241446416123988,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							60
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3104612085651136,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							75
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3025279791991859,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							90
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4584390508667151,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4739737729819591,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3187990505918944,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5568553196959902,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4190561945985761,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							60
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5829329446854151,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							75
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6270174794445985,
			[
			[
				59,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				795027714204181,
				false
				,[
				[
					1,
					[
						2,
						"6"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4213016823676673,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9073784649375937,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				441380254272653,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				279712275303159,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7893968173400212,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9222439669031313,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							60
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				2496911377871516,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							45
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1625017147250735,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							60
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7850173027429064,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							75
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5421550839595007,
				false
				,[
				[
					4,
					52
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							60
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							60
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6556736027488426,
			[
			[
				59,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				3475715673013612,
				false
				,[
				[
					1,
					[
						2,
						"10"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7791723827392388,
				false
				,[
				[
					4,
					50
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				28332004439992,
				false
				,[
				[
					4,
					50
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8814060271331466,
				false
				,[
				[
					4,
					50
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							1,
							7.5
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8592703995221428,
			[
			[
				59,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				4977427552582071,
				false
				,[
				[
					1,
					[
						2,
						"11"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4030964099188687,
				false
				,[
				[
					4,
					51
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						23,
						"x"
					]
				]
,				[
					0,
					[
						23,
						"y"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				638909939568029,
				false
				,[
				[
					4,
					51
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							15
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							15
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7376682301368649,
				false
				,[
				[
					4,
					51
				]
,				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						4,
						[
							23,
							"x"
						]
						,[
							0,
							30
						]
					]
				]
,				[
					0,
					[
						5,
						[
							23,
							"y"
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Colisões com char"],
			false,
			null,
			8829997743771662,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8829997743771662,
				false
				,[
				[
					1,
					[
						2,
						"Colisões com char"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8073788698157628,
				[
				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
					null,
					0,
					false,
					false,
					false,
					6024620905187477,
					false
					,[
					[
						4,
						6
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					378083107568435,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					7435610904844792,
					false
					,[
					[
						1,
						[
							2,
							"explode"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					52,
					cr.behaviors.Fade.prototype.acts.StartFade,
					"Fade",
					6442198447727814,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7343273714309848,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
						null,
						1,
						false,
						false,
						false,
						8083477422665258,
						false
					]
,					[
						52,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						4498074858685004,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						6,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						8989391163652351,
						false
						,[
						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										6,
										cr.plugins_.Spritefont2.prototype.exps.Text,
										true,
										null
									]
									]
								]
								,[
									6,
									[
										0,
										1
									]
									,[
										23,
										"cristalValue"
									]
								]
							]
						]
						]
					]
,					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3362684742700094,
						false
						,[
						[
							1,
							[
								2,
								"cristais"
							]
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										62,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"cristais"
										]
										]
									]
									]
								]
								,[
									6,
									[
										0,
										1
									]
									,[
										23,
										"cristalValue"
									]
								]
							]
						]
						]
					]
,					[
						60,
						cr.plugins_.Audio.prototype.acts.Play,
						null,
						8688788277777266,
						false
						,[
						[
							2,
							["cristal explode",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								-15
							]
						]
,						[
							1,
							[
								2,
								""
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8726051822457192,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					20973900555505,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					8446230670171615,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					5738230858824765,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					779910491613929,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.angle
							,[
[
								20,
								52,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
,[
								20,
								52,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
,[
								0,
								15
							]
,[
								0,
								43
							]
							]
						]
					]
,					[
						0,
						[
							6,
							[
								0,
								600
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				349339020228867,
				[
				[
					50,
					cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
					null,
					0,
					false,
					false,
					false,
					9167714882773392,
					false
					,[
					[
						4,
						6
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					5671007172215995,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					3593614685537113,
					false
					,[
					[
						1,
						[
							2,
							"explode"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					50,
					cr.behaviors.Fade.prototype.acts.StartFade,
					"Fade",
					3688146625206734,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8700539140082191,
					[
					[
						50,
						cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
						null,
						1,
						false,
						false,
						false,
						4012161346677421,
						false
					]
,					[
						50,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						1812643590496232,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						6,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						2717507190587665,
						false
						,[
						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										6,
										cr.plugins_.Spritefont2.prototype.exps.Text,
										true,
										null
									]
									]
								]
								,[
									6,
									[
										0,
										3
									]
									,[
										23,
										"cristalValue"
									]
								]
							]
						]
						]
					]
,					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6921481711417616,
						false
						,[
						[
							1,
							[
								2,
								"cristais"
							]
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										62,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"cristais"
										]
										]
									]
									]
								]
								,[
									6,
									[
										0,
										1
									]
									,[
										23,
										"cristalValue"
									]
								]
							]
						]
						]
					]
,					[
						60,
						cr.plugins_.Audio.prototype.acts.Play,
						null,
						7861229833969548,
						false
						,[
						[
							2,
							["cristal explode",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								-15
							]
						]
,						[
							1,
							[
								2,
								""
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				153568376558591,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					8161744921820477,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					8344578706737592,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1287659501850695,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					782882067226611,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.angle
							,[
[
								20,
								50,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
,[
								20,
								50,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
,[
								0,
								15
							]
,[
								0,
								43
							]
							]
						]
					]
,					[
						0,
						[
							6,
							[
								0,
								600
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1258377512960407,
				[
				[
					51,
					cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
					null,
					0,
					false,
					false,
					false,
					8924852652084981,
					false
					,[
					[
						4,
						6
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					6019477594883869,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				],
				[
				[
					51,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					9310972651570117,
					false
					,[
					[
						1,
						[
							2,
							"explode"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					51,
					cr.behaviors.Fade.prototype.acts.StartFade,
					"Fade",
					1159732757357655,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					9593395316438609,
					[
					[
						51,
						cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
						null,
						1,
						false,
						false,
						false,
						9571680091766099,
						false
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						2814495636318487,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						6,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						68754451094576,
						false
						,[
						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										6,
										cr.plugins_.Spritefont2.prototype.exps.Text,
										true,
										null
									]
									]
								]
								,[
									6,
									[
										0,
										3
									]
									,[
										23,
										"cristalValue"
									]
								]
							]
						]
						]
					]
,					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4679744090515321,
						false
						,[
						[
							1,
							[
								2,
								"cristais"
							]
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										62,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"cristais"
										]
										]
									]
									]
								]
								,[
									6,
									[
										0,
										1
									]
									,[
										23,
										"cristalValue"
									]
								]
							]
						]
						]
					]
,					[
						60,
						cr.plugins_.Audio.prototype.acts.Play,
						null,
						4594376291296738,
						false
						,[
						[
							2,
							["cristal explode",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								-15
							]
						]
,						[
							1,
							[
								2,
								""
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8945271292601277,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					7409719732345603,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					9035485762127021,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6176663809295974,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					51,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					6684392117817515,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.angle
							,[
[
								20,
								51,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
,[
								20,
								51,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
,[
								0,
								15
							]
,[
								0,
								43
							]
							]
						]
					]
,					[
						0,
						[
							6,
							[
								0,
								600
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1077080904319695,
				[
				[
					48,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					5919795173051415,
					false
					,[
					[
						4,
						50
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					2488155652663069,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Sprite.prototype.acts.MoveToLayer,
					null,
					640341763897291,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6552644077287187,
				[
				[
					48,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					9365268384000518,
					false
					,[
					[
						4,
						51
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6059555205925408,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					51,
					cr.plugins_.Sprite.prototype.acts.MoveToLayer,
					null,
					1413303819501698,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7529020175828937,
				[
				[
					48,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					5816213987981507,
					false
					,[
					[
						4,
						52
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6401983053943368,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.MoveToLayer,
					null,
					9101096871253363,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "colisões com imã"],
			false,
			null,
			855902665764603,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				855902665764603,
				false
				,[
				[
					1,
					[
						2,
						"colisões com imã"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7742686410353373,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					6135942280004522,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					9973428534803527,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					4622368311546533,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					8062615174221996,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.angle
							,[
[
								20,
								52,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
,[
								20,
								52,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
,[
								0,
								15
							]
,[
								0,
								43
							]
							]
						]
					]
,					[
						0,
						[
							6,
							[
								0,
								800
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2143595053666248,
				[
				[
					83,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					8507739746063842,
					false
					,[
					[
						4,
						52
					]
					]
				]
,				[
					83,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					610191681936447,
					false
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.MoveToLayer,
					null,
					4699999655099867,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4394858396681905,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					3399286275414969,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					3214417780319227,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1639998467051828,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					51,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					3075217185638158,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.angle
							,[
[
								20,
								51,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
,[
								20,
								51,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
,[
								0,
								15
							]
,[
								0,
								43
							]
							]
						]
					]
,					[
						0,
						[
							6,
							[
								0,
								800
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2151711271127527,
				[
				[
					83,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					191459562722276,
					false
					,[
					[
						4,
						51
					]
					]
				]
,				[
					83,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					4183883132439506,
					false
				]
				],
				[
				[
					51,
					cr.plugins_.Sprite.prototype.acts.MoveToLayer,
					null,
					1672290655709172,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				287296897793379,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					266533271297993,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					4243321962180542,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					814870327159016,
					false
					,[
					[
						7,
						[
							20,
							83,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					7671156492381516,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.angle
							,[
[
								20,
								50,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
,[
								20,
								50,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
,[
								0,
								15
							]
,[
								0,
								43
							]
							]
						]
					]
,					[
						0,
						[
							6,
							[
								0,
								800
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8486556496251649,
				[
				[
					83,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					6591097581948091,
					false
					,[
					[
						4,
						50
					]
					]
				]
,				[
					83,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					7180926295902976,
					false
				]
				],
				[
				[
					50,
					cr.plugins_.Sprite.prototype.acts.MoveToLayer,
					null,
					42392813489713,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"shopItems",
		[
		[
			2,
			"transitions",
			false
		]
,		[
			0,
			null,
			false,
			null,
			8418114124192757,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				6298061645940597,
				false
			]
			],
			[
			[
				45,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				1942573365614207,
				false
				,[
				[
					7,
					[
						20,
						62,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"cristais"
						]
						]
					]
				]
				]
			]
,			[
				67,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				8547028506792816,
				false
				,[
				[
					4,
					78
				]
,				[
					3,
					0
				]
				]
			]
,			[
				44,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				1730730009406834,
				false
				,[
				[
					4,
					67
				]
,				[
					3,
					0
				]
				]
			]
,			[
				46,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				8273096895817418,
				false
				,[
				[
					4,
					67
				]
,				[
					3,
					0
				]
				]
			]
,			[
				77,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				6149221377396452,
				false
				,[
				[
					4,
					67
				]
,				[
					3,
					0
				]
				]
			]
,			[
				68,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				4427559960760212,
				false
				,[
				[
					4,
					78
				]
,				[
					3,
					0
				]
				]
			]
,			[
				71,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				5734609580198427,
				false
				,[
				[
					4,
					68
				]
,				[
					3,
					0
				]
				]
			]
,			[
				72,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				1265157359861496,
				false
				,[
				[
					4,
					68
				]
,				[
					3,
					0
				]
				]
			]
,			[
				69,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				487169407488096,
				false
				,[
				[
					4,
					78
				]
,				[
					3,
					0
				]
				]
			]
,			[
				73,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				3058640963078331,
				false
				,[
				[
					4,
					69
				]
,				[
					3,
					0
				]
				]
			]
,			[
				74,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				3263751611304047,
				false
				,[
				[
					4,
					69
				]
,				[
					3,
					0
				]
				]
			]
,			[
				70,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				4374316375617159,
				false
				,[
				[
					4,
					78
				]
,				[
					3,
					0
				]
				]
			]
,			[
				75,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				9289498719124764,
				false
				,[
				[
					4,
					70
				]
,				[
					3,
					0
				]
				]
			]
,			[
				76,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				6219643524260157,
				false
				,[
				[
					4,
					70
				]
,				[
					3,
					0
				]
				]
			]
,			[
				110,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				4383189637037838,
				false
				,[
				[
					4,
					78
				]
,				[
					3,
					0
				]
				]
			]
,			[
				79,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				1669564697360541,
				false
			]
,			[
				80,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				5293445866087947,
				false
			]
,			[
				81,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				7773385119504451,
				false
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				1128381541200062,
				false
			]
,			[
				103,
				cr.plugins_.CJSAds.prototype.acts.ShowBanner,
				null,
				860421512172617,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			true,
			null,
			7614069212783606,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				8709712904566201,
				false
				,[
				[
					4,
					108
				]
				]
			]
,			[
				95,
				cr.plugins_.CJSBackButton.prototype.cnds.OnBack,
				null,
				1,
				false,
				false,
				false,
				3892955940802807,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				5043677267732313,
				false
				,[
				[
					11,
					"goTo"
				]
,				[
					7,
					[
						2,
						"shopSection"
					]
				]
				]
			]
,			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				2233057994255614,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3457266932102097,
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				2629676505013342,
				false
				,[
				[
					1,
					[
						2,
						"cristais"
					]
				]
,				[
					8,
					2
				]
,				[
					0,
					[
						19,
						cr.system_object.prototype.exps["int"]
						,[
[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Item01Value"
							]
							]
						]
						]
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				1005000708006282,
				false
				,[
				[
					1,
					[
						2,
						"Item01"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						0
					]
				]
				]
			]
			],
			[
			[
				44,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				1677461001818321,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				46,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				3094294730993693,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				67,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				2213259796393033,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1333417097365337,
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				8311527519007224,
				false
				,[
				[
					1,
					[
						2,
						"cristais"
					]
				]
,				[
					8,
					2
				]
,				[
					0,
					[
						19,
						cr.system_object.prototype.exps["int"]
						,[
[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Item02Value"
							]
							]
						]
						]
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				9952114606226356,
				false
				,[
				[
					1,
					[
						2,
						"Item02"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						0
					]
				]
				]
			]
			],
			[
			[
				71,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				712363894792924,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				72,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				8195313823744751,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				68,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				5600882095705915,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7431074631130151,
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				7647894449008242,
				false
				,[
				[
					1,
					[
						2,
						"cristais"
					]
				]
,				[
					8,
					2
				]
,				[
					0,
					[
						19,
						cr.system_object.prototype.exps["int"]
						,[
[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Item03Value"
							]
							]
						]
						]
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				4953770381196835,
				false
				,[
				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						0
					]
				]
				]
			]
			],
			[
			[
				73,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				7941124169995873,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				4130860045775732,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				3615579856640287,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8768418993142468,
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				9202386963231875,
				false
				,[
				[
					1,
					[
						2,
						"cristais"
					]
				]
,				[
					8,
					2
				]
,				[
					0,
					[
						19,
						cr.system_object.prototype.exps["int"]
						,[
[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Item04Value"
							]
							]
						]
						]
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				1789850142546015,
				false
				,[
				[
					1,
					[
						2,
						"Item04"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						0
					]
				]
				]
			]
			],
			[
			[
				75,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				3178923261808118,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				76,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				6323458816240987,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
				null,
				7627061325015378,
				false
				,[
				[
					0,
					[
						0,
						1
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7806824405264679,
			[
			[
				77,
				cr.plugins_.Spritefont2.prototype.cnds.PickByUID,
				null,
				0,
				false,
				false,
				true,
				3691017372052374,
				false
				,[
				[
					0,
					[
						0,
						92
					]
				]
				]
			]
			],
			[
			[
				77,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				798367361760179,
				false
				,[
				[
					7,
					[
						2,
						"1500"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9292029922417042,
			[
			[
				77,
				cr.plugins_.Spritefont2.prototype.cnds.PickByUID,
				null,
				0,
				false,
				false,
				true,
				6966719673475144,
				false
				,[
				[
					0,
					[
						0,
						93
					]
				]
				]
			]
			],
			[
			[
				77,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				3574460837490906,
				false
				,[
				[
					7,
					[
						2,
						"3000"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9068652696499007,
			[
			[
				77,
				cr.plugins_.Spritefont2.prototype.cnds.PickByUID,
				null,
				0,
				false,
				false,
				true,
				5881853614309379,
				false
				,[
				[
					0,
					[
						0,
						94
					]
				]
				]
			]
			],
			[
			[
				77,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				5496540124714373,
				false
				,[
				[
					7,
					[
						2,
						"9000"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7584225712070354,
			[
			[
				77,
				cr.plugins_.Spritefont2.prototype.cnds.PickByUID,
				null,
				0,
				false,
				false,
				true,
				5503538210670905,
				false
				,[
				[
					0,
					[
						0,
						95
					]
				]
				]
			]
			],
			[
			[
				77,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				8205407414280251,
				false
				,[
				[
					7,
					[
						2,
						"9000"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9062961413977788,
			[
			[
				78,
				cr.plugins_.Sprite.prototype.cnds.CompareY,
				null,
				0,
				false,
				false,
				false,
				6142544899208421,
				false
				,[
				[
					8,
					4
				]
,				[
					0,
					[
						0,
						281
					]
				]
				]
			]
			],
			[
			[
				78,
				cr.plugins_.Sprite.prototype.acts.SetY,
				null,
				969782807911312,
				false
				,[
				[
					0,
					[
						0,
						281
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6922773933246091,
			[
			[
				78,
				cr.plugins_.Sprite.prototype.cnds.CompareY,
				null,
				0,
				false,
				false,
				false,
				7689305920452368,
				false
				,[
				[
					8,
					2
				]
,				[
					0,
					[
						0,
						70
					]
				]
				]
			]
			],
			[
			[
				78,
				cr.plugins_.Sprite.prototype.acts.SetY,
				null,
				8867335412719739,
				false
				,[
				[
					0,
					[
						0,
						70
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7504851775333703,
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				1076022840963933,
				false
				,[
				[
					1,
					[
						2,
						"Item01"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				44,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				5200829993415547,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5460902325103755,
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				1923599616963062,
				false
				,[
				[
					1,
					[
						2,
						"Item02"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				71,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				6396100622463556,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7807123042471333,
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				4381690507823744,
				false
				,[
				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				73,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				3789228962539838,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3260587952331429,
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				2257097176191094,
				false
				,[
				[
					1,
					[
						2,
						"Item04"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				75,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				4779708337129359,
				false
			]
			]
		]
,		[
			0,
			[true, "Compra Item01"],
			false,
			null,
			2032760278666437,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2032760278666437,
				false
				,[
				[
					1,
					[
						2,
						"Compra Item01"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7525090686999886,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					6143178105458487,
					false
					,[
					[
						4,
						44
					]
					]
				]
,				[
					67,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					true,
					false,
					5243987300920282,
					false
					,[
					[
						1,
						[
							2,
							"cinza"
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					4728658372963841,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
,					[
						8,
						5
					]
,					[
						0,
						[
							0,
							1500
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					2414797890121382,
					false
					,[
					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					44,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1677118652427732,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8403827058056321,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
,					[
						7,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									62,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"cristais"
									]
									]
								]
								]
							]
							,[
								0,
								1500
							]
						]
					]
					]
				]
,				[
					45,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					8016722992002642,
					false
					,[
					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"cristais"
							]
							]
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8194763327681905,
					false
					,[
					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					229991518544662,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"slot01"
							]
							]
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7473686608258989,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4678303441014983,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4353208607637598,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5068181270600473,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					490257603498855,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item01"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Set slot"],
			false,
			null,
			8401686926600266,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8401686926600266,
				false
				,[
				[
					1,
					[
						2,
						"Set slot"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				155878573294782,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					7778355786126862,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					7057937696714468,
					false
					,[
					[
						7,
						[
							20,
							79,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					4226634692912763,
					false
					,[
					[
						4,
						79
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1893849685947297,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					7074947684695892,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6929936802960511,
					false
					,[
					[
						7,
						[
							20,
							80,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					746671372994502,
					false
					,[
					[
						4,
						80
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7182993217377928,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					904755835283639,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					3029476958955305,
					false
					,[
					[
						7,
						[
							20,
							81,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					390597958570165,
					false
					,[
					[
						4,
						81
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5187360657117961,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					3327603761129132,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6595580559192644,
					false
					,[
					[
						7,
						[
							20,
							82,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					8809692754005019,
					false
					,[
					[
						4,
						82
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3702620370805296,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6710696873763062,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					146155748934564,
					false
					,[
					[
						7,
						[
							20,
							79,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2262409219237843,
					false
					,[
					[
						4,
						79
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6902762080178184,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6296383327961176,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					2696458232221203,
					false
					,[
					[
						7,
						[
							20,
							80,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1013100263421114,
					false
					,[
					[
						4,
						80
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8890588128025935,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					4792165085458655,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1653930733884418,
					false
					,[
					[
						7,
						[
							20,
							81,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					662674902493558,
					false
					,[
					[
						4,
						81
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3886463655669667,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					1357235701116777,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1272601644068601,
					false
					,[
					[
						7,
						[
							20,
							82,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					9191310833915736,
					false
					,[
					[
						4,
						82
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Equip Item01"],
			false,
			null,
			9878199220070284,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9878199220070284,
				false
				,[
				[
					1,
					[
						2,
						"Equip Item01"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				5073579721214939,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					8510757664126368,
					false
					,[
					[
						4,
						46
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					9395167760194222,
					false
					,[
					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					8815309683168917,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					1571152192676605,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					3648500293044482,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					8760848485519965,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5325829913726399,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"slot01"
							]
							]
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					597926979138821,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3236674233742069,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3760974121646388,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9859176676040691,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					864791122598791,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item01"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8600310302149928,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					200246220063929,
					false
					,[
					[
						4,
						46
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					5443886142635804,
					false
					,[
					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6299773655351047,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4021837083219472,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6368962054831211,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3371204681231555,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3455941941009131,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6876516623725038,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item01"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2230780765166105,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					2992988267927755,
					false
					,[
					[
						4,
						46
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					7454332033957527,
					false
					,[
					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6697907092682709,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7523843912739822,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8493290213818844,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1433173379161526,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6272123889546065,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					750969187137776,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							2,
							"Item01"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item01"],
			false,
			null,
			44409704227562,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				44409704227562,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item01"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						79
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item01"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						79,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item01"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						79,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Compra Item02"],
			false,
			null,
			2512127191211409,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2512127191211409,
				false
				,[
				[
					1,
					[
						2,
						"Compra Item02"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7892025719255568,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					3194864163455497,
					false
					,[
					[
						4,
						71
					]
					]
				]
,				[
					68,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					true,
					false,
					9577579484183187,
					false
					,[
					[
						1,
						[
							2,
							"cinza"
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					5454360879191391,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
,					[
						8,
						5
					]
,					[
						0,
						[
							0,
							3000
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					2798291732938999,
					false
					,[
					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					71,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5642327829129283,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2782424821917722,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
,					[
						7,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									62,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"cristais"
									]
									]
								]
								]
							]
							,[
								0,
								3000
							]
						]
					]
					]
				]
,				[
					45,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					9899168974286675,
					false
					,[
					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"cristais"
							]
							]
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5132828171964149,
					false
					,[
					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5733557256116956,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"slot01"
							]
							]
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6147697507734505,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2258246523530688,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8321263939806328,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7906582430953634,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6475205062334838,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item02"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Equip Item02"],
			false,
			null,
			5699355401977415,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5699355401977415,
				false
				,[
				[
					1,
					[
						2,
						"Equip Item02"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6857705024299751,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					2684886238653675,
					false
					,[
					[
						4,
						72
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					1048364335109567,
					false
					,[
					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					3423493098868347,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					3568605834499749,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					5220651586478142,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					9154722668348652,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8629515185466102,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"slot01"
							]
							]
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7858484219293262,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3345298458086683,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1715884942676759,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					883650656223291,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6221030900896908,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item02"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4177025512658883,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					7539552717652358,
					false
					,[
					[
						4,
						72
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					1234965560618356,
					false
					,[
					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					8420692048221492,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7159574813657087,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1788259687976514,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7288362081076938,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9751583884189329,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					3886733885232005,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item02"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4074101501227414,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					1326821881238454,
					false
					,[
					[
						4,
						72
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					8935690005247443,
					false
					,[
					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					4475668077461247,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9925164884091828,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7185702849170407,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1365244659659696,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7686922127615495,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5333712451270542,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							2,
							"Item02"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item02"],
			false,
			null,
			2841340653276165,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2841340653276165,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item02"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						80
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item02"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item02"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Compra Item03"],
			false,
			null,
			6919238824751164,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6919238824751164,
				false
				,[
				[
					1,
					[
						2,
						"Compra Item03"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2826295540044062,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					4238512196073118,
					false
					,[
					[
						4,
						73
					]
					]
				]
,				[
					69,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					true,
					false,
					7608530075675338,
					false
					,[
					[
						1,
						[
							2,
							"cinza"
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					1215825999741129,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
,					[
						8,
						5
					]
,					[
						0,
						[
							0,
							9000
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					646330890009946,
					false
					,[
					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					73,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9204991331180789,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					429504475442146,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
,					[
						7,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									62,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"cristais"
									]
									]
								]
								]
							]
							,[
								0,
								9000
							]
						]
					]
					]
				]
,				[
					45,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					625129131441193,
					false
					,[
					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"cristais"
							]
							]
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					9886920435972784,
					false
					,[
					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6205470971186269,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"slot01"
							]
							]
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1246902856231517,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1640984367508197,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1964923796211118,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8791844919519177,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6196299107572432,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item03"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Equip Item03"],
			false,
			null,
			9957867464322652,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9957867464322652,
				false
				,[
				[
					1,
					[
						2,
						"Equip Item03"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8941077243490766,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					6513144875725221,
					false
					,[
					[
						4,
						74
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					1492295859036228,
					false
					,[
					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					7192335974383198,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					3911228463407279,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					3141142796078616,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					4387476044012785,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8735935106866623,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"slot01"
							]
							]
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9067453211686488,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8233328746734878,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8987327042386217,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7336353418231503,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2993923526816739,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item03"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8764263104495245,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					2167444297345055,
					false
					,[
					[
						4,
						74
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					2104665068549014,
					false
					,[
					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					9340741115750465,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7662938715877007,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7786717076115635,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1050222514967159,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9307655279135971,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8386620633023496,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item03"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5998477984510889,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					1268133503626505,
					false
					,[
					[
						4,
						74
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					1294596005796409,
					false
					,[
					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					9205558110344354,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2033936874501327,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					434895410087519,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6491475015912016,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1274773231647821,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					598018275964802,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							2,
							"Item03"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item3"],
			false,
			null,
			8564891359593171,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8564891359593171,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item3"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						81
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item03"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item03"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Compra Item04"],
			false,
			null,
			4827076229650754,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4827076229650754,
				false
				,[
				[
					1,
					[
						2,
						"Compra Item04"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4980142975278135,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					8549207027784421,
					false
					,[
					[
						4,
						75
					]
					]
				]
,				[
					70,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					true,
					false,
					6142522603593235,
					false
					,[
					[
						1,
						[
							2,
							"cinza"
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					2071800191359486,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
,					[
						8,
						5
					]
,					[
						0,
						[
							0,
							9000
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					9572394386193313,
					false
					,[
					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					75,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3646680112773241,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2746605856293672,
					false
					,[
					[
						1,
						[
							2,
							"cristais"
						]
					]
,					[
						7,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									62,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"cristais"
									]
									]
								]
								]
							]
							,[
								0,
								9000
							]
						]
					]
					]
				]
,				[
					45,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					7632371168548536,
					false
					,[
					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"cristais"
							]
							]
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					743299691783866,
					false
					,[
					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7105776613534661,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"slot01"
							]
							]
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4025968173477682,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6223875224612413,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2216099916414581,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2280918952176297,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2986973162095991,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item04"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Equip Item04"],
			false,
			null,
			9840335668206204,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9840335668206204,
				false
				,[
				[
					1,
					[
						2,
						"Equip Item04"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2801957613140779,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					4201309962387376,
					false
					,[
					[
						4,
						76
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					5183651341086524,
					false
					,[
					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					7412536884572266,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					9874317141463189,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					5350875251736603,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					true,
					false,
					1133711913035622,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7252935038687585,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							20,
							62,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"slot01"
							]
							]
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8252507174319495,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4691353502281809,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					667140395768461,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8053378781990914,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					1463664621386188,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item04"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7751242505586027,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					913098449318203,
					false
					,[
					[
						4,
						76
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					963357586611856,
					false
					,[
					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					3450014114642635,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8161068188437345,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1397422134101854,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					336817559197209,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7967653370438511,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8176973294657981,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						7,
						[
							2,
							"Item04"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				866807465758501,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5195362945765374,
					false
					,[
					[
						4,
						76
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					3081134578461612,
					false
					,[
					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					5537945081694967,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
,					[
						3,
						0
					]
					]
				]
				],
				[
				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1323698633455517,
					false
				]
,				[
					80,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7353389988035176,
					false
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3559970340235142,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9685444092344798,
					false
				]
,				[
					62,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8407079167821935,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						7,
						[
							2,
							"Item04"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item4"],
			false,
			null,
			6181570349291527,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6181570349291527,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item4"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						82
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item04"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item04"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Credits",
		[
		[
			0,
			null,
			false,
			null,
			7562103482028168,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				8597240220605922,
				false
				,[
				[
					4,
					102
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.GoToLayout,
				null,
				1294896793067389,
				false
				,[
				[
					6,
					"MainMenu"
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5572583273447837,
			[
			[
				60,
				cr.plugins_.Audio.prototype.cnds.IsTagPlaying,
				null,
				0,
				false,
				true,
				false,
				6015544176296859,
				false
				,[
				[
					1,
					[
						2,
						"shop"
					]
				]
				]
			]
			],
			[
			]
		]
		]
	]
,	[
		"fodage",
		[
		[
			1,
			"isMove",
			0,
			0,
false,false,3643913540137757,false
		]
,		[
			1,
			"VelocidadeCenario",
			0,
			300,
false,false,2483813307585197,false
		]
,		[
			0,
			[true, "All colision"],
			false,
			null,
			5671733122195817,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5671733122195817,
				false
				,[
				[
					1,
					[
						2,
						"All colision"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4165125621131485,
				[
				[
					113,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					306643158142278,
					false
				]
,				[
					113,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6560433496024177,
					false
				]
				],
				[
				[
					113,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1578499814859935,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2753722562940494,
				[
				[
					113,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					1432171143999146,
					false
				]
,				[
					113,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					6539696984172596,
					false
				]
				],
				[
				[
					113,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					963129678609056,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2337345181988141,
				[
				[
					114,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					6624677202482003,
					false
				]
,				[
					114,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3499850827820477,
					false
				]
				],
				[
				[
					114,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2677564240754251,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6710435003393042,
				[
				[
					114,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					1260548398621062,
					false
				]
,				[
					114,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					5734007226746453,
					false
				]
				],
				[
				[
					114,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4890481470288428,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6265360462594932,
				[
				[
					115,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					9787318192038985,
					false
				]
,				[
					115,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					1382707443144276,
					false
				]
				],
				[
				[
					115,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8838282798459319,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				971548664608265,
				[
				[
					115,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					6404533484017845,
					false
				]
,				[
					115,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					6206351479491344,
					false
				]
				],
				[
				[
					115,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4014149867265897,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9059101054896424,
				[
				[
					116,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					6262383757729977,
					false
				]
,				[
					116,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					118966534809764,
					false
				]
				],
				[
				[
					116,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1352426492853803,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5180177210330176,
				[
				[
					116,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					6991389541482796,
					false
				]
,				[
					116,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					5842259028879596,
					false
				]
				],
				[
				[
					116,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9715764102371441,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7465807575063678,
				[
				[
					117,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					4245596801183627,
					false
				]
,				[
					117,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					5548032104761353,
					false
				]
				],
				[
				[
					117,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3612939896853421,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1519721400694672,
				[
				[
					117,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					1246077211178267,
					false
				]
,				[
					117,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					7721707165224168,
					false
				]
				],
				[
				[
					117,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3871003066075683,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				531808402042468,
				[
				[
					118,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					4470948603420375,
					false
				]
,				[
					118,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6572404699367143,
					false
				]
				],
				[
				[
					118,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7273989566279303,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7401818128215754,
				[
				[
					118,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					8798049136181183,
					false
				]
,				[
					118,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					2119822882190394,
					false
				]
				],
				[
				[
					118,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2482994781726956,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2942274046854022,
				[
				[
					119,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					1186526400481556,
					false
				]
,				[
					119,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					8116599526575317,
					false
				]
				],
				[
				[
					119,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7439195448572837,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7751918391328185,
				[
				[
					119,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					5931805706828757,
					false
				]
,				[
					119,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					9966773772160074,
					false
				]
				],
				[
				[
					119,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2331203789405053,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				272665851820894,
				[
				[
					120,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					5554857030921715,
					false
				]
,				[
					120,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3832420486674099,
					false
				]
				],
				[
				[
					120,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1195042246785271,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3320500006454626,
				[
				[
					120,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					7443054366519396,
					false
				]
,				[
					120,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					3289466912726643,
					false
				]
				],
				[
				[
					120,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8557535085305942,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6060037615230923,
				[
				[
					121,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					1420063279599658,
					false
				]
,				[
					121,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					224228809145376,
					false
				]
				],
				[
				[
					121,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3279818232779462,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1049196754989927,
				[
				[
					121,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					2854186699884794,
					false
				]
,				[
					121,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					7204098804665165,
					false
				]
				],
				[
				[
					121,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5412288780710818,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3828994480095963,
				[
				[
					122,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					896596181692519,
					false
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3013366033042067,
					false
				]
				],
				[
				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9809598203972338,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5745586827557416,
				[
				[
					122,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					8467885626550565,
					false
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					968489062404983,
					false
				]
				],
				[
				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3974361698121344,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3554677089778519,
				[
				[
					125,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					3183314365417155,
					false
				]
,				[
					125,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3531651363393294,
					false
				]
				],
				[
				[
					125,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1635125758051313,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5890658280469095,
				[
				[
					125,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					2389586476229854,
					false
				]
,				[
					125,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					4795468992493512,
					false
				]
				],
				[
				[
					125,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6305065839659286,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				149579803097784,
				[
				[
					126,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					6344062194015713,
					false
				]
,				[
					126,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3796636582803165,
					false
				]
				],
				[
				[
					126,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8428345740099056,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7432046652567798,
				[
				[
					126,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					6612867936729306,
					false
				]
,				[
					126,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					3410602650594414,
					false
				]
				],
				[
				[
					126,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8863643615217704,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3917540306686414,
				[
				[
					127,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					2076607927588072,
					false
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3010743759344656,
					false
				]
				],
				[
				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7617942284965479,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9554512027227398,
				[
				[
					127,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					5549961564921644,
					false
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					4016936331910214,
					false
				]
				],
				[
				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8135200552611592,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				646110297555949,
				[
				[
					128,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					6232201572427845,
					false
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6854001257906939,
					false
				]
				],
				[
				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2113496439516779,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8169664146345007,
				[
				[
					128,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3932559956627014,
					false
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					2925240300055617,
					false
				]
				],
				[
				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2236150298576045,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				398999352132827,
				[
				[
					129,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					6116983968365684,
					false
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					2542846980186538,
					false
				]
				],
				[
				[
					129,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					212294271005349,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3136693963445205,
				[
				[
					129,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					5871661856127723,
					false
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					2196747602641939,
					false
				]
				],
				[
				[
					129,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2876274660599067,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6918079793246673,
				[
				[
					130,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					9497751871897041,
					false
				]
,				[
					130,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					7387833049282059,
					false
				]
				],
				[
				[
					130,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6389407087313303,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4539759543833373,
				[
				[
					130,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					6575954259985155,
					false
				]
,				[
					130,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					7626758629027326,
					false
				]
				],
				[
				[
					130,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2329808205601583,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9859025465802412,
				[
				[
					131,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					3131757568075559,
					false
				]
,				[
					131,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					4911410088687251,
					false
				]
				],
				[
				[
					131,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					795882507365895,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8339407525369686,
				[
				[
					131,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					8897120713940166,
					false
				]
,				[
					131,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					4558657463120239,
					false
				]
				],
				[
				[
					131,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3458531363246709,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1288127124692576,
				[
				[
					132,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					1750698418937116,
					false
				]
,				[
					132,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					9527890432434266,
					false
				]
				],
				[
				[
					132,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5776350530260244,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7364048864308496,
				[
				[
					132,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					7474294244772458,
					false
				]
,				[
					132,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					9003743255714713,
					false
				]
				],
				[
				[
					132,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1034129349773353,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3219988942797439,
				[
				[
					133,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					6295013390333993,
					false
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					9818749844942829,
					false
				]
				],
				[
				[
					133,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6170124432988019,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6668969669707971,
				[
				[
					133,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					4567817008042612,
					false
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					3876688609259793,
					false
				]
				],
				[
				[
					133,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8879472369492323,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3833898139859015,
				[
				[
					134,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					5756833279256223,
					false
				]
,				[
					134,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					1144426120346973,
					false
				]
				],
				[
				[
					134,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4408289943869507,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4062467245288756,
				[
				[
					134,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					6055187818352446,
					false
				]
,				[
					134,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					8515457390463884,
					false
				]
				],
				[
				[
					134,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1627891120506728,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6980200805564363,
				[
				[
					135,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					7236319156494914,
					false
				]
,				[
					135,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					999306010645896,
					false
				]
				],
				[
				[
					135,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4888969038249063,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4676651624566623,
				[
				[
					135,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					6125649205095642,
					false
				]
,				[
					135,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					8294244497919066,
					false
				]
				],
				[
				[
					135,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8151576515407444,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8305490004556503,
				[
				[
					136,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					684693265103998,
					false
				]
,				[
					136,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					5481661924617147,
					false
				]
				],
				[
				[
					136,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					817072149509783,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9941448371954944,
				[
				[
					136,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					2486267085552626,
					false
				]
,				[
					136,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					8072836935325546,
					false
				]
				],
				[
				[
					136,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5828718919401542,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9928019735547896,
				[
				[
					137,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					2025693416729268,
					false
				]
,				[
					137,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6155913940116144,
					false
				]
				],
				[
				[
					137,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					835863712735828,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5284912583180093,
				[
				[
					137,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					5512251396656541,
					false
				]
,				[
					137,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					330826374528538,
					false
				]
				],
				[
				[
					137,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1918462787630515,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2919895057128379,
				[
				[
					138,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					462289947325783,
					false
				]
,				[
					138,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					7526228728462773,
					false
				]
				],
				[
				[
					138,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4694164277854552,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				738186022012163,
				[
				[
					138,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3840848729112547,
					false
				]
,				[
					138,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					4069946933923277,
					false
				]
				],
				[
				[
					138,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7108869209836247,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5003580209492639,
				[
				[
					139,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					2947097944905118,
					false
				]
,				[
					139,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3047019878138006,
					false
				]
				],
				[
				[
					139,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3619198584271952,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8270182653675055,
				[
				[
					139,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3756195927527213,
					false
				]
,				[
					139,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					296661875076587,
					false
				]
				],
				[
				[
					139,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2523891220273429,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1446433435269046,
				[
				[
					140,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					7246780861062322,
					false
				]
,				[
					140,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3720815686429377,
					false
				]
				],
				[
				[
					140,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8674013358182025,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7997104753385498,
				[
				[
					140,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3697476861969935,
					false
				]
,				[
					140,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					7093925248659969,
					false
				]
				],
				[
				[
					140,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2401756849382634,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				928361033605779,
				[
				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					7464353756253518,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3683415365550478,
					false
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					8228248828301521,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5298764274000336,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7389646217592571,
				[
				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					4475542890816863,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					4446439960713138,
					false
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					8319597335697732,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1537674104710327,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7366638915264609,
				[
				[
					50,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					4804003899749585,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					1067225328641741,
					false
				]
				],
				[
				[
					50,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					8844490333467203,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7474969767488738,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8971060976137283,
				[
				[
					50,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					18632767244458,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					9908481137973675,
					false
				]
				],
				[
				[
					50,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					1978949571678493,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5191592746918567,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				795140341142739,
				[
				[
					51,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					7113993975395407,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6626484282875643,
					false
				]
				],
				[
				[
					51,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					682255939378896,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6748708051889502,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7987678524393973,
				[
				[
					51,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					9854609911762293,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					5775083659265853,
					false
				]
				],
				[
				[
					51,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					7334532525314168,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3718316036551308,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9940909366602319,
				[
				[
					17,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					7543356677565966,
					false
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					400464413024846,
					false
				]
				],
				[
				[
					17,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					6114448741224185,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					6710062086948825,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3319366328141962,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7139943396958741,
				[
				[
					17,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					5877035944408693,
					false
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					3438241030448709,
					false
				]
				],
				[
				[
					17,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					5247819305968483,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					3737754152452951,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					415095944586025,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5777186393617911,
				[
				[
					18,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					5214306579635063,
					false
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3729682987536919,
					false
				]
				],
				[
				[
					18,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					9378478120000136,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					6442688873225221,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9604772562120454,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8532739655651327,
				[
				[
					18,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					459327190425427,
					false
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					5846703047672972,
					false
				]
				],
				[
				[
					18,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					4952342899805573,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					3295352449412671,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9408784806562686,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7121158490044433,
				[
				[
					19,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					9294385585852063,
					false
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					2453769305408772,
					false
				]
				],
				[
				[
					19,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					8372810879684713,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					6148398735242371,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5290639431724223,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3546822591382273,
				[
				[
					19,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3463222137566908,
					false
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					9409594428035117,
					false
				]
				],
				[
				[
					19,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					9355803870390839,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					4115795254196126,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					607292548767423,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8976007683333968,
				[
				[
					21,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					8868513111187658,
					false
				]
,				[
					21,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					4550638767433764,
					false
				]
				],
				[
				[
					21,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					4150638109037278,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					21,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					621988793880422,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					21,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					739868393193115,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5672169986096245,
				[
				[
					21,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3173503250292698,
					false
				]
,				[
					21,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					5391403541077881,
					false
				]
				],
				[
				[
					21,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					9072149755144993,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					21,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					8683654233493906,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					21,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9902724248933318,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				450762361967108,
				[
				[
					26,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					604936276271017,
					false
				]
,				[
					26,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6915644411419154,
					false
				]
				],
				[
				[
					26,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					424294405600839,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					26,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					4414225218283224,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					26,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3266615625302086,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				738299904148027,
				[
				[
					26,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3295384408896562,
					false
				]
,				[
					26,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					1992691909680047,
					false
				]
				],
				[
				[
					26,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					4084749895422372,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					26,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					7289256032705354,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					26,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9109239154773783,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9748273546793916,
				[
				[
					11,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					6023104741089892,
					false
				]
,				[
					11,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3159977709737619,
					false
				]
				],
				[
				[
					11,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					5960188908371579,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					11,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					7296033616323507,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					11,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2842983410881377,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6376912135215221,
				[
				[
					11,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					5018750803652608,
					false
				]
,				[
					11,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					1929219187755274,
					false
				]
				],
				[
				[
					11,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					2748881930398861,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					11,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					5517710901978711,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					11,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2745930243768326,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8309189879100285,
				[
				[
					12,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					9821405790818515,
					false
				]
,				[
					12,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					2700075020805249,
					false
				]
				],
				[
				[
					12,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					6415066491937243,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					12,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					7051176656046668,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					12,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3825410780559794,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1809973142739803,
				[
				[
					12,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					7947188061857006,
					false
				]
,				[
					12,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					1485232575737535,
					false
				]
				],
				[
				[
					12,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					1292267842555725,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					12,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					5869970198670573,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					12,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6221876704649417,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1200848614629803,
				[
				[
					13,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					8317297982149553,
					false
				]
,				[
					13,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					2377102477759982,
					false
				]
				],
				[
				[
					13,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					8069147622999813,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					13,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					4142514356588524,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					13,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9283899150928528,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5949723392398806,
				[
				[
					13,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					8253946986560633,
					false
				]
,				[
					13,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					3389633610949646,
					false
				]
				],
				[
				[
					13,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					960273133868822,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					13,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					2954503549308555,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					13,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5113832836011527,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9241862183596686,
				[
				[
					14,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					4115284343179502,
					false
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					5904030462802867,
					false
				]
				],
				[
				[
					14,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					2000527098753574,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					6199877697144334,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1992589018897585,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				741573123094959,
				[
				[
					14,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3290405979047246,
					false
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					4403005649138849,
					false
				]
				],
				[
				[
					14,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					4832129212453872,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					5887671041953902,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1950506596363094,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3120615589409359,
				[
				[
					27,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					9014357753124212,
					false
				]
,				[
					27,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					263609813049536,
					false
				]
				],
				[
				[
					27,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					7962579623811907,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					27,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					7808608780830004,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					27,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2552098330907822,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6058824201588905,
				[
				[
					27,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3963254766543513,
					false
				]
,				[
					27,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					6146078367631061,
					false
				]
				],
				[
				[
					27,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					5342569660347113,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					27,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					8102871261404681,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					27,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					252731458218805,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5520760791947857,
				[
				[
					28,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					8629226002466555,
					false
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3378808291209849,
					false
				]
				],
				[
				[
					28,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					5724546427360762,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					6301609648033914,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4917017488619657,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2242776978469616,
				[
				[
					28,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					4982993795828338,
					false
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					4467508394240005,
					false
				]
				],
				[
				[
					28,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					2109165315237832,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					3004979783365193,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6615674914083785,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1140487861313088,
				[
				[
					29,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					1373689088119932,
					false
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					7485895877617143,
					false
				]
				],
				[
				[
					29,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					3699082388237686,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					3981361354081657,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4624166083253607,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				397710827420473,
				[
				[
					29,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					8159617763973577,
					false
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					1611921534770273,
					false
				]
				],
				[
				[
					29,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					7091863177831054,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					3917938309878966,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					361780203895571,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				477650164310098,
				[
				[
					30,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					5110986456029508,
					false
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					2229253552492406,
					false
				]
				],
				[
				[
					30,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					3299369461596938,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					6257158971709158,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5643344406797093,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7792034576405726,
				[
				[
					30,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					7398524016371858,
					false
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					7598403538216784,
					false
				]
				],
				[
				[
					30,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					4615939099553689,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					1524639595726723,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6875705996784822,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5561514483576499,
				[
				[
					32,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					4146813384177735,
					false
				]
,				[
					32,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3504140950977595,
					false
				]
				],
				[
				[
					32,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					3341737281235388,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					32,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					8902588871872764,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					32,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1567904313258288,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1074915556189285,
				[
				[
					32,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					5198639786325889,
					false
				]
,				[
					32,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					5800378389492177,
					false
				]
				],
				[
				[
					32,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					499500382949757,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					32,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					978486069242903,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					32,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4308125270492643,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2545290126431589,
				[
				[
					34,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					2310520533065994,
					false
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					2973816465349474,
					false
				]
				],
				[
				[
					34,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					8944352320590413,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					9618020919104042,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5967135926400037,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7373801735873529,
				[
				[
					34,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					4292006237858099,
					false
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					7655651682623209,
					false
				]
				],
				[
				[
					34,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					4727505325646403,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					7427460059900449,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6824610066414096,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8349503247085628,
				[
				[
					38,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					4840168531717818,
					false
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					1238244896710001,
					false
				]
				],
				[
				[
					38,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					823514801708216,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					4896575784253332,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7875145691294164,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5028593941113876,
				[
				[
					38,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3460522955584277,
					false
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					4602284553470049,
					false
				]
				],
				[
				[
					38,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					7232558307901325,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					4807257401509491,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9956703883870302,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2275989967637392,
				[
				[
					36,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					6184057634128752,
					false
				]
,				[
					36,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					7801703971661195,
					false
				]
				],
				[
				[
					36,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					1919306751463242,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					36,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					6512885016355751,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					36,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2773992752591463,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9713911544438758,
				[
				[
					36,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					1751578710014162,
					false
				]
,				[
					36,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					1359370502752124,
					false
				]
				],
				[
				[
					36,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					6910316277730722,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					36,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					3720620079832313,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					36,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2946396186714285,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6523638829841697,
				[
				[
					37,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					8421148514856157,
					false
				]
,				[
					37,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					5696315501962654,
					false
				]
				],
				[
				[
					37,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					446891252406035,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					37,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					678307568948113,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					37,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1903347330919312,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1282184002562267,
				[
				[
					37,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					3064391422258012,
					false
				]
,				[
					37,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					4861386817234326,
					false
				]
				],
				[
				[
					37,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					3999824373602738,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					37,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					5220182723020345,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					37,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					201496712547032,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7295367915636376,
				[
				[
					39,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					true,
					false,
					8077204783609756,
					false
				]
,				[
					39,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					5814772274081903,
					false
				]
				],
				[
				[
					39,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					2267445669660055,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					39,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					3724787286366874,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					39,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1174765898573995,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3243236345515634,
				[
				[
					39,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					5262503378401205,
					false
				]
,				[
					39,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					true,
					false,
					7731988650572787,
					false
				]
				],
				[
				[
					39,
					cr.behaviors.solid.prototype.acts.SetEnabled,
					"Solid",
					26351253978253,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					39,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					5447786016765141,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					39,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2969196662957819,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "moviment"],
			false,
			null,
			1877675141631044,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				1877675141631044,
				false
				,[
				[
					1,
					[
						2,
						"moviment"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				5027746777565361,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					2714878852993351,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6327336824323316,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					894556653535538,
					false
					,[
					[
						11,
						"VelocidadeCenario"
					]
,					[
						7,
						[
							4,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								6,
								[
									0,
									1
								]
								,[
									19,
									cr.system_object.prototype.exps.dt
								]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8792478133435144,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					4050609695786941,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					true,
					false,
					9059350770389035,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					3263331690416357,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7837767373213464,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2594949045770099,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					true,
					false,
					9650606600295716,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					3182951663771482,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8106191765751701,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7197213462380441,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					true,
					false,
					4644137886981972,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
					]
				]
				],
				[
				[
					51,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					6177512017682161,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8572309749768059,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					588297611716672,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					113,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					6603407815524426,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					114,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					6133074828168189,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					115,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					9750193426640556,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					116,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					1545213481194198,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					117,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					6914710451057981,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					118,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					1946841824031902,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					119,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					3283823204184036,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					120,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					2107031887212657,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					121,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					9142847881985827,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					4546557439404188,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					125,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					7355394002302881,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					126,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					2714830197326362,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					3989345351054402,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					783646437112945,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					9281478667039775,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					130,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					9227536019230741,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					131,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					5093795040769935,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					132,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					1133456392280559,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					8023991438522192,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					134,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					7482607702381794,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					135,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					9027336792141894,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					136,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					3923482429690476,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					137,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					9562233375371942,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					138,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					6732254217132847,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					139,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					4142879924664739,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					140,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					4656664385026151,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9680191589065283,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7601696079401347,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					16,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					8787250555544653,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					264954331420393,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					1500268752645772,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					1794929819649471,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					20,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					6282358372186518,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					21,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					7370796526274423,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					22,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					445694913164791,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					26,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					1295964821401532,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					4074786308675276,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					24,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					8319383469251698,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					25,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					5025661613260289,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					361626951148288,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					12,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					5763298909511232,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					13,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					7587431600397818,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					4595641300640053,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5334337243757757,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					8872483946430344,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					27,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					9581078468350479,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					5581054880462558,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					9450375263319971,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					7054285169467347,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					31,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					910735222023152,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					32,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					6974047034458535,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					33,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					7356720724708227,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					238246234364331,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2065006386481329,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1879204906718463,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					38,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					3565900342282836,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					36,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					5699984290989424,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					35,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					9278406952381083,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					37,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					2230229377730333,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					8842190527424169,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					8011223042611893,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				85377687373346,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5614446152096184,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					15,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					2284744937277798,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					97,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					7024214383946259,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								7,
								[
									23,
									"VelocidadeCenario"
								]
								,[
									0,
									4
								]
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2795609593214649,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6282110374954198,
					false
					,[
					[
						11,
						"isMove"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					41,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					6003688139925718,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								23,
								"VelocidadeCenario"
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"shopSection",
		[
		[
			2,
			"transitions",
			false
		]
,		[
			0,
			null,
			false,
			null,
			1618532344241983,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				7688944674587357,
				false
			]
			],
			[
			[
				45,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				5533506664759623,
				false
				,[
				[
					7,
					[
						20,
						62,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"cristais"
						]
						]
					]
				]
				]
			]
,			[
				103,
				cr.plugins_.CJSAds.prototype.acts.ShowBanner,
				null,
				3204425099266324,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item6"],
			false,
			null,
			4358414423524328,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4358414423524328,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item6"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						79
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item01"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						79,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item01"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						79,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item6"],
			false,
			null,
			3743723417049004,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				3743723417049004,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item6"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						80
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item02"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item02"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			437999533356903,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				7981100965697786,
				false
				,[
				[
					4,
					74
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				6165723457081293,
				false
				,[
				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				true,
				false,
				3625152168394397,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				true,
				false,
				763283035390176,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				true,
				false,
				3554990623228245,
				false
				,[
				[
					1,
					[
						2,
						"slot02"
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				true,
				false,
				4098853098321917,
				false
				,[
				[
					1,
					[
						2,
						"slot02"
					]
				]
,				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					3,
					0
				]
				]
			]
			],
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4755501381775393,
				false
				,[
				[
					1,
					[
						2,
						"slot02"
					]
				]
,				[
					7,
					[
						20,
						62,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"slot01"
						]
						]
					]
				]
				]
			]
,			[
				79,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				4266777514750458,
				false
			]
,			[
				80,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				9549928749610593,
				false
			]
,			[
				81,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				4404434160347591,
				false
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				7122009224934145,
				false
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				967386706215084,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					7,
					[
						2,
						"Item03"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3011162042692238,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				7395420580637785,
				false
				,[
				[
					4,
					74
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				264479606964129,
				false
				,[
				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				false,
				false,
				2327580440346271,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
,				[
					3,
					0
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				9773627080784653,
				false
			]
,			[
				80,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				816522012763862,
				false
			]
,			[
				81,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				568764848291063,
				false
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				2400368678439895,
				false
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7294152359284572,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					7,
					[
						2,
						"Item03"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2276318478386512,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				1053860880784607,
				false
				,[
				[
					4,
					74
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				7026771523651808,
				false
				,[
				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				false,
				false,
				9049581743277624,
				false
				,[
				[
					1,
					[
						2,
						"slot02"
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
,				[
					3,
					0
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				3218699671908459,
				false
			]
,			[
				80,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				1548077959676565,
				false
			]
,			[
				81,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				4940487879649507,
				false
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				7252631740482492,
				false
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7023390780553759,
				false
				,[
				[
					1,
					[
						2,
						"slot02"
					]
				]
,				[
					7,
					[
						2,
						"Item03"
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item6"],
			false,
			null,
			7308132700393378,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7308132700393378,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item6"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						81
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item03"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item03"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item6"],
			false,
			null,
			2797918114177115,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2797918114177115,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item6"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						82
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item04"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item04"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			true,
			null,
			2028053224362049,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				7558391357862481,
				false
				,[
				[
					4,
					2
				]
				]
			]
,			[
				95,
				cr.plugins_.CJSBackButton.prototype.cnds.OnBack,
				null,
				1,
				false,
				false,
				false,
				5850258516440361,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9043225995565907,
				false
				,[
				[
					11,
					"goTo"
				]
,				[
					7,
					[
						2,
						"MainMenu"
					]
				]
				]
			]
,			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				5990086292771439,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4628109560940352,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				9089274767105818,
				false
				,[
				[
					4,
					106
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3471891705895529,
				false
				,[
				[
					11,
					"goTo"
				]
,				[
					7,
					[
						2,
						"shopItems"
					]
				]
				]
			]
,			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				708893814547108,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9286083511713081,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				7336992598421682,
				false
				,[
				[
					4,
					107
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				815470363690071,
				false
				,[
				[
					11,
					"goTo"
				]
,				[
					7,
					[
						2,
						"shopClothes"
					]
				]
				]
			]
,			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				6080469152206852,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6408763342537892,
			[
			[
				60,
				cr.plugins_.Audio.prototype.cnds.IsTagPlaying,
				null,
				0,
				false,
				false,
				false,
				4853599539075521,
				false
				,[
				[
					1,
					[
						2,
						"01"
					]
				]
				]
			]
			],
			[
			[
				60,
				cr.plugins_.Audio.prototype.acts.SetVolume,
				null,
				564123313023404,
				false
				,[
				[
					1,
					[
						2,
						"01"
					]
				]
,				[
					0,
					[
						5,
						[
							20,
							60,
							cr.plugins_.Audio.prototype.exps.Volume,
							false,
							null
							,[
[
								2,
								"01"
							]
							]
						]
						,[
							1,
							0.3
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				7055154691503314,
				false
				,[
				[
					0,
					[
						1,
						0.8
					]
				]
				]
			]
,			[
				60,
				cr.plugins_.Audio.prototype.acts.Stop,
				null,
				5688519573837442,
				false
				,[
				[
					1,
					[
						2,
						"01"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5031043745248904,
			[
			[
				60,
				cr.plugins_.Audio.prototype.cnds.IsTagPlaying,
				null,
				0,
				false,
				true,
				false,
				2049322035164439,
				false
				,[
				[
					1,
					[
						2,
						"shop"
					]
				]
				]
			]
			],
			[
			[
				60,
				cr.plugins_.Audio.prototype.acts.PlayByName,
				null,
				931085425412408,
				false
				,[
				[
					3,
					1
				]
,				[
					1,
					[
						2,
						"bensound   funnysong"
					]
				]
,				[
					3,
					1
				]
,				[
					0,
					[
						0,
						-20
					]
				]
,				[
					1,
					[
						2,
						"shop"
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Set slot3"],
			false,
			null,
			911084286068789,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				911084286068789,
				false
				,[
				[
					1,
					[
						2,
						"Set slot3"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				155878573294782,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					7778355786126862,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					7057937696714468,
					false
					,[
					[
						7,
						[
							20,
							79,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					4226634692912763,
					false
					,[
					[
						4,
						79
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1893849685947297,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					7074947684695892,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6929936802960511,
					false
					,[
					[
						7,
						[
							20,
							80,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					746671372994502,
					false
					,[
					[
						4,
						80
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7182993217377928,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					904755835283639,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					3029476958955305,
					false
					,[
					[
						7,
						[
							20,
							81,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					390597958570165,
					false
					,[
					[
						4,
						81
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5187360657117961,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					3327603761129132,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6595580559192644,
					false
					,[
					[
						7,
						[
							20,
							82,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					8809692754005019,
					false
					,[
					[
						4,
						82
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3702620370805296,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6710696873763062,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					146155748934564,
					false
					,[
					[
						7,
						[
							20,
							79,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2262409219237843,
					false
					,[
					[
						4,
						79
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6902762080178184,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6296383327961176,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					2696458232221203,
					false
					,[
					[
						7,
						[
							20,
							80,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1013100263421114,
					false
					,[
					[
						4,
						80
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8890588128025935,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					4792165085458655,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1653930733884418,
					false
					,[
					[
						7,
						[
							20,
							81,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					662674902493558,
					false
					,[
					[
						4,
						81
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3886463655669667,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					1357235701116777,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1272601644068601,
					false
					,[
					[
						7,
						[
							20,
							82,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					9191310833915736,
					false
					,[
					[
						4,
						82
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"shopClothes",
		[
		[
			2,
			"transitions",
			false
		]
,		[
			0,
			null,
			false,
			null,
			3630253870264775,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				2802345964766134,
				false
			]
			],
			[
			[
				45,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				691182205960432,
				false
				,[
				[
					7,
					[
						20,
						62,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"cristais"
						]
						]
					]
				]
				]
			]
,			[
				103,
				cr.plugins_.CJSAds.prototype.acts.ShowBanner,
				null,
				4170281440337986,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item2"],
			false,
			null,
			8969029188801187,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8969029188801187,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item2"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						79
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item01"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						79,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item01"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						79,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item5"],
			false,
			null,
			2331810337579038,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2331810337579038,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item5"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						80
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item02"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item02"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6902202533842953,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				5927955096778187,
				false
				,[
				[
					4,
					74
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				2876445257543005,
				false
				,[
				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				true,
				false,
				6259859568540392,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				true,
				false,
				8995944228337399,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				true,
				false,
				3095850530061191,
				false
				,[
				[
					1,
					[
						2,
						"slot02"
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				true,
				false,
				8013675680187167,
				false
				,[
				[
					1,
					[
						2,
						"slot02"
					]
				]
,				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					3,
					0
				]
				]
			]
			],
			[
			[
				62,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4711960699904344,
				false
				,[
				[
					1,
					[
						2,
						"slot02"
					]
				]
,				[
					7,
					[
						20,
						62,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"slot01"
						]
						]
					]
				]
				]
			]
,			[
				79,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				9931604900305967,
				false
			]
,			[
				80,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				8543738511855621,
				false
			]
,			[
				81,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				5960196084284132,
				false
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				65878304935335,
				false
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4605336747804012,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					7,
					[
						2,
						"Item03"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2951332100920664,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				9646809643361751,
				false
				,[
				[
					4,
					74
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				6260826174863309,
				false
				,[
				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				false,
				false,
				6480542444541887,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
,				[
					3,
					0
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				389858010054671,
				false
			]
,			[
				80,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				4141449238820039,
				false
			]
,			[
				81,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				4694488517274277,
				false
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				6941396033496374,
				false
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7762489247528234,
				false
				,[
				[
					1,
					[
						2,
						"slot01"
					]
				]
,				[
					7,
					[
						2,
						"Item03"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6399109318137223,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				8522075407037258,
				false
				,[
				[
					4,
					74
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				8368365256785413,
				false
				,[
				[
					1,
					[
						2,
						"Item03"
					]
				]
,				[
					8,
					0
				]
,				[
					0,
					[
						0,
						1
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
				null,
				0,
				false,
				false,
				false,
				7500306773330615,
				false
				,[
				[
					1,
					[
						2,
						"slot02"
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
,				[
					3,
					0
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				9200910771735332,
				false
			]
,			[
				80,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				602734632734248,
				false
			]
,			[
				81,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				7038822020411829,
				false
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				4189525277494307,
				false
			]
,			[
				62,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1256525022152172,
				false
				,[
				[
					1,
					[
						2,
						"slot02"
					]
				]
,				[
					7,
					[
						2,
						"Item03"
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item5"],
			false,
			null,
			5911536510601084,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5911536510601084,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item5"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						81
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item03"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item03"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "destroi Item5"],
			false,
			null,
			4122841539419664,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4122841539419664,
				false
				,[
				[
					1,
					[
						2,
						"destroi Item5"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2261200714271125,
				[
				[
					49,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5836508911577605,
					false
					,[
					[
						4,
						82
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9337403854553301,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9380861615416712,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							1,
							[
								2,
								"Item04"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3324998974543872,
						false
						,[
						[
							1,
							[
								2,
								"slot01"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						693543134793552,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5905096437290996,
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						8957702789518254,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							1,
							[
								2,
								"Item04"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7964936856320912,
						false
						,[
						[
							1,
							[
								2,
								"slot02"
							]
						]
,						[
							7,
							[
								2,
								""
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5245615925056208,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			true,
			null,
			8219889254798282,
			[
			[
				49,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				2830181153084292,
				false
				,[
				[
					4,
					108
				]
				]
			]
,			[
				95,
				cr.plugins_.CJSBackButton.prototype.cnds.OnBack,
				null,
				1,
				false,
				false,
				false,
				7742348394115234,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				5623333091190832,
				false
				,[
				[
					11,
					"goTo"
				]
,				[
					7,
					[
						2,
						"shopSection"
					]
				]
				]
			]
,			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				9458324364540082,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Set slot2"],
			false,
			null,
			6255461186941824,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6255461186941824,
				false
				,[
				[
					1,
					[
						2,
						"Set slot2"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				155878573294782,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					7778355786126862,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					7057937696714468,
					false
					,[
					[
						7,
						[
							20,
							79,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					4226634692912763,
					false
					,[
					[
						4,
						79
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1893849685947297,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					7074947684695892,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6929936802960511,
					false
					,[
					[
						7,
						[
							20,
							80,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					746671372994502,
					false
					,[
					[
						4,
						80
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7182993217377928,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					904755835283639,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					3029476958955305,
					false
					,[
					[
						7,
						[
							20,
							81,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					390597958570165,
					false
					,[
					[
						4,
						81
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5187360657117961,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					3327603761129132,
					false
					,[
					[
						1,
						[
							2,
							"slot01"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					6595580559192644,
					false
					,[
					[
						7,
						[
							20,
							82,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					8809692754005019,
					false
					,[
					[
						4,
						82
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								152.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3702620370805296,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6710696873763062,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item01"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					146155748934564,
					false
					,[
					[
						7,
						[
							20,
							79,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2262409219237843,
					false
					,[
					[
						4,
						79
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6902762080178184,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					6296383327961176,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item02"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					2696458232221203,
					false
					,[
					[
						7,
						[
							20,
							80,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1013100263421114,
					false
					,[
					[
						4,
						80
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8890588128025935,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					4792165085458655,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item03"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1653930733884418,
					false
					,[
					[
						7,
						[
							20,
							81,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					662674902493558,
					false
					,[
					[
						4,
						81
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3886463655669667,
				[
				[
					62,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
					null,
					0,
					false,
					false,
					false,
					1357235701116777,
					false
					,[
					[
						1,
						[
							2,
							"slot02"
						]
					]
,					[
						1,
						[
							2,
							"Item04"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1272601644068601,
					false
					,[
					[
						7,
						[
							20,
							82,
							cr.plugins_.Sprite.prototype.exps.Count,
							false,
							null
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					9191310833915736,
					false
					,[
					[
						4,
						82
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								47,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								1,
								236.5
							]
						]
					]
,					[
						0,
						[
							0,
							39
						]
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"transitions",
		[
		[
			1,
			"retry",
			0,
			0,
false,false,5136745666118688,false
		]
,		[
			1,
			"goTo",
			1,
			"",
false,false,833741608396441,false
		]
,		[
			0,
			null,
			false,
			null,
			5795716547448162,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				4107936952544076,
				false
			]
			],
			[
			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				5258497777213384,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetOpacity,
				null,
				1643970050644384,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				112,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				6277716873658817,
				false
				,[
				[
					3,
					1
				]
				]
			]
,			[
				112,
				cr.plugins_.Sprite.prototype.acts.SetOpacity,
				null,
				1658562193568121,
				false
				,[
				[
					0,
					[
						0,
						100
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			138977653791959,
			[
			[
				111,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				7541808705510595,
				false
			]
			],
			[
			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetOpacity,
				null,
				9159746040376913,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							111,
							cr.plugins_.Sprite.prototype.exps.Opacity,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				2898356526164897,
				[
				[
					111,
					cr.plugins_.Sprite.prototype.cnds.CompareOpacity,
					null,
					0,
					false,
					false,
					false,
					4226771112292843,
					false
					,[
					[
						8,
						0
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.GoToLayoutByName,
					null,
					1030107511435517,
					false
					,[
					[
						1,
						[
							19,
							cr.system_object.prototype.exps.str
							,[
[
								23,
								"goTo"
							]
							]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9630779947305672,
			[
			[
				111,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				4064674645421037,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.LayerVisible,
				null,
				0,
				false,
				false,
				false,
				869632748409821,
				false
				,[
				[
					5,
					[
						2,
						"Pause"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				9966190665776377,
				false
				,[
				[
					11,
					"retry"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetOpacity,
				null,
				4686155840682687,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							111,
							cr.plugins_.Sprite.prototype.exps.Opacity,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				8437422555055251,
				[
				[
					111,
					cr.plugins_.Sprite.prototype.cnds.CompareOpacity,
					null,
					0,
					false,
					false,
					false,
					5383156791506572,
					false
					,[
					[
						8,
						0
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					4073235881133081,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.ResetGlobals,
					null,
					6908347953998382,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.RestartLayout,
					null,
					6991837664571842,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5413322913004014,
			[
			[
				111,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				5703447081259612,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.LayerVisible,
				null,
				0,
				false,
				false,
				false,
				2112941588325046,
				false
				,[
				[
					5,
					[
						2,
						"Pause"
					]
				]
				]
			]
			],
			[
			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetOpacity,
				null,
				9669481354441385,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							111,
							cr.plugins_.Sprite.prototype.exps.Opacity,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				2546388527936427,
				[
				[
					111,
					cr.plugins_.Sprite.prototype.cnds.CompareOpacity,
					null,
					0,
					false,
					false,
					false,
					831496988222499,
					false
					,[
					[
						8,
						0
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					8487293978089733,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					6060397762926924,
					false
					,[
					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayoutByName,
					null,
					7930296960168541,
					false
					,[
					[
						1,
						[
							19,
							cr.system_object.prototype.exps.str
							,[
[
								23,
								"goTo"
							]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.ResetGlobals,
					null,
					9287759129547354,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8139143591789753,
			[
			[
				111,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				3457232054674233,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.LayerVisible,
				null,
				0,
				false,
				false,
				false,
				11461251007676,
				false
				,[
				[
					5,
					[
						2,
						"GameOver"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				9116023927249508,
				false
				,[
				[
					11,
					"retry"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetOpacity,
				null,
				4848885695960385,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							111,
							cr.plugins_.Sprite.prototype.exps.Opacity,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				5982095715259244,
				[
				[
					111,
					cr.plugins_.Sprite.prototype.cnds.CompareOpacity,
					null,
					0,
					false,
					false,
					false,
					4084799397958109,
					false
					,[
					[
						8,
						0
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					6122866747363398,
					false
					,[
					[
						5,
						[
							2,
							"GameOver"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					9441683381460478,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.ResetGlobals,
					null,
					3420052051130369,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.RestartLayout,
					null,
					5284575111012433,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3308760215009011,
			[
			[
				111,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				3937536401990239,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.LayerVisible,
				null,
				0,
				false,
				false,
				false,
				3376265457342409,
				false
				,[
				[
					5,
					[
						2,
						"GameOver"
					]
				]
				]
			]
			],
			[
			[
				111,
				cr.plugins_.Sprite.prototype.acts.SetOpacity,
				null,
				5477288789689379,
				false
				,[
				[
					0,
					[
						4,
						[
							20,
							111,
							cr.plugins_.Sprite.prototype.exps.Opacity,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				6902468547329624,
				[
				[
					111,
					cr.plugins_.Sprite.prototype.cnds.CompareOpacity,
					null,
					0,
					false,
					false,
					false,
					9993398232361978,
					false
					,[
					[
						8,
						0
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					70604760782025,
					false
					,[
					[
						5,
						[
							2,
							"GameOver"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					6702789623524873,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayoutByName,
					null,
					9510185495886025,
					false
					,[
					[
						1,
						[
							19,
							cr.system_object.prototype.exps.str
							,[
[
								23,
								"goTo"
							]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.ResetGlobals,
					null,
					5221449844874634,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7402501898371088,
			[
			[
				112,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				8152453399881378,
				false
			]
			],
			[
			[
				112,
				cr.plugins_.Sprite.prototype.acts.SetOpacity,
				null,
				8374761331268568,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							112,
							cr.plugins_.Sprite.prototype.exps.Opacity,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Loading",
		[
		[
			0,
			null,
			false,
			null,
			6211907829600898,
			[
			[
				-1,
				cr.system_object.prototype.cnds.EveryTick,
				null,
				0,
				false,
				false,
				false,
				7358922884684873,
				false
			]
			],
			[
			[
				63,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				7894111209206355,
				false
				,[
				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							6,
							[
								19,
								cr.system_object.prototype.exps.loadingprogress
							]
							,[
								0,
								100
							]
						]
						]
					]
				]
				]
			]
,			[
				141,
				cr.plugins_.TiledBg.prototype.acts.SetHeight,
				null,
				9506076057306425,
				false
				,[
				[
					0,
					[
						6,
						[
							19,
							cr.system_object.prototype.exps.loadingprogress
						]
						,[
							0,
							130
						]
					]
				]
				]
			]
,			[
				141,
				cr.plugins_.TiledBg.prototype.acts.SetPos,
				null,
				4716959521404509,
				false
				,[
				[
					0,
					[
						0,
						285
					]
				]
,				[
					0,
					[
						5,
						[
							0,
							296
						]
						,[
							6,
							[
								19,
								cr.system_object.prototype.exps.loadingprogress
							]
							,[
								1,
								65
							]
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1306299453839688,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLoadFinished,
				null,
				1,
				false,
				false,
				false,
				2806477335207868,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.GoToLayout,
				null,
				5723230161457146,
				false
				,[
				[
					6,
					"MainMenu"
				]
				]
			]
			]
		]
		]
	]
	],
	"",
	true,
	569,
	320,
	3,
	false,
	false,
	false,
	"1.1.1",
	false,
	true,
	2,
	2,
	179,
	false,
	false,
	0,
	[
	]
];};

createCocoonJSRuntime();

})();
